// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::Array "
This class provides a simple wrapper for a pointer to an array. A purpose of this class is to enable the simple and safe exchange of data between C++ and Python.
";

%feature("docstring") dolfin::Array::Array(const Array &other) "
Disable copy construction, to avoid unanticipated sharing or copying of data. This means that an :cpp:any:`Array`  must always be passed as reference, or as a (possibly shared) pointer. 

:param const Array & other:
";

%feature("docstring") dolfin::Array::Array(std::size_t N) "
Create array of size N. :cpp:any:`Array`  has ownership. 

:param std\\:\\:size_t N:
";

%feature("docstring") dolfin::Array::Array(std::size_t N, T *x) "
Construct array from a pointer. :cpp:any:`Array`  does not take ownership. 

:param std\\:\\:size_t N: 
:param T * x:
";

%feature("docstring") dolfin::Array::data() "
Return pointer to data (non-const version) 

:rtype: T *
";

%feature("docstring") dolfin::Array::data() const "
Return pointer to data (const version) 

:rtype: const T *
";

%feature("docstring") dolfin::Array::operator[](std::size_t i) "
Access value of given entry (non-const version) 

:param std\\:\\:size_t i: 
:rtype: T &
";

%feature("docstring") dolfin::Array::operator[](std::size_t i) const "
Access value of given entry (const version) 

:param std\\:\\:size_t i: 
:rtype: const T &
";

%feature("docstring") dolfin::Array::size() const "
Return size of array. 

:rtype: std::size_t
";

%feature("docstring") dolfin::Array::str(bool verbose) const "
Return informal string representation (pretty-print). Note that the :cpp:any:`Array`  class is not a subclass of :cpp:any:`Variable`  (for efficiency) which means that one needs to call :cpp:any:`str()`  directly instead of using the :cpp:any:`info()`  function on :cpp:any:`Array`  objects. 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Array::~Array() "
Destructor.
";

%feature("docstring") dolfin::ArrayView "
This class provides a wrapper for a pointer to an array. It never owns the data, and will not be valid if the underlying data goes out-of-scope.
";

%feature("docstring") dolfin::ArrayView::ArrayView() "
Constructor.
";

%feature("docstring") dolfin::ArrayView::ArrayView(V &v) "
Construct array from a container with the the :cpp:any:`data()`  and :cpp:any:`size()`  functions 

:param V & v:
";

%feature("docstring") dolfin::ArrayView::ArrayView(const ArrayView &x) "
Copy constructor. 

:param const ArrayView & x:
";

%feature("docstring") dolfin::ArrayView::ArrayView(std::size_t N, T *x) "
Construct array from a pointer. :cpp:any:`Array`  does not take ownership. 

:param std\\:\\:size_t N: 
:param T * x:
";

%feature("docstring") dolfin::ArrayView::begin() "
Pointer to start of array. 

:rtype: T *
";

%feature("docstring") dolfin::ArrayView::begin() const "
Pointer to start of array (const) 

:rtype: const T *
";

%feature("docstring") dolfin::ArrayView::data() "
Return pointer to data (non-const version) 

:rtype: T *
";

%feature("docstring") dolfin::ArrayView::data() const "
Return pointer to data (const version) 

:rtype: const T *
";

%feature("docstring") dolfin::ArrayView::empty() const "
Test if array view is empty. 

:rtype: bool
";

%feature("docstring") dolfin::ArrayView::end() "
Pointer to beyond end of array. 

:rtype: T *
";

%feature("docstring") dolfin::ArrayView::end() const "
Pointer to beyond end of array (const) 

:rtype: const T *
";

%feature("docstring") dolfin::ArrayView::operator[](std::size_t i) "
Access value of given entry (non-const version) 

:param std\\:\\:size_t i: 
:rtype: T &
";

%feature("docstring") dolfin::ArrayView::operator[](std::size_t i) const "
Access value of given entry (const version) 

:param std\\:\\:size_t i: 
:rtype: const T &
";

%feature("docstring") dolfin::ArrayView::set(V &v) "
Update object to point to new container. 

:param V & v: 
:rtype: void
";

%feature("docstring") dolfin::ArrayView::set(std::size_t N, T *x) "
Update object to point to new data. 

:param std\\:\\:size_t N: 
:param T * x: 
:rtype: void
";

%feature("docstring") dolfin::ArrayView::size() const "
Return size of array. 

:rtype: std::size_t
";

%feature("docstring") dolfin::ArrayView::~ArrayView() "
Destructor.
";

%feature("docstring") dolfin::Hierarchical "
This class provides storage and data access for hierarchical classes; that is, classes where an object may have a child and a parent.
Note to developers: each subclass of :cpp:any:`Hierarchical`  that implements an assignment operator must call the base class assignment operator at the end of the subclass assignment operator. See the :cpp:any:`Mesh`  class for an example.
";

%feature("docstring") dolfin::Hierarchical::Hierarchical(T &self) "
Constructor. 

:param T & self:
";

%feature("docstring") dolfin::Hierarchical::child() "
Return child in hierarchy. An error is thrown if the object has no child.
ReturnsT The child object. 

:rtype: T &
";

%feature("docstring") dolfin::Hierarchical::child() const "
Return child in hierarchy (const version). 

:rtype: const T &
";

%feature("docstring") dolfin::Hierarchical::child_shared_ptr() "
Return shared pointer to child. A zero pointer is returned if the object has no child.
Returns shared_ptr<T> The child object. 

:rtype: std::shared_ptr< T >
";

%feature("docstring") dolfin::Hierarchical::child_shared_ptr() const "
Return shared pointer to child (const version). 

:rtype: std::shared_ptr< const T >
";

%feature("docstring") dolfin::Hierarchical::clear_child() "
Clear child. 

:rtype: void
";

%feature("docstring") dolfin::Hierarchical::depth() const "
Return depth of the hierarchy; that is, the total number of objects in the hierarchy linked to the current object via child-parent relationships, including the object itself.
Returns std::size_t The depth of the hierarchy. 

:rtype: std::size_t
";

%feature("docstring") dolfin::Hierarchical::has_child() const "
Check if the object has a child.
Returns bool The return value is true iff the object has a child. 

:rtype: bool
";

%feature("docstring") dolfin::Hierarchical::has_parent() const "
Check if the object has a parent.
Returns bool The return value is true iff the object has a parent. 

:rtype: bool
";

%feature("docstring") dolfin::Hierarchical::leaf_node() "
Return leaf node object in hierarchy.
ReturnsT The leaf node object. 

:rtype: T &
";

%feature("docstring") dolfin::Hierarchical::leaf_node() const "
Return leaf node object in hierarchy (const version). 

:rtype: const T &
";

%feature("docstring") dolfin::Hierarchical::leaf_node_shared_ptr() "
Return shared pointer to leaf node object in hierarchy.
ReturnsT The leaf node object. 

:rtype: std::shared_ptr< T >
";

%feature("docstring") dolfin::Hierarchical::leaf_node_shared_ptr() const "
Return shared pointer to leaf node object in hierarchy (const version). 

:rtype: std::shared_ptr< const T >
";

%feature("docstring") dolfin::Hierarchical::operator=(const Hierarchical &hierarchical) "
Assignment operator. 

:param const Hierarchical & hierarchical: 
:rtype: const Hierarchical &
";

%feature("docstring") dolfin::Hierarchical::parent() "
Return parent in hierarchy. An error is thrown if the object has no parent.
ReturnsObject The parent object. 

:rtype: T &
";

%feature("docstring") dolfin::Hierarchical::parent() const "
Return parent in hierarchy (const version). 

:rtype: const T &
";

%feature("docstring") dolfin::Hierarchical::parent_shared_ptr() "
Return shared pointer to parent. A zero pointer is returned if the object has no parent.
Returns shared_ptr<T> The parent object. 

:rtype: std::shared_ptr< T >
";

%feature("docstring") dolfin::Hierarchical::parent_shared_ptr() const "
Return shared pointer to parent (const version). 

:rtype: std::shared_ptr< const T >
";

%feature("docstring") dolfin::Hierarchical::root_node() "
Return root node object in hierarchy.
ReturnsT The root node object. 

:rtype: T &
";

%feature("docstring") dolfin::Hierarchical::root_node() const "
Return root node object in hierarchy (const version). 

:rtype: const T &
";

%feature("docstring") dolfin::Hierarchical::root_node_shared_ptr() "
Return shared pointer to root node object in hierarchy.
ReturnsT The root node object. 

:rtype: std::shared_ptr< T >
";

%feature("docstring") dolfin::Hierarchical::root_node_shared_ptr() const "
Return shared pointer to root node object in hierarchy (const version). 

:rtype: std::shared_ptr< const T >
";

%feature("docstring") dolfin::Hierarchical::set_child(std::shared_ptr< T > child) "
:cpp:any:`Set`  child. 

:param std\\:\\:shared_ptr< T > child: 
:rtype: void
";

%feature("docstring") dolfin::Hierarchical::set_parent(std::shared_ptr< T > parent) "
:cpp:any:`Set`  parent. 

:param std\\:\\:shared_ptr< T > parent: 
:rtype: void
";

%feature("docstring") dolfin::Hierarchical::~Hierarchical() "
Destructor.
";

%feature("docstring") dolfin::IndexSet "
This class provides an efficient data structure for index sets. The cost of checking whether a given index is in the set is O(1) and very very fast (optimal) at the cost of extra storage.
";

%feature("docstring") dolfin::IndexSet::IndexSet(std::size_t size) "
Create index set of given size. 

:param std\\:\\:size_t size:
";

%feature("docstring") dolfin::IndexSet::clear() "
Clear set. 

:rtype: void
";

%feature("docstring") dolfin::IndexSet::empty() const "
Return true if set is empty. 

:rtype: bool
";

%feature("docstring") dolfin::IndexSet::fill() "
Fill index set with indices 0, 1, 2, ..., size - 1. 

:rtype: void
";

%feature("docstring") dolfin::IndexSet::find(std::size_t index) const "
Return position (if any) for given index. 

:param std\\:\\:size_t index: 
:rtype: std::size_t
";

%feature("docstring") dolfin::IndexSet::has_index(std::size_t index) const "
Check whether index is in set. 

:param std\\:\\:size_t index: 
:rtype: bool
";

%feature("docstring") dolfin::IndexSet::insert(std::size_t index) "
Insert index into set. 

:param std\\:\\:size_t index: 
:rtype: void
";

%feature("docstring") dolfin::IndexSet::operator[](std::size_t i) "
Return given index. 

:param std\\:\\:size_t i: 
:rtype: std::size_t &
";

%feature("docstring") dolfin::IndexSet::operator[](std::size_t i) const "
Return given index (const version) 

:param std\\:\\:size_t i: 
:rtype: const std::size_t &
";

%feature("docstring") dolfin::IndexSet::size() const "
Return size of set. 

:rtype: std::size_t
";

%feature("docstring") dolfin::IndexSet::~IndexSet() "
Destructor.
";

%feature("docstring") dolfin::MPI "
This class provides utility functions for easy communication with :cpp:any:`MPI`  and handles cases when DOLFIN is not configured with :cpp:any:`MPI` .
";

%feature("docstring") dolfin::MPI::all_gather(MPI_Comm comm, const T in_value, std::vector< T > &out_values) "
Gather values, one primitive from each process (MPI_Allgather) 

:param MPI_Comm comm: 
:param const T in_value: 
:param std\\:\\:vector< T > & out_values: 
:rtype: void
";

%feature("docstring") dolfin::MPI::all_gather(MPI_Comm comm, const std::vector< T > &in_values, std::vector< T > &out_values) "
Gather values from all processes. Same data count from each process (wrapper for MPI_Allgather) 

:param MPI_Comm comm: 
:param const std\\:\\:vector< T > & in_values: 
:param std\\:\\:vector< T > & out_values: 
:rtype: void
";

%feature("docstring") dolfin::MPI::all_gather(MPI_Comm comm, const std::vector< T > &in_values, std::vector< std::vector< T > > &out_values) "
Gather values from each process (variable count per process) 

:param MPI_Comm comm: 
:param const std\\:\\:vector< T > & in_values: 
:param std\\:\\:vector< std\\:\\:vector< T > > & out_values: 
:rtype: void
";

%feature("docstring") dolfin::MPI::all_reduce(MPI_Comm comm, const T &value, X op) "
All reduce. 

:param MPI_Comm comm: 
:param const T & value: 
:param X op: 
:rtype: T
";

%feature("docstring") dolfin::MPI::all_to_all(MPI_Comm comm, std::vector< std::vector< T >> &in_values, std::vector< std::vector< T >> &out_values) "
Send in_values[p0] to process p0 and receive values from process p1 in out_values[p1] 

:param MPI_Comm comm: 
:param std\\:\\:vector< std\\:\\:vector< T >> & in_values: 
:param std\\:\\:vector< std\\:\\:vector< T >> & out_values: 
:rtype: void
";

%feature("docstring") dolfin::MPI::avg(MPI_Comm comm, const T &value) "
Return average across comm; implemented only for T == :cpp:any:`Table` . 

:param MPI_Comm comm: 
:param const T & value: 
:rtype: T
";

%feature("docstring") dolfin::MPI::barrier(MPI_Comm comm) "
:cpp:any:`Set`  a barrier (synchronization point) 

:param MPI_Comm comm: 
:rtype: void
";

%feature("docstring") dolfin::MPI::broadcast(MPI_Comm comm, T &value, unsigned int broadcaster=0) "
Broadcast single primitive from broadcaster to all processes. 

:param MPI_Comm comm: 
:param T & value: 
:param unsigned int broadcaster: 
:rtype: void
";

%feature("docstring") dolfin::MPI::broadcast(MPI_Comm comm, std::vector< T > &value, unsigned int broadcaster=0) "
Broadcast vector of value from broadcaster to all processes. 

:param MPI_Comm comm: 
:param std\\:\\:vector< T > & value: 
:param unsigned int broadcaster: 
:rtype: void
";

%feature("docstring") dolfin::MPI::compute_local_range(int process, std::int64_t N, int size) "
Return local range for given process, splitting [0, N - 1] into :cpp:any:`size()`  portions of almost equal size 

:param int process: 
:param std\\:\\:int64_t N: 
:param int size: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::MPI::error_no_mpi(const char *where) "
:param const char * where: 
:rtype: void
";

%feature("docstring") dolfin::MPI::gather(MPI_Comm comm, const std::string &in_values, std::vector< std::string > &out_values, unsigned int receiving_process=0) "
Gather strings on one process. 

:param MPI_Comm comm: 
:param const std\\:\\:string & in_values: 
:param std\\:\\:vector< std\\:\\:string > & out_values: 
:param unsigned int receiving_process: 
:rtype: void
";

%feature("docstring") dolfin::MPI::gather(MPI_Comm comm, const std::vector< T > &in_values, std::vector< T > &out_values, unsigned int receiving_process=0) "
Gather values on one process. 

:param MPI_Comm comm: 
:param const std\\:\\:vector< T > & in_values: 
:param std\\:\\:vector< T > & out_values: 
:param unsigned int receiving_process: 
:rtype: void
";

%feature("docstring") dolfin::MPI::global_offset(MPI_Comm comm, std::size_t range, bool exclusive) "
Find global offset (index) (wrapper for MPI_(Ex)Scan with MPI_SUM as reduction op) 

:param MPI_Comm comm: 
:param std\\:\\:size_t range: 
:param bool exclusive: 
:rtype: std::size_t
";

%feature("docstring") dolfin::MPI::index_owner(MPI_Comm comm, std::size_t index, std::size_t N) "
Return which process owns index (inverse of local_range) 

:param MPI_Comm comm: 
:param std\\:\\:size_t index: 
:param std\\:\\:size_t N: 
:rtype: unsigned int
";

%feature("docstring") dolfin::MPI::is_broadcaster(MPI_Comm comm) "
Determine whether we should broadcast (based on current parallel policy) 

:param MPI_Comm comm: 
:rtype: bool
";

%feature("docstring") dolfin::MPI::is_receiver(MPI_Comm comm) "
Determine whether we should receive (based on current parallel policy) 

:param MPI_Comm comm: 
:rtype: bool
";

%feature("docstring") dolfin::MPI::local_range(MPI_Comm comm, int process, std::int64_t N) "
Return local range for given process, splitting [0, N - 1] into :cpp:any:`size()`  portions of almost equal size 

:param MPI_Comm comm: 
:param int process: 
:param std\\:\\:int64_t N: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::MPI::local_range(MPI_Comm comm, std::int64_t N) "
Return local range for local process, splitting [0, N - 1] into :cpp:any:`size()`  portions of almost equal size 

:param MPI_Comm comm: 
:param std\\:\\:int64_t N: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::MPI::max(MPI_Comm comm, const T &value) "
Return global max value. 

:param MPI_Comm comm: 
:param const T & value: 
:rtype: T
";

%feature("docstring") dolfin::MPI::min(MPI_Comm comm, const T &value) "
Return global min value. 

:param MPI_Comm comm: 
:param const T & value: 
:rtype: T
";

%feature("docstring") dolfin::MPI::rank(MPI_Comm comm) "
Return process rank for the communicator. 

:param MPI_Comm comm: 
:rtype: unsigned int
";

%feature("docstring") dolfin::MPI::scatter(MPI_Comm comm, const std::vector< T > &in_values, T &out_value, unsigned int sending_process=0) "
Scatter primitive in_values[i] to process i. 

:param MPI_Comm comm: 
:param const std\\:\\:vector< T > & in_values: 
:param T & out_value: 
:param unsigned int sending_process: 
:rtype: void
";

%feature("docstring") dolfin::MPI::scatter(MPI_Comm comm, const std::vector< std::vector< T > > &in_values, std::vector< T > &out_value, unsigned int sending_process=0) "
Scatter vector in_values[i] to process i. 

:param MPI_Comm comm: 
:param const std\\:\\:vector< std\\:\\:vector< T > > & in_values: 
:param std\\:\\:vector< T > & out_value: 
:param unsigned int sending_process: 
:rtype: void
";

%feature("docstring") dolfin::MPI::send_recv(MPI_Comm comm, const std::vector< T > &send_value, unsigned int dest, int send_tag, std::vector< T > &recv_value, unsigned int source, int recv_tag) "
Send-receive data between processes (blocking) 

:param MPI_Comm comm: 
:param const std\\:\\:vector< T > & send_value: 
:param unsigned int dest: 
:param int send_tag: 
:param std\\:\\:vector< T > & recv_value: 
:param unsigned int source: 
:param int recv_tag: 
:rtype: void
";

%feature("docstring") dolfin::MPI::send_recv(MPI_Comm comm, const std::vector< T > &send_value, unsigned int dest, std::vector< T > &recv_value, unsigned int source) "
Send-receive data between processes. 

:param MPI_Comm comm: 
:param const std\\:\\:vector< T > & send_value: 
:param unsigned int dest: 
:param std\\:\\:vector< T > & recv_value: 
:param unsigned int source: 
:rtype: void
";

%feature("docstring") dolfin::MPI::size(MPI_Comm comm) "
Return size of the group (number of processes) associated with the communicator 

:param MPI_Comm comm: 
:rtype: unsigned int
";

%feature("docstring") dolfin::MPI::sum(MPI_Comm comm, const T &value) "
Sum values and return sum. 

:param MPI_Comm comm: 
:param const T & value: 
:rtype: T
";

%feature("docstring") dolfin::NoDeleter "
:cpp:any:`NoDeleter`  is a customised deleter intended for use with smart pointers.
";

%feature("docstring") dolfin::NoDeleter::operator()(const void *) "
Do nothing. 

:rtype: void
";

%feature("docstring") dolfin::RangedIndexSet "
This class provides an special-purpose data structure for testing if a given index within a range is set. It is very fast.
The memory requirements are one bit per item in range, since it uses a (packed) std::vector<bool> for storage.
";

%feature("docstring") dolfin::RangedIndexSet::RangedIndexSet(std::pair< std::size_t, std::size_t > range) "
Create a ranged set with range given as a (lower, upper) pair. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range:
";

%feature("docstring") dolfin::RangedIndexSet::RangedIndexSet(std::size_t upper_range) "
Create a ranged set with 0 as lower range. 

:param std\\:\\:size_t upper_range:
";

%feature("docstring") dolfin::RangedIndexSet::clear() "
Erase all indices from the set. 

:rtype: void
";

%feature("docstring") dolfin::RangedIndexSet::erase(std::size_t i) "
Erase an index from the set. 

:param std\\:\\:size_t i: 
:rtype: void
";

%feature("docstring") dolfin::RangedIndexSet::has_index(std::size_t i) const "
Check is the set contains the given index. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::RangedIndexSet::in_range(std::size_t i) const "
Return true if a given index is within range, i.e., if it can be stored in the set. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::RangedIndexSet::insert(std::size_t i) "
Insert a given index into the set. Returns true if the index was inserted (i.e., the index was not already in the set). 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::Set "
This is a set-like data structure. It is not ordered and it is based a std::vector. It uses linear search, and can be faster than std::set
";

%feature("docstring") dolfin::Set::Set() "
Create empty set.
";

%feature("docstring") dolfin::Set::Set(const dolfin::Set< T > &x) "
Copy constructor. 

:param const dolfin\\:\\:Set< T > & x:
";

%feature("docstring") dolfin::Set::Set(std::vector< T > &x) "
Wrap std::vector as a set. Contents will be erased. 

:param std\\:\\:vector< T > & x:
";

%feature("docstring") dolfin::Set::begin() const "
Iterator to start of :cpp:any:`Set` . 

:rtype: const_iterator
";

%feature("docstring") dolfin::Set::clear() "
Clear set. 

:rtype: void
";

%feature("docstring") dolfin::Set::const_iterator "
Const iterator. 

:rtype: std::vector< T >::const_iterator
";

%feature("docstring") dolfin::Set::end() const "
Iterator to beyond end of :cpp:any:`Set` . 

:rtype: const_iterator
";

%feature("docstring") dolfin::Set::erase(const T &x) "
Erase an entry. 

:param const T & x: 
:rtype: void
";

%feature("docstring") dolfin::Set::find(const T &x) "
Find entry in set and return an iterator to the entry. 

:param const T & x: 
:rtype: iterator
";

%feature("docstring") dolfin::Set::find(const T &x) const "
Find entry in set and return an iterator to the entry (const) 

:param const T & x: 
:rtype: const_iterator
";

%feature("docstring") dolfin::Set::insert(const InputIt first, const InputIt last) "
Insert entries. 

:param const InputIt first: 
:param const InputIt last: 
:rtype: void
";

%feature("docstring") dolfin::Set::insert(const T &x) "
Insert entry. 

:param const T & x: 
:rtype: bool
";

%feature("docstring") dolfin::Set::iterator "
Iterator. 

:rtype: std::vector< T >::iterator
";

%feature("docstring") dolfin::Set::operator[](std::size_t n) const "
Index the nth entry in the set. 

:param std\\:\\:size_t n: 
:rtype: T
";

%feature("docstring") dolfin::Set::set() "
Return the vector that stores the data in the :cpp:any:`Set` . 

:rtype: std::vector< T > &
";

%feature("docstring") dolfin::Set::set() const "
Return the vector that stores the data in the :cpp:any:`Set` . 

:rtype: const std::vector< T > &
";

%feature("docstring") dolfin::Set::size() const "
:cpp:any:`Set`  size. 

:rtype: std::size_t
";

%feature("docstring") dolfin::Set::sort() "
Sort set. 

:rtype: void
";

%feature("docstring") dolfin::Set::~Set() "
Destructor.
";

%feature("docstring") dolfin::SubSystemsManager "
This is a singleton class which manages the initialisation and finalisation of various sub systems, such as :cpp:any:`MPI`  and PETSc.
";

%feature("docstring") dolfin::SubSystemsManager::PetscDolfinErrorHandler(MPI_Comm comm, int line, const char *fun, const char *file, PetscErrorCode n, PetscErrorType p, const char *mess, void *ctx) "
PETSc error handler. Logs everything known to DOLFIN logging system (with level TRACE) and stores the error message into pests_err_msg member. 

:param MPI_Comm comm: 
:param int line: 
:param const char * fun: 
:param const char * file: 
:param PetscErrorCode n: 
:param PetscErrorType p: 
:param const char * mess: 
:param void * ctx: 
:rtype: PetscErrorCode
";

%feature("docstring") dolfin::SubSystemsManager::SubSystemsManager() "

";

%feature("docstring") dolfin::SubSystemsManager::SubSystemsManager(const SubSystemsManager &) "
:param const SubSystemsManager & sub_sys_manager:
";

%feature("docstring") dolfin::SubSystemsManager::control_mpi "
:rtype: bool
";

%feature("docstring") dolfin::SubSystemsManager::finalize() "
Finalize subsystems. This will be called by the destructor, but in special cases it may be necessary to call :cpp:any:`finalize()`  explicitly. 

:rtype: void
";

%feature("docstring") dolfin::SubSystemsManager::finalize_mpi() "
:rtype: void
";

%feature("docstring") dolfin::SubSystemsManager::finalize_petsc() "
:rtype: void
";

%feature("docstring") dolfin::SubSystemsManager::init_mpi() "
Initialise :cpp:any:`MPI` . 

:rtype: void
";

%feature("docstring") dolfin::SubSystemsManager::init_mpi(int argc, char *argv[], int required_thread_level) "
Initialise :cpp:any:`MPI`  with required level of thread support. 

:param int argc: 
:param char * argv: 
:param int required_thread_level: 
:rtype: int
";

%feature("docstring") dolfin::SubSystemsManager::init_petsc() "
Initialize PETSc without command-line arguments. 

:rtype: void
";

%feature("docstring") dolfin::SubSystemsManager::init_petsc(int argc, char *argv[]) "
Initialize PETSc with command-line arguments. Note that PETSc command-line arguments may also be filtered and sent to PETSc by parameters.parse(argc, argv). 

:param int argc: 
:param char * argv: 
:rtype: void
";

%feature("docstring") dolfin::SubSystemsManager::mpi_finalized() "
Check if :cpp:any:`MPI`  has been finalized (returns true if :cpp:any:`MPI`  has been finalised) 

:rtype: bool
";

%feature("docstring") dolfin::SubSystemsManager::mpi_initialized() "
Check if :cpp:any:`MPI`  has been initialised (returns true if :cpp:any:`MPI`  has been initialised, even if it is later finalised) 

:rtype: bool
";

%feature("docstring") dolfin::SubSystemsManager::petsc_err_msg "
Last recorded PETSc error message. 

:rtype: std::string
";

%feature("docstring") dolfin::SubSystemsManager::petsc_initialized "
:rtype: bool
";

%feature("docstring") dolfin::SubSystemsManager::responsible_mpi() "
Return true if DOLFIN initialised :cpp:any:`MPI`  (and is therefore responsible for finalization) 

:rtype: bool
";

%feature("docstring") dolfin::SubSystemsManager::responsible_petsc() "
Return true if DOLFIN initialised PETSc (and is therefore responsible for finalization) 

:rtype: bool
";

%feature("docstring") dolfin::SubSystemsManager::singleton() "
Singleton instance. Calling this ensures singleton instance of :cpp:any:`SubSystemsManager`  is initialized according to the \"Construct
on First Use\" idiom. 

:rtype: SubSystemsManager &
";

%feature("docstring") dolfin::SubSystemsManager::~SubSystemsManager() "

";

%feature("docstring") dolfin::Timer "
A timer can be used for timing tasks. The basic usage is
:cpp:any:`Timer`  timer(\"Assembling over cells\");
The timer is started at construction and timing ends when the timer is destroyed (goes out of scope). It is also possible to start and stop a timer explicitly by
timer.start(); timer.stop();
Timings are stored globally and a summary may be printed by calling
:cpp:any:`list_timings()` ;
";

%feature("docstring") dolfin::Timer::Timer() "
Create timer without logging.
";

%feature("docstring") dolfin::Timer::Timer(std::string task) "
Create timer with logging. 

:param std\\:\\:string task:
";

%feature("docstring") dolfin::Timer::elapsed() const "
Return wall, user and system time in seconds. Wall-clock time has precision around 1 microsecond; user and system around 10 millisecond. 

:rtype: std::tuple< double, double, double >
";

%feature("docstring") dolfin::Timer::resume() "
Resume timer. Not well-defined for logging timer. 

:rtype: void
";

%feature("docstring") dolfin::Timer::start() "
Zero and start timer. 

:rtype: void
";

%feature("docstring") dolfin::Timer::stop() "
Stop timer, return wall time elapsed and store timing data into logger 

:rtype: double
";

%feature("docstring") dolfin::Timer::~Timer() "
Destructor.
";

%feature("docstring") dolfin::UniqueIdGenerator "
This is a singleton class that return IDs that are unique in the lifetime of a program.
";

%feature("docstring") dolfin::UniqueIdGenerator::UniqueIdGenerator() "

";

%feature("docstring") dolfin::UniqueIdGenerator::id() "
Generate a unique ID. 

:rtype: std::size_t
";

%feature("docstring") dolfin::UniqueIdGenerator::next_id "
:rtype: std::size_t
";

%feature("docstring") dolfin::UniqueIdGenerator::unique_id_generator "
:rtype: UniqueIdGenerator
";

%feature("docstring") dolfin::Variable "
Common base class for DOLFIN variables.
";

%feature("docstring") dolfin::Variable::Variable() "
Create unnamed variable.
";

%feature("docstring") dolfin::Variable::Variable(const Variable &variable) "
Copy constructor. 

:param const Variable & variable:
";

%feature("docstring") dolfin::Variable::Variable(const std::string name, const std::string label) "
Create variable with given name and label. 

:param const std\\:\\:string name: 
:param const std\\:\\:string label:
";

%feature("docstring") dolfin::Variable::id() const "
Get unique identifier.
Returnsstd::size_t The unique integer identifier associated with the object. 

:rtype: std::size_t
";

%feature("docstring") dolfin::Variable::label() const "
Return label (description) 

:rtype: std::string
";

%feature("docstring") dolfin::Variable::name() const "
Return name. 

:rtype: std::string
";

%feature("docstring") dolfin::Variable::operator=(const Variable &variable) "
Assignment operator. 

:param const Variable & variable: 
:rtype: const Variable &
";

%feature("docstring") dolfin::Variable::parameters "
:cpp:any:`Parameters` . 

:rtype: Parameters
";

%feature("docstring") dolfin::Variable::rename(const std::string name, const std::string label) "
Rename variable. 

:param const std\\:\\:string name: 
:param const std\\:\\:string label: 
:rtype: void
";

%feature("docstring") dolfin::Variable::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Variable::unique_id "
:rtype: const std::size_t
";

%feature("docstring") dolfin::Variable::~Variable() "
Destructor.
";

%feature("docstring") dolfin::container_to_string(const T &x, std::string delimiter, int precision, int linebreak=0) "
Return string representation of given container of ints, floats, etc. 

:param const T & x: 
:param std\\:\\:string delimiter: 
:param int precision: 
:param int linebreak: 
:rtype: std::string
";

%feature("docstring") dolfin::dolfin_version() "
Return DOLFIN version string. 

:rtype: std::string
";

%feature("docstring") dolfin::dump_timings_to_xml(std::string filename, TimingClear clear) "
Dump a summary of timings and tasks to XML file, optionally clearing stored timings. ``MPI_MAX`` , ``MPI_MIN``  and ``MPI_AVG``  reductions are stored. Collective on ``MPI_COMM_WORLD`` .
Arguments filename (std::string) output filename; must have ``.xml``  suffix; existing file is silently overwritten clear (TimingClear)

*  ``TimingClear::clear``  resets stored timings
*  ``TimingClear::keep``  leaves stored timings intact

:param std\\:\\:string filename: 
:param TimingClear clear: 
:rtype: void
";

%feature("docstring") dolfin::git_commit_hash() "
Return git changeset hash (returns \"unknown\" if changeset is not known) 

:rtype: std::string
";

%feature("docstring") dolfin::has_cholmod() "
Return true if DOLFIN is compiled with Cholmod. 

:rtype: bool
";

%feature("docstring") dolfin::has_debug() "
Return true if DOLFIN is compiled in debugging mode, i.e., with assertions on 

:rtype: bool
";

%feature("docstring") dolfin::has_hdf5() "
Return true if DOLFIN is compiled with HDF5. 

:rtype: bool
";

%feature("docstring") dolfin::has_hdf5_parallel() "
Return true if DOLFIN is compiled with Parallel HDF5. 

:rtype: bool
";

%feature("docstring") dolfin::has_mpi() "
Return true if DOLFIN is compiled with :cpp:any:`MPI` . 

:rtype: bool
";

%feature("docstring") dolfin::has_openmp() "
Return true if DOLFIN is compiled with OpenMP. 

:rtype: bool
";

%feature("docstring") dolfin::has_parmetis() "
Return true if DOLFIN is compiled with :cpp:any:`ParMETIS` . 

:rtype: bool
";

%feature("docstring") dolfin::has_petsc() "
Return true if DOLFIN is compiled with PETSc. 

:rtype: bool
";

%feature("docstring") dolfin::has_scotch() "
Return true if DOLFIN is compiled with Scotch. 

:rtype: bool
";

%feature("docstring") dolfin::has_slepc() "
Return true if DOLFIN is compiled with SLEPc. 

:rtype: bool
";

%feature("docstring") dolfin::has_umfpack() "
Return true if DOLFIN is compiled with Umfpack. 

:rtype: bool
";

%feature("docstring") dolfin::has_vtk() "
Return true if DOLFIN is compiled with VTK. 

:rtype: bool
";

%feature("docstring") dolfin::has_zlib() "
Return true if DOLFIN is compiled with ZLIB. 

:rtype: bool
";

%feature("docstring") dolfin::hash_global(const MPI_Comm mpi_comm, const T &x) "
Return a hash for a distributed (:cpp:any:`MPI` ) object. A hash is computed on each process, and the hash of the std::vector of all local hash keys is returned. This function is collective. 

:param const MPI_Comm mpi_comm: 
:param const T & x: 
:rtype: std::size_t
";

%feature("docstring") dolfin::hash_local(const T &x) "
Return a hash of a given object. 

:param const T & x: 
:rtype: std::size_t
";

%feature("docstring") dolfin::indent(std::string block) "
Indent string block. 

:param std\\:\\:string block: 
:rtype: std::string
";

%feature("docstring") dolfin::init(int argc, char *argv[]) "
Initialize DOLFIN (and PETSc) with command-line arguments. This should not be needed in most cases since the initialization is otherwise handled automatically. 

:param int argc: 
:param char * argv: 
:rtype: void
";

%feature("docstring") dolfin::list_timings(TimingClear clear, std::set< TimingType > type) "
List a summary of timings and tasks, optionally clearing stored timings. ``MPI_AVG``  reduction is printed. Collective on ``MPI_COMM_WORLD`` .
Arguments clear (TimingClear)

*  ``TimingClear::clear``  resets stored timings
*  ``TimingClear::keep``  leaves stored timings intact type (std::set<TimingType>) subset of ``{ TimingType::wall, TimingType::user, TimingType::system }``

:param TimingClear clear: 
:param std\\:\\:set< TimingType > type: 
:rtype: void
";

%feature("docstring") dolfin::reference_to_no_delete_pointer(T &r) "
Helper function to construct shared pointer with :cpp:any:`NoDeleter`  with cleaner syntax. 

:param T & r: 
:rtype: std::shared_ptr< T >
";

%feature("docstring") dolfin::sizeof_la_index() "
Return sizeof the :cpp:any:`dolfin::la_index`  type. 

:rtype: std::size_t
";

%feature("docstring") dolfin::tic() "
Start timing (should not be used internally in DOLFIN!) 

:rtype: void
";

%feature("docstring") dolfin::time() "
Return wall time elapsed since some implementation dependent epoch. 

:rtype: double
";

%feature("docstring") dolfin::timing(std::string task, TimingClear clear) "
Return timing (count, total wall time, total user time, total system time) for given task, optionally clearing all timings for the task
Arguments task (std::string) name of a task clear (TimingClear)

*  ``TimingClear::clear``  resets stored timings
*  ``TimingClear::keep``  leaves stored timings intact

Returns std::tuple<std::size_t, double, double, double> (count, total wall time, total user time, total system time) 

:param std\\:\\:string task: 
:param TimingClear clear: 
:rtype: std::tuple< std::size_t, double, double, double >
";

%feature("docstring") dolfin::timings(TimingClear clear, std::set< TimingType > type) "
Return a summary of timings and tasks in a :cpp:any:`Table` , optionally clearing stored timings
Arguments clear (TimingClear)

*  ``TimingClear::clear``  resets stored timings
*  ``TimingClear::keep``  leaves stored timings intact type (std::set<TimingType>) subset of ``{ TimingType::wall, TimingType::user, TimingType::system }``

Returns:cpp:any:`Table` :cpp:any:`Table`  with timings 

:param TimingClear clear: 
:param std\\:\\:set< TimingType > type: 
:rtype: Table
";

%feature("docstring") dolfin::to_string(const double *x, std::size_t n) "
Return string representation of given array. 

:param const double * x: 
:param std\\:\\:size_t n: 
:rtype: std::string
";

%feature("docstring") dolfin::toc() "
Return elapsed wall time (should not be used internally in DOLFIN!) 

:rtype: double
";

%feature("docstring") dolfin::ufc_signature() "
Return :cpp:any:`UFC`  signature string. 

:rtype: std::string
";

%feature("docstring") dolfin::la_index "
Index type for compatibility with linear algebra backend(s) 

:rtype: PetscInt
";

%feature("docstring") dolfin::TimingClear "
:cpp:any:`Parameter`  specifying whether to clear timing(s):

*  ``TimingClear::keep``
*  ``TimingClear::clear``

.. cpp:enumerator:: dolfin::TimingClear::keep = false

.. cpp:enumerator:: dolfin::TimingClear::clear = true
";

%feature("docstring") dolfin::TimingType "
Timing types:

*  ``TimingType::wall``  wall-clock time
*  ``TimingType::user``  user (cpu) time
*  ``TimingType::system``  system (kernel) time

Precision of wall is around 1 microsecond, user and system are around 10 millisecond (on Linux). 

.. cpp:enumerator:: dolfin::TimingType::wall = 0

.. cpp:enumerator:: dolfin::TimingType::user = 1

.. cpp:enumerator:: dolfin::TimingType::system = 2
";

