// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::Assembler "
This class provides automated assembly of linear systems, or more generally, assembly of a sparse tensor from a given variational form.
Subdomains for cells and facets may be specified by assigning subdomain indicators specified by :cpp:any:`MeshFunction`  to the :cpp:any:`Form`  being assembled:

::
   
   form.dx = cell_domains
   form.ds = exterior_facet_domains
   form.dS = interior_facet_domains
";

%feature("docstring") dolfin::Assembler::Assembler() "
Constructor.
";

%feature("docstring") dolfin::Assembler::assemble(GenericTensor &A, const Form &a) "
Assemble tensor from given form

:param GenericTensor & A:  (:cpp:any:`GenericTensor` ) The tensor to assemble. [direction=out]
:param const Form & a:  (:cpp:any:`Form` &) The form to assemble the tensor from. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Assembler::assemble_cells(GenericTensor &A, const Form &a, UFC &ufc, std::shared_ptr< const MeshFunction< std::size_t >> domains, std::vector< double > *values) "
Assemble tensor from given form over cells. This function is provided for users who wish to build a customized assembler.

:param GenericTensor & A:  (:cpp:any:`GenericTensor` &) The tensor to assemble. [direction=out]
:param const Form & a:  (:cpp:any:`Form` &) The form to assemble the tensor from. [direction=in]
:param UFC & ufc:  (:cpp:any:`UFC` &) [direction=in]
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> domains:  (MeshFunction<std::size_t>) [direction=in]
:param std\\:\\:vector< double > * values:  (std::vector<double>*) [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Assembler::assemble_exterior_facets(GenericTensor &A, const Form &a, UFC &ufc, std::shared_ptr< const MeshFunction< std::size_t >> domains, std::vector< double > *values) "
Assemble tensor from given form over exterior facets. This function is provided for users who wish to build a customized assembler.

:param GenericTensor & A:  (:cpp:any:`GenericTensor` ) The tensor to assemble. [direction=out]
:param const Form & a:  (:cpp:any:`Form` ) The form to assemble the tensor from. [direction=in]
:param UFC & ufc:  (:cpp:any:`UFC` ) [direction=in]
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> domains:  (:cpp:any:`MeshFunction` ) [direction=in]
:param std\\:\\:vector< double > * values:  (std::vector<double>*) [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Assembler::assemble_interior_facets(GenericTensor &A, const Form &a, UFC &ufc, std::shared_ptr< const MeshFunction< std::size_t >> domains, std::shared_ptr< const MeshFunction< std::size_t >> cell_domains, std::vector< double > *values) "
Assemble tensor from given form over interior facets. This function is provided for users who wish to build a customized assembler.

:param GenericTensor & A:  (:cpp:any:`GenericTensor` ) The tensor to assemble. [direction=out]
:param const Form & a:  (:cpp:any:`Form` ) The form to assemble the tensor from. [direction=in]
:param UFC & ufc:  (:cpp:any:`UFC` ) [direction=in]
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> domains:  (MeshFunction<std::size_t>) [direction=in]
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> cell_domains:  (MeshFunction<std::size_t>) [direction=in]
:param std\\:\\:vector< double > * values:  (std::vector<double>*) [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Assembler::assemble_vertices(GenericTensor &A, const Form &a, UFC &ufc, std::shared_ptr< const MeshFunction< std::size_t >> domains) "
Assemble tensor from given form over vertices. This function is provided for users who wish to build a customized assembler.

:param GenericTensor & A:  (GenericTersn) The tensor to assemble. [direction=out]
:param const Form & a:  (:cpp:any:`Form` ) The form to assemble the tensor from. [direction=in]
:param UFC & ufc:  (:cpp:any:`UFC` ) [direction=in]
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> domains:  (:cpp:any:`MeshFunction` ) [direction=in]
:rtype: void
";

%feature("docstring") dolfin::AssemblerBase "
Provide some common functions used in assembler classes.
";

%feature("docstring") dolfin::AssemblerBase::AssemblerBase() "
Constructor.
";

%feature("docstring") dolfin::AssemblerBase::add_values "
add_values (bool) Default value is false. This controls whether values are added to the given tensor or if it is zeroed prior to assembly. 

:rtype: bool
";

%feature("docstring") dolfin::AssemblerBase::check(const Form &a) "
Check form. 

:param const Form & a: 
:rtype: void
";

%feature("docstring") dolfin::AssemblerBase::finalize_tensor "
finalize_tensor (bool) Default value is true. This controls whether the assembler finalizes the given tensor after assembly is completed by calling A.apply(). 

:rtype: bool
";

%feature("docstring") dolfin::AssemblerBase::init_global_tensor(GenericTensor &A, const Form &a) "
Initialize global tensor 

:param GenericTensor & A:  (:cpp:any:`GenericTensor` &) :cpp:any:`GenericTensor`  to assemble into [direction=out]
:param const Form & a:  (:cpp:any:`Form` &) :cpp:any:`Form`  to assemble from [direction=in]
:rtype: void
";

%feature("docstring") dolfin::AssemblerBase::keep_diagonal "
keep_diagonal (bool) Default value is false. This controls whether the assembler enures that a diagonal entry exists in an assembled matrix. It may be removed if the matrix is finalised. 

:rtype: bool
";

%feature("docstring") dolfin::AssemblerBase::progress_message(std::size_t rank, std::string integral_type) "
Pretty-printing for progress bar. 

:param std\\:\\:size_t rank: 
:param std\\:\\:string integral_type: 
:rtype: std::string
";

%feature("docstring") dolfin::BasisFunction "
Represention of a finite element basis function. 
It can be used for computation of basis function values and derivatives.
Evaluation of basis functions is also possible through the use of the functions ``evaluate_basis``  and ``evaluate_basis_derivatives``  available in the :cpp:any:`FiniteElement`  class. The :cpp:any:`BasisFunction`  class relies on these functions for evaluation but also implements the ufc::function interface which allows evaluate_dof to be evaluated for a basis function (on a possibly different element).
";

%feature("docstring") dolfin::BasisFunction::BasisFunction(std::size_t index, std::shared_ptr< const FiniteElement > element, const std::vector< double > &coordinate_dofs) "
Create basis function with given index on element on given cell

:param std\\:\\:size_t index:  (std::size_t) The index of the basis function.
:param std\\:\\:shared_ptr< const FiniteElement > element:  (:cpp:any:`FiniteElement` ) The element to create basis function on.
:param const std\\:\\:vector< double > & coordinate_dofs:  (std::vector<double>&) The coordinate dofs of the cell
";

%feature("docstring") dolfin::BasisFunction::eval(double *values, const double *x) const "
Evaluate basis function at given point

:param double * values:  (double) The values of the function at the point.
:param const double * x:  (double) The coordinates of the point.
:rtype: void
";

%feature("docstring") dolfin::BasisFunction::eval_derivatives(double *values, const double *x, std::size_t n) const "
Evaluate all order n derivatives at given point

:param double * values:  (double) The values of derivatives at the point.
:param const double * x:  (double) The coordinates of the point.
:param std\\:\\:size_t n:  (std::size_t) The order of derivation.
:rtype: void
";

%feature("docstring") dolfin::BasisFunction::evaluate(double *values, const double *coordinates, const ufc::cell &cell) const "
Evaluate function at given point in cell

:param double * values:  (double) The values of the function at the point..
:param const double * coordinates:  (double) The coordinates of the point.
:param const ufc\\:\\:cell & cell:  (ufc::cell) The cell.
:rtype: void
";

%feature("docstring") dolfin::BasisFunction::update_index(std::size_t index) "
Update the basis function index

:param std\\:\\:size_t index:  (std::size_t) The index of the basis function.
:rtype: void
";

%feature("docstring") dolfin::BasisFunction::~BasisFunction() "
Destructor.
";

%feature("docstring") dolfin::DirichletBC "
Interface for setting (strong) Dirichlet boundary conditions. 
u = g on G,
where u is the solution to be computed, g is a function and G is a sub domain of the mesh.
A :cpp:any:`DirichletBC`  is specified by the function g, the function space (trial space) and boundary indicators on (a subset of) the mesh boundary.
The boundary indicators may be specified in a number of different ways.
The simplest approach is to specify the boundary by a :cpp:any:`SubDomain`  object, using the inside() function to specify on which facets the boundary conditions should be applied. The boundary facets will then be searched for and marked only on the first call to apply. This means that the mesh could be moved after the first apply and the boundary markers would still remain intact.
Alternatively, the boundary may be specified by a :cpp:any:`MeshFunction`  over facets labeling all mesh facets together with a number that specifies which facets should be included in the boundary.
The third option is to attach the boundary information to the mesh. This is handled automatically when exporting a mesh from for example VMTK.
The 'method' variable may be used to specify the type of method used to identify degrees of freedom on the boundary. Available methods are: topological approach (default), geometric approach, and pointwise approach. The topological approach is faster, but will only identify degrees of freedom that are located on a facet that is entirely on the boundary. In particular, the topological approach will not identify degrees of freedom for discontinuous elements (which are all internal to the cell). A remedy for this is to use the geometric approach. In the geometric approach, each dof on each facet that matches the boundary condition will be checked. To apply pointwise boundary conditions e.g. pointloads, one will have to use the pointwise approach. The three possibilities are \"topological\", \"geometric\" and \"pointwise\".
Note: when using \"pointwise\", the boolean argument ``on_boundary``  in :cpp:any:`SubDomain::inside`  will always be false.
The 'check_midpoint' variable can be used to decide whether or not the midpoint of each facet should be checked when a user-defined :cpp:any:`SubDomain`  is used to define the domain of the boundary condition. By default, midpoints are always checked. Note that this variable may be of importance close to corners, in which case it is sometimes important to check the midpoint to avoid including facets \"on the diagonal close\" to a corner. This variable is also of importance for curved boundaries (like on a sphere or cylinder), in which case it is important not to check the midpoint which will be located in the interior of a domain defined relative to a radius.
Note that there may be caching employed in BC computation for performance reasons. In particular, applicable DOFs are cached by some methods on a first :cpp:any:`apply()` . This means that changing a supplied object (defining boundary subdomain) after first use may have no effect. But this is implementation and method specific.
";

%feature("docstring") dolfin::DirichletBC::DirichletBC(const DirichletBC &bc) "
Copy constructor. Either cached DOF data are copied.

:param const DirichletBC & bc:  (:cpp:any:`DirichletBC` &) The object to be copied. [direction=in]
";

%feature("docstring") dolfin::DirichletBC::DirichletBC(std::shared_ptr< const FunctionSpace > V, std::shared_ptr< const GenericFunction > g, const std::vector< std::size_t > &markers, std::string method="topological") "
Create boundary condition for subdomain by boundary markers (cells, local facet numbers)

:param std\\:\\:shared_ptr< const FunctionSpace > V:  (:cpp:any:`FunctionSpace` ) The function space. [direction=in]
:param std\\:\\:shared_ptr< const GenericFunction > g:  (:cpp:any:`GenericFunction` ) The value. [direction=in]
:param const std\\:\\:vector< std\\:\\:size_t > & markers:  (std::vector<std:size_t>&) Subdomain markers (facet index local to process) [direction=in]
:param std\\:\\:string method:  (std::string) Optional argument: A string specifying the method to identify dofs. [direction=in]
";

%feature("docstring") dolfin::DirichletBC::DirichletBC(std::shared_ptr< const FunctionSpace > V, std::shared_ptr< const GenericFunction > g, std::shared_ptr< const MeshFunction< std::size_t >> sub_domains, std::size_t sub_domain, std::string method="topological") "
Create boundary condition for subdomain specified by index

:param std\\:\\:shared_ptr< const FunctionSpace > V:  (:cpp:any:`FunctionSpace` ) The function space. [direction=in]
:param std\\:\\:shared_ptr< const GenericFunction > g:  (:cpp:any:`GenericFunction` ) The value. [direction=in]
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> sub_domains:  (MeshFnunction<std::size_t>) Subdomain markers [direction=in]
:param std\\:\\:size_t sub_domain:  (std::size_t) The subdomain index (number) [direction=in]
:param std\\:\\:string method:  (std::string) Optional argument: A string specifying the method to identify dofs. [direction=in]
";

%feature("docstring") dolfin::DirichletBC::DirichletBC(std::shared_ptr< const FunctionSpace > V, std::shared_ptr< const GenericFunction > g, std::shared_ptr< const SubDomain > sub_domain, std::string method="topological", bool check_midpoint=true) "
Create boundary condition for subdomain

:param std\\:\\:shared_ptr< const FunctionSpace > V:  (:cpp:any:`FunctionSpace` ) The function space [direction=in]
:param std\\:\\:shared_ptr< const GenericFunction > g:  (:cpp:any:`GenericFunction` ) The value [direction=in]
:param std\\:\\:shared_ptr< const SubDomain > sub_domain:  (:cpp:any:`SubDomain` ) The subdomain [direction=in]
:param std\\:\\:string method:  (std::string) Optional argument: A string specifying the method to identify dofs [direction=in]
:param bool check_midpoint:  (bool) [direction=in]
";

%feature("docstring") dolfin::DirichletBC::DirichletBC(std::shared_ptr< const FunctionSpace > V, std::shared_ptr< const GenericFunction > g, std::size_t sub_domain, std::string method="topological") "
Create boundary condition for boundary data included in the mesh

:param std\\:\\:shared_ptr< const FunctionSpace > V:  (:cpp:any:`FunctionSpace` ) The function space. [direction=in]
:param std\\:\\:shared_ptr< const GenericFunction > g:  (:cpp:any:`GenericFunction` ) The value. [direction=in]
:param std\\:\\:size_t sub_domain:  (std::size_t) The subdomain index (number) [direction=in]
:param std\\:\\:string method:  (std::string) Optional argument: A string specifying the method to identify dofs. [direction=in]
";

%feature("docstring") dolfin::DirichletBC::Map "
map type used by :cpp:any:`DirichletBC` 

:rtype: std::unordered_map< std::size_t, double >
";

%feature("docstring") dolfin::DirichletBC::apply(GenericMatrix &A) const "
Apply boundary condition to a matrix

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` ) The matrix to apply boundary condition to. [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::apply(GenericMatrix &A, GenericVector &b) const "
Apply boundary condition to a linear system

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` ) The matrix to apply boundary condition to. [direction=inout]
:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary condition to. [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::apply(GenericMatrix &A, GenericVector &b, const GenericVector &x) const "
Apply boundary condition to a linear system for a nonlinear problem

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` ) The matrix to apply boundary conditions to. [direction=inout]
:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary conditions to. [direction=inout]
:param const GenericVector & x:  (:cpp:any:`GenericVector` ) Another vector (nonlinear problem). [direction=in]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::apply(GenericMatrix *A, GenericVector *b, const GenericVector *x) const "
:param GenericMatrix * A: 
:param GenericVector * b: 
:param const GenericVector * x: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::apply(GenericVector &b) const "
Apply boundary condition to a vector

:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary condition to. [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::apply(GenericVector &b, const GenericVector &x) const "
Apply boundary condition to vectors for a nonlinear problem

:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary conditions to. [direction=inout]
:param const GenericVector & x:  (:cpp:any:`GenericVector` ) Another vector (nonlinear problem). [direction=in]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::check() const "
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::check_arguments(GenericMatrix *A, GenericVector *b, const GenericVector *x, std::size_t dim) const "
:param GenericMatrix * A: 
:param GenericVector * b: 
:param const GenericVector * x: 
:param std\\:\\:size_t dim: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::compute_bc(Map &boundary_values, LocalData &data, std::string method) const "
:param Map & boundary_values: 
:param LocalData & data: 
:param std\\:\\:string method: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::compute_bc_geometric(Map &boundary_values, LocalData &data) const "
:param Map & boundary_values: 
:param LocalData & data: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::compute_bc_pointwise(Map &boundary_values, LocalData &data) const "
:param Map & boundary_values: 
:param LocalData & data: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::compute_bc_topological(Map &boundary_values, LocalData &data) const "
:param Map & boundary_values: 
:param LocalData & data: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::function_space() const "
Return function space V

:rtype: std::shared_ptr< const FunctionSpace >
:returns: :cpp:any:`FunctionSpace`  The function space to which boundary conditions are applied.
";

%feature("docstring") dolfin::DirichletBC::gather(Map &boundary_values) const "
Get boundary values from neighbour processes. If a method other than \"pointwise\" is used, this is necessary to ensure all boundary dofs are marked on all processes.

:param Map & boundary_values:  (Map&) Map from dof to boundary value. [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::get_boundary_values(Map &boundary_values) const "
Get Dirichlet dofs and values. If a method other than 'pointwise' is used in parallel, the map may not be complete for local vertices since a vertex can have a bc applied, but the partition might not have a facet on the boundary. To ensure all local boundary dofs are marked, it is necessary to call :cpp:any:`gather()`  on the returned boundary values.

:param Map & boundary_values:  (Map&) Map from dof to boundary value. [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::homogenize() "
:cpp:any:`Set`  value to 0.0. 

:rtype: void
";

%feature("docstring") dolfin::DirichletBC::init_facets(const MPI_Comm mpi_comm) const "
:param const MPI_Comm mpi_comm: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::init_from_mesh(std::size_t sub_domain) const "
:param std\\:\\:size_t sub_domain: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::init_from_mesh_function(const MeshFunction< std::size_t > &sub_domains, std::size_t sub_domain) const "
:param const MeshFunction< std\\:\\:size_t > & sub_domains: 
:param std\\:\\:size_t sub_domain: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::init_from_sub_domain(std::shared_ptr< const SubDomain > sub_domain) const "
:param std\\:\\:shared_ptr< const SubDomain > sub_domain: 
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::markers() const "
Return boundary markers

:rtype: const std::vector< std::size_t > &
:returns: std::vector<std::size_t>& Boundary markers (facets stored as pairs of cells and local facet numbers).
";

%feature("docstring") dolfin::DirichletBC::method() const "
Return method used for computing Dirichlet dofs

:rtype: std::string
:returns: std::string Method used for computing Dirichlet dofs (\"topological\", \"geometric\" or \"pointwise\").
";

%feature("docstring") dolfin::DirichletBC::methods "
:rtype: const std::set< std::string >
";

%feature("docstring") dolfin::DirichletBC::on_facet(const double *coordinates, const Facet &facet) const "
:param const double * coordinates: 
:param const Facet & facet: 
:rtype: bool
";

%feature("docstring") dolfin::DirichletBC::operator=(const DirichletBC &bc) "
Assignment operator. Either cached DOF data are assigned.

:param const DirichletBC & bc:  (:cpp:any:`DirichletBC` ) Another :cpp:any:`DirichletBC`  object. [direction=in]
:rtype: const DirichletBC &
";

%feature("docstring") dolfin::DirichletBC::set_value(std::shared_ptr< const GenericFunction > g) "
:cpp:any:`Set`  value g for boundary condition, domain remains unchanged

:param std\\:\\:shared_ptr< const GenericFunction > g:  (GenericFucntion) The value. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::user_sub_domain() const "
Return shared pointer to subdomain

:rtype: std::shared_ptr< const SubDomain >
:returns: :cpp:any:`SubDomain`  Shared pointer to subdomain.
";

%feature("docstring") dolfin::DirichletBC::value() const "
Return boundary value g

:rtype: std::shared_ptr< const GenericFunction >
:returns: :cpp:any:`GenericFunction`  The boundary values.
";

%feature("docstring") dolfin::DirichletBC::zero(GenericMatrix &A) const "
Make rows of matrix associated with boundary condition zero, useful for non-diagonal matrices in a block matrix.

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` &) The matrix [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::zero_columns(GenericMatrix &A, GenericVector &b, double diag_val=0) const "
Make columns of matrix associated with boundary condition zero, and update a (right-hand side) vector to reflect the changes. Useful for non-diagonals.

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` &) The matrix [direction=inout]
:param GenericVector & b:  (:cpp:any:`GenericVector` &) The vector [direction=inout]
:param double diag_val:  (double) This parameter would normally be -1, 0 or 1. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::DirichletBC::~DirichletBC() "
Destructor.
";

%feature("docstring") dolfin::DirichletBC::LocalData "

";

%feature("docstring") dolfin::DirichletBC::LocalData::LocalData(const FunctionSpace &V) "
:param const FunctionSpace & V:
";

%feature("docstring") dolfin::DirichletBC::LocalData::coordinates "
:rtype: boost::multi_array< double, 2 >
";

%feature("docstring") dolfin::DirichletBC::LocalData::facet_dofs "
:rtype: std::vector< std::size_t >
";

%feature("docstring") dolfin::DirichletBC::LocalData::w "
:rtype: std::vector< double >
";

%feature("docstring") dolfin::DiscreteOperators "
Discrete gradient operators providing derivatives of functions. 
This class computes discrete gradient operators (matrices) that map derivatives of finite element functions into other finite element spaces. An example of where discrete gradient operators are required is the creation of algebraic multigrid solvers for H(curl) and H(div) problems. NOTE: This class is highly experimental and likely to change. It will eventually be expanded to provide the discrete curl and divergence.
";

%feature("docstring") dolfin::DiscreteOperators::build_gradient(const FunctionSpace &V0, const FunctionSpace &V1) "
Build the discrete gradient operator A that takes a  :math:`w \\in H^1`  (P1, nodal :cpp:any:`Lagrange` ) to  :math:`v \\in H(curl)`  (lowest order Nedelec), i.e. v = Aw. V0 is the H(curl) space, and V1 is the P1 :cpp:any:`Lagrange`  space.

:param const FunctionSpace & V0:  (:cpp:any:`FunctionSpace` &) H(curl) space [direction=in]
:param const FunctionSpace & V1:  (:cpp:any:`FunctionSpace` &) P1 :cpp:any:`Lagrange`  space [direction=in]
:rtype: std::shared_ptr< GenericMatrix >
:returns: :cpp:any:`GenericMatrix`
";

%feature("docstring") dolfin::DofMap "
Degree-of-freedom map. 
This class handles the mapping of degrees of freedom. It builds a dof map based on a ufc::dofmap on a specific mesh. It will reorder the dofs when running in parallel. Sub-dofmaps, both views and copies, are supported. 

Friends: :cpp:any:`DofMapBuilder`, :cpp:any:`MultiMeshDofMap`.
";

%feature("docstring") dolfin::DofMap::DofMap(const DofMap &dofmap) "
:param const DofMap & dofmap:
";

%feature("docstring") dolfin::DofMap::DofMap(const DofMap &parent_dofmap, const std::vector< std::size_t > &component, const Mesh &mesh) "
:param const DofMap & parent_dofmap: 
:param const std\\:\\:vector< std\\:\\:size_t > & component: 
:param const Mesh & mesh:
";

%feature("docstring") dolfin::DofMap::DofMap(std::shared_ptr< const ufc::dofmap > ufc_dofmap, const Mesh &mesh) "
Create dof map on mesh (mesh is not stored)

:param std\\:\\:shared_ptr< const ufc\\:\\:dofmap > ufc_dofmap:  (ufc::dofmap) The ufc::dofmap. [direction=in]
:param const Mesh & mesh:  (:cpp:any:`Mesh` &) The mesh. [direction=in]
";

%feature("docstring") dolfin::DofMap::DofMap(std::shared_ptr< const ufc::dofmap > ufc_dofmap, const Mesh &mesh, std::shared_ptr< const SubDomain > constrained_domain) "
Create a periodic dof map on mesh (mesh is not stored)

:param std\\:\\:shared_ptr< const ufc\\:\\:dofmap > ufc_dofmap:  (ufc::dofmap) The ufc::dofmap. [direction=in]
:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The mesh. [direction=in]
:param std\\:\\:shared_ptr< const SubDomain > constrained_domain:  (:cpp:any:`SubDomain` ) The subdomain marking the constrained (tied) boundaries. [direction=in]
";

%feature("docstring") dolfin::DofMap::DofMap(std::unordered_map< std::size_t, std::size_t > &collapsed_map, const DofMap &dofmap_view, const Mesh &mesh) "
:param std\\:\\:unordered_map< std\\:\\:size_t, std\\:\\:size_t > & collapsed_map: 
:param const DofMap & dofmap_view: 
:param const Mesh & mesh:
";

%feature("docstring") dolfin::DofMap::block_size() const "
Return the block size for dof maps with components, typically used for vector valued functions. 

:rtype: int
";

%feature("docstring") dolfin::DofMap::cell_dofs(std::size_t cell_index) const "
Local-to-global mapping of dofs on a cell

:param std\\:\\:size_t cell_index:  (std::size_t) The cell index.
:rtype: ArrayView< const dolfin::la_index >
:returns: ArrayView<const dolfin::la_index> Local-to-global mapping of dofs.
";

%feature("docstring") dolfin::DofMap::check_dimensional_consistency(const ufc::dofmap &dofmap, const Mesh &mesh) "
:param const ufc\\:\\:dofmap & dofmap: 
:param const Mesh & mesh: 
:rtype: void
";

%feature("docstring") dolfin::DofMap::check_provided_entities(const ufc::dofmap &dofmap, const Mesh &mesh) "
:param const ufc\\:\\:dofmap & dofmap: 
:param const Mesh & mesh: 
:rtype: void
";

%feature("docstring") dolfin::DofMap::clear_sub_map_data() "
Clear any data required to build sub-dofmaps (this is to reduce memory use) 

:rtype: void
";

%feature("docstring") dolfin::DofMap::collapse(std::unordered_map< std::size_t, std::size_t > &collapsed_map, const Mesh &mesh) const "
Create a \"collapsed\" dofmap (collapses a sub-dofmap)

:param std\\:\\:unordered_map< std\\:\\:size_t, std\\:\\:size_t > & collapsed_map:  (std::unordered_map<std::size_t, std::size_t>) The \"collapsed\" map.
:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The mesh.
:rtype: std::shared_ptr< GenericDofMap >
:returns: :cpp:any:`DofMap`  The collapsed dofmap.
";

%feature("docstring") dolfin::DofMap::copy() const "
Create a copy of the dof map

:rtype: std::shared_ptr< GenericDofMap >
:returns: :cpp:any:`DofMap`  The Dofmap copy.
";

%feature("docstring") dolfin::DofMap::create(const Mesh &new_mesh) const "
Create a copy of the dof map on a new mesh

:param const Mesh & new_mesh:  (:cpp:any:`Mesh` ) The new mesh to create the dof map on.
:rtype: std::shared_ptr< GenericDofMap >
:returns: :cpp:any:`DofMap`  The new Dofmap copy.
";

%feature("docstring") dolfin::DofMap::dofs() const "
Return list of global dof indices on this process. 

:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::DofMap::dofs(const Mesh &mesh, std::size_t dim) const "
Return list of dof indices on this process that belong to mesh entities of dimension dim 

:param const Mesh & mesh: 
:param std\\:\\:size_t dim: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::DofMap::entity_closure_dofs(const Mesh &mesh, std::size_t entity_dim) const "
Return the dof indices associated with the closure of all entities of given dimension

:param const Mesh & mesh:  (:cpp:any:`Mesh` ) :cpp:any:`Mesh`
:param std\\:\\:size_t entity_dim:  (std::size_t) Entity dimension.
:rtype: std::vector< dolfin::la_index >
:returns: std::vector<dolfin::la_index> Dof indices associated with selected entities and their closure.
";

%feature("docstring") dolfin::DofMap::entity_closure_dofs(const Mesh &mesh, std::size_t entity_dim, const std::vector< std::size_t > &entity_indices) const "
Return the dof indices associated with the closure of entities of given dimension and entity indices
Arguments entity_dim (std::size_t) Entity dimension. entity_indices (std::vector<dolfin::la_index>&) Entity indices to get dofs for. Returns std::vector<dolfin::la_index> Dof indices associated with selected entities and their closure. 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:param const std\\:\\:vector< std\\:\\:size_t > & entity_indices: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::DofMap::entity_dofs(const Mesh &mesh, std::size_t entity_dim) const "
Return the dof indices associated with all entities of given dimension
Arguments entity_dim (std::size_t) Entity dimension. Returns std::vector<dolfin::la_index> Dof indices associated with selected entities. 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::DofMap::entity_dofs(const Mesh &mesh, std::size_t entity_dim, const std::vector< std::size_t > &entity_indices) const "
Return the dof indices associated with entities of given dimension and entity indices
Arguments entity_dim (std::size_t) Entity dimension. entity_indices (std::vector<dolfin::la_index>&) Entity indices to get dofs for. Returns std::vector<dolfin::la_index> Dof indices associated with selected entities. 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:param const std\\:\\:vector< std\\:\\:size_t > & entity_indices: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::DofMap::extract_sub_dofmap(const std::vector< std::size_t > &component, const Mesh &mesh) const "
Extract subdofmap component

:param const std\\:\\:vector< std\\:\\:size_t > & component:  (std::vector<std::size_t>) The component.
:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The mesh.
:rtype: std::shared_ptr< GenericDofMap >
:returns: :cpp:any:`DofMap`  The subdofmap component.
";

%feature("docstring") dolfin::DofMap::global_dimension() const "
Return the dimension of the global finite element function space
Returns std::size_t The dimension of the global finite element function space. 

:rtype: std::size_t
";

%feature("docstring") dolfin::DofMap::index_map() const "
Return the map (const access) 

:rtype: std::shared_ptr< const IndexMap >
";

%feature("docstring") dolfin::DofMap::is_view() const "
True iff dof map is a view into another map
Returns bool True if the dof map is a sub-dof map (a view into another map). 

:rtype: bool
";

%feature("docstring") dolfin::DofMap::local_to_global_index(int local_index) const "
Return global dof index for a given local (process) dof index

:param int local_index:  (int) The local local index.
:rtype: std::size_t
:returns: std::size_t The global dof index.
";

%feature("docstring") dolfin::DofMap::local_to_global_unowned() const "
Return indices of dofs which are owned by other processes. 

:rtype: const std::vector< std::size_t > &
";

%feature("docstring") dolfin::DofMap::max_element_dofs() const "
Return the maximum dimension of the local finite element function space

:rtype: std::size_t
:returns: std::size_t Maximum dimension of the local finite element function space.
";

%feature("docstring") dolfin::DofMap::neighbours() const "
Return set of processes that share dofs with this process

:rtype: const std::set< int > &
:returns: std::set<int> The set of processes
";

%feature("docstring") dolfin::DofMap::num_element_dofs(std::size_t cell_index) const "
Return the dimension of the local finite element function space on a cell

:param std\\:\\:size_t cell_index:  (std::size_t) Index of cell
:rtype: std::size_t
:returns: std::size_t Dimension of the local finite element function space.
";

%feature("docstring") dolfin::DofMap::num_entity_closure_dofs(std::size_t entity_dim) const "
Return the number of dofs for the closure of an entity of given dimension
Arguments entity_dim (std::size_t) Entity dimension
Returns std::size_t Number of dofs associated with closure of an entity of given dimension 

:param std\\:\\:size_t entity_dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::DofMap::num_entity_dofs(std::size_t entity_dim) const "
Return the number of dofs for a given entity dimension

:param std\\:\\:size_t entity_dim:  (std::size_t) Entity dimension
:rtype: std::size_t
:returns: std::size_t Number of dofs associated with given entity dimension
";

%feature("docstring") dolfin::DofMap::num_facet_dofs() const "
Return number of facet dofs

:rtype: std::size_t
:returns: std::size_t The number of facet dofs.
";

%feature("docstring") dolfin::DofMap::off_process_owner() const "
Return map from nonlocal dofs that appear in local dof map to owning process

:rtype: const std::vector< int > &
:returns: std::vector<unsigned int> The map from non-local dofs.
";

%feature("docstring") dolfin::DofMap::ownership_range() const "
Return the ownership range (dofs in this range are owned by this process)

:rtype: std::pair< std::size_t, std::size_t >
:returns: std::pair<std::size_t, std::size_t> The ownership range.
";

%feature("docstring") dolfin::DofMap::set(GenericVector &x, double value) const "
:cpp:any:`Set`  dof entries in vector to a specified value. Parallel layout of vector must be consistent with dof map range. This function is typically used to construct the null space of a matrix operator.

:param GenericVector & x:  (:cpp:any:`GenericVector` ) The vector to set.
:param double value:  (double) The value to set.
:rtype: void
";

%feature("docstring") dolfin::DofMap::shared_nodes() const "
Return map from all shared nodes to the sharing processes (not including the current process) that share it.

:rtype: const std::unordered_map< int, std::vector< int > > &
:returns: std::unordered_map<std::size_t, std::vector<unsigned int>> The map from dofs to list of processes
";

%feature("docstring") dolfin::DofMap::str(bool verbose) const "
Return informal string representation (pretty-print)

:param bool verbose:  (bool) Flag to turn on additional output.
:rtype: std::string
:returns: std::string An informal representation of the function space.
";

%feature("docstring") dolfin::DofMap::tabulate_entity_closure_dofs(std::vector< std::size_t > &element_dofs, std::size_t entity_dim, std::size_t cell_entity_index) const "
Tabulate local-local mapping of dofs on closure of entity (dim, local_entity)

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs:  (std::size_t) Degrees of freedom on a single element.
:param std\\:\\:size_t entity_dim:  (std::size_t) The entity dimension.
:param std\\:\\:size_t cell_entity_index:  (std::size_t) The local entity index on the cell.
:rtype: void
";

%feature("docstring") dolfin::DofMap::tabulate_entity_dofs(std::vector< std::size_t > &element_dofs, std::size_t entity_dim, std::size_t cell_entity_index) const "
Tabulate local-local mapping of dofs on entity (dim, local_entity)

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs:  (std::size_t) Degrees of freedom on a single element.
:param std\\:\\:size_t entity_dim:  (std::size_t) The entity dimension.
:param std\\:\\:size_t cell_entity_index:  (std::size_t) The local entity index on the cell.
:rtype: void
";

%feature("docstring") dolfin::DofMap::tabulate_facet_dofs(std::vector< std::size_t > &element_dofs, std::size_t cell_facet_index) const "
Tabulate local-local facet dofs

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs:  (std::size_t) Degrees of freedom on a single element.
:param std\\:\\:size_t cell_facet_index:  (std::size_t) The local facet index on the cell.
:rtype: void
";

%feature("docstring") dolfin::DofMap::tabulate_global_dofs(std::vector< std::size_t > &element_dofs) const "
Tabulate globally supported dofs

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs:  (std::size_t) Degrees of freedom.
:rtype: void
";

%feature("docstring") dolfin::DofMap::tabulate_local_to_global_dofs(std::vector< std::size_t > &local_to_global_map) const "
Compute the map from local (this process) dof indices to global dof indices.

:param std\\:\\:vector< std\\:\\:size_t > & local_to_global_map:  (std::vector<std::size_t>) The local-to-global map to fill.
:rtype: void
";

%feature("docstring") dolfin::DofMap::~DofMap() "
Destructor.
";

%feature("docstring") dolfin::DofMapBuilder "
Builds a :cpp:any:`DofMap`  on a :cpp:any:`Mesh` .
";

%feature("docstring") dolfin::DofMapBuilder::build(DofMap &dofmap, const Mesh &dolfin_mesh, std::shared_ptr< const SubDomain > constrained_domain) "
Build dofmap. The constrained domain may be a null pointer, in which case it is ignored.

:param DofMap & dofmap:   [direction=out]
:param const Mesh & dolfin_mesh:   [direction=in]
:param std\\:\\:shared_ptr< const SubDomain > constrained_domain:   [direction=in]
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::build_constrained_vertex_indices(const Mesh &mesh, const std::map< unsigned int, std::pair< unsigned int, unsigned int >> &slave_to_master_vertices, std::vector< std::int64_t > &modified_vertex_indices_global) "
:param const Mesh & mesh: 
:param const std\\:\\:map< unsigned int, std\\:\\:pair< unsigned int, unsigned int >> & slave_to_master_vertices: 
:param std\\:\\:vector< std\\:\\:int64_t > & modified_vertex_indices_global: 
:rtype: std::size_t
";

%feature("docstring") dolfin::DofMapBuilder::build_dofmap(std::vector< std::vector< la_index >> &dofmap, const std::vector< std::vector< la_index >> &node_dofmap, const std::vector< int > &old_to_new_node_local, const std::size_t block_size) "
:param std\\:\\:vector< std\\:\\:vector< la_index >> & dofmap: 
:param const std\\:\\:vector< std\\:\\:vector< la_index >> & node_dofmap: 
:param const std\\:\\:vector< int > & old_to_new_node_local: 
:param const std\\:\\:size_t block_size: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::build_local_ufc_dofmap(std::vector< std::vector< dolfin::la_index >> &dofmap, const ufc::dofmap &ufc_dofmap, const Mesh &mesh) "
:param std\\:\\:vector< std\\:\\:vector< dolfin\\:\\:la_index >> & dofmap: 
:param const ufc\\:\\:dofmap & ufc_dofmap: 
:param const Mesh & mesh: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::build_sub_map_view(DofMap &sub_dofmap, const DofMap &parent_dofmap, const std::vector< std::size_t > &component, const Mesh &mesh) "
Build sub-dofmap. This is a view into the parent dofmap.

:param DofMap & sub_dofmap:   [direction=out]
:param const DofMap & parent_dofmap:   [direction=in]
:param const std\\:\\:vector< std\\:\\:size_t > & component:   [direction=in]
:param const Mesh & mesh:   [direction=in]
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::build_ufc_node_graph(std::vector< std::vector< la_index >> &node_dofmap, std::vector< std::size_t > &node_local_to_global, std::vector< std::size_t > &num_mesh_entities_global, std::shared_ptr< const ufc::dofmap > ufc_dofmap, const Mesh &mesh, std::shared_ptr< const SubDomain > constrained_domain, const std::size_t block_size) "
:param std\\:\\:vector< std\\:\\:vector< la_index >> & node_dofmap: 
:param std\\:\\:vector< std\\:\\:size_t > & node_local_to_global: 
:param std\\:\\:vector< std\\:\\:size_t > & num_mesh_entities_global: 
:param std\\:\\:shared_ptr< const ufc\\:\\:dofmap > ufc_dofmap: 
:param const Mesh & mesh: 
:param std\\:\\:shared_ptr< const SubDomain > constrained_domain: 
:param const std\\:\\:size_t block_size: 
:rtype: std::shared_ptr< const ufc::dofmap >
";

%feature("docstring") dolfin::DofMapBuilder::build_ufc_node_graph_constrained(std::vector< std::vector< la_index >> &node_dofmap, std::vector< std::size_t > &node_local_to_global, std::vector< int > &node_ufc_local_to_local, std::vector< std::size_t > &num_mesh_entities_global, std::shared_ptr< const ufc::dofmap > ufc_dofmap, const Mesh &mesh, std::shared_ptr< const SubDomain > constrained_domain, const std::size_t block_size) "
:param std\\:\\:vector< std\\:\\:vector< la_index >> & node_dofmap: 
:param std\\:\\:vector< std\\:\\:size_t > & node_local_to_global: 
:param std\\:\\:vector< int > & node_ufc_local_to_local: 
:param std\\:\\:vector< std\\:\\:size_t > & num_mesh_entities_global: 
:param std\\:\\:shared_ptr< const ufc\\:\\:dofmap > ufc_dofmap: 
:param const Mesh & mesh: 
:param std\\:\\:shared_ptr< const SubDomain > constrained_domain: 
:param const std\\:\\:size_t block_size: 
:rtype: std::shared_ptr< const ufc::dofmap >
";

%feature("docstring") dolfin::DofMapBuilder::compute_blocksize(const ufc::dofmap &ufc_dofmap) "
:param const ufc\\:\\:dofmap & ufc_dofmap: 
:rtype: std::size_t
";

%feature("docstring") dolfin::DofMapBuilder::compute_constrained_mesh_indices(std::vector< std::vector< std::int64_t >> &global_entity_indices, std::vector< std::size_t > &num_mesh_entities_global, const std::vector< bool > &needs_mesh_entities, const Mesh &mesh, const SubDomain &constrained_domain) "
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:int64_t >> & global_entity_indices: 
:param std\\:\\:vector< std\\:\\:size_t > & num_mesh_entities_global: 
:param const std\\:\\:vector< bool > & needs_mesh_entities: 
:param const Mesh & mesh: 
:param const SubDomain & constrained_domain: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::compute_global_dofs(std::set< std::size_t > &global_dofs, std::size_t &offset_local, std::shared_ptr< const ufc::dofmap > ufc_dofmap, const std::vector< std::size_t > &num_mesh_entities_local) "
:param std\\:\\:set< std\\:\\:size_t > & global_dofs: 
:param std\\:\\:size_t & offset_local: 
:param std\\:\\:shared_ptr< const ufc\\:\\:dofmap > ufc_dofmap: 
:param const std\\:\\:vector< std\\:\\:size_t > & num_mesh_entities_local: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::compute_global_dofs(std::shared_ptr< const ufc::dofmap > ufc_dofmap, const std::vector< std::size_t > &num_mesh_entities_local) "
:param std\\:\\:shared_ptr< const ufc\\:\\:dofmap > ufc_dofmap: 
:param const std\\:\\:vector< std\\:\\:size_t > & num_mesh_entities_local: 
:rtype: std::set< std::size_t >
";

%feature("docstring") dolfin::DofMapBuilder::compute_node_ownership(std::vector< short int > &node_ownership, std::unordered_map< int, std::vector< int >> &shared_node_to_processes, std::set< int > &neighbours, const std::vector< std::vector< la_index >> &node_dofmap, const std::vector< int > &boundary_nodes, const std::set< std::size_t > &global_nodes, const std::vector< std::size_t > &node_local_to_global, const Mesh &mesh, const std::size_t global_dim) "
:param std\\:\\:vector< short int > & node_ownership: 
:param std\\:\\:unordered_map< int, std\\:\\:vector< int >> & shared_node_to_processes: 
:param std\\:\\:set< int > & neighbours: 
:param const std\\:\\:vector< std\\:\\:vector< la_index >> & node_dofmap: 
:param const std\\:\\:vector< int > & boundary_nodes: 
:param const std\\:\\:set< std\\:\\:size_t > & global_nodes: 
:param const std\\:\\:vector< std\\:\\:size_t > & node_local_to_global: 
:param const Mesh & mesh: 
:param const std\\:\\:size_t global_dim: 
:rtype: int
";

%feature("docstring") dolfin::DofMapBuilder::compute_node_reordering(IndexMap &index_map, std::vector< int > &old_to_new_local, const std::unordered_map< int, std::vector< int >> &node_to_sharing_processes, const std::vector< std::size_t > &old_local_to_global, const std::vector< std::vector< la_index >> &node_dofmap, const std::vector< short int > &node_ownership, const std::set< std::size_t > &global_nodes, const MPI_Comm mpi_comm) "
:param IndexMap & index_map: 
:param std\\:\\:vector< int > & old_to_new_local: 
:param const std\\:\\:unordered_map< int, std\\:\\:vector< int >> & node_to_sharing_processes: 
:param const std\\:\\:vector< std\\:\\:size_t > & old_local_to_global: 
:param const std\\:\\:vector< std\\:\\:vector< la_index >> & node_dofmap: 
:param const std\\:\\:vector< short int > & node_ownership: 
:param const std\\:\\:set< std\\:\\:size_t > & global_nodes: 
:param const MPI_Comm mpi_comm: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::compute_num_mesh_entities_local(const Mesh &mesh, const std::vector< bool > &needs_mesh_entities) "
:param const Mesh & mesh: 
:param const std\\:\\:vector< bool > & needs_mesh_entities: 
:rtype: std::vector< std::size_t >
";

%feature("docstring") dolfin::DofMapBuilder::compute_shared_nodes(std::vector< int > &boundary_nodes, const std::vector< std::vector< la_index >> &node_dofmap, const std::size_t num_nodes_local, const ufc::dofmap &ufc_dofmap, const Mesh &mesh) "
:param std\\:\\:vector< int > & boundary_nodes: 
:param const std\\:\\:vector< std\\:\\:vector< la_index >> & node_dofmap: 
:param const std\\:\\:size_t num_nodes_local: 
:param const ufc\\:\\:dofmap & ufc_dofmap: 
:param const Mesh & mesh: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::extract_ufc_sub_dofmap(const ufc::dofmap &ufc_dofmap, std::size_t &offset, const std::vector< std::size_t > &component, const std::vector< std::size_t > &num_global_mesh_entities) "
:param const ufc\\:\\:dofmap & ufc_dofmap: 
:param std\\:\\:size_t & offset: 
:param const std\\:\\:vector< std\\:\\:size_t > & component: 
:param const std\\:\\:vector< std\\:\\:size_t > & num_global_mesh_entities: 
:rtype: std::shared_ptr< ufc::dofmap >
";

%feature("docstring") dolfin::DofMapBuilder::get_cell_entities_global(const Cell &cell, std::vector< std::vector< std::size_t >> &entity_indices, const std::vector< bool > &needs_mesh_entities) "
:param const Cell & cell: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & entity_indices: 
:param const std\\:\\:vector< bool > & needs_mesh_entities: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::get_cell_entities_global_constrained(const Cell &cell, std::vector< std::vector< std::size_t >> &entity_indices, const std::vector< std::vector< std::int64_t >> &global_entity_indices, const std::vector< bool > &needs_mesh_entities) "
:param const Cell & cell: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & entity_indices: 
:param const std\\:\\:vector< std\\:\\:vector< std\\:\\:int64_t >> & global_entity_indices: 
:param const std\\:\\:vector< bool > & needs_mesh_entities: 
:rtype: void
";

%feature("docstring") dolfin::DofMapBuilder::get_cell_entities_local(const Cell &cell, std::vector< std::vector< std::size_t >> &entity_indices, const std::vector< bool > &needs_mesh_entities) "
:param const Cell & cell: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & entity_indices: 
:param const std\\:\\:vector< bool > & needs_mesh_entities: 
:rtype: void
";

%feature("docstring") dolfin::Equation "
This class represents a variational equation lhs == rhs. The equation can be either linear or nonlinear:

#. Linear (a == L), in which case a must be a bilinear form and L must be a linear form.
#. Nonlinear (F == 0), in which case F must be a linear form.
";

%feature("docstring") dolfin::Equation::Equation(std::shared_ptr< const Form > F, int rhs) "
Create equation F == 0 

:param std\\:\\:shared_ptr< const Form > F:  (:cpp:any:`Form` ) [direction=in]
:param int rhs:  (int) [direction=in]
";

%feature("docstring") dolfin::Equation::Equation(std::shared_ptr< const Form > a, std::shared_ptr< const Form > L) "
Create equation a == L 

:param std\\:\\:shared_ptr< const Form > a:  (:cpp:any:`Form` ) :cpp:any:`Form`  representing the LHS [direction=in]
:param std\\:\\:shared_ptr< const Form > L:  (:cpp:any:`Form` ) :cpp:any:`Form`  representing the RHS [direction=in]
";

%feature("docstring") dolfin::Equation::is_linear() const "
Check whether equation is linear 

:rtype: bool
:returns: bool
";

%feature("docstring") dolfin::Equation::lhs() const "
Return form for left-hand side 

:rtype: std::shared_ptr< const Form >
:returns: :cpp:any:`Form`  LHS form
";

%feature("docstring") dolfin::Equation::rhs() const "
Return form for right-hand side 

:rtype: std::shared_ptr< const Form >
:returns: :cpp:any:`Form`  RHS form
";

%feature("docstring") dolfin::Equation::rhs_int() const "
Return value for right-hand side 

:rtype: int
:returns: int
";

%feature("docstring") dolfin::Equation::~Equation() "
Destructor.
";

%feature("docstring") dolfin::FiniteElement "
This is a wrapper for a :cpp:any:`UFC`  finite element (ufc::finite_element).
";

%feature("docstring") dolfin::FiniteElement::FiniteElement(std::shared_ptr< const ufc::finite_element > element) "
Create finite element from :cpp:any:`UFC`  finite element (data may be shared) 

:param std\\:\\:shared_ptr< const ufc\\:\\:finite_element > element:  (ufc::finite_element) :cpp:any:`UFC`  finite element
";

%feature("docstring") dolfin::FiniteElement::cell_shape() const "
Return the cell shape 

:rtype: ufc::shape
:returns: ufc::shape
";

%feature("docstring") dolfin::FiniteElement::create() const "
Create a new class instance. 

:rtype: std::shared_ptr< const FiniteElement >
";

%feature("docstring") dolfin::FiniteElement::create_sub_element(std::size_t i) const "
Create a new finite element for sub element i (for a mixed element) 

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< const FiniteElement >
";

%feature("docstring") dolfin::FiniteElement::evaluate_basis(std::size_t i, double *values, const double *x, const double *coordinate_dofs, int cell_orientation) const "
Evaluate basis function i at given point in cell. 

:param std\\:\\:size_t i: 
:param double * values: 
:param const double * x: 
:param const double * coordinate_dofs: 
:param int cell_orientation: 
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::evaluate_basis_all(double *values, const double *x, const double *coordinate_dofs, int cell_orientation) const "
Evaluate all basis functions at given point in cell. 

:param double * values: 
:param const double * x: 
:param const double * coordinate_dofs: 
:param int cell_orientation: 
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::evaluate_basis_derivatives(unsigned int i, unsigned int n, double *values, const double *x, const double *coordinate_dofs, int cell_orientation) const "
Evaluate order n derivatives of basis function i at given point in cell. 

:param unsigned int i: 
:param unsigned int n: 
:param double * values: 
:param const double * x: 
:param const double * coordinate_dofs: 
:param int cell_orientation: 
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::evaluate_basis_derivatives_all(unsigned int n, double *values, const double *x, const double *coordinate_dofs, int cell_orientation) const "
Evaluate order n derivatives of all basis functions at given point in cell 

:param unsigned int n: 
:param double * values: 
:param const double * x: 
:param const double * coordinate_dofs: 
:param int cell_orientation: 
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::evaluate_dof(std::size_t i, const ufc::function &function, const double *coordinate_dofs, int cell_orientation, const ufc::cell &c) const "
Evaluate linear functional for dof i on the function f. 

:param std\\:\\:size_t i: 
:param const ufc\\:\\:function & function: 
:param const double * coordinate_dofs: 
:param int cell_orientation: 
:param const ufc\\:\\:cell & c: 
:rtype: double
";

%feature("docstring") dolfin::FiniteElement::evaluate_dofs(double *values, const ufc::function &f, const double *coordinate_dofs, int cell_orientation, const ufc::cell &c) const "
Evaluate linear functionals for all dofs on the function f. 

:param double * values: 
:param const ufc\\:\\:function & f: 
:param const double * coordinate_dofs: 
:param int cell_orientation: 
:param const ufc\\:\\:cell & c: 
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::extract_sub_element(const FiniteElement &finite_element, const std::vector< std::size_t > &component) "
:param const FiniteElement & finite_element: 
:param const std\\:\\:vector< std\\:\\:size_t > & component: 
:rtype: std::shared_ptr< const FiniteElement >
";

%feature("docstring") dolfin::FiniteElement::extract_sub_element(const std::vector< std::size_t > &component) const "
Extract sub finite element for component. 

:param const std\\:\\:vector< std\\:\\:size_t > & component: 
:rtype: std::shared_ptr< const FiniteElement >
";

%feature("docstring") dolfin::FiniteElement::geometric_dimension() const "
Return the geometric dimension of the cell shape 

:rtype: unsigned int
:returns: unsigned int
";

%feature("docstring") dolfin::FiniteElement::hash() const "
Return simple hash of the signature string. 

:rtype: std::size_t
";

%feature("docstring") dolfin::FiniteElement::interpolate_vertex_values(double *vertex_values, double *coefficients, const double *coordinate_dofs, int cell_orientation, const ufc::cell &cell) const "
Interpolate vertex values from dof values 

:param double * vertex_values:  (double*)
:param double * coefficients:  (double*)
:param const double * coordinate_dofs:  (const double*)
:param int cell_orientation:  (int)
:param const ufc\\:\\:cell & cell:  (ufc::cell&)
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::num_sub_elements() const "
Return the number of sub elements (for a mixed element) 

:rtype: std::size_t
:returns: std::size_t number of sub-elements
";

%feature("docstring") dolfin::FiniteElement::signature() const "
Return a string identifying the finite element 

:rtype: std::string
:returns: std::string
";

%feature("docstring") dolfin::FiniteElement::space_dimension() const "
Return the dimension of the finite element function space 

:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::FiniteElement::tabulate_dof_coordinates(boost::multi_array< double, 2 > &coordinates, const std::vector< double > &coordinate_dofs, const Cell &cell) const "
Tabulate the coordinates of all dofs on an element

:param boost\\:\\:multi_array< double, 2 > & coordinates:  (boost::multi_array<double, 2>) The coordinates of all dofs on a cell. [direction=inout]
:param const std\\:\\:vector< double > & coordinate_dofs:  (std::vector<double>) The cell coordinates [direction=in]
:param const Cell & cell:  (:cpp:any:`Cell` ) The cell. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::FiniteElement::topological_dimension() const "
Return the topological dimension of the cell shape 

:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::FiniteElement::ufc_element() const "
Return underlying :cpp:any:`UFC`  element. Intended for libray usage only and may change. 

:rtype: std::shared_ptr< const ufc::finite_element >
";

%feature("docstring") dolfin::FiniteElement::value_dimension(std::size_t i) const "
Return the dimension of the value space for axis i. 

:param std\\:\\:size_t i: 
:rtype: std::size_t
";

%feature("docstring") dolfin::FiniteElement::value_rank() const "
Return the rank of the value space. 

:rtype: std::size_t
";

%feature("docstring") dolfin::FiniteElement::~FiniteElement() "
Destructor.
";

%feature("docstring") dolfin::Form "
Base class for :cpp:any:`UFC`  code generated by FFC for DOLFIN with option -l. 

::
   
   embed:rst:leading-slashes
   /// A note on the order of trial and test spaces: FEniCS numbers
   /// argument spaces starting with the leading dimension of the
   /// corresponding tensor (matrix). In other words, the test space is
   /// numbered 0 and the trial space is numbered 1. However, in order
   /// to have a notation that agrees with most existing finite element
   /// literature, in particular
   ///
   ///     a = a(u, v)
   ///
   /// the spaces are numbered from right to
   ///
   ///     a: V_1 x V_0 -> R
   ///
   /// .. note::
   ///
   ///     Figure out how to write this in math mode without it getting
   ///     messed up in the Python version.
   ///
   /// This is reflected in the ordering of the spaces that should be
   /// supplied to generated subclasses. In particular, when a bilinear
   /// form is initialized, it should be initialized as
   ///
   /// .. code-block:: c++
   ///
   ///     a(V_1, V_0) = ...
   ///
   /// where ``V_1`` is the trial space and ``V_0`` is the test space.
   /// However, when a form is initialized by a list of argument spaces
   /// (the variable ``function_spaces`` in the constructors below, the
   /// list of spaces should start with space number 0 (the test space)
   /// and then space number 1 (the trial space).
   ///
";

%feature("docstring") dolfin::Form::Form(std::shared_ptr< const ufc::form > ufc_form, std::vector< std::shared_ptr< const FunctionSpace >> function_spaces) "
Create form (shared data)

:param std\\:\\:shared_ptr< const ufc\\:\\:form > ufc_form:  (ufc::form) The :cpp:any:`UFC`  form. [direction=in]
:param std\\:\\:vector< std\\:\\:shared_ptr< const FunctionSpace >> function_spaces:  (std::vector<:cpp:any:`FunctionSpace` >) :cpp:any:`Vector`  of function spaces. [direction=in]
";

%feature("docstring") dolfin::Form::Form(std::size_t rank, std::size_t num_coefficients) "
Create form of given rank with given number of coefficients

:param std\\:\\:size_t rank:  (std::size_t) The rank. [direction=in]
:param std\\:\\:size_t num_coefficients:  (std::size_t) The number of coefficients. [direction=in]
";

%feature("docstring") dolfin::Form::cell_domains() const "
Return cell domains (zero pointer if no domains have been specified)

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
:returns: :cpp:any:`MeshFunction`  <std::size_t> The cell domains.
";

%feature("docstring") dolfin::Form::check() const "
Check function spaces and coefficients. 

:rtype: void
";

%feature("docstring") dolfin::Form::coefficient(std::size_t i) const "
Return coefficient with given number

:param std\\:\\:size_t i:  (std::size_t) Index [direction=in]
:rtype: std::shared_ptr< const GenericFunction >
:returns: :cpp:any:`GenericFunction`  The coefficient.
";

%feature("docstring") dolfin::Form::coefficient(std::string name) const "
Return coefficient with given name

:param std\\:\\:string name:  (std::string) The name. [direction=in]
:rtype: std::shared_ptr< const GenericFunction >
:returns: :cpp:any:`GenericFunction`  The coefficient.
";

%feature("docstring") dolfin::Form::coefficient_name(std::size_t i) const "
Return the name of the coefficient with this number

:param std\\:\\:size_t i:  (std::size_t) The number [direction=in]
:rtype: std::string
:returns: std::string The name of the coefficient with the given number.
";

%feature("docstring") dolfin::Form::coefficient_number(const std::string &name) const "
Return the number of the coefficient with this name

:param const std\\:\\:string & name:  (std::string) The name. [direction=in]
:rtype: std::size_t
:returns: std::size_t The number of the coefficient with the given name.
";

%feature("docstring") dolfin::Form::coefficients() const "
Return all coefficients

:rtype: std::vector< std::shared_ptr< const GenericFunction > >
:returns: std::vector<:cpp:any:`GenericFunction` > All coefficients.
";

%feature("docstring") dolfin::Form::coloring(std::size_t entity_dim) const "
Return coloring type for colored assembly of form over a mesh entity of a given dimension

:param std\\:\\:size_t entity_dim:  (std::size_t) Dimension. [direction=in]
:rtype: std::vector< std::size_t >
:returns: std::vector<std::size_t> Coloring type.
";

%feature("docstring") dolfin::Form::dP "
Domain markers for vertices. 

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
";

%feature("docstring") dolfin::Form::dS "
Domain markers for interior facets. 

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
";

%feature("docstring") dolfin::Form::ds "
Domain markers for exterior facets. 

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
";

%feature("docstring") dolfin::Form::dx "
Domain markers for cells. 

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
";

%feature("docstring") dolfin::Form::exterior_facet_domains() const "
Return exterior facet domains (zero pointer if no domains have been specified)

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
:returns: std::shared_ptr<:cpp:any:`MeshFunction`  <std::size_t>> The exterior facet domains.
";

%feature("docstring") dolfin::Form::function_space(std::size_t i) const "
Return function space for given argument

:param std\\:\\:size_t i:  (std::size_t) Index
:rtype: std::shared_ptr< const FunctionSpace >
:returns: :cpp:any:`FunctionSpace` :cpp:any:`Function`  space shared pointer.
";

%feature("docstring") dolfin::Form::function_spaces() const "
Return function spaces for arguments

:rtype: std::vector< std::shared_ptr< const FunctionSpace > >
:returns: std::vector<:cpp:any:`FunctionSpace` > :cpp:any:`Vector`  of function space shared pointers.
";

%feature("docstring") dolfin::Form::interior_facet_domains() const "
Return interior facet domains (zero pointer if no domains have been specified)

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
:returns: :cpp:any:`MeshFunction`  <std::size_t> The interior facet domains.
";

%feature("docstring") dolfin::Form::mesh() const "
Extract common mesh from form

:rtype: std::shared_ptr< const Mesh >
:returns: :cpp:any:`Mesh`  Shared pointer to the mesh.
";

%feature("docstring") dolfin::Form::num_coefficients() const "
Return number of coefficients

:rtype: std::size_t
:returns: std::size_t The number of coefficients.
";

%feature("docstring") dolfin::Form::operator==(const Form &rhs) const "
Comparison operator, returning equation lhs == rhs. 

:param const Form & rhs: 
:rtype: Equation
";

%feature("docstring") dolfin::Form::operator==(int rhs) const "
Comparison operator, returning equation lhs == 0. 

:param int rhs: 
:rtype: Equation
";

%feature("docstring") dolfin::Form::original_coefficient_position(std::size_t i) const "
Return original coefficient position for each coefficient (0 <= i < n)

:param std\\:\\:size_t i: 
:rtype: std::size_t
:returns: std::size_t The position of coefficient i in original ufl form coefficients.
";

%feature("docstring") dolfin::Form::rank() const "
Return rank of form (bilinear form = 2, linear form = 1, functional = 0, etc)

:rtype: std::size_t
:returns: std::size_t The rank of the form.
";

%feature("docstring") dolfin::Form::set_cell_domains(std::shared_ptr< const MeshFunction< std::size_t >> cell_domains) "
:cpp:any:`Set`  cell domains

:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> cell_domains:  (:cpp:any:`MeshFunction`  <std::size_t>) The cell domains. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_coefficient(std::size_t i, std::shared_ptr< const GenericFunction > coefficient) "
:cpp:any:`Set`  coefficient with given number (shared pointer version)

:param std\\:\\:size_t i:  (std::size_t) The given number. [direction=in]
:param std\\:\\:shared_ptr< const GenericFunction > coefficient:  (:cpp:any:`GenericFunction` ) The coefficient. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_coefficient(std::string name, std::shared_ptr< const GenericFunction > coefficient) "
:cpp:any:`Set`  coefficient with given name (shared pointer version)

:param std\\:\\:string name:  (std::string) The name. [direction=in]
:param std\\:\\:shared_ptr< const GenericFunction > coefficient:  (:cpp:any:`GenericFunction` ) The coefficient. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_coefficients(std::map< std::string, std::shared_ptr< const GenericFunction >> coefficients) "
:cpp:any:`Set`  all coefficients in given map. All coefficients in the given map, which may contain only a subset of the coefficients of the form, will be set.

:param std\\:\\:map< std\\:\\:string, std\\:\\:shared_ptr< const GenericFunction >> coefficients:  (std::map<std::string, :cpp:any:`GenericFunction` >) The map of coefficients. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_exterior_facet_domains(std::shared_ptr< const MeshFunction< std::size_t >> exterior_facet_domains) "
:cpp:any:`Set`  exterior facet domains

:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> exterior_facet_domains:  (:cpp:any:`MeshFunction`  <std::size_t>) The exterior facet domains. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_interior_facet_domains(std::shared_ptr< const MeshFunction< std::size_t >> interior_facet_domains) "
:cpp:any:`Set`  interior facet domains

:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> interior_facet_domains:  (:cpp:any:`MeshFunction`  <std::size_t>) The interior facet domains. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_mesh(std::shared_ptr< const Mesh > mesh) "
:cpp:any:`Set`  mesh, necessary for functionals when there are no function spaces

:param std\\:\\:shared_ptr< const Mesh > mesh:  (:cpp:any:`Mesh` ) The mesh. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_some_coefficients(std::map< std::string, std::shared_ptr< const GenericFunction >> coefficients) "
:cpp:any:`Set`  some coefficients in given map. Each coefficient in the given map will be set, if the name of the coefficient matches the name of a coefficient in the form.
This is useful when reusing the same coefficient map for several forms, or when some part of the form has been outcommented (for testing) in the UFL file, which means that the coefficient and attaching it to the form does not need to be outcommented in a C++ program using code from the generated UFL file.

:param std\\:\\:map< std\\:\\:string, std\\:\\:shared_ptr< const GenericFunction >> coefficients:  (std::map<std::string, :cpp:any:`GenericFunction` >) The map of coefficients. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::set_vertex_domains(std::shared_ptr< const MeshFunction< std::size_t >> vertex_domains) "
:cpp:any:`Set`  vertex domains

:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> vertex_domains:  (:cpp:any:`MeshFunction`  <std::size_t>) The vertex domains. [direction=in]
:rtype: void
";

%feature("docstring") dolfin::Form::ufc_form() const "
Return :cpp:any:`UFC`  form shared pointer

:rtype: std::shared_ptr< const ufc::form >
:returns: ufc::form The :cpp:any:`UFC`  form.
";

%feature("docstring") dolfin::Form::vertex_domains() const "
Return vertex domains (zero pointer if no domains have been specified)

:rtype: std::shared_ptr< const MeshFunction< std::size_t > >
:returns: :cpp:any:`MeshFunction`  <std::size_t> The vertex domains.
";

%feature("docstring") dolfin::Form::~Form() "
Destructor.
";

%feature("docstring") dolfin::GenericDofMap "
This class provides a generic interface for dof maps.
";

%feature("docstring") dolfin::GenericDofMap::GenericDofMap() "
Constructor.
";

%feature("docstring") dolfin::GenericDofMap::block_size() const  "
Get block size. 

:rtype: int
";

%feature("docstring") dolfin::GenericDofMap::cell_dimension(std::size_t index) const "
Return the dimension of the local finite element function space on a cell (deprecated API) 

:param std\\:\\:size_t index: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::cell_dofs(std::size_t cell_index) const  "
Local-to-global mapping of dofs on a cell. 

:param std\\:\\:size_t cell_index: 
:rtype: ArrayView< const dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::clear_sub_map_data() "
Clear any data required to build sub-dofmaps (this is to reduce memory use) 

:rtype: void
";

%feature("docstring") dolfin::GenericDofMap::collapse(std::unordered_map< std::size_t, std::size_t > &collapsed_map, const Mesh &mesh) const  "
Create a \"collapsed\" a dofmap (collapses from a sub-dofmap view) 

:param std\\:\\:unordered_map< std\\:\\:size_t, std\\:\\:size_t > & collapsed_map: 
:param const Mesh & mesh: 
:rtype: std::shared_ptr< GenericDofMap >
";

%feature("docstring") dolfin::GenericDofMap::constrained_domain "
Subdomain mapping constrained boundaries, e.g. periodic conditions 

:rtype: std::shared_ptr< const SubDomain >
";

%feature("docstring") dolfin::GenericDofMap::copy() const  "
Create a copy of the dof map. 

:rtype: std::shared_ptr< GenericDofMap >
";

%feature("docstring") dolfin::GenericDofMap::create(const Mesh &new_mesh) const  "
Create a new dof map on new mesh. 

:param const Mesh & new_mesh: 
:rtype: std::shared_ptr< GenericDofMap >
";

%feature("docstring") dolfin::GenericDofMap::dofs() const  "
Return list of global dof indices on this process. 

:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::dofs(const Mesh &mesh, std::size_t dim) const  "
Return list of dof indices on this process that belong to mesh entities of dimension dim 

:param const Mesh & mesh: 
:param std\\:\\:size_t dim: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::entity_closure_dofs(const Mesh &mesh, std::size_t entity_dim) const  "
Return the dof indices associated with the closure of all entities of given dimension 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::entity_closure_dofs(const Mesh &mesh, std::size_t entity_dim, const std::vector< std::size_t > &entity_indices) const  "
Return the dof indices associated with the closure of entities of given dimension and entity indices 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:param const std\\:\\:vector< std\\:\\:size_t > & entity_indices: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::entity_dofs(const Mesh &mesh, std::size_t entity_dim) const  "
Return the dof indices associated with all entities of given dimension. 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::entity_dofs(const Mesh &mesh, std::size_t entity_dim, const std::vector< std::size_t > &entity_indices) const  "
Return the dof indices associated with entities of given dimension and entity indices. 

:param const Mesh & mesh: 
:param std\\:\\:size_t entity_dim: 
:param const std\\:\\:vector< std\\:\\:size_t > & entity_indices: 
:rtype: std::vector< dolfin::la_index >
";

%feature("docstring") dolfin::GenericDofMap::extract_sub_dofmap(const std::vector< std::size_t > &component, const Mesh &mesh) const  "
Extract sub dofmap component. 

:param const std\\:\\:vector< std\\:\\:size_t > & component: 
:param const Mesh & mesh: 
:rtype: std::shared_ptr< GenericDofMap >
";

%feature("docstring") dolfin::GenericDofMap::global_dimension() const  "
Return the dimension of the global finite element function space 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::index_map() const  "
Index map (const access) 

:rtype: std::shared_ptr< const IndexMap >
";

%feature("docstring") dolfin::GenericDofMap::is_view() const  "
True if dof map is a view into another map (is a sub-dofmap) 

:rtype: bool
";

%feature("docstring") dolfin::GenericDofMap::local_to_global_index(int local_index) const  "
Return global dof index corresponding to a given local index. 

:param int local_index: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::local_to_global_unowned() const  "
Return the map from unowned local dofmap nodes to global dofmap nodes. Dofmap node is dof index modulo block size. 

:rtype: const std::vector< std::size_t > &
";

%feature("docstring") dolfin::GenericDofMap::max_cell_dimension() const "
Return the maximum dimension of the local finite element function space (deprecated API) 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::max_element_dofs() const  "
Return the maximum dimension of the local finite element function space 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::neighbours() const  "
Return set of processes that share dofs with the this process. 

:rtype: const std::set< int > &
";

%feature("docstring") dolfin::GenericDofMap::num_element_dofs(std::size_t index) const  "
Return the dimension of the local finite element function space on a cell 

:param std\\:\\:size_t index: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::num_entity_closure_dofs(std::size_t entity_dim) const  "
Return the number of dofs for closure of entity of given dimension. 

:param std\\:\\:size_t entity_dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::num_entity_dofs(std::size_t entity_dim) const  "
Return the number of dofs for a given entity dimension. 

:param std\\:\\:size_t entity_dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::num_facet_dofs() const  "
Return number of facet dofs. 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericDofMap::off_process_owner() const  "
Return map from nonlocal-dofs (that appear in local dof map) to owning process 

:rtype: const std::vector< int > &
";

%feature("docstring") dolfin::GenericDofMap::ownership_range() const  "
Return the ownership range (dofs in this range are owned by this process) 

:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::GenericDofMap::set(GenericVector &x, double value) const  "
:cpp:any:`Set`  dof entries in vector to a specified value. Parallel layout of vector must be consistent with dof map range. This function is typically used to construct the null space of a matrix operator 

:param GenericVector & x: 
:param double value: 
:rtype: void
";

%feature("docstring") dolfin::GenericDofMap::shared_nodes() const  "
Return map from shared nodes to the processes (not including the current process) that share it. 

:rtype: const std::unordered_map< int, std::vector< int > > &
";

%feature("docstring") dolfin::GenericDofMap::str(bool verbose) const  "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::GenericDofMap::tabulate_entity_closure_dofs(std::vector< std::size_t > &element_dofs, std::size_t entity_dim, std::size_t cell_entity_index) const  "
Tabulate the local-to-local mapping of dofs on closure of entity (dim, local_entity) 

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs: 
:param std\\:\\:size_t entity_dim: 
:param std\\:\\:size_t cell_entity_index: 
:rtype: void
";

%feature("docstring") dolfin::GenericDofMap::tabulate_entity_dofs(std::vector< std::size_t > &element_dofs, std::size_t entity_dim, std::size_t cell_entity_index) const  "
Tabulate the local-to-local mapping of dofs on entity (dim, local_entity) 

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs: 
:param std\\:\\:size_t entity_dim: 
:param std\\:\\:size_t cell_entity_index: 
:rtype: void
";

%feature("docstring") dolfin::GenericDofMap::tabulate_facet_dofs(std::vector< std::size_t > &element_dofs, std::size_t cell_facet_index) const  "
Tabulate local-local facet dofs. 

:param std\\:\\:vector< std\\:\\:size_t > & element_dofs: 
:param std\\:\\:size_t cell_facet_index: 
:rtype: void
";

%feature("docstring") dolfin::GenericDofMap::tabulate_global_dofs(std::vector< std::size_t > &dofs) const  "
Tabulate globally supported dofs. 

:param std\\:\\:vector< std\\:\\:size_t > & dofs: 
:rtype: void
";

%feature("docstring") dolfin::GenericDofMap::tabulate_local_to_global_dofs(std::vector< std::size_t > &local_to_global_map) const  "
Tabulate map between local (process) and global dof indices. 

:param std\\:\\:vector< std\\:\\:size_t > & local_to_global_map: 
:rtype: void
";

%feature("docstring") dolfin::LinearTimeDependentProblem "
This class represents a linear time-dependent variational problem:
Find u in U = U_h (x) U_k such that 

::
   
   a(u, v) = L(v)  for all v in V = V_h (x) V_k,
   
where U is a tensor-product trial space and V is a tensor-product test space.
";

%feature("docstring") dolfin::LinearTimeDependentProblem::LinearTimeDependentProblem(std::shared_ptr< const TensorProductForm > a, std::shared_ptr< const TensorProductForm > L, std::shared_ptr< Function > u, std::vector< std::shared_ptr< const BoundaryCondition >> bcs) "
Create linear variational problem with a list of boundary conditions (shared pointer version) 

:param std\\:\\:shared_ptr< const TensorProductForm > a: 
:param std\\:\\:shared_ptr< const TensorProductForm > L: 
:param std\\:\\:shared_ptr< Function > u: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const BoundaryCondition >> bcs:
";

%feature("docstring") dolfin::LinearTimeDependentProblem::bcs() const "
Return boundary conditions. 

:rtype: std::vector< std::shared_ptr< const BoundaryCondition > >
";

%feature("docstring") dolfin::LinearTimeDependentProblem::bilinear_form() const "
Return bilinear form. 

:rtype: std::shared_ptr< const TensorProductForm >
";

%feature("docstring") dolfin::LinearTimeDependentProblem::check_forms() const "
:rtype: void
";

%feature("docstring") dolfin::LinearTimeDependentProblem::linear_form() const "
Return linear form. 

:rtype: std::shared_ptr< const TensorProductForm >
";

%feature("docstring") dolfin::LinearTimeDependentProblem::solution() "
Return solution variable. 

:rtype: std::shared_ptr< Function >
";

%feature("docstring") dolfin::LinearTimeDependentProblem::solution() const "
Return solution variable (const version) 

:rtype: std::shared_ptr< const Function >
";

%feature("docstring") dolfin::LinearTimeDependentProblem::test_space() const "
Return test space. 

:rtype: std::shared_ptr< const FunctionSpace >
";

%feature("docstring") dolfin::LinearTimeDependentProblem::trial_space() const "
Return trial space. 

:rtype: std::shared_ptr< const FunctionSpace >
";

%feature("docstring") dolfin::LinearVariationalProblem "
This class represents a linear variational problem:
Find u in V such that 

::
   
   a(u, v) = L(v)  for all v in V^,
   
where V is the trial space and V^ is the test space.
";

%feature("docstring") dolfin::LinearVariationalProblem::LinearVariationalProblem(std::shared_ptr< const Form > a, std::shared_ptr< const Form > L, std::shared_ptr< Function > u, std::vector< std::shared_ptr< const DirichletBC >> bcs) "
Create linear variational problem with a list of boundary conditions 

:param std\\:\\:shared_ptr< const Form > a: 
:param std\\:\\:shared_ptr< const Form > L: 
:param std\\:\\:shared_ptr< Function > u: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const DirichletBC >> bcs:
";

%feature("docstring") dolfin::LinearVariationalProblem::bcs() const "
Return boundary conditions. 

:rtype: std::vector< std::shared_ptr< const DirichletBC > >
";

%feature("docstring") dolfin::LinearVariationalProblem::bilinear_form() const "
Return bilinear form. 

:rtype: std::shared_ptr< const Form >
";

%feature("docstring") dolfin::LinearVariationalProblem::check_forms() const "
:rtype: void
";

%feature("docstring") dolfin::LinearVariationalProblem::linear_form() const "
Return linear form. 

:rtype: std::shared_ptr< const Form >
";

%feature("docstring") dolfin::LinearVariationalProblem::solution() "
Return solution variable. 

:rtype: std::shared_ptr< Function >
";

%feature("docstring") dolfin::LinearVariationalProblem::solution() const "
Return solution variable (const version) 

:rtype: std::shared_ptr< const Function >
";

%feature("docstring") dolfin::LinearVariationalProblem::test_space() const "
Return test space. 

:rtype: std::shared_ptr< const FunctionSpace >
";

%feature("docstring") dolfin::LinearVariationalProblem::trial_space() const "
Return trial space. 

:rtype: std::shared_ptr< const FunctionSpace >
";

%feature("docstring") dolfin::LinearVariationalSolver "
This class implements a solver for linear variational problems.
";

%feature("docstring") dolfin::LinearVariationalSolver::LinearVariationalSolver(std::shared_ptr< LinearVariationalProblem > problem) "
Create linear variational solver for given problem. 

:param std\\:\\:shared_ptr< LinearVariationalProblem > problem:
";

%feature("docstring") dolfin::LinearVariationalSolver::solve() "
Solve variational problem. 

:rtype: void
";

%feature("docstring") dolfin::LocalAssembler "
Assembly of local cell tensors. Used by the adaptivity and :cpp:any:`LocalSolver`  functionality in dolfin. The local assembly functionality provided here is also wrapped as a free function assemble_local(form_a, cell) in Python for easier usage. Use from the C++ interface defined below will be faster than the free function as fewer objects need to be created and destroyed.
";

%feature("docstring") dolfin::LocalAssembler::assemble(Eigen::Matrix< double, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor > &A, UFC &ufc, const std::vector< double > &coordinate_dofs, ufc::cell &ufc_cell, const Cell &cell, const MeshFunction< std::size_t > *cell_domains, const MeshFunction< std::size_t > *exterior_facet_domains, const MeshFunction< std::size_t > *interior_facet_domains) "
Assemble a local tensor on a cell. Internally calls :cpp:any:`assemble_cell()` , :cpp:any:`assemble_exterior_facet()` , :cpp:any:`assemble_interior_facet()` . 

:param Eigen\\:\\:Matrix< double, Eigen\\:\\:Dynamic, Eigen\\:\\:Dynamic, Eigen\\:\\:RowMajor > & A: The tensor to assemble.
:param UFC & ufc: 
:param const std\\:\\:vector< double > & coordinate_dofs: 
:param ufc\\:\\:cell & ufc_cell: 
:param const Cell & cell: 
:param const MeshFunction< std\\:\\:size_t > * cell_domains: 
:param const MeshFunction< std\\:\\:size_t > * exterior_facet_domains: 
:param const MeshFunction< std\\:\\:size_t > * interior_facet_domains: 
:rtype: void
";

%feature("docstring") dolfin::LocalAssembler::assemble_cell(Eigen::Matrix< double, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor > &A, UFC &ufc, const std::vector< double > &coordinate_dofs, const ufc::cell &ufc_cell, const Cell &cell, const MeshFunction< std::size_t > *cell_domains) "
Worker method called by :cpp:any:`assemble()`  to perform assembly of volume integrals (UFL measure dx). 

:param Eigen\\:\\:Matrix< double, Eigen\\:\\:Dynamic, Eigen\\:\\:Dynamic, Eigen\\:\\:RowMajor > & A: The tensor to assemble.
:param UFC & ufc: 
:param const std\\:\\:vector< double > & coordinate_dofs: 
:param const ufc\\:\\:cell & ufc_cell: 
:param const Cell & cell: 
:param const MeshFunction< std\\:\\:size_t > * cell_domains: 
:rtype: void
";

%feature("docstring") dolfin::LocalAssembler::assemble_exterior_facet(Eigen::Matrix< double, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor > &A, UFC &ufc, const std::vector< double > &coordinate_dofs, const ufc::cell &ufc_cell, const Cell &cell, const Facet &facet, const std::size_t local_facet, const MeshFunction< std::size_t > *exterior_facet_domains) "
Worker method called by :cpp:any:`assemble()`  for each of the cell's external facets to perform assembly of external facet integrals (UFL measure ds). 

:param Eigen\\:\\:Matrix< double, Eigen\\:\\:Dynamic, Eigen\\:\\:Dynamic, Eigen\\:\\:RowMajor > & A: The tensor to assemble.
:param UFC & ufc: 
:param const std\\:\\:vector< double > & coordinate_dofs: 
:param const ufc\\:\\:cell & ufc_cell: 
:param const Cell & cell: 
:param const Facet & facet: 
:param const std\\:\\:size_t local_facet: 
:param const MeshFunction< std\\:\\:size_t > * exterior_facet_domains: 
:rtype: void
";

%feature("docstring") dolfin::LocalAssembler::assemble_interior_facet(Eigen::Matrix< double, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor > &A, UFC &ufc, const std::vector< double > &coordinate_dofs, const ufc::cell &ufc_cell, const Cell &cell, const Facet &facet, const std::size_t local_facet, const MeshFunction< std::size_t > *interior_facet_domains, const MeshFunction< std::size_t > *cell_domains) "
Worker method called by :cpp:any:`assemble()`  for each of the cell's internal facets to perform assembly of internal facet integrals (UFL measure dS) 

:param Eigen\\:\\:Matrix< double, Eigen\\:\\:Dynamic, Eigen\\:\\:Dynamic, Eigen\\:\\:RowMajor > & A: The tensor to assemble.
:param UFC & ufc: 
:param const std\\:\\:vector< double > & coordinate_dofs: 
:param const ufc\\:\\:cell & ufc_cell: 
:param const Cell & cell: 
:param const Facet & facet: 
:param const std\\:\\:size_t local_facet: 
:param const MeshFunction< std\\:\\:size_t > * interior_facet_domains: 
:param const MeshFunction< std\\:\\:size_t > * cell_domains: 
:rtype: void
";

%feature("docstring") dolfin::LocalSolver "
Solve problems cell-wise. 
This class solves problems cell-wise. It computes the local left-hand side A_local which must be square locally but not globally. The right-hand side b_local is either computed locally for one cell or globally for all cells depending on which of the solve_local_rhs or solve_global_rhs methods which are called. You can optionally assemble the right-hand side vector yourself and use the solve_local method. You must then provide the :cpp:any:`DofMap`  of the right-hand side.
The local solver solves A_local x_local = b_local. The result x_local is copied into the global vector x of the provided :cpp:any:`Function`  u. You can optionally call the :cpp:any:`factorize()`  method to pre-calculate the local left-hand side factorizations to speed up repeated applications of the :cpp:any:`LocalSolver`  with the same LHS. The solve_xxx methods will factorise the LHS A_local matrices each time if they are not cached by a previous call to factorize. You can chose upon initialization whether you want Cholesky or LU (default) factorisations.
For forms with no coupling across cell edges, this function is identical to a global solve. For problems with coupling across cells it is not.
This class can be used for post-processing solutions, e.g. computing stress fields for visualisation, far more cheaply that using global projections.
";

%feature("docstring") dolfin::LocalSolver::LocalSolver(std::shared_ptr< const Form > a, SolverType solver_type=SolverType::LU) "
Constructor (shared pointer version) 

:param std\\:\\:shared_ptr< const Form > a:  (:cpp:any:`Form` ) input LHS form
:param SolverType solver_type:  (SolverType)
";

%feature("docstring") dolfin::LocalSolver::LocalSolver(std::shared_ptr< const Form > a, std::shared_ptr< const Form > L, SolverType solver_type=SolverType::LU) "
Constructor (shared pointer version) 

:param std\\:\\:shared_ptr< const Form > a:  (:cpp:any:`Form` ) input LHS form
:param std\\:\\:shared_ptr< const Form > L:  (:cpp:any:`Form` ) input RHS form
:param SolverType solver_type:  (SolverType)
";

%feature("docstring") dolfin::LocalSolver::SolverType "
SolverType. 

.. cpp:enumerator:: dolfin::LocalSolver::SolverType::LU 

.. cpp:enumerator:: dolfin::LocalSolver::SolverType::Cholesky
";

%feature("docstring") dolfin::LocalSolver::clear_factorization() "
Reset (clear) any stored factorizations. 

:rtype: void
";

%feature("docstring") dolfin::LocalSolver::factorize() "
Factorise the local LHS matrices for all cells and store in cache. 

:rtype: void
";

%feature("docstring") dolfin::LocalSolver::solve_global_rhs(Function &u) const "
Solve local (cell-wise) problems A_e x_e = b_e, where A_e is the cell matrix LHS and b_e is the global RHS vector b restricted to the cell, i.e. b_e may contain contributions from neighbouring cells. The solution is exact for the case in which there is no coupling between cell contributions to the global matrix A, e.g. the discontinuous Galerkin matrix. The result is copied into x. 

:param Function & u:  (:cpp:any:`Function` &) :cpp:any:`Function`
:rtype: void
";

%feature("docstring") dolfin::LocalSolver::solve_local(GenericVector &x, const GenericVector &b, const GenericDofMap &dofmap_b) const "
Solve local problems for given RHS and corresponding dofmap for RHS 

:param GenericVector & x:  (:cpp:any:`GenericVector` )
:param const GenericVector & b:  (:cpp:any:`GenericVector` )
:param const GenericDofMap & dofmap_b:  (:cpp:any:`GenericDofMap` )
:rtype: void
";

%feature("docstring") dolfin::LocalSolver::solve_local_rhs(Function &u) const "
Solve local (cell-wise) problems A_e x_e = b_e where A_e and b_e are the cell element tensors. Compared to solve_global_rhs this function calculates local RHS vectors for each cell and hence does not include contributions from neighbouring cells.
This function is useful for computing (approximate) cell-wise projections, for example for post-processing. It much more efficient than computing global projections. 

:param Function & u:  (:cpp:any:`Function` &) :cpp:any:`Function`
:rtype: void
";

%feature("docstring") dolfin::MultiMeshAssembler "
This class implements functionality for finite element assembly over cut and composite finite element (:cpp:any:`MultiMesh` ) function spaces.
";

%feature("docstring") dolfin::MultiMeshAssembler::MultiMeshAssembler() "
Constructor.
";

%feature("docstring") dolfin::MultiMeshAssembler::assemble(GenericTensor &A, const MultiMeshForm &a) "
Assemble tensor from given form

:param GenericTensor & A:  (:cpp:any:`GenericTensor` ) The tensor to assemble.
:param const MultiMeshForm & a:  (:cpp:any:`Form` ) The form to assemble the tensor from.
:rtype: void
";

%feature("docstring") dolfin::MultiMeshAssembler::extend_cut_cell_integration "
extend_cut_cell_integration (bool) Default value is false. This controls whether the integration over cut cells should extend to the part of cut cells covered by cells from higher ranked meshes - thus including both the cut cell part and the overlap part. 

:rtype: bool
";

%feature("docstring") dolfin::MultiMeshDirichletBC "
This class is used to set Dirichlet boundary conditions for multimesh function spaces.
";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshDirichletBC(std::shared_ptr< const MultiMeshFunctionSpace > V, std::shared_ptr< const GenericFunction > g, std::shared_ptr< const MeshFunction< std::size_t >> sub_domains, std::size_t sub_domain, std::size_t part, std::string method="topological") "
Create boundary condition for subdomain specified by index

:param std\\:\\:shared_ptr< const MultiMeshFunctionSpace > V:  (:cpp:any:`FunctionSpace` ) The function space.
:param std\\:\\:shared_ptr< const GenericFunction > g:  (:cpp:any:`GenericFunction` ) The value.
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> sub_domains:  (:cpp:any:`MeshFunction`  <std::size_t>) Subdomain markers
:param std\\:\\:size_t sub_domain:  (std::size_t) The subdomain index (number)
:param std\\:\\:size_t part:  (std::size_t) The part on which to set boundary conditions
:param std\\:\\:string method:  (std::string) Optional argument: A string specifying the method to identify dofs.
";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshDirichletBC(std::shared_ptr< const MultiMeshFunctionSpace > V, std::shared_ptr< const GenericFunction > g, std::shared_ptr< const SubDomain > sub_domain, std::string method="topological", bool check_midpoint=true, bool exclude_overlapped_boundaries=true) "
Create boundary condition for subdomain

:param std\\:\\:shared_ptr< const MultiMeshFunctionSpace > V:  (:cpp:any:`MultiMeshFunctionSpace` ) The function space
:param std\\:\\:shared_ptr< const GenericFunction > g:  (:cpp:any:`GenericFunction` ) The value
:param std\\:\\:shared_ptr< const SubDomain > sub_domain:  (:cpp:any:`SubDomain` ) The subdomain
:param std\\:\\:string method:  (std::string) Option passed to :cpp:any:`DirichletBC` .
:param bool check_midpoint:  (bool) Option passed to :cpp:any:`DirichletBC` .
:param bool exclude_overlapped_boundaries:  (bool) If true, then the variable on_boundary will be set to false for facets that are overlapped by another mesh (irrespective of the layering order of the meshes).
";

%feature("docstring") dolfin::MultiMeshDirichletBC::apply(GenericMatrix &A) const "
Apply boundary condition to a matrix

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` ) The matrix to apply boundary condition to.
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDirichletBC::apply(GenericMatrix &A, GenericVector &b) const "
Apply boundary condition to a linear system

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` ) The matrix to apply boundary condition to.
:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary condition to.
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDirichletBC::apply(GenericMatrix &A, GenericVector &b, const GenericVector &x) const "
Apply boundary condition to a linear system for a nonlinear problem

:param GenericMatrix & A:  (:cpp:any:`GenericMatrix` ) The matrix to apply boundary conditions to.
:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary conditions to.
:param const GenericVector & x:  (:cpp:any:`GenericVector` ) Another vector (nonlinear problem).
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDirichletBC::apply(GenericVector &b) const "
Apply boundary condition to a vector

:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary condition to.
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDirichletBC::apply(GenericVector &b, const GenericVector &x) const "
Apply boundary condition to vectors for a nonlinear problem

:param GenericVector & b:  (:cpp:any:`GenericVector` ) The vector to apply boundary conditions to.
:param const GenericVector & x:  (:cpp:any:`GenericVector` ) Another vector (nonlinear problem).
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDirichletBC::~MultiMeshDirichletBC() "
Destructor.
";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshSubDomain "

";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshSubDomain::MultiMeshSubDomain(std::shared_ptr< const SubDomain > sub_domain, std::shared_ptr< const MultiMesh > multimesh, bool exclude_overlapped_boundaries) "
:param std\\:\\:shared_ptr< const SubDomain > sub_domain: 
:param std\\:\\:shared_ptr< const MultiMesh > multimesh: 
:param bool exclude_overlapped_boundaries:
";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshSubDomain::inside(const Array< double > &x, bool on_boundary) const "
:param const Array< double > & x: 
:param bool on_boundary: 
:rtype: bool
";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshSubDomain::set_current_part(std::size_t current_part) "
:param std\\:\\:size_t current_part: 
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDirichletBC::MultiMeshSubDomain::~MultiMeshSubDomain() "

";

%feature("docstring") dolfin::MultiMeshDofMap "
This class handles the mapping of degrees of freedom for :cpp:any:`MultiMesh`  function spaces.
";

%feature("docstring") dolfin::MultiMeshDofMap::MultiMeshDofMap() "
Constructor.
";

%feature("docstring") dolfin::MultiMeshDofMap::MultiMeshDofMap(const MultiMeshDofMap &dofmap) "
Copy constructor. 

:param const MultiMeshDofMap & dofmap:
";

%feature("docstring") dolfin::MultiMeshDofMap::add(std::shared_ptr< const GenericDofMap > dofmap) "
Add dofmap
Arguments dofmap (:cpp:any:`GenericDofMap` ) The dofmap. 

:param std\\:\\:shared_ptr< const GenericDofMap > dofmap: 
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDofMap::build(const MultiMeshFunctionSpace &function_space, const std::vector< dolfin::la_index > &offsets) "
Build :cpp:any:`MultiMesh`  dofmap. 

:param const MultiMeshFunctionSpace & function_space: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & offsets: 
:rtype: void
";

%feature("docstring") dolfin::MultiMeshDofMap::clear() "
Clear :cpp:any:`MultiMesh`  dofmap. 

:rtype: void
";

%feature("docstring") dolfin::MultiMeshDofMap::global_dimension() const "
Return the dimension of the global finite element function space 

:rtype: std::size_t
";

%feature("docstring") dolfin::MultiMeshDofMap::index_map() const "
Return the map. 

:rtype: std::shared_ptr< IndexMap >
";

%feature("docstring") dolfin::MultiMeshDofMap::num_parts() const "
Return the number dofmaps (parts) of the :cpp:any:`MultiMesh`  dofmap
Returns std::size_t The number of dofmaps (parts) of the :cpp:any:`MultiMesh`  dofmap 

:rtype: std::size_t
";

%feature("docstring") dolfin::MultiMeshDofMap::off_process_owner() const "
Return map from nonlocal-dofs (that appear in local dof map) to owning process 

:rtype: const std::vector< int > &
";

%feature("docstring") dolfin::MultiMeshDofMap::ownership_range() const "
Return the ownership range (dofs in this range are owned by this process) 

:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::MultiMeshDofMap::part(std::size_t i) const "
Return dofmap (part) number i
Returns:cpp:any:`GenericDofMap`  Dofmap (part) number i 

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< const GenericDofMap >
";

%feature("docstring") dolfin::MultiMeshDofMap::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::MultiMeshDofMap::~MultiMeshDofMap() "
Destructor.
";

%feature("docstring") dolfin::MultiMeshForm "
This class represents a variational form on a cut and composite finite element function space (:cpp:any:`MultiMesh` ) defined on one or more possibly intersecting meshes.
";

%feature("docstring") dolfin::MultiMeshForm::MultiMeshForm() "

";

%feature("docstring") dolfin::MultiMeshForm::MultiMeshForm(std::shared_ptr< const MultiMesh > multimesh) "
Create empty multimesh functional. 

:param std\\:\\:shared_ptr< const MultiMesh > multimesh:
";

%feature("docstring") dolfin::MultiMeshForm::MultiMeshForm(std::shared_ptr< const MultiMeshFunctionSpace > function_space) "
Create empty linear multimesh variational form. 

:param std\\:\\:shared_ptr< const MultiMeshFunctionSpace > function_space:
";

%feature("docstring") dolfin::MultiMeshForm::MultiMeshForm(std::shared_ptr< const MultiMeshFunctionSpace > function_space_0, std::shared_ptr< const MultiMeshFunctionSpace > function_space_1) "
Create empty bilinear multimesh variational form. 

:param std\\:\\:shared_ptr< const MultiMeshFunctionSpace > function_space_0: 
:param std\\:\\:shared_ptr< const MultiMeshFunctionSpace > function_space_1:
";

%feature("docstring") dolfin::MultiMeshForm::add(std::shared_ptr< const Form > form) "
Add form (shared pointer version)

:param std\\:\\:shared_ptr< const Form > form:  (:cpp:any:`Form` ) The form.
:rtype: void
";

%feature("docstring") dolfin::MultiMeshForm::build() "
Build :cpp:any:`MultiMesh`  form. 

:rtype: void
";

%feature("docstring") dolfin::MultiMeshForm::clear() "
Clear :cpp:any:`MultiMesh`  form. 

:rtype: void
";

%feature("docstring") dolfin::MultiMeshForm::function_space(std::size_t i) const "
Return function space for given argument

:param std\\:\\:size_t i:  (std::size_t) Index
:rtype: std::shared_ptr< const MultiMeshFunctionSpace >
:returns: :cpp:any:`MultiMeshFunctionSpace` :cpp:any:`Function`  space shared pointer.
";

%feature("docstring") dolfin::MultiMeshForm::multimesh() const "
Extract common multimesh from form

:rtype: std::shared_ptr< const MultiMesh >
:returns: :cpp:any:`MultiMesh`  The mesh.
";

%feature("docstring") dolfin::MultiMeshForm::num_parts() const "
Return the number of forms (parts) of the :cpp:any:`MultiMesh`  form

:rtype: std::size_t
:returns: std::size_t The number of forms (parts) of the :cpp:any:`MultiMesh`  form.
";

%feature("docstring") dolfin::MultiMeshForm::part(std::size_t i) const "
Return form (part) number i

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< const Form >
:returns: :cpp:any:`Form` :cpp:any:`Form`  (part) number i.
";

%feature("docstring") dolfin::MultiMeshForm::rank() const "
Return rank of form (bilinear form = 2, linear form = 1, functional = 0, etc)

:rtype: std::size_t
:returns: std::size_t The rank of the form.
";

%feature("docstring") dolfin::MultiMeshForm::~MultiMeshForm() "
Destructor.
";

%feature("docstring") dolfin::NonlinearVariationalProblem "
This class represents a nonlinear variational problem:
Find u in V such that 

::
   
   F(u; v) = 0  for all v in V^,
   
where V is the trial space and V^ is the test space.
";

%feature("docstring") dolfin::NonlinearVariationalProblem::NonlinearVariationalProblem(std::shared_ptr< const Form > F, std::shared_ptr< Function > u, std::vector< std::shared_ptr< const DirichletBC >> bcs, std::shared_ptr< const Form > J=nullptr) "
Create nonlinear variational problem, shared pointer version. The Jacobian form is specified which allows the use of a nonlinear solver that relies on the Jacobian (using Newton's method). 

:param std\\:\\:shared_ptr< const Form > F: 
:param std\\:\\:shared_ptr< Function > u: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const DirichletBC >> bcs: 
:param std\\:\\:shared_ptr< const Form > J:
";

%feature("docstring") dolfin::NonlinearVariationalProblem::bcs() const "
Return boundary conditions. 

:rtype: std::vector< std::shared_ptr< const DirichletBC > >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::check_forms() const "
:rtype: void
";

%feature("docstring") dolfin::NonlinearVariationalProblem::has_jacobian() const "
Check whether Jacobian has been defined. 

:rtype: bool
";

%feature("docstring") dolfin::NonlinearVariationalProblem::has_lower_bound() const "
Check whether lower bound has been defined. 

:rtype: bool
";

%feature("docstring") dolfin::NonlinearVariationalProblem::has_upper_bound() const "
Check whether upper bound have has defined. 

:rtype: bool
";

%feature("docstring") dolfin::NonlinearVariationalProblem::jacobian_form() const "
Return Jacobian form. 

:rtype: std::shared_ptr< const Form >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::lower_bound() const "
Return lower bound. 

:rtype: std::shared_ptr< const GenericVector >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::residual_form() const "
Return residual form. 

:rtype: std::shared_ptr< const Form >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::set_bounds(const Function &lb_func, const Function &ub_func) "
:cpp:any:`Set`  the bounds for bound constrained solver. 

:param const Function & lb_func: 
:param const Function & ub_func: 
:rtype: void
";

%feature("docstring") dolfin::NonlinearVariationalProblem::set_bounds(std::shared_ptr< const GenericVector > lb, std::shared_ptr< const GenericVector > ub) "
:cpp:any:`Set`  the bounds for bound constrained solver. 

:param std\\:\\:shared_ptr< const GenericVector > lb: 
:param std\\:\\:shared_ptr< const GenericVector > ub: 
:rtype: void
";

%feature("docstring") dolfin::NonlinearVariationalProblem::solution() "
Return solution variable. 

:rtype: std::shared_ptr< Function >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::solution() const "
Return solution variable (const version) 

:rtype: std::shared_ptr< const Function >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::test_space() const "
Return test space. 

:rtype: std::shared_ptr< const FunctionSpace >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::trial_space() const "
Return trial space. 

:rtype: std::shared_ptr< const FunctionSpace >
";

%feature("docstring") dolfin::NonlinearVariationalProblem::upper_bound() const "
Return upper bound. 

:rtype: std::shared_ptr< const GenericVector >
";

%feature("docstring") dolfin::NonlinearVariationalSolver "
This class implements a solver for nonlinear variational problems.
";

%feature("docstring") dolfin::NonlinearVariationalSolver::NonlinearVariationalSolver(std::shared_ptr< NonlinearVariationalProblem > problem) "
Create nonlinear variational solver for given problem. 

:param std\\:\\:shared_ptr< NonlinearVariationalProblem > problem:
";

%feature("docstring") dolfin::NonlinearVariationalSolver::newton_solver "
:rtype: std::shared_ptr< NewtonSolver >
";

%feature("docstring") dolfin::NonlinearVariationalSolver::nonlinear_problem "
:rtype: std::shared_ptr< NonlinearDiscreteProblem >
";

%feature("docstring") dolfin::NonlinearVariationalSolver::snes_solver "
:rtype: std::shared_ptr< PETScSNESSolver >
";

%feature("docstring") dolfin::NonlinearVariationalSolver::solve() "
Solve variational problem
Returns std::pair<std::size_t, bool> Pair of number of Newton iterations, and whether iteration converged) 

:rtype: std::pair< std::size_t, bool >
";

%feature("docstring") dolfin::NonlinearVariationalSolver::NonlinearDiscreteProblem "

";

%feature("docstring") dolfin::NonlinearVariationalSolver::NonlinearDiscreteProblem::F(GenericVector &b, const GenericVector &x) "
:param GenericVector & b: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::NonlinearVariationalSolver::NonlinearDiscreteProblem::J(GenericMatrix &A, const GenericVector &x) "
:param GenericMatrix & A: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::NonlinearVariationalSolver::NonlinearDiscreteProblem::NonlinearDiscreteProblem(std::shared_ptr< const NonlinearVariationalProblem > problem, std::shared_ptr< const NonlinearVariationalSolver > solver) "
:param std\\:\\:shared_ptr< const NonlinearVariationalProblem > problem: 
:param std\\:\\:shared_ptr< const NonlinearVariationalSolver > solver:
";

%feature("docstring") dolfin::NonlinearVariationalSolver::NonlinearDiscreteProblem::~NonlinearDiscreteProblem() "

";

%feature("docstring") dolfin::PETScDMCollection "
This class builds and stores of collection of PETSc DM objects from a hierarchy of FunctionSpaces objects. The DM objects are used to construct multigrid solvers via PETSc.
Warning: This classs is highly experimental and will change
";

%feature("docstring") dolfin::PETScDMCollection::PETScDMCollection(std::vector< std::shared_ptr< const FunctionSpace >> function_spaces) "
Construct :cpp:any:`PETScDMCollection`  from a vector of FunctionSpaces. The vector of FunctionSpaces is stored from coarse to fine. 

:param std\\:\\:vector< std\\:\\:shared_ptr< const FunctionSpace >> function_spaces:
";

%feature("docstring") dolfin::PETScDMCollection::check_ref_count() const "
These are test/debugging functions that will be removed. 

:rtype: void
";

%feature("docstring") dolfin::PETScDMCollection::coarsen(DM dmf, MPI_Comm comm, DM *dmc) "
:param DM dmf: 
:param MPI_Comm comm: 
:param DM * dmc: 
:rtype: PetscErrorCode
";

%feature("docstring") dolfin::PETScDMCollection::create_global_vector(DM dm, Vec *vec) "
:param DM dm: 
:param Vec * vec: 
:rtype: PetscErrorCode
";

%feature("docstring") dolfin::PETScDMCollection::create_interpolation(DM dmc, DM dmf, Mat *mat, Vec *vec) "
:param DM dmc: 
:param DM dmf: 
:param Mat * mat: 
:param Vec * vec: 
:rtype: PetscErrorCode
";

%feature("docstring") dolfin::PETScDMCollection::create_transfer_matrix(std::shared_ptr< const FunctionSpace > coarse_space, std::shared_ptr< const FunctionSpace > fine_space) "
Create the interpolation matrix from the coarse to the fine space (prolongation matrix) 

:param std\\:\\:shared_ptr< const FunctionSpace > coarse_space: 
:param std\\:\\:shared_ptr< const FunctionSpace > fine_space: 
:rtype: std::shared_ptr< PETScMatrix >
";

%feature("docstring") dolfin::PETScDMCollection::find_exterior_points(MPI_Comm mpi_comm, std::shared_ptr< const BoundingBoxTree > treec, int dim, int data_size, const std::vector< double > &send_points, const std::vector< int > &send_indices, std::vector< int > &indices, std::vector< std::size_t > &cell_ids, std::vector< double > &points) "
:param MPI_Comm mpi_comm: 
:param std\\:\\:shared_ptr< const BoundingBoxTree > treec: 
:param int dim: 
:param int data_size: 
:param const std\\:\\:vector< double > & send_points: 
:param const std\\:\\:vector< int > & send_indices: 
:param std\\:\\:vector< int > & indices: 
:param std\\:\\:vector< std\\:\\:size_t > & cell_ids: 
:param std\\:\\:vector< double > & points: 
:rtype: void
";

%feature("docstring") dolfin::PETScDMCollection::get_dm(int i) "
Return the ith DM objects. The coarest DM has index 0. Use i=-1 to get the DM for the finest level, i=-2 for the DM for the second finest level, etc. 

:param int i: 
:rtype: DM
";

%feature("docstring") dolfin::PETScDMCollection::refine(DM dmc, MPI_Comm comm, DM *dmf) "
:param DM dmc: 
:param MPI_Comm comm: 
:param DM * dmf: 
:rtype: PetscErrorCode
";

%feature("docstring") dolfin::PETScDMCollection::reset(int i) "
Debugging use - to be removed. 

:param int i: 
:rtype: void
";

%feature("docstring") dolfin::PETScDMCollection::~PETScDMCollection() "
Destructor.
";

%feature("docstring") dolfin::PointSource "
This class provides an easy mechanism for adding a point quantities (Dirac delta function) to variational problems. The associated function space must be scalar in order for the inner product with the (scalar) Dirac delta function to be well defined. For each of the constructors, Points passed to :cpp:any:`PointSource`  will be copied.
Note: the interface to this class will likely change.
";

%feature("docstring") dolfin::PointSource::PointSource(std::shared_ptr< const FunctionSpace > V, const Point &p, double magnitude=1.0) "
Create point source at given point of given magnitude. 

:param std\\:\\:shared_ptr< const FunctionSpace > V: 
:param const Point & p: 
:param double magnitude:
";

%feature("docstring") dolfin::PointSource::PointSource(std::shared_ptr< const FunctionSpace > V, const std::vector< std::pair< const Point *, double >> sources) "
Create point sources at given points of given magnitudes. 

:param std\\:\\:shared_ptr< const FunctionSpace > V: 
:param const std\\:\\:vector< std\\:\\:pair< const Point *, double >> sources:
";

%feature("docstring") dolfin::PointSource::PointSource(std::shared_ptr< const FunctionSpace > V0, std::shared_ptr< const FunctionSpace > V1, const Point &p, double magnitude=1.0) "
Create point source at given point of given magnitude. 

:param std\\:\\:shared_ptr< const FunctionSpace > V0: 
:param std\\:\\:shared_ptr< const FunctionSpace > V1: 
:param const Point & p: 
:param double magnitude:
";

%feature("docstring") dolfin::PointSource::PointSource(std::shared_ptr< const FunctionSpace > V0, std::shared_ptr< const FunctionSpace > V1, const std::vector< std::pair< const Point *, double >> sources) "
Create point sources at given points of given magnitudes. 

:param std\\:\\:shared_ptr< const FunctionSpace > V0: 
:param std\\:\\:shared_ptr< const FunctionSpace > V1: 
:param const std\\:\\:vector< std\\:\\:pair< const Point *, double >> sources:
";

%feature("docstring") dolfin::PointSource::apply(GenericMatrix &A) "
Apply (add) point source to matrix. 

:param GenericMatrix & A: 
:rtype: void
";

%feature("docstring") dolfin::PointSource::apply(GenericVector &b) "
Apply (add) point source to right-hand side vector. 

:param GenericVector & b: 
:rtype: void
";

%feature("docstring") dolfin::PointSource::check_space_supported(const FunctionSpace &V) "
:param const FunctionSpace & V: 
:rtype: void
";

%feature("docstring") dolfin::PointSource::distribute_sources(const Mesh &mesh, const std::vector< std::pair< Point, double >> &sources) "
:param const Mesh & mesh: 
:param const std\\:\\:vector< std\\:\\:pair< Point, double >> & sources: 
:rtype: void
";

%feature("docstring") dolfin::PointSource::~PointSource() "
Destructor.
";

%feature("docstring") dolfin::SparsityPatternBuilder "
This class provides functions to compute the sparsity pattern based on DOF maps
";

%feature("docstring") dolfin::SparsityPatternBuilder::build(SparsityPattern &sparsity_pattern, const Mesh &mesh, const std::vector< const GenericDofMap *> dofmaps, bool cells, bool interior_facets, bool exterior_facets, bool vertices, bool diagonal, bool init=true, bool finalize=true) "
Build sparsity pattern for assembly of given form. 

:param SparsityPattern & sparsity_pattern: 
:param const Mesh & mesh: 
:param const std\\:\\:vector< const GenericDofMap *> dofmaps: 
:param bool cells: 
:param bool interior_facets: 
:param bool exterior_facets: 
:param bool vertices: 
:param bool diagonal: 
:param bool init: 
:param bool finalize: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPatternBuilder::build_multimesh_sparsity_pattern(SparsityPattern &sparsity_pattern, const MultiMeshForm &form) "
Build sparsity pattern for assembly of given multimesh form. 

:param SparsityPattern & sparsity_pattern: 
:param const MultiMeshForm & form: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler "
This class provides an assembler for systems of the form Ax = b. It differs from the default DOLFIN assembler in that it applies boundary conditions at the time of assembly, which preserves any symmetries in A.
";

%feature("docstring") dolfin::SystemAssembler::SystemAssembler(std::shared_ptr< const Form > a, std::shared_ptr< const Form > L, std::vector< std::shared_ptr< const DirichletBC >> bcs) "
Constructor. 

:param std\\:\\:shared_ptr< const Form > a: 
:param std\\:\\:shared_ptr< const Form > L: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const DirichletBC >> bcs:
";

%feature("docstring") dolfin::SystemAssembler::apply_bc(double *A, double *b, const std::vector< DirichletBC::Map > &boundary_values, const ArrayView< const dolfin::la_index > &global_dofs0, const ArrayView< const dolfin::la_index > &global_dofs1) "
:param double * A: 
:param double * b: 
:param const std\\:\\:vector< DirichletBC\\:\\:Map > & boundary_values: 
:param const ArrayView< const dolfin\\:\\:la_index > & global_dofs0: 
:param const ArrayView< const dolfin\\:\\:la_index > & global_dofs1: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::assemble(GenericMatrix &A) "
Assemble matrix A. 

:param GenericMatrix & A: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::assemble(GenericMatrix &A, GenericVector &b) "
Assemble system (A, b) 

:param GenericMatrix & A: 
:param GenericVector & b: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::assemble(GenericMatrix &A, GenericVector &b, const GenericVector &x0) "
Assemble system (A, b) for (negative) increment dx, where x = x0 - dx is solution to system a == -L subject to bcs. Suitable for use inside a (quasi-)Newton solver. 

:param GenericMatrix & A: 
:param GenericVector & b: 
:param const GenericVector & x0: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::assemble(GenericMatrix *A, GenericVector *b, const GenericVector *x0) "
:param GenericMatrix * A: 
:param GenericVector * b: 
:param const GenericVector * x0: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::assemble(GenericVector &b) "
Assemble vector b. 

:param GenericVector & b: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::assemble(GenericVector &b, const GenericVector &x0) "
Assemble rhs vector b for (negative) increment dx, where x = x0 - dx is solution to system a == -L subject to bcs. Suitable for use inside a (quasi-)Newton solver. 

:param GenericVector & b: 
:param const GenericVector & x0: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::cell_matrix_required(const GenericTensor *A, const void *integral, const std::vector< DirichletBC::Map > &boundary_values, const ArrayView< const dolfin::la_index > &dofs) "
:param const GenericTensor * A: 
:param const void * integral: 
:param const std\\:\\:vector< DirichletBC\\:\\:Map > & boundary_values: 
:param const ArrayView< const dolfin\\:\\:la_index > & dofs: 
:rtype: bool
";

%feature("docstring") dolfin::SystemAssembler::cell_wise_assembly(std::array< GenericTensor *, 2 > &tensors, std::array< UFC *, 2 > &ufc, Scratch &data, const std::vector< DirichletBC::Map > &boundary_values, std::shared_ptr< const MeshFunction< std::size_t >> cell_domains, std::shared_ptr< const MeshFunction< std::size_t >> exterior_facet_domains) "
:param std\\:\\:array< GenericTensor *, 2 > & tensors: 
:param std\\:\\:array< UFC *, 2 > & ufc: 
:param Scratch & data: 
:param const std\\:\\:vector< DirichletBC\\:\\:Map > & boundary_values: 
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> cell_domains: 
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> exterior_facet_domains: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::check_arity(std::shared_ptr< const Form > a, std::shared_ptr< const Form > L) "
:param std\\:\\:shared_ptr< const Form > a: 
:param std\\:\\:shared_ptr< const Form > L: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::check_functionspace_for_bc(std::shared_ptr< const FunctionSpace > fs, std::size_t bc_index) "
:param std\\:\\:shared_ptr< const FunctionSpace > fs: 
:param std\\:\\:size_t bc_index: 
:rtype: bool
";

%feature("docstring") dolfin::SystemAssembler::compute_exterior_facet_tensor(std::array< std::vector< double >, 2 > &Ae, std::array< UFC *, 2 > &ufc, ufc::cell &ufc_cell, std::vector< double > &coordinate_dofs, const std::array< bool, 2 > &tensor_required_cell, const std::array< bool, 2 > &tensor_required_facet, const Cell &cell, const Facet &facet, const std::array< const ufc::cell_integral *, 2 > &cell_integrals, const std::array< const ufc::exterior_facet_integral *, 2 > &exterior_facet_integrals, const bool compute_cell_tensor) "
:param std\\:\\:array< std\\:\\:vector< double >, 2 > & Ae: 
:param std\\:\\:array< UFC *, 2 > & ufc: 
:param ufc\\:\\:cell & ufc_cell: 
:param std\\:\\:vector< double > & coordinate_dofs: 
:param const std\\:\\:array< bool, 2 > & tensor_required_cell: 
:param const std\\:\\:array< bool, 2 > & tensor_required_facet: 
:param const Cell & cell: 
:param const Facet & facet: 
:param const std\\:\\:array< const ufc\\:\\:cell_integral *, 2 > & cell_integrals: 
:param const std\\:\\:array< const ufc\\:\\:exterior_facet_integral *, 2 > & exterior_facet_integrals: 
:param const bool compute_cell_tensor: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::compute_interior_facet_tensor(std::array< UFC *, 2 > &ufc, std::array< ufc::cell, 2 > &ufc_cell, std::array< std::vector< double >, 2 > &coordinate_dofs, const std::array< bool, 2 > &tensor_required_cell, const std::array< bool, 2 > &tensor_required_facet, const std::array< Cell, 2 > &cell, const std::array< std::size_t, 2 > &local_facet, const bool facet_owner, const std::array< const ufc::cell_integral *, 2 > &cell_integrals, const std::array< const ufc::interior_facet_integral *, 2 > &interior_facet_integrals, const std::array< std::size_t, 2 > &matrix_size, const std::size_t vector_size, const std::array< bool, 2 > compute_cell_tensor) "
:param std\\:\\:array< UFC *, 2 > & ufc: 
:param std\\:\\:array< ufc\\:\\:cell, 2 > & ufc_cell: 
:param std\\:\\:array< std\\:\\:vector< double >, 2 > & coordinate_dofs: 
:param const std\\:\\:array< bool, 2 > & tensor_required_cell: 
:param const std\\:\\:array< bool, 2 > & tensor_required_facet: 
:param const std\\:\\:array< Cell, 2 > & cell: 
:param const std\\:\\:array< std\\:\\:size_t, 2 > & local_facet: 
:param const bool facet_owner: 
:param const std\\:\\:array< const ufc\\:\\:cell_integral *, 2 > & cell_integrals: 
:param const std\\:\\:array< const ufc\\:\\:interior_facet_integral *, 2 > & interior_facet_integrals: 
:param const std\\:\\:array< std\\:\\:size_t, 2 > & matrix_size: 
:param const std\\:\\:size_t vector_size: 
:param const std\\:\\:array< bool, 2 > compute_cell_tensor: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::facet_wise_assembly(std::array< GenericTensor *, 2 > &tensors, std::array< UFC *, 2 > &ufc, Scratch &data, const std::vector< DirichletBC::Map > &boundary_values, std::shared_ptr< const MeshFunction< std::size_t >> cell_domains, std::shared_ptr< const MeshFunction< std::size_t >> exterior_facet_domains, std::shared_ptr< const MeshFunction< std::size_t >> interior_facet_domains) "
:param std\\:\\:array< GenericTensor *, 2 > & tensors: 
:param std\\:\\:array< UFC *, 2 > & ufc: 
:param Scratch & data: 
:param const std\\:\\:vector< DirichletBC\\:\\:Map > & boundary_values: 
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> cell_domains: 
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> exterior_facet_domains: 
:param std\\:\\:shared_ptr< const MeshFunction< std\\:\\:size_t >> interior_facet_domains: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::has_bc(const DirichletBC::Map &boundary_values, const ArrayView< const dolfin::la_index > &dofs) "
:param const DirichletBC\\:\\:Map & boundary_values: 
:param const ArrayView< const dolfin\\:\\:la_index > & dofs: 
:rtype: bool
";

%feature("docstring") dolfin::SystemAssembler::matrix_block_add(GenericTensor &tensor, std::vector< double > &Ae, std::vector< double > &macro_A, const std::array< bool, 2 > &add_local_tensor, const std::array< std::vector< ArrayView< const la_index >>, 2 > &cell_dofs) "
:param GenericTensor & tensor: 
:param std\\:\\:vector< double > & Ae: 
:param std\\:\\:vector< double > & macro_A: 
:param const std\\:\\:array< bool, 2 > & add_local_tensor: 
:param const std\\:\\:array< std\\:\\:vector< ArrayView< const la_index >>, 2 > & cell_dofs: 
:rtype: void
";

%feature("docstring") dolfin::SystemAssembler::Scratch "

";

%feature("docstring") dolfin::SystemAssembler::Scratch::Ae "
:rtype: std::array< std::vector< double >, 2 >
";

%feature("docstring") dolfin::SystemAssembler::Scratch::Scratch(const Form &a, const Form &L) "
:param const Form & a: 
:param const Form & L:
";

%feature("docstring") dolfin::SystemAssembler::Scratch::~Scratch() "

";

%feature("docstring") dolfin::UFC "
This class is a simple data structure that holds data used during assembly of a given :cpp:any:`UFC`  form. Data is created for each primary argument, that is, v_j for j < r. In addition, nodal basis expansion coefficients and a finite element are created for each coefficient function.
";

%feature("docstring") dolfin::UFC::A "
Local tensor. 

:rtype: std::vector< double >
";

%feature("docstring") dolfin::UFC::A_facet "
Local tensor. 

:rtype: std::vector< double >
";

%feature("docstring") dolfin::UFC::UFC(const Form &form) "
Constructor. 

:param const Form & form:
";

%feature("docstring") dolfin::UFC::UFC(const UFC &ufc) "
Copy constructor. 

:param const UFC & ufc:
";

%feature("docstring") dolfin::UFC::cell_integrals "
:rtype: std::vector< std::shared_ptr< ufc::cell_integral > >
";

%feature("docstring") dolfin::UFC::coefficient_elements "
:rtype: std::vector< FiniteElement >
";

%feature("docstring") dolfin::UFC::coefficients "
:rtype: const std::vector< std::shared_ptr< const GenericFunction > >
";

%feature("docstring") dolfin::UFC::custom_integrals "
:rtype: std::vector< std::shared_ptr< ufc::custom_integral > >
";

%feature("docstring") dolfin::UFC::cutcell_integrals "
:rtype: std::vector< std::shared_ptr< ufc::cutcell_integral > >
";

%feature("docstring") dolfin::UFC::dolfin_form "
The form. 

:rtype: const Form &
";

%feature("docstring") dolfin::UFC::exterior_facet_integrals "
:rtype: std::vector< std::shared_ptr< ufc::exterior_facet_integral > >
";

%feature("docstring") dolfin::UFC::form "
:cpp:any:`Form` . 

:rtype: const ufc::form &
";

%feature("docstring") dolfin::UFC::get_cell_integral(std::size_t domain) "
Get cell integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::cell_integral *
";

%feature("docstring") dolfin::UFC::get_custom_integral(std::size_t domain) "
Get custom integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::custom_integral *
";

%feature("docstring") dolfin::UFC::get_cutcell_integral(std::size_t domain) "
Get cutcell integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::cutcell_integral *
";

%feature("docstring") dolfin::UFC::get_exterior_facet_integral(std::size_t domain) "
Get exterior facet integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::exterior_facet_integral *
";

%feature("docstring") dolfin::UFC::get_interface_integral(std::size_t domain) "
Get interface integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::interface_integral *
";

%feature("docstring") dolfin::UFC::get_interior_facet_integral(std::size_t domain) "
Get interior facet integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::interior_facet_integral *
";

%feature("docstring") dolfin::UFC::get_overlap_integral(std::size_t domain) "
Get overlap integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::overlap_integral *
";

%feature("docstring") dolfin::UFC::get_vertex_integral(std::size_t domain) "
Get point integral over a given domain, falling back to the default if necessary 

:param std\\:\\:size_t domain: 
:rtype: ufc::vertex_integral *
";

%feature("docstring") dolfin::UFC::init(const Form &form) "
Initialise memory. 

:param const Form & form: 
:rtype: void
";

%feature("docstring") dolfin::UFC::interface_integrals "
:rtype: std::vector< std::shared_ptr< ufc::interface_integral > >
";

%feature("docstring") dolfin::UFC::interior_facet_integrals "
:rtype: std::vector< std::shared_ptr< ufc::interior_facet_integral > >
";

%feature("docstring") dolfin::UFC::macro_A "
Local tensor for macro element. 

:rtype: std::vector< double >
";

%feature("docstring") dolfin::UFC::macro_w() const "
Pointer to macro element coefficient data. Used to support :cpp:any:`UFC`  interface. 

:rtype: const double *const  *
";

%feature("docstring") dolfin::UFC::macro_w_pointer "
:rtype: std::vector< double * >
";

%feature("docstring") dolfin::UFC::overlap_integrals "
:rtype: std::vector< std::shared_ptr< ufc::overlap_integral > >
";

%feature("docstring") dolfin::UFC::update(const Cell &cell, const std::vector< double > &coordinate_dofs0, const ufc::cell &ufc_cell) "
Update current cell (TODO: Remove this when :cpp:any:`PointIntegralSolver`  supports the version with enabled_coefficients) 

:param const Cell & cell: 
:param const std\\:\\:vector< double > & coordinate_dofs0: 
:param const ufc\\:\\:cell & ufc_cell: 
:rtype: void
";

%feature("docstring") dolfin::UFC::update(const Cell &cell, const std::vector< double > &coordinate_dofs0, const ufc::cell &ufc_cell, const std::vector< bool > &enabled_coefficients) "
Update current cell. 

:param const Cell & cell: 
:param const std\\:\\:vector< double > & coordinate_dofs0: 
:param const ufc\\:\\:cell & ufc_cell: 
:param const std\\:\\:vector< bool > & enabled_coefficients: 
:rtype: void
";

%feature("docstring") dolfin::UFC::update(const Cell &cell0, const std::vector< double > &coordinate_dofs0, const ufc::cell &ufc_cell0, const Cell &cell1, const std::vector< double > &coordinate_dofs1, const ufc::cell &ufc_cell1) "
Update current pair of cells for macro element (TODO: Remove this when :cpp:any:`PointIntegralSolver`  supports the version with enabled_coefficients) 

:param const Cell & cell0: 
:param const std\\:\\:vector< double > & coordinate_dofs0: 
:param const ufc\\:\\:cell & ufc_cell0: 
:param const Cell & cell1: 
:param const std\\:\\:vector< double > & coordinate_dofs1: 
:param const ufc\\:\\:cell & ufc_cell1: 
:rtype: void
";

%feature("docstring") dolfin::UFC::update(const Cell &cell0, const std::vector< double > &coordinate_dofs0, const ufc::cell &ufc_cell0, const Cell &cell1, const std::vector< double > &coordinate_dofs1, const ufc::cell &ufc_cell1, const std::vector< bool > &enabled_coefficients) "
Update current pair of cells for macro element. 

:param const Cell & cell0: 
:param const std\\:\\:vector< double > & coordinate_dofs0: 
:param const ufc\\:\\:cell & ufc_cell0: 
:param const Cell & cell1: 
:param const std\\:\\:vector< double > & coordinate_dofs1: 
:param const ufc\\:\\:cell & ufc_cell1: 
:param const std\\:\\:vector< bool > & enabled_coefficients: 
:rtype: void
";

%feature("docstring") dolfin::UFC::vertex_integrals "
:rtype: std::vector< std::shared_ptr< ufc::vertex_integral > >
";

%feature("docstring") dolfin::UFC::w() "
Pointer to coefficient data. Used to support :cpp:any:`UFC`  interface. None const version 

:rtype: double **
";

%feature("docstring") dolfin::UFC::w() const "
Pointer to coefficient data. Used to support :cpp:any:`UFC`  interface. 

:rtype: const double *const  *
";

%feature("docstring") dolfin::UFC::w_pointer "
:rtype: std::vector< double * >
";

%feature("docstring") dolfin::UFC::~UFC() "
Destructor.
";

%feature("docstring") dolfin::assemble(GenericTensor &A, const Form &a) "
Assemble tensor. 

:param GenericTensor & A: 
:param const Form & a: 
:rtype: void
";

%feature("docstring") dolfin::assemble(const Form &a) "
Assemble scalar. 

:param const Form & a: 
:rtype: double
";

%feature("docstring") dolfin::assemble_local(const Form &a, const Cell &cell, std::vector< double > &tensor) "
Assemble form to local tensor on a cell. 

:param const Form & a: 
:param const Cell & cell: 
:param std\\:\\:vector< double > & tensor: 
:rtype: void
";

%feature("docstring") dolfin::assemble_multimesh(GenericTensor &A, const MultiMeshForm &a) "
Assemble tensor from multimesh form. 

:param GenericTensor & A: 
:param const MultiMeshForm & a: 
:rtype: void
";

%feature("docstring") dolfin::assemble_multimesh(const MultiMeshForm &a) "
Assemble scalar from multimesh form. 

:param const MultiMeshForm & a: 
:rtype: double
";

%feature("docstring") dolfin::assemble_system(GenericMatrix &A, GenericVector &b, const Form &a, const Form &L, std::vector< std::shared_ptr< const DirichletBC >> bcs) "
Assemble system (A, b) and apply Dirichlet boundary conditions. 

:param GenericMatrix & A: 
:param GenericVector & b: 
:param const Form & a: 
:param const Form & L: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const DirichletBC >> bcs: 
:rtype: void
";

%feature("docstring") dolfin::assemble_system(GenericMatrix &A, GenericVector &b, const Form &a, const Form &L, std::vector< std::shared_ptr< const DirichletBC >> bcs, const GenericVector &x0) "
Assemble system (A, b) on sub domains and apply Dirichlet boundary conditions 

:param GenericMatrix & A: 
:param GenericVector & b: 
:param const Form & a: 
:param const Form & L: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const DirichletBC >> bcs: 
:param const GenericVector & x0: 
:rtype: void
";

%feature("docstring") dolfin::create_mesh(Function &coordinates) "
Creates mesh from coordinate function
Topology is given by underlying mesh of the function space and geometry is given by function values. Hence resulting mesh geometry has a degree of the function space degree. Geometry of function mesh is ignored.
:cpp:any:`Mesh`  connectivities d-0, d-1, ..., d-r are built on function mesh (where d is topological dimension of the mesh and r is maximal dimension of entity associated with any coordinate node). Consider clearing unneeded connectivities when finished.

:param Function & coordinates:  (:cpp:any:`Function` ) :cpp:any:`Vector` :cpp:any:`Lagrange`  function of any degree
:rtype: Mesh
:returns: :cpp:any:`Mesh`  The mesh
";

%feature("docstring") dolfin::dof_to_vertex_map(const FunctionSpace &space) "
Return a map between dof indices and vertex indices
Only works for :cpp:any:`FunctionSpace`  with dofs exclusively on vertices. For mixed FunctionSpaces vertex index is offset with the number of dofs per vertex.
In parallel the returned map maps both owned and unowned dofs (using local indices) thus covering all the vertices. Hence the returned map is an inversion of vertex_to_dof_map.

:param const FunctionSpace & space:  (:cpp:any:`FunctionSpace` ) The :cpp:any:`FunctionSpace`  for what the dof to vertex map should be computed for
:rtype: std::vector< std::size_t >
:returns: std::vector<std::size_t> The dof to vertex map
";

%feature("docstring") dolfin::get_coordinates(Function &position, const MeshGeometry &geometry) "
Stores mesh coordinates into function
:cpp:any:`Mesh`  connectivities d-0, d-1, ..., d-r are built on function mesh (where d is topological dimension of the mesh and r is maximal dimension of entity associated with any coordinate node). Consider clearing unneeded connectivities when finished.

:param Function & position:  (:cpp:any:`Function` ) Vectorial :cpp:any:`Lagrange`  function with matching degree and mesh
:param const MeshGeometry & geometry:  (:cpp:any:`MeshGeometry` ) :cpp:any:`Mesh`  geometry to be stored
:rtype: void
";

%feature("docstring") dolfin::set_coordinates(MeshGeometry &geometry, const Function &position) "
Sets mesh coordinates from function
:cpp:any:`Mesh`  connectivities d-0, d-1, ..., d-r are built on function mesh (where d is topological dimension of the mesh and r is maximal dimension of entity associated with any coordinate node). Consider clearing unneeded connectivities when finished.

:param MeshGeometry & geometry:  (:cpp:any:`MeshGeometry` ) :cpp:any:`Mesh`  geometry to be set
:param const Function & position:  (:cpp:any:`Function` ) Vectorial :cpp:any:`Lagrange`  function with matching degree and mesh
:rtype: void
";

%feature("docstring") dolfin::solve(const Equation &equation, Function &u, Parameters parameters=empty_parameters) "
Solve linear variational problem a(u, v) == L(v) or nonlinear variational problem F(u; v) = 0 without boundary conditions.
Optional parameters can be passed to the :cpp:any:`LinearVariationalSolver`  or :cpp:any:`NonlinearVariationalSolver`  classes. 

:param const Equation & equation: 
:param Function & u: 
:param Parameters parameters: 
:rtype: void
";

%feature("docstring") dolfin::solve(const Equation &equation, Function &u, const DirichletBC &bc, Parameters parameters=empty_parameters) "
Solve linear variational problem a(u, v) == L(v) or nonlinear variational problem F(u; v) = 0 with a single boundary condition.
Optional parameters can be passed to the :cpp:any:`LinearVariationalSolver`  or :cpp:any:`NonlinearVariationalSolver`  classes. 

:param const Equation & equation: 
:param Function & u: 
:param const DirichletBC & bc: 
:param Parameters parameters: 
:rtype: void
";

%feature("docstring") dolfin::solve(const Equation &equation, Function &u, const DirichletBC &bc, const Form &J, Parameters parameters=empty_parameters) "
Solve nonlinear variational problem F(u; v) == 0 with a single boundary condition. The argument J should provide the Jacobian bilinear form J = dF/du.
Optional parameters can be passed to the :cpp:any:`LinearVariationalSolver`  or :cpp:any:`NonlinearVariationalSolver`  classes. 

:param const Equation & equation: 
:param Function & u: 
:param const DirichletBC & bc: 
:param const Form & J: 
:param Parameters parameters: 
:rtype: void
";

%feature("docstring") dolfin::solve(const Equation &equation, Function &u, const Form &J, Parameters parameters=empty_parameters) "
Solve nonlinear variational problem F(u; v) == 0 without boundary conditions. The argument J should provide the Jacobian bilinear form J = dF/du.
Optional parameters can be passed to the :cpp:any:`LinearVariationalSolver`  or :cpp:any:`NonlinearVariationalSolver`  classes. 

:param const Equation & equation: 
:param Function & u: 
:param const Form & J: 
:param Parameters parameters: 
:rtype: void
";

%feature("docstring") dolfin::solve(const Equation &equation, Function &u, std::vector< const DirichletBC *> bcs, Parameters parameters=empty_parameters) "
Solve linear variational problem a(u, v) == L(v) or nonlinear variational problem F(u; v) = 0 with a list of boundary conditions.
Optional parameters can be passed to the :cpp:any:`LinearVariationalSolver`  or :cpp:any:`NonlinearVariationalSolver`  classes. 

:param const Equation & equation: 
:param Function & u: 
:param std\\:\\:vector< const DirichletBC *> bcs: 
:param Parameters parameters: 
:rtype: void
";

%feature("docstring") dolfin::solve(const Equation &equation, Function &u, std::vector< const DirichletBC *> bcs, const Form &J, Parameters parameters=empty_parameters) "
Solve nonlinear variational problem F(u; v) == 0 with a list of boundary conditions. The argument J should provide the Jacobian bilinear form J = dF/du.
Optional parameters can be passed to the :cpp:any:`LinearVariationalSolver`  or :cpp:any:`NonlinearVariationalSolver`  classes. 

:param const Equation & equation: 
:param Function & u: 
:param std\\:\\:vector< const DirichletBC *> bcs: 
:param const Form & J: 
:param Parameters parameters: 
:rtype: void
";

%feature("docstring") dolfin::vertex_to_dof_map(const FunctionSpace &space) "
Return a map between vertex indices and dof indices
Only works for :cpp:any:`FunctionSpace`  with dofs exclusively on vertices. For mixed FunctionSpaces dof index is offset with the number of dofs per vertex.

:param const FunctionSpace & space:  (:cpp:any:`FunctionSpace` ) The :cpp:any:`FunctionSpace`  for what the vertex to dof map should be computed for
:rtype: std::vector< dolfin::la_index >
:returns: std::vector<dolfin::la_index> The vertex to dof map
";

%feature("docstring") dolfin::TensorProductForm "
FIXME: Temporary fix. 

:rtype: Form
";

