// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::BoostGraphColoring "
This class colors a graph using the Boost Graph Library.
";

%feature("docstring") dolfin::BoostGraphColoring::compute_local_vertex_coloring(const Graph &graph, std::vector< ColorType > &colors) "
Compute vertex colors. 

:param const Graph & graph: 
:param std\\:\\:vector< ColorType > & colors: 
:rtype: std::size_t
";

%feature("docstring") dolfin::BoostGraphColoring::compute_local_vertex_coloring(const T &graph, std::vector< ColorType > &colors) "
Compute vertex colors. 

:param const T & graph: 
:param std\\:\\:vector< ColorType > & colors: 
:rtype: std::size_t
";

%feature("docstring") dolfin::BoostGraphOrdering "
This class computes graph re-orderings. It uses Boost Graph.
";

%feature("docstring") dolfin::BoostGraphOrdering::build_csr_directed_graph(const X &graph) "
:param const X & graph: 
:rtype: T
";

%feature("docstring") dolfin::BoostGraphOrdering::build_directed_graph(const X &graph) "
:param const X & graph: 
:rtype: T
";

%feature("docstring") dolfin::BoostGraphOrdering::build_undirected_graph(const X &graph) "
:param const X & graph: 
:rtype: T
";

%feature("docstring") dolfin::BoostGraphOrdering::compute_cuthill_mckee(const Graph &graph, bool reverse=false) "
Compute re-ordering (map[old] -> new) using Cuthill-McKee algorithm 

:param const Graph & graph: 
:param bool reverse: 
:rtype: std::vector< int >
";

%feature("docstring") dolfin::BoostGraphOrdering::compute_cuthill_mckee(const std::set< std::pair< std::size_t, std::size_t >> &edges, std::size_t size, bool reverse=false) "
Compute re-ordering (map[old] -> new) using Cuthill-McKee algorithm 

:param const std\\:\\:set< std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t >> & edges: 
:param std\\:\\:size_t size: 
:param bool reverse: 
:rtype: std::vector< int >
";

%feature("docstring") dolfin::CSRGraph "
Compressed Sparse Row graph. 
This class provides a Compressed Sparse Row Graph defined by a vector containing edges for each node and a vector of offsets into the edge vector for each node
In parallel, all nodes must be numbered from zero on process zero continuously through increasing rank processes. Edges must be defined in terms of the global node numbers. The global node offset of each process is given by :cpp:any:`node_distribution()` 
The format of the nodes, edges and distribution is identical with the formats for :cpp:any:`ParMETIS`  and PT-SCOTCH. See the manuals for these libraries for further information.
";

%feature("docstring") dolfin::CSRGraph::CSRGraph() "
Empty CSR Graph.
";

%feature("docstring") dolfin::CSRGraph::CSRGraph(MPI_Comm mpi_comm, const T *xadj, const T *adjncy, std::size_t n) "
Create a CSR Graph from :cpp:any:`ParMETIS`  style adjacency lists. 

:param MPI_Comm mpi_comm: 
:param const T * xadj: 
:param const T * adjncy: 
:param std\\:\\:size_t n:
";

%feature("docstring") dolfin::CSRGraph::CSRGraph(MPI_Comm mpi_comm, const std::vector< X > &graph) "
Create a CSR Graph from a collection of edges (X is a container some type, e.g. std::vector<unsigned int> or std::set<std::size_t> 

:param MPI_Comm mpi_comm: 
:param const std\\:\\:vector< X > & graph:
";

%feature("docstring") dolfin::CSRGraph::calculate_node_distribution() "
:rtype: void
";

%feature("docstring") dolfin::CSRGraph::edges() "
:cpp:any:`Vector`  containing all edges for all local nodes (non-const) (\"adjncy\" in :cpp:any:`ParMETIS` ) 

:rtype: std::vector< T > &
";

%feature("docstring") dolfin::CSRGraph::edges() const "
:cpp:any:`Vector`  containing all edges for all local nodes (\"adjncy\" in :cpp:any:`ParMETIS` ) 

:rtype: const std::vector< T > &
";

%feature("docstring") dolfin::CSRGraph::node_distribution() "
Return number of nodes (offset) on each process (non-const) 

:rtype: std::vector< T > &
";

%feature("docstring") dolfin::CSRGraph::node_distribution() const "
Return number of nodes (offset) on each process. 

:rtype: const std::vector< T > &
";

%feature("docstring") dolfin::CSRGraph::nodes() "
:cpp:any:`Vector`  containing index offsets into edges for all local nodes (plus extra entry marking end) (\"xadj\" in :cpp:any:`ParMETIS` ) 

:rtype: std::vector< T > &
";

%feature("docstring") dolfin::CSRGraph::nodes() const "
:cpp:any:`Vector`  containing index offsets into edges for all local nodes (plus extra entry marking end) (\"xadj\" in :cpp:any:`ParMETIS` ) 

:rtype: const std::vector< T > &
";

%feature("docstring") dolfin::CSRGraph::num_edges() const "
Number of local edges in graph. 

:rtype: std::size_t
";

%feature("docstring") dolfin::CSRGraph::num_edges(std::size_t i) const "
Number of edges from node i. 

:param std\\:\\:size_t i: 
:rtype: std::size_t
";

%feature("docstring") dolfin::CSRGraph::operator[](std::size_t i) const "
Return :cpp:any:`CSRGraph::node`  object which provides :cpp:any:`begin()`  and :cpp:any:`end()`  iterators, also :cpp:any:`size()` , and random-access for the edges of node i. 

:param std\\:\\:size_t i: 
:rtype: const node
";

%feature("docstring") dolfin::CSRGraph::size() const "
Number of local nodes in graph. 

:rtype: std::size_t
";

%feature("docstring") dolfin::CSRGraph::size_global() const "
Total (global) number of nodes in parallel graph. 

:rtype: T
";

%feature("docstring") dolfin::CSRGraph::~CSRGraph() "
Destructor.
";

%feature("docstring") dolfin::CSRGraph::node "
Access edges individually by using operator()[] to get a node object
";

%feature("docstring") dolfin::CSRGraph::node::begin() const "
Iterator pointing to beginning of edges. 

:rtype: std::vector< T >::const_iterator
";

%feature("docstring") dolfin::CSRGraph::node::begin_edge "
:rtype: std::vector< T >::const_iterator
";

%feature("docstring") dolfin::CSRGraph::node::end() const "
Iterator pointing to beyond end of edges. 

:rtype: std::vector< T >::const_iterator
";

%feature("docstring") dolfin::CSRGraph::node::end_edge "
:rtype: std::vector< T >::const_iterator
";

%feature("docstring") dolfin::CSRGraph::node::node(const typename std::vector< T >::const_iterator &begin_it, const typename std::vector< T >::const_iterator &end_it) "
Node object, listing a set of outgoing edges. 

:param const typename std\\:\\:vector< T >\\:\\:const_iterator & begin_it: 
:param const typename std\\:\\:vector< T >\\:\\:const_iterator & end_it:
";

%feature("docstring") dolfin::CSRGraph::node::operator[](std::size_t i) const "
Access outgoing edge i of this node. 

:param std\\:\\:size_t i: 
:rtype: const T &
";

%feature("docstring") dolfin::CSRGraph::node::size() const "
Number of outgoing edges for this node. 

:rtype: std::size_t
";

%feature("docstring") dolfin::GraphBuilder "
This class builds a Graph corresponding to various objects. 

Friends: :cpp:any:`MeshPartitioning`.
";

%feature("docstring") dolfin::GraphBuilder::FacetCellMap "
:rtype: std::vector< std::pair< std::vector< std::size_t >, std::int32_t > >
";

%feature("docstring") dolfin::GraphBuilder::compute_dual_graph(const MPI_Comm mpi_comm, const boost::multi_array< std::int64_t, 2 > &cell_vertices, const CellType &cell_type, const std::int64_t num_global_vertices, std::vector< std::vector< std::size_t >> &local_graph, std::set< std::int64_t > &ghost_vertices) "
Build distributed dual graph (cell-cell connections) from minimal mesh data, and return (num local edges, num non-local edges) 

:param const MPI_Comm mpi_comm: 
:param const boost\\:\\:multi_array< std\\:\\:int64_t, 2 > & cell_vertices: 
:param const CellType & cell_type: 
:param const std\\:\\:int64_t num_global_vertices: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & local_graph: 
:param std\\:\\:set< std\\:\\:int64_t > & ghost_vertices: 
:rtype: std::pair< std::int32_t, std::int32_t >
";

%feature("docstring") dolfin::GraphBuilder::compute_local_dual_graph(const MPI_Comm mpi_comm, const boost::multi_array< std::int64_t, 2 > &cell_vertices, const CellType &cell_type, std::vector< std::vector< std::size_t >> &local_graph, FacetCellMap &facet_cell_map) "
:param const MPI_Comm mpi_comm: 
:param const boost\\:\\:multi_array< std\\:\\:int64_t, 2 > & cell_vertices: 
:param const CellType & cell_type: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & local_graph: 
:param FacetCellMap & facet_cell_map: 
:rtype: std::int32_t
";

%feature("docstring") dolfin::GraphBuilder::compute_local_dual_graph_keyed(const MPI_Comm mpi_comm, const boost::multi_array< std::int64_t, 2 > &cell_vertices, const CellType &cell_type, std::vector< std::vector< std::size_t >> &local_graph, FacetCellMap &facet_cell_map) "
:param const MPI_Comm mpi_comm: 
:param const boost\\:\\:multi_array< std\\:\\:int64_t, 2 > & cell_vertices: 
:param const CellType & cell_type: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & local_graph: 
:param FacetCellMap & facet_cell_map: 
:rtype: std::int32_t
";

%feature("docstring") dolfin::GraphBuilder::compute_nonlocal_dual_graph(const MPI_Comm mpi_comm, const boost::multi_array< std::int64_t, 2 > &cell_vertices, const CellType &cell_type, const std::int64_t num_global_vertices, std::vector< std::vector< std::size_t >> &local_graph, FacetCellMap &facet_cell_map, std::set< std::int64_t > &ghost_vertices) "
:param const MPI_Comm mpi_comm: 
:param const boost\\:\\:multi_array< std\\:\\:int64_t, 2 > & cell_vertices: 
:param const CellType & cell_type: 
:param const std\\:\\:int64_t num_global_vertices: 
:param std\\:\\:vector< std\\:\\:vector< std\\:\\:size_t >> & local_graph: 
:param FacetCellMap & facet_cell_map: 
:param std\\:\\:set< std\\:\\:int64_t > & ghost_vertices: 
:rtype: std::int32_t
";

%feature("docstring") dolfin::GraphBuilder::local_graph(const Mesh &mesh, const GenericDofMap &dofmap0, const GenericDofMap &dofmap1) "
Build local graph from dofmap. 

:param const Mesh & mesh: 
:param const GenericDofMap & dofmap0: 
:param const GenericDofMap & dofmap1: 
:rtype: Graph
";

%feature("docstring") dolfin::GraphBuilder::local_graph(const Mesh &mesh, const std::vector< std::size_t > &coloring_type) "
Build local graph from mesh (general version) 

:param const Mesh & mesh: 
:param const std\\:\\:vector< std\\:\\:size_t > & coloring_type: 
:rtype: Graph
";

%feature("docstring") dolfin::GraphBuilder::local_graph(const Mesh &mesh, std::size_t dim0, std::size_t dim1) "
Build local graph (specialized version) 

:param const Mesh & mesh: 
:param std\\:\\:size_t dim0: 
:param std\\:\\:size_t dim1: 
:rtype: Graph
";

%feature("docstring") dolfin::GraphColoring "
This class provides a common interface to graph coloring libraries.
";

%feature("docstring") dolfin::GraphColoring::compute_local_vertex_coloring(const Graph &graph, std::vector< std::size_t > &colors) "
Compute vertex colors. 

:param const Graph & graph: 
:param std\\:\\:vector< std\\:\\:size_t > & colors: 
:rtype: std::size_t
";

%feature("docstring") dolfin::ParMETIS "
This class provides an interface to :cpp:any:`ParMETIS` .
";

%feature("docstring") dolfin::ParMETIS::adaptive_repartition(MPI_Comm mpi_comm, CSRGraph< T > &csr_graph, std::vector< int > &cell_partition) "
:param MPI_Comm mpi_comm: 
:param CSRGraph< T > & csr_graph: 
:param std\\:\\:vector< int > & cell_partition: 
:rtype: void
";

%feature("docstring") dolfin::ParMETIS::compute_partition(const MPI_Comm mpi_comm, std::vector< int > &cell_partition, std::map< std::int64_t, std::vector< int >> &ghost_procs, const boost::multi_array< std::int64_t, 2 > &cell_vertices, const std::size_t num_global_vertices, const CellType &cell_type, const std::string mode="partition") "
Compute cell partition from local mesh data. The output vector cell_partition contains the desired destination process numbers for each cell. Cells shared on multiple processes have an entry in ghost_procs pointing to the set of sharing process numbers. The mode argument determines which :cpp:any:`ParMETIS`  function is called. It can be one of \"partition\", \"adaptive_repartition\" or \"refine\". For meshes that have already been partitioned or are already well partitioned, it can be advantageous to use \"adaptive_repartition\" or \"refine\". 

:param const MPI_Comm mpi_comm: 
:param std\\:\\:vector< int > & cell_partition: 
:param std\\:\\:map< std\\:\\:int64_t, std\\:\\:vector< int >> & ghost_procs: 
:param const boost\\:\\:multi_array< std\\:\\:int64_t, 2 > & cell_vertices: 
:param const std\\:\\:size_t num_global_vertices: 
:param const CellType & cell_type: 
:param const std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::ParMETIS::partition(MPI_Comm mpi_comm, CSRGraph< T > &csr_graph, std::vector< int > &cell_partition, std::map< std::int64_t, std::vector< int >> &ghost_procs) "
:param MPI_Comm mpi_comm: 
:param CSRGraph< T > & csr_graph: 
:param std\\:\\:vector< int > & cell_partition: 
:param std\\:\\:map< std\\:\\:int64_t, std\\:\\:vector< int >> & ghost_procs: 
:rtype: void
";

%feature("docstring") dolfin::ParMETIS::refine(MPI_Comm mpi_comm, CSRGraph< T > &csr_graph, std::vector< int > &cell_partition) "
:param MPI_Comm mpi_comm: 
:param CSRGraph< T > & csr_graph: 
:param std\\:\\:vector< int > & cell_partition: 
:rtype: void
";

%feature("docstring") dolfin::SCOTCH "
This class provides an interface to SCOTCH-PT (parallel version)
";

%feature("docstring") dolfin::SCOTCH::compute_gps(const Graph &graph, std::size_t num_passes=5) "
Compute reordering (map[old] -> new) using Gibbs-Poole-Stockmeyer (GPS) re-ordering 

:param const Graph & graph:  (Graph) Input graph
:param std\\:\\:size_t num_passes:  (std::size_t) Number of passes to use in GPS algorithm
:rtype: std::vector< int >
:returns: std::vector<int> Mapping from old to new nodes
";

%feature("docstring") dolfin::SCOTCH::compute_partition(const MPI_Comm mpi_comm, std::vector< int > &cell_partition, std::map< std::int64_t, std::vector< int >> &ghost_procs, const boost::multi_array< std::int64_t, 2 > &cell_vertices, const std::vector< std::size_t > &cell_weight, const std::int64_t num_global_vertices, const std::int64_t num_global_cells, const CellType &cell_type) "
Compute cell partition from local mesh data. The vector cell_partition contains the desired destination process numbers for each cell. Cells shared on multiple processes have an entry in ghost_procs pointing to the set of sharing process numbers. 

:param const MPI_Comm mpi_comm:  (MPI_Comm)
:param std\\:\\:vector< int > & cell_partition:  (std::vector<int>)
:param std\\:\\:map< std\\:\\:int64_t, std\\:\\:vector< int >> & ghost_procs:  (std::map<std::int64_t, std::vector<int>>)
:param const boost\\:\\:multi_array< std\\:\\:int64_t, 2 > & cell_vertices:  (const boost::multi_array<std::int64_t, 2>)
:param const std\\:\\:vector< std\\:\\:size_t > & cell_weight:  (const std::vector<std::size_t>)
:param const std\\:\\:int64_t num_global_vertices:  (const std::int64_t)
:param const std\\:\\:int64_t num_global_cells:  (const std::int64_t)
:param const CellType & cell_type:  (const :cpp:any:`CellType` )
:rtype: void
";

%feature("docstring") dolfin::SCOTCH::compute_reordering(const Graph &graph, std::string scotch_strategy="") "
Compute graph re-ordering 

:param const Graph & graph:  (Graph) Input graph
:param std\\:\\:string scotch_strategy:  (string) :cpp:any:`SCOTCH`  parameters
:rtype: std::vector< int >
:returns: std::vector<int> Mapping from old to new nodes
";

%feature("docstring") dolfin::SCOTCH::compute_reordering(const Graph &graph, std::vector< int > &permutation, std::vector< int > &inverse_permutation, std::string scotch_strategy="") "
Compute graph re-ordering 

:param const Graph & graph:  (Graph)
:param std\\:\\:vector< int > & permutation:  (std::vector<int>)
:param std\\:\\:vector< int > & inverse_permutation:  (std::vector<int>)
:param std\\:\\:string scotch_strategy:  (std::string)
:rtype: void
";

%feature("docstring") dolfin::SCOTCH::partition(const MPI_Comm mpi_comm, CSRGraph< T > &local_graph, const std::vector< std::size_t > &node_weights, const std::set< std::int64_t > &ghost_vertices, const std::size_t num_global_vertices, std::vector< int > &cell_partition, std::map< std::int64_t, std::vector< int >> &ghost_procs) "
:param const MPI_Comm mpi_comm: 
:param CSRGraph< T > & local_graph: 
:param const std\\:\\:vector< std\\:\\:size_t > & node_weights: 
:param const std\\:\\:set< std\\:\\:int64_t > & ghost_vertices: 
:param const std\\:\\:size_t num_global_vertices: 
:param std\\:\\:vector< int > & cell_partition: 
:param std\\:\\:map< std\\:\\:int64_t, std\\:\\:vector< int >> & ghost_procs: 
:rtype: void
";

%feature("docstring") dolfin::ZoltanInterface "
This class colors a graph using Zoltan (part of Trilinos). It is designed to work on a single process.
";

%feature("docstring") dolfin::ZoltanInterface::compute_local_vertex_coloring(const Graph &graph, std::vector< std::size_t > &colors) "
Compute vertex colors. 

:param const Graph & graph: 
:param std\\:\\:vector< std\\:\\:size_t > & colors: 
:rtype: std::size_t
";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface "

";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface::ZoltanGraphInterface(const Graph &graph) "
Constructor. 

:param const Graph & graph:
";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface::get_all_edges(void *data, int num_gid_entries, int num_lid_entries, int num_obj, ZOLTAN_ID_PTR global_ids, ZOLTAN_ID_PTR local_ids, int *num_edges, ZOLTAN_ID_PTR nbor_global_id, int *nbor_procs, int wgt_dim, float *ewgts, int *ierr) "
:param void * data: 
:param int num_gid_entries: 
:param int num_lid_entries: 
:param int num_obj: 
:param ZOLTAN_ID_PTR global_ids: 
:param ZOLTAN_ID_PTR local_ids: 
:param int * num_edges: 
:param ZOLTAN_ID_PTR nbor_global_id: 
:param int * nbor_procs: 
:param int wgt_dim: 
:param float * ewgts: 
:param int * ierr: 
:rtype: void
";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface::get_number_edges(void *data, int num_gid_entries, int num_lid_entries, int num_obj, ZOLTAN_ID_PTR global_ids, ZOLTAN_ID_PTR local_ids, int *num_edges, int *ierr) "
:param void * data: 
:param int num_gid_entries: 
:param int num_lid_entries: 
:param int num_obj: 
:param ZOLTAN_ID_PTR global_ids: 
:param ZOLTAN_ID_PTR local_ids: 
:param int * num_edges: 
:param int * ierr: 
:rtype: void
";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface::get_number_of_objects(void *data, int *ierr) "
:param void * data: 
:param int * ierr: 
:rtype: int
";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface::get_object_list(void *data, int sizeGID, int sizeLID, ZOLTAN_ID_PTR globalID, ZOLTAN_ID_PTR localID, int wgt_dim, float *obj_wgts, int *ierr) "
:param void * data: 
:param int sizeGID: 
:param int sizeLID: 
:param ZOLTAN_ID_PTR globalID: 
:param ZOLTAN_ID_PTR localID: 
:param int wgt_dim: 
:param float * obj_wgts: 
:param int * ierr: 
:rtype: void
";

%feature("docstring") dolfin::ZoltanInterface::ZoltanGraphInterface::num_vertex_edges(unsigned int *num_edges) const "
Number of edges from each vertex. 

:param unsigned int * num_edges: 
:rtype: void
";

%feature("docstring") dolfin::Graph "
:cpp:any:`Vector`  of unordered Sets. 

:rtype: std::vector< graph_set_type >
";

%feature("docstring") dolfin::graph_set_type "
Typedefs for simple graph data structures. 
DOLFIN container for graphs 

:rtype: dolfin::Set< int >
";

