// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::Event "
A event is a string message which is displayed only a limited number of times.

::
   
   Event event(\"System is stiff, damping is needed.\");
   while ()
   {
   ...
   if ( ... )
   {
   event();
   ...
   }
   }
";

%feature("docstring") dolfin::Event::Event(const std::string msg, unsigned int maxcount=1) "
Constructor. 

:param const std\\:\\:string msg: 
:param unsigned int maxcount:
";

%feature("docstring") dolfin::Event::count() const "
Display count. 

:rtype: unsigned int
";

%feature("docstring") dolfin::Event::maxcount() const "
Maximum display count. 

:rtype: unsigned int
";

%feature("docstring") dolfin::Event::operator()() "
Display message. 

:rtype: void
";

%feature("docstring") dolfin::Event::~Event() "
Destructor.
";

%feature("docstring") dolfin::LogManager "
:cpp:any:`Logger`  initialisation.
";

%feature("docstring") dolfin::LogManager::logger() "
Singleton instance of logger. 

:rtype: Logger &
";

%feature("docstring") dolfin::LogStream "
This class provides functionality similar to standard C++ streams (std::cout, std::endl) for output but working through the DOLFIN log system.
";

%feature("docstring") dolfin::LogStream::LogStream(Type type) "
Create log stream of given type. 

:param Type type:
";

%feature("docstring") dolfin::LogStream::Type "
Stream types. 

.. cpp:enumerator:: dolfin::LogStream::Type::COUT 

.. cpp:enumerator:: dolfin::LogStream::Type::ENDL
";

%feature("docstring") dolfin::LogStream::buffer "
:rtype: std::stringstream
";

%feature("docstring") dolfin::LogStream::operator<<(const LogStream &stream) "
Output for log stream. 

:param const LogStream & stream: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(const MeshEntity &entity) "
Output for mesh entity (not subclass of :cpp:any:`Variable`  for efficiency) 

:param const MeshEntity & entity: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(const Point &point) "
Output for point (not subclass of :cpp:any:`Variable`  for efficiency) 

:param const Point & point: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(const Variable &variable) "
Output for variable (calling str() method) 

:param const Variable & variable: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(const std::string &s) "
Output for string. 

:param const std\\:\\:string & s: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(double a) "
Output for double. 

:param double a: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(int a) "
Output for int. 

:param int a: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(long int a) "
Output for long int. 

:param long int a: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(long unsigned int a) "
Output for long int. 

:param long unsigned int a: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(std::complex< double > z) "
Output for std::complex<double> 

:param std\\:\\:complex< double > z: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::operator<<(unsigned int a) "
Output for unsigned int. 

:param unsigned int a: 
:rtype: LogStream &
";

%feature("docstring") dolfin::LogStream::setprecision(std::streamsize n) "
:cpp:any:`Set`  precision. 

:param std\\:\\:streamsize n: 
:rtype: void
";

%feature("docstring") dolfin::LogStream::~LogStream() "
Destructor.
";

%feature("docstring") dolfin::Logger "
Handling of error messages, logging and informational display.
";

%feature("docstring") dolfin::Logger::Logger() "
Constructor.
";

%feature("docstring") dolfin::Logger::begin(std::string msg, int log_level=INFO) "
Begin task (increase indentation level) 

:param std\\:\\:string msg: 
:param int log_level: 
:rtype: void
";

%feature("docstring") dolfin::Logger::deprecation(std::string feature, std::string version_deprecated, std::string message) const "
Issue deprecation warning for removed feature. 

:param std\\:\\:string feature: 
:param std\\:\\:string version_deprecated: 
:param std\\:\\:string message: 
:rtype: void
";

%feature("docstring") dolfin::Logger::dolfin_error(std::string location, std::string task, std::string reason, int mpi_rank=-1) const "
Print error message, prefer this to the above generic error message. 

:param std\\:\\:string location: 
:param std\\:\\:string task: 
:param std\\:\\:string reason: 
:param int mpi_rank: 
:rtype: void
";

%feature("docstring") dolfin::Logger::dump_timings_to_xml(std::string filename, TimingClear clear) "
Dump a summary of timings and tasks to XML file, optionally clearing stored timings. ``MPI_MAX`` , ``MPI_MIN``  and ``MPI_AVG``  reductions are stored. Collective on ``:cpp:any:`Logger::mpi_comm()` `` . 

:param std\\:\\:string filename: 
:param TimingClear clear: 
:rtype: void
";

%feature("docstring") dolfin::Logger::end() "
End task (decrease indentation level) 

:rtype: void
";

%feature("docstring") dolfin::Logger::error(std::string msg) const "
Print error message and throw exception. 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::Logger::get_log_level() const "
Get log level. 

:rtype: int
";

%feature("docstring") dolfin::Logger::get_output_stream() "
Get output stream. 

:rtype: std::ostream &
";

%feature("docstring") dolfin::Logger::indentation_level "
:rtype: int
";

%feature("docstring") dolfin::Logger::is_active() "
Return true iff logging is active. 

:rtype: bool
";

%feature("docstring") dolfin::Logger::list_timings(TimingClear clear, std::set< TimingType > type) "
List a summary of timings and tasks, optionally clearing stored timings. ``MPI_AVG``  reduction is printed. Collective on ``:cpp:any:`Logger::mpi_comm()` `` . 

:param TimingClear clear: 
:param std\\:\\:set< TimingType > type: 
:rtype: void
";

%feature("docstring") dolfin::Logger::log(std::string msg, int log_level=INFO) const "
Print message. 

:param std\\:\\:string msg: 
:param int log_level: 
:rtype: void
";

%feature("docstring") dolfin::Logger::log_underline(std::string msg, int log_level=INFO) const "
Print underlined message. 

:param std\\:\\:string msg: 
:param int log_level: 
:rtype: void
";

%feature("docstring") dolfin::Logger::logstream "
:rtype: std::ostream *
";

%feature("docstring") dolfin::Logger::monitor_memory_usage() "
Monitor memory usage. Call this function at the start of a program to continuously monitor the memory usage of the process. 

:rtype: void
";

%feature("docstring") dolfin::Logger::mpi_comm() "
Return :cpp:any:`MPI`  Communicator of :cpp:any:`Logger` . 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::Logger::progress(std::string title, double p) const "
Draw progress bar. 

:param std\\:\\:string title: 
:param double p: 
:rtype: void
";

%feature("docstring") dolfin::Logger::register_timing(std::string task, std::tuple< double, double, double > elapsed) "
Register timing (for later summary) 

:param std\\:\\:string task: 
:param std\\:\\:tuple< double, double, double > elapsed: 
:rtype: void
";

%feature("docstring") dolfin::Logger::set_log_active(bool active) "
Turn logging on or off. 

:param bool active: 
:rtype: void
";

%feature("docstring") dolfin::Logger::set_log_level(int log_level) "
:cpp:any:`Set`  log level. 

:param int log_level: 
:rtype: void
";

%feature("docstring") dolfin::Logger::set_output_stream(std::ostream &stream) "
:cpp:any:`Set`  output stream. 

:param std\\:\\:ostream & stream: 
:rtype: void
";

%feature("docstring") dolfin::Logger::timing(std::string task, TimingClear clear) "
Return timing (count, total wall time, total user time, total system time) for given task, optionally clearing all timings for the task 

:param std\\:\\:string task: 
:param TimingClear clear: 
:rtype: std::tuple< std::size_t, double, double, double >
";

%feature("docstring") dolfin::Logger::timings(TimingClear clear, std::set< TimingType > type) "
Return a summary of timings and tasks in a :cpp:any:`Table` , optionally clearing stored timings 

:param TimingClear clear: 
:param std\\:\\:set< TimingType > type: 
:rtype: Table
";

%feature("docstring") dolfin::Logger::warning(std::string msg) const "
Print warning. 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::Logger::write(int log_level, std::string msg) const "
:param int log_level: 
:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::Logger::~Logger() "
Destructor.
";

%feature("docstring") dolfin::Progress "
This class provides a simple way to create and update progress bars during a computation. 

::
   
   A progress bar may be used either in an iteration with a known number
   of steps:
   
::
   
   Progress p(\"Iterating...\", n);
   for (int i = 0; i < n; i++)
   {
   ...
   p++;
   }

::
   
   or in an iteration with an unknown number of steps:
   
::
   
   Progress p(\"Iterating...\");
   while (t < T)
   {
   ...
   p = t / T;
   }
";

%feature("docstring") dolfin::Progress::Progress(std::string title) "
Create progress bar with an unknown number of steps

:param std\\:\\:string title:  (std::string) The title.
";

%feature("docstring") dolfin::Progress::Progress(std::string title, unsigned int n) "
Create progress bar with a known number of steps

:param std\\:\\:string title:  (std::string) The title.
:param unsigned int n:  (unsigned int) Number of steps.
";

%feature("docstring") dolfin::Progress::always "
:rtype: bool
";

%feature("docstring") dolfin::Progress::c_step "
:rtype: std::size_t
";

%feature("docstring") dolfin::Progress::counter "
:rtype: std::size_t
";

%feature("docstring") dolfin::Progress::displayed "
:rtype: bool
";

%feature("docstring") dolfin::Progress::finished "
:rtype: bool
";

%feature("docstring") dolfin::Progress::i "
:rtype: std::size_t
";

%feature("docstring") dolfin::Progress::operator++(int) "
Increment progress. 

:rtype: void
";

%feature("docstring") dolfin::Progress::operator=(double p) "
:cpp:any:`Set`  current position

:param double p:  (double) The position.
:rtype: void
";

%feature("docstring") dolfin::Progress::t_step "
:rtype: double
";

%feature("docstring") dolfin::Progress::tc "
:rtype: double
";

%feature("docstring") dolfin::Progress::update(double p) "
:param double p: 
:rtype: void
";

%feature("docstring") dolfin::Progress::~Progress() "
Destructor.
";

%feature("docstring") dolfin::Table "
This class provides storage and pretty-printing for tables. Example usage:
:cpp:any:`Table`  table(\"Timings\");
table(\"Eigen\", \"Assemble\") = 0.010; table(\"Eigen\", \"Solve\") = 0.020; table(\"PETSc\", \"Assemble\") = 0.011; table(\"PETSc\", \"Solve\") = 0.019; table(\"Tpetra\", \"Assemble\") = 0.012; table(\"Tpetra\", \"Solve\") = 0.018;
info(table); 

Friends: :cpp:any:`MPI`, :cpp:any:`XMLTable`.
";

%feature("docstring") dolfin::Table::Table(std::string title="", bool right_justify=true) "
Create empty table. 

:param std\\:\\:string title: 
:param bool right_justify:
";

%feature("docstring") dolfin::Table::col_set "
:rtype: std::set< std::string >
";

%feature("docstring") dolfin::Table::cols "
:rtype: std::vector< std::string >
";

%feature("docstring") dolfin::Table::dvalues "
:rtype: std::map< std::pair< std::string, std::string >, double >
";

%feature("docstring") dolfin::Table::get(std::string row, std::string col) const "
Get value of table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:rtype: std::string
";

%feature("docstring") dolfin::Table::get_value(std::string row, std::string col) const "
Get value of table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:rtype: double
";

%feature("docstring") dolfin::Table::operator()(std::string row, std::string col) "
Return table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:rtype: TableEntry
";

%feature("docstring") dolfin::Table::operator=(const Table &table) "
Assignment operator. 

:param const Table & table: 
:rtype: const Table &
";

%feature("docstring") dolfin::Table::row_set "
:rtype: std::set< std::string >
";

%feature("docstring") dolfin::Table::rows "
:rtype: std::vector< std::string >
";

%feature("docstring") dolfin::Table::set(std::string row, std::string col, double value) "
:cpp:any:`Set`  value of table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:param double value: 
:rtype: void
";

%feature("docstring") dolfin::Table::set(std::string row, std::string col, int value) "
:cpp:any:`Set`  value of table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:param int value: 
:rtype: void
";

%feature("docstring") dolfin::Table::set(std::string row, std::string col, std::size_t value) "
:cpp:any:`Set`  value of table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:param std\\:\\:size_t value: 
:rtype: void
";

%feature("docstring") dolfin::Table::set(std::string row, std::string col, std::string value) "
:cpp:any:`Set`  value of table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:param std\\:\\:string value: 
:rtype: void
";

%feature("docstring") dolfin::Table::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Table::str_latex() const "
Return informal string representation for LaTeX. 

:rtype: std::string
";

%feature("docstring") dolfin::Table::values "
:rtype: std::map< std::pair< std::string, std::string >, std::string >
";

%feature("docstring") dolfin::Table::~Table() "
Destructor.
";

%feature("docstring") dolfin::TableEntry "
This class represents an entry in a :cpp:any:`Table` .
";

%feature("docstring") dolfin::TableEntry::TableEntry(std::string row, std::string col, Table &table) "
Create table entry. 

:param std\\:\\:string row: 
:param std\\:\\:string col: 
:param Table & table:
";

%feature("docstring") dolfin::TableEntry::operator std::string() const "
Cast to entry value.
";

%feature("docstring") dolfin::TableEntry::operator=(double value) "
Assign value to table entry. 

:param double value: 
:rtype: const TableEntry &
";

%feature("docstring") dolfin::TableEntry::operator=(int value) "
Assign value to table entry. 

:param int value: 
:rtype: const TableEntry &
";

%feature("docstring") dolfin::TableEntry::operator=(std::size_t value) "
Assign value to table entry. 

:param std\\:\\:size_t value: 
:rtype: const TableEntry &
";

%feature("docstring") dolfin::TableEntry::operator=(std::string value) "
Assign value to table entry. 

:param std\\:\\:string value: 
:rtype: const TableEntry &
";

%feature("docstring") dolfin::TableEntry::~TableEntry() "
Destructor.
";

%feature("docstring") dolfin::begin(int debug_level, std::string msg,...) "
Begin task (increase indentation level) 

:param int debug_level: 
:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::begin(std::string msg,...) "
Begin task (increase indentation level) 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::deprecation(std::string feature, std::string version_deprecated, std::string message,...) "
Issue deprecation warning for removed feature
Arguments feature (std::string) Name of the feature that has been removed. version_deprecated (std::string) Version number of the release in which the feature is deprecated. message (std::string) A format string explaining the deprecation. 

:param std\\:\\:string feature: 
:param std\\:\\:string version_deprecated: 
:param std\\:\\:string message: 
:rtype: void
";

%feature("docstring") dolfin::dolfin_error(std::string location, std::string task, std::string reason,...) "
Print error message. Prefer this to the above generic error message.
Arguments location (std::string) Name of the file from which the error message was generated. task (std::string) Name of the task that failed. Note that this string should begin with lowercase. Note that this string should not be punctuated. reason (std::string) A format string explaining the reason for the failure. Note that this string should begin with uppercase. Note that this string should not be punctuated. Note that this string may contain printf style formatting. ... (primitive types like int, std::size_t, double, bool) Optional arguments for the format string.
Developers should read the file dolfin/log/README in the DOLFIN source tree for further notes about the use of this function. 

:param std\\:\\:string location: 
:param std\\:\\:string task: 
:param std\\:\\:string reason: 
:rtype: void
";

%feature("docstring") dolfin::end() "
End task (decrease indentation level) 

:rtype: void
";

%feature("docstring") dolfin::error(std::string msg,...) "
Print error message and throw an exception. Note to developers: this function should not be used internally in DOLFIN. Use the more informative dolfin_error instead. 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::get_log_level() "
Get log level. 

:rtype: int
";

%feature("docstring") dolfin::info(const Parameters &parameters, bool verbose=false) "
Print parameter (using output of str() method) 

:param const Parameters & parameters: 
:param bool verbose: 
:rtype: void
";

%feature("docstring") dolfin::info(const Variable &variable, bool verbose=false) "
Print variable (using output of str() method) 

:param const Variable & variable: 
:param bool verbose: 
:rtype: void
";

%feature("docstring") dolfin::info(std::string msg,...) "
Print message. 
The DOLFIN log system provides the following set of functions for uniform handling of log messages, warnings and errors. In addition, macros are provided for debug messages and dolfin_assertions.
Only messages with a debug level higher than or equal to the current log level are printed (the default being zero). Logging may also be turned off by calling set_log_active(false). 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::info_stream(std::ostream &out, std::string msg) "
Print message to stream. 

:param std\\:\\:ostream & out: 
:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::info_underline(std::string msg,...) "
Print underlined message. 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::log(int debug_level, std::string msg,...) "
Print message at given debug level. 

:param int debug_level: 
:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::monitor_memory_usage() "
Monitor memory usage. Call this function at the start of a program to continuously monitor the memory usage of the process. 

:rtype: void
";

%feature("docstring") dolfin::not_working_in_parallel(std::string what) "
Report that functionality has not (yet) been implemented to work in parallel 

:param std\\:\\:string what: 
:rtype: void
";

%feature("docstring") dolfin::set_log_active(bool active=true) "
Turn logging on or off. 

:param bool active: 
:rtype: void
";

%feature("docstring") dolfin::set_log_level(int level) "
:cpp:any:`Set`  log level. 

:param int level: 
:rtype: void
";

%feature("docstring") dolfin::set_output_stream(std::ostream &out) "
:cpp:any:`Set`  output stream. 

:param std\\:\\:ostream & out: 
:rtype: void
";

%feature("docstring") dolfin::warning(std::string msg,...) "
Print warning. 

:param std\\:\\:string msg: 
:rtype: void
";

%feature("docstring") dolfin::cout "
:cpp:any:`dolfin::cout` 

:rtype: LogStream
";

%feature("docstring") dolfin::endl "
:cpp:any:`dolfin::endl` ; 

:rtype: LogStream
";

%feature("docstring") dolfin::LogLevel "
These log levels match the levels in the Python 'logging' module (and adds trace/progress). 

.. cpp:enumerator:: dolfin::LogLevel::CRITICAL = 50

.. cpp:enumerator:: dolfin::LogLevel::ERROR = 40

.. cpp:enumerator:: dolfin::LogLevel::WARNING = 30

.. cpp:enumerator:: dolfin::LogLevel::INFO = 20

.. cpp:enumerator:: dolfin::LogLevel::PROGRESS = 16

.. cpp:enumerator:: dolfin::LogLevel::TRACE = 13

.. cpp:enumerator:: dolfin::LogLevel::DBG = 10
";

