// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::Lagrange "
:cpp:any:`Lagrange`  polynomial (basis) with given degree q determined by n = q + 1 nodal points.
Example: q = 1 (n = 2)
:cpp:any:`Lagrange`  p(1); p.set(0, 0.0); p.set(1, 1.0);
It is the callers responsibility that the points are distinct.
This creates a :cpp:any:`Lagrange`  polynomial (actually two :cpp:any:`Lagrange`  polynomials):
p(0,x) = 1 - x (one at x = 0, zero at x = 1) p(1,x) = x (zero at x = 0, one at x = 1)
";

%feature("docstring") dolfin::Lagrange::Lagrange(const Lagrange &p) "
Copy constructor. 

:param const Lagrange & p:
";

%feature("docstring") dolfin::Lagrange::Lagrange(std::size_t q) "
Constructor. 

:param std\\:\\:size_t q:
";

%feature("docstring") dolfin::Lagrange::constants "
:rtype: std::vector< double >
";

%feature("docstring") dolfin::Lagrange::counter "
:rtype: std::size_t
";

%feature("docstring") dolfin::Lagrange::ddx(std::size_t i, double x) "
Return derivate of polynomial i at given point x 

:param std\\:\\:size_t i:  (std::size_t)
:param double x:  (double)
:rtype: double
";

%feature("docstring") dolfin::Lagrange::degree() const "
Return degree 

:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::Lagrange::dqdx(std::size_t i) "
Return derivative q (a constant) of polynomial 

:param std\\:\\:size_t i:  (std::size_t)
:rtype: double
";

%feature("docstring") dolfin::Lagrange::eval(std::size_t i, double x) "
Return value of polynomial i at given point x 

:param std\\:\\:size_t i:  (std::size_t)
:param double x:  (double)
:rtype: double
";

%feature("docstring") dolfin::Lagrange::init() "
:rtype: void
";

%feature("docstring") dolfin::Lagrange::instability_detected "
:rtype: Event
";

%feature("docstring") dolfin::Lagrange::operator()(std::size_t i, double x) "
Return value of polynomial i at given point x 

:param std\\:\\:size_t i:  (std::size_t)
:param double x:  (double)
:rtype: double
";

%feature("docstring") dolfin::Lagrange::point(std::size_t i) const "
Return point 

:param std\\:\\:size_t i:  (std::size_t)
:rtype: double
";

%feature("docstring") dolfin::Lagrange::points "
:rtype: std::vector< double >
";

%feature("docstring") dolfin::Lagrange::set(std::size_t i, double x) "
Specify point 

:param std\\:\\:size_t i:  (std::size_t)
:param double x:  (double)
:rtype: void
";

%feature("docstring") dolfin::Lagrange::size() const "
Return number of points 

:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::Lagrange::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose:  (bool) Verbosity of output string
:rtype: std::string
";

%feature("docstring") dolfin::Legendre "
Interface for computing :cpp:any:`Legendre`  polynomials via Boost.
";

%feature("docstring") dolfin::Legendre::d2dx(std::size_t n, double x) "
Evaluate second derivative of polynomial of order n at point x 

:param std\\:\\:size_t n:  (std::size_t) Order
:param double x:  (double) :cpp:any:`Point`
:rtype: double
:returns: double :cpp:any:`Legendre`  polynomial 2nd derivative value at x
";

%feature("docstring") dolfin::Legendre::ddx(std::size_t n, double x) "
Evaluate first derivative of polynomial of order n at point x 

:param std\\:\\:size_t n:  (std::size_t) Order
:param double x:  (double) :cpp:any:`Point`
:rtype: double
:returns: double :cpp:any:`Legendre`  polynomial derivative value at x
";

%feature("docstring") dolfin::Legendre::eval(std::size_t n, double x) "
Evaluate polynomial of order n at point x 

:param std\\:\\:size_t n:  (std::size_t) Order
:param double x:  (double) :cpp:any:`Point`
:rtype: double
:returns: double :cpp:any:`Legendre`  polynomial value at x
";

%feature("docstring") dolfin::between(double x, std::pair< double, double > range) "
Check whether x is between x0 and x1 (inclusive, to within DOLFIN_EPS) 

:param double x:  (double) Value to check
:param std\\:\\:pair< double, double > range:  (std::pair<double, double>) Range to check
:rtype: bool
:returns: bool
";

%feature("docstring") dolfin::ipow(std::size_t a, std::size_t n) "
Return a to the power n. NOTE: Overflow is not checked! 

:param std\\:\\:size_t a:  (std::size_t) Value
:param std\\:\\:size_t n:  (std::size_t) Power
:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::near(double x, double x0, double eps=DOLFIN_EPS) "
Check whether x is close to x0 (to within DOLFIN_EPS) 

:param double x:  (double) First value
:param double x0:  (double) Second value
:param double eps:  (double) Tolerance
:rtype: bool
:returns: bool
";

%feature("docstring") dolfin::rand() "
Return a random number, uniformly distributed between [0.0, 1.0) 

:rtype: double
:returns: double
";

%feature("docstring") dolfin::seed(std::size_t s) "
Seed random number generator 

:param std\\:\\:size_t s:  (std::size_t) Seed value
:rtype: void
";

%feature("docstring") dolfin::rand_seeded "
Flag to determine whether to reseed :cpp:any:`dolfin::rand()` . Normally on first call. 

:rtype: bool
";

