// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::MultiStageScheme "
Place-holder for forms and solutions for a multi-stage Butcher tableau based method.
";

%feature("docstring") dolfin::MultiStageScheme::MultiStageScheme(std::vector< std::vector< std::shared_ptr< const Form >>> stage_forms, std::shared_ptr< const Form > last_stage, std::vector< std::shared_ptr< Function > > stage_solutions, std::shared_ptr< Function > u, std::shared_ptr< Constant > t, std::shared_ptr< Constant > dt, std::vector< double > dt_stage_offset, std::vector< int > jacobian_indices, unsigned int order, const std::string name, const std::string human_form, std::vector< std::shared_ptr< const DirichletBC >> bcs={}) "
Constructor. 

:param std\\:\\:vector< std\\:\\:vector< std\\:\\:shared_ptr< const Form >>> stage_forms: 
:param std\\:\\:shared_ptr< const Form > last_stage: 
:param std\\:\\:vector< std\\:\\:shared_ptr< Function > > stage_solutions: 
:param std\\:\\:shared_ptr< Function > u: 
:param std\\:\\:shared_ptr< Constant > t: 
:param std\\:\\:shared_ptr< Constant > dt: 
:param std\\:\\:vector< double > dt_stage_offset: 
:param std\\:\\:vector< int > jacobian_indices: 
:param unsigned int order: 
:param const std\\:\\:string name: 
:param const std\\:\\:string human_form: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const DirichletBC >> bcs:
";

%feature("docstring") dolfin::MultiStageScheme::bcs() const "
Return boundary conditions. 

:rtype: std::vector< std::shared_ptr< const DirichletBC > >
";

%feature("docstring") dolfin::MultiStageScheme::dt() "
Return local timestep. 

:rtype: std::shared_ptr< Constant >
";

%feature("docstring") dolfin::MultiStageScheme::dt_stage_offset() const "
Return local timestep. 

:rtype: const std::vector< double > &
";

%feature("docstring") dolfin::MultiStageScheme::implicit() const "
Return true if the whole scheme is implicit. 

:rtype: bool
";

%feature("docstring") dolfin::MultiStageScheme::implicit(unsigned int stage) const "
Return true if stage is implicit. 

:param unsigned int stage: 
:rtype: bool
";

%feature("docstring") dolfin::MultiStageScheme::jacobian_index(unsigned int stage) const "
Return a distinct jacobian index for a given stage if negative the stage is explicit and hence no jacobian needed. 

:param unsigned int stage: 
:rtype: int
";

%feature("docstring") dolfin::MultiStageScheme::last_stage() "
Return the last stage. 

:rtype: std::shared_ptr< const Form >
";

%feature("docstring") dolfin::MultiStageScheme::order() const "
Return the order of the scheme. 

:rtype: unsigned int
";

%feature("docstring") dolfin::MultiStageScheme::solution() "
Return solution variable. 

:rtype: std::shared_ptr< Function >
";

%feature("docstring") dolfin::MultiStageScheme::solution() const "
Return solution variable (const version) 

:rtype: std::shared_ptr< const Function >
";

%feature("docstring") dolfin::MultiStageScheme::stage_forms() "
Return the stages. 

:rtype: std::vector< std::vector< std::shared_ptr< const Form > > > &
";

%feature("docstring") dolfin::MultiStageScheme::stage_solutions() "
Return stage solutions. 

:rtype: std::vector< std::shared_ptr< Function > > &
";

%feature("docstring") dolfin::MultiStageScheme::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::MultiStageScheme::t() "
Return local time. 

:rtype: std::shared_ptr< Constant >
";

%feature("docstring") dolfin::PointIntegralSolver "
This class is a time integrator for general Runge Kutta forms. 
It only includes :cpp:any:`Point`  integrals with piecewise linear test functions. Such problems are disconnected at the vertices and can therefore be solved locally.
";

%feature("docstring") dolfin::PointIntegralSolver::PointIntegralSolver(std::shared_ptr< MultiStageScheme > scheme) "
Constructor FIXME: Include version where one can pass a Solver and/or :cpp:any:`Parameters` 

:param std\\:\\:shared_ptr< MultiStageScheme > scheme:
";

%feature("docstring") dolfin::PointIntegralSolver::num_jacobian_computations() const "
Return number of computations of jacobian. 

:rtype: std::size_t
";

%feature("docstring") dolfin::PointIntegralSolver::reset_newton_solver() "
Reset newton solver. 

:rtype: void
";

%feature("docstring") dolfin::PointIntegralSolver::reset_stage_solutions() "
Reset stage solutions. 

:rtype: void
";

%feature("docstring") dolfin::PointIntegralSolver::scheme() const "
Return the :cpp:any:`MultiStageScheme` . 

:rtype: std::shared_ptr< MultiStageScheme >
";

%feature("docstring") dolfin::PointIntegralSolver::step(double dt) "
Step solver with time step dt. 

:param double dt: 
:rtype: void
";

%feature("docstring") dolfin::PointIntegralSolver::step_interval(double t0, double t1, double dt) "
Step solver an interval using dt as time step. 

:param double t0: 
:param double t1: 
:param double dt: 
:rtype: void
";

%feature("docstring") dolfin::PointIntegralSolver::~PointIntegralSolver() "
Destructor.
";

%feature("docstring") dolfin::RKSolver "
This class is a time integrator for general Runge Kutta problems.
";

%feature("docstring") dolfin::RKSolver::RKSolver(std::shared_ptr< MultiStageScheme > scheme) "
Constructor FIXME: Include version where one can pass a Solver and/or :cpp:any:`Parameters` 

:param std\\:\\:shared_ptr< MultiStageScheme > scheme:
";

%feature("docstring") dolfin::RKSolver::scheme() const "
Return the :cpp:any:`MultiStageScheme` . 

:rtype: std::shared_ptr< MultiStageScheme >
";

%feature("docstring") dolfin::RKSolver::step(double dt) "
Step solver with time step dt. 

:param double dt: 
:rtype: void
";

%feature("docstring") dolfin::RKSolver::step_interval(double t0, double t1, double dt) "
Step solver an interval using dt as time step. 

:param double t0: 
:param double t1: 
:param double dt: 
:rtype: void
";

