// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::BoolParameter "
:cpp:any:`Parameter`  with value type bool.
";

%feature("docstring") dolfin::BoolParameter::BoolParameter(std::string key) "
Create unset bool-valued parameter. 

:param std\\:\\:string key:
";

%feature("docstring") dolfin::BoolParameter::BoolParameter(std::string key, bool value) "
Create bool-valued parameter. 

:param std\\:\\:string key: 
:param bool value:
";

%feature("docstring") dolfin::BoolParameter::operator bool() const "
Cast parameter to bool.
";

%feature("docstring") dolfin::BoolParameter::operator=(bool value) "
Assignment. 

:param bool value: 
:rtype: const BoolParameter &
";

%feature("docstring") dolfin::BoolParameter::range_str() const "
Return range string. 

:rtype: std::string
";

%feature("docstring") dolfin::BoolParameter::str() const "
Return short string description. 

:rtype: std::string
";

%feature("docstring") dolfin::BoolParameter::type_str() const "
Return value type string. 

:rtype: std::string
";

%feature("docstring") dolfin::BoolParameter::value_str() const "
Return value string. 

:rtype: std::string
";

%feature("docstring") dolfin::BoolParameter::~BoolParameter() "
Destructor.
";

%feature("docstring") dolfin::DoubleParameter "
:cpp:any:`Parameter`  with value type double.
";

%feature("docstring") dolfin::DoubleParameter::DoubleParameter(std::string key) "
Create unset double-valued parameter. 

:param std\\:\\:string key:
";

%feature("docstring") dolfin::DoubleParameter::DoubleParameter(std::string key, double value) "
Create double-valued parameter. 

:param std\\:\\:string key: 
:param double value:
";

%feature("docstring") dolfin::DoubleParameter::get_range(double &min_value, double &max_value) const "
Get range. 

:param double & min_value: 
:param double & max_value: 
:rtype: void
";

%feature("docstring") dolfin::DoubleParameter::operator double() const "
Cast parameter to double.
";

%feature("docstring") dolfin::DoubleParameter::operator=(double value) "
Assignment. 

:param double value: 
:rtype: const DoubleParameter &
";

%feature("docstring") dolfin::DoubleParameter::range_str() const "
Return range string. 

:rtype: std::string
";

%feature("docstring") dolfin::DoubleParameter::set_range(double min_value, double max_value) "
:cpp:any:`Set`  range. 

:param double min_value: 
:param double max_value: 
:rtype: void
";

%feature("docstring") dolfin::DoubleParameter::str() const "
Return short string description. 

:rtype: std::string
";

%feature("docstring") dolfin::DoubleParameter::type_str() const "
Return value type string. 

:rtype: std::string
";

%feature("docstring") dolfin::DoubleParameter::value_str() const "
Return value string. 

:rtype: std::string
";

%feature("docstring") dolfin::DoubleParameter::~DoubleParameter() "
Destructor.
";

%feature("docstring") dolfin::GlobalParameters "
This class defines the global DOLFIN parameter database.
";

%feature("docstring") dolfin::GlobalParameters::GlobalParameters() "
Constructor.
";

%feature("docstring") dolfin::GlobalParameters::parse(int argc, char *argv[]) "
Parse parameters from command-line. 

:param int argc: 
:param char * argv: 
:rtype: void
";

%feature("docstring") dolfin::GlobalParameters::~GlobalParameters() "
Destructor.
";

%feature("docstring") dolfin::IntParameter "
:cpp:any:`Parameter`  with value type int.
";

%feature("docstring") dolfin::IntParameter::IntParameter(std::string key) "
Create unset int-valued. 

:param std\\:\\:string key:
";

%feature("docstring") dolfin::IntParameter::IntParameter(std::string key, int value) "
Create int-valued parameter. 

:param std\\:\\:string key: 
:param int value:
";

%feature("docstring") dolfin::IntParameter::get_range(int &min_value, int &max_value) const "
Get range. 

:param int & min_value: 
:param int & max_value: 
:rtype: void
";

%feature("docstring") dolfin::IntParameter::operator int() const "
Cast parameter to int.
";

%feature("docstring") dolfin::IntParameter::operator std::size_t() const "
Cast parameter to std::size_t.
";

%feature("docstring") dolfin::IntParameter::operator=(int value) "
Assignment. 

:param int value: 
:rtype: const IntParameter &
";

%feature("docstring") dolfin::IntParameter::range_str() const "
Return range string. 

:rtype: std::string
";

%feature("docstring") dolfin::IntParameter::set_range(int min_value, int max_value) "
:cpp:any:`Set`  range. 

:param int min_value: 
:param int max_value: 
:rtype: void
";

%feature("docstring") dolfin::IntParameter::str() const "
Return short string description. 

:rtype: std::string
";

%feature("docstring") dolfin::IntParameter::type_str() const "
Return value type string. 

:rtype: std::string
";

%feature("docstring") dolfin::IntParameter::value_str() const "
Return value string. 

:rtype: std::string
";

%feature("docstring") dolfin::IntParameter::~IntParameter() "
Destructor.
";

%feature("docstring") dolfin::Parameter "
Base class for parameters.
";

%feature("docstring") dolfin::Parameter::Parameter(std::string key) "
Create parameter for given key 

:param std\\:\\:string key:  (std::string)
";

%feature("docstring") dolfin::Parameter::access_count() const "
Return access count (number of times parameter has been accessed) 

:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::Parameter::change_count() const "
Return change count (number of times parameter has been changed) 

:rtype: std::size_t
:returns: std::size_t
";

%feature("docstring") dolfin::Parameter::check_key(std::string key) "
Check that key name is allowed. 

:param std\\:\\:string key: 
:rtype: void
";

%feature("docstring") dolfin::Parameter::description() const "
Return parameter description 

:rtype: std::string
:returns: std::string
";

%feature("docstring") dolfin::Parameter::get_range(double &min_value, double &max_value) const "
Get range for double-valued parameter 

:param double & min_value:  (double) [direction=out]
:param double & max_value:  (double) [direction=out]
:rtype: void
";

%feature("docstring") dolfin::Parameter::get_range(int &min_value, int &max_value) const "
Get range for int-valued parameter 

:param int & min_value:  (int) [direction=out]
:param int & max_value:  (int) [direction=out]
:rtype: void
";

%feature("docstring") dolfin::Parameter::get_range(std::set< std::string > &range) const "
Get range for string-valued parameter 

:param std\\:\\:set< std\\:\\:string > & range:  (std::set<std::string>) [direction=out]
:rtype: void
";

%feature("docstring") dolfin::Parameter::is_set() const "
Return true if parameter is set, return false otherwise 

:rtype: bool
:returns: bool
";

%feature("docstring") dolfin::Parameter::key() const "
Return parameter key 

:rtype: std::string
:returns: std::string
";

%feature("docstring") dolfin::Parameter::operator bool() const "
Cast parameter to bool.
";

%feature("docstring") dolfin::Parameter::operator double() const "
Cast parameter to double.
";

%feature("docstring") dolfin::Parameter::operator int() const "
Cast parameter to int.
";

%feature("docstring") dolfin::Parameter::operator std::size_t() const "
Cast parameter to std::size_t.
";

%feature("docstring") dolfin::Parameter::operator std::string() const "
Cast parameter to string.
";

%feature("docstring") dolfin::Parameter::operator=(bool value) "
Assignment from bool 

:param bool value:  (bool)
:rtype: const Parameter &
";

%feature("docstring") dolfin::Parameter::operator=(const char *value) "
Assignment from string 

:param const char * value:  (char *)
:rtype: const Parameter &
";

%feature("docstring") dolfin::Parameter::operator=(double value) "
Assignment from double 

:param double value:  (double)
:rtype: const Parameter &
";

%feature("docstring") dolfin::Parameter::operator=(int value) "
Assignment from int 

:param int value:  (int)
:rtype: const Parameter &
";

%feature("docstring") dolfin::Parameter::operator=(std::string value) "
Assignment from string 

:param std\\:\\:string value:  (std::string)
:rtype: const Parameter &
";

%feature("docstring") dolfin::Parameter::range_str() const  "
Return range string. 

:rtype: std::string
";

%feature("docstring") dolfin::Parameter::reset() "
Reset the parameter to empty, so that :cpp:any:`is_set()`  returns false. 

:rtype: void
";

%feature("docstring") dolfin::Parameter::set_range(double min_value, double max_value) "
:cpp:any:`Set`  range for double-valued parameter 

:param double min_value:  (double)
:param double max_value:  (double)
:rtype: void
";

%feature("docstring") dolfin::Parameter::set_range(int min_value, int max_value) "
:cpp:any:`Set`  range for int-valued parameter 

:param int min_value:  (int)
:param int max_value:  (int)
:rtype: void
";

%feature("docstring") dolfin::Parameter::set_range(std::set< std::string > range) "
:cpp:any:`Set`  range for string-valued parameter 

:param std\\:\\:set< std\\:\\:string > range:  (std::set<std::string>)
:rtype: void
";

%feature("docstring") dolfin::Parameter::str() const  "
Return short string description. 

:rtype: std::string
";

%feature("docstring") dolfin::Parameter::type_str() const  "
Return value type string. 

:rtype: std::string
";

%feature("docstring") dolfin::Parameter::value_str() const  "
Return value string. 

:rtype: std::string
";

%feature("docstring") dolfin::Parameter::~Parameter() "
Destructor.
";

%feature("docstring") dolfin::Parameters "
This class stores a set of parameters. Each parameter is identified by a unique string (the key) and a value of some given value type. :cpp:any:`Parameter`  sets can be nested at arbitrary depths.
A parameter may be either int, double, string or boolean valued.
:cpp:any:`Parameters`  may be added as follows:

::
   
   Parameters p(\"my_parameters\");
   p.add(\"relative_tolerance\",  1e-15);
   p.add(\"absolute_tolerance\",  1e-15);
   p.add(\"gmres_restart\",       30);
   p.add(\"monitor_convergence\", false);

:cpp:any:`Parameters`  may be changed as follows:

::
   
   p[\"gmres_restart\"] = 50;

:cpp:any:`Parameter`  values may be retrieved as follows:

::
   
   int gmres_restart = p[\"gmres_restart\"];

:cpp:any:`Parameter`  sets may be nested as follows:

::
   
   Parameters q(\"nested_parameters\");
   p.add(q);

Nested parameters may then be accessed by

::
   
   p(\"nested_parameters\")[\"...\"]

:cpp:any:`Parameters`  may be nested at arbitrary depths.
:cpp:any:`Parameters`  may be parsed from the command-line as follows:

::
   
   p.parse(argc, argv);

Note: spaces in parameter keys are not allowed (to simplify usage from command-line).
";

%feature("docstring") dolfin::Parameters::Parameters(const Parameters &parameters) "
Copy constructor. 

:param const Parameters & parameters:
";

%feature("docstring") dolfin::Parameters::Parameters(std::string key="parameters") "
Create empty parameter set. 

:param std\\:\\:string key:
";

%feature("docstring") dolfin::Parameters::add(const Parameters &parameters) "
Add nested parameter set. 

:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key) "
Add an unset parameter of type T. For example, to create a unset parameter of type bool, do parameters.add<bool>(\"my_setting\") 

:param std\\:\\:string key: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, T min, T max) "
Add an unset parameter of type T with allows parameters. For example, to create a unset parameter of type bool, do parameters.add<bool>(\"my_setting\") 

:param std\\:\\:string key: 
:param T min: 
:param T max: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, bool value) "
Add bool-valued parameter. 

:param std\\:\\:string key: 
:param bool value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, const char *value) "
Add string-valued parameter. 

:param std\\:\\:string key: 
:param const char * value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, const char *value, std::set< std::string > range) "
Add string-valued parameter with given range. 

:param std\\:\\:string key: 
:param const char * value: 
:param std\\:\\:set< std\\:\\:string > range: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, double value) "
Add double-valued parameter. 

:param std\\:\\:string key: 
:param double value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, double value, double min_value, double max_value) "
Add double-valued parameter with given range. 

:param std\\:\\:string key: 
:param double value: 
:param double min_value: 
:param double max_value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, int value) "
Add int-valued parameter. 

:param std\\:\\:string key: 
:param int value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, int value, int min_value, int max_value) "
Add int-valued parameter with given range. 

:param std\\:\\:string key: 
:param int value: 
:param int min_value: 
:param int max_value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, std::set< T > valid_values) "
Add an unset parameter of type T with allows parameters. For example, to create a unset parameter of type bool, do parameters.add<bool>(\"my_setting\") 

:param std\\:\\:string key: 
:param std\\:\\:set< T > valid_values: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, std::string value) "
Add string-valued parameter. 

:param std\\:\\:string key: 
:param std\\:\\:string value: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add(std::string key, std::string value, std::set< std::string > range) "
Add string-valued parameter with given range. 

:param std\\:\\:string key: 
:param std\\:\\:string value: 
:param std\\:\\:set< std\\:\\:string > range: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::add_parameter_set_to_po(boost::program_options::options_description &desc, const Parameters &parameters, std::string base_name="") const "
:param boost\\:\\:program_options\\:\\:options_description & desc: 
:param const Parameters & parameters: 
:param std\\:\\:string base_name: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::clear() "
Clear parameter set. 

:rtype: void
";

%feature("docstring") dolfin::Parameters::find_parameter(std::string key) const "
Return pointer to parameter for given key and 0 if not found. 

:param std\\:\\:string key: 
:rtype: Parameter *
";

%feature("docstring") dolfin::Parameters::find_parameter_set(std::string key) const "
Return pointer to parameter set for given key and 0 if not found. 

:param std\\:\\:string key: 
:rtype: Parameters *
";

%feature("docstring") dolfin::Parameters::get_parameter_keys(std::vector< std::string > &keys) const "
Return a vector of parameter keys. 

:param std\\:\\:vector< std\\:\\:string > & keys: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::get_parameter_set_keys(std::vector< std::string > &keys) const "
Return a vector of parameter set keys. 

:param std\\:\\:vector< std\\:\\:string > & keys: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::has_key(std::string key) const "
Check if parameter set has key (parameter or nested parameter set) 

:param std\\:\\:string key: 
:rtype: bool
";

%feature("docstring") dolfin::Parameters::has_parameter(std::string key) const "
Check if parameter set has given parameter. 

:param std\\:\\:string key: 
:rtype: bool
";

%feature("docstring") dolfin::Parameters::has_parameter_set(std::string key) const "
Check if parameter set has given nested parameter set. 

:param std\\:\\:string key: 
:rtype: bool
";

%feature("docstring") dolfin::Parameters::name() const "
Return name for parameter set. 

:rtype: std::string
";

%feature("docstring") dolfin::Parameters::operator()(std::string key) "
Return nested parameter set for given key. 

:param std\\:\\:string key: 
:rtype: Parameters &
";

%feature("docstring") dolfin::Parameters::operator()(std::string key) const "
Return nested parameter set for given key (const) 

:param std\\:\\:string key: 
:rtype: const Parameters &
";

%feature("docstring") dolfin::Parameters::operator=(const Parameters &parameters) "
Assignment operator. 

:param const Parameters & parameters: 
:rtype: const Parameters &
";

%feature("docstring") dolfin::Parameters::operator[](std::string key) "
Return parameter for given key. 

:param std\\:\\:string key: 
:rtype: Parameter &
";

%feature("docstring") dolfin::Parameters::operator[](std::string key) const "
Return parameter for given key (const version) 

:param std\\:\\:string key: 
:rtype: const Parameter &
";

%feature("docstring") dolfin::Parameters::parse(int argc, char *argv[]) "
Parse parameters from command-line. 

:param int argc: 
:param char * argv: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::parse_common(int argc, char *argv[]) "
Parse filtered options (everything except PETSc options) 

:param int argc: 
:param char * argv: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::parse_petsc(int argc, char *argv[]) "
Parse filtered options (only PETSc options) 

:param int argc: 
:param char * argv: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::read_vm(boost::program_options::variables_map &vm, Parameters &parameters, std::string base_name="") "
:param boost\\:\\:program_options\\:\\:variables_map & vm: 
:param Parameters & parameters: 
:param std\\:\\:string base_name: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::remove(std::string key) "
Remove parameter or parameter set with given key. 

:param std\\:\\:string key: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::rename(std::string key) "
Rename parameter set. 

:param std\\:\\:string key: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Parameters::update(const Parameters &parameters) "
Update parameters with another set of parameters. 

:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::Parameters::~Parameters() "
Destructor.
";

%feature("docstring") dolfin::StringParameter "
:cpp:any:`Parameter`  with value type string.
";

%feature("docstring") dolfin::StringParameter::StringParameter(std::string key) "
Create unset string-valued parameter. 

:param std\\:\\:string key:
";

%feature("docstring") dolfin::StringParameter::StringParameter(std::string key, std::string value) "
Create string-valued parameter. 

:param std\\:\\:string key: 
:param std\\:\\:string value:
";

%feature("docstring") dolfin::StringParameter::get_range(std::set< std::string > &range) const "
Get range. 

:param std\\:\\:set< std\\:\\:string > & range: 
:rtype: void
";

%feature("docstring") dolfin::StringParameter::operator std::string() const "
Cast parameter to string.
";

%feature("docstring") dolfin::StringParameter::operator=(const char *value) "
Assignment. 

:param const char * value: 
:rtype: const StringParameter &
";

%feature("docstring") dolfin::StringParameter::operator=(std::string value) "
Assignment. 

:param std\\:\\:string value: 
:rtype: const StringParameter &
";

%feature("docstring") dolfin::StringParameter::range_str() const "
Return range string. 

:rtype: std::string
";

%feature("docstring") dolfin::StringParameter::set_range(std::set< std::string > range) "
:cpp:any:`Set`  range. 

:param std\\:\\:set< std\\:\\:string > range: 
:rtype: void
";

%feature("docstring") dolfin::StringParameter::str() const "
Return short string description. 

:rtype: std::string
";

%feature("docstring") dolfin::StringParameter::type_str() const "
Return value type string. 

:rtype: std::string
";

%feature("docstring") dolfin::StringParameter::value_str() const "
Return value string. 

:rtype: std::string
";

%feature("docstring") dolfin::StringParameter::~StringParameter() "
Destructor.
";

%feature("docstring") dolfin::empty_parameters "
Default empty parameters. 

:rtype: Parameters
";

%feature("docstring") dolfin::parameters "
The global parameter database. 

:rtype: GlobalParameters
";

