// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::ExpressionWrapper "
A light wrapper class to hold an expression to plot, along with the mesh to plot it on. Allows clean, templated plotter code in plot.cpp
";

%feature("docstring") dolfin::ExpressionWrapper::ExpressionWrapper(std::shared_ptr< const Expression > expression, std::shared_ptr< const Mesh > mesh) "
Create wrapped expression object. 

:param std\\:\\:shared_ptr< const Expression > expression: 
:param std\\:\\:shared_ptr< const Mesh > mesh:
";

%feature("docstring") dolfin::ExpressionWrapper::expression() const "
Get shared pointer to the expression. 

:rtype: std::shared_ptr< const Expression >
";

%feature("docstring") dolfin::ExpressionWrapper::mesh() const "
Get shared pointer to the mesh. 

:rtype: std::shared_ptr< const Mesh >
";

%feature("docstring") dolfin::interactive(bool really=false) "
Make the current plots interactive. If really is set, the interactive mode is entered even if 'Q' has been pressed. 

:param bool really: 
:rtype: void
";

%feature("docstring") dolfin::plot(const Expression &expression, const Mesh &mesh, const Parameters &parameters) "
Plot expression (parameter version) 

:param const Expression & expression: 
:param const Mesh & mesh: 
:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::plot(const Expression &expression, const Mesh &mesh, std::string title="", std::string mode="auto") "
Plot expression. 

:param const Expression & expression: 
:param const Mesh & mesh: 
:param std\\:\\:string title: 
:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::plot(const MultiMesh &multimesh) "
Plot multimesh. 

:param const MultiMesh & multimesh: 
:rtype: void
";

%feature("docstring") dolfin::plot(const Variable &, const Parameters &parameters) "
Plot variable (parameter version) 

:param const Variable & var: 
:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::plot(const Variable &, std::string title="", std::string mode="auto") "
Simple built-in plot commands for plotting functions and meshes. 
Plot variable of any supported type 

:param const Variable & var: 
:param std\\:\\:string title: 
:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::plot(std::shared_ptr< const Expression > expression, std::shared_ptr< const Mesh > mesh, std::shared_ptr< const Parameters > parameters) "
Plot expression (parameter, shared_ptr version) 

:param std\\:\\:shared_ptr< const Expression > expression: 
:param std\\:\\:shared_ptr< const Mesh > mesh: 
:param std\\:\\:shared_ptr< const Parameters > parameters: 
:rtype: std::shared_ptr< VTKPlotter >
";

%feature("docstring") dolfin::plot(std::shared_ptr< const Expression > expression, std::shared_ptr< const Mesh > mesh, std::string title="", std::string mode="auto") "
Plot expression (shared_ptr version) 

:param std\\:\\:shared_ptr< const Expression > expression: 
:param std\\:\\:shared_ptr< const Mesh > mesh: 
:param std\\:\\:string title: 
:param std\\:\\:string mode: 
:rtype: std::shared_ptr< VTKPlotter >
";

%feature("docstring") dolfin::plot(std::shared_ptr< const MultiMesh > multimesh) "
Plot multimesh (shared_ptr version) 

:param std\\:\\:shared_ptr< const MultiMesh > multimesh: 
:rtype: void
";

%feature("docstring") dolfin::plot(std::shared_ptr< const Variable >, std::shared_ptr< const Parameters > parameters) "
Plot variable (parameter, shared_ptr version) 

:param std\\:\\:shared_ptr< const Variable > var: 
:param std\\:\\:shared_ptr< const Parameters > parameters: 
:rtype: std::shared_ptr< VTKPlotter >
";

%feature("docstring") dolfin::plot(std::shared_ptr< const Variable >, std::string title="", std::string mode="auto") "
Plot variable (shared_ptr version) 

:param std\\:\\:shared_ptr< const Variable > var: 
:param std\\:\\:string title: 
:param std\\:\\:string mode: 
:rtype: std::shared_ptr< VTKPlotter >
";

