// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::BisectionRefinement1D "
This class implements mesh refinement in 1D.
";

%feature("docstring") dolfin::BisectionRefinement1D::refine(Mesh &refined_mesh, const Mesh &mesh, bool redistribute=false) "
Refine mesh uniformly 

:param Mesh & refined_mesh:  (:cpp:any:`Mesh` )
:param const Mesh & mesh:  (const :cpp:any:`Mesh` )
:param bool redistribute:  (bool)
:rtype: void
";

%feature("docstring") dolfin::BisectionRefinement1D::refine(Mesh &refined_mesh, const Mesh &mesh, const MeshFunction< bool > &cell_markers, bool redistribute=false) "
Refine mesh based on cell markers 

:param Mesh & refined_mesh:  (:cpp:any:`Mesh` )
:param const Mesh & mesh:  (const :cpp:any:`Mesh` )
:param const MeshFunction< bool > & cell_markers:  (const MeshFunction<bool>)
:param bool redistribute:  (bool)
:rtype: void
";

%feature("docstring") dolfin::LocalMeshCoarsening "
This class implements local mesh coarsening for different mesh types.
";

%feature("docstring") dolfin::LocalMeshCoarsening::coarsen_cell(Mesh &mesh, Mesh &coarse_mesh, int cell_id, std::vector< int > &old2new_vertex, std::vector< int > &old2new_cell, bool coarsen_boundary=false) "
Coarsen simplicial cell by edge collapse. 

:param Mesh & mesh: 
:param Mesh & coarse_mesh: 
:param int cell_id: 
:param std\\:\\:vector< int > & old2new_vertex: 
:param std\\:\\:vector< int > & old2new_cell: 
:param bool coarsen_boundary: 
:rtype: bool
";

%feature("docstring") dolfin::LocalMeshCoarsening::coarsen_mesh_by_edge_collapse(Mesh &mesh, MeshFunction< bool > &cell_marker, bool coarsen_boundary=false) "
Coarsen simplicial mesh locally by edge collapse. 

:param Mesh & mesh: 
:param MeshFunction< bool > & cell_marker: 
:param bool coarsen_boundary: 
:rtype: void
";

%feature("docstring") dolfin::LocalMeshCoarsening::coarsen_mesh_ok(Mesh &mesh, std::size_t edge_index, std::size_t *edge_vertex, MeshFunction< bool > &vertex_forbidden) "
Check that edge collapse is ok. 

:param Mesh & mesh: 
:param std\\:\\:size_t edge_index: 
:param std\\:\\:size_t * edge_vertex: 
:param MeshFunction< bool > & vertex_forbidden: 
:rtype: bool
";

%feature("docstring") dolfin::LocalMeshCoarsening::collapse_edge(Mesh &mesh, Edge &edge, Vertex &vertex_to_remove, MeshFunction< bool > &cell_to_remove, std::vector< int > &old2new_vertex, std::vector< int > &old2new_cell, MeshEditor &editor, std::size_t &current_cell) "
Collapse edge by node deletion. 

:param Mesh & mesh: 
:param Edge & edge: 
:param Vertex & vertex_to_remove: 
:param MeshFunction< bool > & cell_to_remove: 
:param std\\:\\:vector< int > & old2new_vertex: 
:param std\\:\\:vector< int > & old2new_cell: 
:param MeshEditor & editor: 
:param std\\:\\:size_t & current_cell: 
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement "
Data structure and methods for refining meshes in parallel. 
:cpp:any:`ParallelRefinement`  encapsulates two main features: a distributed :cpp:any:`EdgeFunction` , which can be updated across processes, and storage for local mesh data, which can be used to construct the new :cpp:any:`Mesh`
";

%feature("docstring") dolfin::ParallelRefinement::ParallelRefinement(const Mesh &mesh) "
Constructor. 

:param const Mesh & mesh:
";

%feature("docstring") dolfin::ParallelRefinement::build_local(Mesh &new_mesh) const "
Build local mesh from internal data when not running in parallel 

:param Mesh & new_mesh:  (:cpp:any:`Mesh` )
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::create_new_vertices() "
Add new vertex for each marked edge, and create new_vertex_coordinates and global_edge->new_vertex mapping. Communicate new vertices with :cpp:any:`MPI`  to all affected processes. 

:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::edge_to_new_vertex() const "
Mapping of old edge (to be removed) to new global vertex number. Useful for forming new topology 

:rtype: std::shared_ptr< const std::map< std::size_t, std::size_t > >
";

%feature("docstring") dolfin::ParallelRefinement::is_marked(std::size_t edge_index) const "
Return marked status of edge 

:param std\\:\\:size_t edge_index:  (std::size_t)
:rtype: bool
";

%feature("docstring") dolfin::ParallelRefinement::local_edge_to_new_vertex "
:rtype: std::shared_ptr< std::map< std::size_t, std::size_t > >
";

%feature("docstring") dolfin::ParallelRefinement::mark(const MeshEntity &cell) "
Mark all incident edges of an entity 

:param const MeshEntity & cell:  (:cpp:any:`MeshEntity` )
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::mark(const MeshFunction< bool > &refinement_marker) "
Mark all edges incident on entities indicated by refinement marker 

:param const MeshFunction< bool > & refinement_marker:  (const MeshFunction<bool>)
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::mark(std::size_t edge_index) "
Mark edge by index 

:param std\\:\\:size_t edge_index:  (std::size_t) Index of edge to mark
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::mark_all() "
Mark all edges in mesh. 

:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::marked_edge_list(const MeshEntity &cell) const "
Return list of marked edges incident on this :cpp:any:`MeshEntity`  - usually a cell 

:param const MeshEntity & cell:  (const :cpp:any:`MeshEntity` )
:rtype: std::vector< std::size_t >
";

%feature("docstring") dolfin::ParallelRefinement::marked_edges "
:rtype: std::vector< bool >
";

%feature("docstring") dolfin::ParallelRefinement::marked_for_update "
:rtype: std::vector< std::vector< std::size_t > >
";

%feature("docstring") dolfin::ParallelRefinement::mesh() const "
Original mesh associated with this refinement. 

:rtype: const Mesh &
";

%feature("docstring") dolfin::ParallelRefinement::new_cell(const Cell &cell) "
Add a new cell to the list in 3D or 2D 

:param const Cell & cell:  (const :cpp:any:`Cell` )
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::new_cell(std::size_t i0, std::size_t i1, std::size_t i2) "
Add a new cell with vertex indices 

:param std\\:\\:size_t i0:  (std::size_t)
:param std\\:\\:size_t i1:  (std::size_t)
:param std\\:\\:size_t i2:  (std::size_t)
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::new_cell(std::size_t i0, std::size_t i1, std::size_t i2, std::size_t i3) "
Add a new cell with vertex indices 

:param std\\:\\:size_t i0:  (std::size_t)
:param std\\:\\:size_t i1:  (std::size_t)
:param std\\:\\:size_t i2:  (std::size_t)
:param std\\:\\:size_t i3:  (std::size_t)
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::new_cell_topology "
:rtype: std::vector< std::size_t >
";

%feature("docstring") dolfin::ParallelRefinement::new_cells(const std::vector< std::size_t > &idx) "
Add new cells with vertex indices 

:param const std\\:\\:vector< std\\:\\:size_t > & idx:  (const std::vector<std::size_t>)
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::new_vertex_coordinates "
:rtype: std::vector< double >
";

%feature("docstring") dolfin::ParallelRefinement::partition(Mesh &new_mesh, bool redistribute) const "
Use vertex and topology data to partition new mesh across processes 

:param Mesh & new_mesh:  (:cpp:any:`Mesh` )
:param bool redistribute:  (bool)
:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::shared_edges "
:rtype: std::unordered_map< unsigned int, std::vector< std::pair< unsigned int, unsigned int > > >
";

%feature("docstring") dolfin::ParallelRefinement::update_logical_edgefunction() "
Transfer marked edges between processes. 

:rtype: void
";

%feature("docstring") dolfin::ParallelRefinement::~ParallelRefinement() "
Destructor.
";

%feature("docstring") dolfin::PlazaRefinementND "
Implementation of the refinement method described in Plaza and Carey \"Local refinement of simplicial grids
based on the skeleton\" (Applied Numerical Mathematics 32 (2000) 195-218)
";

%feature("docstring") dolfin::PlazaRefinementND::do_refine(Mesh &new_mesh, const Mesh &mesh, ParallelRefinement &p_ref, const std::vector< unsigned int > &long_edge, const std::vector< bool > &edge_ratio_ok, bool redistribute, bool calculate_parent_facets, MeshRelation &mesh_relation) "
:param Mesh & new_mesh: 
:param const Mesh & mesh: 
:param ParallelRefinement & p_ref: 
:param const std\\:\\:vector< unsigned int > & long_edge: 
:param const std\\:\\:vector< bool > & edge_ratio_ok: 
:param bool redistribute: 
:param bool calculate_parent_facets: 
:param MeshRelation & mesh_relation: 
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::enforce_rules(ParallelRefinement &p_ref, const Mesh &mesh, const std::vector< unsigned int > &long_edge) "
:param ParallelRefinement & p_ref: 
:param const Mesh & mesh: 
:param const std\\:\\:vector< unsigned int > & long_edge: 
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::face_long_edge(std::vector< unsigned int > &long_edge, std::vector< bool > &edge_ratio_ok, const Mesh &mesh) "
:param std\\:\\:vector< unsigned int > & long_edge: 
:param std\\:\\:vector< bool > & edge_ratio_ok: 
:param const Mesh & mesh: 
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::get_simplices(std::vector< std::size_t > &simplex_set, const std::vector< bool > &marked_edges, const std::vector< std::size_t > &longest_edge, std::size_t tdim, bool uniform) "
Get the subdivision of an original simplex into smaller simplices, for a given set of marked edges, and the longest edge of each facet (cell local indexing). A flag indicates if a uniform subdivision is preferable in 2D. 

:param std\\:\\:vector< std\\:\\:size_t > & simplex_set:  Returned set of triangles/tets topological description
:param const std\\:\\:vector< bool > & marked_edges:  :cpp:any:`Vector`  indicating which edges are to be split
:param const std\\:\\:vector< std\\:\\:size_t > & longest_edge:  :cpp:any:`Vector`  indicating the longest edge for each triangle. For tdim=2, one entry, for tdim=3, four entries.
:param std\\:\\:size_t tdim:  Topological dimension (2 or 3)
:param bool uniform:  Make a \"uniform\" subdivision with all triangles being similar shape
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::get_tetrahedra(std::vector< std::size_t > &tet_set, const std::vector< bool > &marked_edges, const std::vector< std::size_t > &longest_edge) "
:param std\\:\\:vector< std\\:\\:size_t > & tet_set: 
:param const std\\:\\:vector< bool > & marked_edges: 
:param const std\\:\\:vector< std\\:\\:size_t > & longest_edge: 
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::get_triangles(std::vector< std::size_t > &tri_set, const std::vector< bool > &marked_edges, const std::size_t longest_edge, bool uniform) "
:param std\\:\\:vector< std\\:\\:size_t > & tri_set: 
:param const std\\:\\:vector< bool > & marked_edges: 
:param const std\\:\\:size_t longest_edge: 
:param bool uniform: 
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::refine(Mesh &new_mesh, const Mesh &mesh, bool redistribute, bool calculate_parent_facets) "
Uniform refine, optionally redistributing and optionally calculating the parent-child relation for facets (in 2D)

:param Mesh & new_mesh:  New :cpp:any:`Mesh`
:param const Mesh & mesh:  Input mesh to be refined
:param bool redistribute:  Flag to call the :cpp:any:`Mesh`  Partitioner to redistribute after refinement
:param bool calculate_parent_facets:  Flag to build parent facet information, needed to propagate information on boundaries
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::refine(Mesh &new_mesh, const Mesh &mesh, const MeshFunction< bool > &refinement_marker, bool calculate_parent_facets, MeshRelation &mesh_relation) "
Refine with markers, optionally calculating facet relations, and saving relation data in :cpp:any:`MeshRelation`  structure 

:param Mesh & new_mesh:  New :cpp:any:`Mesh`
:param const Mesh & mesh:  Input mesh to be refined
:param const MeshFunction< bool > & refinement_marker:  :cpp:any:`MeshFunction`  listing MeshEntities which should be split by this refinement
:param bool calculate_parent_facets:  Flag to build parent facet information, needed to propagate information on boundaries
:param MeshRelation & mesh_relation:  New relationship between the two meshes
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::refine(Mesh &new_mesh, const Mesh &mesh, const MeshFunction< bool > &refinement_marker, bool redistribute, bool calculate_parent_facets) "
Refine with markers, optionally redistributing and optionally calculating the parent-child relation for facets (in 2D)

:param Mesh & new_mesh:  New :cpp:any:`Mesh`
:param const Mesh & mesh:  Input mesh to be refined
:param const MeshFunction< bool > & refinement_marker:  :cpp:any:`MeshFunction`  listing MeshEntities which should be split by this refinement
:param bool redistribute:  Flag to call the :cpp:any:`Mesh`  Partitioner to redistribute after refinement
:param bool calculate_parent_facets:  Flag to build parent facet information, needed to propagate information on boundaries
:rtype: void
";

%feature("docstring") dolfin::PlazaRefinementND::set_parent_facet_markers(const Mesh &mesh, Mesh &new_mesh, const std::map< std::size_t, std::size_t > &new_vertex_map) "
:param const Mesh & mesh: 
:param Mesh & new_mesh: 
:param const std\\:\\:map< std\\:\\:size_t, std\\:\\:size_t > & new_vertex_map: 
:rtype: void
";

%feature("docstring") dolfin::RegularCutRefinement "
This class implements local mesh refinement by a regular cut of each cell marked for refinement in combination with propagation of cut edges to neighboring cells.
";

%feature("docstring") dolfin::RegularCutRefinement::compute_markers(std::vector< int > &refinement_markers, IndexSet &marked_edges, const Mesh &mesh, const MeshFunction< bool > &cell_markers) "
:param std\\:\\:vector< int > & refinement_markers: 
:param IndexSet & marked_edges: 
:param const Mesh & mesh: 
:param const MeshFunction< bool > & cell_markers: 
:rtype: void
";

%feature("docstring") dolfin::RegularCutRefinement::count_markers(const std::vector< bool > &markers) "
:param const std\\:\\:vector< bool > & markers: 
:rtype: std::size_t
";

%feature("docstring") dolfin::RegularCutRefinement::extract_edge(const std::vector< bool > &markers) "
:param const std\\:\\:vector< bool > & markers: 
:rtype: std::size_t
";

%feature("docstring") dolfin::RegularCutRefinement::find_bisection_edges(const Cell &cell, const Mesh &mesh, std::size_t bisection_twin) "
:param const Cell & cell: 
:param const Mesh & mesh: 
:param std\\:\\:size_t bisection_twin: 
:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::RegularCutRefinement::find_bisection_vertices(const Cell &cell, const Mesh &mesh, std::size_t bisection_twin, const std::pair< std::size_t, std::size_t > &bisection_edges) "
:param const Cell & cell: 
:param const Mesh & mesh: 
:param std\\:\\:size_t bisection_twin: 
:param const std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > & bisection_edges: 
:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::RegularCutRefinement::find_common_edges(const Cell &cell, const Mesh &mesh, std::size_t bisection_twin) "
:param const Cell & cell: 
:param const Mesh & mesh: 
:param std\\:\\:size_t bisection_twin: 
:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::RegularCutRefinement::marker_type "
.. cpp:enumerator:: dolfin::RegularCutRefinement::marker_type::no_refinement =-1

.. cpp:enumerator:: dolfin::RegularCutRefinement::marker_type::regular_refinement =-2

.. cpp:enumerator:: dolfin::RegularCutRefinement::marker_type::backtrack_bisection =-3

.. cpp:enumerator:: dolfin::RegularCutRefinement::marker_type::backtrack_bisection_refine =-4
";

%feature("docstring") dolfin::RegularCutRefinement::refine(Mesh &refined_mesh, const Mesh &mesh, const MeshFunction< bool > &cell_markers) "
Refine mesh based on cell markers 

:param Mesh & refined_mesh:  New :cpp:any:`Mesh`
:param const Mesh & mesh:  Input :cpp:any:`Mesh`
:param const MeshFunction< bool > & cell_markers:  Markers of MeshEntities to split (typically Cells)
:rtype: void
";

%feature("docstring") dolfin::RegularCutRefinement::refine_marked(Mesh &refined_mesh, const Mesh &mesh, const std::vector< int > &refinement_markers, const IndexSet &marked_edges) "
:param Mesh & refined_mesh: 
:param const Mesh & mesh: 
:param const std\\:\\:vector< int > & refinement_markers: 
:param const IndexSet & marked_edges: 
:rtype: void
";

%feature("docstring") dolfin::RegularCutRefinement::too_thin(const Cell &cell, const std::vector< bool > &edge_markers) "
:param const Cell & cell: 
:param const std\\:\\:vector< bool > & edge_markers: 
:rtype: bool
";

%feature("docstring") dolfin::p_refine(Mesh &refined_mesh, const Mesh &mesh) "
Increase the polynomial order of the mesh from 1 to 2, i.e. add points at the :cpp:any:`Edge`  midpoints, to make a quadratic mesh.

:param Mesh & refined_mesh:  (:cpp:any:`Mesh` ) The mesh that will be the quadratic mesh.
:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The original linear mesh.
:rtype: void
";

%feature("docstring") dolfin::p_refine(const Mesh &mesh) "
Return a p_refined mesh Increase the polynomial order of the mesh from 1 to 2, i.e. add points at the :cpp:any:`Edge`  midpoints, to make a quadratic mesh.

:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The original linear mesh.
:rtype: Mesh
:returns: :cpp:any:`Mesh`
";

%feature("docstring") dolfin::refine(Mesh &refined_mesh, const Mesh &mesh, bool redistribute=true) "
Create uniformly refined mesh

:param Mesh & refined_mesh:  (:cpp:any:`Mesh` ) The mesh that will be the refined mesh.
:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The original mesh.
:param bool redistribute:  (bool) Optional argument to redistribute the refined mesh if mesh is a distributed mesh.
:rtype: void
";

%feature("docstring") dolfin::refine(Mesh &refined_mesh, const Mesh &mesh, const MeshFunction< bool > &cell_markers, bool redistribute=true) "
Create locally refined mesh

:param Mesh & refined_mesh:  (:cpp:any:`Mesh` ) The mesh that will be the refined mesh.
:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The original mesh.
:param const MeshFunction< bool > & cell_markers:  (MeshFunction<bool>) A mesh function over booleans specifying which cells that should be refined (and which should not).
:param bool redistribute:  (bool) Optional argument to redistribute the refined mesh if mesh is a distributed mesh.
:rtype: void
";

%feature("docstring") dolfin::refine(const Mesh &mesh, bool redistribute=true) "
Create uniformly refined mesh

::
   
   mesh = refine(mesh);

:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The mesh to refine.
:param bool redistribute:  (bool) Optional argument to redistribute the refined mesh if mesh is a distributed mesh.
:rtype: Mesh
:returns: :cpp:any:`Mesh`  The refined mesh.
";

%feature("docstring") dolfin::refine(const Mesh &mesh, const MeshFunction< bool > &cell_markers, bool redistribute=true) "
Create locally refined mesh

::
   
   CellFunction<bool> cell_markers(mesh);
   cell_markers.set_all(false);
   Point origin(0.0, 0.0, 0.0);
   for (CellIterator cell(mesh); !cell.end(); ++cell)
   {
   Point p = cell->midpoint();
   if (p.distance(origin) < 0.1)
   cell_markers[*cell] = true;
   }
   mesh = refine(mesh, cell_markers);

:param const Mesh & mesh:  (:cpp:any:`Mesh` ) The mesh to refine.
:param const MeshFunction< bool > & cell_markers:  (MeshFunction<bool>) A mesh function over booleans specifying which cells that should be refined (and which should not).
:param bool redistribute:  (bool) Optional argument to redistribute the refined mesh if mesh is a distributed mesh.
:rtype: Mesh
:returns: :cpp:any:`Mesh`  The locally refined mesh.
";

%feature("docstring") dolfin::refine(const MeshHierarchy &hierarchy, const MeshFunction< bool > &markers) "
Refine a :cpp:any:`MeshHierarchy` . 

:param const MeshHierarchy & hierarchy: 
:param const MeshFunction< bool > & markers: 
:rtype: std::shared_ptr< const MeshHierarchy >
";

