// This code conforms with the UFC specification version 2017.1.0
// and was automatically generated by FFC version 2017.1.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
// 
// This code was generated with the following parameters:
// 
//   add_tabulate_tensor_timing:     False
//   convert_exceptions_to_warnings: False
//   cpp_optimize:                   True
//   cpp_optimize_flags:             '-O2'
//   epsilon:                        1e-14
//   error_control:                  False
//   form_postfix:                   True
//   format:                         'dolfin'
//   generate_dummy_tabulate_tensor: False
//   max_signature_length:           0
//   optimize:                       True
//   precision:                      None
//   quadrature_degree:              None
//   quadrature_rule:                None
//   representation:                 'auto'
//   split:                          True

#include "Poisson2D_4.h"

poisson2d_4_finite_element_0::poisson2d_4_finite_element_0() : ufc::finite_element()
{
    // Do nothing
}

poisson2d_4_finite_element_0::~poisson2d_4_finite_element_0()
{
    // Do nothing
}

const char * poisson2d_4_finite_element_0::signature() const
{
    return "FiniteElement('Lagrange', triangle, 1)";
}

ufc::shape poisson2d_4_finite_element_0::cell_shape() const
{
    return ufc::shape::triangle;
}

std::size_t poisson2d_4_finite_element_0::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_0::geometric_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_0::space_dimension() const
{
    return 3;
}

std::size_t poisson2d_4_finite_element_0::value_rank() const
{
    return 0;
}

std::size_t poisson2d_4_finite_element_0::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_0::value_size() const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_0::reference_value_rank() const
{
    return 0;
}

std::size_t poisson2d_4_finite_element_0::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_0::reference_value_size() const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_0::degree() const
{
    return 1;
}

const char * poisson2d_4_finite_element_0::family() const
{
    return "Lagrange";
}

void poisson2d_4_finite_element_0::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_4_finite_element_0::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson2d_4_finite_element_0::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_4_finite_element_0::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 3; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[2];
    for (unsigned int r = 0; r < 2; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson2d_4_finite_element_0::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson2d_4_finite_element_0::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
}

void poisson2d_4_finite_element_0::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
}

void poisson2d_4_finite_element_0::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
}

std::size_t poisson2d_4_finite_element_0::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson2d_4_finite_element_0::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson2d_4_finite_element_0::create() const
{
    return new poisson2d_4_finite_element_0();
}


poisson2d_4_finite_element_1::poisson2d_4_finite_element_1() : ufc::finite_element()
{
    // Do nothing
}

poisson2d_4_finite_element_1::~poisson2d_4_finite_element_1()
{
    // Do nothing
}

const char * poisson2d_4_finite_element_1::signature() const
{
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
}

ufc::shape poisson2d_4_finite_element_1::cell_shape() const
{
    return ufc::shape::triangle;
}

std::size_t poisson2d_4_finite_element_1::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_1::geometric_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_1::space_dimension() const
{
    return 6;
}

std::size_t poisson2d_4_finite_element_1::value_rank() const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_1::value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_finite_element_1::value_size() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_1::reference_value_rank() const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_1::reference_value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_finite_element_1::reference_value_size() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_1::degree() const
{
    return 1;
}

const char * poisson2d_4_finite_element_1::family() const
{
    return "Lagrange";
}

void poisson2d_4_finite_element_1::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_4_finite_element_1::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2; s++)
      {
        values[r*2 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

void poisson2d_4_finite_element_1::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 2*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_4_finite_element_1::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 6; r++)
    {
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[4];
    for (unsigned int r = 0; r < 4; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson2d_4_finite_element_1::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 4:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 5:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    }
    
    return 0.0;
}

void poisson2d_4_finite_element_1::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    values[5] = vals[1];
}

void poisson2d_4_finite_element_1::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
}

void poisson2d_4_finite_element_1::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[0];
    dof_coordinates[7] = coordinate_dofs[1];
    dof_coordinates[8] = coordinate_dofs[2];
    dof_coordinates[9] = coordinate_dofs[3];
    dof_coordinates[10] = coordinate_dofs[4];
    dof_coordinates[11] = coordinate_dofs[5];
}

std::size_t poisson2d_4_finite_element_1::num_sub_elements() const
{
    return 2;
}

ufc::finite_element * poisson2d_4_finite_element_1::create_sub_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_4_finite_element_0();
        break;
      }
    case 1:
      {
        return new poisson2d_4_finite_element_0();
        break;
      }
    }
    
    return 0;
}

ufc::finite_element * poisson2d_4_finite_element_1::create() const
{
    return new poisson2d_4_finite_element_1();
}


poisson2d_4_finite_element_2::poisson2d_4_finite_element_2() : ufc::finite_element()
{
    // Do nothing
}

poisson2d_4_finite_element_2::~poisson2d_4_finite_element_2()
{
    // Do nothing
}

const char * poisson2d_4_finite_element_2::signature() const
{
    return "FiniteElement('Lagrange', triangle, 4)";
}

ufc::shape poisson2d_4_finite_element_2::cell_shape() const
{
    return ufc::shape::triangle;
}

std::size_t poisson2d_4_finite_element_2::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_2::geometric_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_finite_element_2::space_dimension() const
{
    return 15;
}

std::size_t poisson2d_4_finite_element_2::value_rank() const
{
    return 0;
}

std::size_t poisson2d_4_finite_element_2::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_2::value_size() const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_2::reference_value_rank() const
{
    return 0;
}

std::size_t poisson2d_4_finite_element_2::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_2::reference_value_size() const
{
    return 1;
}

std::size_t poisson2d_4_finite_element_2::degree() const
{
    return 4;
}

const char * poisson2d_4_finite_element_2::family() const
{
    return "Lagrange";
}

void poisson2d_4_finite_element_2::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.0, -0.04123930494211609, -0.02380952380952382, 0.02898002949762782, 0.02244783432338244, 0.01296026318932897, -0.03959425806109992, -0.03346325566315744, -0.02592052637865797, -0.01496522288225497, 0.03212472543663117, 0.02833134481385229, 0.02394435661160796, 0.01854721887848184, 0.0107082418122104};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.0, 0.04123930494211613, -0.02380952380952378, 0.02898002949762785, -0.02244783432338247, 0.01296026318932898, 0.0395942580610999, -0.03346325566315744, 0.02592052637865797, -0.01496522288225497, 0.03212472543663116, -0.0283313448138523, 0.02394435661160794, -0.01854721887848182, 0.01070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.0, 0.0, 0.04761904761904767, 0.0, 0.0, 0.038880789567987, 0.0, 0.0, 0.0, 0.05986089152901988, 0.0, 0.0, 0.0, 0.0, 0.05354120906105191};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109417, 0.1319657758147715, -0.02539682539682531, 0.1391041415886136, -0.07183306983482386, 0.0311046316543896, 0.06335081289775987, 0.02677060453052593, -0.0622092633087791, 0.04788871322321588, 0.0, 0.05666268962770458, -0.08380524814062787, 0.08346248495316817, -0.05354120906105193};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {-0.03142696805273548, 0.01099714798456442, 0.006349206349206469, 0.0, 0.1885618083164127, -0.1632993161855451, 0.0, 0.09369711585684087, 0.0, -0.04190262407031398, 0.0, 0.0, 0.08380524814062781, -0.1391041415886136, 0.1070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109417, 0.0439885919382572, 0.1269841269841269, 0.0, 0.03591653491741195, 0.1555231582719478, 0.0, 0.0, 0.1036821055146319, -0.01197217830580397, 0.0, 0.0, 0.0, 0.09273609439240908, -0.1070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109418, -0.1319657758147717, -0.0253968253968254, 0.1391041415886137, 0.07183306983482388, 0.03110463165438955, -0.06335081289775983, 0.02677060453052595, 0.06220926330877918, 0.04788871322321592, 0.0, -0.05666268962770455, -0.08380524814062786, -0.08346248495316819, -0.05354120906105191};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {-0.0314269680527354, -0.01099714798456426, 0.006349206349206462, 0.0, -0.1885618083164127, -0.1632993161855451, 0.0, 0.09369711585684086, 0.0, -0.04190262407031396, 0.0, 0.0, 0.08380524814062786, 0.1391041415886136, 0.1070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109418, -0.04398859193825722, 0.126984126984127, 0.0, -0.03591653491741193, 0.1555231582719477, 0.0, 0.0, -0.1036821055146319, -0.01197217830580399, 0.0, 0.0, 0.0, -0.09273609439240911, -0.1070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.125707872210942, -0.08797718387651439, -0.1015873015873016, 0.09273609439240908, 0.1077496047522359, 0.07257747386024233, 0.07918851612219981, -0.01338530226526298, -0.05184105275731595, -0.04190262407031393, -0.1284989017465246, -0.0566626896277046, -0.01197217830580396, 0.009273609439240882, 0.01070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {-0.03142696805273535, 0.0, -0.01269841269841262, -0.2434322477800738, 0.0, 0.05443310539518173, 0.0, 0.09369711585684086, 0.0, -0.04190262407031396, 0.1927483526197869, 0.0, -0.02394435661160798, 0.0, 0.0107082418122104};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.125707872210942, 0.08797718387651435, -0.1015873015873016, 0.09273609439240904, -0.1077496047522359, 0.07257747386024228, -0.07918851612219983, -0.01338530226526299, 0.05184105275731593, -0.04190262407031391, -0.1284989017465246, 0.05666268962770457, -0.01197217830580397, -0.009273609439240903, 0.01070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.2514157444218837, -0.3519087355060576, -0.2031746031746033, -0.1391041415886136, -0.1077496047522358, -0.06220926330877913, 0.1900524386932795, -0.02677060453052593, 0.1244185266175582, 0.1556383179754517, 0.0, 0.1699880688831137, 0.08380524814062784, -0.02782082831772272, -0.05354120906105193};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.2514157444218835, 0.3519087355060574, -0.2031746031746032, -0.1391041415886136, 0.1077496047522357, -0.06220926330877918, -0.1900524386932795, -0.02677060453052594, -0.1244185266175582, 0.1556383179754517, 0.0, -0.1699880688831137, 0.08380524814062784, 0.02782082831772271, -0.0535412090610519};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.2514157444218835, 0.0, 0.4063492063492063, 0.0, 0.0, -0.1866277899263374, 0.0, -0.1873942317136817, 0.0, -0.2035270311986676, 0.0, 0.0, -0.1676104962812557, 0.0, 0.1070824181221038};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 15; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_4_finite_element_2::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 15; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson2d_4_finite_element_2::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 4)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[16][4];
    for (unsigned int row = 0; row < 16; row++)
    {
      for (unsigned int col = 0; col < 4; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[16][16];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.0, -0.04123930494211609, -0.02380952380952382, 0.02898002949762782, 0.02244783432338244, 0.01296026318932897, -0.03959425806109992, -0.03346325566315744, -0.02592052637865797, -0.01496522288225497, 0.03212472543663117, 0.02833134481385229, 0.02394435661160796, 0.01854721887848184, 0.0107082418122104};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.0, 0.04123930494211613, -0.02380952380952378, 0.02898002949762785, -0.02244783432338247, 0.01296026318932898, 0.0395942580610999, -0.03346325566315744, 0.02592052637865797, -0.01496522288225497, 0.03212472543663116, -0.0283313448138523, 0.02394435661160794, -0.01854721887848182, 0.01070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.0, 0.0, 0.04761904761904767, 0.0, 0.0, 0.038880789567987, 0.0, 0.0, 0.0, 0.05986089152901988, 0.0, 0.0, 0.0, 0.0, 0.05354120906105191};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109417, 0.1319657758147715, -0.02539682539682531, 0.1391041415886136, -0.07183306983482386, 0.0311046316543896, 0.06335081289775987, 0.02677060453052593, -0.0622092633087791, 0.04788871322321588, 0.0, 0.05666268962770458, -0.08380524814062787, 0.08346248495316817, -0.05354120906105193};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {-0.03142696805273548, 0.01099714798456442, 0.006349206349206469, 0.0, 0.1885618083164127, -0.1632993161855451, 0.0, 0.09369711585684087, 0.0, -0.04190262407031398, 0.0, 0.0, 0.08380524814062781, -0.1391041415886136, 0.1070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109417, 0.0439885919382572, 0.1269841269841269, 0.0, 0.03591653491741195, 0.1555231582719478, 0.0, 0.0, 0.1036821055146319, -0.01197217830580397, 0.0, 0.0, 0.0, 0.09273609439240908, -0.1070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109418, -0.1319657758147717, -0.0253968253968254, 0.1391041415886137, 0.07183306983482388, 0.03110463165438955, -0.06335081289775983, 0.02677060453052595, 0.06220926330877918, 0.04788871322321592, 0.0, -0.05666268962770455, -0.08380524814062786, -0.08346248495316819, -0.05354120906105191};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {-0.0314269680527354, -0.01099714798456426, 0.006349206349206462, 0.0, -0.1885618083164127, -0.1632993161855451, 0.0, 0.09369711585684086, 0.0, -0.04190262407031396, 0.0, 0.0, 0.08380524814062786, 0.1391041415886136, 0.1070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.1257078722109418, -0.04398859193825722, 0.126984126984127, 0.0, -0.03591653491741193, 0.1555231582719477, 0.0, 0.0, -0.1036821055146319, -0.01197217830580399, 0.0, 0.0, 0.0, -0.09273609439240911, -0.1070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.125707872210942, -0.08797718387651439, -0.1015873015873016, 0.09273609439240908, 0.1077496047522359, 0.07257747386024233, 0.07918851612219981, -0.01338530226526298, -0.05184105275731595, -0.04190262407031393, -0.1284989017465246, -0.0566626896277046, -0.01197217830580396, 0.009273609439240882, 0.01070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {-0.03142696805273535, 0.0, -0.01269841269841262, -0.2434322477800738, 0.0, 0.05443310539518173, 0.0, 0.09369711585684086, 0.0, -0.04190262407031396, 0.1927483526197869, 0.0, -0.02394435661160798, 0.0, 0.0107082418122104};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.125707872210942, 0.08797718387651435, -0.1015873015873016, 0.09273609439240904, -0.1077496047522359, 0.07257747386024228, -0.07918851612219983, -0.01338530226526299, 0.05184105275731593, -0.04190262407031391, -0.1284989017465246, 0.05666268962770457, -0.01197217830580397, -0.009273609439240903, 0.01070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.2514157444218837, -0.3519087355060576, -0.2031746031746033, -0.1391041415886136, -0.1077496047522358, -0.06220926330877913, 0.1900524386932795, -0.02677060453052593, 0.1244185266175582, 0.1556383179754517, 0.0, 0.1699880688831137, 0.08380524814062784, -0.02782082831772272, -0.05354120906105193};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.2514157444218835, 0.3519087355060574, -0.2031746031746032, -0.1391041415886136, 0.1077496047522357, -0.06220926330877918, -0.1900524386932795, -0.02677060453052594, -0.1244185266175582, 0.1556383179754517, 0.0, -0.1699880688831137, 0.08380524814062784, 0.02782082831772271, -0.0535412090610519};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[15] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[10] *= std::sqrt(22.5);
      
      // Table(s) of coefficients
      static const double coefficients0[15] = \
      {0.2514157444218835, 0.0, 0.4063492063492063, 0.0, 0.0, -0.1866277899263374, 0.0, -0.1873942317136817, 0.0, -0.2035270311986676, 0.0, 0.0, -0.1676104962812557, 0.0, 0.1070824181221038};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.898979485566348, 1.238823858310903e-15, -1.332267629550188e-15, -3.286204293672685e-15, 7.105612375501081e-15, -2.664535259100376e-15, -1.324178266642867e-15, 1.313101623166422e-15, 0.0, 2.220446049250313e-15, 0.0, 2.388191194543593e-15, -3.34549074204744e-15, 1.590637682871179e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-6.530780316104644e-15, 9.486832980505147, 3.569983814739114e-15, -1.979151444214857e-15, 0.0, 0.0, 0.0, 0.0, 3.108624468950438e-15, -1.070963161872696e-15, -2.252511559354121e-15, -2.007530442841236e-15, 0.0, 0.0, 0.0},
      {3.999999999999994, 0.0, 7.071067811865468, -1.55659452674745e-15, 8.126832540256141e-15, -1.77635683940025e-15, -1.21151107042532e-15, 0.0, 1.373686382305103e-15, 1.77635683940025e-15, 0.0, 3.517437043353566e-15, -1.177992888419994e-15, 3.988642673506642e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212921, -6.058441774868359e-14, -2.993325909419169, 13.66260102127947, 1.364279788597637e-14, 0.6110100926607878, 0.0, -1.766450905855439e-15, -4.447003927688252e-15, -3.774758283725532e-15, 3.845792673898214e-15, -1.886215085258661e-15, 0.0, 3.922010646794456e-15, 3.05311331771918e-15},
      {-1.024455667325484e-14, 4.38178046004133, 0.0, 2.786444219247522e-15, 12.52198067399884, -8.070204649155281e-15, -1.32676831391953e-15, -1.395284729139431e-15, 0.0, -2.806320113512194e-15, 0.0, 4.755380105654132e-15, 0.0, 8.881784197001249e-15, -3.499258496133367e-15},
      {3.464101615137766, -2.043578417809944e-15, 7.838367176906182, 1.7325955362807e-15, 4.836661802407712e-15, 8.40000000000002, 0.0, 0.0, 2.590520390792035e-15, 5.329070518200751e-15, 0.0, 0.0, 2.855565105181162e-15, 5.786735712501032e-15, 7.105427357601002e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-5.595185198247997e-14, 10.95445115010331, 3.832839649474063e-14, -8.730238864208682e-14, -3.833259389999649, -1.929749827221824e-14, 17.74823934929884, 1.719500595523367e-14, 0.5532833351724962, 4.634114436467015e-15, -2.440092449805629e-15, -6.865939685224573e-15, -4.535711111298265e-15, -6.217248937900877e-15, -2.625343358346824e-15},
      {4.732863826479687, -4.046375622522198e-14, 3.346640106136291, 4.364357804719845, -6.803961224120785e-14, -5.074680379332367, 1.563250101977366e-15, 17.00840128541521, 1.792542765488324e-14, 1.521277658511321, 0.0, -1.650005061923725e-15, -2.811715173325994e-15, 3.757212009238235e-15, -2.664535259100376e-15},
      {-1.218599366216833e-14, 2.449489742783166, -1.049566633524492e-14, -1.09956357087579e-15, 9.142857142857078, -1.779608168072724e-14, 0.0, 0.0, 14.84614977916181, -4.816401051503851e-15, 0.0, 6.019343723876346e-15, -2.802156654861205e-15, 7.105427357600996e-15, -8.959682927405492e-15},
      {3.098386676965947, 1.220080089515621e-15, 7.668115805072359, 0.0, 6.906153928538213e-15, 10.73312629199903, 0.0, 0.0, 2.67012053328765e-15, 9.295160030897799, 0.0, -1.358776429876508e-15, 1.378498794498087e-15, 2.393455803921077e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[15][15] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783181, 0.0, 0.0, -1.754124449298855e-15, 2.886672372975448e-15, 0.0, 0.0, 0.0, 0.0, 1.110223024625157e-15, 0.0, 1.305117899734311e-15, -1.672745371023716e-15, 0.0, 0.0},
      {4.242640687119284, 1.317742747864049e-15, -1.77635683940025e-15, -3.559896471226239e-15, 6.542505032805864e-15, 0.0, -1.021943464671144e-15, 1.637847641719053e-15, 0.0, 1.77635683940025e-15, 0.0, 2.262666346657473e-15, -2.842054967065505e-15, 1.94061519658002e-15, 1.332267629550188e-15},
      {2.581988897471618, 4.743416490252574, -0.91287092917528, -3.35053437291186e-15, 3.309285315581404e-15, 0.0, 0.0, 0.0, 1.399852009170672e-15, 0.0, -1.126255779677061e-15, 0.0, -2.42120946029811e-15, 1.4909370034862e-15, 1.27675647831893e-15},
      {1.999999999999911, 6.123724356957937, 3.535533905932737, -1.760968652903856e-15, 5.839773109528307e-15, 0.0, -1.531104247124066e-15, 0.0, 1.575021610852655e-15, 2.220446049250313e-15, -1.381169190030412e-15, 0.0, 0.0, 1.994321336753309e-15, 0.0},
      {-2.309401076758488, -3.131212955692769e-15, 8.16496580927727, 3.867200129077475e-15, 1.086063271653671e-15, 7.105427357601002e-15, 0.0, 0.0, 1.517304800321052e-15, 1.77635683940025e-15, 0.0, 0.0, 3.005176989264066e-15, 2.449278646400455e-15, 3.552713678800501e-15},
      {2.645751311064579, 5.184592558726252, -1.496662954709568, 6.831300510639735, -1.058300524425832, 0.3055050463303929, 0.0, -3.081078026372754e-15, 0.0, -1.387778780781446e-15, 1.567560525838334e-15, -3.658770786178837e-15, 1.221613829511741e-15, 0.0, 2.747801985947262e-15},
      {2.23606797749983, 2.19089023002066, 2.529822128134687, 8.082903768654784, 6.260990336999423, -1.807392228230117, 1.404065792660075e-15, -2.527563045285392e-15, -3.881677075195862e-15, 1.998401444325282e-15, 0.0, 1.813979259155712e-15, 1.637627683023893e-15, 8.543252611825762e-15, 4.884981308350689e-15},
      {1.732050807568886, -5.091168824543144, 3.919183588453092, 3.070548803284479e-15, 9.699484522385703, 4.200000000000017, 0.0, 0.0, 0.0, 5.329070518200751e-15, 1.116471102225203e-15, 3.326388007084153e-15, 2.159782009096403e-15, 6.001992325200953e-15, 7.549516567451064e-15},
      {5.000000000000028, 0.0, -2.828427124746231, 0.0, 4.662936703425651e-15, 12.12435565298217, 0.0, 0.0, 0.0, 0.0, 1.998401444325283e-15, -2.205123015276571e-15, 1.003441157326127e-15, 3.005404525014909e-15, 0.0},
      {2.683281572999722, 5.477225575051648, -1.897366596101009, 7.423074889580866, -1.916629694999825, 0.6639400022069775, 8.874119674649426, -1.071428571428564, 0.2766416675862469, -0.09583148474998932, 0.0, -6.720626467516752e-15, -2.712811039751159e-15, -2.032053291336994e-15, 0.0},
      {2.366431913239829, 2.898275349237851, 1.673320053068147, 2.182178902359859, 5.747048932153885, -2.537340189666181, 10.06230589874905, 8.50420064270763, -2.195775164134187, 0.7606388292556634, -2.421802605689141e-15, -1.85497435870004e-15, -2.824701356329695e-15, 2.54473981939421e-15, -1.77635683940025e-15},
      {1.999999999999997, 1.224744871391584, 3.535533905932719, -7.377111135633236, 4.571428571428534, 1.649572197684664, 2.228307339267934e-15, 11.49977816999893, 7.423074889580906, -2.571428571428573, -1.862740687086425e-15, 2.716596139415403e-15, 2.713878504639256e-15, 5.030333335479081e-15, 2.886579864025407e-15},
      {1.54919333848291, 6.640783086353566, 3.834057902536165, -6.501415628293559e-15, -6.196773353931827, 5.366563145999518, -1.752385659064879e-15, 3.365949822121732e-15, 13.41640786499873, 4.647580015448903, -1.798452618387343e-15, -2.204624327919271e-15, -2.890073582726584e-15, -1.02371814728979e-15, 4.440892098500626e-15},
      {-3.577708763999691, 2.982462755387514e-15, 8.854377448471439, -1.660191126960419e-15, 0.0, -3.098386676965972, 0.0, 2.148728361209683e-15, 0.0, 16.09968943799848, 0.0, 0.0, -1.428958395713987e-15, -1.908951112388748e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[15][15] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 15; t++)
        {
          for (unsigned int u = 0; u < 15; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 15; t++)
          {
            for (unsigned int u = 0; u < 15; u++)
            {
              for (unsigned int tu = 0; tu < 15; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 15; s++)
        {
          for (unsigned int t = 0; t < 15; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_4_finite_element_2::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 15; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 4)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[16];
    for (unsigned int r = 0; r < 16; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 15; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson2d_4_finite_element_2::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
      y[1] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 4:
      {
        y[0] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 5:
      {
        y[0] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 6:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 7:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 8:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 9:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 10:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 11:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 12:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 13:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 14:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson2d_4_finite_element_2::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    y[1] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
    y[0] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0];
    y[0] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0];
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[6] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[7] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[8] = vals[0];
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[9] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[10] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[11] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[12] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[13] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[14] = vals[0];
}

void poisson2d_4_finite_element_2::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
}

void poisson2d_4_finite_element_2::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    dof_coordinates[7] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    dof_coordinates[8] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
    dof_coordinates[9] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
    dof_coordinates[10] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
    dof_coordinates[11] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
    dof_coordinates[12] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
    dof_coordinates[13] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
    dof_coordinates[14] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
    dof_coordinates[15] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
    dof_coordinates[16] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
    dof_coordinates[17] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
    dof_coordinates[18] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
    dof_coordinates[19] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
    dof_coordinates[20] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
    dof_coordinates[21] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
    dof_coordinates[22] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
    dof_coordinates[23] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
    dof_coordinates[24] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    dof_coordinates[25] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    dof_coordinates[26] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    dof_coordinates[27] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    dof_coordinates[28] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
    dof_coordinates[29] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
}

std::size_t poisson2d_4_finite_element_2::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson2d_4_finite_element_2::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson2d_4_finite_element_2::create() const
{
    return new poisson2d_4_finite_element_2();
}


poisson2d_4_dofmap_0::poisson2d_4_dofmap_0() : ufc::dofmap()
{
    // Do nothing
}

poisson2d_4_dofmap_0::~poisson2d_4_dofmap_0()
{
    // Do nothing
}

const char * poisson2d_4_dofmap_0::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
}

bool poisson2d_4_dofmap_0::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson2d_4_dofmap_0::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_dofmap_0::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0];
}

std::size_t poisson2d_4_dofmap_0::num_element_dofs() const
{
    return 3;
}

std::size_t poisson2d_4_dofmap_0::num_facet_dofs() const
{
    return 2;
}

std::size_t poisson2d_4_dofmap_0::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_dofmap_0::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

void poisson2d_4_dofmap_0::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
}

void poisson2d_4_dofmap_0::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
        break;
      }
    }
    
}

void poisson2d_4_dofmap_0::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
}

void poisson2d_4_dofmap_0::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    }
    
}

std::size_t poisson2d_4_dofmap_0::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson2d_4_dofmap_0::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson2d_4_dofmap_0::create() const
{
    return new poisson2d_4_dofmap_0();
}


poisson2d_4_dofmap_1::poisson2d_4_dofmap_1() : ufc::dofmap()
{
    // Do nothing
}

poisson2d_4_dofmap_1::~poisson2d_4_dofmap_1()
{
    // Do nothing
}

const char * poisson2d_4_dofmap_1::signature() const
{
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
}

bool poisson2d_4_dofmap_1::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson2d_4_dofmap_1::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_dofmap_1::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return 2*num_global_entities[0];
}

std::size_t poisson2d_4_dofmap_1::num_element_dofs() const
{
    return 6;
}

std::size_t poisson2d_4_dofmap_1::num_facet_dofs() const
{
    return 4;
}

std::size_t poisson2d_4_dofmap_1::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_dofmap_1::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 4;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
}

void poisson2d_4_dofmap_1::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
}

void poisson2d_4_dofmap_1::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 5;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 5;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 4;
        break;
      }
    }
    
}

void poisson2d_4_dofmap_1::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
}

void poisson2d_4_dofmap_1::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
        break;
      }
    }
    
}

std::size_t poisson2d_4_dofmap_1::num_sub_dofmaps() const
{
    return 2;
}

ufc::dofmap * poisson2d_4_dofmap_1::create_sub_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_4_dofmap_0();
        break;
      }
    case 1:
      {
        return new poisson2d_4_dofmap_0();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson2d_4_dofmap_1::create() const
{
    return new poisson2d_4_dofmap_1();
}


poisson2d_4_dofmap_2::poisson2d_4_dofmap_2() : ufc::dofmap()
{
    // Do nothing
}

poisson2d_4_dofmap_2::~poisson2d_4_dofmap_2()
{
    // Do nothing
}

const char * poisson2d_4_dofmap_2::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 4)";
}

bool poisson2d_4_dofmap_2::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return true;
        break;
      }
    case 2:
      {
        return true;
        break;
      }
    }
    
    return false;
}

std::size_t poisson2d_4_dofmap_2::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_4_dofmap_2::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0] + 3*num_global_entities[1] + 3*num_global_entities[2];
}

std::size_t poisson2d_4_dofmap_2::num_element_dofs() const
{
    return 15;
}

std::size_t poisson2d_4_dofmap_2::num_facet_dofs() const
{
    return 5;
}

std::size_t poisson2d_4_dofmap_2::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 3;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_dofmap_2::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 5;
        break;
      }
    case 2:
      {
        return 15;
        break;
      }
    }
    
    return 0;
}

void poisson2d_4_dofmap_2::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + 3*entity_indices[1][0];
    dofs[4] = offset + 3*entity_indices[1][0] + 1;
    dofs[5] = offset + 3*entity_indices[1][0] + 2;
    dofs[6] = offset + 3*entity_indices[1][1];
    dofs[7] = offset + 3*entity_indices[1][1] + 1;
    dofs[8] = offset + 3*entity_indices[1][1] + 2;
    dofs[9] = offset + 3*entity_indices[1][2];
    dofs[10] = offset + 3*entity_indices[1][2] + 1;
    dofs[11] = offset + 3*entity_indices[1][2] + 2;
    offset += 3*num_global_entities[1];
    dofs[12] = offset + 3*entity_indices[2][0];
    dofs[13] = offset + 3*entity_indices[2][0] + 1;
    dofs[14] = offset + 3*entity_indices[2][0] + 2;
    offset += 3*num_global_entities[2];
}

void poisson2d_4_dofmap_2::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 6;
      dofs[3] = 7;
      dofs[4] = 8;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 9;
      dofs[3] = 10;
      dofs[4] = 11;
        break;
      }
    }
    
}

void poisson2d_4_dofmap_2::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
          break;
        }
      case 2:
        {
          dofs[0] = 9;
        dofs[1] = 10;
        dofs[2] = 11;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 12;
      dofs[1] = 13;
      dofs[2] = 14;
        break;
      }
    }
    
}

void poisson2d_4_dofmap_2::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 6;
        dofs[3] = 7;
        dofs[4] = 8;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 9;
        dofs[3] = 10;
        dofs[4] = 11;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
      dofs[12] = 12;
      dofs[13] = 13;
      dofs[14] = 14;
        break;
      }
    }
    
}

std::size_t poisson2d_4_dofmap_2::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson2d_4_dofmap_2::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson2d_4_dofmap_2::create() const
{
    return new poisson2d_4_dofmap_2();
}


poisson2d_4_cell_integral_0_otherwise::poisson2d_4_cell_integral_0_otherwise() : ufc::cell_integral()
{

}

poisson2d_4_cell_integral_0_otherwise::~poisson2d_4_cell_integral_0_otherwise()
{

}

const std::vector<bool> & poisson2d_4_cell_integral_0_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({});
return enabled;
}

void poisson2d_4_cell_integral_0_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 6
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 6
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           6
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.3730158730158794 * sp[19] + 0.3730158730158794 * sp[18] + 0.3730158730158794 * sp[18] + 0.3730158730158792 * sp[17];
    A[1] = 0.05661375661375733 * sp[19] + 0.05661375661375646 * sp[18];
    A[2] = 0.05661375661375713 * sp[18] + 0.05661375661375675 * sp[17];
    A[3] = 0.0423280423280426 * sp[19] + 0.042328042328041 * sp[18] + 0.04232804232804087 * sp[18] + 0.04232804232803822 * sp[17];
    A[4] = 0.04232804232804441 * sp[19] + 0.04232804232804562 * sp[18] + 0.04232804232804541 * sp[18] + 0.04232804232804688 * sp[17];
    A[5] = 0.04232804232804346 * sp[19] + 0.04232804232804374 * sp[18] + 0.04232804232804203 * sp[18] + 0.04232804232804259 * sp[17];
    A[6] = 0.1269841269841298 * sp[19] + -0.6518518518518617 * sp[18] + 0.12698412698413 * sp[18] + -0.651851851851861 * sp[17];
    A[7] = 0.04232804232804231 * sp[19] + 0.467724867724873 * sp[18] + 0.04232804232804389 * sp[18] + 0.4677248677248733 * sp[17];
    A[8] = -0.04232804232804346 * sp[19] + -0.2455026455026482 * sp[18] + -0.04232804232804203 * sp[18] + -0.2455026455026482 * sp[17];
    A[9] = -0.651851851851863 * sp[19] + 0.1269841269841287 * sp[18] + -0.6518518518518631 * sp[18] + 0.1269841269841284 * sp[17];
    A[10] = 0.4677248677248747 * sp[19] + 0.04232804232804291 * sp[18] + 0.4677248677248747 * sp[18] + 0.0423280423280419 * sp[17];
    A[11] = -0.2455026455026483 * sp[19] + -0.0423280423280433 * sp[18] + -0.2455026455026473 * sp[18] + -0.04232804232804049 * sp[17];
    A[12] = -0.08465608465608851 * sp[19] + -0.08465608465608714 * sp[18] + -0.08465608465608886 * sp[18] + -0.08465608465608486 * sp[17];
    A[13] = -0.08465608465608353 * sp[19] + -0.08465608465608625 * sp[18] + -0.08465608465608174 * sp[18] + -0.08465608465608651 * sp[17];
    A[14] = -0.08465608465608657 * sp[19] + -0.08465608465608507 * sp[18] + -0.08465608465608915 * sp[18] + -0.08465608465608589 * sp[17];
    A[15] = 0.05661375661375733 * sp[19] + 0.05661375661375646 * sp[18];
    A[16] = 0.373015873015875 * sp[19];
    A[17] = -0.05661375661375703 * sp[18];
    A[18] = 0.1269841269841254 * sp[19] + 0.7788359788359824 * sp[18];
    A[19] = 0.04232804232804347 * sp[19] + -0.4253968253968284 * sp[18];
    A[20] = -0.04232804232804408 * sp[19] + 0.2031746031746025 * sp[18];
    A[21] = 0.0423280423280448 * sp[19];
    A[22] = 0.04232804232804565 * sp[19];
    A[23] = 0.0423280423280441 * sp[19];
    A[24] = -0.2455026455026465 * sp[19] + -0.2031746031746039 * sp[18];
    A[25] = 0.4677248677248682 * sp[19] + 0.4253968253968259 * sp[18];
    A[26] = -0.6518518518518541 * sp[19] + -0.7788359788359813 * sp[18];
    A[27] = -0.0846560846560894 * sp[19];
    A[28] = -0.0846560846560807 * sp[19];
    A[29] = -0.08465608465608934 * sp[19];
    A[30] = 0.05661375661375713 * sp[18] + 0.05661375661375675 * sp[17];
    A[31] = -0.05661375661375703 * sp[18];
    A[32] = 0.3730158730158759 * sp[17];
    A[33] = 0.2031746031746057 * sp[18] + -0.04232804232804197 * sp[17];
    A[34] = -0.4253968253968314 * sp[18] + 0.04232804232804099 * sp[17];
    A[35] = 0.7788359788359865 * sp[18] + 0.1269841269841289 * sp[17];
    A[36] = -0.2031746031746052 * sp[18] + -0.2455026455026474 * sp[17];
    A[37] = 0.4253968253968309 * sp[18] + 0.4677248677248724 * sp[17];
    A[38] = -0.7788359788359868 * sp[18] + -0.6518518518518578 * sp[17];
    A[39] = 0.0423280423280431 * sp[17];
    A[40] = 0.04232804232804576 * sp[17];
    A[41] = 0.04232804232804355 * sp[17];
    A[42] = -0.08465608465608671 * sp[17];
    A[43] = -0.08465608465609038 * sp[17];
    A[44] = -0.08465608465608419 * sp[17];
    A[45] = 0.0423280423280426 * sp[19] + 0.04232804232804087 * sp[18] + 0.042328042328041 * sp[18] + 0.04232804232803822 * sp[17];
    A[46] = 0.1269841269841254 * sp[19] + 0.7788359788359824 * sp[18];
    A[47] = 0.2031746031746057 * sp[18] + -0.04232804232804197 * sp[17];
    A[48] = 1.828571428571442 * sp[19] + 1.049735449735454 * sp[18] + 1.049735449735454 * sp[18] + 2.099470899470913 * sp[17];
    A[49] = -0.6603174603174647 * sp[19] + 0.8211640211640286 * sp[18] + -0.2962962962962956 * sp[18] + -0.7619047619047693 * sp[17];
    A[50] = 0.3386243386243473 * sp[19] + -0.4402116402116382 * sp[18] + 0.1015873015873046 * sp[18] + 0.3386243386243434 * sp[17];
    A[51] = -0.2031746031746093 * sp[19] + -0.1015873015873001 * sp[18] + -0.101587301587307 * sp[18];
    A[52] = -0.1523809523809613 * sp[19] + -0.04232804232804616 * sp[18] + -0.04232804232803838 * sp[18];
    A[53] = -0.3386243386243472 * sp[19] + -0.1015873015872931 * sp[18] + -0.1015873015873045 * sp[18];
    A[54] = -0.1354497354497389 * sp[19] + -0.2370370370370499 * sp[18] + -0.2370370370370341 * sp[18] + -0.3386243386243479 * sp[17];
    A[55] = 0.1015873015873061 * sp[19] + 0.4656084656084772 * sp[18] + 0.4656084656084598 * sp[18] + 0.7619047619047642 * sp[17];
    A[56] = -0.1354497354497352 * sp[19] + -1.049735449735449 * sp[18] + -1.04973544973545 * sp[18] + -2.099470899470908 * sp[17];
    A[57] = 0.8126984126984362 * sp[19] + 0.3386243386243547 * sp[18] + 0.3386243386243503 * sp[18];
    A[58] = -2.438095238095269 * sp[19] + -1.28677248677251 * sp[18] + -1.286772486772497 * sp[18];
    A[59] = 0.8126984126984257 * sp[19] + 0.3386243386243221 * sp[18] + 0.3386243386243336 * sp[18];
    A[60] = 0.04232804232804441 * sp[19] + 0.04232804232804541 * sp[18] + 0.04232804232804562 * sp[18] + 0.04232804232804688 * sp[17];
    A[61] = 0.04232804232804347 * sp[19] + -0.4253968253968284 * sp[18];
    A[62] = -0.4253968253968314 * sp[18] + 0.04232804232804099 * sp[17];
    A[63] = -0.6603174603174647 * sp[19] + -0.2962962962962956 * sp[18] + 0.8211640211640286 * sp[18] + -0.7619047619047693 * sp[17];
    A[64] = 2.450793650793683 * sp[19] + 0.9714285714285847 * sp[18] + 0.9714285714285847 * sp[18] + 2.450793650793679 * sp[17];
    A[65] = -0.7619047619047798 * sp[19] + 0.821164021164023 * sp[18] + -0.2962962962963069 * sp[18] + -0.6603174603174718 * sp[17];
    A[66] = -0.1523809523809575 * sp[19] + -0.1100529100529202 * sp[18] + -0.1100529100529067 * sp[18] + -0.06772486772487549 * sp[17];
    A[67] = 0.3936507936508085 * sp[19] + 0.1968253968254154 * sp[18] + 0.1968253968253924 * sp[18] + 0.05079365079365489 * sp[17];
    A[68] = 0.7619047619047801 * sp[19] + 0.2962962962962937 * sp[18] + 0.2962962962963072 * sp[18] + -0.06772486772486581 * sp[17];
    A[69] = -0.0677248677248732 * sp[19] + -0.1100529100529148 * sp[18] + -0.1100529100529203 * sp[18] + -0.1523809523809569 * sp[17];
    A[70] = 0.05079365079365512 * sp[19] + 0.1968253968254008 * sp[18] + 0.1968253968254162 * sp[18] + 0.3936507936508165 * sp[17];
    A[71] = -0.06772486772487102 * sp[19] + 0.2962962962962974 * sp[18] + 0.2962962962962863 * sp[18] + 0.7619047619047706 * sp[17];
    A[72] = 0.4063492063492197 * sp[19] + 0.4571428571428719 * sp[18] + 0.4571428571428695 * sp[18] + 0.4063492063492108 * sp[17];
    A[73] = 0.4063492063492024 * sp[19] + -1.168253968253985 * sp[18] + -1.168253968253992 * sp[18] + -2.844444444444493 * sp[17];
    A[74] = -2.844444444444491 * sp[19] + -1.168253968253983 * sp[18] + -1.168253968253977 * sp[18] + 0.4063492063492135 * sp[17];
    A[75] = 0.04232804232804346 * sp[19] + 0.04232804232804203 * sp[18] + 0.04232804232804374 * sp[18] + 0.04232804232804259 * sp[17];
    A[76] = -0.04232804232804408 * sp[19] + 0.2031746031746025 * sp[18];
    A[77] = 0.7788359788359865 * sp[18] + 0.1269841269841289 * sp[17];
    A[78] = 0.3386243386243473 * sp[19] + 0.1015873015873046 * sp[18] + -0.4402116402116382 * sp[18] + 0.3386243386243434 * sp[17];
    A[79] = -0.7619047619047798 * sp[19] + -0.2962962962963069 * sp[18] + 0.821164021164023 * sp[18] + -0.6603174603174718 * sp[17];
    A[80] = 2.099470899470928 * sp[19] + 1.049735449735466 * sp[18] + 1.049735449735466 * sp[18] + 1.828571428571452 * sp[17];
    A[81] = -0.3386243386243455 * sp[19] + -0.2370370370370405 * sp[18] + -0.237037037037049 * sp[18] + -0.1354497354497422 * sp[17];
    A[82] = 0.7619047619047771 * sp[19] + 0.4656084656084736 * sp[18] + 0.4656084656084881 * sp[18] + 0.1015873015873161 * sp[17];
    A[83] = -2.099470899470929 * sp[19] + -1.049735449735459 * sp[18] + -1.049735449735466 * sp[18] + -0.135449735449741 * sp[17];
    A[84] = -0.101587301587306 * sp[18] + -0.101587301587305 * sp[18] + -0.2031746031746131 * sp[17];
    A[85] = -0.04232804232804227 * sp[18] + -0.04232804232804817 * sp[18] + -0.1523809523809644 * sp[17];
    A[86] = -0.1015873015872981 * sp[18] + -0.1015873015872937 * sp[18] + -0.3386243386243371 * sp[17];
    A[87] = 0.3386243386243535 * sp[18] + 0.3386243386243576 * sp[18] + 0.8126984126984483 * sp[17];
    A[88] = 0.3386243386243368 * sp[18] + 0.3386243386243298 * sp[18] + 0.8126984126984269 * sp[17];
    A[89] = -1.286772486772512 * sp[18] + -1.286772486772514 * sp[18] + -2.438095238095288 * sp[17];
    A[90] = 0.1269841269841298 * sp[19] + 0.12698412698413 * sp[18] + -0.6518518518518617 * sp[18] + -0.651851851851861 * sp[17];
    A[91] = 0.0423280423280448 * sp[19];
    A[92] = -0.2031746031746052 * sp[18] + -0.2455026455026474 * sp[17];
    A[93] = -0.2031746031746093 * sp[19] + -0.101587301587307 * sp[18] + -0.1015873015873001 * sp[18];
    A[94] = -0.1523809523809575 * sp[19] + -0.1100529100529067 * sp[18] + -0.1100529100529202 * sp[18] + -0.06772486772487549 * sp[17];
    A[95] = -0.3386243386243455 * sp[19] + -0.237037037037049 * sp[18] + -0.2370370370370405 * sp[18] + -0.1354497354497422 * sp[17];
    A[96] = 1.828571428571452 * sp[19] + 0.7788359788359898 * sp[18] + 0.7788359788359898 * sp[18] + 1.828571428571454 * sp[17];
    A[97] = -0.6603174603174597 * sp[19] + -1.4814814814815 * sp[18] + -0.3640211640211665 * sp[18] + -1.947089947089971 * sp[17];
    A[98] = 0.3386243386243454 * sp[19] + 0.7788359788359813 * sp[18] + 0.2370370370370405 * sp[18] + 1.015873015873025 * sp[17];
    A[99] = -0.1354497354497461 * sp[19] + 0.914285714285718 * sp[18] + 0.9142857142857252 * sp[18] + -0.1354497354497399 * sp[17];
    A[100] = 0.1015873015873172 * sp[19] + -0.3640211640211655 * sp[18] + -0.364021164021162 * sp[18] + -0.0677248677248658 * sp[17];
    A[101] = -0.1354497354497456 * sp[19] + 0.1015873015873 * sp[18] + 0.1015873015872953 * sp[18];
    A[102] = -2.438095238095284 * sp[19] + -1.151322751322762 * sp[18] + -1.151322751322771 * sp[18] + 0.135449735449737 * sp[17];
    A[103] = 0.8126984126984416 * sp[19] + 0.4740740740740803 * sp[18] + 0.4740740740740815 * sp[18] + 0.1354497354497406 * sp[17];
    A[104] = 0.8126984126984167 * sp[19] + 0.4740740740740947 * sp[18] + 0.4740740740740862 * sp[18] + 0.1354497354497439 * sp[17];
    A[105] = 0.04232804232804231 * sp[19] + 0.04232804232804389 * sp[18] + 0.467724867724873 * sp[18] + 0.4677248677248733 * sp[17];
    A[106] = 0.04232804232804565 * sp[19];
    A[107] = 0.4253968253968309 * sp[18] + 0.4677248677248724 * sp[17];
    A[108] = -0.1523809523809613 * sp[19] + -0.04232804232803838 * sp[18] + -0.04232804232804616 * sp[18];
    A[109] = 0.3936507936508085 * sp[19] + 0.1968253968253924 * sp[18] + 0.1968253968254154 * sp[18] + 0.05079365079365489 * sp[17];
    A[110] = 0.7619047619047771 * sp[19] + 0.4656084656084881 * sp[18] + 0.4656084656084736 * sp[18] + 0.1015873015873161 * sp[17];
    A[111] = -0.6603174603174597 * sp[19] + -0.3640211640211665 * sp[18] + -1.4814814814815 * sp[18] + -1.947089947089971 * sp[17];
    A[112] = 2.450793650793683 * sp[19] + 1.479365079365098 * sp[18] + 1.479365079365098 * sp[18] + 2.958730158730195 * sp[17];
    A[113] = -0.7619047619047774 * sp[19] + -1.583068783068807 * sp[18] + -0.4656084656084735 * sp[18] + -1.94708994708997 * sp[17];
    A[114] = -0.06772486772486727 * sp[19] + -0.3640211640211643 * sp[18] + -0.3640211640211629 * sp[18] + 0.1015873015873083 * sp[17];
    A[115] = 0.05079365079365553 * sp[19] + -0.1460317460317468 * sp[18] + -0.1460317460317552 * sp[18] + 0.05079365079365428 * sp[17];
    A[116] = -0.06772486772487547 * sp[19] + 0.04232804232803977 * sp[18] + 0.04232804232804502 * sp[18];
    A[117] = 0.4063492063491871 * sp[19] + 1.574603174603181 * sp[18] + 1.574603174603197 * sp[18] + -0.1015873015873096 * sp[17];
    A[118] = 0.4063492063492335 * sp[19] + -0.0507936507936473 * sp[18] + -0.0507936507936515 * sp[18] + -0.1015873015873109 * sp[17];
    A[119] = -2.844444444444492 * sp[19] + -1.676190476190504 * sp[18] + -1.676190476190512 * sp[18] + -0.1015873015873131 * sp[17];
    A[120] = -0.04232804232804346 * sp[19] + -0.04232804232804203 * sp[18] + -0.2455026455026482 * sp[18] + -0.2455026455026482 * sp[17];
    A[121] = 0.0423280423280441 * sp[19];
    A[122] = -0.7788359788359868 * sp[18] + -0.6518518518518578 * sp[17];
    A[123] = -0.3386243386243472 * sp[19] + -0.1015873015873045 * sp[18] + -0.1015873015872931 * sp[18];
    A[124] = 0.7619047619047801 * sp[19] + 0.2962962962963072 * sp[18] + 0.2962962962962937 * sp[18] + -0.06772486772486581 * sp[17];
    A[125] = -2.099470899470929 * sp[19] + -1.049735449735466 * sp[18] + -1.049735449735459 * sp[18] + -0.135449735449741 * sp[17];
    A[126] = 0.3386243386243454 * sp[19] + 0.2370370370370405 * sp[18] + 0.7788359788359813 * sp[18] + 1.015873015873025 * sp[17];
    A[127] = -0.7619047619047774 * sp[19] + -0.4656084656084735 * sp[18] + -1.583068783068807 * sp[18] + -1.94708994708997 * sp[17];
    A[128] = 2.099470899470929 * sp[19] + 1.049735449735459 * sp[18] + 1.049735449735459 * sp[18] + 1.828571428571451 * sp[17];
    A[129] = 0.101587301587306 * sp[18] + 0.1015873015872978 * sp[18] + -0.1354497354497456 * sp[17];
    A[130] = 0.04232804232804247 * sp[18] + 0.04232804232804456 * sp[18] + -0.06772486772487586 * sp[17];
    A[131] = 0.101587301587298 * sp[18] + 0.101587301587305 * sp[18];
    A[132] = -0.3386243386243534 * sp[18] + -0.3386243386243365 * sp[18] + 0.1354497354497468 * sp[17];
    A[133] = -0.3386243386243372 * sp[18] + -0.3386243386243516 * sp[18] + 0.1354497354497455 * sp[17];
    A[134] = 1.286772486772512 * sp[18] + 1.286772486772514 * sp[18] + 0.135449735449738 * sp[17];
    A[135] = -0.651851851851863 * sp[19] + -0.6518518518518631 * sp[18] + 0.1269841269841287 * sp[18] + 0.1269841269841284 * sp[17];
    A[136] = -0.2455026455026465 * sp[19] + -0.2031746031746039 * sp[18];
    A[137] = 0.0423280423280431 * sp[17];
    A[138] = -0.1354497354497389 * sp[19] + -0.2370370370370341 * sp[18] + -0.2370370370370499 * sp[18] + -0.3386243386243479 * sp[17];
    A[139] = -0.0677248677248732 * sp[19] + -0.1100529100529203 * sp[18] + -0.1100529100529148 * sp[18] + -0.1523809523809569 * sp[17];
    A[140] = -0.101587301587305 * sp[18] + -0.101587301587306 * sp[18] + -0.2031746031746131 * sp[17];
    A[141] = -0.1354497354497461 * sp[19] + 0.9142857142857252 * sp[18] + 0.914285714285718 * sp[18] + -0.1354497354497399 * sp[17];
    A[142] = -0.06772486772486727 * sp[19] + -0.3640211640211629 * sp[18] + -0.3640211640211643 * sp[18] + 0.1015873015873083 * sp[17];
    A[143] = 0.1015873015872978 * sp[18] + 0.101587301587306 * sp[18] + -0.1354497354497456 * sp[17];
    A[144] = 1.828571428571457 * sp[19] + 0.7788359788359877 * sp[18] + 0.7788359788359877 * sp[18] + 1.82857142857145 * sp[17];
    A[145] = -1.947089947089972 * sp[19] + -0.3640211640211628 * sp[18] + -1.481481481481494 * sp[18] + -0.6603174603174564 * sp[17];
    A[146] = 1.015873015873024 * sp[19] + 0.2370370370370358 * sp[18] + 0.7788359788359808 * sp[18] + 0.3386243386243411 * sp[17];
    A[147] = 0.1354497354497469 * sp[19] + -1.151322751322772 * sp[18] + -1.151322751322763 * sp[18] + -2.438095238095279 * sp[17];
    A[148] = 0.1354497354497377 * sp[19] + 0.4740740740740809 * sp[18] + 0.4740740740740947 * sp[18] + 0.8126984126984199 * sp[17];
    A[149] = 0.1354497354497398 * sp[19] + 0.4740740740740911 * sp[18] + 0.4740740740740789 * sp[18] + 0.8126984126984463 * sp[17];
    A[150] = 0.4677248677248747 * sp[19] + 0.4677248677248747 * sp[18] + 0.04232804232804291 * sp[18] + 0.0423280423280419 * sp[17];
    A[151] = 0.4677248677248682 * sp[19] + 0.4253968253968259 * sp[18];
    A[152] = 0.04232804232804576 * sp[17];
    A[153] = 0.1015873015873061 * sp[19] + 0.4656084656084598 * sp[18] + 0.4656084656084772 * sp[18] + 0.7619047619047642 * sp[17];
    A[154] = 0.05079365079365512 * sp[19] + 0.1968253968254162 * sp[18] + 0.1968253968254008 * sp[18] + 0.3936507936508165 * sp[17];
    A[155] = -0.04232804232804817 * sp[18] + -0.04232804232804227 * sp[18] + -0.1523809523809644 * sp[17];
    A[156] = 0.1015873015873172 * sp[19] + -0.364021164021162 * sp[18] + -0.3640211640211655 * sp[18] + -0.0677248677248658 * sp[17];
    A[157] = 0.05079365079365553 * sp[19] + -0.1460317460317552 * sp[18] + -0.1460317460317468 * sp[18] + 0.05079365079365428 * sp[17];
    A[158] = 0.04232804232804456 * sp[18] + 0.04232804232804247 * sp[18] + -0.06772486772487586 * sp[17];
    A[159] = -1.947089947089972 * sp[19] + -1.481481481481494 * sp[18] + -0.3640211640211628 * sp[18] + -0.6603174603174564 * sp[17];
    A[160] = 2.958730158730193 * sp[19] + 1.479365079365091 * sp[18] + 1.479365079365091 * sp[18] + 2.450793650793688 * sp[17];
    A[161] = -1.947089947089964 * sp[19] + -0.4656084656084604 * sp[18] + -1.583068783068798 * sp[18] + -0.7619047619047653 * sp[17];
    A[162] = -0.1015873015873213 * sp[19] + 1.574603174603195 * sp[18] + 1.574603174603186 * sp[18] + 0.4063492063491835 * sp[17];
    A[163] = -0.1015873015873019 * sp[19] + -1.676190476190506 * sp[18] + -1.676190476190498 * sp[18] + -2.844444444444503 * sp[17];
    A[164] = -0.1015873015873108 * sp[19] + -0.05079365079365467 * sp[18] + -0.05079365079365489 * sp[18] + 0.4063492063492385 * sp[17];
    A[165] = -0.2455026455026483 * sp[19] + -0.2455026455026473 * sp[18] + -0.0423280423280433 * sp[18] + -0.04232804232804049 * sp[17];
    A[166] = -0.6518518518518541 * sp[19] + -0.7788359788359813 * sp[18];
    A[167] = 0.04232804232804355 * sp[17];
    A[168] = -0.1354497354497352 * sp[19] + -1.04973544973545 * sp[18] + -1.049735449735449 * sp[18] + -2.099470899470908 * sp[17];
    A[169] = -0.06772486772487102 * sp[19] + 0.2962962962962863 * sp[18] + 0.2962962962962974 * sp[18] + 0.7619047619047706 * sp[17];
    A[170] = -0.1015873015872937 * sp[18] + -0.1015873015872981 * sp[18] + -0.3386243386243371 * sp[17];
    A[171] = -0.1354497354497456 * sp[19] + 0.1015873015872953 * sp[18] + 0.1015873015873 * sp[18];
    A[172] = -0.06772486772487547 * sp[19] + 0.04232804232804502 * sp[18] + 0.04232804232803977 * sp[18];
    A[173] = 0.101587301587305 * sp[18] + 0.101587301587298 * sp[18];
    A[174] = 1.015873015873024 * sp[19] + 0.7788359788359808 * sp[18] + 0.2370370370370358 * sp[18] + 0.3386243386243411 * sp[17];
    A[175] = -1.947089947089964 * sp[19] + -1.583068783068798 * sp[18] + -0.4656084656084604 * sp[18] + -0.7619047619047653 * sp[17];
    A[176] = 1.828571428571442 * sp[19] + 1.04973544973545 * sp[18] + 1.04973544973545 * sp[18] + 2.099470899470903 * sp[17];
    A[177] = 0.1354497354497522 * sp[19] + -0.3386243386243345 * sp[18] + -0.3386243386243467 * sp[18];
    A[178] = 0.1354497354497285 * sp[19] + 1.286772486772512 * sp[18] + 1.286772486772495 * sp[18];
    A[179] = 0.1354497354497472 * sp[19] + -0.3386243386243493 * sp[18] + -0.3386243386243368 * sp[18];
    A[180] = -0.08465608465608851 * sp[19] + -0.08465608465608886 * sp[18] + -0.08465608465608714 * sp[18] + -0.08465608465608486 * sp[17];
    A[181] = -0.0846560846560894 * sp[19];
    A[182] = -0.08465608465608671 * sp[17];
    A[183] = 0.8126984126984362 * sp[19] + 0.3386243386243503 * sp[18] + 0.3386243386243547 * sp[18];
    A[184] = 0.4063492063492197 * sp[19] + 0.4571428571428695 * sp[18] + 0.4571428571428719 * sp[18] + 0.4063492063492108 * sp[17];
    A[185] = 0.3386243386243576 * sp[18] + 0.3386243386243535 * sp[18] + 0.8126984126984483 * sp[17];
    A[186] = -2.438095238095284 * sp[19] + -1.151322751322771 * sp[18] + -1.151322751322762 * sp[18] + 0.135449735449737 * sp[17];
    A[187] = 0.4063492063491871 * sp[19] + 1.574603174603197 * sp[18] + 1.574603174603181 * sp[18] + -0.1015873015873096 * sp[17];
    A[188] = -0.3386243386243365 * sp[18] + -0.3386243386243534 * sp[18] + 0.1354497354497468 * sp[17];
    A[189] = 0.1354497354497469 * sp[19] + -1.151322751322763 * sp[18] + -1.151322751322772 * sp[18] + -2.438095238095279 * sp[17];
    A[190] = -0.1015873015873213 * sp[19] + 1.574603174603186 * sp[18] + 1.574603174603195 * sp[18] + 0.4063492063491835 * sp[17];
    A[191] = 0.1354497354497522 * sp[19] + -0.3386243386243467 * sp[18] + -0.3386243386243345 * sp[18];
    A[192] = 5.688888888888975 * sp[19] + 2.844444444444456 * sp[18] + 2.844444444444456 * sp[18] + 5.688888888888967 * sp[17];
    A[193] = -4.063492063492127 * sp[19] + -2.031746031746057 * sp[18] + -2.031746031746047 * sp[18] + -0.812698412698396 * sp[17];
    A[194] = -0.8126984126984051 * sp[19] + -2.031746031746047 * sp[18] + -2.03174603174605 * sp[18] + -4.063492063492138 * sp[17];
    A[195] = -0.08465608465608353 * sp[19] + -0.08465608465608174 * sp[18] + -0.08465608465608625 * sp[18] + -0.08465608465608651 * sp[17];
    A[196] = -0.0846560846560807 * sp[19];
    A[197] = -0.08465608465609038 * sp[17];
    A[198] = -2.438095238095269 * sp[19] + -1.286772486772497 * sp[18] + -1.28677248677251 * sp[18];
    A[199] = 0.4063492063492024 * sp[19] + -1.168253968253992 * sp[18] + -1.168253968253985 * sp[18] + -2.844444444444493 * sp[17];
    A[200] = 0.3386243386243298 * sp[18] + 0.3386243386243368 * sp[18] + 0.8126984126984269 * sp[17];
    A[201] = 0.8126984126984416 * sp[19] + 0.4740740740740815 * sp[18] + 0.4740740740740803 * sp[18] + 0.1354497354497406 * sp[17];
    A[202] = 0.4063492063492335 * sp[19] + -0.0507936507936515 * sp[18] + -0.0507936507936473 * sp[18] + -0.1015873015873109 * sp[17];
    A[203] = -0.3386243386243516 * sp[18] + -0.3386243386243372 * sp[18] + 0.1354497354497455 * sp[17];
    A[204] = 0.1354497354497377 * sp[19] + 0.4740740740740947 * sp[18] + 0.4740740740740809 * sp[18] + 0.8126984126984199 * sp[17];
    A[205] = -0.1015873015873019 * sp[19] + -1.676190476190498 * sp[18] + -1.676190476190506 * sp[18] + -2.844444444444503 * sp[17];
    A[206] = 0.1354497354497285 * sp[19] + 1.286772486772495 * sp[18] + 1.286772486772512 * sp[18];
    A[207] = -4.063492063492127 * sp[19] + -2.031746031746047 * sp[18] + -2.031746031746057 * sp[18] + -0.812698412698396 * sp[17];
    A[208] = 5.688888888888953 * sp[19] + 2.844444444444487 * sp[18] + 2.844444444444487 * sp[18] + 5.688888888888995 * sp[17];
    A[209] = -0.8126984126984371 * sp[19] + 1.219047619047629 * sp[18] + 1.219047619047633 * sp[18] + -0.8126984126984473 * sp[17];
    A[210] = -0.08465608465608657 * sp[19] + -0.08465608465608915 * sp[18] + -0.08465608465608507 * sp[18] + -0.08465608465608589 * sp[17];
    A[211] = -0.08465608465608934 * sp[19];
    A[212] = -0.08465608465608419 * sp[17];
    A[213] = 0.8126984126984257 * sp[19] + 0.3386243386243336 * sp[18] + 0.3386243386243221 * sp[18];
    A[214] = -2.844444444444491 * sp[19] + -1.168253968253977 * sp[18] + -1.168253968253983 * sp[18] + 0.4063492063492135 * sp[17];
    A[215] = -1.286772486772514 * sp[18] + -1.286772486772512 * sp[18] + -2.438095238095288 * sp[17];
    A[216] = 0.8126984126984167 * sp[19] + 0.4740740740740862 * sp[18] + 0.4740740740740947 * sp[18] + 0.1354497354497439 * sp[17];
    A[217] = -2.844444444444492 * sp[19] + -1.676190476190512 * sp[18] + -1.676190476190504 * sp[18] + -0.1015873015873131 * sp[17];
    A[218] = 1.286772486772514 * sp[18] + 1.286772486772512 * sp[18] + 0.135449735449738 * sp[17];
    A[219] = 0.1354497354497398 * sp[19] + 0.4740740740740789 * sp[18] + 0.4740740740740911 * sp[18] + 0.8126984126984463 * sp[17];
    A[220] = -0.1015873015873108 * sp[19] + -0.05079365079365489 * sp[18] + -0.05079365079365467 * sp[18] + 0.4063492063492385 * sp[17];
    A[221] = 0.1354497354497472 * sp[19] + -0.3386243386243368 * sp[18] + -0.3386243386243493 * sp[18];
    A[222] = -0.8126984126984051 * sp[19] + -2.03174603174605 * sp[18] + -2.031746031746047 * sp[18] + -4.063492063492138 * sp[17];
    A[223] = -0.8126984126984371 * sp[19] + 1.219047619047633 * sp[18] + 1.219047619047629 * sp[18] + -0.8126984126984473 * sp[17];
    A[224] = 5.688888888888983 * sp[19] + 2.844444444444488 * sp[18] + 2.844444444444488 * sp[18] + 5.688888888888975 * sp[17];
}


poisson2d_4_cell_integral_1_otherwise::poisson2d_4_cell_integral_1_otherwise() : ufc::cell_integral()
{

}

poisson2d_4_cell_integral_1_otherwise::~poisson2d_4_cell_integral_1_otherwise()
{

}

const std::vector<bool> & poisson2d_4_cell_integral_1_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({true});
return enabled;
}

void poisson2d_4_cell_integral_1_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 8
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 8
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           8
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Quadrature rules
    alignas(32) static const double weights25[25] = { 0.01146508035159253, 0.01980408313204737, 0.0173415064313657, 0.008755499182163834, 0.001865552166877836, 0.02316122192949835, 0.04000728738616045, 0.03503250450337171, 0.01768745211048347, 0.003768701695327616, 0.02752898566446977, 0.04755189705795404, 0.04163896521519497, 0.02102296748732208, 0.004479406797281353, 0.02316122192949835, 0.04000728738616045, 0.03503250450337171, 0.01768745211048347, 0.003768701695327616, 0.01146508035159253, 0.01980408313204737, 0.0173415064313657, 0.008755499182163834, 0.001865552166877837 };
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q25[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double FE6_C0_Q25[1][25][15] =
        { { { 0.4451562263925466, -0.03158270668536051, -0.02917048430386153, 0.007134065275287878, 0.004943903029679515, 0.0074003520425001, 0.4292308497443857, -0.3259808246515267, 0.1503557743791674, 0.4856503425184885, -0.3596467139821189, 0.163997633685216, 0.1397118018034136, -0.0430505510725603, -0.04414966817525721 },
            { 0.01592654198372205, -0.02807254887150221, -0.01830335811304836, 0.03121228065137618, 0.005263930705069378, 0.004989941977801532, 0.8781334117964688, -0.2590231183191913, 0.1013825539475274, 0.1668395961881514, -0.2010466984853998, 0.1204846896211011, 0.3748957403590039, -0.1547924854741931, -0.03789047796688642 },
            { -0.01247552235598083, -0.02155534630393641, 0.0169955517944373, 0.05218483945720873, -0.03106641593597602, -0.005744173270766623, 0.1019684319288196, 0.8062480570403354, -0.1167065587331739, 0.006138164662550627, -0.05774073171417178, 0.06382412613772204, 0.2261626835325779, -0.1770562051755825, 0.1488230989359371 },
            { 0.0120168299638107, -0.01283538271691922, -0.03522612897171294, 0.04853270493590333, -0.06676637996799435, 0.03691035339860615, -0.07271147090601124, 0.2316354142279611, 0.7499217248023277, -0.001493593795341586, -0.002517719865904534, 0.02025497909715191, 0.01485684083027092, -0.08700557338279277, 0.1644274023506457 },
            { -0.04165831197397276, -0.004467183014870943, 0.3809151292451658, 0.02161056705024808, -0.04262967190915434, 0.04649788678407851, 0.2289543614127657, -0.5509496449326026, 0.9447152965513561, 0.001173970375450761, 0.001064055314646425, 0.002251345306607502, -0.007818220545970783, -0.01229067491169214, 0.03263109524794533 },
            { -0.01046080741492519, -0.009882910554720879, -0.02917048430386153, 0.002978208403733321, 0.003372532094812135, 0.03640464693122356, 0.146268417801009, -0.1932692389730816, 0.1213514794904439, 0.8141187896221883, -0.1454564307596655, 0.05525614103589515, 0.4074818032869242, -0.02370226374113964, -0.1752898829188347 },
            { -0.03756824456660141, -0.0228041670217816, -0.01830335811304833, 0.0319723628129167, 0.007916700284814657, 0.02454708571509866, 0.2235883907136696, -0.1491276939331437, 0.08182541021023025, 0.2089740317665444, -0.1740807544700821, 0.09961071472799321, 1.061780448256613, -0.1878922544505435, -0.1504386719326794 },
            { 0.01807498284392648, -0.03822948900626855, 0.01699555179443731, 0.107969972703516, -0.08221204064708595, -0.02825738540992147, -0.09968040501450094, 0.4153361542567941, -0.09419334659401907, -0.02951800698283954, -0.07871502090637435, 0.1065782244777395, 0.5731343634285991, -0.3781641813745905, 0.5908806264305884 },
            { -0.005390577424180689, -0.03935180567361961, -0.03522612897171292, 0.1610523488657886, -0.2504274242676088, 0.1815735759415279, 0.02907627798200094, -0.07311139922563258, 0.6052585022594059, 0.00293814230330439, 0.002980654244326756, 0.05424869923296641, -0.02306805887005803, -0.263388066500361, 0.6528352601038538 },
            { -0.04028099255114136, -0.01913212184648635, 0.3809151292451658, 0.09485961336981591, -0.1942259359664021, 0.2287376521685723, 0.2154358856176661, -0.496279337853032, 0.7624755311668623, 0.00543413854413332, 0.004366904803487833, 0.007975947057867548, -0.0346438897097149, -0.04519557627241608, 0.1295570522256226 },
            { 0.006330452071431697, 0.006330452071431549, -0.02917048430386152, -0.003734861655345329, -0.05915854740812535, 0.07887806321083377, -0.003734861655345249, -0.05915854740812521, 0.07887806321083371, -0.04504132408843473, 0.7809965259627781, -0.04504132408843461, 0.2702479445306086, 0.2702479445306085, -0.2468694949808535 },
            { 0.02231628408102606, 0.02231628408102596, -0.01830335811304832, -0.05064571622229198, -0.03988968597199848, 0.0531862479626644, -0.05064571622229184, -0.03988968597199825, 0.05318624796266443, -0.1025616983147698, 0.2346224089035601, -0.1025616983147698, 0.6153701898886195, 0.6153701898886194, -0.2118702936370112 },
            { 0.009547132103506141, 0.009547132103506061, 0.01699555179443731, -0.03566324660967784, 0.04591902450147767, -0.06122536600197035, -0.03566324660967778, 0.04591902450147772, -0.06122536600197018, -0.02288218691353143, 0.004860800046234213, -0.0228821869135314, 0.1372931214811896, 0.1372931214811895, 0.8321666910373413 },
            { -0.03299330380134806, -0.03299330380134805, -0.03522612897171291, 0.1535514833203395, -0.29506202932535, 0.3934160391004668, 0.1535514833203395, -0.2950620293253499, 0.393416039100467, 0.03361920543027584, 0.01417330942494169, 0.03361920543027585, -0.2017152325816542, -0.2017152325816543, 0.9194204952613121 },
            { -0.03331795170047747, -0.03331795170047742, 0.3809151292451658, 0.1714489698125597, -0.3717049437507878, 0.4956065916677173, 0.1714489698125596, -0.3717049437507878, 0.4956065916677173, 0.009370158884980783, 0.006259461638854311, 0.009370158884980797, -0.05622095330988404, -0.05622095330988422, 0.1824616659077641 },
            { -0.009882910554720698, -0.01046080741492526, -0.0291704843038615, 0.1462684178010088, -0.1932692389730814, 0.1213514794904439, 0.002978208403733321, 0.003372532094812267, 0.03640464693122359, 0.05525614103589516, -0.1454564307596652, 0.8141187896221876, -0.02370226374113928, 0.4074818032869236, -0.1752898829188348 },
            { -0.02280416702178147, -0.03756824456660141, -0.01830335811304829, 0.2235883907136691, -0.1491276939331434, 0.08182541021023008, 0.0319723628129166, 0.007916700284815087, 0.02454708571509871, 0.0996107147279932, -0.174080754470082, 0.2089740317665442, -0.1878922544505433, 1.061780448256612, -0.1504386719326792 },
            { -0.03822948900626848, 0.01807498284392643, 0.0169955517944373, -0.09968040501450121, 0.415336154256794, -0.09419334659401923, 0.107969972703516, -0.08221204064708576, -0.02825738540992127, 0.1065782244777395, -0.07871502090637426, -0.02951800698283955, -0.3781641813745905, 0.573134363428599, 0.5908806264305887 },
            { -0.03935180567361963, -0.005390577424180684, -0.03522612897171289, 0.02907627798200114, -0.07311139922563298, 0.6052585022594056, 0.1610523488657886, -0.2504274242676089, 0.1815735759415281, 0.05424869923296638, 0.002980654244326794, 0.002938142303304352, -0.2633880665003609, -0.02306805887005823, 0.6528352601038542 },
            { -0.01913212184648634, -0.04028099255114127, 0.3809151292451659, 0.2154358856176662, -0.496279337853032, 0.7624755311668622, 0.0948596133698159, -0.194225935966402, 0.2287376521685721, 0.007975947057867477, 0.004366904803487861, 0.005434138544133271, -0.04519557627241598, -0.0346438897097151, 0.1295570522256224 },
            { -0.0315827066853604, 0.4451562263925465, -0.02917048430386148, 0.4292308497443853, -0.3259808246515264, 0.1503557743791674, 0.007134065275287902, 0.004943903029679612, 0.007400352042500113, 0.1639976336852161, -0.359646713982119, 0.4856503425184885, -0.04305055107256013, 0.1397118018034134, -0.04414966817525701 },
            { -0.02807254887150216, 0.01592654198372211, -0.01830335811304825, 0.8781334117964683, -0.2590231183191911, 0.1013825539475272, 0.03121228065137614, 0.005263930705069558, 0.004989941977801629, 0.120484689621101, -0.2010466984853997, 0.1668395961881513, -0.1547924854741931, 0.3748957403590035, -0.03789047796688604 },
            { -0.02155534630393643, -0.01247552235598089, 0.01699555179443731, 0.1019684319288191, 0.8062480570403353, -0.1167065587331741, 0.05218483945720895, -0.03106641593597603, -0.005744173270766345, 0.06382412613772212, -0.05774073171417192, 0.006138164662550563, -0.1770562051755829, 0.2261626835325782, 0.1488230989359376 },
            { -0.01283538271691928, 0.01201682996381067, -0.03522612897171289, -0.07271147090601093, 0.2316354142279601, 0.7499217248023272, 0.04853270493590383, -0.06676637996799499, 0.03691035339860659, 0.020254979097152, -0.002517719865904516, -0.001493593795341744, -0.08700557338279319, 0.01485684083027099, 0.164427402350647 },
            { -0.004467183014870929, -0.04165831197397267, 0.3809151292451659, 0.2289543614127658, -0.5509496449326027, 0.9447152965513558, 0.02161056705024812, -0.04262967190915434, 0.04649788678407851, 0.002251345306607406, 0.001064055314646475, 0.001173970375450684, -0.01229067491169195, -0.00781822054597095, 0.03263109524794522 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q25[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q25[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q25[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q25[0][0][1];
    alignas(32) double sp[4];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = std::abs(sp[2]);
    alignas(32) double BF0[15] = {};
    for (int iq = 0; iq < 25; ++iq)
    {
        // Quadrature loop body setup (num_points=25)
        // Unstructured varying computations for num_points=25
        double w0 = 0.0;
        for (int ic = 0; ic < 15; ++ic)
            w0 += w[0][ic] * FE6_C0_Q25[0][iq][ic];
        alignas(32) double sv25[1];
        sv25[0] = sp[3] * w0;
        const double fw0 = sv25[0] * weights25[iq];
        for (int i = 0; i < 15; ++i)
            BF0[i] += fw0 * FE6_C0_Q25[0][iq][i];
    }
    std::fill(&A[0], &A[15], 0.0);
    for (int i = 0; i < 15; ++i)
        A[i] += BF0[i];
}


poisson2d_4_form_0::poisson2d_4_form_0() : ufc::form()
{
    // Do nothing
}

poisson2d_4_form_0::~poisson2d_4_form_0()
{
    // Do nothing
}

const char * poisson2d_4_form_0::signature() const
{
    return "713e6753a5bbd4888a92f2a9683c727abd2cb30c49e0af56d26b2510aabf394eaa9b1a6652f7924875bb5f3be6b570919094928b83c54656c3157a98440d7f13";
}

std::size_t poisson2d_4_form_0::rank() const
{
    return 2;
}

std::size_t poisson2d_4_form_0::num_coefficients() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({});
    return position[i];
}

ufc::finite_element * poisson2d_4_form_0::create_coordinate_finite_element() const
{
    return new poisson2d_4_finite_element_1();
}

ufc::dofmap * poisson2d_4_form_0::create_coordinate_dofmap() const
{
    return new poisson2d_4_dofmap_1();
}

ufc::coordinate_mapping * poisson2d_4_form_0::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson2d_4_form_0::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_4_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson2d_4_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson2d_4_form_0::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_4_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson2d_4_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_form_0::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_0::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson2d_4_form_0::has_cell_integrals() const
{
    return true;
}

bool poisson2d_4_form_0::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson2d_4_form_0::has_interior_facet_integrals() const
{
    return false;
}

bool poisson2d_4_form_0::has_vertex_integrals() const
{
    return false;
}

bool poisson2d_4_form_0::has_custom_integrals() const
{
    return false;
}

bool poisson2d_4_form_0::has_cutcell_integrals() const
{
    return false;
}

bool poisson2d_4_form_0::has_interface_integrals() const
{
    return false;
}

bool poisson2d_4_form_0::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson2d_4_form_0::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson2d_4_form_0::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_4_form_0::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson2d_4_form_0::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson2d_4_form_0::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_4_form_0::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson2d_4_form_0::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson2d_4_form_0::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson2d_4_form_0::create_default_cell_integral() const
{
    return new poisson2d_4_cell_integral_0_otherwise();
}

ufc::exterior_facet_integral * poisson2d_4_form_0::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_4_form_0::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson2d_4_form_0::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson2d_4_form_0::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_4_form_0::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson2d_4_form_0::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson2d_4_form_0::create_default_overlap_integral() const
{
    return 0;
}


poisson2d_4_form_1::poisson2d_4_form_1() : ufc::form()
{
    // Do nothing
}

poisson2d_4_form_1::~poisson2d_4_form_1()
{
    // Do nothing
}

const char * poisson2d_4_form_1::signature() const
{
    return "857039e500cfecf0f73a9f3b68d2909bee3e2c0b305e02d8056f963d0ee74534ac8a14102ad61851ec10b0e897c782b39f969c15b67a3dcd62385fb0b7d0e92a";
}

std::size_t poisson2d_4_form_1::rank() const
{
    return 1;
}

std::size_t poisson2d_4_form_1::num_coefficients() const
{
    return 1;
}

std::size_t poisson2d_4_form_1::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({0});
    return position[i];
}

ufc::finite_element * poisson2d_4_form_1::create_coordinate_finite_element() const
{
    return new poisson2d_4_finite_element_1();
}

ufc::dofmap * poisson2d_4_form_1::create_coordinate_dofmap() const
{
    return new poisson2d_4_dofmap_1();
}

ufc::coordinate_mapping * poisson2d_4_form_1::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson2d_4_form_1::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_4_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson2d_4_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson2d_4_form_1::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_4_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson2d_4_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_4_form_1::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_4_form_1::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson2d_4_form_1::has_cell_integrals() const
{
    return true;
}

bool poisson2d_4_form_1::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson2d_4_form_1::has_interior_facet_integrals() const
{
    return false;
}

bool poisson2d_4_form_1::has_vertex_integrals() const
{
    return false;
}

bool poisson2d_4_form_1::has_custom_integrals() const
{
    return false;
}

bool poisson2d_4_form_1::has_cutcell_integrals() const
{
    return false;
}

bool poisson2d_4_form_1::has_interface_integrals() const
{
    return false;
}

bool poisson2d_4_form_1::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson2d_4_form_1::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson2d_4_form_1::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_4_form_1::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson2d_4_form_1::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson2d_4_form_1::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_4_form_1::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson2d_4_form_1::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson2d_4_form_1::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson2d_4_form_1::create_default_cell_integral() const
{
    return new poisson2d_4_cell_integral_1_otherwise();
}

ufc::exterior_facet_integral * poisson2d_4_form_1::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_4_form_1::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson2d_4_form_1::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson2d_4_form_1::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_4_form_1::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson2d_4_form_1::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson2d_4_form_1::create_default_overlap_integral() const
{
    return 0;
}

