// This code conforms with the UFC specification version 2017.1.0
// and was automatically generated by FFC version 2017.1.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
// 
// This code was generated with the following parameters:
// 
//   add_tabulate_tensor_timing:     False
//   convert_exceptions_to_warnings: False
//   cpp_optimize:                   True
//   cpp_optimize_flags:             '-O2'
//   epsilon:                        1e-14
//   error_control:                  False
//   evaluate_basis:                 False
//   evaluate_basis_derivatives:     False
//   form_postfix:                   True
//   format:                         'dolfin'
//   generate_dummy_tabulate_tensor: False
//   max_signature_length:           0
//   optimize:                       True
//   precision:                      None
//   quadrature_degree:              None
//   quadrature_rule:                None
//   representation:                 'auto'
//   split:                          True

#include "Poisson2D_5.h"

poisson2d_5_finite_element_0::poisson2d_5_finite_element_0() : ufc::finite_element()
{
    // Do nothing
}

poisson2d_5_finite_element_0::~poisson2d_5_finite_element_0()
{
    // Do nothing
}

const char * poisson2d_5_finite_element_0::signature() const
{
    return "FiniteElement('Lagrange', triangle, 1)";
}

ufc::shape poisson2d_5_finite_element_0::cell_shape() const
{
    return ufc::shape::triangle;
}

std::size_t poisson2d_5_finite_element_0::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_0::geometric_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_0::space_dimension() const
{
    return 3;
}

std::size_t poisson2d_5_finite_element_0::value_rank() const
{
    return 0;
}

std::size_t poisson2d_5_finite_element_0::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_0::value_size() const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_0::reference_value_rank() const
{
    return 0;
}

std::size_t poisson2d_5_finite_element_0::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_0::reference_value_size() const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_0::degree() const
{
    return 1;
}

const char * poisson2d_5_finite_element_0::family() const
{
    return "Lagrange";
}

void poisson2d_5_finite_element_0::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_5_finite_element_0::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson2d_5_finite_element_0::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_5_finite_element_0::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 3; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[2];
    for (unsigned int r = 0; r < 2; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson2d_5_finite_element_0::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson2d_5_finite_element_0::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
}

void poisson2d_5_finite_element_0::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
}

void poisson2d_5_finite_element_0::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
}

std::size_t poisson2d_5_finite_element_0::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson2d_5_finite_element_0::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson2d_5_finite_element_0::create() const
{
    return new poisson2d_5_finite_element_0();
}


poisson2d_5_finite_element_1::poisson2d_5_finite_element_1() : ufc::finite_element()
{
    // Do nothing
}

poisson2d_5_finite_element_1::~poisson2d_5_finite_element_1()
{
    // Do nothing
}

const char * poisson2d_5_finite_element_1::signature() const
{
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
}

ufc::shape poisson2d_5_finite_element_1::cell_shape() const
{
    return ufc::shape::triangle;
}

std::size_t poisson2d_5_finite_element_1::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_1::geometric_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_1::space_dimension() const
{
    return 6;
}

std::size_t poisson2d_5_finite_element_1::value_rank() const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_1::value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_finite_element_1::value_size() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_1::reference_value_rank() const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_1::reference_value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_finite_element_1::reference_value_size() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_1::degree() const
{
    return 1;
}

const char * poisson2d_5_finite_element_1::family() const
{
    return "Lagrange";
}

void poisson2d_5_finite_element_1::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_5_finite_element_1::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2; s++)
      {
        values[r*2 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

void poisson2d_5_finite_element_1::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 2*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_5_finite_element_1::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 6; r++)
    {
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[4];
    for (unsigned int r = 0; r < 4; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson2d_5_finite_element_1::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 4:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 5:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    }
    
    return 0.0;
}

void poisson2d_5_finite_element_1::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    values[5] = vals[1];
}

void poisson2d_5_finite_element_1::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
}

void poisson2d_5_finite_element_1::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[0];
    dof_coordinates[7] = coordinate_dofs[1];
    dof_coordinates[8] = coordinate_dofs[2];
    dof_coordinates[9] = coordinate_dofs[3];
    dof_coordinates[10] = coordinate_dofs[4];
    dof_coordinates[11] = coordinate_dofs[5];
}

std::size_t poisson2d_5_finite_element_1::num_sub_elements() const
{
    return 2;
}

ufc::finite_element * poisson2d_5_finite_element_1::create_sub_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_5_finite_element_0();
        break;
      }
    case 1:
      {
        return new poisson2d_5_finite_element_0();
        break;
      }
    }
    
    return 0;
}

ufc::finite_element * poisson2d_5_finite_element_1::create() const
{
    return new poisson2d_5_finite_element_1();
}


poisson2d_5_finite_element_2::poisson2d_5_finite_element_2() : ufc::finite_element()
{
    // Do nothing
}

poisson2d_5_finite_element_2::~poisson2d_5_finite_element_2()
{
    // Do nothing
}

const char * poisson2d_5_finite_element_2::signature() const
{
    return "FiniteElement('Lagrange', triangle, 5)";
}

ufc::shape poisson2d_5_finite_element_2::cell_shape() const
{
    return ufc::shape::triangle;
}

std::size_t poisson2d_5_finite_element_2::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_2::geometric_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_finite_element_2::space_dimension() const
{
    return 21;
}

std::size_t poisson2d_5_finite_element_2::value_rank() const
{
    return 0;
}

std::size_t poisson2d_5_finite_element_2::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_2::value_size() const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_2::reference_value_rank() const
{
    return 0;
}

std::size_t poisson2d_5_finite_element_2::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_2::reference_value_size() const
{
    return 1;
}

std::size_t poisson2d_5_finite_element_2::degree() const
{
    return 5;
}

const char * poisson2d_5_finite_element_2::family() const
{
    return "Lagrange";
}

void poisson2d_5_finite_element_2::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.01543288609732534, -0.00945067404923493, -0.005456349206349177, 0.03018753072669566, 0.02338316075352332, 0.01350027415555106, -0.02319976058267573, -0.01960737636513128, -0.01518780842499491, -0.008768685282571268, 0.0213898651255978, 0.0188640878998484, 0.01594306415012957, 0.0123494443881937, 0.007129955041865947, -0.01798917575600383, -0.01627182171011527, -0.01435039787431557, -0.0121282998205249, -0.009394540644540665, -0.005423940570038449};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.01543288609732539, 0.009450674049234945, -0.00545634920634921, 0.0301875307266957, -0.0233831607535234, 0.01350027415555102, 0.02319976058267573, -0.01960737636513131, 0.0151878084249949, -0.008768685282571275, 0.02138986512559779, -0.0188640878998484, 0.01594306415012958, -0.01234944438819368, 0.007129955041865928, 0.01798917575600383, -0.01627182171011527, 0.01435039787431557, -0.01212829982052486, 0.009394540644540639, -0.005423940570038414};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.01543288609732541, 0.0, 0.01091269841269838, 0.0, 0.0, 0.04050082246665312, 0.0, 0.0, 0.0, 0.03507474113028508, 0.0, 0.0, 0.0, 0.0, 0.03564977520932965, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03254364342023055};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028509, 0.1260089873231326, -0.08432539682539675, 0.1018829162025978, -0.02864437192306617, 0.002025041123332625, 0.07733253527558578, -0.02614316848684178, 0.0, 0.005845790188380859, 0.03564977520932966, 0.01257605859989893, -0.03852907169614649, 0.04425217572436067, -0.02970814600777465, 0.0, 0.03254364342023052, -0.05166143234753608, 0.05821583913851937, -0.05260942760942761, 0.03254364342023046};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028503, -0.03293416714127329, 0.1215277777777778, -0.01132032402251088, 0.07541069343011292, -0.02227545235665913, 0.0, 0.1045726739473671, -0.1012520561666327, 0.05845790188380841, 0.0, 0.05659226369954515, -0.009300120754242237, -0.0401356942616295, 0.04159140441088458, 0.0, 0.0, 0.0516614323475361, -0.1018777184924089, 0.1183712121212121, -0.08135910855057625};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028516, 0.08877905925038884, -0.08928571428571441, 0.03018753072669567, 0.0432588473940183, -0.05940120628442454, 0.0, 0.02614316848684174, 0.1012520561666327, -0.1169158037676169, 0.0, 0.0, 0.07440096603393807, -0.03087361097048417, -0.01188325840310989, 0.0, 0.0, 0.0, 0.06791847899493929, -0.131523569023569, 0.1084788114007684};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028498, -0.01002344217343103, 0.1512896825396825, 0.0, 0.05027379562007534, 0.09315189167330204, 0.0, 0.0, 0.05062602808331636, 0.0643036920721894, 0.0, 0.0, 0.0, 0.07203842559779647, -0.02376651680621971, 0.0, 0.0, 0.0, 0.0, 0.06576178451178455, -0.08135910855057638};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028509, -0.1260089873231326, -0.08432539682539682, 0.1018829162025978, 0.02864437192306621, 0.002025041123332697, -0.07733253527558576, -0.02614316848684178, 0.0, 0.005845790188380794, 0.03564977520932966, -0.01257605859989896, -0.03852907169614651, -0.04425217572436069, -0.02970814600777473, 0.0, 0.03254364342023052, 0.05166143234753602, 0.05821583913851934, 0.05260942760942759, 0.03254364342023054};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028518, 0.03293416714127334, 0.1215277777777777, -0.01132032402251086, -0.07541069343011299, -0.02227545235665926, 0.0, 0.1045726739473671, 0.1012520561666326, 0.05845790188380851, 0.0, -0.05659226369954512, -0.009300120754242198, 0.04013569426162947, 0.04159140441088467, 0.0, 0.0, -0.05166143234753603, -0.1018777184924089, -0.1183712121212121, -0.08135910855057633};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028516, -0.0887790592503888, -0.08928571428571427, 0.03018753072669565, -0.04325884739401825, -0.05940120628442441, 0.0, 0.02614316848684172, -0.1012520561666327, -0.1169158037676171, 0.0, 0.0, 0.07440096603393805, 0.03087361097048421, -0.01188325840310998, 0.0, 0.0, 0.0, 0.06791847899493927, 0.131523569023569, 0.1084788114007685};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028503, 0.01002344217343112, 0.1512896825396826, 0.0, -0.05027379562007524, 0.09315189167330203, 0.0, 0.0, -0.05062602808331635, 0.06430369207218942, 0.0, 0.0, 0.0, -0.07203842559779652, -0.02376651680621968, 0.0, 0.0, 0.0, 0.0, -0.06576178451178459, -0.08135910855057642};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028512, -0.1360324294965636, -0.06696428571428571, 0.03697972514020221, 0.07891816754314143, 0.0600762199922021, -0.007733253527558605, -0.04575054485197307, -0.05568863089164799, -0.03799763622447552, -0.06416959537679347, -0.01257605859989899, 0.01727165282930705, 0.02778624987343577, 0.0202015392852868, 0.08994587878001908, 0.04881546513034576, 0.02009055702404179, 0.002425659964104958, -0.00563672438672439, -0.00542394057003842};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028505, 0.1217132263916621, -0.03224206349206353, -0.06716725586689787, -0.03215184603609468, 0.02767556201887957, 0.1391985634960544, 0.06535792121710443, -0.0101252056166633, -0.02922895094190424, 0.04277973025119569, -0.05659226369954509, -0.03321471697943669, 0.009262083291145249, 0.02020153928528684, -0.1798917575600382, -0.03254364342023054, 0.01148031829945244, 0.009702639856419924, -0.001878908128908117, -0.00542394057003843};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028536, -0.121713226391662, -0.03224206349206357, -0.06716725586689784, 0.03215184603609471, 0.02767556201887969, -0.1391985634960544, 0.06535792121710444, 0.01012520561666329, -0.02922895094190426, 0.04277973025119555, 0.05659226369954514, -0.03321471697943661, -0.009262083291145253, 0.02020153928528674, 0.1798917575600382, -0.03254364342023053, -0.01148031829945242, 0.009702639856419846, 0.001878908128908138, -0.005423940570038383};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.035074741130285, 0.1360324294965637, -0.06696428571428566, 0.03697972514020222, -0.0789181675431414, 0.06007621999220203, 0.007733253527558661, -0.0457505448519731, 0.05568863089164799, -0.03799763622447548, -0.0641695953767934, 0.01257605859989891, 0.01727165282930703, -0.02778624987343577, 0.02020153928528685, -0.08994587878001917, 0.04881546513034579, -0.02009055702404184, 0.00242565996410499, 0.005636724386724385, -0.005423940570038466};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 15:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.2805979290422803, -0.2147880465735216, -0.1240079365079366, 0.09056259218008705, 0.1169158037676168, 0.0, 0.1546650705511715, 0.07842950546052525, 0.1012520561666328, 0.08184106263733185, -0.1425991008373186, 0.02515211719979797, -0.03188612830025914, -0.1070285180310119, -0.09506606722487916, 0.0, -0.130174573680922, -0.1033228646950721, -0.02910791956925956, 0.02630471380471375, 0.03254364342023063};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 16:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028509, 0.0, -0.1240079365079365, -0.3848910167653697, 0.0, 0.1012520561666326, 0.0, -0.104572673947367, 0.0, 0.04676632150704695, 0.2138986512559778, 0.0, 0.1408303999928114, 0.0, -0.09506606722487902, 0.0, 0.195261860521383, 0.0, -0.05821583913851934, 0.0, 0.0325436434202304};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 17:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.2805979290422807, 0.2147880465735215, -0.1240079365079366, 0.09056259218008687, -0.1169158037676169, 0.0, -0.1546650705511715, 0.07842950546052528, -0.1012520561666327, 0.08184106263733185, -0.1425991008373185, -0.02515211719979782, -0.03188612830025912, 0.1070285180310119, -0.09506606722487915, 0.0, -0.130174573680922, 0.1033228646950721, -0.02910791956925967, -0.02630471380471374, 0.03254364342023058};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 18:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028524, -0.1073940232867609, 0.06200396825396856, 0.01132032402251096, -0.3069039848899947, -0.2531301404165816, 0.0, -0.1045726739473671, 0.0, 0.04676632150704661, 0.0, 0.1697767910986355, 0.00930012075424202, 0.1265818049789852, 0.1723072468450934, 0.0, 0.0, 0.1549842970426083, 0.1018777184924087, -0.03945707070707061, -0.08135910855057631};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 19:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028512, 0.1073940232867607, 0.06200396825396826, 0.01132032402251089, 0.3069039848899945, -0.2531301404165818, 0.0, -0.1045726739473671, 0.0, 0.04676632150704678, 0.0, -0.1697767910986354, 0.009300120754242249, -0.1265818049789853, 0.1723072468450934, 0.0, 0.0, -0.1549842970426083, 0.1018777184924089, 0.03945707070707064, -0.08135910855057628};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 20:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.2805979290422805, 0.0, 0.2480158730158729, -0.06037506145339131, 0.0, 0.1350027415555103, 0.0, -0.05228633697368345, 0.0, -0.2104484467817105, 0.0, 0.0, -0.148801932067876, 0.0, -0.1425991008373187, 0.0, 0.0, 0.0, -0.1358369579898784, 0.0, 0.1084788114007684};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 21; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_5_finite_element_2::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 21; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson2d_5_finite_element_2::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 5)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[32][5];
    for (unsigned int row = 0; row < 32; row++)
    {
      for (unsigned int col = 0; col < 5; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[32][32];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.01543288609732534, -0.00945067404923493, -0.005456349206349177, 0.03018753072669566, 0.02338316075352332, 0.01350027415555106, -0.02319976058267573, -0.01960737636513128, -0.01518780842499491, -0.008768685282571268, 0.0213898651255978, 0.0188640878998484, 0.01594306415012957, 0.0123494443881937, 0.007129955041865947, -0.01798917575600383, -0.01627182171011527, -0.01435039787431557, -0.0121282998205249, -0.009394540644540665, -0.005423940570038449};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.01543288609732539, 0.009450674049234945, -0.00545634920634921, 0.0301875307266957, -0.0233831607535234, 0.01350027415555102, 0.02319976058267573, -0.01960737636513131, 0.0151878084249949, -0.008768685282571275, 0.02138986512559779, -0.0188640878998484, 0.01594306415012958, -0.01234944438819368, 0.007129955041865928, 0.01798917575600383, -0.01627182171011527, 0.01435039787431557, -0.01212829982052486, 0.009394540644540639, -0.005423940570038414};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.01543288609732541, 0.0, 0.01091269841269838, 0.0, 0.0, 0.04050082246665312, 0.0, 0.0, 0.0, 0.03507474113028508, 0.0, 0.0, 0.0, 0.0, 0.03564977520932965, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03254364342023055};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028509, 0.1260089873231326, -0.08432539682539675, 0.1018829162025978, -0.02864437192306617, 0.002025041123332625, 0.07733253527558578, -0.02614316848684178, 0.0, 0.005845790188380859, 0.03564977520932966, 0.01257605859989893, -0.03852907169614649, 0.04425217572436067, -0.02970814600777465, 0.0, 0.03254364342023052, -0.05166143234753608, 0.05821583913851937, -0.05260942760942761, 0.03254364342023046};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028503, -0.03293416714127329, 0.1215277777777778, -0.01132032402251088, 0.07541069343011292, -0.02227545235665913, 0.0, 0.1045726739473671, -0.1012520561666327, 0.05845790188380841, 0.0, 0.05659226369954515, -0.009300120754242237, -0.0401356942616295, 0.04159140441088458, 0.0, 0.0, 0.0516614323475361, -0.1018777184924089, 0.1183712121212121, -0.08135910855057625};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028516, 0.08877905925038884, -0.08928571428571441, 0.03018753072669567, 0.0432588473940183, -0.05940120628442454, 0.0, 0.02614316848684174, 0.1012520561666327, -0.1169158037676169, 0.0, 0.0, 0.07440096603393807, -0.03087361097048417, -0.01188325840310989, 0.0, 0.0, 0.0, 0.06791847899493929, -0.131523569023569, 0.1084788114007684};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028498, -0.01002344217343103, 0.1512896825396825, 0.0, 0.05027379562007534, 0.09315189167330204, 0.0, 0.0, 0.05062602808331636, 0.0643036920721894, 0.0, 0.0, 0.0, 0.07203842559779647, -0.02376651680621971, 0.0, 0.0, 0.0, 0.0, 0.06576178451178455, -0.08135910855057638};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028509, -0.1260089873231326, -0.08432539682539682, 0.1018829162025978, 0.02864437192306621, 0.002025041123332697, -0.07733253527558576, -0.02614316848684178, 0.0, 0.005845790188380794, 0.03564977520932966, -0.01257605859989896, -0.03852907169614651, -0.04425217572436069, -0.02970814600777473, 0.0, 0.03254364342023052, 0.05166143234753602, 0.05821583913851934, 0.05260942760942759, 0.03254364342023054};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028518, 0.03293416714127334, 0.1215277777777777, -0.01132032402251086, -0.07541069343011299, -0.02227545235665926, 0.0, 0.1045726739473671, 0.1012520561666326, 0.05845790188380851, 0.0, -0.05659226369954512, -0.009300120754242198, 0.04013569426162947, 0.04159140441088467, 0.0, 0.0, -0.05166143234753603, -0.1018777184924089, -0.1183712121212121, -0.08135910855057633};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028516, -0.0887790592503888, -0.08928571428571427, 0.03018753072669565, -0.04325884739401825, -0.05940120628442441, 0.0, 0.02614316848684172, -0.1012520561666327, -0.1169158037676171, 0.0, 0.0, 0.07440096603393805, 0.03087361097048421, -0.01188325840310998, 0.0, 0.0, 0.0, 0.06791847899493927, 0.131523569023569, 0.1084788114007685};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028503, 0.01002344217343112, 0.1512896825396826, 0.0, -0.05027379562007524, 0.09315189167330203, 0.0, 0.0, -0.05062602808331635, 0.06430369207218942, 0.0, 0.0, 0.0, -0.07203842559779652, -0.02376651680621968, 0.0, 0.0, 0.0, 0.0, -0.06576178451178459, -0.08135910855057642};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028512, -0.1360324294965636, -0.06696428571428571, 0.03697972514020221, 0.07891816754314143, 0.0600762199922021, -0.007733253527558605, -0.04575054485197307, -0.05568863089164799, -0.03799763622447552, -0.06416959537679347, -0.01257605859989899, 0.01727165282930705, 0.02778624987343577, 0.0202015392852868, 0.08994587878001908, 0.04881546513034576, 0.02009055702404179, 0.002425659964104958, -0.00563672438672439, -0.00542394057003842};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028505, 0.1217132263916621, -0.03224206349206353, -0.06716725586689787, -0.03215184603609468, 0.02767556201887957, 0.1391985634960544, 0.06535792121710443, -0.0101252056166633, -0.02922895094190424, 0.04277973025119569, -0.05659226369954509, -0.03321471697943669, 0.009262083291145249, 0.02020153928528684, -0.1798917575600382, -0.03254364342023054, 0.01148031829945244, 0.009702639856419924, -0.001878908128908117, -0.00542394057003843};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028536, -0.121713226391662, -0.03224206349206357, -0.06716725586689784, 0.03215184603609471, 0.02767556201887969, -0.1391985634960544, 0.06535792121710444, 0.01012520561666329, -0.02922895094190426, 0.04277973025119555, 0.05659226369954514, -0.03321471697943661, -0.009262083291145253, 0.02020153928528674, 0.1798917575600382, -0.03254364342023053, -0.01148031829945242, 0.009702639856419846, 0.001878908128908138, -0.005423940570038383};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.035074741130285, 0.1360324294965637, -0.06696428571428566, 0.03697972514020222, -0.0789181675431414, 0.06007621999220203, 0.007733253527558661, -0.0457505448519731, 0.05568863089164799, -0.03799763622447548, -0.0641695953767934, 0.01257605859989891, 0.01727165282930703, -0.02778624987343577, 0.02020153928528685, -0.08994587878001917, 0.04881546513034579, -0.02009055702404184, 0.00242565996410499, 0.005636724386724385, -0.005423940570038466};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 15:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.2805979290422803, -0.2147880465735216, -0.1240079365079366, 0.09056259218008705, 0.1169158037676168, 0.0, 0.1546650705511715, 0.07842950546052525, 0.1012520561666328, 0.08184106263733185, -0.1425991008373186, 0.02515211719979797, -0.03188612830025914, -0.1070285180310119, -0.09506606722487916, 0.0, -0.130174573680922, -0.1033228646950721, -0.02910791956925956, 0.02630471380471375, 0.03254364342023063};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 16:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028509, 0.0, -0.1240079365079365, -0.3848910167653697, 0.0, 0.1012520561666326, 0.0, -0.104572673947367, 0.0, 0.04676632150704695, 0.2138986512559778, 0.0, 0.1408303999928114, 0.0, -0.09506606722487902, 0.0, 0.195261860521383, 0.0, -0.05821583913851934, 0.0, 0.0325436434202304};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 17:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.2805979290422807, 0.2147880465735215, -0.1240079365079366, 0.09056259218008687, -0.1169158037676169, 0.0, -0.1546650705511715, 0.07842950546052528, -0.1012520561666327, 0.08184106263733185, -0.1425991008373185, -0.02515211719979782, -0.03188612830025912, 0.1070285180310119, -0.09506606722487915, 0.0, -0.130174573680922, 0.1033228646950721, -0.02910791956925967, -0.02630471380471374, 0.03254364342023058};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 18:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028524, -0.1073940232867609, 0.06200396825396856, 0.01132032402251096, -0.3069039848899947, -0.2531301404165816, 0.0, -0.1045726739473671, 0.0, 0.04676632150704661, 0.0, 0.1697767910986355, 0.00930012075424202, 0.1265818049789852, 0.1723072468450934, 0.0, 0.0, 0.1549842970426083, 0.1018777184924087, -0.03945707070707061, -0.08135910855057631};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 19:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.03507474113028512, 0.1073940232867607, 0.06200396825396826, 0.01132032402251089, 0.3069039848899945, -0.2531301404165818, 0.0, -0.1045726739473671, 0.0, 0.04676632150704678, 0.0, -0.1697767910986354, 0.009300120754242249, -0.1265818049789853, 0.1723072468450934, 0.0, 0.0, -0.1549842970426083, 0.1018777184924089, 0.03945707070707064, -0.08135910855057628};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 20:
      {
        
      // Array of basisvalues
      double basisvalues[21] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[10] = basisvalues[6]*1.75*tmp0 - basisvalues[3]*0.75*tmp2;
      basisvalues[15] = basisvalues[10]*1.8*tmp0 - basisvalues[6]*0.8*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[11] = basisvalues[6]*(3.5 + 4.5*Y);
      basisvalues[16] = basisvalues[10]*(4.5 + 5.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[14] = basisvalues[9]*(0.02857142857142857 + Y*1.8) - basisvalues[5]*0.7714285714285715;
      basisvalues[20] = basisvalues[14]*(0.01851851851851852 + Y*1.833333333333333) - basisvalues[9]*0.8148148148148148;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[13] = basisvalues[8]*(0.2857142857142857 + Y*2.0) - basisvalues[4]*0.7142857142857143;
      basisvalues[19] = basisvalues[13]*(0.1785714285714286 + Y*1.964285714285714) - basisvalues[8]*0.7857142857142857;
      basisvalues[12] = basisvalues[7]*(1.020408163265306 + Y*2.571428571428572) - basisvalues[3]*0.5510204081632653;
      basisvalues[18] = basisvalues[12]*(0.5787037037037037 + Y*2.291666666666667) - basisvalues[7]*0.7129629629629629;
      basisvalues[17] = basisvalues[11]*(1.512345679012346 + Y*3.055555555555555) - basisvalues[6]*0.5432098765432098;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[14] *= std::sqrt(2.5);
      basisvalues[20] *= std::sqrt(3.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[13] *= std::sqrt(7.5);
      basisvalues[19] *= std::sqrt(9.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[12] *= std::sqrt(12.5);
      basisvalues[18] *= std::sqrt(15.0);
      basisvalues[6] *= std::sqrt(14.0);
      basisvalues[11] *= std::sqrt(17.5);
      basisvalues[17] *= std::sqrt(21.0);
      basisvalues[10] *= std::sqrt(22.5);
      basisvalues[16] *= std::sqrt(27.0);
      basisvalues[15] *= std::sqrt(33.0);
      
      // Table(s) of coefficients
      static const double coefficients0[21] = \
      {0.2805979290422805, 0.0, 0.2480158730158729, -0.06037506145339131, 0.0, 0.1350027415555103, 0.0, -0.05228633697368345, 0.0, -0.2104484467817105, 0.0, 0.0, -0.148801932067876, 0.0, -0.1425991008373187, 0.0, 0.0, 0.0, -0.1358369579898784, 0.0, 0.1084788114007684};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, -7.739394553449489e-15, 7.993605777301127e-15, 4.831197096089371e-15, -4.329869796038111e-15, 0.0, -4.794159662570115e-15, -1.28685062494593e-15, -4.509722415522039e-15, 4.440892098500626e-15, 2.052985546690602e-15, 0.0, 0.0, -2.113658689124473e-15, 0.0, 0.0, -1.529344847996242e-15, 1.271584082499417e-15, 0.0, -2.047822426738039e-15, 1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.10702591327572e-15, 9.486832980505152, 3.552713678800501e-15, 3.364794804892823e-15, -8.049116928532385e-15, 1.332267629550188e-15, 0.0, -7.744432500611971e-15, -9.325873406851315e-15, 1.77635683940025e-15, 1.247317608011867e-15, -4.718255131121651e-15, 1.60924101449553e-15, -2.886579864025407e-15, 2.220446049250313e-15, 3.882817823945192e-15, -3.491443317577885e-15, 0.0, -2.746351157529004e-15, -7.771561172376096e-15, 1.554312234475219e-15},
      {3.999999999999988, -9.100338110733001e-15, 7.071067811865477, 0.0, -9.325873406851315e-15, 1.77635683940025e-15, 3.051165718642594e-15, 0.0, -6.775965419786281e-15, 8.881784197001252e-15, 0.0, 1.252476306130838e-15, -1.307296956807776e-15, 0.0, 4.440892098500626e-15, 0.0, 0.0, 1.826313396211445e-15, 1.005351816964029e-15, -1.756237901107011e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129207, -4.268124654691885e-14, -2.993325909419167, 13.66260102127946, 1.271205363195804e-14, 0.6110100926607899, 4.835403341523103e-15, -1.773487489628241e-14, 9.852756735138961e-15, 1.221245327087672e-15, 6.305279538981612e-15, 0.0, 3.081596944608647e-15, -5.044316992639389e-15, 0.0, -1.591456420401182e-15, -8.862658073985919e-15, 2.863229326883958e-15, -1.162469682608131e-15, 3.55992131597803e-15, 2.470246229790973e-15},
      {1.865174681370263e-14, 4.381780460041321, 3.552713678800501e-15, 6.350240812827717e-15, 12.52198067399881, 0.0, -1.758894197499644e-15, -1.866024933270626e-14, -5.329070518200751e-15, 7.105427357601002e-15, 1.394863793254662e-15, -3.642652370058379e-15, 4.700646255189816e-15, -4.440892098500626e-15, 4.440892098500626e-15, 0.0, -2.973305467881855e-15, -7.159560656224627e-15, -7.424273266727876e-15, -7.993605777301127e-15, 4.440892098500626e-15},
      {3.464101615137756, -4.615349586907813e-15, 7.838367176906178, -7.320145676037532e-15, -3.552713678800501e-15, 8.400000000000009, -1.41405840784408e-15, 4.965214063206351e-15, -1.607179997552614e-15, 3.552713678800501e-15, -2.117578100722705e-15, 4.802456137342668e-15, -3.575884489321098e-15, 6.600614576156736e-15, -1.77635683940025e-15, 0.0, 2.586336500356257e-15, -3.082109297176668e-15, 5.015487524263546e-15, 3.054979662179697e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.593698238033715e-14, 10.95445115010328, 3.442277541719952e-14, -9.27190151343171e-14, -3.833259389999629, -6.23750565258255e-15, 17.74823934929884, 8.590820748743761e-15, 0.5532833351724682, 3.832696930314228e-15, 1.630958973730325e-15, 4.748247914432518e-15, 1.951889557306623e-15, 8.215650382226158e-15, -2.112788058983631e-15, 2.161502828465742e-15, -8.095745085541818e-15, -1.140385688323059e-14, 4.699840165130157e-15, -6.439293542825908e-15, 1.64967341618927e-15},
      {4.732863826479694, -1.975770005593559e-14, 3.3466401061363, 4.364357804719845, -6.006306563222097e-14, -5.07468037933236, 2.17723174362249e-15, 17.0084012854152, 3.588494510863384e-14, 1.521277658511335, 0.0, 0.0, 1.571110101939887e-15, -7.780848242587004e-15, 6.661338147750939e-15, 0.0, -4.577357877990039e-15, -1.49289732059979e-15, -1.200174864810446e-14, 6.168395133556446e-15, 6.217248937900877e-15},
      {1.504908131212804e-14, 2.449489742783175, -2.565848768022583e-15, 5.996193882644488e-15, 9.14285714285705, 6.277579067060576e-15, 1.769330581497094e-15, 0.0, 14.84614977916183, 1.063343040801711e-15, 0.0, -2.184355890763038e-15, 4.562007337550653e-15, -7.105427357601001e-15, 5.813258191173485e-15, -1.236386977869532e-15, 3.220603437889146e-15, -2.526481355579947e-15, -3.199256104466931e-15, 1.06581410364015e-14, 0.0},
      {3.098386676965954, 3.684710471849483e-15, 7.668115805072361, -2.100372740231438e-15, 5.995204332975845e-15, 10.73312629199904, -6.461830449913059e-15, 9.001576117215171e-15, 1.994375249392672e-15, 9.295160030897804, 0.0, 2.296622155572916e-15, -1.953576874554436e-15, 5.082706742260164e-15, -5.329070518200751e-15, 0.0, 0.0, -2.853531128005635e-15, 5.451777897667602e-15, 3.927795471512872e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.416025603090603, -1.175795344894246e-13, -4.376809635457536, 15.73213272255223, 5.3179682879545e-14, 2.010178182781459, -1.035068248202099e-13, -4.036867138796651, -3.187382975412146e-15, -0.5158119621990984, 21.79908254950193, 4.733048084397381e-15, 0.4513354669242175, 1.572301405460876e-15, 0.05766953055423594, -6.591075017603489e-15, -9.455331183062681e-15, 7.695565916612735e-15, -5.194338320309706e-15, 5.160550158453321e-15, 7.539108226595204e-15},
      {-4.820690306736536e-14, 6.857142857142822, -2.486109365779049e-14, -3.607028862932295e-14, 9.972922524188636, 4.776210527351524e-14, 4.320493798938558, -9.567214212300408e-14, -7.273098320775927, -3.155292673222535e-14, -4.622222910980787e-15, 21.2540192277445, 2.866321395353964e-14, 1.490788039793671, 8.835739393391064e-15, 2.160833750459163e-15, -1.553897032516745e-15, -1.155973460728685e-14, -7.756104690800534e-15, -5.32907051820075e-15, 3.415449741210484e-15},
      {4.320493798938534, -1.416732268732082e-14, 5.935526614418983, 1.792842914001581, -5.417888360170764e-14, -0.3207134902949047, -1.249660989264158e-15, 9.200874124564677, -4.038837061691353e-14, -5.966396198534202, 0.0, -7.917268055059448e-15, 19.80226324513511, 2.939209656899016e-14, 2.530240384255297, 0.0, -4.59378312607397e-15, 3.937433351946746e-15, -1.139195048382073e-14, 4.425181161274129e-15, 5.329070518200751e-15},
      {-1.189371111787756e-14, 1.533303755999836, 1.693964681805415e-14, -1.160312644663505e-14, 6.337932451131185, 4.53717220482264e-15, 6.20778455269112e-15, 2.504700963666594e-14, 13.55261854357873, 6.217655116048257e-15, -4.746720416956653e-15, -2.14142500400751e-15, -6.436238608054387e-15, 16.66751698511147, -2.180599270368835e-15, 4.227202544854137e-15, 4.510682971497351e-15, 1.979903247298058e-15, 1.115016489845191e-14, 0.0, 1.523313755809143e-15},
      {2.828427124746216, 5.603336716546417e-15, 7.314285714285781, 1.905179571863424e-15, 4.662936703425657e-15, 11.33763823802502, 3.711152861044325e-15, 9.833003030452659e-15, 0.0, 12.92995257026832, -1.696230549790344e-15, -2.956710567065854e-15, 2.742265785270138e-15, 3.126905088404707e-15, 9.938586931957776, 0.0, 5.019148073368542e-15, 0.0, 0.0, 1.648961550918037e-15, 2.775557561562891e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[21][21] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, -4.313786486574808e-15, 4.440892098500626e-15, 2.748665455432233e-15, -2.386979502944087e-15, 0.0, -1.508901411584938e-15, 0.0, 0.0, 2.220446049250313e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.430806238773216e-15, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, -5.626309273759821e-15, 7.993605777301127e-15, 4.364565268073116e-15, -3.996802888650564e-15, 0.0, -5.825169637206276e-15, 0.0, -4.381507556445007e-15, 3.552713678800501e-15, 1.875153688580555e-15, 0.0, 0.0, -1.255729148246499e-15, 1.332267629550188e-15, 0.0, -1.383948162084947e-15, 1.208547047170871e-15, 0.0, 0.0, 1.998401444325282e-15},
      {2.581988897471623, 4.74341649025257, -0.912870929175271, 5.033149691569215e-15, -6.938893903907228e-15, -1.221245327087672e-15, -2.788430305016609e-15, -6.060961541888837e-15, -3.741859138095532e-15, 3.663735981263017e-15, 1.682163383717734e-15, -1.899146616355797e-15, 0.0, -2.29234620703556e-15, 0.0, 2.22096340735138e-15, -2.803857941540207e-15, 0.0, 0.0, -2.232831241678514e-15, 2.775557561562891e-15},
      {1.999999999999915, 6.123724356957936, 3.535533905932747, 0.0, -1.176836406102666e-14, 1.77635683940025e-15, 5.399435147247775e-15, -5.018529168551866e-15, -7.82887480839375e-15, 4.440892098500626e-15, 1.140816720082264e-15, -3.281596430396357e-15, 0.0, -1.713720907717672e-15, 2.664535259100376e-15, 2.72929751533638e-15, -1.702073743057707e-15, 0.0, 0.0, -7.0953678884544e-15, 1.554312234475219e-15},
      {-2.309401076758502, -1.674431912009263e-15, 8.164965809277266, -9.118514603428587e-15, -2.442490654175344e-15, -1.77635683940025e-15, 1.183639389134248e-14, 5.382276421332662e-15, -3.25665420556713e-15, 5.329070518200751e-15, -2.510189212631626e-15, 0.0, -2.872919394092076e-15, 2.884187277629304e-15, 0.0, 1.614693265827138e-15, 2.664211098643073e-15, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {2.64575131106458, 5.184592558726259, -1.496662954709565, 6.831300510639724, -1.058300524425835, 0.3055050463303941, -1.271299223422091e-15, -1.129612418756079e-14, 0.0, 0.0, 1.654772878669499e-15, -2.590598682336274e-15, 1.080283295188019e-15, -5.603027389654505e-15, 1.415534356397075e-15, 0.0, -5.887046831248417e-15, 0.0, -1.212816591924671e-15, -2.758075955166313e-15, 1.096345236817342e-15},
      {2.236067977499834, 2.190890230020663, 2.529822128134697, 8.082903768654775, 6.260990336999405, -1.807392228230118, 7.846734787456156e-15, -1.492300259705574e-14, -7.842548835020875e-15, 1.509903313490213e-14, 2.358899362232486e-15, -1.022203521366667e-15, 2.260717854454131e-15, -4.766785654457273e-15, 4.662936703425657e-15, 0.0, -5.927960725662309e-15, 0.0, -6.79384383005429e-15, -7.17653907915964e-15, 9.103828801926284e-15},
      {1.732050807568889, -5.091168824543156, 3.919183588453087, 0.0, 9.699484522385688, 4.200000000000006, -3.277364528302079e-15, 0.0, 2.749123680024194e-15, 7.105427357601002e-15, -2.264292581351222e-15, 3.821976262130677e-15, 0.0, 1.523950448678117e-15, 2.664535259100376e-15, -2.873804034191588e-15, 2.649014000329175e-15, -5.182486078754105e-15, -2.440013858756698e-15, 5.524292719740412e-15, 1.332267629550188e-15},
      {5.000000000000037, 1.148324988857887e-15, -2.828427124746236, 0.0, 6.286637876939949e-15, 12.12435565298216, -1.410498248052135e-14, 5.342501001062515e-15, 2.543075664764304e-15, -1.06581410364015e-14, 0.0, 5.112416520743168e-15, -2.316142040598475e-15, 6.349699054941681e-15, -7.993605777301127e-15, 0.0, 1.64541856636712e-15, -4.281049119332242e-15, 6.644788168219877e-15, 5.756361385056511e-15, -6.217248937900877e-15},
      {2.683281572999726, 5.477225575051629, -1.897366596101005, 7.42307488958085, -1.916629694999805, 0.6639400022069849, 8.874119674649421, -1.07142857142857, 0.2766416675862305, -0.0958314847499859, 0.0, 6.212406482456371e-15, 1.532059335068212e-15, 4.380456128357143e-15, -1.318389841742373e-15, -1.998106361017432e-15, -9.13334304957355e-15, -7.147574858935285e-15, 2.549943545751919e-15, -5.085559207800358e-15, 3.150257832373882e-15},
      {2.366431913239849, 2.898275349237829, 1.673320053068152, 2.182178902359853, 5.747048932153892, -2.537340189666169, 10.06230589874903, 8.504200642707611, -2.195775164134205, 0.7606388292556692, 0.0, 3.028746085100769e-15, 0.0, 3.867259263274776e-15, 2.442490654175344e-15, -2.095405012112276e-15, -4.683611684109024e-15, -1.353088956521257e-14, -5.743964574770931e-15, -7.338021076890436e-15, 6.106226635438361e-15},
      {2.000000000000005, 1.224744871391578, 3.535533905932708, -7.377111135633228, 4.571428571428525, 1.649572197684652, -1.460669065152914e-14, 11.49977816999893, 7.423074889580918, -2.571428571428582, -2.392195245354927e-15, 1.378005830198945e-15, 0.0, 3.050401420131743e-15, -3.552713678800501e-15, -2.132281867658527e-15, 6.010151192127887e-15, -6.60218650178259e-15, 0.0, 9.211616896764899e-15, -6.883382752675971e-15},
      {1.549193338482902, 6.640783086353579, 3.834057902536171, -5.18691882343081e-15, -6.196773353931821, 5.366563145999521, -2.547993719766001e-15, 1.256661109624516e-14, 13.41640786499874, 4.64758001544891, -2.182285413071357e-15, 1.364451467072124e-15, -1.913205721555056e-15, 3.485042942061428e-15, 0.0, 1.979248677325317e-15, 0.0, 1.117099708332355e-15, 6.525822331890503e-15, 4.683944146088049e-15, 1.77635683940025e-15},
      {-3.577708763999679, 1.258101567979373e-14, 8.854377448471457, 5.221725195385663e-15, 4.884981308350689e-15, -3.098386676965962, 6.152941990544253e-15, -5.510184991034616e-15, 5.492875290960744e-15, 16.0996894379985, 3.558444026516833e-15, -6.324815421204702e-15, 2.575673702583286e-15, -3.875038852899119e-15, 8.160139230994901e-15, 0.0, -1.871070766989385e-15, 2.756796828679407e-15, -4.248224276707001e-15, -2.846105636465173e-15, 8.965050923848139e-15},
      {2.708012801545298, 5.685642497752036, -2.188404817728764, 7.866066361276096, -2.611298058632957, 1.005089091390732, 9.552971226757569, -2.018433569398328, 0.6700593942604731, -0.2579059810995458, 10.89954127475098, -1.068054652506472, 0.2256677334621103, -0.07491491772643227, 0.02883476527711743, -6.244355198503534e-15, -8.538281740449495e-15, -4.411001754031148e-15, 0.0, -1.902250382697409e-15, 4.260480856999038e-15},
      {2.449489742783129, 3.428571428571329, 0.9897433186107952, 3.049339172305167, 4.986461262094336, -2.727411870290958, 2.160246899469197, 8.346248495316788, -3.636549160387967, 1.516350793151483, 12.04989626511364, 10.62700961387226, -2.245365597551237, 0.7453940198968385, -0.2869022920265136, -3.087471451180123e-15, 5.880046468504198e-15, -1.477474934006899e-14, -1.129503576277351e-15, -2.021097544939976e-15, 3.275157922644212e-15},
      {2.16024689946926, 1.814229470444305, 2.967763307209468, 0.8964214570008574, 5.416047583669373, -0.1603567451474541, -9.525793444156802, 4.600437062282254, 5.345224838248489, -2.983198099267101, -3.328130142090142e-15, 13.38877362790406, 9.90113162256759, -3.286878675669564, 1.265120192127652, 7.754290733303859e-15, 3.497707636386947e-15, 0.0, -1.397673532859423e-14, 6.875527284062718e-15, -1.77635683940025e-15},
      {1.825741858350525, 0.7666518779999211, 3.836097790529249, 8.636804255921435, 3.168966225565603, 3.659207006766266, 1.934399609204007e-15, -8.748177652797109, 6.77630927178937, 0.5216405309573207, 4.828832976722823e-15, 0.0, 15.06237033139205, 8.333758492555733, -3.20766513935892, 1.40572820449628e-15, -1.063002373340709e-14, 1.470450542467728e-15, -1.09786257560062e-15, 3.513417545478817e-15, 5.84601811404184e-15},
      {1.414213562373033, -6.73025456655335, 3.657142857142972, -9.108849810216301e-15, 9.455027817008698, 5.668819119012483, 6.744016111883614e-15, 2.03287204302313e-14, -6.998542122237658, 6.464976285134175, 0.0, -1.314434808848352e-15, -5.131451462071179e-15, 17.21413752159095, 4.969293465978883, 3.718383438413215e-15, 3.313551435297088e-15, 0.0, 1.113885997772721e-14, 0.0, 8.770761894538737e-15},
      {5.71547606649415, -8.362389900954554e-15, -4.618802153517025, 0.0, -3.108624468950438e-15, 12.72792206135793, 5.670654596594491e-15, 9.938583518476721e-15, -1.104296094996905e-14, -3.265986323710878, -5.026790508557046e-15, 0.0, 2.912716395373332e-15, 0.0, 20.08316044185613, 0.0, 8.942945667433219e-15, -1.818647445654665e-15, 0.0, 0.0, -7.993605777301127e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[32];
      for (unsigned int r = 0; r < 32; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[21][21] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 21; t++)
        {
          for (unsigned int u = 0; u < 21; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 21; t++)
          {
            for (unsigned int u = 0; u < 21; u++)
            {
              for (unsigned int tu = 0; tu < 21; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 21; s++)
        {
          for (unsigned int t = 0; t < 21; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson2d_5_finite_element_2::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 21; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 5)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[32];
    for (unsigned int r = 0; r < 32; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 21; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson2d_5_finite_element_2::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = 0.8*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
      y[1] = 0.8*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 4:
      {
        y[0] = 0.6*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
      y[1] = 0.6*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 5:
      {
        y[0] = 0.3999999999999999*coordinate_dofs[2] + 0.6000000000000001*coordinate_dofs[4];
      y[1] = 0.3999999999999999*coordinate_dofs[3] + 0.6000000000000001*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 6:
      {
        y[0] = 0.2*coordinate_dofs[2] + 0.8*coordinate_dofs[4];
      y[1] = 0.2*coordinate_dofs[3] + 0.8*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 7:
      {
        y[0] = 0.8*coordinate_dofs[0] + 0.2*coordinate_dofs[4];
      y[1] = 0.8*coordinate_dofs[1] + 0.2*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 8:
      {
        y[0] = 0.6*coordinate_dofs[0] + 0.4*coordinate_dofs[4];
      y[1] = 0.6*coordinate_dofs[1] + 0.4*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 9:
      {
        y[0] = 0.3999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[4];
      y[1] = 0.3999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 10:
      {
        y[0] = 0.2*coordinate_dofs[0] + 0.8*coordinate_dofs[4];
      y[1] = 0.2*coordinate_dofs[1] + 0.8*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 11:
      {
        y[0] = 0.8*coordinate_dofs[0] + 0.2*coordinate_dofs[2];
      y[1] = 0.8*coordinate_dofs[1] + 0.2*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 12:
      {
        y[0] = 0.6*coordinate_dofs[0] + 0.4*coordinate_dofs[2];
      y[1] = 0.6*coordinate_dofs[1] + 0.4*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 13:
      {
        y[0] = 0.3999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[2];
      y[1] = 0.3999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 14:
      {
        y[0] = 0.2*coordinate_dofs[0] + 0.8*coordinate_dofs[2];
      y[1] = 0.2*coordinate_dofs[1] + 0.8*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 15:
      {
        y[0] = 0.6000000000000001*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
      y[1] = 0.6000000000000001*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 16:
      {
        y[0] = 0.4*coordinate_dofs[0] + 0.4*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
      y[1] = 0.4*coordinate_dofs[1] + 0.4*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 17:
      {
        y[0] = 0.1999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
      y[1] = 0.1999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 18:
      {
        y[0] = 0.4*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
      y[1] = 0.4*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 19:
      {
        y[0] = 0.2*coordinate_dofs[0] + 0.4*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
      y[1] = 0.2*coordinate_dofs[1] + 0.4*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 20:
      {
        y[0] = 0.2*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.6000000000000001*coordinate_dofs[4];
      y[1] = 0.2*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.6000000000000001*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson2d_5_finite_element_2::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = 0.8*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    y[1] = 0.8*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
    y[0] = 0.6*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
    y[1] = 0.6*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0];
    y[0] = 0.3999999999999999*coordinate_dofs[2] + 0.6000000000000001*coordinate_dofs[4];
    y[1] = 0.3999999999999999*coordinate_dofs[3] + 0.6000000000000001*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0];
    y[0] = 0.2*coordinate_dofs[2] + 0.8*coordinate_dofs[4];
    y[1] = 0.2*coordinate_dofs[3] + 0.8*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[6] = vals[0];
    y[0] = 0.8*coordinate_dofs[0] + 0.2*coordinate_dofs[4];
    y[1] = 0.8*coordinate_dofs[1] + 0.2*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[7] = vals[0];
    y[0] = 0.6*coordinate_dofs[0] + 0.4*coordinate_dofs[4];
    y[1] = 0.6*coordinate_dofs[1] + 0.4*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[8] = vals[0];
    y[0] = 0.3999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[4];
    y[1] = 0.3999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[9] = vals[0];
    y[0] = 0.2*coordinate_dofs[0] + 0.8*coordinate_dofs[4];
    y[1] = 0.2*coordinate_dofs[1] + 0.8*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[10] = vals[0];
    y[0] = 0.8*coordinate_dofs[0] + 0.2*coordinate_dofs[2];
    y[1] = 0.8*coordinate_dofs[1] + 0.2*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[11] = vals[0];
    y[0] = 0.6*coordinate_dofs[0] + 0.4*coordinate_dofs[2];
    y[1] = 0.6*coordinate_dofs[1] + 0.4*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[12] = vals[0];
    y[0] = 0.3999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[2];
    y[1] = 0.3999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[13] = vals[0];
    y[0] = 0.2*coordinate_dofs[0] + 0.8*coordinate_dofs[2];
    y[1] = 0.2*coordinate_dofs[1] + 0.8*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[14] = vals[0];
    y[0] = 0.6000000000000001*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    y[1] = 0.6000000000000001*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[15] = vals[0];
    y[0] = 0.4*coordinate_dofs[0] + 0.4*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    y[1] = 0.4*coordinate_dofs[1] + 0.4*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[16] = vals[0];
    y[0] = 0.1999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    y[1] = 0.1999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[17] = vals[0];
    y[0] = 0.4*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
    y[1] = 0.4*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[18] = vals[0];
    y[0] = 0.2*coordinate_dofs[0] + 0.4*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
    y[1] = 0.2*coordinate_dofs[1] + 0.4*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[19] = vals[0];
    y[0] = 0.2*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.6000000000000001*coordinate_dofs[4];
    y[1] = 0.2*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.6000000000000001*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[20] = vals[0];
}

void poisson2d_5_finite_element_2::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
}

void poisson2d_5_finite_element_2::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = 0.8*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    dof_coordinates[7] = 0.8*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    dof_coordinates[8] = 0.6*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
    dof_coordinates[9] = 0.6*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
    dof_coordinates[10] = 0.3999999999999999*coordinate_dofs[2] + 0.6000000000000001*coordinate_dofs[4];
    dof_coordinates[11] = 0.3999999999999999*coordinate_dofs[3] + 0.6000000000000001*coordinate_dofs[5];
    dof_coordinates[12] = 0.2*coordinate_dofs[2] + 0.8*coordinate_dofs[4];
    dof_coordinates[13] = 0.2*coordinate_dofs[3] + 0.8*coordinate_dofs[5];
    dof_coordinates[14] = 0.8*coordinate_dofs[0] + 0.2*coordinate_dofs[4];
    dof_coordinates[15] = 0.8*coordinate_dofs[1] + 0.2*coordinate_dofs[5];
    dof_coordinates[16] = 0.6*coordinate_dofs[0] + 0.4*coordinate_dofs[4];
    dof_coordinates[17] = 0.6*coordinate_dofs[1] + 0.4*coordinate_dofs[5];
    dof_coordinates[18] = 0.3999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[4];
    dof_coordinates[19] = 0.3999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[5];
    dof_coordinates[20] = 0.2*coordinate_dofs[0] + 0.8*coordinate_dofs[4];
    dof_coordinates[21] = 0.2*coordinate_dofs[1] + 0.8*coordinate_dofs[5];
    dof_coordinates[22] = 0.8*coordinate_dofs[0] + 0.2*coordinate_dofs[2];
    dof_coordinates[23] = 0.8*coordinate_dofs[1] + 0.2*coordinate_dofs[3];
    dof_coordinates[24] = 0.6*coordinate_dofs[0] + 0.4*coordinate_dofs[2];
    dof_coordinates[25] = 0.6*coordinate_dofs[1] + 0.4*coordinate_dofs[3];
    dof_coordinates[26] = 0.3999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[2];
    dof_coordinates[27] = 0.3999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[3];
    dof_coordinates[28] = 0.2*coordinate_dofs[0] + 0.8*coordinate_dofs[2];
    dof_coordinates[29] = 0.2*coordinate_dofs[1] + 0.8*coordinate_dofs[3];
    dof_coordinates[30] = 0.6000000000000001*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    dof_coordinates[31] = 0.6000000000000001*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    dof_coordinates[32] = 0.4*coordinate_dofs[0] + 0.4*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    dof_coordinates[33] = 0.4*coordinate_dofs[1] + 0.4*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    dof_coordinates[34] = 0.1999999999999999*coordinate_dofs[0] + 0.6000000000000001*coordinate_dofs[2] + 0.2*coordinate_dofs[4];
    dof_coordinates[35] = 0.1999999999999999*coordinate_dofs[1] + 0.6000000000000001*coordinate_dofs[3] + 0.2*coordinate_dofs[5];
    dof_coordinates[36] = 0.4*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
    dof_coordinates[37] = 0.4*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
    dof_coordinates[38] = 0.2*coordinate_dofs[0] + 0.4*coordinate_dofs[2] + 0.4*coordinate_dofs[4];
    dof_coordinates[39] = 0.2*coordinate_dofs[1] + 0.4*coordinate_dofs[3] + 0.4*coordinate_dofs[5];
    dof_coordinates[40] = 0.2*coordinate_dofs[0] + 0.2*coordinate_dofs[2] + 0.6000000000000001*coordinate_dofs[4];
    dof_coordinates[41] = 0.2*coordinate_dofs[1] + 0.2*coordinate_dofs[3] + 0.6000000000000001*coordinate_dofs[5];
}

std::size_t poisson2d_5_finite_element_2::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson2d_5_finite_element_2::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson2d_5_finite_element_2::create() const
{
    return new poisson2d_5_finite_element_2();
}


poisson2d_5_dofmap_0::poisson2d_5_dofmap_0() : ufc::dofmap()
{
    // Do nothing
}

poisson2d_5_dofmap_0::~poisson2d_5_dofmap_0()
{
    // Do nothing
}

const char * poisson2d_5_dofmap_0::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
}

bool poisson2d_5_dofmap_0::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson2d_5_dofmap_0::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_dofmap_0::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0];
}

std::size_t poisson2d_5_dofmap_0::num_element_dofs() const
{
    return 3;
}

std::size_t poisson2d_5_dofmap_0::num_facet_dofs() const
{
    return 2;
}

std::size_t poisson2d_5_dofmap_0::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_dofmap_0::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

void poisson2d_5_dofmap_0::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
}

void poisson2d_5_dofmap_0::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
        break;
      }
    }
    
}

void poisson2d_5_dofmap_0::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
}

void poisson2d_5_dofmap_0::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    }
    
}

std::size_t poisson2d_5_dofmap_0::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson2d_5_dofmap_0::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson2d_5_dofmap_0::create() const
{
    return new poisson2d_5_dofmap_0();
}


poisson2d_5_dofmap_1::poisson2d_5_dofmap_1() : ufc::dofmap()
{
    // Do nothing
}

poisson2d_5_dofmap_1::~poisson2d_5_dofmap_1()
{
    // Do nothing
}

const char * poisson2d_5_dofmap_1::signature() const
{
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
}

bool poisson2d_5_dofmap_1::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson2d_5_dofmap_1::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_dofmap_1::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return 2*num_global_entities[0];
}

std::size_t poisson2d_5_dofmap_1::num_element_dofs() const
{
    return 6;
}

std::size_t poisson2d_5_dofmap_1::num_facet_dofs() const
{
    return 4;
}

std::size_t poisson2d_5_dofmap_1::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_dofmap_1::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 4;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
}

void poisson2d_5_dofmap_1::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
}

void poisson2d_5_dofmap_1::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 5;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 5;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 4;
        break;
      }
    }
    
}

void poisson2d_5_dofmap_1::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
}

void poisson2d_5_dofmap_1::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
        break;
      }
    }
    
}

std::size_t poisson2d_5_dofmap_1::num_sub_dofmaps() const
{
    return 2;
}

ufc::dofmap * poisson2d_5_dofmap_1::create_sub_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_5_dofmap_0();
        break;
      }
    case 1:
      {
        return new poisson2d_5_dofmap_0();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson2d_5_dofmap_1::create() const
{
    return new poisson2d_5_dofmap_1();
}


poisson2d_5_dofmap_2::poisson2d_5_dofmap_2() : ufc::dofmap()
{
    // Do nothing
}

poisson2d_5_dofmap_2::~poisson2d_5_dofmap_2()
{
    // Do nothing
}

const char * poisson2d_5_dofmap_2::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 5)";
}

bool poisson2d_5_dofmap_2::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return true;
        break;
      }
    case 2:
      {
        return true;
        break;
      }
    }
    
    return false;
}

std::size_t poisson2d_5_dofmap_2::topological_dimension() const
{
    return 2;
}

std::size_t poisson2d_5_dofmap_2::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0] + 4*num_global_entities[1] + 6*num_global_entities[2];
}

std::size_t poisson2d_5_dofmap_2::num_element_dofs() const
{
    return 21;
}

std::size_t poisson2d_5_dofmap_2::num_facet_dofs() const
{
    return 6;
}

std::size_t poisson2d_5_dofmap_2::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 4;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_dofmap_2::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 6;
        break;
      }
    case 2:
      {
        return 21;
        break;
      }
    }
    
    return 0;
}

void poisson2d_5_dofmap_2::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + 4*entity_indices[1][0];
    dofs[4] = offset + 4*entity_indices[1][0] + 1;
    dofs[5] = offset + 4*entity_indices[1][0] + 2;
    dofs[6] = offset + 4*entity_indices[1][0] + 3;
    dofs[7] = offset + 4*entity_indices[1][1];
    dofs[8] = offset + 4*entity_indices[1][1] + 1;
    dofs[9] = offset + 4*entity_indices[1][1] + 2;
    dofs[10] = offset + 4*entity_indices[1][1] + 3;
    dofs[11] = offset + 4*entity_indices[1][2];
    dofs[12] = offset + 4*entity_indices[1][2] + 1;
    dofs[13] = offset + 4*entity_indices[1][2] + 2;
    dofs[14] = offset + 4*entity_indices[1][2] + 3;
    offset += 4*num_global_entities[1];
    dofs[15] = offset + 6*entity_indices[2][0];
    dofs[16] = offset + 6*entity_indices[2][0] + 1;
    dofs[17] = offset + 6*entity_indices[2][0] + 2;
    dofs[18] = offset + 6*entity_indices[2][0] + 3;
    dofs[19] = offset + 6*entity_indices[2][0] + 4;
    dofs[20] = offset + 6*entity_indices[2][0] + 5;
    offset += 6*num_global_entities[2];
}

void poisson2d_5_dofmap_2::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 6;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 7;
      dofs[3] = 8;
      dofs[4] = 9;
      dofs[5] = 10;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 11;
      dofs[3] = 12;
      dofs[4] = 13;
      dofs[5] = 14;
        break;
      }
    }
    
}

void poisson2d_5_dofmap_2::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        dofs[3] = 6;
          break;
        }
      case 1:
        {
          dofs[0] = 7;
        dofs[1] = 8;
        dofs[2] = 9;
        dofs[3] = 10;
          break;
        }
      case 2:
        {
          dofs[0] = 11;
        dofs[1] = 12;
        dofs[2] = 13;
        dofs[3] = 14;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 15;
      dofs[1] = 16;
      dofs[2] = 17;
      dofs[3] = 18;
      dofs[4] = 19;
      dofs[5] = 20;
        break;
      }
    }
    
}

void poisson2d_5_dofmap_2::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 6;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 7;
        dofs[3] = 8;
        dofs[4] = 9;
        dofs[5] = 10;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 11;
        dofs[3] = 12;
        dofs[4] = 13;
        dofs[5] = 14;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
      dofs[12] = 12;
      dofs[13] = 13;
      dofs[14] = 14;
      dofs[15] = 15;
      dofs[16] = 16;
      dofs[17] = 17;
      dofs[18] = 18;
      dofs[19] = 19;
      dofs[20] = 20;
        break;
      }
    }
    
}

std::size_t poisson2d_5_dofmap_2::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson2d_5_dofmap_2::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson2d_5_dofmap_2::create() const
{
    return new poisson2d_5_dofmap_2();
}


poisson2d_5_cell_integral_0_otherwise::poisson2d_5_cell_integral_0_otherwise() : ufc::cell_integral()
{

}

poisson2d_5_cell_integral_0_otherwise::~poisson2d_5_cell_integral_0_otherwise()
{

}

const std::vector<bool> & poisson2d_5_cell_integral_0_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({});
return enabled;
}

void poisson2d_5_cell_integral_0_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 8
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 8
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           8
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q25[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q25[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q25[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q25[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q25[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q25[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.342406580687832 * sp[19] + 0.3424065806878323 * sp[18] + 0.3424065806878323 * sp[18] + 0.3424065806878326 * sp[17];
    A[1] = -0.04099840167548433 * sp[19] + -0.04099840167548528 * sp[18];
    A[2] = -0.04099840167548547 * sp[18] + -0.0409984016754858 * sp[17];
    A[3] = -0.04081927910052825 * sp[19] + -0.04081927910052833 * sp[18] + -0.04081927910052976 * sp[18] + -0.04081927910053118 * sp[17];
    A[4] = -0.03797743055555523 * sp[19] + -0.0379774305555538 * sp[18] + -0.03797743055555574 * sp[18] + -0.03797743055555303 * sp[17];
    A[5] = -0.03797743055555416 * sp[19] + -0.03797743055555592 * sp[18] + -0.03797743055555379 * sp[18] + -0.03797743055555687 * sp[17];
    A[6] = -0.04081927910052922 * sp[19] + -0.04081927910052806 * sp[18] + -0.04081927910053013 * sp[18] + -0.04081927910052821 * sp[17];
    A[7] = 0.2022879464285735 * sp[19] + -0.6480275848765444 * sp[18] + 0.2022879464285736 * sp[18] + -0.6480275848765451 * sp[17];
    A[8] = -0.01584545855379456 * sp[19] + 0.5942046957671956 * sp[18] + -0.01584545855379343 * sp[18] + 0.594204695767196 * sp[17];
    A[9] = -0.06966834766313854 * sp[19] + -0.4499593529541442 * sp[18] + -0.06966834766313845 * sp[18] + -0.4499593529541448 * sp[17];
    A[10] = 0.04081927910052927 * sp[19] + 0.2023740630511469 * sp[18] + 0.04081927910053017 * sp[18] + 0.2023740630511471 * sp[17];
    A[11] = -0.6480275848765448 * sp[19] + 0.202287946428573 * sp[18] + -0.648027584876546 * sp[18] + 0.2022879464285723 * sp[17];
    A[12] = 0.594204695767195 * sp[19] + -0.01584545855379275 * sp[18] + 0.5942046957671966 * sp[18] + -0.01584545855379283 * sp[17];
    A[13] = -0.4499593529541439 * sp[19] + -0.06966834766313887 * sp[18] + -0.4499593529541447 * sp[18] + -0.06966834766313974 * sp[17];
    A[14] = 0.2023740630511457 * sp[19] + 0.04081927910052823 * sp[18] + 0.2023740630511471 * sp[18] + 0.04081927910053109 * sp[17];
    A[15] = -0.2152915564373931 * sp[19] + -0.2152915564373923 * sp[18] + -0.2152915564373936 * sp[18] + -0.2152915564373911 * sp[17];
    A[16] = -0.05382288910934412 * sp[19] + -0.05382288910934259 * sp[18] + -0.05382288910934366 * sp[18] + -0.05382288910934159 * sp[17];
    A[17] = 0.1076457782186923 * sp[19] + 0.1076457782186899 * sp[18] + 0.1076457782186939 * sp[18] + 0.10764577821869 * sp[17];
    A[18] = -0.05382288910934298 * sp[19] + -0.0538228891093489 * sp[18] + -0.05382288910934391 * sp[18] + -0.05382288910934974 * sp[17];
    A[19] = 0.1076457782186926 * sp[19] + 0.107645778218696 * sp[18] + 0.1076457782186929 * sp[18] + 0.1076457782186961 * sp[17];
    A[20] = 0.1076457782186926 * sp[19] + 0.1076457782186943 * sp[18] + 0.1076457782186922 * sp[18] + 0.1076457782186946 * sp[17];
    A[21] = -0.04099840167548433 * sp[19] + -0.04099840167548528 * sp[18];
    A[22] = 0.3424065806878282 * sp[19];
    A[23] = 0.04099840167548517 * sp[18];
    A[24] = 0.2022879464285677 * sp[19] + 0.850315531305108 * sp[18];
    A[25] = -0.01584545855378995 * sp[19] + -0.6100501543209872 * sp[18];
    A[26] = -0.06966834766313884 * sp[19] + 0.380291005291007 * sp[18];
    A[27] = 0.0408192791005288 * sp[19] + -0.1615547839506196 * sp[18];
    A[28] = -0.04081927910053054 * sp[19];
    A[29] = -0.03797743055555613 * sp[19];
    A[30] = -0.03797743055555416 * sp[19];
    A[31] = -0.04081927910052884 * sp[19];
    A[32] = 0.2023740630511444 * sp[19] + 0.1615547839506138 * sp[18];
    A[33] = -0.4499593529541391 * sp[19] + -0.3802910052909976 * sp[18];
    A[34] = 0.5942046957671868 * sp[19] + 0.6100501543209803 * sp[18];
    A[35] = -0.6480275848765358 * sp[19] + -0.8503155313051092 * sp[18];
    A[36] = 0.1076457782186992 * sp[19];
    A[37] = -0.05382288910935458 * sp[19];
    A[38] = -0.215291556437382 * sp[19];
    A[39] = 0.1076457782186966 * sp[19];
    A[40] = -0.05382288910935037 * sp[19];
    A[41] = 0.107645778218693 * sp[19];
    A[42] = -0.04099840167548547 * sp[18] + -0.0409984016754858 * sp[17];
    A[43] = 0.04099840167548517 * sp[18];
    A[44] = 0.3424065806878316 * sp[17];
    A[45] = -0.1615547839506164 * sp[18] + 0.04081927910053096 * sp[17];
    A[46] = 0.380291005291007 * sp[18] + -0.06966834766314027 * sp[17];
    A[47] = -0.6100501543209894 * sp[18] + -0.01584545855378921 * sp[17];
    A[48] = 0.8503155313051169 * sp[18] + 0.2022879464285697 * sp[17];
    A[49] = 0.161554783950617 * sp[18] + 0.2023740630511477 * sp[17];
    A[50] = -0.3802910052910072 * sp[18] + -0.4499593529541478 * sp[17];
    A[51] = 0.6100501543209906 * sp[18] + 0.594204695767201 * sp[17];
    A[52] = -0.8503155313051174 * sp[18] + -0.6480275848765473 * sp[17];
    A[53] = -0.04081927910053149 * sp[17];
    A[54] = -0.03797743055555652 * sp[17];
    A[55] = -0.0379774305555558 * sp[17];
    A[56] = -0.04081927910053007 * sp[17];
    A[57] = 0.1076457782186985 * sp[17];
    A[58] = 0.1076457782186963 * sp[17];
    A[59] = 0.1076457782186963 * sp[17];
    A[60] = -0.05382288910935165 * sp[17];
    A[61] = -0.05382288910935309 * sp[17];
    A[62] = -0.2152915564373835 * sp[17];
    A[63] = -0.04081927910052825 * sp[19] + -0.04081927910052976 * sp[18] + -0.04081927910052833 * sp[18] + -0.04081927910053118 * sp[17];
    A[64] = 0.2022879464285677 * sp[19] + 0.850315531305108 * sp[18];
    A[65] = -0.1615547839506164 * sp[18] + 0.04081927910053096 * sp[17];
    A[66] = 1.989293981481469 * sp[19] + 1.280984760802456 * sp[18] + 1.280984760802456 * sp[18] + 2.56196952160492 * sp[17];
    A[67] = -0.9063774526014099 * sp[19] + 0.7965787588183368 * sp[18] + -0.5296172288359725 * sp[18] + -1.395089285714288 * sp[17];
    A[68] = 0.8181079144620788 * sp[19] + -0.4822530864197514 * sp[18] + 0.2325148809523799 * sp[18] + 0.8956128747795488 * sp[17];
    A[69] = -0.3401606591710766 * sp[19] + 0.3293960813492013 * sp[18] + -0.07104621362433734 * sp[18] + -0.3401606591710836 * sp[17];
    A[70] = 0.1420924272486727 * sp[19] + 0.07104621362433906 * sp[18] + 0.07104621362433025 * sp[18];
    A[71] = 0.1313278494268137 * sp[19] + 0.03014081790124095 * sp[18] + 0.03014081790123759 * sp[18];
    A[72] = 0.1722332451499092 * sp[19] + 0.03014081790122865 * sp[18] + 0.03014081790123779 * sp[18];
    A[73] = 0.3401606591710765 * sp[19] + 0.07104621362434378 * sp[18] + 0.07104621362433716 * sp[18];
    A[74] = 0.1980682319223915 * sp[19] + 0.2691144455467241 * sp[18] + 0.2691144455467313 * sp[18] + 0.3401606591710589 * sp[17];
    A[75] = -0.3595368992504254 * sp[19] + -0.6630979938271441 * sp[18] + -0.663097993827143 * sp[18] + -0.8956128747795195 * sp[17];
    A[76] = 0.2863377700617098 * sp[19] + 0.8654720568782928 * sp[18] + 0.8654720568782797 * sp[18] + 1.395089285714263 * sp[17];
    A[77] = -0.2863377700617156 * sp[19] + -1.280984760802458 * sp[18] + -1.280984760802448 * sp[18] + -2.561969521604923 * sp[17];
    A[78] = -0.6674038249558926 * sp[19] + -0.2626556988535987 * sp[18] + -0.2626556988535986 * sp[18];
    A[79] = 1.356336805555532 * sp[19] + 0.5726755401234278 * sp[18] + 0.572675540123437 * sp[18];
    A[80] = -2.82031938932978 * sp[19] + -1.662050815696616 * sp[18] + -1.662050815696624 * sp[18];
    A[81] = -0.4198185350529175 * sp[19] + -0.0731991291887148 * sp[18] + -0.07319912918871314 * sp[18];
    A[82] = 1.194868138227511 * sp[19] + 0.572675540123455 * sp[18] + 0.5726755401234468 * sp[18];
    A[83] = -0.9903411596119871 * sp[19] + -0.262655698853618 * sp[18] + -0.2626556988536171 * sp[18];
    A[84] = -0.03797743055555523 * sp[19] + -0.03797743055555574 * sp[18] + -0.0379774305555538 * sp[18] + -0.03797743055555303 * sp[17];
    A[85] = -0.01584545855378995 * sp[19] + -0.6100501543209872 * sp[18];
    A[86] = 0.380291005291007 * sp[18] + -0.06966834766314027 * sp[17];
    A[87] = -0.9063774526014099 * sp[19] + -0.5296172288359725 * sp[18] + 0.7965787588183368 * sp[18] + -1.395089285714288 * sp[17];
    A[88] = 3.07436342592592 * sp[19] + 1.175491898148142 * sp[18] + 1.175491898148142 * sp[18] + 3.69440310846561 * sp[17];
    A[89] = -1.804143242945328 * sp[19] + 0.6996975584215147 * sp[18] + -0.3509252369929485 * sp[18] + -1.804143242945339 * sp[17];
    A[90] = 0.8956128747795463 * sp[19] + -0.4822530864197523 * sp[18] + 0.2325148809523811 * sp[18] + 0.8181079144620869 * sp[17];
    A[91] = 0.1313278494268082 * sp[19] + 0.1011870315255729 * sp[18] + 0.1011870315255795 * sp[18] + 0.07104621362433487 * sp[17];
    A[92] = -0.2971023478836025 * sp[19] + -0.1485511739418009 * sp[18] + -0.1485511739418003 * sp[18] + -0.01722332451498805 * sp[17];
    A[93] = -0.2195973875661306 * sp[19] + -0.06243455136683515 * sp[18] + -0.06243455136684598 * sp[18] + -0.01722332451499209 * sp[17];
    A[94] = -0.8956128747795462 * sp[19] + -0.2325148809523859 * sp[18] + -0.2325148809523812 * sp[18] + 0.07104621362434207 * sp[17];
    A[95] = 0.1119516093474398 * sp[19] + 0.1420924272486733 * sp[18] + 0.1420924272486715 * sp[18] + 0.1722332451499139 * sp[17];
    A[96] = -0.1119516093474396 * sp[19] + -0.15716283619929 * sp[18] + -0.1571628361992889 * sp[18] + -0.2195973875661316 * sp[17];
    A[97] = 0.1033399470899508 * sp[19] + 0.1334807649911869 * sp[18] + 0.1334807649911861 * sp[18] + 0.2669615299823694 * sp[17];
    A[98] = -0.04951705798060532 * sp[19] + 0.5296172288359738 * sp[18] + 0.5296172288359726 * sp[18] + 1.395089285714289 * sp[17];
    A[99] = -0.3444664902998138 * sp[19] + -0.4478064373897627 * sp[18] + -0.4478064373897616 * sp[18] + -0.5166997354497366 * sp[17];
    A[100] = 0.387524801587281 * sp[19] + 0.8590133101851629 * sp[18] + 0.8590133101851569 * sp[18] + 1.011870315255714 * sp[17];
    A[101] = 0.7319912918871327 * sp[19] + -1.308972663139326 * sp[18] + -1.308972663139312 * sp[18] + -3.961364638447971 * sp[17];
    A[102] = 1.033399470899462 * sp[19] + 0.3746073082010465 * sp[18] + 0.3746073082010491 * sp[18] + 0.0430583112874674 * sp[17];
    A[103] = -3.810660548941777 * sp[19] + -1.401548032407395 * sp[18] + -1.401548032407391 * sp[18] + 1.011870315255744 * sp[17];
    A[104] = 2.023740630511456 * sp[19] + 0.4133597883597954 * sp[18] + 0.4133597883597937 * sp[18] + -0.5166997354497299 * sp[17];
    A[105] = -0.03797743055555416 * sp[19] + -0.03797743055555379 * sp[18] + -0.03797743055555592 * sp[18] + -0.03797743055555687 * sp[17];
    A[106] = -0.06966834766313884 * sp[19] + 0.380291005291007 * sp[18];
    A[107] = -0.6100501543209894 * sp[18] + -0.01584545855378921 * sp[17];
    A[108] = 0.8181079144620788 * sp[19] + 0.2325148809523799 * sp[18] + -0.4822530864197514 * sp[18] + 0.8956128747795488 * sp[17];
    A[109] = -1.804143242945328 * sp[19] + -0.3509252369929485 * sp[18] + 0.6996975584215147 * sp[18] + -1.804143242945339 * sp[17];
    A[110] = 3.694403108465594 * sp[19] + 1.175491898148136 * sp[18] + 1.175491898148136 * sp[18] + 3.074363425925927 * sp[17];
    A[111] = -1.395089285714291 * sp[19] + 0.7965787588183346 * sp[18] + -0.5296172288359776 * sp[18] + -0.9063774526014228 * sp[17];
    A[112] = 0.1722332451499023 * sp[19] + 0.1420924272486679 * sp[18] + 0.1420924272486646 * sp[18] + 0.1119516093474395 * sp[17];
    A[113] = -0.2195973875661238 * sp[19] + -0.157162836199278 * sp[18] + -0.1571628361992858 * sp[18] + -0.1119516093474354 * sp[17];
    A[114] = 0.266961529982349 * sp[19] + 0.133480764991168 * sp[18] + 0.1334807649911785 * sp[18] + 0.1033399470899455 * sp[17];
    A[115] = 1.395089285714292 * sp[19] + 0.5296172288359884 * sp[18] + 0.5296172288359776 * sp[18] + -0.04951705798060096 * sp[17];
    A[116] = 0.07104621362433533 * sp[19] + 0.1011870315255707 * sp[18] + 0.101187031525571 * sp[18] + 0.1313278494267962 * sp[17];
    A[117] = -0.01722332451498916 * sp[19] + -0.1485511739417954 * sp[18] + -0.1485511739417961 * sp[18] + -0.2971023478835951 * sp[17];
    A[118] = -0.01722332451499304 * sp[19] + -0.06243455136684728 * sp[18] + -0.06243455136684797 * sp[18] + -0.2195973875661455 * sp[17];
    A[119] = 0.07104621362433927 * sp[19] + -0.2325148809523806 * sp[18] + -0.2325148809523784 * sp[18] + -0.8956128747795488 * sp[17];
    A[120] = -0.5166997354497175 * sp[19] + -0.4478064373897672 * sp[18] + -0.4478064373897529 * sp[18] + -0.3444664902998056 * sp[17];
    A[121] = 0.04305831128747142 * sp[19] + 0.3746073082010541 * sp[18] + 0.3746073082010498 * sp[18] + 1.033399470899458 * sp[17];
    A[122] = -0.5166997354497315 * sp[19] + 0.4133597883598016 * sp[18] + 0.4133597883597904 * sp[18] + 2.023740630511488 * sp[17];
    A[123] = 1.011870315255712 * sp[19] + 0.8590133101851811 * sp[18] + 0.8590133101851678 * sp[18] + 0.3875248015872937 * sp[17];
    A[124] = 1.011870315255736 * sp[19] + -1.4015480324074 * sp[18] + -1.401548032407396 * sp[18] + -3.810660548941792 * sp[17];
    A[125] = -3.961364638447941 * sp[19] + -1.308972663139322 * sp[18] + -1.308972663139315 * sp[18] + 0.7319912918871329 * sp[17];
    A[126] = -0.04081927910052922 * sp[19] + -0.04081927910053013 * sp[18] + -0.04081927910052806 * sp[18] + -0.04081927910052821 * sp[17];
    A[127] = 0.0408192791005288 * sp[19] + -0.1615547839506196 * sp[18];
    A[128] = 0.8503155313051169 * sp[18] + 0.2022879464285697 * sp[17];
    A[129] = -0.3401606591710766 * sp[19] + -0.07104621362433734 * sp[18] + 0.3293960813492013 * sp[18] + -0.3401606591710836 * sp[17];
    A[130] = 0.8956128747795463 * sp[19] + 0.2325148809523811 * sp[18] + -0.4822530864197523 * sp[18] + 0.8181079144620869 * sp[17];
    A[131] = -1.395089285714291 * sp[19] + -0.5296172288359776 * sp[18] + 0.7965787588183346 * sp[18] + -0.9063774526014228 * sp[17];
    A[132] = 2.561969521604951 * sp[19] + 1.280984760802473 * sp[18] + 1.280984760802473 * sp[18] + 1.989293981481486 * sp[17];
    A[133] = 0.3401606591710777 * sp[19] + 0.2691144455467399 * sp[18] + 0.2691144455467387 * sp[18] + 0.1980682319223967 * sp[17];
    A[134] = -0.8956128747795487 * sp[19] + -0.6630979938271683 * sp[18] + -0.6630979938271591 * sp[18] + -0.3595368992504391 * sp[17];
    A[135] = 1.395089285714296 * sp[19] + 0.8654720568783195 * sp[18] + 0.8654720568783104 * sp[18] + 0.2863377700617299 * sp[17];
    A[136] = -2.561969521604952 * sp[19] + -1.280984760802479 * sp[18] + -1.280984760802473 * sp[18] + -0.2863377700617285 * sp[17];
    A[137] = 0.07104621362433527 * sp[18] + 0.07104621362433597 * sp[18] + 0.1420924272486784 * sp[17];
    A[138] = 0.03014081790123613 * sp[18] + 0.03014081790123687 * sp[18] + 0.1313278494268134 * sp[17];
    A[139] = 0.03014081790123514 * sp[18] + 0.03014081790123544 * sp[18] + 0.1722332451499143 * sp[17];
    A[140] = 0.07104621362434071 * sp[18] + 0.07104621362433898 * sp[18] + 0.340160659171086 * sp[17];
    A[141] = -0.2626556988536112 * sp[18] + -0.2626556988536115 * sp[18] + -0.6674038249559102 * sp[17];
    A[142] = -0.07319912918871235 * sp[18] + -0.07319912918871611 * sp[18] + -0.4198185350529117 * sp[17];
    A[143] = -0.2626556988536151 * sp[18] + -0.2626556988536099 * sp[18] + -0.9903411596119975 * sp[17];
    A[144] = 0.5726755401234465 * sp[18] + 0.5726755401234527 * sp[18] + 1.35633680555555 * sp[17];
    A[145] = 0.5726755401234439 * sp[18] + 0.5726755401234541 * sp[18] + 1.194868138227509 * sp[17];
    A[146] = -1.662050815696638 * sp[18] + -1.662050815696643 * sp[18] + -2.8203193893298 * sp[17];
    A[147] = 0.2022879464285735 * sp[19] + 0.2022879464285736 * sp[18] + -0.6480275848765444 * sp[18] + -0.6480275848765451 * sp[17];
    A[148] = -0.04081927910053054 * sp[19];
    A[149] = 0.161554783950617 * sp[18] + 0.2023740630511477 * sp[17];
    A[150] = 0.1420924272486727 * sp[19] + 0.07104621362433025 * sp[18] + 0.07104621362433906 * sp[18];
    A[151] = 0.1313278494268082 * sp[19] + 0.1011870315255795 * sp[18] + 0.1011870315255729 * sp[18] + 0.07104621362433487 * sp[17];
    A[152] = 0.1722332451499023 * sp[19] + 0.1420924272486646 * sp[18] + 0.1420924272486679 * sp[18] + 0.1119516093474395 * sp[17];
    A[153] = 0.3401606591710777 * sp[19] + 0.2691144455467387 * sp[18] + 0.2691144455467399 * sp[18] + 0.1980682319223967 * sp[17];
    A[154] = 1.989293981481487 * sp[19] + 0.7083092206790138 * sp[18] + 0.7083092206790138 * sp[18] + 1.989293981481483 * sp[17];
    A[155] = -0.9063774526014066 * sp[19] + -1.702956211419759 * sp[18] + -0.3767602237654269 * sp[18] + -2.568428268298061 * sp[17];
    A[156] = 0.8181079144620775 * sp[19] + 1.300361000881837 * sp[18] + 0.585593033509697 * sp[18] + 1.963458994708994 * sp[17];
    A[157] = -0.340160659171078 * sp[19] + -0.6695567405202864 * sp[18] + -0.2691144455467401 * sp[18] + -0.9386711860670225 * sp[17];
    A[158] = -0.2863377700617342 * sp[19] + 0.9946469907407394 * sp[18] + 0.9946469907407437 * sp[18] + -0.2863377700617251 * sp[17];
    A[159] = 0.2863377700617343 * sp[19] + -0.579134286816573 * sp[18] + -0.5791342868165789 * sp[18] + -0.04951705798059679 * sp[17];
    A[160] = -0.3595368992504458 * sp[19] + 0.3035610945767182 * sp[18] + 0.3035610945767196 * sp[18] + 0.07104621362434449 * sp[17];
    A[161] = 0.1980682319224016 * sp[19] + -0.07104621362433469 * sp[18] + -0.0710462136243411 * sp[18];
    A[162] = -2.820319389329808 * sp[19] + -1.158268573633147 * sp[18] + -1.158268573633154 * sp[18] + 0.5037822420634926 * sp[17];
    A[163] = 1.356336805555552 * sp[19] + 0.7836612654320935 * sp[18] + 0.7836612654320959 * sp[18] + 0.2109857253086315 * sp[17];
    A[164] = -0.6674038249559033 * sp[19] + -0.4047481261022959 * sp[18] + -0.4047481261022952 * sp[18] + -0.1420924272486736 * sp[17];
    A[165] = 1.194868138227502 * sp[19] + 0.6221925981040343 * sp[18] + 0.6221925981040434 * sp[18] + 0.04951705798059639 * sp[17];
    A[166] = -0.4198185350529052 * sp[19] + -0.3466194058641816 * sp[18] + -0.3466194058641901 * sp[18] + -0.2734202766754812 * sp[17];
    A[167] = -0.9903411596119804 * sp[19] + -0.7276854607583659 * sp[18] + -0.727685460758365 * sp[18] + -0.4650297619047563 * sp[17];
    A[168] = -0.01584545855379456 * sp[19] + -0.01584545855379343 * sp[18] + 0.5942046957671956 * sp[18] + 0.594204695767196 * sp[17];
    A[169] = -0.03797743055555613 * sp[19];
    A[170] = -0.3802910052910072 * sp[18] + -0.4499593529541478 * sp[17];
    A[171] = 0.1313278494268137 * sp[19] + 0.03014081790123759 * sp[18] + 0.03014081790124095 * sp[18];
    A[172] = -0.2971023478836025 * sp[19] + -0.1485511739418003 * sp[18] + -0.1485511739418009 * sp[18] + -0.01722332451498805 * sp[17];
    A[173] = -0.2195973875661238 * sp[19] + -0.1571628361992858 * sp[18] + -0.157162836199278 * sp[18] + -0.1119516093474354 * sp[17];
    A[174] = -0.8956128747795487 * sp[19] + -0.6630979938271591 * sp[18] + -0.6630979938271683 * sp[18] + -0.3595368992504391 * sp[17];
    A[175] = -0.9063774526014066 * sp[19] + -0.3767602237654269 * sp[18] + -1.702956211419759 * sp[18] + -2.568428268298061 * sp[17];
    A[176] = 3.074363425925924 * sp[19] + 1.898871527777773 * sp[18] + 1.898871527777773 * sp[18] + 4.417782738095241 * sp[17];
    A[177] = -1.804143242945324 * sp[19] + -2.503840801366843 * sp[18] + -1.45321800595238 * sp[18] + -3.957058807319226 * sp[17];
    A[178] = 0.8956128747795497 * sp[19] + 1.377865961199297 * sp[18] + 0.6630979938271688 * sp[18] + 1.963458994709003 * sp[17];
    A[179] = -0.04951705798059326 * sp[19] + -0.5791342868165755 * sp[18] + -0.5791342868165787 * sp[18] + 0.2863377700617233 * sp[17];
    A[180] = 0.1033399470899446 * sp[19] + -0.03014081790123598 * sp[18] + -0.03014081790123527 * sp[18] + 0.1033399470899433 * sp[17];
    A[181] = -0.1119516093474431 * sp[19] + 0.04521122685185028 * sp[18] + 0.04521122685185223 * sp[18] + -0.01722332451499845 * sp[17];
    A[182] = 0.1119516093474433 * sp[19] + -0.0301408179012376 * sp[18] + -0.03014081790123316 * sp[18];
    A[183] = 0.7319912918871128 * sp[19] + 2.040963955026446 * sp[18] + 2.040963955026453 * sp[18] + -0.6114280202821896 * sp[17];
    A[184] = 0.3875248015873055 * sp[19] + -0.4714885085978805 * sp[18] + -0.4714885085978855 * sp[18] + -0.3186315035273315 * sp[17];
    A[185] = -0.344466490299828 * sp[19] + 0.1033399470899468 * sp[18] + 0.1033399470899484 * sp[18] + 0.0344466490299801 * sp[17];
    A[186] = -3.810660548941789 * sp[19] + -2.409112516534374 * sp[18] + -2.409112516534377 * sp[18] + 0.004305831128759374 * sp[17];
    A[187] = 1.03339947089947 * sp[19] + 0.6587921626984091 * sp[18] + 0.658792162698406 * sp[18] + 0.3272431657848308 * sp[17];
    A[188] = 2.023740630511446 * sp[19] + 1.61038084215166 * sp[18] + 1.610380842151658 * sp[18] + 0.6803213183421404 * sp[17];
    A[189] = -0.06966834766313854 * sp[19] + -0.06966834766313845 * sp[18] + -0.4499593529541442 * sp[18] + -0.4499593529541448 * sp[17];
    A[190] = -0.03797743055555416 * sp[19];
    A[191] = 0.6100501543209906 * sp[18] + 0.594204695767201 * sp[17];
    A[192] = 0.1722332451499092 * sp[19] + 0.03014081790123779 * sp[18] + 0.03014081790122865 * sp[18];
    A[193] = -0.2195973875661306 * sp[19] + -0.06243455136684598 * sp[18] + -0.06243455136683515 * sp[18] + -0.01722332451499209 * sp[17];
    A[194] = 0.266961529982349 * sp[19] + 0.1334807649911785 * sp[18] + 0.133480764991168 * sp[18] + 0.1033399470899455 * sp[17];
    A[195] = 1.395089285714296 * sp[19] + 0.8654720568783104 * sp[18] + 0.8654720568783195 * sp[18] + 0.2863377700617299 * sp[17];
    A[196] = 0.8181079144620775 * sp[19] + 0.585593033509697 * sp[18] + 1.300361000881837 * sp[18] + 1.963458994708994 * sp[17];
    A[197] = -1.804143242945324 * sp[19] + -1.45321800595238 * sp[18] + -2.503840801366843 * sp[18] + -3.957058807319226 * sp[17];
    A[198] = 3.694403108465604 * sp[19] + 2.518911210317463 * sp[18] + 2.518911210317463 * sp[18] + 4.417782738095243 * sp[17];
    A[199] = -1.395089285714298 * sp[19] + -2.191668044532637 * sp[18] + -0.8654720568783207 * sp[18] + -2.568428268298073 * sp[17];
    A[200] = 0.07104621362433643 * sp[19] + 0.3035610945767213 * sp[18] + 0.3035610945767185 * sp[18] + -0.3595368992504371 * sp[17];
    A[201] = -0.01722332451499141 * sp[19] + 0.04521122685185357 * sp[18] + 0.04521122685185232 * sp[18] + -0.1119516093474428 * sp[17];
    A[202] = -0.01722332451498946 * sp[19] + 0.1313278494268091 * sp[18] + 0.1313278494268084 * sp[18] + -0.01722332451498649 * sp[17];
    A[203] = 0.07104621362433629 * sp[19] + -0.03014081790123891 * sp[18] + -0.03014081790123537 * sp[18];
    A[204] = -0.5166997354497258 * sp[19] + -0.9300595238095256 * sp[18] + -0.9300595238095205 * sp[18] + 0.6803213183421525 * sp[17];
    A[205] = 0.043058311287476 * sp[19] + -0.331548996913582 * sp[18] + -0.3315489969135776 * sp[18] + 0.3272431657848336 * sp[17];
    A[206] = -0.5166997354497329 * sp[19] + -0.06889329805995915 * sp[18] + -0.06889329805996527 * sp[18] + 0.03444664902998407 * sp[17];
    A[207] = 1.011870315255721 * sp[19] + 2.413418347663133 * sp[18] + 2.413418347663129 * sp[18] + 0.004305831128740611 * sp[17];
    A[208] = 1.011870315255729 * sp[19] + 0.1528570050705468 * sp[18] + 0.1528570050705454 * sp[18] + -0.3186315035273427 * sp[17];
    A[209] = -3.961364638447948 * sp[19] + -2.652391975308634 * sp[18] + -2.652391975308628 * sp[18] + -0.6114280202821805 * sp[17];
    A[210] = 0.04081927910052927 * sp[19] + 0.04081927910053017 * sp[18] + 0.2023740630511469 * sp[18] + 0.2023740630511471 * sp[17];
    A[211] = -0.04081927910052884 * sp[19];
    A[212] = -0.8503155313051174 * sp[18] + -0.6480275848765473 * sp[17];
    A[213] = 0.3401606591710765 * sp[19] + 0.07104621362433716 * sp[18] + 0.07104621362434378 * sp[18];
    A[214] = -0.8956128747795462 * sp[19] + -0.2325148809523812 * sp[18] + -0.2325148809523859 * sp[18] + 0.07104621362434207 * sp[17];
    A[215] = 1.395089285714292 * sp[19] + 0.5296172288359776 * sp[18] + 0.5296172288359884 * sp[18] + -0.04951705798060096 * sp[17];
    A[216] = -2.561969521604952 * sp[19] + -1.280984760802473 * sp[18] + -1.280984760802479 * sp[18] + -0.2863377700617285 * sp[17];
    A[217] = -0.340160659171078 * sp[19] + -0.2691144455467401 * sp[18] + -0.6695567405202864 * sp[18] + -0.9386711860670225 * sp[17];
    A[218] = 0.8956128747795497 * sp[19] + 0.6630979938271688 * sp[18] + 1.377865961199297 * sp[18] + 1.963458994709003 * sp[17];
    A[219] = -1.395089285714298 * sp[19] + -0.8654720568783207 * sp[18] + -2.191668044532637 * sp[18] + -2.568428268298073 * sp[17];
    A[220] = 2.561969521604953 * sp[19] + 1.28098476080248 * sp[18] + 1.28098476080248 * sp[18] + 1.989293981481495 * sp[17];
    A[221] = -0.07104621362433522 * sp[18] + -0.07104621362433836 * sp[18] + 0.1980682319223974 * sp[17];
    A[222] = -0.03014081790123625 * sp[18] + -0.03014081790123553 * sp[18] + 0.1119516093474417 * sp[17];
    A[223] = -0.03014081790123526 * sp[18] + -0.03014081790123477 * sp[18] + 0.07104621362433515 * sp[17];
    A[224] = -0.07104621362434052 * sp[18] + -0.07104621362433851 * sp[18];
    A[225] = 0.2626556988536115 * sp[18] + 0.2626556988536152 * sp[18] + -0.4650297619047644 * sp[17];
    A[226] = 0.07319912918871234 * sp[18] + 0.07319912918870941 * sp[18] + -0.2734202766754882 * sp[17];
    A[227] = 0.2626556988536152 * sp[18] + 0.2626556988536161 * sp[18] + -0.1420924272486795 * sp[17];
    A[228] = -0.572675540123448 * sp[18] + -0.5726755401234566 * sp[18] + 0.04951705798060324 * sp[17];
    A[229] = -0.572675540123444 * sp[18] + -0.5726755401234525 * sp[18] + 0.2109857253086517 * sp[17];
    A[230] = 1.66205081569664 * sp[18] + 1.662050815696645 * sp[18] + 0.5037822420634885 * sp[17];
    A[231] = -0.6480275848765448 * sp[19] + -0.648027584876546 * sp[18] + 0.202287946428573 * sp[18] + 0.2022879464285723 * sp[17];
    A[232] = 0.2023740630511444 * sp[19] + 0.1615547839506138 * sp[18];
    A[233] = -0.04081927910053149 * sp[17];
    A[234] = 0.1980682319223915 * sp[19] + 0.2691144455467313 * sp[18] + 0.2691144455467241 * sp[18] + 0.3401606591710589 * sp[17];
    A[235] = 0.1119516093474398 * sp[19] + 0.1420924272486715 * sp[18] + 0.1420924272486733 * sp[18] + 0.1722332451499139 * sp[17];
    A[236] = 0.07104621362433533 * sp[19] + 0.101187031525571 * sp[18] + 0.1011870315255707 * sp[18] + 0.1313278494267962 * sp[17];
    A[237] = 0.07104621362433597 * sp[18] + 0.07104621362433527 * sp[18] + 0.1420924272486784 * sp[17];
    A[238] = -0.2863377700617342 * sp[19] + 0.9946469907407437 * sp[18] + 0.9946469907407394 * sp[18] + -0.2863377700617251 * sp[17];
    A[239] = -0.04951705798059326 * sp[19] + -0.5791342868165787 * sp[18] + -0.5791342868165755 * sp[18] + 0.2863377700617233 * sp[17];
    A[240] = 0.07104621362433643 * sp[19] + 0.3035610945767185 * sp[18] + 0.3035610945767213 * sp[18] + -0.3595368992504371 * sp[17];
    A[241] = -0.07104621362433836 * sp[18] + -0.07104621362433522 * sp[18] + 0.1980682319223974 * sp[17];
    A[242] = 1.98929398148148 * sp[19] + 0.7083092206790071 * sp[18] + 0.7083092206790071 * sp[18] + 1.989293981481477 * sp[17];
    A[243] = -2.568428268298055 * sp[19] + -0.3767602237654243 * sp[18] + -1.702956211419745 * sp[18] + -0.906377452601396 * sp[17];
    A[244] = 1.963458994708988 * sp[19] + 0.5855930335096912 * sp[18] + 1.300361000881825 * sp[18] + 0.8181079144620702 * sp[17];
    A[245] = -0.9386711860670138 * sp[19] + -0.2691144455467335 * sp[18] + -0.6695567405202744 * sp[18] + -0.3401606591710637 * sp[17];
    A[246] = 0.5037822420635049 * sp[19] + -1.158268573633148 * sp[18] + -1.158268573633146 * sp[18] + -2.820319389329795 * sp[17];
    A[247] = 0.04951705798057941 * sp[19] + 0.6221925981040346 * sp[18] + 0.622192598104037 * sp[18] + 1.194868138227492 * sp[17];
    A[248] = -0.4650297619047432 * sp[19] + -0.7276854607583552 * sp[18] + -0.7276854607583557 * sp[18] + -0.9903411596119809 * sp[17];
    A[249] = 0.2109857253086325 * sp[19] + 0.7836612654320988 * sp[18] + 0.7836612654320925 * sp[18] + 1.356336805555544 * sp[17];
    A[250] = -0.2734202766754781 * sp[19] + -0.3466194058641914 * sp[18] + -0.3466194058641902 * sp[18] + -0.419818535052892 * sp[17];
    A[251] = -0.1420924272486722 * sp[19] + -0.40474812610229 * sp[18] + -0.4047481261022928 * sp[18] + -0.6674038249559042 * sp[17];
    A[252] = 0.594204695767195 * sp[19] + 0.5942046957671966 * sp[18] + -0.01584545855379275 * sp[18] + -0.01584545855379283 * sp[17];
    A[253] = -0.4499593529541391 * sp[19] + -0.3802910052909976 * sp[18];
    A[254] = -0.03797743055555652 * sp[17];
    A[255] = -0.3595368992504254 * sp[19] + -0.663097993827143 * sp[18] + -0.6630979938271441 * sp[18] + -0.8956128747795195 * sp[17];
    A[256] = -0.1119516093474396 * sp[19] + -0.1571628361992889 * sp[18] + -0.15716283619929 * sp[18] + -0.2195973875661316 * sp[17];
    A[257] = -0.01722332451498916 * sp[19] + -0.1485511739417961 * sp[18] + -0.1485511739417954 * sp[18] + -0.2971023478835951 * sp[17];
    A[258] = 0.03014081790123687 * sp[18] + 0.03014081790123613 * sp[18] + 0.1313278494268134 * sp[17];
    A[259] = 0.2863377700617343 * sp[19] + -0.5791342868165789 * sp[18] + -0.579134286816573 * sp[18] + -0.04951705798059679 * sp[17];
    A[260] = 0.1033399470899446 * sp[19] + -0.03014081790123527 * sp[18] + -0.03014081790123598 * sp[18] + 0.1033399470899433 * sp[17];
    A[261] = -0.01722332451499141 * sp[19] + 0.04521122685185232 * sp[18] + 0.04521122685185357 * sp[18] + -0.1119516093474428 * sp[17];
    A[262] = -0.03014081790123553 * sp[18] + -0.03014081790123625 * sp[18] + 0.1119516093474417 * sp[17];
    A[263] = -2.568428268298055 * sp[19] + -1.702956211419745 * sp[18] + -0.3767602237654243 * sp[18] + -0.906377452601396 * sp[17];
    A[264] = 4.417782738095223 * sp[19] + 1.898871527777758 * sp[18] + 1.898871527777758 * sp[18] + 3.074363425925902 * sp[17];
    A[265] = -3.957058807319203 * sp[19] + -1.453218005952359 * sp[18] + -2.503840801366817 * sp[18] + -1.804143242945296 * sp[17];
    A[266] = 1.963458994708979 * sp[19] + 0.6630979938271463 * sp[18] + 1.377865961199275 * sp[18] + 0.8956128747795207 * sp[17];
    A[267] = -0.611428020282206 * sp[19] + 2.040963955026443 * sp[18] + 2.040963955026433 * sp[18] + 0.731991291887105 * sp[17];
    A[268] = 0.004305831128784557 * sp[19] + -2.409112516534356 * sp[18] + -2.409112516534354 * sp[18] + -3.810660548941773 * sp[17];
    A[269] = 0.6803213183421175 * sp[19] + 1.610380842151639 * sp[18] + 1.610380842151641 * sp[18] + 2.023740630511422 * sp[17];
    A[270] = -0.3186315035273327 * sp[19] + -0.4714885085978844 * sp[18] + -0.4714885085978802 * sp[18] + 0.3875248015873138 * sp[17];
    A[271] = 0.3272431657848259 * sp[19] + 0.6587921626984059 * sp[18] + 0.6587921626984065 * sp[18] + 1.033399470899471 * sp[17];
    A[272] = 0.03444664902998119 * sp[19] + 0.1033399470899467 * sp[18] + 0.1033399470899426 * sp[18] + -0.3444664902998291 * sp[17];
    A[273] = -0.4499593529541439 * sp[19] + -0.4499593529541447 * sp[18] + -0.06966834766313887 * sp[18] + -0.06966834766313974 * sp[17];
    A[274] = 0.5942046957671868 * sp[19] + 0.6100501543209803 * sp[18];
    A[275] = -0.0379774305555558 * sp[17];
    A[276] = 0.2863377700617098 * sp[19] + 0.8654720568782797 * sp[18] + 0.8654720568782928 * sp[18] + 1.395089285714263 * sp[17];
    A[277] = 0.1033399470899508 * sp[19] + 0.1334807649911861 * sp[18] + 0.1334807649911869 * sp[18] + 0.2669615299823694 * sp[17];
    A[278] = -0.01722332451499304 * sp[19] + -0.06243455136684797 * sp[18] + -0.06243455136684728 * sp[18] + -0.2195973875661455 * sp[17];
    A[279] = 0.03014081790123544 * sp[18] + 0.03014081790123514 * sp[18] + 0.1722332451499143 * sp[17];
    A[280] = -0.3595368992504458 * sp[19] + 0.3035610945767196 * sp[18] + 0.3035610945767182 * sp[18] + 0.07104621362434449 * sp[17];
    A[281] = -0.1119516093474431 * sp[19] + 0.04521122685185223 * sp[18] + 0.04521122685185028 * sp[18] + -0.01722332451499845 * sp[17];
    A[282] = -0.01722332451498946 * sp[19] + 0.1313278494268084 * sp[18] + 0.1313278494268091 * sp[18] + -0.01722332451498649 * sp[17];
    A[283] = -0.03014081790123477 * sp[18] + -0.03014081790123526 * sp[18] + 0.07104621362433515 * sp[17];
    A[284] = 1.963458994708988 * sp[19] + 1.300361000881825 * sp[18] + 0.5855930335096912 * sp[18] + 0.8181079144620702 * sp[17];
    A[285] = -3.957058807319203 * sp[19] + -2.503840801366817 * sp[18] + -1.453218005952359 * sp[18] + -1.804143242945296 * sp[17];
    A[286] = 4.417782738095211 * sp[19] + 2.518911210317434 * sp[18] + 2.518911210317434 * sp[18] + 3.694403108465584 * sp[17];
    A[287] = -2.568428268298039 * sp[19] + -0.8654720568782832 * sp[18] + -2.191668044532609 * sp[18] + -1.39508928571427 * sp[17];
    A[288] = 0.6803213183421695 * sp[19] + -0.9300595238095136 * sp[18] + -0.9300595238095095 * sp[18] + -0.5166997354497234 * sp[17];
    A[289] = 0.004305831128712842 * sp[19] + 2.413418347663103 * sp[18] + 2.41341834766311 * sp[18] + 1.011870315255689 * sp[17];
    A[290] = -0.61142802028215 * sp[19] + -2.65239197530861 * sp[18] + -2.652391975308611 * sp[18] + -3.961364638447942 * sp[17];
    A[291] = 0.3272431657848319 * sp[19] + -0.3315489969135789 * sp[18] + -0.3315489969135846 * sp[18] + 0.04305831128747138 * sp[17];
    A[292] = -0.318631503527338 * sp[19] + 0.1528570050705512 * sp[18] + 0.1528570050705464 * sp[18] + 1.011870315255744 * sp[17];
    A[293] = 0.03444664902998212 * sp[19] + -0.06889329805996568 * sp[18] + -0.06889329805996224 * sp[18] + -0.5166997354497308 * sp[17];
    A[294] = 0.2023740630511457 * sp[19] + 0.2023740630511471 * sp[18] + 0.04081927910052823 * sp[18] + 0.04081927910053109 * sp[17];
    A[295] = -0.6480275848765358 * sp[19] + -0.8503155313051092 * sp[18];
    A[296] = -0.04081927910053007 * sp[17];
    A[297] = -0.2863377700617156 * sp[19] + -1.280984760802448 * sp[18] + -1.280984760802458 * sp[18] + -2.561969521604923 * sp[17];
    A[298] = -0.04951705798060532 * sp[19] + 0.5296172288359726 * sp[18] + 0.5296172288359738 * sp[18] + 1.395089285714289 * sp[17];
    A[299] = 0.07104621362433927 * sp[19] + -0.2325148809523784 * sp[18] + -0.2325148809523806 * sp[18] + -0.8956128747795488 * sp[17];
    A[300] = 0.07104621362433898 * sp[18] + 0.07104621362434071 * sp[18] + 0.340160659171086 * sp[17];
    A[301] = 0.1980682319224016 * sp[19] + -0.0710462136243411 * sp[18] + -0.07104621362433469 * sp[18];
    A[302] = 0.1119516093474433 * sp[19] + -0.03014081790123316 * sp[18] + -0.0301408179012376 * sp[18];
    A[303] = 0.07104621362433629 * sp[19] + -0.03014081790123537 * sp[18] + -0.03014081790123891 * sp[18];
    A[304] = -0.07104621362433851 * sp[18] + -0.07104621362434052 * sp[18];
    A[305] = -0.9386711860670138 * sp[19] + -0.6695567405202744 * sp[18] + -0.2691144455467335 * sp[18] + -0.3401606591710637 * sp[17];
    A[306] = 1.963458994708979 * sp[19] + 1.377865961199275 * sp[18] + 0.6630979938271463 * sp[18] + 0.8956128747795207 * sp[17];
    A[307] = -2.568428268298039 * sp[19] + -2.191668044532609 * sp[18] + -0.8654720568782832 * sp[18] + -1.39508928571427 * sp[17];
    A[308] = 1.989293981481464 * sp[19] + 1.280984760802451 * sp[18] + 1.280984760802451 * sp[18] + 2.561969521604926 * sp[17];
    A[309] = -0.4650297619047717 * sp[19] + 0.2626556988536076 * sp[18] + 0.2626556988536017 * sp[18];
    A[310] = 0.04951705798061998 * sp[19] + -0.5726755401234291 * sp[18] + -0.5726755401234394 * sp[18];
    A[311] = 0.5037822420634674 * sp[19] + 1.662050815696627 * sp[18] + 1.66205081569663 * sp[18];
    A[312] = -0.2734202766754867 * sp[19] + 0.07319912918871105 * sp[18] + 0.07319912918871146 * sp[18];
    A[313] = 0.2109857253086478 * sp[19] + -0.5726755401234601 * sp[18] + -0.5726755401234466 * sp[18];
    A[314] = -0.1420924272486753 * sp[19] + 0.2626556988536163 * sp[18] + 0.2626556988536189 * sp[18];
    A[315] = -0.2152915564373931 * sp[19] + -0.2152915564373936 * sp[18] + -0.2152915564373923 * sp[18] + -0.2152915564373911 * sp[17];
    A[316] = 0.1076457782186992 * sp[19];
    A[317] = 0.1076457782186985 * sp[17];
    A[318] = -0.6674038249558926 * sp[19] + -0.2626556988535986 * sp[18] + -0.2626556988535987 * sp[18];
    A[319] = -0.3444664902998138 * sp[19] + -0.4478064373897616 * sp[18] + -0.4478064373897627 * sp[18] + -0.5166997354497366 * sp[17];
    A[320] = -0.5166997354497175 * sp[19] + -0.4478064373897529 * sp[18] + -0.4478064373897672 * sp[18] + -0.3444664902998056 * sp[17];
    A[321] = -0.2626556988536115 * sp[18] + -0.2626556988536112 * sp[18] + -0.6674038249559102 * sp[17];
    A[322] = -2.820319389329808 * sp[19] + -1.158268573633154 * sp[18] + -1.158268573633147 * sp[18] + 0.5037822420634926 * sp[17];
    A[323] = 0.7319912918871128 * sp[19] + 2.040963955026453 * sp[18] + 2.040963955026446 * sp[18] + -0.6114280202821896 * sp[17];
    A[324] = -0.5166997354497258 * sp[19] + -0.9300595238095205 * sp[18] + -0.9300595238095256 * sp[18] + 0.6803213183421525 * sp[17];
    A[325] = 0.2626556988536152 * sp[18] + 0.2626556988536115 * sp[18] + -0.4650297619047644 * sp[17];
    A[326] = 0.5037822420635049 * sp[19] + -1.158268573633146 * sp[18] + -1.158268573633148 * sp[18] + -2.820319389329795 * sp[17];
    A[327] = -0.611428020282206 * sp[19] + 2.040963955026433 * sp[18] + 2.040963955026443 * sp[18] + 0.731991291887105 * sp[17];
    A[328] = 0.6803213183421695 * sp[19] + -0.9300595238095095 * sp[18] + -0.9300595238095136 * sp[18] + -0.5166997354497234 * sp[17];
    A[329] = -0.4650297619047717 * sp[19] + 0.2626556988536017 * sp[18] + 0.2626556988536076 * sp[18];
    A[330] = 7.061563051146369 * sp[19] + 3.100198412698385 * sp[18] + 3.100198412698385 * sp[18] + 7.061563051146369 * sp[17];
    A[331] = -6.329571759259232 * sp[19] + -3.057140101410909 * sp[18] + -3.057140101410905 * sp[18] + -1.808449074074038 * sp[17];
    A[332] = 2.755731922398565 * sp[19] + 1.377865961199267 * sp[18] + 1.377865961199266 * sp[18] + 1.033399470899456 * sp[17];
    A[333] = -1.808449074074044 * sp[19] + -3.057140101410899 * sp[18] + -3.05714010141091 * sp[18] + -6.329571759259246 * sp[17];
    A[334] = 1.420924272486749 * sp[19] + 1.463982583774229 * sp[18] + 1.463982583774228 * sp[18] + 1.420924272486744 * sp[17];
    A[335] = 1.033399470899445 * sp[19] + 1.377865961199279 * sp[18] + 1.377865961199294 * sp[18] + 2.755731922398584 * sp[17];
    A[336] = -0.05382288910934412 * sp[19] + -0.05382288910934366 * sp[18] + -0.05382288910934259 * sp[18] + -0.05382288910934159 * sp[17];
    A[337] = -0.05382288910935458 * sp[19];
    A[338] = 0.1076457782186963 * sp[17];
    A[339] = 1.356336805555532 * sp[19] + 0.572675540123437 * sp[18] + 0.5726755401234278 * sp[18];
    A[340] = 0.387524801587281 * sp[19] + 0.8590133101851569 * sp[18] + 0.8590133101851629 * sp[18] + 1.011870315255714 * sp[17];
    A[341] = 0.04305831128747142 * sp[19] + 0.3746073082010498 * sp[18] + 0.3746073082010541 * sp[18] + 1.033399470899458 * sp[17];
    A[342] = -0.07319912918871611 * sp[18] + -0.07319912918871235 * sp[18] + -0.4198185350529117 * sp[17];
    A[343] = 1.356336805555552 * sp[19] + 0.7836612654320959 * sp[18] + 0.7836612654320935 * sp[18] + 0.2109857253086315 * sp[17];
    A[344] = 0.3875248015873055 * sp[19] + -0.4714885085978855 * sp[18] + -0.4714885085978805 * sp[18] + -0.3186315035273315 * sp[17];
    A[345] = 0.043058311287476 * sp[19] + -0.3315489969135776 * sp[18] + -0.331548996913582 * sp[18] + 0.3272431657848336 * sp[17];
    A[346] = 0.07319912918870941 * sp[18] + 0.07319912918871234 * sp[18] + -0.2734202766754882 * sp[17];
    A[347] = 0.04951705798057941 * sp[19] + 0.622192598104037 * sp[18] + 0.6221925981040346 * sp[18] + 1.194868138227492 * sp[17];
    A[348] = 0.004305831128784557 * sp[19] + -2.409112516534354 * sp[18] + -2.409112516534356 * sp[18] + -3.810660548941773 * sp[17];
    A[349] = 0.004305831128712842 * sp[19] + 2.41341834766311 * sp[18] + 2.413418347663103 * sp[18] + 1.011870315255689 * sp[17];
    A[350] = 0.04951705798061998 * sp[19] + -0.5726755401234394 * sp[18] + -0.5726755401234291 * sp[18];
    A[351] = -6.329571759259232 * sp[19] + -3.057140101410905 * sp[18] + -3.057140101410909 * sp[18] + -1.808449074074038 * sp[17];
    A[352] = 9.946469907407366 * sp[19] + 4.973234953703654 * sp[18] + 4.973234953703654 * sp[18] + 8.654720568783041 * sp[17];
    A[353] = -6.32957175925922 * sp[19] + -3.27243165784826 * sp[18] + -3.272431657848268 * sp[18] + -2.023740630511401 * sp[17];
    A[354] = -0.3875248015873241 * sp[19] + 2.551204943783048 * sp[18] + 2.551204943783056 * sp[18] + -0.387524801587332 * sp[17];
    A[355] = -0.387524801587266 * sp[19] + -2.938729745370356 * sp[18] + -2.938729745370339 * sp[18] + -5.877459490740729 * sp[17];
    A[356] = -0.08611662257494915 * sp[19] + -0.04305831128746803 * sp[18] + -0.04305831128747402 * sp[18] + 1.420924272486784 * sp[17];
    A[357] = 0.1076457782186923 * sp[19] + 0.1076457782186939 * sp[18] + 0.1076457782186899 * sp[18] + 0.10764577821869 * sp[17];
    A[358] = -0.215291556437382 * sp[19];
    A[359] = 0.1076457782186963 * sp[17];
    A[360] = -2.82031938932978 * sp[19] + -1.662050815696624 * sp[18] + -1.662050815696616 * sp[18];
    A[361] = 0.7319912918871327 * sp[19] + -1.308972663139312 * sp[18] + -1.308972663139326 * sp[18] + -3.961364638447971 * sp[17];
    A[362] = -0.5166997354497315 * sp[19] + 0.4133597883597904 * sp[18] + 0.4133597883598016 * sp[18] + 2.023740630511488 * sp[17];
    A[363] = -0.2626556988536099 * sp[18] + -0.2626556988536151 * sp[18] + -0.9903411596119975 * sp[17];
    A[364] = -0.6674038249559033 * sp[19] + -0.4047481261022952 * sp[18] + -0.4047481261022959 * sp[18] + -0.1420924272486736 * sp[17];
    A[365] = -0.344466490299828 * sp[19] + 0.1033399470899484 * sp[18] + 0.1033399470899468 * sp[18] + 0.0344466490299801 * sp[17];
    A[366] = -0.5166997354497329 * sp[19] + -0.06889329805996527 * sp[18] + -0.06889329805995915 * sp[18] + 0.03444664902998407 * sp[17];
    A[367] = 0.2626556988536161 * sp[18] + 0.2626556988536152 * sp[18] + -0.1420924272486795 * sp[17];
    A[368] = -0.4650297619047432 * sp[19] + -0.7276854607583557 * sp[18] + -0.7276854607583552 * sp[18] + -0.9903411596119809 * sp[17];
    A[369] = 0.6803213183421175 * sp[19] + 1.610380842151641 * sp[18] + 1.610380842151639 * sp[18] + 2.023740630511422 * sp[17];
    A[370] = -0.61142802028215 * sp[19] + -2.652391975308611 * sp[18] + -2.65239197530861 * sp[18] + -3.961364638447942 * sp[17];
    A[371] = 0.5037822420634674 * sp[19] + 1.66205081569663 * sp[18] + 1.662050815696627 * sp[18];
    A[372] = 2.755731922398565 * sp[19] + 1.377865961199266 * sp[18] + 1.377865961199267 * sp[18] + 1.033399470899456 * sp[17];
    A[373] = -6.32957175925922 * sp[19] + -3.272431657848268 * sp[18] + -3.27243165784826 * sp[18] + -2.023740630511401 * sp[17];
    A[374] = 7.061563051146333 * sp[19] + 3.961364638447906 * sp[18] + 3.961364638447906 * sp[18] + 7.922729276895893 * sp[17];
    A[375] = 1.420924272486788 * sp[19] + -0.04305831128746525 * sp[18] + -0.04305831128746014 * sp[18] + -0.08611662257493505 * sp[17];
    A[376] = -1.808449074074088 * sp[19] + 1.248691027336852 * sp[18] + 1.24869102733684 * sp[18] + -2.023740630511488 * sp[17];
    A[377] = 1.033399470899464 * sp[19] + -0.3444664902998326 * sp[18] + -0.3444664902998412 * sp[18] + 1.033399470899453 * sp[17];
    A[378] = -0.05382288910934298 * sp[19] + -0.05382288910934391 * sp[18] + -0.0538228891093489 * sp[18] + -0.05382288910934974 * sp[17];
    A[379] = 0.1076457782186966 * sp[19];
    A[380] = -0.05382288910935165 * sp[17];
    A[381] = -0.4198185350529175 * sp[19] + -0.07319912918871314 * sp[18] + -0.0731991291887148 * sp[18];
    A[382] = 1.033399470899462 * sp[19] + 0.3746073082010491 * sp[18] + 0.3746073082010465 * sp[18] + 0.0430583112874674 * sp[17];
    A[383] = 1.011870315255712 * sp[19] + 0.8590133101851678 * sp[18] + 0.8590133101851811 * sp[18] + 0.3875248015872937 * sp[17];
    A[384] = 0.5726755401234527 * sp[18] + 0.5726755401234465 * sp[18] + 1.35633680555555 * sp[17];
    A[385] = 1.194868138227502 * sp[19] + 0.6221925981040434 * sp[18] + 0.6221925981040343 * sp[18] + 0.04951705798059639 * sp[17];
    A[386] = -3.810660548941789 * sp[19] + -2.409112516534377 * sp[18] + -2.409112516534374 * sp[18] + 0.004305831128759374 * sp[17];
    A[387] = 1.011870315255721 * sp[19] + 2.413418347663129 * sp[18] + 2.413418347663133 * sp[18] + 0.004305831128740611 * sp[17];
    A[388] = -0.5726755401234566 * sp[18] + -0.572675540123448 * sp[18] + 0.04951705798060324 * sp[17];
    A[389] = 0.2109857253086325 * sp[19] + 0.7836612654320925 * sp[18] + 0.7836612654320988 * sp[18] + 1.356336805555544 * sp[17];
    A[390] = -0.3186315035273327 * sp[19] + -0.4714885085978802 * sp[18] + -0.4714885085978844 * sp[18] + 0.3875248015873138 * sp[17];
    A[391] = 0.3272431657848319 * sp[19] + -0.3315489969135846 * sp[18] + -0.3315489969135789 * sp[18] + 0.04305831128747138 * sp[17];
    A[392] = -0.2734202766754867 * sp[19] + 0.07319912918871146 * sp[18] + 0.07319912918871105 * sp[18];
    A[393] = -1.808449074074044 * sp[19] + -3.05714010141091 * sp[18] + -3.057140101410899 * sp[18] + -6.329571759259246 * sp[17];
    A[394] = -0.3875248015873241 * sp[19] + 2.551204943783056 * sp[18] + 2.551204943783048 * sp[18] + -0.387524801587332 * sp[17];
    A[395] = 1.420924272486788 * sp[19] + -0.04305831128746014 * sp[18] + -0.04305831128746525 * sp[18] + -0.08611662257493505 * sp[17];
    A[396] = 8.654720568783045 * sp[19] + 4.973234953703664 * sp[18] + 4.973234953703664 * sp[18] + 9.946469907407392 * sp[17];
    A[397] = -5.877459490740719 * sp[19] + -2.938729745370347 * sp[18] + -2.93872974537034 * sp[18] + -0.3875248015872805 * sp[17];
    A[398] = -2.023740630511434 * sp[19] + -3.272431657848299 * sp[18] + -3.272431657848312 * sp[18] + -6.329571759259245 * sp[17];
    A[399] = 0.1076457782186926 * sp[19] + 0.1076457782186929 * sp[18] + 0.107645778218696 * sp[18] + 0.1076457782186961 * sp[17];
    A[400] = -0.05382288910935037 * sp[19];
    A[401] = -0.05382288910935309 * sp[17];
    A[402] = 1.194868138227511 * sp[19] + 0.5726755401234468 * sp[18] + 0.572675540123455 * sp[18];
    A[403] = -3.810660548941777 * sp[19] + -1.401548032407391 * sp[18] + -1.401548032407395 * sp[18] + 1.011870315255744 * sp[17];
    A[404] = 1.011870315255736 * sp[19] + -1.401548032407396 * sp[18] + -1.4015480324074 * sp[18] + -3.810660548941792 * sp[17];
    A[405] = 0.5726755401234541 * sp[18] + 0.5726755401234439 * sp[18] + 1.194868138227509 * sp[17];
    A[406] = -0.4198185350529052 * sp[19] + -0.3466194058641901 * sp[18] + -0.3466194058641816 * sp[18] + -0.2734202766754812 * sp[17];
    A[407] = 1.03339947089947 * sp[19] + 0.658792162698406 * sp[18] + 0.6587921626984091 * sp[18] + 0.3272431657848308 * sp[17];
    A[408] = 1.011870315255729 * sp[19] + 0.1528570050705454 * sp[18] + 0.1528570050705468 * sp[18] + -0.3186315035273427 * sp[17];
    A[409] = -0.5726755401234525 * sp[18] + -0.572675540123444 * sp[18] + 0.2109857253086517 * sp[17];
    A[410] = -0.2734202766754781 * sp[19] + -0.3466194058641902 * sp[18] + -0.3466194058641914 * sp[18] + -0.419818535052892 * sp[17];
    A[411] = 0.3272431657848259 * sp[19] + 0.6587921626984065 * sp[18] + 0.6587921626984059 * sp[18] + 1.033399470899471 * sp[17];
    A[412] = -0.318631503527338 * sp[19] + 0.1528570050705464 * sp[18] + 0.1528570050705512 * sp[18] + 1.011870315255744 * sp[17];
    A[413] = 0.2109857253086478 * sp[19] + -0.5726755401234466 * sp[18] + -0.5726755401234601 * sp[18];
    A[414] = 1.420924272486749 * sp[19] + 1.463982583774228 * sp[18] + 1.463982583774229 * sp[18] + 1.420924272486744 * sp[17];
    A[415] = -0.387524801587266 * sp[19] + -2.938729745370339 * sp[18] + -2.938729745370356 * sp[18] + -5.877459490740729 * sp[17];
    A[416] = -1.808449074074088 * sp[19] + 1.24869102733684 * sp[18] + 1.248691027336852 * sp[18] + -2.023740630511488 * sp[17];
    A[417] = -5.877459490740719 * sp[19] + -2.93872974537034 * sp[18] + -2.938729745370347 * sp[18] + -0.3875248015872805 * sp[17];
    A[418] = 8.654720568783018 * sp[19] + 3.681485615079333 * sp[18] + 3.681485615079333 * sp[18] + 8.65472056878305 * sp[17];
    A[419] = -2.023740630511459 * sp[19] + 1.24869102733685 * sp[18] + 1.248691027336855 * sp[18] + -1.808449074074078 * sp[17];
    A[420] = 0.1076457782186926 * sp[19] + 0.1076457782186922 * sp[18] + 0.1076457782186943 * sp[18] + 0.1076457782186946 * sp[17];
    A[421] = 0.107645778218693 * sp[19];
    A[422] = -0.2152915564373835 * sp[17];
    A[423] = -0.9903411596119871 * sp[19] + -0.2626556988536171 * sp[18] + -0.262655698853618 * sp[18];
    A[424] = 2.023740630511456 * sp[19] + 0.4133597883597937 * sp[18] + 0.4133597883597954 * sp[18] + -0.5166997354497299 * sp[17];
    A[425] = -3.961364638447941 * sp[19] + -1.308972663139315 * sp[18] + -1.308972663139322 * sp[18] + 0.7319912918871329 * sp[17];
    A[426] = -1.662050815696643 * sp[18] + -1.662050815696638 * sp[18] + -2.8203193893298 * sp[17];
    A[427] = -0.9903411596119804 * sp[19] + -0.727685460758365 * sp[18] + -0.7276854607583659 * sp[18] + -0.4650297619047563 * sp[17];
    A[428] = 2.023740630511446 * sp[19] + 1.610380842151658 * sp[18] + 1.61038084215166 * sp[18] + 0.6803213183421404 * sp[17];
    A[429] = -3.961364638447948 * sp[19] + -2.652391975308628 * sp[18] + -2.652391975308634 * sp[18] + -0.6114280202821805 * sp[17];
    A[430] = 1.662050815696645 * sp[18] + 1.66205081569664 * sp[18] + 0.5037822420634885 * sp[17];
    A[431] = -0.1420924272486722 * sp[19] + -0.4047481261022928 * sp[18] + -0.40474812610229 * sp[18] + -0.6674038249559042 * sp[17];
    A[432] = 0.03444664902998119 * sp[19] + 0.1033399470899426 * sp[18] + 0.1033399470899467 * sp[18] + -0.3444664902998291 * sp[17];
    A[433] = 0.03444664902998212 * sp[19] + -0.06889329805996224 * sp[18] + -0.06889329805996568 * sp[18] + -0.5166997354497308 * sp[17];
    A[434] = -0.1420924272486753 * sp[19] + 0.2626556988536189 * sp[18] + 0.2626556988536163 * sp[18];
    A[435] = 1.033399470899445 * sp[19] + 1.377865961199294 * sp[18] + 1.377865961199279 * sp[18] + 2.755731922398584 * sp[17];
    A[436] = -0.08611662257494915 * sp[19] + -0.04305831128747402 * sp[18] + -0.04305831128746803 * sp[18] + 1.420924272486784 * sp[17];
    A[437] = 1.033399470899464 * sp[19] + -0.3444664902998412 * sp[18] + -0.3444664902998326 * sp[18] + 1.033399470899453 * sp[17];
    A[438] = -2.023740630511434 * sp[19] + -3.272431657848312 * sp[18] + -3.272431657848299 * sp[18] + -6.329571759259245 * sp[17];
    A[439] = -2.023740630511459 * sp[19] + 1.248691027336855 * sp[18] + 1.24869102733685 * sp[18] + -1.808449074074078 * sp[17];
    A[440] = 7.922729276895885 * sp[19] + 3.961364638447953 * sp[18] + 3.961364638447953 * sp[18] + 7.061563051146358 * sp[17];
}


poisson2d_5_cell_integral_1_otherwise::poisson2d_5_cell_integral_1_otherwise() : ufc::cell_integral()
{

}

poisson2d_5_cell_integral_1_otherwise::~poisson2d_5_cell_integral_1_otherwise()
{

}

const std::vector<bool> & poisson2d_5_cell_integral_1_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({true});
return enabled;
}

void poisson2d_5_cell_integral_1_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 10
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 10
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           10
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Quadrature rules
    alignas(32) static const double weights36[36] = { 0.006194265352658847, 0.0116108747669975, 0.0120606064042651, 0.008451535796943108, 0.003765298212691667, 0.0007485425612363173, 0.01304339433008284, 0.02444926225805782, 0.02539627158904766, 0.01779657599702627, 0.007928667333796482, 0.001576221754023589, 0.01691750568001268, 0.03171111159070401, 0.03293939890078672, 0.02308246365135824, 0.01028361722876633, 0.00204438659154486, 0.01691750568001267, 0.03171111159070399, 0.0329393989007867, 0.02308246365135823, 0.01028361722876633, 0.002044386591544859, 0.01304339433008284, 0.02444926225805782, 0.02539627158904766, 0.01779657599702627, 0.007928667333796482, 0.001576221754023589, 0.006194265352658863, 0.01161087476699754, 0.01206060640426513, 0.008451535796943131, 0.003765298212691677, 0.0007485425612363194 };
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q36[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double FE6_C0_Q36[1][36][21] =
        { { { 0.451781527938019, 0.02281003826121966, 0.02124449224936851, -0.004357972855004281, -0.002622715352798267, -0.002647419070325334, -0.004517392393904474, 0.4801969592095873, -0.4851124131039362, 0.3343009094065305, -0.129270846816877, 0.5368536656756279, -0.5313582551132943, 0.3627530462854966, -0.1394228048643138, 0.1863065897219217, -0.08687834876741969, 0.02882370237569987, -0.08867537437438051, 0.02009559840230966, 0.02969701318647262 },
            { 0.02920934794485388, 0.0209787447672339, 0.01486040611232548, -0.02013980491870929, -0.003661146405198518, -0.002484469289198807, -0.003278497456177504, 0.9339408288389818, -0.4345973312998704, 0.2587328334320642, -0.09381831496836869, 0.1814247231924392, -0.2784257890218427, 0.2442628454393166, -0.1119554253657896, 0.4815485284060068, -0.2922957093194949, 0.1160868103533367, -0.08862926418909592, 0.02435409576297018, 0.02388658798421645 },
            { -0.01145342574273666, 0.01756244561894018, -0.009225149941974733, -0.03805411130431542, 0.01804955741855213, 0.003012073388412778, 0.00223018824236805, 0.121089015118006, 0.8165384919044408, -0.2138335213478529, 0.06381963254752342, 0.008044295419533679, -0.07033361747421242, 0.110373061425867, -0.07234318513433072, 0.2668873939477337, -0.2954931589373591, 0.1688226579069234, 0.2279000405878063, -0.09186433621179065, -0.02172834743153551 },
            { 0.004308696537154501, 0.01270656510410462, 0.008258082231334632, -0.04520959215968424, 0.055427914578819, -0.02283787871342362, -0.002549602413917523, -0.03221787320114235, 0.1331500641722878, 0.7994546703194028, -0.07296006951669383, -0.0008593541337167301, -0.001832831504814932, 0.02670839447900016, -0.03450791099004578, 0.01106385098730639, -0.1162395212869169, 0.1317972213590019, 0.2252412629710417, -0.1841291929200166, 0.1052271041009187 },
            { -0.005137687664160602, 0.007176500500397253, -0.02192197449425876, -0.03484189961886383, 0.06698046930884462, -0.06305697350011374, 0.02775994806870506, 0.03424529507291704, -0.1034071665224595, 0.2156829179850724, 0.7943857166971464, 0.0003468841681158429, 0.0003536838425268465, 0.0007836017484645109, -0.01009946036163101, -0.002830947835339867, -0.004610610747591122, 0.0524737609398929, 0.01365455158614962, -0.1142372110686423, 0.1463006018948278 },
            { 0.03026079123944941, 0.002403861228280122, 0.3837817694217621, -0.01396962830299617, 0.03399027560947074, -0.04505541666846025, 0.0372865568411148, -0.1922788169116356, 0.5280430226581628, -0.8446859064541007, 1.067001570251125, -0.0005116735800916993, -0.0003818292819523913, -0.000460789788441259, -0.001063798025859857, 0.003583547634621626, 0.003223330700029253, 0.006601024381606077, -0.01186223419465238, -0.01810635511332655, 0.03220069835589445 },
            { 0.006670795867502708, 0.009933103444159794, 0.02124449224936853, -0.002290878708155482, -0.001795416038869214, -0.002825186099193085, -0.02266309982290941, 0.1563427754899152, -0.2587595940143055, 0.2361031586343127, -0.1111251393878721, 0.8768914391417175, -0.302458555327639, 0.1753837086394725, -0.06300327358245826, 0.4985558140265616, -0.06547871757281497, 0.01696193644927847, -0.3141946351837752, 0.01843474080814413, 0.1280725309875585 },
            { -0.02860689769333534, 0.01598866389248405, 0.01486040611232548, -0.01805414394677723, -0.004114198223826845, -0.004053582874827162, -0.01644774432674099, 0.2292491276018601, -0.2212237768041464, 0.1811742769488769, -0.08064906809780523, 0.2234170404121626, -0.2312382266572351, 0.1922075842235972, -0.08627371722146208, 1.229748503528525, -0.333943393600633, 0.1121405597771459, -0.3113534134367245, 0.03415774233350314, 0.1030142580530326 },
            { 0.009314972911753063, 0.02474524022661073, -0.009225149941974774, -0.06062897167784265, 0.03405962618782195, 0.007460427682362825, 0.01118852965460027, -0.06295725917869385, 0.349891088888984, -0.1463036798509598, 0.05486129113529106, -0.02098266141639589, -0.07464785802270836, 0.1425003301317838, -0.0990804497179823, 0.5737408545821591, -0.500754739487113, 0.2738519124924794, 0.7822676302687145, -0.1955945916465119, -0.09370654322237856 },
            { -0.005378243146524489, 0.03020821420140968, 0.008258082231334608, -0.1163507598836089, 0.1589049660983037, -0.07752309903702757, -0.01279098404055147, 0.03466151229350942, -0.106516480672617, 0.5055603622023509, -0.06271868789005969, 0.004638251621316976, 0.004977065239698497, 0.04842123760436092, -0.07634296602857975, -0.04440309495001141, -0.2495217160137682, 0.3248081442524438, 0.7145927762133992, -0.5372912128369538, 0.4538066325415739 },
            { 0.002150195791906531, 0.02523172711611741, -0.02192197449425876, -0.1275388467055941, 0.2588633505058132, -0.264834169802158, 0.1392676170900616, -0.01359474460160604, 0.0379041070687602, -0.06718113147189955, 0.6828780476757903, -0.0006908537429151001, -0.0005444923073763489, -0.0009432989298299947, -0.03177975569418955, 0.005205938032869548, 0.00603157757626626, 0.1743316735090791, -0.02133735100151805, -0.4124394632691625, 0.630941847653844 },
            { 0.02978621033932847, 0.01084770982531246, 0.3837817694217621, -0.06383265156405088, 0.1579336294892865, -0.2146983692659691, 0.1870612260477991, -0.1867267990320255, 0.5033748205395165, -0.7817122796378341, 0.9172269010444408, -0.002492870392594267, -0.001734495372692737, -0.001981410509767969, -0.004178582098201558, 0.01713826510717183, 0.01421471923696256, 0.02636592375356696, -0.05507438745257148, -0.07416935361657691, 0.1388700241371368 },
            { -0.0002897904330765734, -0.004931690347245306, 0.02124449224936856, 0.001679321618684317, 0.002487373799347253, 0.03026013516340827, -0.05093189923140042, 0.0002136227307524517, -0.0632114408178763, 0.1164852982047432, -0.08285633997938116, 0.002692687997377935, 0.7913869870761817, -0.1198766292861131, 0.03443565317563116, 0.2737055307222304, 0.3460136935900012, -0.01752123897688343, -0.3483683113304331, -0.147222526079844, 0.2146050701545269 },
            { 0.01132680651836239, -0.01042054752557151, 0.01486040611232551, 0.01621946041072209, 0.006109488668734987, 0.02033663400871732, -0.03696382503626407, -0.03078701743194053, -0.04415948647242984, 0.08718220827873688, -0.06013298738828216, -0.06742900945326218, 0.2315750989998844, -0.137347734436376, 0.0577898328531742, 0.5516696272752981, 0.8062026123675275, -0.1241640292614855, -0.3367096158808737, -0.1277740324466266, 0.1726161098396281 },
            { 0.001762403266264618, -0.009676914462510153, -0.009225149941974788, 0.02977532205215199, -0.02346838399212088, -0.01001966962609863, 0.02514453315603322, -0.007626102047062593, 0.0110319323492212, -0.06551051252610751, 0.04090528763385815, -0.005711996487402133, 0.003161009023221543, -0.04396579457272622, 0.03628086734621316, 0.040654164812245, 0.3011414193549587, -0.1406930074413038, 0.787193803309953, 0.1958664020319544, -0.1570196132387693 },
            { -0.01137465071039932, 0.008864991262991204, 0.00825808223133459, -0.03918269564681599, 0.06506493813760482, -0.04450162141982018, -0.0287458077365597, 0.06032772143553775, -0.1324707158449497, 0.1659232512261956, -0.04676386419405126, 0.01814238085798413, 0.003553211975063897, 0.006506982958707257, -0.01916935685266536, -0.1241043132890955, -0.04700967951431582, 0.09916305271325411, 0.5270640729734319, -0.2299682464639551, 0.7604222659005216 },
            { 0.01640432936068268, 0.02921063549287818, -0.02192197449425875, -0.1577604739730724, 0.3506889921035669, -0.4148212066619236, 0.3129829676987976, -0.09602090098289981, 0.239160899941259, -0.3434915974661175, 0.5091626970670542, -0.01096607969947022, -0.005381242817728497, -0.006533858295128928, -0.02931026180752012, 0.07381990170921719, 0.04830439573377654, 0.176092675323993, -0.2451770778979161, -0.4816821708430167, 1.057239350507827 },
            { 0.02708397628164659, 0.02050776367294924, 0.3837817694217621, -0.1230889379840109, 0.3127602365513167, -0.4428064482638281, 0.4203918965020754, -0.1663143420852971, 0.4358720837868666, -0.6474320941789264, 0.6838962305901644, -0.004989916850370426, -0.003097604048907454, -0.003249815226445788, -0.006007842037487762, 0.03335070223881381, 0.02428123470626843, 0.03893080062585071, -0.1025103048492699, -0.114057306529259, 0.232697917676088 },
            { -0.004931690347245219, -0.0002897904330766009, 0.02124449224936851, 0.0002136227307523234, -0.06321144081787616, 0.1164852982047431, -0.08285633997938113, 0.001679321618684382, 0.002487373799347357, 0.03026013516340832, -0.05093189923140028, 0.03443565317563113, -0.119876629286113, 0.7913869870761819, 0.002692687997377554, -0.01752123897688375, 0.3460136935900008, 0.2737055307222309, -0.1472225260798436, -0.348368311330433, 0.2146050701545265 },
            { -0.01042054752557151, 0.01132680651836245, 0.01486040611232543, -0.0307870174319407, -0.04415948647242968, 0.08718220827873685, -0.06013298738828209, 0.01621946041072217, 0.006109488668735188, 0.02033663400871719, -0.036963825036264, 0.05778983285317425, -0.1373477344363762, 0.2315750989998848, -0.06742900945326243, -0.1241640292614861, 0.8062026123675281, 0.5516696272752982, -0.1277740324466269, -0.3367096158808734, 0.1726161098396277 },
            { -0.00967691446251024, 0.001762403266264649, -0.009225149941974821, -0.007626102047062384, 0.01103193234922088, -0.06551051252610726, 0.04090528763385816, 0.02977532205215182, -0.02346838399212051, -0.01001966962609889, 0.02514453315603338, 0.03628086734621312, -0.0439657945727262, 0.003161009023221526, -0.005711996487401966, -0.1406930074413043, 0.3011414193549592, 0.04065416481224503, 0.1958664020319539, 0.7871938033099531, -0.1570196132387693 },
            { 0.008864991262991131, -0.01137465071039929, 0.008258082231334569, 0.06032772143553783, -0.1324707158449498, 0.1659232512261955, -0.04676386419405125, -0.03918269564681592, 0.06506493813760475, -0.04450162141981989, -0.02874580773655955, -0.01916935685266527, 0.006506982958707166, 0.003553211975063991, 0.0181423808579842, 0.09916305271325389, -0.04700967951431559, -0.1241043132890954, -0.2299682464639552, 0.5270640729734315, 0.7604222659005216 },
            { 0.02921063549287827, 0.01640432936068255, -0.0219219744942588, -0.09602090098289978, 0.239160899941259, -0.3434915974661179, 0.5091626970670541, -0.1577604739730723, 0.3506889921035665, -0.4148212066619231, 0.3129829676987978, -0.02931026180751997, -0.006533858295129305, -0.005381242817728119, -0.0109660796994703, 0.1760926753239924, 0.04830439573377683, 0.07381990170921759, -0.481682170843016, -0.2451770778979175, 1.057239350507827 },
            { 0.0205077636729494, 0.0270839762816464, 0.3837817694217621, -0.1663143420852967, 0.435872083786866, -0.6474320941789256, 0.6838962305901632, -0.1230889379840113, 0.3127602365513175, -0.4428064482638286, 0.4203918965020764, -0.006007842037487754, -0.003249815226446013, -0.003097604048907193, -0.004989916850370439, 0.03893080062585043, 0.02428123470626854, 0.03335070223881424, -0.1140573065292587, -0.1025103048492706, 0.2326979176760882 },
            { 0.00993310344415986, 0.006670795867502979, 0.02124449224936846, 0.1563427754899152, -0.2587595940143055, 0.2361031586343126, -0.111125139387872, -0.002290878708155383, -0.001795416038869194, -0.002825186099192918, -0.02266309982290942, -0.06300327358245811, 0.1753837086394726, -0.3024585553276393, 0.8768914391417179, 0.01696193644927842, -0.06547871757281475, 0.4985558140265615, 0.01843474080814411, -0.314194635183775, 0.1280725309875584 },
            { 0.01598866389248403, -0.02860689769333518, 0.01486040611232535, 0.2292491276018602, -0.2212237768041466, 0.181174276948877, -0.08064906809780509, -0.01805414394677727, -0.004114198223826596, -0.004053582874827252, -0.01644774432674102, -0.08627371722146185, 0.1922075842235972, -0.231238226657235, 0.2234170404121628, 0.1121405597771458, -0.3339433936006323, 1.229748503528525, 0.03415774233350295, -0.3113534134367246, 0.1030142580530323 },
            { 0.02474524022661065, 0.009314972911753011, -0.00922514994197484, -0.06295725917869363, 0.3498910888889839, -0.1463036798509595, 0.05486129113529115, -0.06062897167784284, 0.03405962618782243, 0.007460427682362575, 0.01118852965460049, -0.09908044971798215, 0.1425003301317838, -0.07464785802270818, -0.02098266141639573, 0.273851912492479, -0.5007547394871124, 0.5737408545821591, -0.1955945916465121, 0.7822676302687138, -0.09370654322237842 },
            { 0.03020821420140955, -0.005378243146524487, 0.008258082231334559, 0.03466151229350944, -0.106516480672617, 0.5055603622023512, -0.06271868789005954, -0.1163507598836088, 0.1589049660983036, -0.07752309903702725, -0.01279098404055119, -0.07634296602857953, 0.0484212376043608, 0.004977065239698731, 0.004638251621317023, 0.3248081442524434, -0.2495217160137675, -0.04440309495001132, -0.5372912128369541, 0.7145927762133982, 0.4538066325415735 },
            { 0.02523172711611739, 0.002150195791906441, -0.02192197449425886, -0.01359474460160592, 0.03790410706875988, -0.06718113147189968, 0.68287804767579, -0.127538846705594, 0.2588633505058128, -0.2648341698021575, 0.1392676170900617, -0.03177975569418939, -0.0009432989298302826, -0.0005444923073759812, -0.0006908537429151295, 0.1743316735090787, 0.00603157757626694, 0.005205938032869749, -0.4124394632691626, -0.02133735100151915, 0.630941847653844 },
            { 0.01084770982531257, 0.02978621033932827, 0.3837817694217621, -0.1867267990320252, 0.5033748205395159, -0.7817122796378333, 0.9172269010444394, -0.06383265156405143, 0.1579336294892872, -0.2146983692659698, 0.1870612260478001, -0.004178582098201565, -0.001981410509768135, -0.001734495372692484, -0.002492870392594259, 0.02636592375356671, 0.01421471923696285, 0.0171382651071722, -0.07416935361657698, -0.05507438745257241, 0.1388700241371373 },
            { 0.02281003826121968, 0.4517815279380186, 0.02124449224936846, 0.4801969592095866, -0.485112413103936, 0.3343009094065305, -0.1292708468168769, -0.004357972855004191, -0.00262271535279842, -0.002647419070325029, -0.004517392393904592, -0.1394228048643139, 0.362753046285497, -0.5313582551132948, 0.5368536656756296, 0.02882370237570003, -0.08687834876741894, 0.186306589721922, 0.02009559840230912, -0.08867537437438078, 0.02969701318647298 },
            { 0.02097874476723389, 0.02920934794485398, 0.01486040611232535, 0.9339408288389811, -0.4345973312998703, 0.2587328334320644, -0.09381831496836865, -0.02013980491870926, -0.003661146405198532, -0.002484469289198751, -0.003278497456177601, -0.1119554253657898, 0.2442628454393173, -0.2784257890218433, 0.18142472319244, 0.1160868103533371, -0.2922957093194946, 0.481548528406008, 0.02435409576296972, -0.08862926418909652, 0.02388658798421674 },
            { 0.01756244561894015, -0.01145342574273678, -0.009225149941974792, 0.121089015118006, 0.8165384919044402, -0.2138335213478525, 0.06381963254752333, -0.03805411130431567, 0.01804955741855256, 0.003012073388412487, 0.002230188242368307, -0.07234318513433079, 0.1103730614258673, -0.07033361747421199, 0.008044295419533753, 0.1688226579069234, -0.2954931589373586, 0.2668873939477343, -0.09186433621179066, 0.2279000405878061, -0.02172834743153566 },
            { 0.01270656510410444, 0.004308696537154468, 0.008258082231334542, -0.03221787320114236, 0.1331500641722876, 0.7994546703194026, -0.07296006951669348, -0.04520959215968424, 0.05542791457881915, -0.02283787871342347, -0.00254960241391719, -0.03450791099004562, 0.02670839447900003, -0.001832831504814372, -0.0008593541337168454, 0.1317972213590017, -0.1162395212869161, 0.01106385098730671, -0.1841291929200174, 0.2252412629710412, 0.1052271041009184 },
            { 0.007176500500397121, -0.005137687664160646, -0.02192197449425892, 0.03424529507291719, -0.10340716652246, 0.2156829179850724, 0.7943857166971465, -0.03484189961886385, 0.06698046930884438, -0.06305697350011316, 0.02775994806870508, -0.01009946036163088, 0.0007836017484643314, 0.0003536838425271978, 0.0003468841681158151, 0.05247376093989274, -0.004610610747590276, -0.002830947835339929, -0.114237211068643, 0.01365455158614888, 0.1463006018948279 },
            { 0.002403861228280221, 0.03026079123944922, 0.383781769421762, -0.1922788169116355, 0.5280430226581622, -0.8446859064540997, 1.067001570251123, -0.0139696283029971, 0.033990275609472, -0.04505541666846188, 0.03728655684111642, -0.00106379802585992, -0.0004607897884413839, -0.000381829281952138, -0.0005116735800916698, 0.006601024381606077, 0.003223330700029767, 0.003583547634622063, -0.01810635511332745, -0.01186223419465343, 0.03220069835589595 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q36[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q36[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q36[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q36[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q36[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q36[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q36[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q36[0][0][1];
    alignas(32) double sp[4];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = std::abs(sp[2]);
    alignas(32) double BF0[21] = {};
    for (int iq = 0; iq < 36; ++iq)
    {
        // Quadrature loop body setup (num_points=36)
        // Unstructured varying computations for num_points=36
        double w0 = 0.0;
        for (int ic = 0; ic < 21; ++ic)
            w0 += w[0][ic] * FE6_C0_Q36[0][iq][ic];
        alignas(32) double sv36[1];
        sv36[0] = sp[3] * w0;
        const double fw0 = sv36[0] * weights36[iq];
        for (int i = 0; i < 21; ++i)
            BF0[i] += fw0 * FE6_C0_Q36[0][iq][i];
    }
    std::fill(&A[0], &A[21], 0.0);
    for (int i = 0; i < 21; ++i)
        A[i] += BF0[i];
}


poisson2d_5_form_0::poisson2d_5_form_0() : ufc::form()
{
    // Do nothing
}

poisson2d_5_form_0::~poisson2d_5_form_0()
{
    // Do nothing
}

const char * poisson2d_5_form_0::signature() const
{
    return "1bc0138e7fa5eaefa938690a0c6b17c679fa6f1074cbd4bd4fd681067ecd02d9cd0c91bacb45d126c7920a72e5a1d2bfbf0ff52559cede2485079e696c379f69";
}

std::size_t poisson2d_5_form_0::rank() const
{
    return 2;
}

std::size_t poisson2d_5_form_0::num_coefficients() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({});
    return position[i];
}

ufc::finite_element * poisson2d_5_form_0::create_coordinate_finite_element() const
{
    return new poisson2d_5_finite_element_1();
}

ufc::dofmap * poisson2d_5_form_0::create_coordinate_dofmap() const
{
    return new poisson2d_5_dofmap_1();
}

ufc::coordinate_mapping * poisson2d_5_form_0::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson2d_5_form_0::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_5_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson2d_5_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson2d_5_form_0::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_5_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson2d_5_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_form_0::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_0::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson2d_5_form_0::has_cell_integrals() const
{
    return true;
}

bool poisson2d_5_form_0::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson2d_5_form_0::has_interior_facet_integrals() const
{
    return false;
}

bool poisson2d_5_form_0::has_vertex_integrals() const
{
    return false;
}

bool poisson2d_5_form_0::has_custom_integrals() const
{
    return false;
}

bool poisson2d_5_form_0::has_cutcell_integrals() const
{
    return false;
}

bool poisson2d_5_form_0::has_interface_integrals() const
{
    return false;
}

bool poisson2d_5_form_0::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson2d_5_form_0::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson2d_5_form_0::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_5_form_0::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson2d_5_form_0::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson2d_5_form_0::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_5_form_0::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson2d_5_form_0::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson2d_5_form_0::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson2d_5_form_0::create_default_cell_integral() const
{
    return new poisson2d_5_cell_integral_0_otherwise();
}

ufc::exterior_facet_integral * poisson2d_5_form_0::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_5_form_0::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson2d_5_form_0::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson2d_5_form_0::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_5_form_0::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson2d_5_form_0::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson2d_5_form_0::create_default_overlap_integral() const
{
    return 0;
}


poisson2d_5_form_1::poisson2d_5_form_1() : ufc::form()
{
    // Do nothing
}

poisson2d_5_form_1::~poisson2d_5_form_1()
{
    // Do nothing
}

const char * poisson2d_5_form_1::signature() const
{
    return "e1b9a9ae891a7b0463aa644c4f13f4cae623032c35d10c0ba56a4e1f2880e4bfd3c5cd6996b2b4a5c0f17169305c79e0e36b85378f8ffd1d2ced662503db7bee";
}

std::size_t poisson2d_5_form_1::rank() const
{
    return 1;
}

std::size_t poisson2d_5_form_1::num_coefficients() const
{
    return 1;
}

std::size_t poisson2d_5_form_1::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({0});
    return position[i];
}

ufc::finite_element * poisson2d_5_form_1::create_coordinate_finite_element() const
{
    return new poisson2d_5_finite_element_1();
}

ufc::dofmap * poisson2d_5_form_1::create_coordinate_dofmap() const
{
    return new poisson2d_5_dofmap_1();
}

ufc::coordinate_mapping * poisson2d_5_form_1::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson2d_5_form_1::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_5_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson2d_5_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson2d_5_form_1::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson2d_5_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson2d_5_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson2d_5_form_1::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson2d_5_form_1::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson2d_5_form_1::has_cell_integrals() const
{
    return true;
}

bool poisson2d_5_form_1::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson2d_5_form_1::has_interior_facet_integrals() const
{
    return false;
}

bool poisson2d_5_form_1::has_vertex_integrals() const
{
    return false;
}

bool poisson2d_5_form_1::has_custom_integrals() const
{
    return false;
}

bool poisson2d_5_form_1::has_cutcell_integrals() const
{
    return false;
}

bool poisson2d_5_form_1::has_interface_integrals() const
{
    return false;
}

bool poisson2d_5_form_1::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson2d_5_form_1::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson2d_5_form_1::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_5_form_1::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson2d_5_form_1::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson2d_5_form_1::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_5_form_1::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson2d_5_form_1::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson2d_5_form_1::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson2d_5_form_1::create_default_cell_integral() const
{
    return new poisson2d_5_cell_integral_1_otherwise();
}

ufc::exterior_facet_integral * poisson2d_5_form_1::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson2d_5_form_1::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson2d_5_form_1::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson2d_5_form_1::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson2d_5_form_1::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson2d_5_form_1::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson2d_5_form_1::create_default_overlap_integral() const
{
    return 0;
}

