// This code conforms with the UFC specification version 2017.1.0
// and was automatically generated by FFC version 2017.1.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
// 
// This code was generated with the following parameters:
// 
//   add_tabulate_tensor_timing:     False
//   convert_exceptions_to_warnings: False
//   cpp_optimize:                   True
//   cpp_optimize_flags:             '-O2'
//   epsilon:                        1e-14
//   error_control:                  False
//   form_postfix:                   True
//   format:                         'dolfin'
//   generate_dummy_tabulate_tensor: False
//   max_signature_length:           0
//   optimize:                       True
//   precision:                      None
//   quadrature_degree:              None
//   quadrature_rule:                None
//   representation:                 'auto'
//   split:                          True

#include "Poisson3D_3.h"

poisson3d_3_finite_element_0::poisson3d_3_finite_element_0() : ufc::finite_element()
{
    // Do nothing
}

poisson3d_3_finite_element_0::~poisson3d_3_finite_element_0()
{
    // Do nothing
}

const char * poisson3d_3_finite_element_0::signature() const
{
    return "FiniteElement('Lagrange', tetrahedron, 1)";
}

ufc::shape poisson3d_3_finite_element_0::cell_shape() const
{
    return ufc::shape::tetrahedron;
}

std::size_t poisson3d_3_finite_element_0::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_0::geometric_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_0::space_dimension() const
{
    return 4;
}

std::size_t poisson3d_3_finite_element_0::value_rank() const
{
    return 0;
}

std::size_t poisson3d_3_finite_element_0::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_0::value_size() const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_0::reference_value_rank() const
{
    return 0;
}

std::size_t poisson3d_3_finite_element_0::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_0::reference_value_size() const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_0::degree() const
{
    return 1;
}

const char * poisson3d_3_finite_element_0::family() const
{
    return "Lagrange";
}

void poisson3d_3_finite_element_0::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_3_finite_element_0::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 4; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson3d_3_finite_element_0::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[3][1];
    for (unsigned int row = 0; row < 3; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 2)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[3][3] = {{K[0], K[1], K[2]}, {K[3], K[4], K[5]}, {K[6], K[7], K[8]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[3][3];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_3_finite_element_0::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 4; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[3];
    for (unsigned int r = 0; r < 3; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 4; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson3d_3_finite_element_0::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson3d_3_finite_element_0::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    y[2] = coordinate_dofs[2];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[3];
    y[1] = coordinate_dofs[4];
    y[2] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[6];
    y[1] = coordinate_dofs[7];
    y[2] = coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[9];
    y[1] = coordinate_dofs[10];
    y[2] = coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
}

void poisson3d_3_finite_element_0::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
    vertex_values[3] = dof_values[3];
}

void poisson3d_3_finite_element_0::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[6];
    dof_coordinates[7] = coordinate_dofs[7];
    dof_coordinates[8] = coordinate_dofs[8];
    dof_coordinates[9] = coordinate_dofs[9];
    dof_coordinates[10] = coordinate_dofs[10];
    dof_coordinates[11] = coordinate_dofs[11];
}

std::size_t poisson3d_3_finite_element_0::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson3d_3_finite_element_0::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson3d_3_finite_element_0::create() const
{
    return new poisson3d_3_finite_element_0();
}


poisson3d_3_finite_element_1::poisson3d_3_finite_element_1() : ufc::finite_element()
{
    // Do nothing
}

poisson3d_3_finite_element_1::~poisson3d_3_finite_element_1()
{
    // Do nothing
}

const char * poisson3d_3_finite_element_1::signature() const
{
    return "VectorElement(FiniteElement('Lagrange', tetrahedron, 1), dim=3)";
}

ufc::shape poisson3d_3_finite_element_1::cell_shape() const
{
    return ufc::shape::tetrahedron;
}

std::size_t poisson3d_3_finite_element_1::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_1::geometric_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_1::space_dimension() const
{
    return 12;
}

std::size_t poisson3d_3_finite_element_1::value_rank() const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_1::value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_finite_element_1::value_size() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_1::reference_value_rank() const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_1::reference_value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_finite_element_1::reference_value_size() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_1::degree() const
{
    return 1;
}

const char * poisson3d_3_finite_element_1::family() const
{
    return "Lagrange";
}

void poisson3d_3_finite_element_1::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    values[2] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_3_finite_element_1::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values[3] = {0.0, 0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 12; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 3; s++)
      {
        values[r*3 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

void poisson3d_3_finite_element_1::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 3*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[3][1];
    for (unsigned int row = 0; row < 3; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 2)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[3][3] = {{K[0], K[1], K[2]}, {K[3], K[4], K[5]}, {K[6], K[7], K[8]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[3][3];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_3_finite_element_1::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 12; r++)
    {
      for (unsigned int s = 0; s < 3*num_derivatives; s++)
      {
        values[r*3*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[9];
    for (unsigned int r = 0; r < 9; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 12; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 3*num_derivatives; s++)
      {
        values[r*3*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson3d_3_finite_element_1::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[3];
    
    // Declare variable for physical coordinates
    double y[3];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 4:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 5:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 6:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 7:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 8:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    case 9:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    case 10:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    case 11:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    }
    
    return 0.0;
}

void poisson3d_3_finite_element_1::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[3];
    
    // Declare variable for physical coordinates
    double y[3];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    y[2] = coordinate_dofs[2];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    values[4] = vals[1];
    values[8] = vals[2];
    y[0] = coordinate_dofs[3];
    y[1] = coordinate_dofs[4];
    y[2] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    values[5] = vals[1];
    values[9] = vals[2];
    y[0] = coordinate_dofs[6];
    y[1] = coordinate_dofs[7];
    y[2] = coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    values[6] = vals[1];
    values[10] = vals[2];
    y[0] = coordinate_dofs[9];
    y[1] = coordinate_dofs[10];
    y[2] = coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
    values[7] = vals[1];
    values[11] = vals[2];
}

void poisson3d_3_finite_element_1::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[3] = dof_values[1];
    vertex_values[6] = dof_values[2];
    vertex_values[9] = dof_values[3];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[4];
    vertex_values[4] = dof_values[5];
    vertex_values[7] = dof_values[6];
    vertex_values[10] = dof_values[7];
    // Evaluate function and change variables
    vertex_values[2] = dof_values[8];
    vertex_values[5] = dof_values[9];
    vertex_values[8] = dof_values[10];
    vertex_values[11] = dof_values[11];
}

void poisson3d_3_finite_element_1::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[6];
    dof_coordinates[7] = coordinate_dofs[7];
    dof_coordinates[8] = coordinate_dofs[8];
    dof_coordinates[9] = coordinate_dofs[9];
    dof_coordinates[10] = coordinate_dofs[10];
    dof_coordinates[11] = coordinate_dofs[11];
    dof_coordinates[12] = coordinate_dofs[0];
    dof_coordinates[13] = coordinate_dofs[1];
    dof_coordinates[14] = coordinate_dofs[2];
    dof_coordinates[15] = coordinate_dofs[3];
    dof_coordinates[16] = coordinate_dofs[4];
    dof_coordinates[17] = coordinate_dofs[5];
    dof_coordinates[18] = coordinate_dofs[6];
    dof_coordinates[19] = coordinate_dofs[7];
    dof_coordinates[20] = coordinate_dofs[8];
    dof_coordinates[21] = coordinate_dofs[9];
    dof_coordinates[22] = coordinate_dofs[10];
    dof_coordinates[23] = coordinate_dofs[11];
    dof_coordinates[24] = coordinate_dofs[0];
    dof_coordinates[25] = coordinate_dofs[1];
    dof_coordinates[26] = coordinate_dofs[2];
    dof_coordinates[27] = coordinate_dofs[3];
    dof_coordinates[28] = coordinate_dofs[4];
    dof_coordinates[29] = coordinate_dofs[5];
    dof_coordinates[30] = coordinate_dofs[6];
    dof_coordinates[31] = coordinate_dofs[7];
    dof_coordinates[32] = coordinate_dofs[8];
    dof_coordinates[33] = coordinate_dofs[9];
    dof_coordinates[34] = coordinate_dofs[10];
    dof_coordinates[35] = coordinate_dofs[11];
}

std::size_t poisson3d_3_finite_element_1::num_sub_elements() const
{
    return 3;
}

ufc::finite_element * poisson3d_3_finite_element_1::create_sub_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_3_finite_element_0();
        break;
      }
    case 1:
      {
        return new poisson3d_3_finite_element_0();
        break;
      }
    case 2:
      {
        return new poisson3d_3_finite_element_0();
        break;
      }
    }
    
    return 0;
}

ufc::finite_element * poisson3d_3_finite_element_1::create() const
{
    return new poisson3d_3_finite_element_1();
}


poisson3d_3_finite_element_2::poisson3d_3_finite_element_2() : ufc::finite_element()
{
    // Do nothing
}

poisson3d_3_finite_element_2::~poisson3d_3_finite_element_2()
{
    // Do nothing
}

const char * poisson3d_3_finite_element_2::signature() const
{
    return "FiniteElement('Lagrange', tetrahedron, 3)";
}

ufc::shape poisson3d_3_finite_element_2::cell_shape() const
{
    return ufc::shape::tetrahedron;
}

std::size_t poisson3d_3_finite_element_2::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_2::geometric_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_finite_element_2::space_dimension() const
{
    return 20;
}

std::size_t poisson3d_3_finite_element_2::value_rank() const
{
    return 0;
}

std::size_t poisson3d_3_finite_element_2::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_2::value_size() const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_2::reference_value_rank() const
{
    return 0;
}

std::size_t poisson3d_3_finite_element_2::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_2::reference_value_size() const
{
    return 1;
}

std::size_t poisson3d_3_finite_element_2::degree() const
{
    return 3;
}

const char * poisson3d_3_finite_element_2::family() const
{
    return "Lagrange";
}

void poisson3d_3_finite_element_2::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948138, 0.01304101327393251, 0.007529232524210411, 0.005323971374999491, 0.018298126367785, 0.01417366773784603, 0.01157275124715688, 0.008183170883849724, 0.006681531047810592, 0.004724555912615332, -0.02834733547569204, -0.02395787118749776, -0.02074812506896831, -0.01855768722395226, -0.01607142857142857, -0.0131222664791956, -0.01071428571428571, -0.009278843611976109, -0.00757614408414157, -0.005357142857142851};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948137, -0.01304101327393249, 0.007529232524210419, 0.005323971374999505, 0.01829812636778498, -0.01417366773784601, -0.01157275124715689, 0.008183170883849716, 0.006681531047810611, 0.004724555912615331, 0.02834733547569204, -0.02395787118749775, -0.02074812506896831, 0.01855768722395225, 0.01607142857142859, 0.0131222664791956, -0.01071428571428572, -0.009278843611976135, -0.007576144084141578, -0.005357142857142853};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948126, 0.0, -0.01505846504842089, 0.005323971374999496, 0.0, 0.0, 0.0, 0.02454951265154914, -0.01336306209562122, 0.004724555912615357, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04285714285714285, -0.02783653083592838, 0.01515228816828317, -0.005357142857142863};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948128, 0.0, 0.0, -0.01597191412499855, 0.0, 0.0, 0.0, 0.0, 0.0, 0.02834733547569203, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05357142857142858};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0, 0.1129384878631564, -0.06388765649999399, 0.0, 0.0, 0.0, 0.0736485379546474, 0.02672612419124241, -0.02362277956307673, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06495190528383286, -0.06060915267313263, 0.0267857142857143};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0, -0.02258769757263129, 0.127775312999988, 0.0, 0.0, 0.0, 0.0, 0.06681531047810613, 0.04724555912615341, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.07576144084141583, -0.05357142857142858};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.09780759955449396, -0.05646924393157818, -0.06388765649999402, 0.05489437910335498, -0.04252100321353804, 0.02314550249431379, 0.02454951265154914, -0.01336306209562121, -0.02362277956307673, 0.0, 0.0, 0.04841229182759271, 0.0, -0.03749999999999998, -0.05248906591678238, 0.0, 0.02165063509461096, 0.03030457633656632, 0.02678571428571431};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.01956151991089884, 0.01129384878631563, 0.127775312999988, 0.0, 0.0, 0.05786375623578445, 0.0, -0.03340765523905307, 0.04724555912615342, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06561133239597798, 0.0, 0.0, -0.03788072042070791, -0.0535714285714286};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0978075995544939, -0.07905694150420949, -0.03194382824999696, 0.05489437910335502, 0.01417366773784598, -0.04629100498862757, -0.02454951265154916, 0.01336306209562123, 0.0236227795630767, 0.0, 0.0479157423749955, -0.0069160416896561, -0.0618589574131742, -0.01607142857142857, 0.008748177652797057, 0.04285714285714286, 0.01546473935329354, 0.0, -0.005357142857142854};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.01956151991089879, 0.1242323366494721, -0.03194382824999702, 0.0, 0.0566946709513841, -0.01157275124715687, 0.02454951265154915, -0.04677071733467426, 0.02362277956307669, 0.0, 0.0, 0.0, 0.06185895741317421, -0.02142857142857142, 0.004374088826398527, -0.06428571428571429, 0.009278843611976133, 0.007576144084141583, -0.005357142857142851};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.0978075995544939, -0.0564692439315782, -0.06388765649999403, 0.05489437910335501, 0.04252100321353806, -0.02314550249431375, 0.02454951265154913, -0.01336306209562121, -0.02362277956307672, 0.0, 0.0, 0.04841229182759271, 0.0, 0.03750000000000001, 0.05248906591678239, 0.0, 0.02165063509461095, 0.03030457633656632, 0.02678571428571431};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0195615199108988, 0.01129384878631561, 0.127775312999988, 0.0, 0.0, -0.0578637562357845, 0.0, -0.03340765523905306, 0.04724555912615341, 0.0, 0.0, 0.0, 0.0, 0.0, -0.06561133239597799, 0.0, 0.0, -0.0378807204207079, -0.05357142857142858};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.09780759955449395, -0.0790569415042095, -0.03194382824999698, 0.05489437910335501, -0.01417366773784601, 0.04629100498862759, -0.02454951265154917, 0.01336306209562124, 0.0236227795630767, 0.0, 0.0479157423749955, -0.006916041689656106, 0.0618589574131742, 0.01607142857142857, -0.008748177652797059, 0.04285714285714288, 0.01546473935329352, 0.0, -0.005357142857142861};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.01956151991089873, 0.1242323366494721, -0.031943828249997, 0.0, -0.0566946709513841, 0.01157275124715689, 0.02454951265154916, -0.04677071733467428, 0.02362277956307668, 0.0, 0.0, 0.0, -0.06185895741317418, 0.02142857142857144, -0.004374088826398525, -0.06428571428571429, 0.009278843611976144, 0.00757614408414157, -0.005357142857142849};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.1173691194653928, -0.04517539514526255, -0.031943828249997, -0.01829812636778497, 0.04252100321353807, 0.03471825374147067, 0.04091585441924857, 0.03340765523905304, 0.02362277956307672, 0.08504200642707613, 0.02395787118749775, 0.02074812506896831, -0.006185895741317416, -0.005357142857142849, -0.004374088826398511, -0.01071428571428572, -0.009278843611976124, -0.007576144084141579, -0.005357142857142864};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 15:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.1173691194653928, -0.04517539514526255, -0.03194382824999698, -0.01829812636778499, -0.04252100321353804, -0.03471825374147069, 0.04091585441924858, 0.03340765523905306, 0.0236227795630767, -0.08504200642707613, 0.02395787118749776, 0.02074812506896831, 0.006185895741317413, 0.005357142857142849, 0.00437408882639852, -0.01071428571428572, -0.009278843611976133, -0.007576144084141583, -0.005357142857142858};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 16:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353317, 0.1173691194653927, 0.06776309271789389, 0.04791574237499554, 0.0, 0.08504200642707609, 0.06943650748294135, -0.07364853795464743, 0.04008918628686368, -0.09921567416492215, 0.0, 0.0, 0.0, 0.0, 0.07499999999999998, -0.02624453295839118, 0.0, -0.06495190528383291, -0.01515228816828318, 0.02678571428571427};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 17:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353315, -0.1173691194653927, 0.06776309271789378, 0.04791574237499545, 0.0, -0.08504200642707617, -0.06943650748294139, -0.07364853795464738, 0.04008918628686367, -0.09921567416492211, 0.0, 0.0, 0.0, 0.0, -0.07500000000000005, 0.02624453295839118, 0.0, -0.06495190528383285, -0.01515228816828317, 0.02678571428571428};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 18:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353317, 0.0, -0.1355261854357877, 0.04791574237499548, -0.10978875820671, 0.0, 0.0, 0.02454951265154912, -0.08017837257372734, -0.09921567416492218, 0.0, 0.0, -0.09682458365518544, 0.0, 0.0, 0.0, 0.0, 0.02165063509461096, 0.03030457633656631, 0.02678571428571429};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 19:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353316, 0.0, 0.0, -0.1437472271249866, -0.10978875820671, 0.0, 0.0, -0.1227475632577457, 0.0, 0.04252100321353807, 0.0, -0.09583148474999101, 0.01383208337931222, 0.0, 0.0, 0.0, 0.04285714285714288, 0.01546473935329356, 0.0, -0.005357142857142835};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 20; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_3_finite_element_2::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 20; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson3d_3_finite_element_2::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[27][3];
    for (unsigned int row = 0; row < 27; row++)
    {
      for (unsigned int col = 0; col < 3; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 2)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[3][3] = {{K[0], K[1], K[2]}, {K[3], K[4], K[5]}, {K[6], K[7], K[8]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[27][27];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948138, 0.01304101327393251, 0.007529232524210411, 0.005323971374999491, 0.018298126367785, 0.01417366773784603, 0.01157275124715688, 0.008183170883849724, 0.006681531047810592, 0.004724555912615332, -0.02834733547569204, -0.02395787118749776, -0.02074812506896831, -0.01855768722395226, -0.01607142857142857, -0.0131222664791956, -0.01071428571428571, -0.009278843611976109, -0.00757614408414157, -0.005357142857142851};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948137, -0.01304101327393249, 0.007529232524210419, 0.005323971374999505, 0.01829812636778498, -0.01417366773784601, -0.01157275124715689, 0.008183170883849716, 0.006681531047810611, 0.004724555912615331, 0.02834733547569204, -0.02395787118749775, -0.02074812506896831, 0.01855768722395225, 0.01607142857142859, 0.0131222664791956, -0.01071428571428572, -0.009278843611976135, -0.007576144084141578, -0.005357142857142853};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948126, 0.0, -0.01505846504842089, 0.005323971374999496, 0.0, 0.0, 0.0, 0.02454951265154914, -0.01336306209562122, 0.004724555912615357, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04285714285714285, -0.02783653083592838, 0.01515228816828317, -0.005357142857142863};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.02886751345948128, 0.0, 0.0, -0.01597191412499855, 0.0, 0.0, 0.0, 0.0, 0.0, 0.02834733547569203, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05357142857142858};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0, 0.1129384878631564, -0.06388765649999399, 0.0, 0.0, 0.0, 0.0736485379546474, 0.02672612419124241, -0.02362277956307673, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06495190528383286, -0.06060915267313263, 0.0267857142857143};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0, -0.02258769757263129, 0.127775312999988, 0.0, 0.0, 0.0, 0.0, 0.06681531047810613, 0.04724555912615341, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.07576144084141583, -0.05357142857142858};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.09780759955449396, -0.05646924393157818, -0.06388765649999402, 0.05489437910335498, -0.04252100321353804, 0.02314550249431379, 0.02454951265154914, -0.01336306209562121, -0.02362277956307673, 0.0, 0.0, 0.04841229182759271, 0.0, -0.03749999999999998, -0.05248906591678238, 0.0, 0.02165063509461096, 0.03030457633656632, 0.02678571428571431};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.01956151991089884, 0.01129384878631563, 0.127775312999988, 0.0, 0.0, 0.05786375623578445, 0.0, -0.03340765523905307, 0.04724555912615342, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06561133239597798, 0.0, 0.0, -0.03788072042070791, -0.0535714285714286};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0978075995544939, -0.07905694150420949, -0.03194382824999696, 0.05489437910335502, 0.01417366773784598, -0.04629100498862757, -0.02454951265154916, 0.01336306209562123, 0.0236227795630767, 0.0, 0.0479157423749955, -0.0069160416896561, -0.0618589574131742, -0.01607142857142857, 0.008748177652797057, 0.04285714285714286, 0.01546473935329354, 0.0, -0.005357142857142854};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.01956151991089879, 0.1242323366494721, -0.03194382824999702, 0.0, 0.0566946709513841, -0.01157275124715687, 0.02454951265154915, -0.04677071733467426, 0.02362277956307669, 0.0, 0.0, 0.0, 0.06185895741317421, -0.02142857142857142, 0.004374088826398527, -0.06428571428571429, 0.009278843611976133, 0.007576144084141583, -0.005357142857142851};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.0978075995544939, -0.0564692439315782, -0.06388765649999403, 0.05489437910335501, 0.04252100321353806, -0.02314550249431375, 0.02454951265154913, -0.01336306209562121, -0.02362277956307672, 0.0, 0.0, 0.04841229182759271, 0.0, 0.03750000000000001, 0.05248906591678239, 0.0, 0.02165063509461095, 0.03030457633656632, 0.02678571428571431};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.0195615199108988, 0.01129384878631561, 0.127775312999988, 0.0, 0.0, -0.0578637562357845, 0.0, -0.03340765523905306, 0.04724555912615341, 0.0, 0.0, 0.0, 0.0, 0.0, -0.06561133239597799, 0.0, 0.0, -0.0378807204207079, -0.05357142857142858};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.09780759955449395, -0.0790569415042095, -0.03194382824999698, 0.05489437910335501, -0.01417366773784601, 0.04629100498862759, -0.02454951265154917, 0.01336306209562124, 0.0236227795630767, 0.0, 0.0479157423749955, -0.006916041689656106, 0.0618589574131742, 0.01607142857142857, -0.008748177652797059, 0.04285714285714288, 0.01546473935329352, 0.0, -0.005357142857142861};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.01956151991089873, 0.1242323366494721, -0.031943828249997, 0.0, -0.0566946709513841, 0.01157275124715689, 0.02454951265154916, -0.04677071733467428, 0.02362277956307668, 0.0, 0.0, 0.0, -0.06185895741317418, 0.02142857142857144, -0.004374088826398525, -0.06428571428571429, 0.009278843611976144, 0.00757614408414157, -0.005357142857142849};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, -0.1173691194653928, -0.04517539514526255, -0.031943828249997, -0.01829812636778497, 0.04252100321353807, 0.03471825374147067, 0.04091585441924857, 0.03340765523905304, 0.02362277956307672, 0.08504200642707613, 0.02395787118749775, 0.02074812506896831, -0.006185895741317416, -0.005357142857142849, -0.004374088826398511, -0.01071428571428572, -0.009278843611976124, -0.007576144084141579, -0.005357142857142864};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 15:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.0, 0.1173691194653928, -0.04517539514526255, -0.03194382824999698, -0.01829812636778499, -0.04252100321353804, -0.03471825374147069, 0.04091585441924858, 0.03340765523905306, 0.0236227795630767, -0.08504200642707613, 0.02395787118749776, 0.02074812506896831, 0.006185895741317413, 0.005357142857142849, 0.00437408882639852, -0.01071428571428572, -0.009278843611976133, -0.007576144084141583, -0.005357142857142858};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 16:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353317, 0.1173691194653927, 0.06776309271789389, 0.04791574237499554, 0.0, 0.08504200642707609, 0.06943650748294135, -0.07364853795464743, 0.04008918628686368, -0.09921567416492215, 0.0, 0.0, 0.0, 0.0, 0.07499999999999998, -0.02624453295839118, 0.0, -0.06495190528383291, -0.01515228816828318, 0.02678571428571427};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 17:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353315, -0.1173691194653927, 0.06776309271789378, 0.04791574237499545, 0.0, -0.08504200642707617, -0.06943650748294139, -0.07364853795464738, 0.04008918628686367, -0.09921567416492211, 0.0, 0.0, 0.0, 0.0, -0.07500000000000005, 0.02624453295839118, 0.0, -0.06495190528383285, -0.01515228816828317, 0.02678571428571428};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 18:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353317, 0.0, -0.1355261854357877, 0.04791574237499548, -0.10978875820671, 0.0, 0.0, 0.02454951265154912, -0.08017837257372734, -0.09921567416492218, 0.0, 0.0, -0.09682458365518544, 0.0, 0.0, 0.0, 0.0, 0.02165063509461096, 0.03030457633656631, 0.02678571428571429};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 19:
      {
        
      // Array of basisvalues
      double basisvalues[20] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[10] *= std::sqrt(63.0);
      
      // Table(s) of coefficients
      static const double coefficients0[20] = \
      {0.2598076211353316, 0.0, 0.0, -0.1437472271249866, -0.10978875820671, 0.0, 0.0, -0.1227475632577457, 0.0, 0.04252100321353807, 0.0, -0.09583148474999101, 0.01383208337931222, 0.0, 0.0, 0.0, 0.04285714285714288, 0.01546473935329356, 0.0, -0.005357142857142835};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 2.521713647700794e-15, -5.495275263404379e-15, -1.77635683940025e-15, 0.0, 2.188150318759559e-15, 1.194236755450747e-15, -1.050330761363089e-15, 1.54929135005805e-15, -1.77635683940025e-15, 0.0, 0.0, 1.160374616521958e-15, 0.0, -1.292536425563208e-15, 2.181837417763971e-15, -4.03871045247155e-15, 2.769715633042472e-15, 0.0, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.423141430393384e-15, 11.22497216032182, 0.0, 0.0, 2.300934064457781e-15, -2.966159851743344e-15, 0.0, -1.9841378487077e-15, 2.129368244509855e-15, 1.450859377915378e-15, 0.0, -1.174050877224393e-15, -2.648909796579073e-15, 0.0, 0.0, -2.220446049250313e-15, 0.0, 1.555927170567964e-15, 1.398968236161439e-15, 0.0},
      {4.582575694955858, 0.0, 8.366600265340754, -1.183215956619928, 0.0, 1.21521875770802e-15, 0.0, -3.134839904229629e-15, 2.325889199939574e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -2.736375982275161e-15, 0.0, -4.144414434589198e-15, 7.011452736978098e-15, -4.643158151327501e-15, -3.108624468950438e-15},
      {3.741657386773952, 1.446116552396844e-15, 0.0, 8.694826047713672, 0.0, 0.0, 0.0, 0.0, 3.813875994660741e-15, -1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 2.11905047541413e-15, 1.02828240733017e-15, 3.483709457500024e-15, -4.015211881033069e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833946997, -6.672029859433957e-14, -3.346640106136303, -2.366431913239848, 15.49193338482966, 1.925054048741832e-14, 1.1183436843606e-14, 0.6928203230275478, 0.5656854249492353, 0.3999999999999975, 3.853975752669995e-15, -3.033773916133962e-15, 2.217007904586941e-15, -6.869209560334341e-15, 0.0, -4.58479344930058e-15, -4.12202322782754e-15, -1.906846190135871e-15, -3.950314617613263e-15, -6.661338147750939e-15},
      {-6.419734499603167e-15, 4.898979485566358, 1.20142659132654e-14, -3.367676508029642e-15, 0.0, 14.19859147943908, -0.8280786712108241, 2.916517254040961e-15, -1.939800196891104e-15, 1.349348825006484e-15, 0.0, 0.0, -1.22343762934608e-15, 1.596666179839102e-15, -1.397291869096539e-15, -1.776356839400251e-15, 9.16605905885332e-15, -7.409958878853184e-15, 4.391307352822832e-15, 0.0},
      {-7.714680473238917e-15, 4.242640687119286, 6.511396716844622e-15, 2.583750984355752e-15, 1.114641864926126e-15, 0.0, 14.34274331201274, 1.037741102034751e-15, 0.0, 0.0, 0.0, -1.070096454324808e-15, 0.0, 0.0, -1.610284270285042e-15, -3.552713678800501e-15, 1.128082818887494e-15, -5.557800569229354e-15, 1.030754258135986e-14, 3.384185346029e-15},
      {3.60000000000003, -3.388139913991425e-15, 8.763560920082682, -1.549193338482979, 0.0, -2.734978203462988e-15, 1.395157646234648e-15, 9.524704719832553, -1.481312159636086, 0.2618614682831927, 0.0, 0.0, 0.0, -3.104070252591684e-15, 0.0, 0.0, -4.16449154004964e-15, 6.63917109925218e-15, -4.273098328370954e-15, -3.885780586188048e-15},
      {3.117691453623981, 1.229143981082209e-15, 3.162277660168376, 4.919349550499534, 0.0, 0.0, 1.3450181652838e-15, -1.2459511421388e-15, 10.69044967649698, -2.418972627259056, 0.0, 0.0, 0.0, 0.0, 0.0, 2.093999531486197e-15, 0.0, 5.936178308387972e-15, -4.415885040048118e-15, 0.0},
      {2.545584412271556, -1.187809430164752e-15, 0.0, 7.668115805072295, 0.0, -1.745724324458159e-15, -1.376431322673082e-15, 0.0, 3.316160425389367e-15, 10.36918511745257, 0.0, 0.0, -2.261797378980743e-15, 0.0, 2.82934501089857e-15, -1.010302952408893e-15, 2.273478607496658e-15, 3.632561406028415e-15, -7.349620972710225e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {5.477225575051665, 2.037262232995496e-15, -5.857600587053326e-15, -1.77635683940025e-15, 0.0, 1.940684184999838e-15, 1.405025654711858e-15, -1.176280231071729e-15, 2.481697027925593e-15, 0.0, 0.0, 0.0, 1.242900586108041e-15, 0.0, -1.238362725001172e-15, 2.12751332100444e-15, -3.708000038826892e-15, 1.30436316021689e-15, -1.392649833595809e-15, -3.108624468950438e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477963, 7.245688373094731, 4.18330013267038, -0.5916079783099732, 2.821372836302874e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.699785570114263e-15, 0.0, 0.0, -1.356644566233714e-15, -2.133338079079104e-15, 1.845537779308901e-15, 1.231134603136743e-15, -2.775557561562891e-15},
      {1.870828693386976, 0.0, 0.0, 4.347413023856836, 0.0, 0.0, 0.0, 0.0, 1.906937997330371e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.059525237707065e-15, 0.0, 1.741854728750012e-15, -2.007605940516535e-15, 0.0},
      {-2.645751311064624, -2.334983843489119e-15, 9.660917830792954, 0.6831300510639895, 0.0, 0.0, 0.0, -2.610887184790749e-15, 0.0, 0.0, 1.908128084696582e-15, 0.0, -2.269066744970258e-15, 0.0, -1.657797988837844e-15, -1.291714851610477e-15, 0.0, 2.880146669722971e-15, -2.479056059200629e-15, 2.55351295663786e-15},
      {3.24037034920394, 1.490360361502237e-15, 0.0, 7.529940238806687, 0.0, 0.0, 1.102587306065744e-15, 0.0, 3.747002708109909e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.073138233903528e-15, 0.0, 2.572891679749063e-15, -1.22494527056469e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724445, 2.449489742783173, 2.828427124746189, -0.9999999999999984, 9.165151389911685, 7.099295739719545, -0.4140393356054127, -2.049390153191926, -0.4780914437337582, 0.1690308509457008, 1.17550512831762e-15, -2.331111754478575e-15, -2.121986527547079e-15, -4.062986162084082e-15, 0.0, -2.704151605690764e-15, 1.287280592120398e-15, 4.546066153984031e-15, -4.045923333285746e-15, -2.997602166487923e-15},
      {2.01246117974981, 2.121320343559645, -0.4082482904638616, 3.175426480542948, 0.0, 0.0, 7.171371656006369, 0.0, -1.380131118684708, -1.561440116717655, 0.0, 0.0, 0.0, 0.0, 0.0, -1.618369333314299e-15, 0.0, 1.874974997503232e-15, 1.59045056202182e-15, 2.664535259100376e-15},
      {1.8, -5.692099788303093, 4.381780460041318, -0.7745966692414861, -2.040419550760736e-15, 10.99818166789403, 0.9621404708847326, 4.762352359916257, -0.7406560798180377, 0.1309307341415945, -1.77181141703336e-15, 0.0, 0.0, 2.295298746950473e-15, 1.151025051133622e-15, 0.0, -6.070359128700294e-15, 6.646870919583184e-15, -5.356195935598432e-15, -2.275957200481571e-15},
      {1.558845726811987, 2.738612787525828, 1.58113883008419, 2.459674775249773, 0.0, 0.0, 9.258200997725517, 0.0, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 0.0, 0.0, 0.0, -1.617535493357277e-15, 0.0, 4.845621498860071e-15, 0.0, 0.0},
      {1.272792206135776, 0.0, 0.0, 3.83405790253615, 0.0, 0.0, 0.0, 0.0, 1.213991002844623e-15, 5.184592558726294, 0.0, 0.0, -1.130898689490372e-15, 0.0, 1.858761715299349e-15, 0.0, 1.35878390867336e-15, 2.260369912864272e-15, -3.119698974042538e-15, 0.0},
      {5.196152422706655, -1.99526589987696e-15, -3.162277660168416, -2.236067977499803, 0.0, -3.412616322517135e-15, 2.579867966076249e-15, 13.74772708486752, 0.5345224838248563, 0.3779644730092309, 0.0, 0.0, 0.0, -5.25410409350771e-15, 1.76573165810989e-15, 0.0, 1.614498081985539e-15, 0.0, 0.0, -4.440892098500626e-15},
      {-1.799999999999999, -1.150342913512333e-15, 3.651483716701109, -2.840187787218783, 0.0, 0.0, 0.0, -1.129227163995743e-15, 12.34426799696738, 1.396594497510347, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 4.753430324585095e-15, -7.220450200119147e-15, -5.773159728050814e-15},
      {2.204540768504851, 0.0, 0.0, 6.640783086353577, 0.0, -1.4236645213502e-15, -1.284721063589107e-15, 0.0, 2.416367356147982e-15, 8.979977728257467, 0.0, 0.0, -2.137264006130433e-15, 0.0, 3.338463075209048e-15, 0.0, 1.852032718355939e-15, 3.02689711328083e-15, -6.113165529342252e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[20][20] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 1.260856823850397e-15, -2.747637631702189e-15, 0.0, 0.0, 1.094075159379779e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.090918708881986e-15, -2.019355226235775e-15, 1.384857816521236e-15, 0.0, 0.0},
      {1.825741858350554, 0.0, -1.952533529017775e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.08797027632561e-15, 0.0, 0.0, 0.0},
      {5.163977794943222, 2.022340803479375e-15, -5.827373445862949e-15, -2.664535259100376e-15, 0.0, 1.043107726910597e-15, 0.0, -1.584844206556714e-15, 2.415960058998751e-15, 0.0, 0.0, 0.0, 0.0, 1.009124476334559e-15, 0.0, 1.2192519255667e-15, -3.749914838136528e-15, 1.255163268493427e-15, 0.0, -1.77635683940025e-15},
      {2.958039891549812, 5.612486080160915, -1.080123449734647, -0.763762615825974, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -1.186836056807244e-15, 0.0, 0.0, 0.0, -1.223898386605332e-15, -3.473776923794777e-15, 1.930526901264454e-15, 0.0, -1.443289932012704e-15},
      {2.291287847477919, 1.449137674618944, 4.18330013267037, -0.5916079783099608, 0.0, 0.0, 0.0, -2.675801554463839e-15, 1.607033809819848e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.041230395159448e-15, 0.0, -3.860790229051752e-15, 3.706595702473093e-15, -2.76566828551381e-15, 0.0},
      {1.870828693387014, 7.099295739719546, -1.765025725372954e-15, 4.347413023856838, 0.0, -1.424390770162612e-15, 1.643750842808947e-15, 0.0, 2.35102720718044e-15, 0.0, 0.0, 0.0, 0.0, -2.284479753032343e-15, 0.0, 0.0, -2.099267520536231e-15, 4.280221709692451e-15, -2.007605940516549e-15, 0.0},
      {1.322875655532308, 0.0, 3.86436713231719, -0.3415650255319891, 0.0, 0.0, 0.0, -1.700763504877909e-15, 1.490903957693083e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 2.564724794684447e-15, 0.0, 0.0},
      {1.08012344973463, 0.0, 7.099295739719541, 2.509980079602213, 0.0, 0.0, 0.0, -3.741190461595502e-15, 2.433238795636794e-15, -1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, -1.420910645404085e-15, 0.0, -1.247764390446298e-15, 5.09048316041895e-15, -3.072850349288588e-15, -1.77635683940025e-15},
      {-3.818813079129911, -2.477222110142647e-15, 6.940748678657674e-15, 8.874119674649437, 0.0, -3.224181082252071e-15, 0.0, 1.931321646908432e-15, 1.62358435413874e-15, 1.77635683940025e-15, 0.0, 0.0, -1.745846764577382e-15, -2.029850799741755e-15, 1.064351054901856e-15, 0.0, 6.339762903997647e-15, 1.023683736458606e-15, -1.434894166578705e-15, 4.440892098500626e-15},
      {2.749545416973479, 5.796550698475739, -1.673320053068137, -1.183215956619914, 7.74596669241484, -1.199999999999991, -0.9797958971132654, 0.3464101615137706, 0.2828427124746153, 0.199999999999998, 1.957160114649098e-15, -1.810679519710648e-15, -1.811107043341094e-15, -3.412687503307201e-15, 0.0, -2.236885573419033e-15, -2.302150564657574e-15, 0.0, -1.309023494031534e-15, -3.108624468950438e-15},
      {2.323790007724452, 2.44948974278318, 2.828427124746186, -0.9999999999999988, 1.309307341415955, 7.099295739719541, -0.4140393356054117, -2.049390153191924, -0.4780914437337567, 0.1690308509457014, 0.0, 0.0, 0.0, -2.022139231647724e-15, -1.264922372253471e-15, 0.0, -2.567472914004819e-15, 5.286864865827827e-15, 0.0, 0.0},
      {2.012461179749805, 2.12132034355964, -0.4082482904638582, 3.175426480542945, 9.071147352221457, 3.51024647595687e-15, 7.17137165600637, -2.757097233252245e-15, -1.38013111868471, -1.561440116717655, 3.556259396319962e-15, -2.148363244369583e-15, -3.344424383121238e-15, -5.61061826488252e-15, 0.0, -1.758802672057367e-15, 2.390456775505333e-15, 2.087475888121408e-15, 0.0, -2.220446049250313e-15},
      {1.800000000000003, 0.6324555320336726, 4.38178046004132, -0.7745966692414841, 0.0, 3.142337619398289, -0.1069044967649685, 4.762352359916258, -0.7406560798180386, 0.1309307341415953, 0.0, 0.0, 0.0, -1.148203437748323e-15, 0.0, 0.0, -4.012069291770081e-15, 5.690317138105343e-15, -2.414104920341767e-15, -1.831867990631508e-15},
      {1.558845726811988, 0.5477225575051655, 1.581138830084187, 2.45967477524977, 0.0, 9.071147352221452, 1.851640199545105, -3.94618758565717e-15, 5.345224838248493, -1.20948631362953, 0.0, 1.005622306727725e-15, 0.0, 2.657173406809211e-15, 1.493727017076729e-15, 0.0, -1.201082826296663e-15, 7.334247175455137e-15, -3.984299359424308e-15, -1.77635683940025e-15},
      {1.272792206135772, -6.260990336999445, 0.0, 3.834057902536152, 0.0, 0.0, 10.58300524425835, 3.235338304737015e-15, 3.351170325248047e-15, 5.184592558726293, 0.0, 0.0, 1.343441783550911e-15, 0.0, 0.0, 0.0, 1.022932041640217e-15, 1.011434112217371e-15, -2.45356515926744e-15, -1.77635683940025e-15},
      {1.039230484541329, -1.757885619510421e-15, 3.162277660168361, -0.4472135954999596, 0.0, -1.999007917730069e-15, 0.0, 5.891883036371791, -0.5345224838248459, 0.07559289460184626, 0.0, 0.0, 0.0, -2.747276701381762e-15, 0.0, 0.0, 1.30102526617857e-15, 3.090569535635313e-15, -1.246450634594476e-15, -2.220446049250313e-15},
      {0.8999999999999968, -2.371711752640277e-15, 1.460593486680368, 1.420093893609388, 0.0, -3.409084865183844e-15, 1.307152106401494e-15, 9.071147352221432, 4.937707198786966, -0.6982972487551766, 0.0, 0.0, 0.0, -5.320470275626746e-15, 1.001856889400092e-15, 0.0, -2.91350503663035e-15, 1.509696289928442e-15, -5.139932550008914e-15, -3.719247132494274e-15},
      {0.7348469228349485, 0.0, -6.26099033699946, 2.213594362117849, 0.0, 0.0, 0.0, 2.499723555036546e-15, 10.58300524425839, 2.993325909419149, 0.0, 0.0, 0.0, 0.0, 2.742561885485749e-15, 0.0, 0.0, -2.254462289444827e-15, -1.297573160030641e-15, -3.996802888650564e-15},
      {5.715767664977284, 0.0, -8.136865105540533e-15, -4.695742752749558, 0.0, 1.764524864798232e-15, -2.1333767656747e-15, -1.281765146891444e-15, 0.0, 12.69960629311002, 0.0, 0.0, -1.124295658485126e-15, 0.0, 1.461403336307693e-15, -2.125541779214696e-15, -4.784134153924104e-15, 3.917246307329848e-15, -4.17093758440723e-15, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[27];
      for (unsigned int r = 0; r < 27; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[20][20] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 20; t++)
        {
          for (unsigned int u = 0; u < 20; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 20; t++)
          {
            for (unsigned int u = 0; u < 20; u++)
            {
              for (unsigned int tu = 0; tu < 20; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 20; s++)
        {
          for (unsigned int t = 0; t < 20; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_3_finite_element_2::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 20; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[27];
    for (unsigned int r = 0; r < 27; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 20; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson3d_3_finite_element_2::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 4:
      {
        y[0] = 0.6666666666666667*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
      y[1] = 0.6666666666666667*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
      y[2] = 0.6666666666666667*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 5:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[6] + 0.6666666666666666*coordinate_dofs[9];
      y[1] = 0.3333333333333334*coordinate_dofs[7] + 0.6666666666666666*coordinate_dofs[10];
      y[2] = 0.3333333333333334*coordinate_dofs[8] + 0.6666666666666666*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 6:
      {
        y[0] = 0.6666666666666667*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[9];
      y[1] = 0.6666666666666667*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[10];
      y[2] = 0.6666666666666667*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 7:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[3] + 0.6666666666666666*coordinate_dofs[9];
      y[1] = 0.3333333333333334*coordinate_dofs[4] + 0.6666666666666666*coordinate_dofs[10];
      y[2] = 0.3333333333333334*coordinate_dofs[5] + 0.6666666666666666*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 8:
      {
        y[0] = 0.6666666666666667*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6];
      y[1] = 0.6666666666666667*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7];
      y[2] = 0.6666666666666667*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 9:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[3] + 0.6666666666666666*coordinate_dofs[6];
      y[1] = 0.3333333333333334*coordinate_dofs[4] + 0.6666666666666666*coordinate_dofs[7];
      y[2] = 0.3333333333333334*coordinate_dofs[5] + 0.6666666666666666*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 10:
      {
        y[0] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[9];
      y[1] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[10];
      y[2] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 11:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[9];
      y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[10];
      y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 12:
      {
        y[0] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[6];
      y[1] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[7];
      y[2] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 13:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[6];
      y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[7];
      y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 14:
      {
        y[0] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3];
      y[1] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4];
      y[2] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 15:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[3];
      y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[4];
      y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 16:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
      y[1] = 0.3333333333333334*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
      y[2] = 0.3333333333333334*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 17:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
      y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
      y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 18:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[9];
      y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[10];
      y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 19:
      {
        y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6];
      y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7];
      y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson3d_3_finite_element_2::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    y[2] = coordinate_dofs[2];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[3];
    y[1] = coordinate_dofs[4];
    y[2] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[6];
    y[1] = coordinate_dofs[7];
    y[2] = coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[9];
    y[1] = coordinate_dofs[10];
    y[2] = coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
    y[0] = 0.6666666666666667*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
    y[1] = 0.6666666666666667*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
    y[2] = 0.6666666666666667*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[4] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[6] + 0.6666666666666666*coordinate_dofs[9];
    y[1] = 0.3333333333333334*coordinate_dofs[7] + 0.6666666666666666*coordinate_dofs[10];
    y[2] = 0.3333333333333334*coordinate_dofs[8] + 0.6666666666666666*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[5] = vals[0];
    y[0] = 0.6666666666666667*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[9];
    y[1] = 0.6666666666666667*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[10];
    y[2] = 0.6666666666666667*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[6] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[3] + 0.6666666666666666*coordinate_dofs[9];
    y[1] = 0.3333333333333334*coordinate_dofs[4] + 0.6666666666666666*coordinate_dofs[10];
    y[2] = 0.3333333333333334*coordinate_dofs[5] + 0.6666666666666666*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[7] = vals[0];
    y[0] = 0.6666666666666667*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6];
    y[1] = 0.6666666666666667*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7];
    y[2] = 0.6666666666666667*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[8] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[3] + 0.6666666666666666*coordinate_dofs[6];
    y[1] = 0.3333333333333334*coordinate_dofs[4] + 0.6666666666666666*coordinate_dofs[7];
    y[2] = 0.3333333333333334*coordinate_dofs[5] + 0.6666666666666666*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[9] = vals[0];
    y[0] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[9];
    y[1] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[10];
    y[2] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[10] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[9];
    y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[10];
    y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[11] = vals[0];
    y[0] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[6];
    y[1] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[7];
    y[2] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[12] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[6];
    y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[7];
    y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[13] = vals[0];
    y[0] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3];
    y[1] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4];
    y[2] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[14] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[3];
    y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[4];
    y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[15] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
    y[1] = 0.3333333333333334*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
    y[2] = 0.3333333333333334*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[16] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
    y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
    y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[17] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[9];
    y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[10];
    y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[18] = vals[0];
    y[0] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6];
    y[1] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7];
    y[2] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[19] = vals[0];
}

void poisson3d_3_finite_element_2::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
    vertex_values[3] = dof_values[3];
}

void poisson3d_3_finite_element_2::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[6];
    dof_coordinates[7] = coordinate_dofs[7];
    dof_coordinates[8] = coordinate_dofs[8];
    dof_coordinates[9] = coordinate_dofs[9];
    dof_coordinates[10] = coordinate_dofs[10];
    dof_coordinates[11] = coordinate_dofs[11];
    dof_coordinates[12] = 0.6666666666666667*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
    dof_coordinates[13] = 0.6666666666666667*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
    dof_coordinates[14] = 0.6666666666666667*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
    dof_coordinates[15] = 0.3333333333333334*coordinate_dofs[6] + 0.6666666666666666*coordinate_dofs[9];
    dof_coordinates[16] = 0.3333333333333334*coordinate_dofs[7] + 0.6666666666666666*coordinate_dofs[10];
    dof_coordinates[17] = 0.3333333333333334*coordinate_dofs[8] + 0.6666666666666666*coordinate_dofs[11];
    dof_coordinates[18] = 0.6666666666666667*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[9];
    dof_coordinates[19] = 0.6666666666666667*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[10];
    dof_coordinates[20] = 0.6666666666666667*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[11];
    dof_coordinates[21] = 0.3333333333333334*coordinate_dofs[3] + 0.6666666666666666*coordinate_dofs[9];
    dof_coordinates[22] = 0.3333333333333334*coordinate_dofs[4] + 0.6666666666666666*coordinate_dofs[10];
    dof_coordinates[23] = 0.3333333333333334*coordinate_dofs[5] + 0.6666666666666666*coordinate_dofs[11];
    dof_coordinates[24] = 0.6666666666666667*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6];
    dof_coordinates[25] = 0.6666666666666667*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7];
    dof_coordinates[26] = 0.6666666666666667*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8];
    dof_coordinates[27] = 0.3333333333333334*coordinate_dofs[3] + 0.6666666666666666*coordinate_dofs[6];
    dof_coordinates[28] = 0.3333333333333334*coordinate_dofs[4] + 0.6666666666666666*coordinate_dofs[7];
    dof_coordinates[29] = 0.3333333333333334*coordinate_dofs[5] + 0.6666666666666666*coordinate_dofs[8];
    dof_coordinates[30] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[9];
    dof_coordinates[31] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[10];
    dof_coordinates[32] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[11];
    dof_coordinates[33] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[9];
    dof_coordinates[34] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[10];
    dof_coordinates[35] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[11];
    dof_coordinates[36] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[6];
    dof_coordinates[37] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[7];
    dof_coordinates[38] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[8];
    dof_coordinates[39] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[6];
    dof_coordinates[40] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[7];
    dof_coordinates[41] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[8];
    dof_coordinates[42] = 0.6666666666666667*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3];
    dof_coordinates[43] = 0.6666666666666667*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4];
    dof_coordinates[44] = 0.6666666666666667*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5];
    dof_coordinates[45] = 0.3333333333333334*coordinate_dofs[0] + 0.6666666666666666*coordinate_dofs[3];
    dof_coordinates[46] = 0.3333333333333334*coordinate_dofs[1] + 0.6666666666666666*coordinate_dofs[4];
    dof_coordinates[47] = 0.3333333333333334*coordinate_dofs[2] + 0.6666666666666666*coordinate_dofs[5];
    dof_coordinates[48] = 0.3333333333333334*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
    dof_coordinates[49] = 0.3333333333333334*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
    dof_coordinates[50] = 0.3333333333333334*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
    dof_coordinates[51] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[6] + 0.3333333333333333*coordinate_dofs[9];
    dof_coordinates[52] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[7] + 0.3333333333333333*coordinate_dofs[10];
    dof_coordinates[53] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[8] + 0.3333333333333333*coordinate_dofs[11];
    dof_coordinates[54] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[9];
    dof_coordinates[55] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[10];
    dof_coordinates[56] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[11];
    dof_coordinates[57] = 0.3333333333333334*coordinate_dofs[0] + 0.3333333333333333*coordinate_dofs[3] + 0.3333333333333333*coordinate_dofs[6];
    dof_coordinates[58] = 0.3333333333333334*coordinate_dofs[1] + 0.3333333333333333*coordinate_dofs[4] + 0.3333333333333333*coordinate_dofs[7];
    dof_coordinates[59] = 0.3333333333333334*coordinate_dofs[2] + 0.3333333333333333*coordinate_dofs[5] + 0.3333333333333333*coordinate_dofs[8];
}

std::size_t poisson3d_3_finite_element_2::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson3d_3_finite_element_2::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson3d_3_finite_element_2::create() const
{
    return new poisson3d_3_finite_element_2();
}


poisson3d_3_dofmap_0::poisson3d_3_dofmap_0() : ufc::dofmap()
{
    // Do nothing
}

poisson3d_3_dofmap_0::~poisson3d_3_dofmap_0()
{
    // Do nothing
}

const char * poisson3d_3_dofmap_0::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', tetrahedron, 1)";
}

bool poisson3d_3_dofmap_0::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    case 3:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson3d_3_dofmap_0::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_dofmap_0::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0];
}

std::size_t poisson3d_3_dofmap_0::num_element_dofs() const
{
    return 4;
}

std::size_t poisson3d_3_dofmap_0::num_facet_dofs() const
{
    return 3;
}

std::size_t poisson3d_3_dofmap_0::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    case 3:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_dofmap_0::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    case 3:
      {
        return 4;
        break;
      }
    }
    
    return 0;
}

void poisson3d_3_dofmap_0::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
    dofs[3] = entity_indices[0][3];
}

void poisson3d_3_dofmap_0::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
        break;
      }
    case 3:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    }
    
}

void poisson3d_3_dofmap_0::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    case 3:
      {
        
        break;
      }
    }
    
}

void poisson3d_3_dofmap_0::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 2;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 3;
          break;
        }
      case 2:
        {
          dofs[0] = 1;
        dofs[1] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 4:
        {
          dofs[0] = 0;
        dofs[1] = 2;
          break;
        }
      case 5:
        {
          dofs[0] = 0;
        dofs[1] = 1;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
        break;
      }
    }
    
}

std::size_t poisson3d_3_dofmap_0::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson3d_3_dofmap_0::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson3d_3_dofmap_0::create() const
{
    return new poisson3d_3_dofmap_0();
}


poisson3d_3_dofmap_1::poisson3d_3_dofmap_1() : ufc::dofmap()
{
    // Do nothing
}

poisson3d_3_dofmap_1::~poisson3d_3_dofmap_1()
{
    // Do nothing
}

const char * poisson3d_3_dofmap_1::signature() const
{
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', tetrahedron, 1), dim=3)";
}

bool poisson3d_3_dofmap_1::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    case 3:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson3d_3_dofmap_1::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_dofmap_1::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return 3*num_global_entities[0];
}

std::size_t poisson3d_3_dofmap_1::num_element_dofs() const
{
    return 12;
}

std::size_t poisson3d_3_dofmap_1::num_facet_dofs() const
{
    return 9;
}

std::size_t poisson3d_3_dofmap_1::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 3;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    case 3:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_dofmap_1::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 3;
        break;
      }
    case 1:
      {
        return 6;
        break;
      }
    case 2:
      {
        return 9;
        break;
      }
    case 3:
      {
        return 12;
        break;
      }
    }
    
    return 0;
}

void poisson3d_3_dofmap_1::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    dofs[3] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
    dofs[4] = offset + entity_indices[0][0];
    dofs[5] = offset + entity_indices[0][1];
    dofs[6] = offset + entity_indices[0][2];
    dofs[7] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
    dofs[8] = offset + entity_indices[0][0];
    dofs[9] = offset + entity_indices[0][1];
    dofs[10] = offset + entity_indices[0][2];
    dofs[11] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
}

void poisson3d_3_dofmap_1::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 5;
      dofs[4] = 6;
      dofs[5] = 7;
      dofs[6] = 9;
      dofs[7] = 10;
      dofs[8] = 11;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 6;
      dofs[5] = 7;
      dofs[6] = 8;
      dofs[7] = 10;
      dofs[8] = 11;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 7;
      dofs[6] = 8;
      dofs[7] = 9;
      dofs[8] = 11;
        break;
      }
    case 3:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 6;
      dofs[6] = 8;
      dofs[7] = 9;
      dofs[8] = 10;
        break;
      }
    }
    
}

void poisson3d_3_dofmap_1::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 4;
        dofs[2] = 8;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 5;
        dofs[2] = 9;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 6;
        dofs[2] = 10;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
        dofs[1] = 7;
        dofs[2] = 11;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    case 3:
      {
        
        break;
      }
    }
    
}

void poisson3d_3_dofmap_1::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 4;
        dofs[2] = 8;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 5;
        dofs[2] = 9;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 6;
        dofs[2] = 10;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
        dofs[1] = 7;
        dofs[2] = 11;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 2;
        dofs[1] = 3;
        dofs[2] = 6;
        dofs[3] = 7;
        dofs[4] = 10;
        dofs[5] = 11;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 3;
        dofs[2] = 5;
        dofs[3] = 7;
        dofs[4] = 9;
        dofs[5] = 11;
          break;
        }
      case 2:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 5;
        dofs[3] = 6;
        dofs[4] = 9;
        dofs[5] = 10;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 3;
        dofs[2] = 4;
        dofs[3] = 7;
        dofs[4] = 8;
        dofs[5] = 11;
          break;
        }
      case 4:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 6;
        dofs[4] = 8;
        dofs[5] = 10;
          break;
        }
      case 5:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 4;
        dofs[3] = 5;
        dofs[4] = 8;
        dofs[5] = 9;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        dofs[4] = 6;
        dofs[5] = 7;
        dofs[6] = 9;
        dofs[7] = 10;
        dofs[8] = 11;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 6;
        dofs[5] = 7;
        dofs[6] = 8;
        dofs[7] = 10;
        dofs[8] = 11;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 7;
        dofs[6] = 8;
        dofs[7] = 9;
        dofs[8] = 11;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 6;
        dofs[6] = 8;
        dofs[7] = 9;
        dofs[8] = 10;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
        break;
      }
    }
    
}

std::size_t poisson3d_3_dofmap_1::num_sub_dofmaps() const
{
    return 3;
}

ufc::dofmap * poisson3d_3_dofmap_1::create_sub_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_3_dofmap_0();
        break;
      }
    case 1:
      {
        return new poisson3d_3_dofmap_0();
        break;
      }
    case 2:
      {
        return new poisson3d_3_dofmap_0();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson3d_3_dofmap_1::create() const
{
    return new poisson3d_3_dofmap_1();
}


poisson3d_3_dofmap_2::poisson3d_3_dofmap_2() : ufc::dofmap()
{
    // Do nothing
}

poisson3d_3_dofmap_2::~poisson3d_3_dofmap_2()
{
    // Do nothing
}

const char * poisson3d_3_dofmap_2::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', tetrahedron, 3)";
}

bool poisson3d_3_dofmap_2::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return true;
        break;
      }
    case 2:
      {
        return true;
        break;
      }
    case 3:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson3d_3_dofmap_2::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_3_dofmap_2::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0] + 2*num_global_entities[1] + num_global_entities[2];
}

std::size_t poisson3d_3_dofmap_2::num_element_dofs() const
{
    return 20;
}

std::size_t poisson3d_3_dofmap_2::num_facet_dofs() const
{
    return 10;
}

std::size_t poisson3d_3_dofmap_2::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 1;
        break;
      }
    case 3:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_dofmap_2::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 4;
        break;
      }
    case 2:
      {
        return 10;
        break;
      }
    case 3:
      {
        return 20;
        break;
      }
    }
    
    return 0;
}

void poisson3d_3_dofmap_2::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    dofs[3] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
    dofs[4] = offset + 2*entity_indices[1][0];
    dofs[5] = offset + 2*entity_indices[1][0] + 1;
    dofs[6] = offset + 2*entity_indices[1][1];
    dofs[7] = offset + 2*entity_indices[1][1] + 1;
    dofs[8] = offset + 2*entity_indices[1][2];
    dofs[9] = offset + 2*entity_indices[1][2] + 1;
    dofs[10] = offset + 2*entity_indices[1][3];
    dofs[11] = offset + 2*entity_indices[1][3] + 1;
    dofs[12] = offset + 2*entity_indices[1][4];
    dofs[13] = offset + 2*entity_indices[1][4] + 1;
    dofs[14] = offset + 2*entity_indices[1][5];
    dofs[15] = offset + 2*entity_indices[1][5] + 1;
    offset += 2*num_global_entities[1];
    dofs[16] = offset + entity_indices[2][0];
    dofs[17] = offset + entity_indices[2][1];
    dofs[18] = offset + entity_indices[2][2];
    dofs[19] = offset + entity_indices[2][3];
    offset += num_global_entities[2];
}

void poisson3d_3_dofmap_2::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 6;
      dofs[6] = 7;
      dofs[7] = 8;
      dofs[8] = 9;
      dofs[9] = 16;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 10;
      dofs[6] = 11;
      dofs[7] = 12;
      dofs[8] = 13;
      dofs[9] = 17;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 6;
      dofs[4] = 7;
      dofs[5] = 10;
      dofs[6] = 11;
      dofs[7] = 14;
      dofs[8] = 15;
      dofs[9] = 18;
        break;
      }
    case 3:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 8;
      dofs[4] = 9;
      dofs[5] = 12;
      dofs[6] = 13;
      dofs[7] = 14;
      dofs[8] = 15;
      dofs[9] = 19;
        break;
      }
    }
    
}

void poisson3d_3_dofmap_2::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 4;
        dofs[1] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 6;
        dofs[1] = 7;
          break;
        }
      case 2:
        {
          dofs[0] = 8;
        dofs[1] = 9;
          break;
        }
      case 3:
        {
          dofs[0] = 10;
        dofs[1] = 11;
          break;
        }
      case 4:
        {
          dofs[0] = 12;
        dofs[1] = 13;
          break;
        }
      case 5:
        {
          dofs[0] = 14;
        dofs[1] = 15;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 16;
          break;
        }
      case 1:
        {
          dofs[0] = 17;
          break;
        }
      case 2:
        {
          dofs[0] = 18;
          break;
        }
      case 3:
        {
          dofs[0] = 19;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        
        break;
      }
    }
    
}

void poisson3d_3_dofmap_2::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 2;
        dofs[1] = 3;
        dofs[2] = 4;
        dofs[3] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 3;
        dofs[2] = 6;
        dofs[3] = 7;
          break;
        }
      case 2:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 8;
        dofs[3] = 9;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 3;
        dofs[2] = 10;
        dofs[3] = 11;
          break;
        }
      case 4:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 12;
        dofs[3] = 13;
          break;
        }
      case 5:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 14;
        dofs[3] = 15;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 6;
        dofs[6] = 7;
        dofs[7] = 8;
        dofs[8] = 9;
        dofs[9] = 16;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 10;
        dofs[6] = 11;
        dofs[7] = 12;
        dofs[8] = 13;
        dofs[9] = 17;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 6;
        dofs[4] = 7;
        dofs[5] = 10;
        dofs[6] = 11;
        dofs[7] = 14;
        dofs[8] = 15;
        dofs[9] = 18;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        dofs[3] = 8;
        dofs[4] = 9;
        dofs[5] = 12;
        dofs[6] = 13;
        dofs[7] = 14;
        dofs[8] = 15;
        dofs[9] = 19;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
      dofs[12] = 12;
      dofs[13] = 13;
      dofs[14] = 14;
      dofs[15] = 15;
      dofs[16] = 16;
      dofs[17] = 17;
      dofs[18] = 18;
      dofs[19] = 19;
        break;
      }
    }
    
}

std::size_t poisson3d_3_dofmap_2::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson3d_3_dofmap_2::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson3d_3_dofmap_2::create() const
{
    return new poisson3d_3_dofmap_2();
}


poisson3d_3_cell_integral_0_otherwise::poisson3d_3_cell_integral_0_otherwise() : ufc::cell_integral()
{

}

poisson3d_3_cell_integral_0_otherwise::~poisson3d_3_cell_integral_0_otherwise()
{

}

const std::vector<bool> & poisson3d_3_cell_integral_0_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({});
return enabled;
}

void poisson3d_3_cell_integral_0_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 4
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 4
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           4
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE8_C0_D001_Q14[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c4 = coordinate_dofs[1] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[7] * FE8_C0_D001_Q14[0][0][1];
    const double J_c8 = coordinate_dofs[2] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[11] * FE8_C0_D001_Q14[0][0][1];
    const double J_c5 = coordinate_dofs[1] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[10] * FE8_C0_D001_Q14[0][0][1];
    const double J_c7 = coordinate_dofs[2] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[8] * FE8_C0_D001_Q14[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[3] * FE8_C0_D001_Q14[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[6] * FE8_C0_D001_Q14[0][0][1];
    const double J_c6 = coordinate_dofs[2] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[5] * FE8_C0_D001_Q14[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[4] * FE8_C0_D001_Q14[0][0][1];
    const double J_c2 = coordinate_dofs[0] * FE8_C0_D001_Q14[0][0][0] + coordinate_dofs[9] * FE8_C0_D001_Q14[0][0][1];
    alignas(32) double sp[80];
    sp[0] = J_c4 * J_c8;
    sp[1] = J_c5 * J_c7;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 * sp[2];
    sp[4] = J_c5 * J_c6;
    sp[5] = J_c3 * J_c8;
    sp[6] = sp[4] + -1 * sp[5];
    sp[7] = J_c1 * sp[6];
    sp[8] = sp[3] + sp[7];
    sp[9] = J_c3 * J_c7;
    sp[10] = J_c4 * J_c6;
    sp[11] = sp[9] + -1 * sp[10];
    sp[12] = J_c2 * sp[11];
    sp[13] = sp[8] + sp[12];
    sp[14] = sp[2] / sp[13];
    sp[15] = J_c3 * (-1 * J_c8);
    sp[16] = sp[4] + sp[15];
    sp[17] = sp[16] / sp[13];
    sp[18] = sp[11] / sp[13];
    sp[19] = sp[14] * sp[14];
    sp[20] = sp[14] * sp[17];
    sp[21] = sp[18] * sp[14];
    sp[22] = sp[17] * sp[17];
    sp[23] = sp[18] * sp[17];
    sp[24] = sp[18] * sp[18];
    sp[25] = J_c2 * J_c7;
    sp[26] = J_c8 * (-1 * J_c1);
    sp[27] = sp[25] + sp[26];
    sp[28] = sp[27] / sp[13];
    sp[29] = J_c0 * J_c8;
    sp[30] = J_c6 * (-1 * J_c2);
    sp[31] = sp[29] + sp[30];
    sp[32] = sp[31] / sp[13];
    sp[33] = J_c1 * J_c6;
    sp[34] = J_c0 * J_c7;
    sp[35] = sp[33] + -1 * sp[34];
    sp[36] = sp[35] / sp[13];
    sp[37] = sp[28] * sp[28];
    sp[38] = sp[28] * sp[32];
    sp[39] = sp[28] * sp[36];
    sp[40] = sp[32] * sp[32];
    sp[41] = sp[32] * sp[36];
    sp[42] = sp[36] * sp[36];
    sp[43] = sp[37] + sp[19];
    sp[44] = sp[38] + sp[20];
    sp[45] = sp[39] + sp[21];
    sp[46] = sp[40] + sp[22];
    sp[47] = sp[41] + sp[23];
    sp[48] = sp[24] + sp[42];
    sp[49] = J_c1 * J_c5;
    sp[50] = J_c2 * J_c4;
    sp[51] = sp[49] + -1 * sp[50];
    sp[52] = sp[51] / sp[13];
    sp[53] = J_c2 * J_c3;
    sp[54] = J_c0 * J_c5;
    sp[55] = sp[53] + -1 * sp[54];
    sp[56] = sp[55] / sp[13];
    sp[57] = J_c0 * J_c4;
    sp[58] = J_c1 * J_c3;
    sp[59] = sp[57] + -1 * sp[58];
    sp[60] = sp[59] / sp[13];
    sp[61] = sp[52] * sp[52];
    sp[62] = sp[52] * sp[56];
    sp[63] = sp[60] * sp[52];
    sp[64] = sp[56] * sp[56];
    sp[65] = sp[60] * sp[56];
    sp[66] = sp[60] * sp[60];
    sp[67] = sp[43] + sp[61];
    sp[68] = sp[44] + sp[62];
    sp[69] = sp[45] + sp[63];
    sp[70] = sp[46] + sp[64];
    sp[71] = sp[47] + sp[65];
    sp[72] = sp[48] + sp[66];
    sp[73] = std::abs(sp[13]);
    sp[74] = sp[67] * sp[73];
    sp[75] = sp[68] * sp[73];
    sp[76] = sp[69] * sp[73];
    sp[77] = sp[70] * sp[73];
    sp[78] = sp[71] * sp[73];
    sp[79] = sp[72] * sp[73];
    A[0] = 0.0595238095238096 * sp[74] + 0.0595238095238096 * sp[75] + 0.05952380952380957 * sp[76] + 0.0595238095238096 * sp[75] + 0.05952380952380957 * sp[77] + 0.05952380952380956 * sp[78] + 0.05952380952380957 * sp[76] + 0.05952380952380956 * sp[78] + 0.05952380952380953 * sp[79];
    A[1] = -0.01130952380952374 * sp[74] + -0.01130952380952375 * sp[75] + -0.01130952380952376 * sp[76];
    A[2] = -0.01130952380952381 * sp[75] + -0.01130952380952372 * sp[77] + -0.01130952380952369 * sp[78];
    A[3] = -0.01130952380952378 * sp[76] + -0.01130952380952376 * sp[78] + -0.01130952380952375 * sp[79];
    A[4] = -0.01339285714285721 * sp[75] + -0.01339285714285725 * sp[76] + -0.01339285714285707 * sp[77] + -0.013392857142857 * sp[78] + -0.01339285714285702 * sp[78] + -0.01339285714285688 * sp[79];
    A[5] = -0.01339285714285708 * sp[75] + -0.01339285714285705 * sp[76] + -0.01339285714285713 * sp[77] + -0.01339285714285715 * sp[78] + -0.01339285714285715 * sp[78] + -0.0133928571428572 * sp[79];
    A[6] = -0.01339285714285705 * sp[74] + -0.01339285714285693 * sp[76] + -0.01339285714285706 * sp[75] + -0.01339285714285699 * sp[78] + -0.01339285714285706 * sp[76] + -0.01339285714285702 * sp[79];
    A[7] = -0.01339285714285706 * sp[74] + -0.01339285714285715 * sp[76] + -0.01339285714285711 * sp[75] + -0.01339285714285719 * sp[78] + -0.01339285714285713 * sp[76] + -0.01339285714285718 * sp[79];
    A[8] = -0.01339285714285686 * sp[74] + -0.01339285714285686 * sp[75] + -0.01339285714285699 * sp[75] + -0.01339285714285691 * sp[77] + -0.013392857142857 * sp[76] + -0.01339285714285695 * sp[78];
    A[9] = -0.01339285714285738 * sp[74] + -0.01339285714285735 * sp[75] + -0.01339285714285712 * sp[75] + -0.01339285714285727 * sp[77] + -0.01339285714285701 * sp[76] + -0.01339285714285717 * sp[78];
    A[10] = -0.0348214285714285 * sp[74] + -0.0348214285714285 * sp[75] + -0.09642857142857156 * sp[76] + -0.03482142857142849 * sp[75] + -0.03482142857142848 * sp[77] + -0.0964285714285715 * sp[78] + -0.03482142857142846 * sp[76] + -0.03482142857142845 * sp[78] + -0.09642857142857147 * sp[79];
    A[11] = 0.01339285714285705 * sp[74] + 0.01339285714285706 * sp[75] + 0.0482142857142858 * sp[76] + 0.01339285714285711 * sp[75] + 0.01339285714285712 * sp[77] + 0.04821428571428574 * sp[78] + 0.01339285714285713 * sp[76] + 0.01339285714285714 * sp[78] + 0.04821428571428574 * sp[79];
    A[12] = -0.03482142857142857 * sp[74] + -0.09642857142857161 * sp[75] + -0.03482142857142849 * sp[76] + -0.03482142857142852 * sp[75] + -0.09642857142857156 * sp[77] + -0.03482142857142844 * sp[78] + -0.03482142857142847 * sp[76] + -0.0964285714285715 * sp[78] + -0.03482142857142839 * sp[79];
    A[13] = 0.01339285714285736 * sp[74] + 0.04821428571428591 * sp[75] + 0.01339285714285725 * sp[76] + 0.0133928571428571 * sp[75] + 0.04821428571428575 * sp[77] + 0.013392857142857 * sp[78] + 0.01339285714285699 * sp[76] + 0.0482142857142857 * sp[78] + 0.01339285714285689 * sp[79];
    A[14] = -0.09642857142857146 * sp[74] + -0.03482142857142843 * sp[75] + -0.03482142857142843 * sp[76] + -0.09642857142857152 * sp[75] + -0.03482142857142853 * sp[77] + -0.03482142857142852 * sp[78] + -0.09642857142857153 * sp[76] + -0.03482142857142851 * sp[78] + -0.0348214285714285 * sp[79];
    A[15] = 0.04821428571428561 * sp[74] + 0.01339285714285693 * sp[75] + 0.01339285714285692 * sp[76] + 0.04821428571428571 * sp[75] + 0.01339285714285698 * sp[77] + 0.01339285714285698 * sp[78] + 0.04821428571428574 * sp[76] + 0.01339285714285702 * sp[78] + 0.01339285714285701 * sp[79];
    A[16] = -0.03214285714285706 * sp[74] + -0.03214285714285694 * sp[75] + -0.03214285714285703 * sp[76] + -0.03214285714285693 * sp[75] + -0.03214285714285696 * sp[77] + -0.0321428571428569 * sp[78] + -0.03214285714285687 * sp[76] + -0.03214285714285693 * sp[78] + -0.03214285714285683 * sp[79];
    A[17] = 0.0321428571428571 * sp[74] + 0.04821428571428573 * sp[75] + 0.04821428571428563 * sp[76] + 0.03214285714285697 * sp[75] + 0.04821428571428556 * sp[77] + 0.04821428571428568 * sp[78] + 0.0321428571428569 * sp[76] + 0.04821428571428549 * sp[78] + 0.04821428571428567 * sp[79];
    A[18] = 0.04821428571428553 * sp[74] + 0.03214285714285693 * sp[75] + 0.0482142857142854 * sp[76] + 0.04821428571428552 * sp[75] + 0.03214285714285695 * sp[77] + 0.04821428571428553 * sp[78] + 0.04821428571428548 * sp[76] + 0.03214285714285692 * sp[78] + 0.04821428571428552 * sp[79];
    A[19] = 0.0482142857142854 * sp[74] + 0.04821428571428554 * sp[75] + 0.03214285714285703 * sp[76] + 0.04821428571428548 * sp[75] + 0.04821428571428556 * sp[77] + 0.0321428571428569 * sp[78] + 0.04821428571428545 * sp[76] + 0.04821428571428545 * sp[78] + 0.03214285714285679 * sp[79];
    A[20] = -0.01130952380952374 * sp[74] + -0.01130952380952375 * sp[75] + -0.01130952380952376 * sp[76];
    A[21] = 0.0595238095238094 * sp[74];
    A[22] = 0.01130952380952381 * sp[75];
    A[23] = 0.01130952380952376 * sp[76];
    A[24] = 0.0133928571428572 * sp[75] + 0.01339285714285716 * sp[76];
    A[25] = 0.01339285714285706 * sp[75] + 0.01339285714285714 * sp[76];
    A[26] = -0.03482142857142873 * sp[74] + 0.06160714285714263 * sp[76];
    A[27] = 0.01339285714285705 * sp[74] + -0.03482142857142861 * sp[76];
    A[28] = -0.0348214285714288 * sp[74] + 0.06160714285714272 * sp[75];
    A[29] = 0.01339285714285727 * sp[74] + -0.03482142857142859 * sp[75];
    A[30] = -0.01339285714285733 * sp[74] + -0.01339285714285731 * sp[75];
    A[31] = -0.01339285714285706 * sp[74] + -0.01339285714285706 * sp[75];
    A[32] = -0.01339285714285718 * sp[74] + -0.01339285714285727 * sp[76];
    A[33] = -0.01339285714285728 * sp[74] + -0.01339285714285718 * sp[76];
    A[34] = 0.04821428571428547 * sp[74] + 0.03482142857142818 * sp[75] + 0.03482142857142816 * sp[76];
    A[35] = -0.09642857142857116 * sp[74] + -0.06160714285714258 * sp[75] + -0.06160714285714255 * sp[76];
    A[36] = 0.03214285714285717 * sp[74] + -0.01607142857142874 * sp[75] + -0.0160714285714287 * sp[76];
    A[37] = -0.0321428571428572 * sp[74];
    A[38] = 0.04821428571428611 * sp[74] + 0.01607142857142878 * sp[75];
    A[39] = 0.04821428571428599 * sp[74] + 0.01607142857142866 * sp[76];
    A[40] = -0.01130952380952381 * sp[75] + -0.01130952380952372 * sp[77] + -0.01130952380952369 * sp[78];
    A[41] = 0.01130952380952381 * sp[75];
    A[42] = 0.0595238095238094 * sp[77];
    A[43] = 0.0113095238095238 * sp[78];
    A[44] = -0.03482142857142888 * sp[77] + 0.06160714285714244 * sp[78];
    A[45] = 0.01339285714285712 * sp[77] + -0.03482142857142877 * sp[78];
    A[46] = 0.01339285714285721 * sp[75] + 0.01339285714285716 * sp[78];
    A[47] = 0.0133928571428571 * sp[75] + 0.01339285714285714 * sp[78];
    A[48] = -0.03482142857142863 * sp[75] + 0.01339285714285721 * sp[77];
    A[49] = 0.06160714285714275 * sp[75] + -0.03482142857142873 * sp[77];
    A[50] = -0.01339285714285723 * sp[75] + -0.01339285714285719 * sp[77];
    A[51] = -0.01339285714285711 * sp[75] + -0.01339285714285712 * sp[77];
    A[52] = 0.03482142857142857 * sp[75] + 0.04821428571428555 * sp[77] + 0.03482142857142828 * sp[78];
    A[53] = -0.06160714285714276 * sp[75] + -0.09642857142857129 * sp[77] + -0.06160714285714256 * sp[78];
    A[54] = -0.01339285714285727 * sp[77] + -0.01339285714285724 * sp[78];
    A[55] = -0.01339285714285721 * sp[77] + -0.01339285714285714 * sp[78];
    A[56] = -0.01607142857142897 * sp[75] + 0.03214285714285721 * sp[77] + -0.01607142857142856 * sp[78];
    A[57] = 0.01607142857142898 * sp[75] + 0.04821428571428603 * sp[77];
    A[58] = -0.03214285714285714 * sp[77];
    A[59] = 0.04821428571428613 * sp[77] + 0.01607142857142872 * sp[78];
    A[60] = -0.01130952380952378 * sp[76] + -0.01130952380952376 * sp[78] + -0.01130952380952375 * sp[79];
    A[61] = 0.01130952380952376 * sp[76];
    A[62] = 0.0113095238095238 * sp[78];
    A[63] = 0.05952380952380943 * sp[79];
    A[64] = -0.03482142857142868 * sp[78] + 0.01339285714285706 * sp[79];
    A[65] = 0.06160714285714288 * sp[78] + -0.03482142857142859 * sp[79];
    A[66] = -0.03482142857142861 * sp[76] + 0.01339285714285705 * sp[79];
    A[67] = 0.06160714285714278 * sp[76] + -0.0348214285714285 * sp[79];
    A[68] = 0.01339285714285702 * sp[76] + 0.01339285714285706 * sp[78];
    A[69] = 0.01339285714285708 * sp[76] + 0.01339285714285705 * sp[78];
    A[70] = 0.03482142857142861 * sp[76] + 0.03482142857142865 * sp[78] + 0.04821428571428571 * sp[79];
    A[71] = -0.06160714285714282 * sp[76] + -0.06160714285714288 * sp[78] + -0.09642857142857142 * sp[79];
    A[72] = -0.01339285714285698 * sp[76] + -0.01339285714285703 * sp[79];
    A[73] = -0.01339285714285709 * sp[76] + -0.01339285714285703 * sp[79];
    A[74] = -0.01339285714285713 * sp[78] + -0.01339285714285713 * sp[79];
    A[75] = -0.01339285714285705 * sp[78] + -0.01339285714285703 * sp[79];
    A[76] = -0.01607142857142889 * sp[76] + -0.01607142857142889 * sp[78] + 0.03214285714285673 * sp[79];
    A[77] = 0.01607142857142889 * sp[76] + 0.04821428571428553 * sp[79];
    A[78] = 0.01607142857142885 * sp[78] + 0.04821428571428579 * sp[79];
    A[79] = -0.03214285714285672 * sp[79];
    A[80] = -0.01339285714285721 * sp[75] + -0.01339285714285707 * sp[77] + -0.01339285714285702 * sp[78] + -0.01339285714285725 * sp[76] + -0.013392857142857 * sp[78] + -0.01339285714285688 * sp[79];
    A[81] = 0.0133928571428572 * sp[75] + 0.01339285714285716 * sp[76];
    A[82] = -0.03482142857142888 * sp[77] + 0.06160714285714244 * sp[78];
    A[83] = -0.03482142857142868 * sp[78] + 0.01339285714285706 * sp[79];
    A[84] = 0.2410714285714282 * sp[77] + 0.09642857142857093 * sp[78] + 0.09642857142857093 * sp[78] + 0.1928571428571421 * sp[79];
    A[85] = -0.07232142857142833 * sp[77] + 0.07232142857142854 * sp[78] + -0.0241071428571428 * sp[78] + -0.07232142857142901 * sp[79];
    A[86] = -0.04821428571428567 * sp[75] + -0.02410714285714298 * sp[78] + -0.02410714285714273 * sp[76] + -0.02410714285714304 * sp[79];
    A[87] = -0.07232142857142823 * sp[75] + -0.04821428571428539 * sp[78] + -0.02410714285714276 * sp[76] + -0.02410714285714264 * sp[79];
    A[88] = -0.04821428571428601 * sp[75] + -0.02410714285714285 * sp[77] + -0.07232142857142869 * sp[76] + -0.0241071428571428 * sp[78];
    A[89] = 0.09642857142857146 * sp[75] + 0.1205357142857141 * sp[77] + 0.192857142857143 * sp[76] + 0.09642857142857154 * sp[78];
    A[90] = 0.04821428571428593 * sp[75] + 0.04821428571428581 * sp[77] + 0.02410714285714264 * sp[78] + 0.02410714285714276 * sp[76] + 0.02410714285714271 * sp[78];
    A[91] = 0.07232142857142829 * sp[75] + 0.07232142857142834 * sp[77] + 0.02410714285714284 * sp[78] + 0.02410714285714278 * sp[76] + 0.0241071428571428 * sp[78];
    A[92] = 0.04821428571428602 * sp[75] + 0.02410714285714262 * sp[77] + 0.04821428571428549 * sp[78] + 0.07232142857142881 * sp[76] + 0.04821428571428525 * sp[78] + 0.07232142857142793 * sp[79];
    A[93] = -0.09642857142857145 * sp[75] + 0.02410714285714307 * sp[77] + -0.09642857142857097 * sp[78] + -0.1928571428571429 * sp[76] + -0.09642857142857102 * sp[78] + -0.1928571428571423 * sp[79];
    A[94] = 0.02410714285714303 * sp[77] + 0.02410714285714312 * sp[78] + 0.02410714285714276 * sp[78] + 0.02410714285714291 * sp[79];
    A[95] = 0.02410714285714266 * sp[77] + 0.02410714285714296 * sp[78] + 0.02410714285714258 * sp[78] + 0.02410714285714296 * sp[79];
    A[96] = 0.2410714285714285 * sp[75] + -0.04821428571428546 * sp[77] + 0.1205357142857144 * sp[78] + 0.09642857142857134 * sp[76] + -0.02410714285714229 * sp[78] + 0.09642857142857245 * sp[79];
    A[97] = -0.2410714285714286 * sp[75] + -0.2892857142857141 * sp[77] + -0.1205357142857145 * sp[78] + -0.09642857142857138 * sp[76] + -0.1205357142857138 * sp[78];
    A[98] = 0.04821428571428568 * sp[77] + 0.02410714285714251 * sp[78] + 0.02410714285714255 * sp[78];
    A[99] = -0.1446428571428569 * sp[77] + -0.1205357142857142 * sp[78] + -0.1205357142857138 * sp[78] + -0.096428571428572 * sp[79];
    A[100] = -0.01339285714285708 * sp[75] + -0.01339285714285713 * sp[77] + -0.01339285714285715 * sp[78] + -0.01339285714285705 * sp[76] + -0.01339285714285715 * sp[78] + -0.0133928571428572 * sp[79];
    A[101] = 0.01339285714285706 * sp[75] + 0.01339285714285714 * sp[76];
    A[102] = 0.01339285714285712 * sp[77] + -0.03482142857142877 * sp[78];
    A[103] = 0.06160714285714288 * sp[78] + -0.03482142857142859 * sp[79];
    A[104] = -0.07232142857142833 * sp[77] + -0.0241071428571428 * sp[78] + 0.07232142857142854 * sp[78] + -0.07232142857142901 * sp[79];
    A[105] = 0.1928571428571427 * sp[77] + 0.09642857142857107 * sp[78] + 0.09642857142857107 * sp[78] + 0.2410714285714282 * sp[79];
    A[106] = -0.0723214285714283 * sp[75] + -0.02410714285714274 * sp[78] + -0.04821428571428533 * sp[76] + -0.02410714285714241 * sp[79];
    A[107] = 0.1928571428571425 * sp[75] + 0.09642857142857142 * sp[78] + 0.09642857142857097 * sp[76] + 0.120535714285714 * sp[79];
    A[108] = -0.0241071428571429 * sp[75] + -0.0241071428571429 * sp[77] + -0.04821428571428556 * sp[76] + -0.02410714285714263 * sp[78];
    A[109] = -0.02410714285714288 * sp[75] + -0.02410714285714288 * sp[77] + -0.07232142857142911 * sp[76] + -0.04821428571428615 * sp[78];
    A[110] = 0.07232142857142849 * sp[75] + 0.07232142857142858 * sp[77] + 0.04821428571428568 * sp[78] + 0.04821428571428553 * sp[76] + 0.04821428571428556 * sp[78] + 0.02410714285714296 * sp[79];
    A[111] = -0.1928571428571426 * sp[75] + -0.1928571428571427 * sp[77] + -0.09642857142857145 * sp[78] + -0.09642857142857104 * sp[76] + -0.09642857142857103 * sp[78] + 0.02410714285714276 * sp[79];
    A[112] = 0.02410714285714297 * sp[75] + 0.024107142857143 * sp[78] + 0.0482142857142855 * sp[76] + 0.02410714285714292 * sp[78] + 0.04821428571428567 * sp[79];
    A[113] = 0.02410714285714289 * sp[75] + 0.02410714285714295 * sp[78] + 0.07232142857142915 * sp[76] + 0.02410714285714306 * sp[78] + 0.07232142857142917 * sp[79];
    A[114] = 0.02410714285714303 * sp[77] + 0.02410714285714295 * sp[78] + 0.02410714285714307 * sp[78] + 0.02410714285714295 * sp[79];
    A[115] = 0.02410714285714288 * sp[77] + 0.02410714285714266 * sp[78] + 0.02410714285714262 * sp[78] + 0.02410714285714237 * sp[79];
    A[116] = 0.09642857142857138 * sp[75] + 0.09642857142857136 * sp[77] + -0.0241071428571429 * sp[78] + 0.2410714285714277 * sp[76] + 0.1205357142857139 * sp[78] + -0.04821428571428638 * sp[79];
    A[117] = -0.09642857142857147 * sp[75] + -0.1205357142857145 * sp[78] + -0.2410714285714279 * sp[76] + -0.1205357142857141 * sp[78] + -0.2892857142857141 * sp[79];
    A[118] = -0.09642857142857154 * sp[77] + -0.1205357142857141 * sp[78] + -0.1205357142857139 * sp[78] + -0.1446428571428569 * sp[79];
    A[119] = 0.02410714285714293 * sp[78] + 0.02410714285714309 * sp[78] + 0.04821428571428633 * sp[79];
    A[120] = -0.01339285714285705 * sp[74] + -0.01339285714285706 * sp[75] + -0.01339285714285706 * sp[76] + -0.01339285714285693 * sp[76] + -0.01339285714285699 * sp[78] + -0.01339285714285702 * sp[79];
    A[121] = -0.03482142857142873 * sp[74] + 0.06160714285714263 * sp[76];
    A[122] = 0.01339285714285721 * sp[75] + 0.01339285714285716 * sp[78];
    A[123] = -0.03482142857142861 * sp[76] + 0.01339285714285705 * sp[79];
    A[124] = -0.04821428571428567 * sp[75] + -0.02410714285714273 * sp[76] + -0.02410714285714298 * sp[78] + -0.02410714285714304 * sp[79];
    A[125] = -0.0723214285714283 * sp[75] + -0.04821428571428533 * sp[76] + -0.02410714285714274 * sp[78] + -0.02410714285714241 * sp[79];
    A[126] = 0.2410714285714283 * sp[74] + 0.09642857142857177 * sp[76] + 0.09642857142857177 * sp[76] + 0.1928571428571436 * sp[79];
    A[127] = -0.07232142857142826 * sp[74] + 0.07232142857142845 * sp[76] + -0.02410714285714275 * sp[76] + -0.07232142857142868 * sp[79];
    A[128] = 0.1205357142857143 * sp[74] + 0.09642857142857149 * sp[75] + 0.09642857142857196 * sp[76] + 0.1928571428571435 * sp[78];
    A[129] = -0.02410714285714289 * sp[74] + -0.0482142857142856 * sp[75] + -0.02410714285714312 * sp[76] + -0.07232142857142879 * sp[78];
    A[130] = 0.04821428571428587 * sp[74] + 0.04821428571428589 * sp[75] + 0.02410714285714288 * sp[76] + 0.02410714285714286 * sp[76] + 0.02410714285714294 * sp[78];
    A[131] = 0.07232142857142829 * sp[74] + 0.07232142857142834 * sp[75] + 0.02410714285714283 * sp[76] + 0.02410714285714277 * sp[76] + 0.02410714285714277 * sp[78];
    A[132] = 0.0241071428571429 * sp[74] + 0.02410714285714312 * sp[76] + 0.02410714285714274 * sp[76] + 0.02410714285714292 * sp[79];
    A[133] = 0.02410714285714289 * sp[74] + 0.02410714285714284 * sp[76] + 0.02410714285714312 * sp[76] + 0.02410714285714313 * sp[79];
    A[134] = 0.02410714285714226 * sp[74] + 0.04821428571428532 * sp[75] + 0.04821428571428527 * sp[76] + 0.04821428571428497 * sp[76] + 0.07232142857142797 * sp[78] + 0.07232142857142788 * sp[79];
    A[135] = 0.0241071428571435 * sp[74] + -0.09642857142857111 * sp[75] + -0.0964285714285711 * sp[76] + -0.09642857142857068 * sp[76] + -0.1928571428571429 * sp[78] + -0.1928571428571429 * sp[79];
    A[136] = -0.04821428571428534 * sp[74] + 0.2410714285714292 * sp[75] + 0.1205357142857146 * sp[76] + -0.0241071428571424 * sp[76] + 0.09642857142857261 * sp[78] + 0.09642857142857217 * sp[79];
    A[137] = 0.0482142857142854 * sp[74] + 0.02410714285714247 * sp[76] + 0.02410714285714241 * sp[76];
    A[138] = -0.2892857142857143 * sp[74] + -0.2410714285714289 * sp[75] + -0.1205357142857143 * sp[76] + -0.1205357142857147 * sp[76] + -0.09642857142857249 * sp[78];
    A[139] = -0.1446428571428572 * sp[74] + -0.1205357142857145 * sp[76] + -0.1205357142857147 * sp[76] + -0.09642857142857225 * sp[79];
    A[140] = -0.01339285714285706 * sp[74] + -0.01339285714285711 * sp[75] + -0.01339285714285713 * sp[76] + -0.01339285714285715 * sp[76] + -0.01339285714285719 * sp[78] + -0.01339285714285718 * sp[79];
    A[141] = 0.01339285714285705 * sp[74] + -0.03482142857142861 * sp[76];
    A[142] = 0.0133928571428571 * sp[75] + 0.01339285714285714 * sp[78];
    A[143] = 0.06160714285714278 * sp[76] + -0.0348214285714285 * sp[79];
    A[144] = -0.07232142857142823 * sp[75] + -0.02410714285714276 * sp[76] + -0.04821428571428539 * sp[78] + -0.02410714285714264 * sp[79];
    A[145] = 0.1928571428571425 * sp[75] + 0.09642857142857097 * sp[76] + 0.09642857142857142 * sp[78] + 0.120535714285714 * sp[79];
    A[146] = -0.07232142857142826 * sp[74] + -0.02410714285714275 * sp[76] + 0.07232142857142845 * sp[76] + -0.07232142857142868 * sp[79];
    A[147] = 0.1928571428571423 * sp[74] + 0.09642857142857134 * sp[76] + 0.09642857142857134 * sp[76] + 0.2410714285714285 * sp[79];
    A[148] = -0.02410714285714291 * sp[74] + -0.0241071428571429 * sp[75] + -0.04821428571428601 * sp[76] + -0.07232142857142895 * sp[78];
    A[149] = -0.02410714285714284 * sp[74] + -0.02410714285714284 * sp[75] + -0.0241071428571427 * sp[76] + -0.04821428571428549 * sp[78];
    A[150] = 0.07232142857142843 * sp[74] + 0.07232142857142852 * sp[75] + 0.04821428571428561 * sp[76] + 0.0482142857142855 * sp[76] + 0.04821428571428556 * sp[78] + 0.02410714285714262 * sp[79];
    A[151] = -0.1928571428571424 * sp[74] + -0.1928571428571424 * sp[75] + -0.09642857142857132 * sp[76] + -0.09642857142857139 * sp[76] + -0.09642857142857138 * sp[78] + 0.02410714285714298 * sp[79];
    A[152] = 0.02410714285714297 * sp[74] + 0.02410714285714299 * sp[76] + 0.02410714285714293 * sp[76] + 0.02410714285714297 * sp[79];
    A[153] = 0.02410714285714286 * sp[74] + 0.02410714285714291 * sp[76] + 0.02410714285714271 * sp[76] + 0.02410714285714276 * sp[79];
    A[154] = 0.02410714285714303 * sp[75] + 0.02410714285714296 * sp[76] + 0.02410714285714292 * sp[76] + 0.0482142857142859 * sp[78] + 0.04821428571428586 * sp[79];
    A[155] = 0.02410714285714288 * sp[75] + 0.02410714285714266 * sp[76] + 0.0241071428571428 * sp[76] + 0.07232142857142888 * sp[78] + 0.07232142857142862 * sp[79];
    A[156] = 0.09642857142857127 * sp[74] + 0.09642857142857117 * sp[75] + -0.02410714285714294 * sp[76] + 0.1205357142857145 * sp[76] + 0.2410714285714286 * sp[78] + -0.04821428571428565 * sp[79];
    A[157] = -0.09642857142857138 * sp[74] + -0.1205357142857143 * sp[76] + -0.1205357142857146 * sp[76] + -0.1446428571428573 * sp[79];
    A[158] = -0.09642857142857138 * sp[75] + -0.120535714285714 * sp[76] + -0.1205357142857139 * sp[76] + -0.2410714285714287 * sp[78] + -0.2892857142857143 * sp[79];
    A[159] = 0.02410714285714297 * sp[76] + 0.02410714285714306 * sp[76] + 0.04821428571428579 * sp[79];
    A[160] = -0.01339285714285686 * sp[74] + -0.01339285714285699 * sp[75] + -0.013392857142857 * sp[76] + -0.01339285714285686 * sp[75] + -0.01339285714285691 * sp[77] + -0.01339285714285695 * sp[78];
    A[161] = -0.0348214285714288 * sp[74] + 0.06160714285714272 * sp[75];
    A[162] = -0.03482142857142863 * sp[75] + 0.01339285714285721 * sp[77];
    A[163] = 0.01339285714285702 * sp[76] + 0.01339285714285706 * sp[78];
    A[164] = -0.04821428571428601 * sp[75] + -0.07232142857142869 * sp[76] + -0.02410714285714285 * sp[77] + -0.0241071428571428 * sp[78];
    A[165] = -0.0241071428571429 * sp[75] + -0.04821428571428556 * sp[76] + -0.0241071428571429 * sp[77] + -0.02410714285714263 * sp[78];
    A[166] = 0.1205357142857143 * sp[74] + 0.09642857142857196 * sp[76] + 0.09642857142857149 * sp[75] + 0.1928571428571435 * sp[78];
    A[167] = -0.02410714285714291 * sp[74] + -0.04821428571428601 * sp[76] + -0.0241071428571429 * sp[75] + -0.07232142857142895 * sp[78];
    A[168] = 0.2410714285714289 * sp[74] + 0.09642857142857167 * sp[75] + 0.09642857142857167 * sp[75] + 0.1928571428571435 * sp[77];
    A[169] = -0.07232142857142915 * sp[74] + 0.07232142857142841 * sp[75] + -0.02410714285714288 * sp[75] + -0.07232142857142874 * sp[77];
    A[170] = 0.02410714285714294 * sp[74] + 0.02410714285714299 * sp[75] + 0.02410714285714274 * sp[75] + 0.02410714285714282 * sp[77];
    A[171] = 0.02410714285714294 * sp[74] + 0.02410714285714293 * sp[75] + 0.02410714285714292 * sp[75] + 0.02410714285714292 * sp[77];
    A[172] = 0.04821428571428529 * sp[74] + 0.0241071428571429 * sp[75] + 0.04821428571428574 * sp[76] + 0.02410714285714267 * sp[75] + 0.02410714285714286 * sp[78];
    A[173] = 0.07232142857142916 * sp[74] + 0.02410714285714272 * sp[75] + 0.07232142857142893 * sp[76] + 0.02410714285714289 * sp[75] + 0.02410714285714289 * sp[78];
    A[174] = 0.02410714285714232 * sp[74] + 0.0482142857142853 * sp[75] + 0.04821428571428525 * sp[76] + 0.0482142857142849 * sp[75] + 0.07232142857142793 * sp[77] + 0.07232142857142783 * sp[78];
    A[175] = 0.02410714285714336 * sp[74] + -0.09642857142857134 * sp[75] + -0.09642857142857125 * sp[76] + -0.09642857142857079 * sp[75] + -0.1928571428571429 * sp[77] + -0.1928571428571428 * sp[78];
    A[176] = -0.04821428571428631 * sp[74] + 0.1205357142857142 * sp[75] + 0.2410714285714282 * sp[76] + -0.02410714285714258 * sp[75] + 0.09642857142857204 * sp[77] + 0.09642857142857193 * sp[78];
    A[177] = 0.04821428571428633 * sp[74] + 0.02410714285714301 * sp[75] + 0.02410714285714259 * sp[75];
    A[178] = -0.1446428571428574 * sp[74] + -0.1205357142857141 * sp[75] + -0.1205357142857143 * sp[75] + -0.09642857142857188 * sp[77];
    A[179] = -0.2892857142857143 * sp[74] + -0.120535714285714 * sp[75] + -0.2410714285714283 * sp[76] + -0.1205357142857144 * sp[75] + -0.096428571428572 * sp[78];
    A[180] = -0.01339285714285738 * sp[74] + -0.01339285714285712 * sp[75] + -0.01339285714285701 * sp[76] + -0.01339285714285735 * sp[75] + -0.01339285714285727 * sp[77] + -0.01339285714285717 * sp[78];
    A[181] = 0.01339285714285727 * sp[74] + -0.03482142857142859 * sp[75];
    A[182] = 0.06160714285714275 * sp[75] + -0.03482142857142873 * sp[77];
    A[183] = 0.01339285714285708 * sp[76] + 0.01339285714285705 * sp[78];
    A[184] = 0.09642857142857146 * sp[75] + 0.192857142857143 * sp[76] + 0.1205357142857141 * sp[77] + 0.09642857142857154 * sp[78];
    A[185] = -0.02410714285714288 * sp[75] + -0.07232142857142911 * sp[76] + -0.02410714285714288 * sp[77] + -0.04821428571428615 * sp[78];
    A[186] = -0.02410714285714289 * sp[74] + -0.02410714285714312 * sp[76] + -0.0482142857142856 * sp[75] + -0.07232142857142879 * sp[78];
    A[187] = -0.02410714285714284 * sp[74] + -0.0241071428571427 * sp[76] + -0.02410714285714284 * sp[75] + -0.04821428571428549 * sp[78];
    A[188] = -0.07232142857142915 * sp[74] + -0.02410714285714288 * sp[75] + 0.07232142857142841 * sp[75] + -0.07232142857142874 * sp[77];
    A[189] = 0.1928571428571438 * sp[74] + 0.09642857142857184 * sp[75] + 0.09642857142857184 * sp[75] + 0.2410714285714289 * sp[77];
    A[190] = 0.02410714285714292 * sp[74] + 0.02410714285714288 * sp[75] + 0.02410714285714311 * sp[75] + 0.02410714285714302 * sp[77];
    A[191] = 0.02410714285714286 * sp[74] + 0.02410714285714288 * sp[75] + 0.02410714285714286 * sp[75] + 0.02410714285714288 * sp[77];
    A[192] = 0.07232142857142924 * sp[74] + 0.04821428571428563 * sp[75] + 0.07232142857142837 * sp[76] + 0.04821428571428608 * sp[75] + 0.02410714285714296 * sp[77] + 0.04821428571428564 * sp[78];
    A[193] = -0.1928571428571438 * sp[74] + -0.09642857142857157 * sp[75] + -0.1928571428571431 * sp[76] + -0.09642857142857179 * sp[75] + 0.0241071428571427 * sp[77] + -0.09642857142857145 * sp[78];
    A[194] = 0.02410714285714289 * sp[75] + 0.02410714285714305 * sp[76] + 0.0241071428571431 * sp[75] + 0.04821428571428593 * sp[77] + 0.04821428571428606 * sp[78];
    A[195] = 0.02410714285714267 * sp[75] + 0.02410714285714305 * sp[76] + 0.02410714285714292 * sp[75] + 0.07232142857142838 * sp[77] + 0.07232142857142872 * sp[78];
    A[196] = 0.09642857142857188 * sp[74] + -0.0241071428571424 * sp[75] + 0.09642857142857265 * sp[76] + 0.1205357142857142 * sp[75] + -0.04821428571428556 * sp[77] + 0.2410714285714293 * sp[78];
    A[197] = -0.09642857142857193 * sp[74] + -0.1205357142857145 * sp[75] + -0.1205357142857143 * sp[75] + -0.1446428571428574 * sp[77];
    A[198] = 0.02410714285714267 * sp[75] + 0.02410714285714251 * sp[75] + 0.04821428571428575 * sp[77];
    A[199] = -0.1205357142857142 * sp[75] + -0.09642857142857221 * sp[76] + -0.1205357142857144 * sp[75] + -0.2892857142857143 * sp[77] + -0.241071428571429 * sp[78];
    A[200] = -0.0348214285714285 * sp[74] + -0.03482142857142849 * sp[75] + -0.03482142857142846 * sp[76] + -0.0348214285714285 * sp[75] + -0.03482142857142848 * sp[77] + -0.03482142857142845 * sp[78] + -0.09642857142857156 * sp[76] + -0.0964285714285715 * sp[78] + -0.09642857142857147 * sp[79];
    A[201] = -0.01339285714285733 * sp[74] + -0.01339285714285731 * sp[75];
    A[202] = -0.01339285714285723 * sp[75] + -0.01339285714285719 * sp[77];
    A[203] = 0.03482142857142861 * sp[76] + 0.03482142857142865 * sp[78] + 0.04821428571428571 * sp[79];
    A[204] = 0.04821428571428593 * sp[75] + 0.02410714285714276 * sp[76] + 0.04821428571428581 * sp[77] + 0.02410714285714271 * sp[78] + 0.02410714285714264 * sp[78];
    A[205] = 0.07232142857142849 * sp[75] + 0.04821428571428553 * sp[76] + 0.07232142857142858 * sp[77] + 0.04821428571428556 * sp[78] + 0.04821428571428568 * sp[78] + 0.02410714285714296 * sp[79];
    A[206] = 0.04821428571428587 * sp[74] + 0.02410714285714286 * sp[76] + 0.04821428571428589 * sp[75] + 0.02410714285714294 * sp[78] + 0.02410714285714288 * sp[76];
    A[207] = 0.07232142857142843 * sp[74] + 0.0482142857142855 * sp[76] + 0.07232142857142852 * sp[75] + 0.04821428571428556 * sp[78] + 0.04821428571428561 * sp[76] + 0.02410714285714262 * sp[79];
    A[208] = 0.02410714285714294 * sp[74] + 0.02410714285714274 * sp[75] + 0.02410714285714299 * sp[75] + 0.02410714285714282 * sp[77];
    A[209] = 0.02410714285714292 * sp[74] + 0.02410714285714311 * sp[75] + 0.02410714285714288 * sp[75] + 0.02410714285714302 * sp[77];
    A[210] = 0.2410714285714285 * sp[74] + 0.2410714285714284 * sp[75] + 0.1446428571428567 * sp[76] + 0.2410714285714284 * sp[75] + 0.2410714285714285 * sp[77] + 0.1446428571428567 * sp[78] + 0.1446428571428567 * sp[76] + 0.1446428571428567 * sp[78] + 0.2410714285714285 * sp[79];
    A[211] = -0.07232142857142838 * sp[74] + -0.07232142857142843 * sp[75] + -0.1446428571428566 * sp[76] + -0.07232142857142847 * sp[75] + -0.07232142857142852 * sp[77] + -0.1446428571428566 * sp[78] + -0.0482142857142856 * sp[76] + -0.04821428571428565 * sp[78] + -0.1928571428571428 * sp[79];
    A[212] = 0.1205357142857144 * sp[74] + 0.02410714285714268 * sp[75] + 0.1205357142857142 * sp[76] + 0.1205357142857144 * sp[75] + 0.02410714285714267 * sp[77] + 0.1205357142857143 * sp[78] + 0.02410714285714257 * sp[76] + 0.1205357142857144 * sp[78] + 0.02410714285714255 * sp[79];
    A[213] = -0.02410714285714286 * sp[74] + 0.02410714285714315 * sp[75] + -0.0241071428571428 * sp[76] + -0.02410714285714281 * sp[75] + 0.02410714285714313 * sp[77] + -0.02410714285714275 * sp[78] + -0.02410714285714284 * sp[78];
    A[214] = 0.02410714285714251 * sp[74] + 0.1205357142857142 * sp[75] + 0.1205357142857142 * sp[76] + 0.02410714285714252 * sp[75] + 0.1205357142857143 * sp[77] + 0.1205357142857143 * sp[78] + 0.1205357142857145 * sp[76] + 0.02410714285714261 * sp[78] + 0.0241071428571426 * sp[79];
    A[215] = 0.02410714285714342 * sp[74] + -0.02410714285714266 * sp[75] + -0.02410714285714271 * sp[76] + 0.02410714285714342 * sp[75] + -0.02410714285714274 * sp[77] + -0.02410714285714278 * sp[78] + -0.02410714285714299 * sp[76];
    A[216] = 0.04821428571428564 * sp[74] + 0.0482142857142854 * sp[75] + 0.02410714285714299 * sp[76] + 0.04821428571428562 * sp[75] + 0.04821428571428553 * sp[77] + 0.02410714285714298 * sp[78] + 0.0241071428571424 * sp[76] + 0.02410714285714255 * sp[78];
    A[217] = -0.04821428571428572 * sp[74] + -0.2892857142857143 * sp[75] + -0.16875 * sp[76] + -0.04821428571428568 * sp[75] + -0.2892857142857142 * sp[77] + -0.16875 * sp[78] + -0.02410714285714247 * sp[76] + -0.1687499999999992 * sp[78] + -0.04821428571428556 * sp[79];
    A[218] = -0.2892857142857143 * sp[74] + -0.04821428571428572 * sp[75] + -0.1687499999999998 * sp[76] + -0.2892857142857143 * sp[75] + -0.04821428571428583 * sp[77] + -0.1687499999999999 * sp[78] + -0.1687499999999995 * sp[76] + -0.02410714285714269 * sp[78] + -0.04821428571428475 * sp[79];
    A[219] = -0.1446428571428572 * sp[74] + -0.1446428571428573 * sp[75] + -0.02410714285714296 * sp[76] + -0.1446428571428573 * sp[75] + -0.1446428571428572 * sp[77] + -0.02410714285714294 * sp[78] + -0.0241071428571427 * sp[76] + -0.02410714285714222 * sp[78];
    A[220] = 0.01339285714285705 * sp[74] + 0.01339285714285711 * sp[75] + 0.01339285714285713 * sp[76] + 0.01339285714285706 * sp[75] + 0.01339285714285712 * sp[77] + 0.01339285714285714 * sp[78] + 0.0482142857142858 * sp[76] + 0.04821428571428574 * sp[78] + 0.04821428571428574 * sp[79];
    A[221] = -0.01339285714285706 * sp[74] + -0.01339285714285706 * sp[75];
    A[222] = -0.01339285714285711 * sp[75] + -0.01339285714285712 * sp[77];
    A[223] = -0.06160714285714282 * sp[76] + -0.06160714285714288 * sp[78] + -0.09642857142857142 * sp[79];
    A[224] = 0.07232142857142829 * sp[75] + 0.02410714285714278 * sp[76] + 0.07232142857142834 * sp[77] + 0.0241071428571428 * sp[78] + 0.02410714285714284 * sp[78];
    A[225] = -0.1928571428571426 * sp[75] + -0.09642857142857104 * sp[76] + -0.1928571428571427 * sp[77] + -0.09642857142857103 * sp[78] + -0.09642857142857145 * sp[78] + 0.02410714285714276 * sp[79];
    A[226] = 0.07232142857142829 * sp[74] + 0.02410714285714277 * sp[76] + 0.07232142857142834 * sp[75] + 0.02410714285714277 * sp[78] + 0.02410714285714283 * sp[76];
    A[227] = -0.1928571428571424 * sp[74] + -0.09642857142857139 * sp[76] + -0.1928571428571424 * sp[75] + -0.09642857142857138 * sp[78] + -0.09642857142857132 * sp[76] + 0.02410714285714298 * sp[79];
    A[228] = 0.02410714285714294 * sp[74] + 0.02410714285714292 * sp[75] + 0.02410714285714293 * sp[75] + 0.02410714285714292 * sp[77];
    A[229] = 0.02410714285714286 * sp[74] + 0.02410714285714286 * sp[75] + 0.02410714285714288 * sp[75] + 0.02410714285714288 * sp[77];
    A[230] = -0.07232142857142838 * sp[74] + -0.07232142857142847 * sp[75] + -0.0482142857142856 * sp[76] + -0.07232142857142843 * sp[75] + -0.07232142857142852 * sp[77] + -0.04821428571428565 * sp[78] + -0.1446428571428566 * sp[76] + -0.1446428571428566 * sp[78] + -0.1928571428571428 * sp[79];
    A[231] = 0.1928571428571424 * sp[74] + 0.1928571428571426 * sp[75] + 0.09642857142857134 * sp[76] + 0.1928571428571426 * sp[75] + 0.1928571428571426 * sp[77] + 0.09642857142857142 * sp[78] + 0.09642857142857134 * sp[76] + 0.09642857142857142 * sp[78] + 0.2410714285714283 * sp[79];
    A[232] = -0.02410714285714293 * sp[74] + -0.02410714285714297 * sp[76] + -0.02410714285714293 * sp[75] + -0.02410714285714296 * sp[78] + 0.02410714285714313 * sp[76] + -0.02410714285714299 * sp[78] + 0.02410714285714313 * sp[79];
    A[233] = -0.02410714285714288 * sp[74] + -0.02410714285714293 * sp[76] + -0.02410714285714288 * sp[75] + -0.02410714285714295 * sp[78] + -0.02410714285714271 * sp[78];
    A[234] = -0.024107142857143 * sp[75] + -0.02410714285714292 * sp[76] + -0.02410714285714299 * sp[77] + -0.02410714285714291 * sp[78] + -0.02410714285714298 * sp[76] + 0.02410714285714328 * sp[78] + 0.02410714285714328 * sp[79];
    A[235] = -0.0241071428571429 * sp[75] + -0.02410714285714268 * sp[76] + -0.02410714285714291 * sp[77] + -0.02410714285714268 * sp[78] + -0.02410714285714274 * sp[76];
    A[236] = -0.09642857142857136 * sp[74] + -0.09642857142857127 * sp[75] + 0.02410714285714294 * sp[76] + -0.09642857142857132 * sp[75] + -0.09642857142857128 * sp[77] + 0.02410714285714295 * sp[78] + 0.02410714285714259 * sp[76] + 0.02410714285714274 * sp[78];
    A[237] = 0.09642857142857142 * sp[74] + 0.1205357142857144 * sp[76] + 0.09642857142857143 * sp[75] + 0.1205357142857144 * sp[78] + -0.02410714285714255 * sp[76] + 0.1205357142857136 * sp[78] + -0.04821428571428583 * sp[79];
    A[238] = 0.09642857142857143 * sp[75] + 0.120535714285714 * sp[76] + 0.09642857142857145 * sp[77] + 0.120535714285714 * sp[78] + 0.1205357142857137 * sp[76] + -0.02410714285714258 * sp[78] + -0.04821428571428671 * sp[79];
    A[239] = -0.02410714285714297 * sp[76] + -0.02410714285714298 * sp[78] + -0.02410714285714307 * sp[76] + -0.02410714285714335 * sp[78];
    A[240] = -0.03482142857142857 * sp[74] + -0.03482142857142852 * sp[75] + -0.03482142857142847 * sp[76] + -0.09642857142857161 * sp[75] + -0.09642857142857156 * sp[77] + -0.0964285714285715 * sp[78] + -0.03482142857142849 * sp[76] + -0.03482142857142844 * sp[78] + -0.03482142857142839 * sp[79];
    A[241] = -0.01339285714285718 * sp[74] + -0.01339285714285727 * sp[76];
    A[242] = 0.03482142857142857 * sp[75] + 0.04821428571428555 * sp[77] + 0.03482142857142828 * sp[78];
    A[243] = -0.01339285714285698 * sp[76] + -0.01339285714285703 * sp[79];
    A[244] = 0.04821428571428602 * sp[75] + 0.07232142857142881 * sp[76] + 0.02410714285714262 * sp[77] + 0.04821428571428525 * sp[78] + 0.04821428571428549 * sp[78] + 0.07232142857142793 * sp[79];
    A[245] = 0.02410714285714297 * sp[75] + 0.0482142857142855 * sp[76] + 0.02410714285714292 * sp[78] + 0.024107142857143 * sp[78] + 0.04821428571428567 * sp[79];
    A[246] = 0.0241071428571429 * sp[74] + 0.02410714285714274 * sp[76] + 0.02410714285714312 * sp[76] + 0.02410714285714292 * sp[79];
    A[247] = 0.02410714285714297 * sp[74] + 0.02410714285714293 * sp[76] + 0.02410714285714299 * sp[76] + 0.02410714285714297 * sp[79];
    A[248] = 0.04821428571428529 * sp[74] + 0.02410714285714267 * sp[75] + 0.0241071428571429 * sp[75] + 0.04821428571428574 * sp[76] + 0.02410714285714286 * sp[78];
    A[249] = 0.07232142857142924 * sp[74] + 0.04821428571428608 * sp[75] + 0.04821428571428563 * sp[75] + 0.02410714285714296 * sp[77] + 0.07232142857142837 * sp[76] + 0.04821428571428564 * sp[78];
    A[250] = 0.1205357142857144 * sp[74] + 0.1205357142857144 * sp[75] + 0.02410714285714257 * sp[76] + 0.02410714285714268 * sp[75] + 0.02410714285714267 * sp[77] + 0.1205357142857144 * sp[78] + 0.1205357142857142 * sp[76] + 0.1205357142857143 * sp[78] + 0.02410714285714255 * sp[79];
    A[251] = -0.02410714285714293 * sp[74] + -0.02410714285714293 * sp[75] + 0.02410714285714313 * sp[76] + -0.02410714285714299 * sp[78] + -0.02410714285714297 * sp[76] + -0.02410714285714296 * sp[78] + 0.02410714285714313 * sp[79];
    A[252] = 0.2410714285714287 * sp[74] + 0.1446428571428569 * sp[75] + 0.2410714285714283 * sp[76] + 0.1446428571428569 * sp[75] + 0.2410714285714287 * sp[77] + 0.1446428571428566 * sp[78] + 0.2410714285714283 * sp[76] + 0.1446428571428566 * sp[78] + 0.241071428571428 * sp[79];
    A[253] = -0.07232142857142915 * sp[74] + -0.1446428571428569 * sp[75] + -0.07232142857142897 * sp[76] + -0.04821428571428558 * sp[75] + -0.1928571428571427 * sp[77] + -0.04821428571428538 * sp[78] + -0.07232142857142823 * sp[76] + -0.1446428571428564 * sp[78] + -0.07232142857142806 * sp[79];
    A[254] = 0.02410714285714247 * sp[74] + 0.1205357142857143 * sp[75] + 0.1205357142857143 * sp[76] + 0.1205357142857145 * sp[75] + 0.02410714285714267 * sp[77] + 0.02410714285714271 * sp[78] + 0.02410714285714243 * sp[76] + 0.1205357142857142 * sp[78] + 0.1205357142857142 * sp[79];
    A[255] = 0.02410714285714332 * sp[74] + -0.02410714285714268 * sp[75] + -0.02410714285714259 * sp[76] + -0.02410714285714293 * sp[75] + 0.02410714285714334 * sp[76] + -0.02410714285714286 * sp[78] + -0.02410714285714278 * sp[79];
    A[256] = 0.0482142857142863 * sp[74] + 0.02410714285714303 * sp[75] + 0.04821428571428637 * sp[76] + 0.0241071428571429 * sp[75] + 0.02410714285714324 * sp[78] + 0.04821428571428565 * sp[76] + 0.02410714285714313 * sp[78] + 0.04821428571428604 * sp[79];
    A[257] = -0.04821428571428635 * sp[74] + -0.1687500000000005 * sp[75] + -0.2892857142857141 * sp[76] + -0.02410714285714292 * sp[75] + -0.0482142857142854 * sp[77] + -0.1687499999999998 * sp[78] + -0.0482142857142857 * sp[76] + -0.1687499999999998 * sp[78] + -0.289285714285714 * sp[79];
    A[258] = -0.1446428571428572 * sp[74] + -0.02410714285714322 * sp[75] + -0.1446428571428575 * sp[76] + -0.02410714285714284 * sp[75] + -0.02410714285714249 * sp[78] + -0.1446428571428573 * sp[76] + -0.02410714285714334 * sp[78] + -0.1446428571428574 * sp[79];
    A[259] = -0.2892857142857139 * sp[74] + -0.16875 * sp[75] + -0.04821428571428615 * sp[76] + -0.1687499999999997 * sp[75] + -0.04821428571428504 * sp[77] + -0.02410714285714315 * sp[78] + -0.289285714285714 * sp[76] + -0.1687499999999995 * sp[78] + -0.04821428571428581 * sp[79];
    A[260] = 0.01339285714285736 * sp[74] + 0.0133928571428571 * sp[75] + 0.01339285714285699 * sp[76] + 0.04821428571428591 * sp[75] + 0.04821428571428575 * sp[77] + 0.0482142857142857 * sp[78] + 0.01339285714285725 * sp[76] + 0.013392857142857 * sp[78] + 0.01339285714285689 * sp[79];
    A[261] = -0.01339285714285728 * sp[74] + -0.01339285714285718 * sp[76];
    A[262] = -0.06160714285714276 * sp[75] + -0.09642857142857129 * sp[77] + -0.06160714285714256 * sp[78];
    A[263] = -0.01339285714285709 * sp[76] + -0.01339285714285703 * sp[79];
    A[264] = -0.09642857142857145 * sp[75] + -0.1928571428571429 * sp[76] + 0.02410714285714307 * sp[77] + -0.09642857142857102 * sp[78] + -0.09642857142857097 * sp[78] + -0.1928571428571423 * sp[79];
    A[265] = 0.02410714285714289 * sp[75] + 0.07232142857142915 * sp[76] + 0.02410714285714306 * sp[78] + 0.02410714285714295 * sp[78] + 0.07232142857142917 * sp[79];
    A[266] = 0.02410714285714289 * sp[74] + 0.02410714285714312 * sp[76] + 0.02410714285714284 * sp[76] + 0.02410714285714313 * sp[79];
    A[267] = 0.02410714285714286 * sp[74] + 0.02410714285714271 * sp[76] + 0.02410714285714291 * sp[76] + 0.02410714285714276 * sp[79];
    A[268] = 0.07232142857142916 * sp[74] + 0.02410714285714289 * sp[75] + 0.02410714285714272 * sp[75] + 0.07232142857142893 * sp[76] + 0.02410714285714289 * sp[78];
    A[269] = -0.1928571428571438 * sp[74] + -0.09642857142857179 * sp[75] + -0.09642857142857157 * sp[75] + 0.0241071428571427 * sp[77] + -0.1928571428571431 * sp[76] + -0.09642857142857145 * sp[78];
    A[270] = -0.02410714285714286 * sp[74] + -0.02410714285714281 * sp[75] + 0.02410714285714315 * sp[75] + 0.02410714285714313 * sp[77] + -0.02410714285714284 * sp[78] + -0.0241071428571428 * sp[76] + -0.02410714285714275 * sp[78];
    A[271] = -0.02410714285714288 * sp[74] + -0.02410714285714288 * sp[75] + -0.02410714285714271 * sp[78] + -0.02410714285714293 * sp[76] + -0.02410714285714295 * sp[78];
    A[272] = -0.07232142857142915 * sp[74] + -0.04821428571428558 * sp[75] + -0.07232142857142823 * sp[76] + -0.1446428571428569 * sp[75] + -0.1928571428571427 * sp[77] + -0.1446428571428564 * sp[78] + -0.07232142857142897 * sp[76] + -0.04821428571428538 * sp[78] + -0.07232142857142806 * sp[79];
    A[273] = 0.1928571428571438 * sp[74] + 0.09642857142857152 * sp[75] + 0.1928571428571431 * sp[76] + 0.09642857142857152 * sp[75] + 0.2410714285714284 * sp[77] + 0.09642857142857122 * sp[78] + 0.1928571428571431 * sp[76] + 0.09642857142857122 * sp[78] + 0.1928571428571425 * sp[79];
    A[274] = -0.02410714285714283 * sp[75] + -0.02410714285714299 * sp[76] + -0.02410714285714291 * sp[75] + 0.02410714285714319 * sp[77] + 0.02410714285714313 * sp[78] + -0.02410714285714281 * sp[78] + -0.02410714285714296 * sp[79];
    A[275] = -0.02410714285714267 * sp[75] + -0.02410714285714305 * sp[76] + -0.02410714285714281 * sp[75] + -0.02410714285714267 * sp[78] + -0.02410714285714305 * sp[79];
    A[276] = -0.09642857142857184 * sp[74] + 0.0241071428571424 * sp[75] + -0.09642857142857267 * sp[76] + 0.02410714285714243 * sp[75] + 0.02410714285714165 * sp[78] + -0.09642857142857091 * sp[76] + 0.02410714285714281 * sp[78] + -0.09642857142857196 * sp[79];
    A[277] = 0.0964285714285719 * sp[74] + 0.1205357142857144 * sp[75] + -0.02410714285714247 * sp[75] + -0.04821428571428605 * sp[77] + 0.1205357142857137 * sp[78] + 0.09642857142857099 * sp[76] + 0.1205357142857139 * sp[78];
    A[278] = -0.02410714285714266 * sp[75] + -0.02410714285714282 * sp[75] + -0.02410714285714326 * sp[78] + -0.02410714285714308 * sp[78];
    A[279] = 0.1205357142857141 * sp[75] + 0.09642857142857224 * sp[76] + 0.1205357142857141 * sp[75] + -0.04821428571428638 * sp[77] + -0.02410714285714188 * sp[78] + 0.1205357142857138 * sp[78] + 0.09642857142857153 * sp[79];
    A[280] = -0.09642857142857146 * sp[74] + -0.09642857142857152 * sp[75] + -0.09642857142857153 * sp[76] + -0.03482142857142843 * sp[75] + -0.03482142857142853 * sp[77] + -0.03482142857142851 * sp[78] + -0.03482142857142843 * sp[76] + -0.03482142857142852 * sp[78] + -0.0348214285714285 * sp[79];
    A[281] = 0.04821428571428547 * sp[74] + 0.03482142857142818 * sp[75] + 0.03482142857142816 * sp[76];
    A[282] = -0.01339285714285727 * sp[77] + -0.01339285714285724 * sp[78];
    A[283] = -0.01339285714285713 * sp[78] + -0.01339285714285713 * sp[79];
    A[284] = 0.02410714285714303 * sp[77] + 0.02410714285714276 * sp[78] + 0.02410714285714312 * sp[78] + 0.02410714285714291 * sp[79];
    A[285] = 0.02410714285714303 * sp[77] + 0.02410714285714307 * sp[78] + 0.02410714285714295 * sp[78] + 0.02410714285714295 * sp[79];
    A[286] = 0.02410714285714226 * sp[74] + 0.04821428571428497 * sp[76] + 0.04821428571428532 * sp[75] + 0.07232142857142797 * sp[78] + 0.04821428571428527 * sp[76] + 0.07232142857142788 * sp[79];
    A[287] = 0.02410714285714292 * sp[76] + 0.02410714285714303 * sp[75] + 0.0482142857142859 * sp[78] + 0.02410714285714296 * sp[76] + 0.04821428571428586 * sp[79];
    A[288] = 0.02410714285714232 * sp[74] + 0.0482142857142849 * sp[75] + 0.0482142857142853 * sp[75] + 0.07232142857142793 * sp[77] + 0.04821428571428525 * sp[76] + 0.07232142857142783 * sp[78];
    A[289] = 0.0241071428571431 * sp[75] + 0.02410714285714289 * sp[75] + 0.04821428571428593 * sp[77] + 0.02410714285714305 * sp[76] + 0.04821428571428606 * sp[78];
    A[290] = 0.02410714285714251 * sp[74] + 0.02410714285714252 * sp[75] + 0.1205357142857145 * sp[76] + 0.1205357142857142 * sp[75] + 0.1205357142857143 * sp[77] + 0.02410714285714261 * sp[78] + 0.1205357142857142 * sp[76] + 0.1205357142857143 * sp[78] + 0.0241071428571426 * sp[79];
    A[291] = -0.02410714285714298 * sp[76] + -0.024107142857143 * sp[75] + -0.02410714285714299 * sp[77] + 0.02410714285714328 * sp[78] + -0.02410714285714292 * sp[76] + -0.02410714285714291 * sp[78] + 0.02410714285714328 * sp[79];
    A[292] = 0.02410714285714247 * sp[74] + 0.1205357142857145 * sp[75] + 0.02410714285714243 * sp[76] + 0.1205357142857143 * sp[75] + 0.02410714285714267 * sp[77] + 0.1205357142857142 * sp[78] + 0.1205357142857143 * sp[76] + 0.02410714285714271 * sp[78] + 0.1205357142857142 * sp[79];
    A[293] = -0.02410714285714291 * sp[75] + -0.02410714285714283 * sp[75] + 0.02410714285714319 * sp[77] + -0.02410714285714281 * sp[78] + -0.02410714285714299 * sp[76] + 0.02410714285714313 * sp[78] + -0.02410714285714296 * sp[79];
    A[294] = 0.2410714285714283 * sp[74] + 0.1446428571428566 * sp[75] + 0.1446428571428565 * sp[76] + 0.1446428571428566 * sp[75] + 0.2410714285714286 * sp[77] + 0.2410714285714286 * sp[78] + 0.1446428571428565 * sp[76] + 0.2410714285714286 * sp[78] + 0.2410714285714285 * sp[79];
    A[295] = -0.1928571428571424 * sp[74] + -0.04821428571428495 * sp[75] + -0.04821428571428497 * sp[76] + -0.1446428571428564 * sp[75] + -0.07232142857142775 * sp[77] + -0.07232142857142773 * sp[78] + -0.1446428571428563 * sp[76] + -0.07232142857142765 * sp[78] + -0.07232142857142762 * sp[79];
    A[296] = 0.02410714285714226 * sp[75] + 0.02410714285714224 * sp[76] + 0.02410714285714283 * sp[75] + 0.04821428571428513 * sp[77] + 0.04821428571428518 * sp[78] + 0.02410714285714282 * sp[76] + 0.04821428571428493 * sp[78] + 0.0482142857142852 * sp[79];
    A[297] = -0.02410714285714267 * sp[75] + -0.02410714285714267 * sp[76] + -0.02410714285714288 * sp[75] + -0.1446428571428572 * sp[77] + -0.1446428571428573 * sp[78] + -0.02410714285714285 * sp[76] + -0.1446428571428574 * sp[78] + -0.1446428571428572 * sp[79];
    A[298] = -0.04821428571428477 * sp[74] + -0.02410714285714233 * sp[75] + -0.1687499999999995 * sp[76] + -0.1687499999999996 * sp[75] + -0.04821428571428532 * sp[77] + -0.289285714285715 * sp[78] + -0.1687499999999995 * sp[76] + -0.04821428571428515 * sp[78] + -0.2892857142857149 * sp[79];
    A[299] = -0.04821428571428474 * sp[74] + -0.1687499999999995 * sp[75] + -0.0241071428571423 * sp[76] + -0.1687499999999996 * sp[75] + -0.2892857142857146 * sp[77] + -0.04821428571428515 * sp[78] + -0.1687499999999996 * sp[76] + -0.2892857142857147 * sp[78] + -0.0482142857142852 * sp[79];
    A[300] = 0.04821428571428561 * sp[74] + 0.04821428571428571 * sp[75] + 0.04821428571428574 * sp[76] + 0.01339285714285693 * sp[75] + 0.01339285714285698 * sp[77] + 0.01339285714285702 * sp[78] + 0.01339285714285692 * sp[76] + 0.01339285714285698 * sp[78] + 0.01339285714285701 * sp[79];
    A[301] = -0.09642857142857116 * sp[74] + -0.06160714285714258 * sp[75] + -0.06160714285714255 * sp[76];
    A[302] = -0.01339285714285721 * sp[77] + -0.01339285714285714 * sp[78];
    A[303] = -0.01339285714285705 * sp[78] + -0.01339285714285703 * sp[79];
    A[304] = 0.02410714285714266 * sp[77] + 0.02410714285714258 * sp[78] + 0.02410714285714296 * sp[78] + 0.02410714285714296 * sp[79];
    A[305] = 0.02410714285714288 * sp[77] + 0.02410714285714262 * sp[78] + 0.02410714285714266 * sp[78] + 0.02410714285714237 * sp[79];
    A[306] = 0.0241071428571435 * sp[74] + -0.09642857142857068 * sp[76] + -0.09642857142857111 * sp[75] + -0.1928571428571429 * sp[78] + -0.0964285714285711 * sp[76] + -0.1928571428571429 * sp[79];
    A[307] = 0.0241071428571428 * sp[76] + 0.02410714285714288 * sp[75] + 0.07232142857142888 * sp[78] + 0.02410714285714266 * sp[76] + 0.07232142857142862 * sp[79];
    A[308] = 0.02410714285714336 * sp[74] + -0.09642857142857079 * sp[75] + -0.09642857142857134 * sp[75] + -0.1928571428571429 * sp[77] + -0.09642857142857125 * sp[76] + -0.1928571428571428 * sp[78];
    A[309] = 0.02410714285714292 * sp[75] + 0.02410714285714267 * sp[75] + 0.07232142857142838 * sp[77] + 0.02410714285714305 * sp[76] + 0.07232142857142872 * sp[78];
    A[310] = 0.02410714285714342 * sp[74] + 0.02410714285714342 * sp[75] + -0.02410714285714299 * sp[76] + -0.02410714285714266 * sp[75] + -0.02410714285714274 * sp[77] + -0.02410714285714271 * sp[76] + -0.02410714285714278 * sp[78];
    A[311] = -0.02410714285714274 * sp[76] + -0.0241071428571429 * sp[75] + -0.02410714285714291 * sp[77] + -0.02410714285714268 * sp[76] + -0.02410714285714268 * sp[78];
    A[312] = 0.02410714285714332 * sp[74] + -0.02410714285714293 * sp[75] + 0.02410714285714334 * sp[76] + -0.02410714285714268 * sp[75] + -0.02410714285714286 * sp[78] + -0.02410714285714259 * sp[76] + -0.02410714285714278 * sp[79];
    A[313] = -0.02410714285714281 * sp[75] + -0.02410714285714267 * sp[75] + -0.02410714285714267 * sp[78] + -0.02410714285714305 * sp[76] + -0.02410714285714305 * sp[79];
    A[314] = -0.1928571428571424 * sp[74] + -0.1446428571428564 * sp[75] + -0.1446428571428563 * sp[76] + -0.04821428571428495 * sp[75] + -0.07232142857142775 * sp[77] + -0.07232142857142765 * sp[78] + -0.04821428571428497 * sp[76] + -0.07232142857142773 * sp[78] + -0.07232142857142762 * sp[79];
    A[315] = 0.241071428571428 * sp[74] + 0.09642857142857061 * sp[75] + 0.09642857142857061 * sp[76] + 0.09642857142857061 * sp[75] + 0.1928571428571423 * sp[77] + 0.1928571428571422 * sp[78] + 0.09642857142857061 * sp[76] + 0.1928571428571422 * sp[78] + 0.1928571428571421 * sp[79];
    A[316] = 0.0241071428571434 * sp[75] + 0.02410714285714358 * sp[76] + 0.02410714285714247 * sp[75] + -0.09642857142857157 * sp[77] + -0.09642857142857167 * sp[78] + 0.02410714285714271 * sp[76] + -0.09642857142857161 * sp[78] + -0.09642857142857114 * sp[79];
    A[317] = -0.02410714285714347 * sp[75] + -0.02410714285714324 * sp[76] + -0.02410714285714248 * sp[75] + -0.02410714285714272 * sp[76];
    A[318] = -0.04821428571428699 * sp[74] + -0.02410714285714338 * sp[75] + 0.1205357142857138 * sp[76] + 0.1205357142857138 * sp[75] + 0.09642857142857139 * sp[77] + 0.1205357142857138 * sp[76] + 0.09642857142857145 * sp[78];
    A[319] = -0.0482142857142867 * sp[74] + 0.1205357142857137 * sp[75] + -0.02410714285714344 * sp[76] + 0.120535714285714 * sp[75] + 0.09642857142857178 * sp[78] + 0.1205357142857139 * sp[76] + 0.09642857142857121 * sp[79];
    A[320] = -0.03214285714285706 * sp[74] + -0.03214285714285693 * sp[75] + -0.03214285714285687 * sp[76] + -0.03214285714285694 * sp[75] + -0.03214285714285696 * sp[77] + -0.03214285714285693 * sp[78] + -0.03214285714285703 * sp[76] + -0.0321428571428569 * sp[78] + -0.03214285714285683 * sp[79];
    A[321] = 0.03214285714285717 * sp[74] + -0.01607142857142874 * sp[75] + -0.0160714285714287 * sp[76];
    A[322] = -0.01607142857142897 * sp[75] + 0.03214285714285721 * sp[77] + -0.01607142857142856 * sp[78];
    A[323] = -0.01607142857142889 * sp[76] + -0.01607142857142889 * sp[78] + 0.03214285714285673 * sp[79];
    A[324] = 0.2410714285714285 * sp[75] + 0.09642857142857134 * sp[76] + -0.04821428571428546 * sp[77] + -0.02410714285714229 * sp[78] + 0.1205357142857144 * sp[78] + 0.09642857142857245 * sp[79];
    A[325] = 0.09642857142857138 * sp[75] + 0.2410714285714277 * sp[76] + 0.09642857142857136 * sp[77] + 0.1205357142857139 * sp[78] + -0.0241071428571429 * sp[78] + -0.04821428571428638 * sp[79];
    A[326] = -0.04821428571428534 * sp[74] + -0.0241071428571424 * sp[76] + 0.2410714285714292 * sp[75] + 0.09642857142857261 * sp[78] + 0.1205357142857146 * sp[76] + 0.09642857142857217 * sp[79];
    A[327] = 0.09642857142857127 * sp[74] + 0.1205357142857145 * sp[76] + 0.09642857142857117 * sp[75] + 0.2410714285714286 * sp[78] + -0.02410714285714294 * sp[76] + -0.04821428571428565 * sp[79];
    A[328] = -0.04821428571428631 * sp[74] + -0.02410714285714258 * sp[75] + 0.1205357142857142 * sp[75] + 0.09642857142857204 * sp[77] + 0.2410714285714282 * sp[76] + 0.09642857142857193 * sp[78];
    A[329] = 0.09642857142857188 * sp[74] + 0.1205357142857142 * sp[75] + -0.0241071428571424 * sp[75] + -0.04821428571428556 * sp[77] + 0.09642857142857265 * sp[76] + 0.2410714285714293 * sp[78];
    A[330] = 0.04821428571428564 * sp[74] + 0.04821428571428562 * sp[75] + 0.0241071428571424 * sp[76] + 0.0482142857142854 * sp[75] + 0.04821428571428553 * sp[77] + 0.02410714285714255 * sp[78] + 0.02410714285714299 * sp[76] + 0.02410714285714298 * sp[78];
    A[331] = -0.09642857142857136 * sp[74] + -0.09642857142857132 * sp[75] + 0.02410714285714259 * sp[76] + -0.09642857142857127 * sp[75] + -0.09642857142857128 * sp[77] + 0.02410714285714274 * sp[78] + 0.02410714285714294 * sp[76] + 0.02410714285714295 * sp[78];
    A[332] = 0.0482142857142863 * sp[74] + 0.0241071428571429 * sp[75] + 0.04821428571428565 * sp[76] + 0.02410714285714303 * sp[75] + 0.02410714285714313 * sp[78] + 0.04821428571428637 * sp[76] + 0.02410714285714324 * sp[78] + 0.04821428571428604 * sp[79];
    A[333] = -0.09642857142857184 * sp[74] + 0.02410714285714243 * sp[75] + -0.09642857142857091 * sp[76] + 0.0241071428571424 * sp[75] + 0.02410714285714281 * sp[78] + -0.09642857142857267 * sp[76] + 0.02410714285714165 * sp[78] + -0.09642857142857196 * sp[79];
    A[334] = 0.02410714285714283 * sp[75] + 0.02410714285714282 * sp[76] + 0.02410714285714226 * sp[75] + 0.04821428571428513 * sp[77] + 0.04821428571428493 * sp[78] + 0.02410714285714224 * sp[76] + 0.04821428571428518 * sp[78] + 0.0482142857142852 * sp[79];
    A[335] = 0.02410714285714247 * sp[75] + 0.02410714285714271 * sp[76] + 0.0241071428571434 * sp[75] + -0.09642857142857157 * sp[77] + -0.09642857142857161 * sp[78] + 0.02410714285714358 * sp[76] + -0.09642857142857167 * sp[78] + -0.09642857142857114 * sp[79];
    A[336] = 0.5785714285714288 * sp[74] + 0.2892857142857156 * sp[75] + 0.2892857142857155 * sp[76] + 0.2892857142857156 * sp[75] + 0.5785714285714314 * sp[77] + 0.2892857142857165 * sp[78] + 0.2892857142857155 * sp[76] + 0.2892857142857165 * sp[78] + 0.5785714285714314 * sp[79];
    A[337] = -0.5785714285714292 * sp[74] + -0.2892857142857143 * sp[75] + -0.2892857142857146 * sp[76] + -0.2892857142857158 * sp[75] + -0.1446428571428575 * sp[78] + -0.2892857142857157 * sp[76] + -0.1446428571428577 * sp[78];
    A[338] = -0.289285714285715 * sp[75] + -0.1446428571428567 * sp[76] + -0.2892857142857145 * sp[75] + -0.5785714285714307 * sp[77] + -0.2892857142857139 * sp[78] + -0.1446428571428575 * sp[76] + -0.2892857142857156 * sp[78];
    A[339] = -0.1446428571428565 * sp[75] + -0.2892857142857151 * sp[76] + -0.1446428571428573 * sp[75] + -0.2892857142857161 * sp[78] + -0.2892857142857146 * sp[76] + -0.2892857142857143 * sp[78] + -0.5785714285714311 * sp[79];
    A[340] = 0.0321428571428571 * sp[74] + 0.03214285714285697 * sp[75] + 0.0321428571428569 * sp[76] + 0.04821428571428573 * sp[75] + 0.04821428571428556 * sp[77] + 0.04821428571428549 * sp[78] + 0.04821428571428563 * sp[76] + 0.04821428571428568 * sp[78] + 0.04821428571428567 * sp[79];
    A[341] = -0.0321428571428572 * sp[74];
    A[342] = 0.01607142857142898 * sp[75] + 0.04821428571428603 * sp[77];
    A[343] = 0.01607142857142889 * sp[76] + 0.04821428571428553 * sp[79];
    A[344] = -0.2410714285714286 * sp[75] + -0.09642857142857138 * sp[76] + -0.2892857142857141 * sp[77] + -0.1205357142857138 * sp[78] + -0.1205357142857145 * sp[78];
    A[345] = -0.09642857142857147 * sp[75] + -0.2410714285714279 * sp[76] + -0.1205357142857141 * sp[78] + -0.1205357142857145 * sp[78] + -0.2892857142857141 * sp[79];
    A[346] = 0.0482142857142854 * sp[74] + 0.02410714285714241 * sp[76] + 0.02410714285714247 * sp[76];
    A[347] = -0.09642857142857138 * sp[74] + -0.1205357142857146 * sp[76] + -0.1205357142857143 * sp[76] + -0.1446428571428573 * sp[79];
    A[348] = 0.04821428571428633 * sp[74] + 0.02410714285714259 * sp[75] + 0.02410714285714301 * sp[75];
    A[349] = -0.09642857142857193 * sp[74] + -0.1205357142857143 * sp[75] + -0.1205357142857145 * sp[75] + -0.1446428571428574 * sp[77];
    A[350] = -0.04821428571428572 * sp[74] + -0.04821428571428568 * sp[75] + -0.02410714285714247 * sp[76] + -0.2892857142857143 * sp[75] + -0.2892857142857142 * sp[77] + -0.1687499999999992 * sp[78] + -0.16875 * sp[76] + -0.16875 * sp[78] + -0.04821428571428556 * sp[79];
    A[351] = 0.09642857142857142 * sp[74] + 0.09642857142857143 * sp[75] + -0.02410714285714255 * sp[76] + 0.1205357142857136 * sp[78] + 0.1205357142857144 * sp[76] + 0.1205357142857144 * sp[78] + -0.04821428571428583 * sp[79];
    A[352] = -0.04821428571428635 * sp[74] + -0.02410714285714292 * sp[75] + -0.0482142857142857 * sp[76] + -0.1687500000000005 * sp[75] + -0.0482142857142854 * sp[77] + -0.1687499999999998 * sp[78] + -0.2892857142857141 * sp[76] + -0.1687499999999998 * sp[78] + -0.289285714285714 * sp[79];
    A[353] = 0.0964285714285719 * sp[74] + -0.02410714285714247 * sp[75] + 0.09642857142857099 * sp[76] + 0.1205357142857144 * sp[75] + -0.04821428571428605 * sp[77] + 0.1205357142857139 * sp[78] + 0.1205357142857137 * sp[78];
    A[354] = -0.02410714285714288 * sp[75] + -0.02410714285714285 * sp[76] + -0.02410714285714267 * sp[75] + -0.1446428571428572 * sp[77] + -0.1446428571428574 * sp[78] + -0.02410714285714267 * sp[76] + -0.1446428571428573 * sp[78] + -0.1446428571428572 * sp[79];
    A[355] = -0.02410714285714248 * sp[75] + -0.02410714285714272 * sp[76] + -0.02410714285714347 * sp[75] + -0.02410714285714324 * sp[76];
    A[356] = -0.5785714285714292 * sp[74] + -0.2892857142857158 * sp[75] + -0.2892857142857157 * sp[76] + -0.2892857142857143 * sp[75] + -0.1446428571428577 * sp[78] + -0.2892857142857146 * sp[76] + -0.1446428571428575 * sp[78];
    A[357] = 0.5785714285714296 * sp[74] + 0.2892857142857145 * sp[75] + 0.2892857142857148 * sp[76] + 0.2892857142857145 * sp[75] + 0.5785714285714284 * sp[77] + 0.2892857142857146 * sp[78] + 0.2892857142857148 * sp[76] + 0.2892857142857146 * sp[78] + 0.5785714285714286 * sp[79];
    A[358] = 0.2892857142857152 * sp[75] + 0.1446428571428569 * sp[76] + 0.2892857142857145 * sp[75] + 0.1446428571428574 * sp[78] + 0.1446428571428573 * sp[76] + 0.1446428571428577 * sp[78] + 0.2892857142857147 * sp[79];
    A[359] = 0.1446428571428567 * sp[75] + 0.2892857142857153 * sp[76] + 0.1446428571428573 * sp[75] + 0.2892857142857142 * sp[77] + 0.1446428571428574 * sp[78] + 0.2892857142857141 * sp[76] + 0.1446428571428572 * sp[78];
    A[360] = 0.04821428571428553 * sp[74] + 0.04821428571428552 * sp[75] + 0.04821428571428548 * sp[76] + 0.03214285714285693 * sp[75] + 0.03214285714285695 * sp[77] + 0.03214285714285692 * sp[78] + 0.0482142857142854 * sp[76] + 0.04821428571428553 * sp[78] + 0.04821428571428552 * sp[79];
    A[361] = 0.04821428571428611 * sp[74] + 0.01607142857142878 * sp[75];
    A[362] = -0.03214285714285714 * sp[77];
    A[363] = 0.01607142857142885 * sp[78] + 0.04821428571428579 * sp[79];
    A[364] = 0.04821428571428568 * sp[77] + 0.02410714285714255 * sp[78] + 0.02410714285714251 * sp[78];
    A[365] = -0.09642857142857154 * sp[77] + -0.1205357142857139 * sp[78] + -0.1205357142857141 * sp[78] + -0.1446428571428569 * sp[79];
    A[366] = -0.2892857142857143 * sp[74] + -0.1205357142857147 * sp[76] + -0.2410714285714289 * sp[75] + -0.09642857142857249 * sp[78] + -0.1205357142857143 * sp[76];
    A[367] = -0.1205357142857139 * sp[76] + -0.09642857142857138 * sp[75] + -0.2410714285714287 * sp[78] + -0.120535714285714 * sp[76] + -0.2892857142857143 * sp[79];
    A[368] = -0.1446428571428574 * sp[74] + -0.1205357142857143 * sp[75] + -0.1205357142857141 * sp[75] + -0.09642857142857188 * sp[77];
    A[369] = 0.02410714285714251 * sp[75] + 0.02410714285714267 * sp[75] + 0.04821428571428575 * sp[77];
    A[370] = -0.2892857142857143 * sp[74] + -0.2892857142857143 * sp[75] + -0.1687499999999995 * sp[76] + -0.04821428571428572 * sp[75] + -0.04821428571428583 * sp[77] + -0.02410714285714269 * sp[78] + -0.1687499999999998 * sp[76] + -0.1687499999999999 * sp[78] + -0.04821428571428475 * sp[79];
    A[371] = 0.1205357142857137 * sp[76] + 0.09642857142857143 * sp[75] + 0.09642857142857145 * sp[77] + -0.02410714285714258 * sp[78] + 0.120535714285714 * sp[76] + 0.120535714285714 * sp[78] + -0.04821428571428671 * sp[79];
    A[372] = -0.1446428571428572 * sp[74] + -0.02410714285714284 * sp[75] + -0.1446428571428573 * sp[76] + -0.02410714285714322 * sp[75] + -0.02410714285714334 * sp[78] + -0.1446428571428575 * sp[76] + -0.02410714285714249 * sp[78] + -0.1446428571428574 * sp[79];
    A[373] = -0.02410714285714282 * sp[75] + -0.02410714285714266 * sp[75] + -0.02410714285714308 * sp[78] + -0.02410714285714326 * sp[78];
    A[374] = -0.04821428571428477 * sp[74] + -0.1687499999999996 * sp[75] + -0.1687499999999995 * sp[76] + -0.02410714285714233 * sp[75] + -0.04821428571428532 * sp[77] + -0.04821428571428515 * sp[78] + -0.1687499999999995 * sp[76] + -0.289285714285715 * sp[78] + -0.2892857142857149 * sp[79];
    A[375] = -0.04821428571428699 * sp[74] + 0.1205357142857138 * sp[75] + 0.1205357142857138 * sp[76] + -0.02410714285714338 * sp[75] + 0.09642857142857139 * sp[77] + 0.09642857142857145 * sp[78] + 0.1205357142857138 * sp[76];
    A[376] = -0.2892857142857145 * sp[75] + -0.1446428571428575 * sp[76] + -0.289285714285715 * sp[75] + -0.5785714285714307 * sp[77] + -0.2892857142857156 * sp[78] + -0.1446428571428567 * sp[76] + -0.2892857142857139 * sp[78];
    A[377] = 0.2892857142857145 * sp[75] + 0.1446428571428573 * sp[76] + 0.2892857142857152 * sp[75] + 0.1446428571428577 * sp[78] + 0.1446428571428569 * sp[76] + 0.1446428571428574 * sp[78] + 0.2892857142857147 * sp[79];
    A[378] = 0.5785714285714287 * sp[74] + 0.2892857142857146 * sp[75] + 0.289285714285714 * sp[76] + 0.2892857142857146 * sp[75] + 0.5785714285714302 * sp[77] + 0.2892857142857142 * sp[78] + 0.289285714285714 * sp[76] + 0.2892857142857142 * sp[78] + 0.5785714285714293 * sp[79];
    A[379] = 0.2892857142857146 * sp[74] + 0.1446428571428572 * sp[75] + 0.1446428571428574 * sp[76] + 0.1446428571428574 * sp[75] + 0.2892857142857153 * sp[78] + 0.1446428571428572 * sp[76] + 0.2892857142857148 * sp[78];
    A[380] = 0.0482142857142854 * sp[74] + 0.04821428571428548 * sp[75] + 0.04821428571428545 * sp[76] + 0.04821428571428554 * sp[75] + 0.04821428571428556 * sp[77] + 0.04821428571428545 * sp[78] + 0.03214285714285703 * sp[76] + 0.0321428571428569 * sp[78] + 0.03214285714285679 * sp[79];
    A[381] = 0.04821428571428599 * sp[74] + 0.01607142857142866 * sp[76];
    A[382] = 0.04821428571428613 * sp[77] + 0.01607142857142872 * sp[78];
    A[383] = -0.03214285714285672 * sp[79];
    A[384] = -0.1446428571428569 * sp[77] + -0.1205357142857138 * sp[78] + -0.1205357142857142 * sp[78] + -0.096428571428572 * sp[79];
    A[385] = 0.02410714285714309 * sp[78] + 0.02410714285714293 * sp[78] + 0.04821428571428633 * sp[79];
    A[386] = -0.1446428571428572 * sp[74] + -0.1205357142857147 * sp[76] + -0.1205357142857145 * sp[76] + -0.09642857142857225 * sp[79];
    A[387] = 0.02410714285714306 * sp[76] + 0.02410714285714297 * sp[76] + 0.04821428571428579 * sp[79];
    A[388] = -0.2892857142857143 * sp[74] + -0.1205357142857144 * sp[75] + -0.120535714285714 * sp[75] + -0.2410714285714283 * sp[76] + -0.096428571428572 * sp[78];
    A[389] = -0.1205357142857144 * sp[75] + -0.1205357142857142 * sp[75] + -0.2892857142857143 * sp[77] + -0.09642857142857221 * sp[76] + -0.241071428571429 * sp[78];
    A[390] = -0.1446428571428572 * sp[74] + -0.1446428571428573 * sp[75] + -0.0241071428571427 * sp[76] + -0.1446428571428573 * sp[75] + -0.1446428571428572 * sp[77] + -0.02410714285714222 * sp[78] + -0.02410714285714296 * sp[76] + -0.02410714285714294 * sp[78];
    A[391] = -0.02410714285714307 * sp[76] + -0.02410714285714335 * sp[78] + -0.02410714285714297 * sp[76] + -0.02410714285714298 * sp[78];
    A[392] = -0.2892857142857139 * sp[74] + -0.1687499999999997 * sp[75] + -0.289285714285714 * sp[76] + -0.16875 * sp[75] + -0.04821428571428504 * sp[77] + -0.1687499999999995 * sp[78] + -0.04821428571428615 * sp[76] + -0.02410714285714315 * sp[78] + -0.04821428571428581 * sp[79];
    A[393] = 0.1205357142857141 * sp[75] + 0.1205357142857141 * sp[75] + -0.04821428571428638 * sp[77] + 0.1205357142857138 * sp[78] + 0.09642857142857224 * sp[76] + -0.02410714285714188 * sp[78] + 0.09642857142857153 * sp[79];
    A[394] = -0.04821428571428474 * sp[74] + -0.1687499999999996 * sp[75] + -0.1687499999999996 * sp[76] + -0.1687499999999995 * sp[75] + -0.2892857142857146 * sp[77] + -0.2892857142857147 * sp[78] + -0.0241071428571423 * sp[76] + -0.04821428571428515 * sp[78] + -0.0482142857142852 * sp[79];
    A[395] = -0.0482142857142867 * sp[74] + 0.120535714285714 * sp[75] + 0.1205357142857139 * sp[76] + 0.1205357142857137 * sp[75] + -0.02410714285714344 * sp[76] + 0.09642857142857178 * sp[78] + 0.09642857142857121 * sp[79];
    A[396] = -0.1446428571428573 * sp[75] + -0.2892857142857146 * sp[76] + -0.1446428571428565 * sp[75] + -0.2892857142857143 * sp[78] + -0.2892857142857151 * sp[76] + -0.2892857142857161 * sp[78] + -0.5785714285714311 * sp[79];
    A[397] = 0.1446428571428573 * sp[75] + 0.2892857142857141 * sp[76] + 0.1446428571428567 * sp[75] + 0.2892857142857142 * sp[77] + 0.1446428571428572 * sp[78] + 0.2892857142857153 * sp[76] + 0.1446428571428574 * sp[78];
    A[398] = 0.2892857142857146 * sp[74] + 0.1446428571428574 * sp[75] + 0.1446428571428572 * sp[76] + 0.1446428571428572 * sp[75] + 0.2892857142857148 * sp[78] + 0.1446428571428574 * sp[76] + 0.2892857142857153 * sp[78];
    A[399] = 0.5785714285714281 * sp[74] + 0.2892857142857139 * sp[75] + 0.2892857142857145 * sp[76] + 0.2892857142857139 * sp[75] + 0.5785714285714284 * sp[77] + 0.289285714285714 * sp[78] + 0.2892857142857145 * sp[76] + 0.289285714285714 * sp[78] + 0.5785714285714304 * sp[79];
}


poisson3d_3_cell_integral_1_otherwise::poisson3d_3_cell_integral_1_otherwise() : ufc::cell_integral()
{

}

poisson3d_3_cell_integral_1_otherwise::~poisson3d_3_cell_integral_1_otherwise()
{

}

const std::vector<bool> & poisson3d_3_cell_integral_1_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({true});
return enabled;
}

void poisson3d_3_cell_integral_1_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 6
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 6
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           6
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Quadrature rules
    alignas(32) static const double weights24[24] = { 0.006653791709694649, 0.006653791709694649, 0.006653791709694649, 0.006653791709694649, 0.001679535175886783, 0.001679535175886783, 0.001679535175886783, 0.001679535175886783, 0.009226196923942399, 0.009226196923942399, 0.009226196923942399, 0.009226196923942399, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283, 0.008035714285714283 };
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE11_C0_Q24[1][24][20] =
        { { { 0.05183342742053283, -0.01137528241650878, 0.05183342742053276, 0.05183342742053276, -0.07381880034180834, -0.07381880034180849, 0.0235880447339438, -0.1225222228796847, 0.02358804473394371, -0.1225222228796846, -0.07381880034180836, -0.07381880034180846, -0.07381880034180853, -0.07381880034180838, -0.1225222228796848, 0.02358804473394382, 0.4429128020508511, 0.2668519304904311, 0.4429128020508512, 0.4429128020508512 },
            { -0.01137528241650883, 0.05183342742053283, 0.05183342742053272, 0.05183342742053278, -0.07381880034180838, -0.07381880034180846, -0.0738188003418084, -0.07381880034180857, -0.07381880034180842, -0.07381880034180847, 0.02358804473394381, -0.1225222228796846, 0.02358804473394373, -0.1225222228796845, 0.02358804473394362, -0.1225222228796846, 0.2668519304904313, 0.4429128020508508, 0.4429128020508512, 0.4429128020508511 },
            { 0.0518334274205328, 0.05183342742053286, 0.05183342742053271, -0.01137528241650892, -0.1225222228796844, 0.02358804473394373, -0.1225222228796845, 0.02358804473394362, -0.07381880034180845, -0.07381880034180846, -0.1225222228796845, 0.02358804473394376, -0.0738188003418085, -0.07381880034180834, -0.07381880034180865, -0.07381880034180842, 0.4429128020508511, 0.4429128020508508, 0.4429128020508512, 0.2668519304904313 },
            { 0.05183342742053279, 0.05183342742053286, -0.01137528241650894, 0.05183342742053276, 0.02358804473394384, -0.1225222228796846, -0.07381880034180836, -0.0738188003418086, -0.1225222228796845, 0.02358804473394374, -0.07381880034180836, -0.0738188003418085, -0.1225222228796846, 0.02358804473394392, -0.07381880034180864, -0.07381880034180843, 0.4429128020508512, 0.4429128020508508, 0.2668519304904314, 0.4429128020508511 },
            { 0.03353209363244265, 0.454708014971024, 0.03353209363244247, 0.03353209363244241, -0.006536256580629146, -0.006536256580629073, 0.2625713032082067, -0.1410900364750473, 0.2625713032082068, -0.1410900364750471, -0.006536256580628994, -0.006536256580628966, -0.006536256580629234, -0.006536256580628973, -0.1410900364750477, 0.2625713032082079, 0.03921753948377486, 0.001816824964619265, 0.03921753948377497, 0.03921753948377502 },
            { 0.4547080149710246, 0.03353209363244242, 0.03353209363244238, 0.03353209363244244, -0.006536256580629146, -0.006536256580629032, -0.006536256580629176, -0.006536256580629, -0.006536256580629162, -0.006536256580628873, 0.2625713032082072, -0.1410900364750471, 0.262571303208207, -0.1410900364750471, 0.2625713032082068, -0.141090036475047, 0.00181682496461916, 0.03921753948377482, 0.03921753948377475, 0.03921753948377487 },
            { 0.03353209363244253, 0.03353209363244248, 0.03353209363244244, 0.454708014971024, -0.1410900364750472, 0.2625713032082073, -0.1410900364750472, 0.2625713032082068, -0.006536256580628987, -0.006536256580629177, -0.1410900364750475, 0.2625713032082075, -0.00653625658062917, -0.006536256580629046, -0.006536256580629264, -0.006536256580629004, 0.03921753948377493, 0.03921753948377485, 0.03921753948377479, 0.001816824964619247 },
            { 0.03353209363244261, 0.03353209363244249, 0.4547080149710238, 0.03353209363244241, 0.262571303208207, -0.1410900364750472, -0.006536256580629151, -0.006536256580629181, -0.1410900364750472, 0.262571303208207, -0.006536256580629212, -0.006536256580629098, -0.1410900364750477, 0.262571303208208, -0.00653625658062921, -0.006536256580629025, 0.03921753948377503, 0.03921753948377492, 0.00181682496461907, 0.03921753948377493 },
            { 0.005491739535993259, 0.02825140445644194, 0.005491739535993019, 0.005491739535993106, -0.01542301302648352, -0.01542301302648346, -0.04311242233496347, -0.001578308372243748, -0.04311242233496331, -0.001578308372243689, -0.01542301302648382, -0.01542301302648348, -0.01542301302648386, -0.01542301302648324, -0.001578308372243821, -0.0431124223349634, 0.09253807815890215, 0.9042694127393964, 0.09253807815890189, 0.09253807815890172 },
            { 0.02825140445644179, 0.005491739535993269, 0.00549173953599313, 0.005491739535993062, -0.0154230130264833, -0.0154230130264835, -0.01542301302648334, -0.01542301302648365, -0.01542301302648349, -0.01542301302648344, -0.04311242233496305, -0.001578308372243639, -0.04311242233496321, -0.001578308372243519, -0.04311242233496343, -0.001578308372243511, 0.9042694127393971, 0.09253807815890092, 0.09253807815890142, 0.09253807815890121 },
            { 0.005491739535993339, 0.005491739535993206, 0.005491739535993144, 0.02825140445644193, -0.00157830837224367, -0.04311242233496344, -0.001578308372243677, -0.04311242233496352, -0.01542301302648357, -0.01542301302648352, -0.001578308372243695, -0.04311242233496338, -0.01542301302648391, -0.01542301302648338, -0.01542301302648394, -0.01542301302648347, 0.09253807815890196, 0.09253807815890171, 0.09253807815890189, 0.9042694127393968 },
            { 0.005491739535993386, 0.005491739535993224, 0.0282514044564419, 0.005491739535993128, -0.04311242233496332, -0.001578308372243698, -0.01542301302648346, -0.01542301302648362, -0.00157830837224372, -0.04311242233496346, -0.01542301302648382, -0.01542301302648345, -0.001578308372243857, -0.04311242233496323, -0.01542301302648399, -0.01542301302648343, 0.0925380781589019, 0.09253807815890179, 0.9042694127393966, 0.09253807815890192 },
            { -0.04658474953124552, 0.03066949906249125, 0.04658474953124562, 0.04658474953124566, -0.01475424859373679, -0.0147542485937368, -0.01475424859373676, -0.06250000000000004, -0.01475424859373679, -0.06249999999999998, 0.1397542485937368, -0.1397542485937367, 0.1397542485937368, -0.1397542485937366, 0.5920084971874738, -0.1397542485937367, 0.02950849718747373, 0.06598300562505249, 0.2795084971874736, 0.2795084971874739 },
            { -0.04658474953124558, 0.0465847495312456, 0.03066949906249113, 0.04658474953124566, -0.01475424859373685, -0.06249999999999996, -0.01475424859373687, -0.01475424859373687, -0.06249999999999988, -0.01475424859373669, 0.1397542485937369, -0.1397542485937368, 0.5920084971874738, -0.1397542485937364, 0.1397542485937368, -0.1397542485937369, 0.02950849718747383, 0.2795084971874737, 0.06598300562505256, 0.2795084971874737 },
            { -0.04658474953124546, 0.0465847495312457, 0.04658474953124558, 0.03066949906249124, -0.06249999999999997, -0.0147542485937367, -0.06249999999999999, -0.01475424859373676, -0.01475424859373679, -0.01475424859373676, 0.5920084971874736, -0.1397542485937366, 0.1397542485937367, -0.1397542485937366, 0.1397542485937369, -0.1397542485937368, 0.0295084971874737, 0.2795084971874735, 0.2795084971874737, 0.06598300562505269 },
            { 0.03066949906249122, -0.04658474953124556, 0.04658474953124567, 0.04658474953124563, -0.01475424859373676, -0.01475424859373687, 0.1397542485937368, -0.1397542485937369, 0.1397542485937368, -0.1397542485937369, -0.01475424859373674, -0.06249999999999993, -0.01475424859373689, -0.06249999999999998, -0.1397542485937368, 0.5920084971874739, 0.06598300562505249, 0.02950849718747378, 0.2795084971874737, 0.2795084971874739 },
            { 0.03066949906249124, 0.04658474953124564, -0.04658474953124563, 0.04658474953124563, 0.1397542485937369, -0.1397542485937368, -0.01475424859373678, -0.01475424859373692, -0.1397542485937367, 0.1397542485937368, -0.01475424859373676, -0.06249999999999996, -0.1397542485937368, 0.5920084971874742, -0.01475424859373689, -0.06249999999999997, 0.06598300562505263, 0.2795084971874735, 0.02950849718747377, 0.2795084971874736 },
            { 0.0306694990624913, 0.04658474953124565, 0.04658474953124558, -0.04658474953124582, -0.1397542485937368, 0.1397542485937369, -0.1397542485937368, 0.1397542485937368, -0.0147542485937367, -0.0147542485937369, -0.1397542485937368, 0.5920084971874739, -0.01475424859373689, -0.06249999999999981, -0.0147542485937369, -0.06249999999999985, 0.06598300562505267, 0.2795084971874736, 0.2795084971874738, 0.02950849718747355 },
            { 0.04658474953124567, 0.04658474953124568, 0.0306694990624912, -0.04658474953124575, -0.1397542485937367, 0.5920084971874739, -0.1397542485937368, 0.1397542485937367, -0.06249999999999988, -0.01475424859373675, -0.1397542485937369, 0.139754248593737, -0.06250000000000006, -0.01475424859373665, -0.01475424859373697, -0.0147542485937367, 0.2795084971874739, 0.2795084971874737, 0.06598300562505248, 0.02950849718747355 },
            { 0.04658474953124572, 0.03066949906249128, -0.04658474953124576, 0.0465847495312456, 0.1397542485937369, -0.1397542485937368, -0.0147542485937367, -0.06250000000000006, -0.1397542485937368, 0.5920084971874738, -0.01475424859373678, -0.01475424859373685, -0.139754248593737, 0.1397542485937371, -0.06250000000000017, -0.01475424859373669, 0.2795084971874737, 0.06598300562505237, 0.02950849718747373, 0.2795084971874739 },
            { 0.04658474953124576, -0.04658474953124562, 0.04658474953124565, 0.03066949906249119, -0.06249999999999985, -0.01475424859373682, 0.5920084971874735, -0.1397542485937369, 0.1397542485937368, -0.1397542485937368, -0.06249999999999992, -0.01475424859373673, -0.01475424859373695, -0.01475424859373673, -0.1397542485937372, 0.1397542485937371, 0.2795084971874735, 0.02950849718747371, 0.2795084971874741, 0.0659830056250527 },
            { 0.04658474953124573, 0.04658474953124567, -0.04658474953124581, 0.0306694990624912, 0.5920084971874735, -0.1397542485937366, -0.06249999999999985, -0.01475424859373696, -0.1397542485937368, 0.1397542485937369, -0.06250000000000003, -0.01475424859373686, -0.139754248593737, 0.1397542485937373, -0.01475424859373697, -0.01475424859373671, 0.2795084971874738, 0.2795084971874738, 0.02950849718747369, 0.06598300562505245 },
            { 0.04658474953124565, 0.03066949906249132, 0.0465847495312456, -0.0465847495312457, -0.1397542485937367, 0.1397542485937368, -0.1397542485937368, 0.5920084971874737, -0.0147542485937368, -0.0625, -0.1397542485937369, 0.1397542485937369, -0.01475424859373685, -0.01475424859373672, -0.06250000000000012, -0.01475424859373671, 0.2795084971874738, 0.06598300562505238, 0.2795084971874739, 0.0295084971874736 },
            { 0.04658474953124574, -0.0465847495312456, 0.03066949906249124, 0.04658474953124559, -0.0147542485937367, -0.06249999999999999, 0.1397542485937368, -0.1397542485937369, 0.5920084971874735, -0.1397542485937367, -0.01475424859373674, -0.01475424859373677, -0.06250000000000014, -0.01475424859373676, -0.1397542485937371, 0.1397542485937372, 0.2795084971874735, 0.02950849718747375, 0.06598300562505269, 0.2795084971874741 } } };
    alignas(32) static const double FE8_C0_D001_Q24[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[3] * FE8_C0_D001_Q24[0][0][1];
    const double J_c4 = coordinate_dofs[1] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[7] * FE8_C0_D001_Q24[0][0][1];
    const double J_c8 = coordinate_dofs[2] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[11] * FE8_C0_D001_Q24[0][0][1];
    const double J_c5 = coordinate_dofs[1] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[10] * FE8_C0_D001_Q24[0][0][1];
    const double J_c7 = coordinate_dofs[2] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[8] * FE8_C0_D001_Q24[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[6] * FE8_C0_D001_Q24[0][0][1];
    const double J_c6 = coordinate_dofs[2] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[5] * FE8_C0_D001_Q24[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[4] * FE8_C0_D001_Q24[0][0][1];
    const double J_c2 = coordinate_dofs[0] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[9] * FE8_C0_D001_Q24[0][0][1];
    alignas(32) double sp[15];
    sp[0] = J_c4 * J_c8;
    sp[1] = J_c5 * J_c7;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 * sp[2];
    sp[4] = J_c5 * J_c6;
    sp[5] = J_c3 * J_c8;
    sp[6] = sp[4] + -1 * sp[5];
    sp[7] = J_c1 * sp[6];
    sp[8] = sp[3] + sp[7];
    sp[9] = J_c3 * J_c7;
    sp[10] = J_c4 * J_c6;
    sp[11] = sp[9] + -1 * sp[10];
    sp[12] = J_c2 * sp[11];
    sp[13] = sp[8] + sp[12];
    sp[14] = std::abs(sp[13]);
    alignas(32) double BF0[20] = {};
    for (int iq = 0; iq < 24; ++iq)
    {
        // Quadrature loop body setup (num_points=24)
        // Unstructured varying computations for num_points=24
        double w0 = 0.0;
        for (int ic = 0; ic < 20; ++ic)
            w0 += w[0][ic] * FE11_C0_Q24[0][iq][ic];
        alignas(32) double sv24[1];
        sv24[0] = sp[14] * w0;
        const double fw0 = sv24[0] * weights24[iq];
        for (int i = 0; i < 20; ++i)
            BF0[i] += fw0 * FE11_C0_Q24[0][iq][i];
    }
    std::fill(&A[0], &A[20], 0.0);
    for (int i = 0; i < 20; ++i)
        A[i] += BF0[i];
}


poisson3d_3_form_0::poisson3d_3_form_0() : ufc::form()
{
    // Do nothing
}

poisson3d_3_form_0::~poisson3d_3_form_0()
{
    // Do nothing
}

const char * poisson3d_3_form_0::signature() const
{
    return "32fbe2e1df38410c6b4133633394262f461a2cbb3d064726f995f987d220bd4e750b2ce171b9522d6d654823b8ae499f06d085cb5fa006d6ba33cb84ae77a589";
}

std::size_t poisson3d_3_form_0::rank() const
{
    return 2;
}

std::size_t poisson3d_3_form_0::num_coefficients() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({});
    return position[i];
}

ufc::finite_element * poisson3d_3_form_0::create_coordinate_finite_element() const
{
    return new poisson3d_3_finite_element_1();
}

ufc::dofmap * poisson3d_3_form_0::create_coordinate_dofmap() const
{
    return new poisson3d_3_dofmap_1();
}

ufc::coordinate_mapping * poisson3d_3_form_0::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson3d_3_form_0::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_3_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson3d_3_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson3d_3_form_0::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_3_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson3d_3_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_form_0::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_0::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson3d_3_form_0::has_cell_integrals() const
{
    return true;
}

bool poisson3d_3_form_0::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson3d_3_form_0::has_interior_facet_integrals() const
{
    return false;
}

bool poisson3d_3_form_0::has_vertex_integrals() const
{
    return false;
}

bool poisson3d_3_form_0::has_custom_integrals() const
{
    return false;
}

bool poisson3d_3_form_0::has_cutcell_integrals() const
{
    return false;
}

bool poisson3d_3_form_0::has_interface_integrals() const
{
    return false;
}

bool poisson3d_3_form_0::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson3d_3_form_0::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson3d_3_form_0::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_3_form_0::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson3d_3_form_0::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson3d_3_form_0::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_3_form_0::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson3d_3_form_0::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson3d_3_form_0::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson3d_3_form_0::create_default_cell_integral() const
{
    return new poisson3d_3_cell_integral_0_otherwise();
}

ufc::exterior_facet_integral * poisson3d_3_form_0::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_3_form_0::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson3d_3_form_0::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson3d_3_form_0::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_3_form_0::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson3d_3_form_0::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson3d_3_form_0::create_default_overlap_integral() const
{
    return 0;
}


poisson3d_3_form_1::poisson3d_3_form_1() : ufc::form()
{
    // Do nothing
}

poisson3d_3_form_1::~poisson3d_3_form_1()
{
    // Do nothing
}

const char * poisson3d_3_form_1::signature() const
{
    return "4b354a66f56215a75c862ef25b8d88eb4d950dddca6f2c6ff25c356a255a6d03ee6cbf9c0a35aee037fa312537e8ad10f172e6dbe8024fb0aeb4ba05a474e7f0";
}

std::size_t poisson3d_3_form_1::rank() const
{
    return 1;
}

std::size_t poisson3d_3_form_1::num_coefficients() const
{
    return 1;
}

std::size_t poisson3d_3_form_1::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({0});
    return position[i];
}

ufc::finite_element * poisson3d_3_form_1::create_coordinate_finite_element() const
{
    return new poisson3d_3_finite_element_1();
}

ufc::dofmap * poisson3d_3_form_1::create_coordinate_dofmap() const
{
    return new poisson3d_3_dofmap_1();
}

ufc::coordinate_mapping * poisson3d_3_form_1::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson3d_3_form_1::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_3_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson3d_3_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson3d_3_form_1::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_3_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson3d_3_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_3_form_1::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_3_form_1::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson3d_3_form_1::has_cell_integrals() const
{
    return true;
}

bool poisson3d_3_form_1::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson3d_3_form_1::has_interior_facet_integrals() const
{
    return false;
}

bool poisson3d_3_form_1::has_vertex_integrals() const
{
    return false;
}

bool poisson3d_3_form_1::has_custom_integrals() const
{
    return false;
}

bool poisson3d_3_form_1::has_cutcell_integrals() const
{
    return false;
}

bool poisson3d_3_form_1::has_interface_integrals() const
{
    return false;
}

bool poisson3d_3_form_1::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson3d_3_form_1::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson3d_3_form_1::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_3_form_1::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson3d_3_form_1::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson3d_3_form_1::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_3_form_1::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson3d_3_form_1::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson3d_3_form_1::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson3d_3_form_1::create_default_cell_integral() const
{
    return new poisson3d_3_cell_integral_1_otherwise();
}

ufc::exterior_facet_integral * poisson3d_3_form_1::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_3_form_1::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson3d_3_form_1::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson3d_3_form_1::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_3_form_1::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson3d_3_form_1::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson3d_3_form_1::create_default_overlap_integral() const
{
    return 0;
}

