// This code conforms with the UFC specification version 2017.1.0
// and was automatically generated by FFC version 2017.1.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
// 
// This code was generated with the following parameters:
// 
//   add_tabulate_tensor_timing:     False
//   convert_exceptions_to_warnings: False
//   cpp_optimize:                   True
//   cpp_optimize_flags:             '-O2'
//   epsilon:                        1e-14
//   error_control:                  False
//   evaluate_basis:                 False
//   evaluate_basis_derivatives:     False
//   form_postfix:                   True
//   format:                         'dolfin'
//   generate_dummy_tabulate_tensor: False
//   max_signature_length:           0
//   optimize:                       True
//   precision:                      None
//   quadrature_degree:              None
//   quadrature_rule:                None
//   representation:                 'auto'
//   split:                          True

#include "Poisson3D_4.h"

poisson3d_4_finite_element_0::poisson3d_4_finite_element_0() : ufc::finite_element()
{
    // Do nothing
}

poisson3d_4_finite_element_0::~poisson3d_4_finite_element_0()
{
    // Do nothing
}

const char * poisson3d_4_finite_element_0::signature() const
{
    return "FiniteElement('Lagrange', tetrahedron, 1)";
}

ufc::shape poisson3d_4_finite_element_0::cell_shape() const
{
    return ufc::shape::tetrahedron;
}

std::size_t poisson3d_4_finite_element_0::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_0::geometric_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_0::space_dimension() const
{
    return 4;
}

std::size_t poisson3d_4_finite_element_0::value_rank() const
{
    return 0;
}

std::size_t poisson3d_4_finite_element_0::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_0::value_size() const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_0::reference_value_rank() const
{
    return 0;
}

std::size_t poisson3d_4_finite_element_0::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_0::reference_value_size() const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_0::degree() const
{
    return 1;
}

const char * poisson3d_4_finite_element_0::family() const
{
    return "Lagrange";
}

void poisson3d_4_finite_element_0::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_4_finite_element_0::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 4; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson3d_4_finite_element_0::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[3][1];
    for (unsigned int row = 0; row < 3; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 2)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[3][3] = {{K[0], K[1], K[2]}, {K[3], K[4], K[5]}, {K[6], K[7], K[8]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[3][3];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_4_finite_element_0::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 4; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[3];
    for (unsigned int r = 0; r < 3; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 4; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson3d_4_finite_element_0::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson3d_4_finite_element_0::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    y[2] = coordinate_dofs[2];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[3];
    y[1] = coordinate_dofs[4];
    y[2] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[6];
    y[1] = coordinate_dofs[7];
    y[2] = coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[9];
    y[1] = coordinate_dofs[10];
    y[2] = coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
}

void poisson3d_4_finite_element_0::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
    vertex_values[3] = dof_values[3];
}

void poisson3d_4_finite_element_0::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[6];
    dof_coordinates[7] = coordinate_dofs[7];
    dof_coordinates[8] = coordinate_dofs[8];
    dof_coordinates[9] = coordinate_dofs[9];
    dof_coordinates[10] = coordinate_dofs[10];
    dof_coordinates[11] = coordinate_dofs[11];
}

std::size_t poisson3d_4_finite_element_0::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson3d_4_finite_element_0::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson3d_4_finite_element_0::create() const
{
    return new poisson3d_4_finite_element_0();
}


poisson3d_4_finite_element_1::poisson3d_4_finite_element_1() : ufc::finite_element()
{
    // Do nothing
}

poisson3d_4_finite_element_1::~poisson3d_4_finite_element_1()
{
    // Do nothing
}

const char * poisson3d_4_finite_element_1::signature() const
{
    return "VectorElement(FiniteElement('Lagrange', tetrahedron, 1), dim=3)";
}

ufc::shape poisson3d_4_finite_element_1::cell_shape() const
{
    return ufc::shape::tetrahedron;
}

std::size_t poisson3d_4_finite_element_1::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_1::geometric_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_1::space_dimension() const
{
    return 12;
}

std::size_t poisson3d_4_finite_element_1::value_rank() const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_1::value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_finite_element_1::value_size() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_1::reference_value_rank() const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_1::reference_value_dimension(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return 3;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_finite_element_1::reference_value_size() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_1::degree() const
{
    return 1;
}

const char * poisson3d_4_finite_element_1::family() const
{
    return "Lagrange";
}

void poisson3d_4_finite_element_1::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    values[2] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 4; r++)
      {
        values[2] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_4_finite_element_1::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values[3] = {0.0, 0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 12; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 3; s++)
      {
        values[r*3 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

void poisson3d_4_finite_element_1::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 3*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[3][1];
    for (unsigned int row = 0; row < 3; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 2)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[3][3] = {{K[0], K[1], K[2]}, {K[3], K[4], K[5]}, {K[6], K[7], K[8]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[3][3];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.288675134594813, -0.1825741858350554, -0.105409255338946, -0.07453559924999298};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.1825741858350554, -0.105409255338946, -0.07453559924999296};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.210818510677892, -0.07453559924999299};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[4] = {0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[1] *= std::sqrt(7.5);
      
      // Table(s) of coefficients
      static const double coefficients0[4] = \
      {0.2886751345948129, 0.0, 0.0, 0.223606797749979};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {6.324555320336758, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {5.477225575051664, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[4][4] = \
      {{0.0, 0.0, 0.0, 0.0},
      {3.162277660168379, 0.0, 0.0, 0.0},
      {1.825741858350554, 0.0, 0.0, 0.0},
      {5.163977794943223, 0.0, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[3];
      for (unsigned int r = 0; r < 3; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[4][4] = \
      {{1.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 4; t++)
        {
          for (unsigned int u = 0; u < 4; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 4; t++)
          {
            for (unsigned int u = 0; u < 4; u++)
            {
              for (unsigned int tu = 0; tu < 4; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 4; s++)
        {
          for (unsigned int t = 0; t < 4; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[2*num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_4_finite_element_1::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 12; r++)
    {
      for (unsigned int s = 0; s < 3*num_derivatives; s++)
      {
        values[r*3*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[9];
    for (unsigned int r = 0; r < 9; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 12; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 3*num_derivatives; s++)
      {
        values[r*3*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson3d_4_finite_element_1::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[3];
    
    // Declare variable for physical coordinates
    double y[3];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 4:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 5:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 6:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 7:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 8:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    case 9:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    case 10:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    case 11:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[2];
        break;
      }
    }
    
    return 0.0;
}

void poisson3d_4_finite_element_1::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[3];
    
    // Declare variable for physical coordinates
    double y[3];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    y[2] = coordinate_dofs[2];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    values[4] = vals[1];
    values[8] = vals[2];
    y[0] = coordinate_dofs[3];
    y[1] = coordinate_dofs[4];
    y[2] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    values[5] = vals[1];
    values[9] = vals[2];
    y[0] = coordinate_dofs[6];
    y[1] = coordinate_dofs[7];
    y[2] = coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    values[6] = vals[1];
    values[10] = vals[2];
    y[0] = coordinate_dofs[9];
    y[1] = coordinate_dofs[10];
    y[2] = coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
    values[7] = vals[1];
    values[11] = vals[2];
}

void poisson3d_4_finite_element_1::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[3] = dof_values[1];
    vertex_values[6] = dof_values[2];
    vertex_values[9] = dof_values[3];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[4];
    vertex_values[4] = dof_values[5];
    vertex_values[7] = dof_values[6];
    vertex_values[10] = dof_values[7];
    // Evaluate function and change variables
    vertex_values[2] = dof_values[8];
    vertex_values[5] = dof_values[9];
    vertex_values[8] = dof_values[10];
    vertex_values[11] = dof_values[11];
}

void poisson3d_4_finite_element_1::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[6];
    dof_coordinates[7] = coordinate_dofs[7];
    dof_coordinates[8] = coordinate_dofs[8];
    dof_coordinates[9] = coordinate_dofs[9];
    dof_coordinates[10] = coordinate_dofs[10];
    dof_coordinates[11] = coordinate_dofs[11];
    dof_coordinates[12] = coordinate_dofs[0];
    dof_coordinates[13] = coordinate_dofs[1];
    dof_coordinates[14] = coordinate_dofs[2];
    dof_coordinates[15] = coordinate_dofs[3];
    dof_coordinates[16] = coordinate_dofs[4];
    dof_coordinates[17] = coordinate_dofs[5];
    dof_coordinates[18] = coordinate_dofs[6];
    dof_coordinates[19] = coordinate_dofs[7];
    dof_coordinates[20] = coordinate_dofs[8];
    dof_coordinates[21] = coordinate_dofs[9];
    dof_coordinates[22] = coordinate_dofs[10];
    dof_coordinates[23] = coordinate_dofs[11];
    dof_coordinates[24] = coordinate_dofs[0];
    dof_coordinates[25] = coordinate_dofs[1];
    dof_coordinates[26] = coordinate_dofs[2];
    dof_coordinates[27] = coordinate_dofs[3];
    dof_coordinates[28] = coordinate_dofs[4];
    dof_coordinates[29] = coordinate_dofs[5];
    dof_coordinates[30] = coordinate_dofs[6];
    dof_coordinates[31] = coordinate_dofs[7];
    dof_coordinates[32] = coordinate_dofs[8];
    dof_coordinates[33] = coordinate_dofs[9];
    dof_coordinates[34] = coordinate_dofs[10];
    dof_coordinates[35] = coordinate_dofs[11];
}

std::size_t poisson3d_4_finite_element_1::num_sub_elements() const
{
    return 3;
}

ufc::finite_element * poisson3d_4_finite_element_1::create_sub_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_4_finite_element_0();
        break;
      }
    case 1:
      {
        return new poisson3d_4_finite_element_0();
        break;
      }
    case 2:
      {
        return new poisson3d_4_finite_element_0();
        break;
      }
    }
    
    return 0;
}

ufc::finite_element * poisson3d_4_finite_element_1::create() const
{
    return new poisson3d_4_finite_element_1();
}


poisson3d_4_finite_element_2::poisson3d_4_finite_element_2() : ufc::finite_element()
{
    // Do nothing
}

poisson3d_4_finite_element_2::~poisson3d_4_finite_element_2()
{
    // Do nothing
}

const char * poisson3d_4_finite_element_2::signature() const
{
    return "FiniteElement('Lagrange', tetrahedron, 4)";
}

ufc::shape poisson3d_4_finite_element_2::cell_shape() const
{
    return ufc::shape::tetrahedron;
}

std::size_t poisson3d_4_finite_element_2::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_2::geometric_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_finite_element_2::space_dimension() const
{
    return 35;
}

std::size_t poisson3d_4_finite_element_2::value_rank() const
{
    return 0;
}

std::size_t poisson3d_4_finite_element_2::value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_2::value_size() const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_2::reference_value_rank() const
{
    return 0;
}

std::size_t poisson3d_4_finite_element_2::reference_value_dimension(std::size_t i) const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_2::reference_value_size() const
{
    return 1;
}

std::size_t poisson3d_4_finite_element_2::degree() const
{
    return 4;
}

const char * poisson3d_4_finite_element_2::family() const
{
    return "Lagrange";
}

void poisson3d_4_finite_element_2::_evaluate_basis(std::size_t i,
                                    double * values,
                                    const double * x,
                                    const double * coordinate_dofs,
                                    int cell_orientation)
{
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070516, -0.01449001474881393, -0.008365813915789359, -0.005915523749999427, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.006719368409052932, -0.005678902799999472, -0.004918074090422123, -0.004398859193825722, -0.003809523809523813, -0.003110463165438962, -0.002539682539682542, -0.002199429596912858, -0.001795826745870597, -0.001269841269841281, 0.01369802895163412, 0.01208052601926224, 0.01080515095321011, 0.01020990796453802, 0.00913201930108941, 0.007908560702593244, 0.007908560702593251, 0.007073631734072796, 0.006125944778722815, 0.005001812966779232, 0.004566009650544716, 0.004083963185815211, 0.003536815867036398, 0.002887798062806154, 0.002041981592907613};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070539, 0.01449001474881389, -0.008365813915789336, -0.005915523749999416, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.006719368409052916, -0.005678902799999469, -0.004918074090422118, 0.004398859193825718, 0.003809523809523802, 0.003110463165438965, -0.002539682539682543, -0.002199429596912867, -0.0017958267458706, -0.001269841269841278, 0.01369802895163412, -0.01208052601926223, -0.01080515095321013, 0.01020990796453803, 0.009132019301089414, 0.007908560702593258, -0.007908560702593263, -0.007073631734072805, -0.006125944778722817, -0.005001812966779238, 0.00456600965054471, 0.004083963185815217, 0.003536815867036401, 0.002887798062806152, 0.002041981592907608};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070541, 0.0, 0.0167316278315787, -0.005915523749999463, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.01015873015873016, -0.006598288790738578, 0.003591653491741187, -0.001269841269841255, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.02283004825272355, -0.01633585274326085, 0.01061044760110921, -0.005775596125612305, 0.002041981592907607};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070541, 0.0, 0.0, 0.01774657124999831, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0126984126984127, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03062972389361409};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825717, 0.0, 0.0267706045305259, 0.01892967599999825, 0.0, 0.0, 0.0, 0.05819143739626462, -0.03167540644887994, 0.01119894734842155, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04063492063492063, 0.004398859193825729, -0.01436661396696476, 0.007619047619047604, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03675566867233689, -0.0424417904044368, 0.03032187965946458, -0.01225188955744563};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369298, 0.0, -0.02007795339789445, -0.0141972569999987, 0.0, 0.0, 0.0, -0.009698572899377438, 0.07126966450997985, -0.050395263067897, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04618802153517005, 0.01077496047522356, -0.01904761904761903, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04951542213850962, -0.06064375931892915, 0.03062972389361408};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825719, 0.0, 0.02677060453052596, 0.01892967599999822, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06719368409052932, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03591653491741194, 0.02539682539682541, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05053646609910763, -0.04083963185815213};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825708, 0.02318402359810225, -0.01338530226526292, 0.01892967599999823, 0.04337333657549038, -0.03359684204526465, -0.02743170665992748, 0.01939714579875487, 0.01583770322443997, 0.01119894734842158, 0.02687747363621172, -0.02271561119999788, 0.003278716060281401, 0.01759543677530287, -0.002539682539682555, -0.01244185266175583, -0.01015873015873016, 0.001466286397941899, 0.00718330698348237, 0.0076190476190476, 0.0, 0.0, 0.02431158964472277, 0.0, -0.0205470434274512, -0.03163424281037301, 0.0, 0.0159156714016638, 0.02450377911489126, 0.02625951807559097, 0.0, -0.009188917168084223, -0.0141472634681456, -0.01516093982973228, -0.01225188955744563};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369305, -0.01738801769857669, 0.01003897669894715, -0.01419725699999869, -0.007228889429248391, 0.00559947367421076, 0.0617213399848368, -0.003232857633125809, -0.03563483225498995, -0.05039526306789702, 0.0, 0.0, 0.03442651863295484, 0.0, -0.02666666666666665, 0.009331389496316874, 0.0, 0.01539600717839002, -0.005387480237611767, -0.01904761904761903, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03690661661210184, 0.0, 0.0, -0.02858774230070646, -0.05251903615118195, 0.0, 0.0, 0.01650514071283653, 0.03032187965946458, 0.03062972389361409};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825729, 0.0231840235981023, -0.01338530226526295, 0.01892967599999821, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06719368409052932, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03110463165438955, 0.0, 0.0, -0.01795826745870598, 0.02539682539682542, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04376586345931829, 0.0, 0.0, 0.0, -0.02526823304955382, -0.04083963185815213};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825719, 0.02318402359810225, 0.01338530226526302, -0.01892967599999821, 0.04337333657549038, -0.03359684204526468, -0.02743170665992747, 0.01939714579875485, 0.01583770322443998, 0.01119894734842155, 0.02687747363621172, 0.0, -0.02295101242196988, -0.01173029118353525, 0.00761904761904761, 0.01658913688234111, 0.01015873015873016, -0.001466286397941899, -0.0071833069834824, -0.007619047619047614, 0.0, 0.02416105203852448, -0.002701287738302526, -0.0357346778758831, -0.01141502412636178, 0.003954280351296617, 0.03558852316166964, 0.01591567140166381, 0.003062972389361414, -0.003751359725084425, -0.02283004825272353, -0.01123089876099184, -0.003536815867036393, 0.000721949515701543, 0.002041981592907603};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369302, -0.01738801769857674, -0.01003897669894724, 0.01419725699999864, -0.007228889429248393, 0.0615942104163185, -0.006857926664981869, -0.06142429502939046, -0.003959425806110004, 0.005599473674210766, 0.0, 0.03407341679999679, -0.004918074090422114, 0.0, -0.02666666666666667, 0.00933138949631686, -0.01523809523809524, 0.01759543677530288, 0.005387480237611798, -0.007619047619047591, 0.0, 0.0, 0.0, 0.03573467787588309, -0.009132019301089409, 0.001318093450432208, -0.05931420526944938, 0.0, 0.007146935575176609, -0.002500906483389622, 0.04566009650544709, 0.004083963185815217, -0.004715754489381859, -0.001443899031403076, 0.002041981592907598};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825716, 0.02318402359810225, 0.01338530226526296, -0.01892967599999819, 0.0, 0.0, 0.0, 0.05819143739626465, -0.03167540644887992, 0.01119894734842155, 0.0, 0.0, 0.0, 0.02932572795883814, -0.01015873015873017, 0.002073642110292642, 0.01015873015873016, -0.0219942959691286, 0.01795826745870599, -0.007619047619047636, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03954280351296625, -0.017684079335182, 0.006125944778722825, -0.001250453241694806, -0.04566009650544709, 0.01429387115035324, 0.0, -0.003609747578507694, 0.00204198159290761};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.0439885919382571, -0.0231840235981022, -0.01338530226526303, 0.01892967599999826, 0.04337333657549036, 0.03359684204526466, 0.02743170665992745, 0.01939714579875488, 0.01583770322443995, 0.01119894734842157, -0.02687747363621172, -0.02271561119999784, 0.003278716060281415, -0.01759543677530285, 0.002539682539682542, 0.01244185266175582, -0.01015873015873013, 0.001466286397941895, 0.00718330698348239, 0.007619047619047615, 0.0, 0.0, -0.02431158964472276, 0.0, -0.02054704342745118, -0.03163424281037299, 0.0, -0.01591567140166378, -0.02450377911489127, -0.02625951807559097, 0.0, -0.009188917168084202, -0.01414726346814561, -0.01516093982973229, -0.01225188955744564};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369279, 0.01738801769857665, 0.01003897669894724, -0.01419725699999868, -0.00722888942924836, -0.005599473674210774, -0.06172133998483678, -0.003232857633125814, -0.03563483225498995, -0.05039526306789702, 0.0, 0.0, 0.03442651863295483, 0.0, 0.02666666666666667, -0.009331389496316851, 0.0, 0.01539600717839001, -0.005387480237611784, -0.01904761904761905, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03690661661210181, 0.0, 0.0, 0.02858774230070648, 0.05251903615118194, 0.0, 0.0, 0.01650514071283654, 0.0303218796594646, 0.0306297238936141};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 15:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825719, -0.02318402359810219, -0.01338530226526297, 0.01892967599999822, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06719368409052934, 0.0, 0.0, 0.0, 0.0, 0.0, -0.03110463165438958, 0.0, 0.0, -0.01795826745870598, 0.02539682539682541, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.04376586345931828, 0.0, 0.0, 0.0, -0.02526823304955383, -0.04083963185815213};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 16:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825707, -0.02318402359810231, 0.01338530226526298, -0.01892967599999824, 0.04337333657549039, 0.03359684204526466, 0.02743170665992743, 0.01939714579875489, 0.01583770322443995, 0.01119894734842156, -0.02687747363621172, 0.0, -0.02295101242196987, 0.01173029118353526, -0.007619047619047619, -0.0165891368823411, 0.01015873015873017, -0.001466286397941911, -0.007183306983482378, -0.007619047619047623, 0.0, -0.02416105203852448, 0.002701287738302527, -0.03573467787588309, -0.01141502412636176, 0.003954280351296629, -0.03558852316166963, -0.0159156714016638, -0.003062972389361414, 0.003751359725084423, -0.02283004825272355, -0.01123089876099182, -0.003536815867036398, 0.0007219495157015355, 0.002041981592907604};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 17:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369279, 0.01738801769857666, -0.0100389766989472, 0.01419725699999864, -0.007228889429248401, -0.06159421041631855, 0.006857926664981881, -0.06142429502939047, -0.003959425806109963, 0.005599473674210756, 0.0, 0.03407341679999679, -0.0049180740904221, 0.0, 0.02666666666666666, -0.009331389496316882, -0.01523809523809526, 0.0175954367753029, 0.005387480237611767, -0.00761904761904759, 0.0, 0.0, 0.0, 0.03573467787588309, -0.009132019301089405, 0.001318093450432206, 0.05931420526944936, 0.0, -0.007146935575176628, 0.002500906483389618, 0.04566009650544711, 0.004083963185815189, -0.00471575448938186, -0.001443899031403069, 0.002041981592907601};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 18:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825713, -0.02318402359810228, 0.01338530226526297, -0.01892967599999822, 0.0, 0.0, 0.0, 0.05819143739626467, -0.03167540644887992, 0.01119894734842155, 0.0, 0.0, 0.0, -0.02932572795883813, 0.01015873015873015, -0.002073642110292627, 0.01015873015873015, -0.0219942959691286, 0.01795826745870598, -0.007619047619047628, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.03954280351296625, 0.017684079335182, -0.006125944778722803, 0.001250453241694811, -0.0456600965054471, 0.01429387115035323, 0.0, -0.003609747578507696, 0.002041981592907605};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 19:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825708, 0.0, -0.02677060453052591, -0.01892967599999822, 0.04337333657549037, 0.03359684204526463, 0.02743170665992744, 0.01939714579875489, 0.01583770322443998, 0.01119894734842154, 0.01343873681810584, -0.01135780559999893, -0.009836148180844242, -0.02052800957118667, -0.01777777777777778, -0.01451549477204845, -0.01523809523809526, -0.01319657758147717, -0.01077496047522359, -0.007619047619047621, -0.05479211580653651, -0.02416105203852446, -0.02161030190642023, -0.005104953982269014, -0.004566009650544714, -0.003954280351296622, 0.003954280351296629, 0.003536815867036403, 0.003062972389361407, 0.002500906483389605, 0.004566009650544718, 0.004083963185815206, 0.003536815867036399, 0.002887798062806159, 0.002041981592907607};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 20:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369306, 0.0, 0.02007795339789444, 0.01419725699999863, -0.08674667315098074, 0.0, 0.0, 0.009698572899377448, 0.007918851612219993, 0.005599473674210793, 0.0, 0.03407341679999678, 0.02950844454253271, 0.0, 0.0, 0.0, -0.01523809523809522, -0.01319657758147717, -0.0107749604752236, -0.007619047619047623, 0.08218817370980473, 0.0, 0.0, -0.01020990796453802, -0.009132019301089414, -0.007908560702593251, 0.0, 0.0, 0.0, 0.0, 0.004566009650544692, 0.004083963185815206, 0.003536815867036396, 0.002887798062806154, 0.002041981592907599};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 21:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825739, 0.0, -0.02677060453052591, -0.01892967599999822, 0.04337333657549036, -0.03359684204526465, -0.02743170665992747, 0.01939714579875487, 0.01583770322443997, 0.01119894734842154, -0.01343873681810586, -0.01135780559999893, -0.00983614818084424, 0.0205280095711867, 0.01777777777777778, 0.01451549477204847, -0.01523809523809525, -0.01319657758147716, -0.01077496047522358, -0.007619047619047621, -0.0547921158065365, 0.02416105203852448, 0.02161030190642024, -0.005104953982269015, -0.004566009650544715, -0.003954280351296627, -0.003954280351296623, -0.003536815867036393, -0.003062972389361405, -0.002500906483389624, 0.004566009650544716, 0.004083963185815208, 0.0035368158670364, 0.00288779806280616, 0.002041981592907609};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 22:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825711, 0.1391041415886136, -0.08031181359157794, -0.05678902799999466, 0.05783111543398714, 0.03359684204526459, 0.02743170665992746, -0.04202714923063559, -0.04751310967331988, -0.01679842102263234, 0.0, 0.0454312223999957, 0.03934459272337693, -0.05865145591767626, 0.002539682539682541, -0.06013562119848649, 0.04063492063492063, -0.01099714798456428, 0.01795826745870598, 0.03936507936507937, 0.0, 0.0, 0.0, 0.0, 0.04109408685490236, -0.01054474760345766, 0.0, -0.05305223800554602, -0.02450377911489125, 0.01750634538372733, 0.0, 0.0367556686723369, 0.02357877244690935, 0.0, -0.01225188955744563};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 23:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825724, 0.0, 0.1606236271831558, -0.05678902799999466, 0.0, 0.07839263143895082, -0.02743170665992744, 0.009698572899377419, 0.04751310967331988, -0.01679842102263228, 0.0, 0.0, 0.0, 0.05865145591767622, 0.03301587301587303, -0.01451549477204845, -0.06095238095238094, 0.02419372556604145, -0.06105810935960029, 0.03936507936507937, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05305223800554598, -0.03267170548652169, 0.008753172691863662, 0.0, -0.05513350300850535, 0.01414726346814559, 0.0151609398297323, -0.01225188955744565};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 24:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825716, 0.0, 0.0, 0.170367083999984, 0.0, -0.01119894734842152, 0.08229511997978234, 0.00969857289937744, 0.04751310967331991, -0.01679842102263236, 0.0, 0.0, 0.0, 0.0, 0.05333333333333334, 0.04354648431614532, 0.0, -0.04618802153517006, 0.02514157444218837, -0.08253968253968254, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05717548460141293, -0.026259518075591, 0.0, 0.0, -0.0495154221385096, -0.01516093982973227, 0.0306297238936141};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 25:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825744, -0.1391041415886136, -0.08031181359157784, -0.05678902799999468, 0.05783111543398711, -0.03359684204526461, -0.02743170665992741, -0.04202714923063558, -0.0475131096733199, -0.01679842102263233, 0.0, 0.04543122239999572, 0.03934459272337695, 0.05865145591767626, -0.002539682539682534, 0.06013562119848649, 0.04063492063492063, -0.01099714798456428, 0.01795826745870598, 0.03936507936507937, 0.0, 0.0, 0.0, 0.0, 0.04109408685490237, -0.01054474760345766, 0.0, 0.053052238005546, 0.02450377911489128, -0.01750634538372731, 0.0, 0.0367556686723369, 0.02357877244690935, 0.0, -0.01225188955744563};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 26:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825737, 0.0, 0.1606236271831559, -0.05678902799999459, 0.0, -0.07839263143895082, 0.02743170665992744, 0.009698572899377434, 0.04751310967331988, -0.01679842102263229, 0.0, 0.0, 0.0, -0.05865145591767625, -0.03301587301587302, 0.01451549477204849, -0.06095238095238095, 0.02419372556604144, -0.06105810935960031, 0.03936507936507935, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.05305223800554598, 0.03267170548652169, -0.00875317269186366, 0.0, -0.05513350300850535, 0.01414726346814558, 0.0151609398297323, -0.01225188955744564};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 27:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825697, 0.0, 0.0, 0.1703670839999839, 0.0, 0.01119894734842154, -0.08229511997978235, 0.009698572899377401, 0.04751310967331989, -0.01679842102263238, 0.0, 0.0, 0.0, 0.0, -0.05333333333333335, -0.04354648431614538, 0.0, -0.04618802153517006, 0.02514157444218837, -0.08253968253968252, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.05717548460141295, 0.02625951807559097, 0.0, 0.0, -0.04951542213850959, -0.01516093982973228, 0.0306297238936141};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 28:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825692, -0.1391041415886136, -0.08031181359157792, -0.05678902799999461, -0.04337333657549037, 0.04479578939368625, -0.05486341331985491, 0.04849286449688722, 0.0, -0.01679842102263233, 0.08063242090863514, 0.02271561119999786, -0.00327871606028143, -0.005865145591767621, 0.03047619047619049, 0.04562012642643801, -0.01015873015873016, 0.02712629836192527, 0.04309984190089435, 0.03936507936507936, 0.0, 0.0, 0.07293476893416828, 0.0, 0.02054704342745118, 0.03163424281037298, 0.0, -0.005305223800554608, -0.008167926371630418, -0.008753172691863657, 0.0, -0.009188917168084213, -0.01414726346814561, -0.0151609398297323, -0.01225188955744563};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 29:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825718, 0.1391041415886137, -0.08031181359157794, -0.05678902799999466, -0.04337333657549035, -0.04479578939368619, 0.05486341331985492, 0.04849286449688723, 0.0, -0.01679842102263231, -0.08063242090863515, 0.02271561119999787, -0.003278716060281405, 0.005865145591767631, -0.03047619047619048, -0.04562012642643801, -0.01015873015873016, 0.02712629836192527, 0.04309984190089433, 0.03936507936507935, 0.0, 0.0, -0.0729347689341683, 0.0, 0.02054704342745119, 0.031634242810373, 0.0, 0.005305223800554598, 0.008167926371630416, 0.008753172691863669, 0.0, -0.009188917168084218, -0.01414726346814561, -0.0151609398297323, -0.01225188955744563};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 30:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825739, 0.0, 0.0, 0.170367083999984, 0.01445777885849676, 0.0, 0.0, -0.003232857633125829, -0.09502621934663978, -0.01679842102263237, 0.0, 0.0, -0.06885303726590963, 0.0, 0.0, 0.0, 0.0, 0.01539600717839001, -0.0502831488843767, -0.08253968253968252, 0.0, 0.0, 0.0, 0.0, 0.0, -0.07381323322420365, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.01650514071283654, 0.03032187965946459, 0.03062972389361408};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 31:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825705, -0.1391041415886136, -0.08031181359157795, -0.05678902799999466, -0.04337333657549038, -0.04479578939368619, 0.0548634133198549, -0.009698572899377422, 0.03167540644887994, 0.03919631571947543, 0.08063242090863514, 0.0, 0.02295101242196987, 0.05278631032590864, 0.01015873015873017, -0.01244185266175584, 0.06095238095238097, 0.01686229357633193, -0.007183306983482363, -0.01396825396825398, 0.0, 0.0724831561155734, -0.008103863214907603, 0.03573467787588309, 0.01141502412636176, -0.003954280351296626, -0.01186284105388988, -0.005305223800554585, -0.001020990796453802, 0.001250453241694826, -0.02283004825272355, -0.01123089876099182, -0.003536815867036396, 0.0007219495157015157, 0.002041981592907609};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 32:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825724, 0.1391041415886136, -0.08031181359157794, -0.0567890279999947, -0.04337333657549036, 0.04479578939368623, -0.05486341331985491, -0.009698572899377419, 0.03167540644887994, 0.03919631571947544, -0.08063242090863514, 0.0, 0.02295101242196989, -0.05278631032590862, -0.01015873015873017, 0.01244185266175583, 0.06095238095238097, 0.01686229357633193, -0.007183306983482369, -0.01396825396825397, 0.0, -0.0724831561155734, 0.008103863214907589, 0.03573467787588309, 0.01141502412636178, -0.00395428035129662, 0.01186284105388987, 0.005305223800554588, 0.001020990796453803, -0.001250453241694806, -0.02283004825272356, -0.01123089876099182, -0.003536815867036388, 0.0007219495157015189, 0.002041981592907606};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 33:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825713, 0.0, 0.1606236271831558, -0.05678902799999469, 0.0144577788584968, 0.0, 0.0, -0.0614242950293905, -0.06335081289775983, 0.03919631571947543, 0.0, -0.06814683359999359, 0.009836148180844245, 0.0, 0.0, 0.0, -0.09142857142857144, 0.02859258475986718, 0.01436661396696472, -0.01396825396825393, 0.0, 0.0, 0.0, -0.07146935575176618, 0.01826403860217883, -0.002636186900864421, 0.0, 0.0, 0.0, 0.0, 0.04566009650544711, 0.004083963185815182, -0.004715754489381878, -0.001443899031403046, 0.00204198159290758};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 34:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.3519087355060579, 0.0, 0.0, 0.0, -0.1156622308679743, 0.0, 0.0, -0.1293143053250325, 0.0, -0.1343873681810586, 0.0, -0.09086244479999145, -0.07868918544675392, 0.0, 0.0, 0.0, 0.04063492063492061, -0.08797718387651439, 0.0, 0.07111111111111107, 0.0, 0.0, 0.0, 0.0, -0.08218817370980473, 0.02108949520691531, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03675566867233688, 0.02357877244690934, 0.0, -0.0122518895574456};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 35; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_4_finite_element_2::_evaluate_basis_all(double * values,
                                        const double * x,
                                        const double * coordinate_dofs,
                                        int cell_orientation)
{
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 35; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
}

void poisson3d_4_finite_element_2::_evaluate_basis_derivatives(std::size_t i,
                                                std::size_t n,
                                                double * values,
                                                const double * x,
                                                const double * coordinate_dofs,
                                                int cell_orientation)
{
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 4)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[9];
    compute_jacobian_tetrahedron_3d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[9];
    double detJ;
    compute_jacobian_inverse_tetrahedron_3d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[9]  + coordinate_dofs[6] + coordinate_dofs[3]  - coordinate_dofs[0];
    const double C1 = coordinate_dofs[10] + coordinate_dofs[7] + coordinate_dofs[4]  - coordinate_dofs[1];
    const double C2 = coordinate_dofs[11] + coordinate_dofs[8] + coordinate_dofs[5]  - coordinate_dofs[2];
    
    // Compute subdeterminants
    const double d_00 = J[4]*J[8] - J[5]*J[7];
    const double d_01 = J[5]*J[6] - J[3]*J[8];
    const double d_02 = J[3]*J[7] - J[4]*J[6];
    const double d_10 = J[2]*J[7] - J[1]*J[8];
    const double d_11 = J[0]*J[8] - J[2]*J[6];
    const double d_12 = J[1]*J[6] - J[0]*J[7];
    const double d_20 = J[1]*J[5] - J[2]*J[4];
    const double d_21 = J[2]*J[3] - J[0]*J[5];
    const double d_22 = J[0]*J[4] - J[1]*J[3];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (d_00*(2.0*x[0] - C0) + d_10*(2.0*x[1] - C1) + d_20*(2.0*x[2] - C2)) / detJ;
    double Y = (d_01*(2.0*x[0] - C0) + d_11*(2.0*x[1] - C1) + d_21*(2.0*x[2] - C2)) / detJ;
    double Z = (d_02*(2.0*x[0] - C0) + d_12*(2.0*x[1] - C1) + d_22*(2.0*x[2] - C2)) / detJ;
    
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[81][4];
    for (unsigned int row = 0; row < 81; row++)
    {
      for (unsigned int col = 0; col < 4; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 2)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[3][3] = {{K[0], K[1], K[2]}, {K[3], K[4], K[5]}, {K[6], K[7], K[8]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[81][81];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070516, -0.01449001474881393, -0.008365813915789359, -0.005915523749999427, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.006719368409052932, -0.005678902799999472, -0.004918074090422123, -0.004398859193825722, -0.003809523809523813, -0.003110463165438962, -0.002539682539682542, -0.002199429596912858, -0.001795826745870597, -0.001269841269841281, 0.01369802895163412, 0.01208052601926224, 0.01080515095321011, 0.01020990796453802, 0.00913201930108941, 0.007908560702593244, 0.007908560702593251, 0.007073631734072796, 0.006125944778722815, 0.005001812966779232, 0.004566009650544716, 0.004083963185815211, 0.003536815867036398, 0.002887798062806154, 0.002041981592907613};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070539, 0.01449001474881389, -0.008365813915789336, -0.005915523749999416, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.006719368409052916, -0.005678902799999469, -0.004918074090422118, 0.004398859193825718, 0.003809523809523802, 0.003110463165438965, -0.002539682539682543, -0.002199429596912867, -0.0017958267458706, -0.001269841269841278, 0.01369802895163412, -0.01208052601926223, -0.01080515095321013, 0.01020990796453803, 0.009132019301089414, 0.007908560702593258, -0.007908560702593263, -0.007073631734072805, -0.006125944778722817, -0.005001812966779238, 0.00456600965054471, 0.004083963185815217, 0.003536815867036401, 0.002887798062806152, 0.002041981592907608};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070541, 0.0, 0.0167316278315787, -0.005915523749999463, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.01015873015873016, -0.006598288790738578, 0.003591653491741187, -0.001269841269841255, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.02283004825272355, -0.01633585274326085, 0.01061044760110921, -0.005775596125612305, 0.002041981592907607};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.01374643498070541, 0.0, 0.0, 0.01774657124999831, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0126984126984127, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03062972389361409};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825717, 0.0, 0.0267706045305259, 0.01892967599999825, 0.0, 0.0, 0.0, 0.05819143739626462, -0.03167540644887994, 0.01119894734842155, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04063492063492063, 0.004398859193825729, -0.01436661396696476, 0.007619047619047604, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03675566867233689, -0.0424417904044368, 0.03032187965946458, -0.01225188955744563};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369298, 0.0, -0.02007795339789445, -0.0141972569999987, 0.0, 0.0, 0.0, -0.009698572899377438, 0.07126966450997985, -0.050395263067897, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04618802153517005, 0.01077496047522356, -0.01904761904761903, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04951542213850962, -0.06064375931892915, 0.03062972389361408};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825719, 0.0, 0.02677060453052596, 0.01892967599999822, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06719368409052932, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03591653491741194, 0.02539682539682541, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05053646609910763, -0.04083963185815213};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825708, 0.02318402359810225, -0.01338530226526292, 0.01892967599999823, 0.04337333657549038, -0.03359684204526465, -0.02743170665992748, 0.01939714579875487, 0.01583770322443997, 0.01119894734842158, 0.02687747363621172, -0.02271561119999788, 0.003278716060281401, 0.01759543677530287, -0.002539682539682555, -0.01244185266175583, -0.01015873015873016, 0.001466286397941899, 0.00718330698348237, 0.0076190476190476, 0.0, 0.0, 0.02431158964472277, 0.0, -0.0205470434274512, -0.03163424281037301, 0.0, 0.0159156714016638, 0.02450377911489126, 0.02625951807559097, 0.0, -0.009188917168084223, -0.0141472634681456, -0.01516093982973228, -0.01225188955744563};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369305, -0.01738801769857669, 0.01003897669894715, -0.01419725699999869, -0.007228889429248391, 0.00559947367421076, 0.0617213399848368, -0.003232857633125809, -0.03563483225498995, -0.05039526306789702, 0.0, 0.0, 0.03442651863295484, 0.0, -0.02666666666666665, 0.009331389496316874, 0.0, 0.01539600717839002, -0.005387480237611767, -0.01904761904761903, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03690661661210184, 0.0, 0.0, -0.02858774230070646, -0.05251903615118195, 0.0, 0.0, 0.01650514071283653, 0.03032187965946458, 0.03062972389361409};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825729, 0.0231840235981023, -0.01338530226526295, 0.01892967599999821, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06719368409052932, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03110463165438955, 0.0, 0.0, -0.01795826745870598, 0.02539682539682542, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.04376586345931829, 0.0, 0.0, 0.0, -0.02526823304955382, -0.04083963185815213};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825719, 0.02318402359810225, 0.01338530226526302, -0.01892967599999821, 0.04337333657549038, -0.03359684204526468, -0.02743170665992747, 0.01939714579875485, 0.01583770322443998, 0.01119894734842155, 0.02687747363621172, 0.0, -0.02295101242196988, -0.01173029118353525, 0.00761904761904761, 0.01658913688234111, 0.01015873015873016, -0.001466286397941899, -0.0071833069834824, -0.007619047619047614, 0.0, 0.02416105203852448, -0.002701287738302526, -0.0357346778758831, -0.01141502412636178, 0.003954280351296617, 0.03558852316166964, 0.01591567140166381, 0.003062972389361414, -0.003751359725084425, -0.02283004825272353, -0.01123089876099184, -0.003536815867036393, 0.000721949515701543, 0.002041981592907603};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369302, -0.01738801769857674, -0.01003897669894724, 0.01419725699999864, -0.007228889429248393, 0.0615942104163185, -0.006857926664981869, -0.06142429502939046, -0.003959425806110004, 0.005599473674210766, 0.0, 0.03407341679999679, -0.004918074090422114, 0.0, -0.02666666666666667, 0.00933138949631686, -0.01523809523809524, 0.01759543677530288, 0.005387480237611798, -0.007619047619047591, 0.0, 0.0, 0.0, 0.03573467787588309, -0.009132019301089409, 0.001318093450432208, -0.05931420526944938, 0.0, 0.007146935575176609, -0.002500906483389622, 0.04566009650544709, 0.004083963185815217, -0.004715754489381859, -0.001443899031403076, 0.002041981592907598};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825716, 0.02318402359810225, 0.01338530226526296, -0.01892967599999819, 0.0, 0.0, 0.0, 0.05819143739626465, -0.03167540644887992, 0.01119894734842155, 0.0, 0.0, 0.0, 0.02932572795883814, -0.01015873015873017, 0.002073642110292642, 0.01015873015873016, -0.0219942959691286, 0.01795826745870599, -0.007619047619047636, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03954280351296625, -0.017684079335182, 0.006125944778722825, -0.001250453241694806, -0.04566009650544709, 0.01429387115035324, 0.0, -0.003609747578507694, 0.00204198159290761};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.0439885919382571, -0.0231840235981022, -0.01338530226526303, 0.01892967599999826, 0.04337333657549036, 0.03359684204526466, 0.02743170665992745, 0.01939714579875488, 0.01583770322443995, 0.01119894734842157, -0.02687747363621172, -0.02271561119999784, 0.003278716060281415, -0.01759543677530285, 0.002539682539682542, 0.01244185266175582, -0.01015873015873013, 0.001466286397941895, 0.00718330698348239, 0.007619047619047615, 0.0, 0.0, -0.02431158964472276, 0.0, -0.02054704342745118, -0.03163424281037299, 0.0, -0.01591567140166378, -0.02450377911489127, -0.02625951807559097, 0.0, -0.009188917168084202, -0.01414726346814561, -0.01516093982973229, -0.01225188955744564};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369279, 0.01738801769857665, 0.01003897669894724, -0.01419725699999868, -0.00722888942924836, -0.005599473674210774, -0.06172133998483678, -0.003232857633125814, -0.03563483225498995, -0.05039526306789702, 0.0, 0.0, 0.03442651863295483, 0.0, 0.02666666666666667, -0.009331389496316851, 0.0, 0.01539600717839001, -0.005387480237611784, -0.01904761904761905, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03690661661210181, 0.0, 0.0, 0.02858774230070648, 0.05251903615118194, 0.0, 0.0, 0.01650514071283654, 0.0303218796594646, 0.0306297238936141};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 15:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825719, -0.02318402359810219, -0.01338530226526297, 0.01892967599999822, 0.0, 0.0, 0.0, 0.0, 0.0, 0.06719368409052934, 0.0, 0.0, 0.0, 0.0, 0.0, -0.03110463165438958, 0.0, 0.0, -0.01795826745870598, 0.02539682539682541, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.04376586345931828, 0.0, 0.0, 0.0, -0.02526823304955383, -0.04083963185815213};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 16:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825707, -0.02318402359810231, 0.01338530226526298, -0.01892967599999824, 0.04337333657549039, 0.03359684204526466, 0.02743170665992743, 0.01939714579875489, 0.01583770322443995, 0.01119894734842156, -0.02687747363621172, 0.0, -0.02295101242196987, 0.01173029118353526, -0.007619047619047619, -0.0165891368823411, 0.01015873015873017, -0.001466286397941911, -0.007183306983482378, -0.007619047619047623, 0.0, -0.02416105203852448, 0.002701287738302527, -0.03573467787588309, -0.01141502412636176, 0.003954280351296629, -0.03558852316166963, -0.0159156714016638, -0.003062972389361414, 0.003751359725084423, -0.02283004825272355, -0.01123089876099182, -0.003536815867036398, 0.0007219495157015355, 0.002041981592907604};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 17:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369279, 0.01738801769857666, -0.0100389766989472, 0.01419725699999864, -0.007228889429248401, -0.06159421041631855, 0.006857926664981881, -0.06142429502939047, -0.003959425806109963, 0.005599473674210756, 0.0, 0.03407341679999679, -0.0049180740904221, 0.0, 0.02666666666666666, -0.009331389496316882, -0.01523809523809526, 0.0175954367753029, 0.005387480237611767, -0.00761904761904759, 0.0, 0.0, 0.0, 0.03573467787588309, -0.009132019301089405, 0.001318093450432206, 0.05931420526944936, 0.0, -0.007146935575176628, 0.002500906483389618, 0.04566009650544711, 0.004083963185815189, -0.00471575448938186, -0.001443899031403069, 0.002041981592907601};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 18:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825713, -0.02318402359810228, 0.01338530226526297, -0.01892967599999822, 0.0, 0.0, 0.0, 0.05819143739626467, -0.03167540644887992, 0.01119894734842155, 0.0, 0.0, 0.0, -0.02932572795883813, 0.01015873015873015, -0.002073642110292627, 0.01015873015873015, -0.0219942959691286, 0.01795826745870598, -0.007619047619047628, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.03954280351296625, 0.017684079335182, -0.006125944778722803, 0.001250453241694811, -0.0456600965054471, 0.01429387115035323, 0.0, -0.003609747578507696, 0.002041981592907605};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 19:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825708, 0.0, -0.02677060453052591, -0.01892967599999822, 0.04337333657549037, 0.03359684204526463, 0.02743170665992744, 0.01939714579875489, 0.01583770322443998, 0.01119894734842154, 0.01343873681810584, -0.01135780559999893, -0.009836148180844242, -0.02052800957118667, -0.01777777777777778, -0.01451549477204845, -0.01523809523809526, -0.01319657758147717, -0.01077496047522359, -0.007619047619047621, -0.05479211580653651, -0.02416105203852446, -0.02161030190642023, -0.005104953982269014, -0.004566009650544714, -0.003954280351296622, 0.003954280351296629, 0.003536815867036403, 0.003062972389361407, 0.002500906483389605, 0.004566009650544718, 0.004083963185815206, 0.003536815867036399, 0.002887798062806159, 0.002041981592907607};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 20:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {-0.03299144395369306, 0.0, 0.02007795339789444, 0.01419725699999863, -0.08674667315098074, 0.0, 0.0, 0.009698572899377448, 0.007918851612219993, 0.005599473674210793, 0.0, 0.03407341679999678, 0.02950844454253271, 0.0, 0.0, 0.0, -0.01523809523809522, -0.01319657758147717, -0.0107749604752236, -0.007619047619047623, 0.08218817370980473, 0.0, 0.0, -0.01020990796453802, -0.009132019301089414, -0.007908560702593251, 0.0, 0.0, 0.0, 0.0, 0.004566009650544692, 0.004083963185815206, 0.003536815867036396, 0.002887798062806154, 0.002041981592907599};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 21:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825739, 0.0, -0.02677060453052591, -0.01892967599999822, 0.04337333657549036, -0.03359684204526465, -0.02743170665992747, 0.01939714579875487, 0.01583770322443997, 0.01119894734842154, -0.01343873681810586, -0.01135780559999893, -0.00983614818084424, 0.0205280095711867, 0.01777777777777778, 0.01451549477204847, -0.01523809523809525, -0.01319657758147716, -0.01077496047522358, -0.007619047619047621, -0.0547921158065365, 0.02416105203852448, 0.02161030190642024, -0.005104953982269015, -0.004566009650544715, -0.003954280351296627, -0.003954280351296623, -0.003536815867036393, -0.003062972389361405, -0.002500906483389624, 0.004566009650544716, 0.004083963185815208, 0.0035368158670364, 0.00288779806280616, 0.002041981592907609};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 22:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825711, 0.1391041415886136, -0.08031181359157794, -0.05678902799999466, 0.05783111543398714, 0.03359684204526459, 0.02743170665992746, -0.04202714923063559, -0.04751310967331988, -0.01679842102263234, 0.0, 0.0454312223999957, 0.03934459272337693, -0.05865145591767626, 0.002539682539682541, -0.06013562119848649, 0.04063492063492063, -0.01099714798456428, 0.01795826745870598, 0.03936507936507937, 0.0, 0.0, 0.0, 0.0, 0.04109408685490236, -0.01054474760345766, 0.0, -0.05305223800554602, -0.02450377911489125, 0.01750634538372733, 0.0, 0.0367556686723369, 0.02357877244690935, 0.0, -0.01225188955744563};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 23:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825724, 0.0, 0.1606236271831558, -0.05678902799999466, 0.0, 0.07839263143895082, -0.02743170665992744, 0.009698572899377419, 0.04751310967331988, -0.01679842102263228, 0.0, 0.0, 0.0, 0.05865145591767622, 0.03301587301587303, -0.01451549477204845, -0.06095238095238094, 0.02419372556604145, -0.06105810935960029, 0.03936507936507937, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05305223800554598, -0.03267170548652169, 0.008753172691863662, 0.0, -0.05513350300850535, 0.01414726346814559, 0.0151609398297323, -0.01225188955744565};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 24:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825716, 0.0, 0.0, 0.170367083999984, 0.0, -0.01119894734842152, 0.08229511997978234, 0.00969857289937744, 0.04751310967331991, -0.01679842102263236, 0.0, 0.0, 0.0, 0.0, 0.05333333333333334, 0.04354648431614532, 0.0, -0.04618802153517006, 0.02514157444218837, -0.08253968253968254, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.05717548460141293, -0.026259518075591, 0.0, 0.0, -0.0495154221385096, -0.01516093982973227, 0.0306297238936141};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 25:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825744, -0.1391041415886136, -0.08031181359157784, -0.05678902799999468, 0.05783111543398711, -0.03359684204526461, -0.02743170665992741, -0.04202714923063558, -0.0475131096733199, -0.01679842102263233, 0.0, 0.04543122239999572, 0.03934459272337695, 0.05865145591767626, -0.002539682539682534, 0.06013562119848649, 0.04063492063492063, -0.01099714798456428, 0.01795826745870598, 0.03936507936507937, 0.0, 0.0, 0.0, 0.0, 0.04109408685490237, -0.01054474760345766, 0.0, 0.053052238005546, 0.02450377911489128, -0.01750634538372731, 0.0, 0.0367556686723369, 0.02357877244690935, 0.0, -0.01225188955744563};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 26:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825737, 0.0, 0.1606236271831559, -0.05678902799999459, 0.0, -0.07839263143895082, 0.02743170665992744, 0.009698572899377434, 0.04751310967331988, -0.01679842102263229, 0.0, 0.0, 0.0, -0.05865145591767625, -0.03301587301587302, 0.01451549477204849, -0.06095238095238095, 0.02419372556604144, -0.06105810935960031, 0.03936507936507935, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.05305223800554598, 0.03267170548652169, -0.00875317269186366, 0.0, -0.05513350300850535, 0.01414726346814558, 0.0151609398297323, -0.01225188955744564};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 27:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825697, 0.0, 0.0, 0.1703670839999839, 0.0, 0.01119894734842154, -0.08229511997978235, 0.009698572899377401, 0.04751310967331989, -0.01679842102263238, 0.0, 0.0, 0.0, 0.0, -0.05333333333333335, -0.04354648431614538, 0.0, -0.04618802153517006, 0.02514157444218837, -0.08253968253968252, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -0.05717548460141295, 0.02625951807559097, 0.0, 0.0, -0.04951542213850959, -0.01516093982973228, 0.0306297238936141};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 28:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825692, -0.1391041415886136, -0.08031181359157792, -0.05678902799999461, -0.04337333657549037, 0.04479578939368625, -0.05486341331985491, 0.04849286449688722, 0.0, -0.01679842102263233, 0.08063242090863514, 0.02271561119999786, -0.00327871606028143, -0.005865145591767621, 0.03047619047619049, 0.04562012642643801, -0.01015873015873016, 0.02712629836192527, 0.04309984190089435, 0.03936507936507936, 0.0, 0.0, 0.07293476893416828, 0.0, 0.02054704342745118, 0.03163424281037298, 0.0, -0.005305223800554608, -0.008167926371630418, -0.008753172691863657, 0.0, -0.009188917168084213, -0.01414726346814561, -0.0151609398297323, -0.01225188955744563};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 29:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825718, 0.1391041415886137, -0.08031181359157794, -0.05678902799999466, -0.04337333657549035, -0.04479578939368619, 0.05486341331985492, 0.04849286449688723, 0.0, -0.01679842102263231, -0.08063242090863515, 0.02271561119999787, -0.003278716060281405, 0.005865145591767631, -0.03047619047619048, -0.04562012642643801, -0.01015873015873016, 0.02712629836192527, 0.04309984190089433, 0.03936507936507935, 0.0, 0.0, -0.0729347689341683, 0.0, 0.02054704342745119, 0.031634242810373, 0.0, 0.005305223800554598, 0.008167926371630416, 0.008753172691863669, 0.0, -0.009188917168084218, -0.01414726346814561, -0.0151609398297323, -0.01225188955744563};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 30:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825739, 0.0, 0.0, 0.170367083999984, 0.01445777885849676, 0.0, 0.0, -0.003232857633125829, -0.09502621934663978, -0.01679842102263237, 0.0, 0.0, -0.06885303726590963, 0.0, 0.0, 0.0, 0.0, 0.01539600717839001, -0.0502831488843767, -0.08253968253968252, 0.0, 0.0, 0.0, 0.0, 0.0, -0.07381323322420365, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.01650514071283654, 0.03032187965946459, 0.03062972389361408};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 31:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825705, -0.1391041415886136, -0.08031181359157795, -0.05678902799999466, -0.04337333657549038, -0.04479578939368619, 0.0548634133198549, -0.009698572899377422, 0.03167540644887994, 0.03919631571947543, 0.08063242090863514, 0.0, 0.02295101242196987, 0.05278631032590864, 0.01015873015873017, -0.01244185266175584, 0.06095238095238097, 0.01686229357633193, -0.007183306983482363, -0.01396825396825398, 0.0, 0.0724831561155734, -0.008103863214907603, 0.03573467787588309, 0.01141502412636176, -0.003954280351296626, -0.01186284105388988, -0.005305223800554585, -0.001020990796453802, 0.001250453241694826, -0.02283004825272355, -0.01123089876099182, -0.003536815867036396, 0.0007219495157015157, 0.002041981592907609};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 32:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825724, 0.1391041415886136, -0.08031181359157794, -0.0567890279999947, -0.04337333657549036, 0.04479578939368623, -0.05486341331985491, -0.009698572899377419, 0.03167540644887994, 0.03919631571947544, -0.08063242090863514, 0.0, 0.02295101242196989, -0.05278631032590862, -0.01015873015873017, 0.01244185266175583, 0.06095238095238097, 0.01686229357633193, -0.007183306983482369, -0.01396825396825397, 0.0, -0.0724831561155734, 0.008103863214907589, 0.03573467787588309, 0.01141502412636178, -0.00395428035129662, 0.01186284105388987, 0.005305223800554588, 0.001020990796453803, -0.001250453241694806, -0.02283004825272356, -0.01123089876099182, -0.003536815867036388, 0.0007219495157015189, 0.002041981592907606};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 33:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.04398859193825713, 0.0, 0.1606236271831558, -0.05678902799999469, 0.0144577788584968, 0.0, 0.0, -0.0614242950293905, -0.06335081289775983, 0.03919631571947543, 0.0, -0.06814683359999359, 0.009836148180844245, 0.0, 0.0, 0.0, -0.09142857142857144, 0.02859258475986718, 0.01436661396696472, -0.01396825396825393, 0.0, 0.0, 0.0, -0.07146935575176618, 0.01826403860217883, -0.002636186900864421, 0.0, 0.0, 0.0, 0.0, 0.04566009650544711, 0.004083963185815182, -0.004715754489381878, -0.001443899031403046, 0.00204198159290758};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 34:
      {
        
      // Array of basisvalues
      double basisvalues[35] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = 0.5*(2.0 + Y + Z + 2.0*X);
      double tmp1 = 0.25*(Y + Z)*(Y + Z);
      double tmp2 = 0.5*(1.0 + Z + 2.0*Y);
      double tmp3 = 0.5*(1.0 - Z);
      double tmp4 = tmp3*tmp3;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[4] = 1.5*tmp0*basisvalues[1] - 0.5*tmp1*basisvalues[0];
      basisvalues[10] = 1.666666666666667*tmp0*basisvalues[4] - 0.6666666666666666*tmp1*basisvalues[1];
      basisvalues[20] = 1.75*tmp0*basisvalues[10] - 0.75*tmp1*basisvalues[4];
      basisvalues[2] = 0.5*(2.0 + 3.0*Y + Z)*basisvalues[0];
      basisvalues[5] = (0.5*(2.0 + 3.0*Y + Z) + 1.0*(1.0 + Y))*basisvalues[1];
      basisvalues[11] = (0.5*(2.0 + 3.0*Y + Z) + 2.0*(1.0 + Y))*basisvalues[4];
      basisvalues[21] = (0.5*(2.0 + 3.0*Y + Z) + 3.0*(1.0 + Y))*basisvalues[10];
      basisvalues[7] = (1.666666666666667*tmp2 + 0.1111111111111111*tmp3)*basisvalues[2] - 0.5555555555555556*tmp4*basisvalues[0];
      basisvalues[16] = (1.75*tmp2 + 0.05*tmp3)*basisvalues[7] - 0.7*tmp4*basisvalues[2];
      basisvalues[30] = (1.8*tmp2 + 0.02857142857142857*tmp3)*basisvalues[16] - 0.7714285714285715*tmp4*basisvalues[7];
      basisvalues[13] = (2.1*tmp2 + 0.54*tmp3)*basisvalues[5] - 0.5600000000000001*tmp4*basisvalues[1];
      basisvalues[26] = (2.0*tmp2 + 0.2857142857142857*tmp3)*basisvalues[13] - 0.7142857142857143*tmp4*basisvalues[5];
      basisvalues[23] = (2.571428571428572*tmp2 + 1.020408163265306*tmp3)*basisvalues[11] - 0.5510204081632653*tmp4*basisvalues[4];
      basisvalues[3] = (2.0*Z + 1.0)*basisvalues[0];
      basisvalues[8] = (3.0*Z + 2.0)*basisvalues[2];
      basisvalues[17] = (4.0*Z + 3.0)*basisvalues[7];
      basisvalues[31] = (5.0*Z + 4.0)*basisvalues[16];
      basisvalues[6] = (3.0*Z + 2.0)*basisvalues[1];
      basisvalues[14] = (4.0*Z + 3.0)*basisvalues[5];
      basisvalues[27] = (5.0*Z + 4.0)*basisvalues[13];
      basisvalues[12] = (4.0*Z + 3.0)*basisvalues[4];
      basisvalues[24] = (5.0*Z + 4.0)*basisvalues[11];
      basisvalues[22] = (5.0*Z + 4.0)*basisvalues[10];
      basisvalues[9] = basisvalues[3]*(0.3125 + 1.875*Z) - 0.5625*basisvalues[0];
      basisvalues[19] = basisvalues[9]*(0.1555555555555556 + 1.866666666666667*Z) - 0.7111111111111111*basisvalues[3];
      basisvalues[34] = basisvalues[19]*(0.09375 + 1.875*Z) - 0.78125*basisvalues[9];
      basisvalues[18] = basisvalues[8]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[2];
      basisvalues[33] = basisvalues[18]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[8];
      basisvalues[32] = basisvalues[17]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[7];
      basisvalues[15] = basisvalues[6]*(0.7777777777777778 + 2.333333333333333*Z) - 0.5555555555555556*basisvalues[1];
      basisvalues[29] = basisvalues[15]*(0.4285714285714285 + 2.142857142857143*Z) - 0.7142857142857143*basisvalues[6];
      basisvalues[28] = basisvalues[14]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[5];
      basisvalues[25] = basisvalues[12]*(1.265625 + 2.8125*Z) - 0.546875*basisvalues[4];
      basisvalues[0] *= std::sqrt(0.75);
      basisvalues[3] *= std::sqrt(1.25);
      basisvalues[9] *= std::sqrt(1.75);
      basisvalues[19] *= std::sqrt(2.25);
      basisvalues[34] *= std::sqrt(2.75);
      basisvalues[2] *= std::sqrt(2.5);
      basisvalues[8] *= std::sqrt(3.5);
      basisvalues[18] *= std::sqrt(4.5);
      basisvalues[33] *= std::sqrt(5.5);
      basisvalues[7] *= std::sqrt(5.25);
      basisvalues[17] *= std::sqrt(6.75);
      basisvalues[32] *= std::sqrt(8.25);
      basisvalues[16] *= std::sqrt(9.0);
      basisvalues[31] *= std::sqrt(11.0);
      basisvalues[30] *= std::sqrt(13.75);
      basisvalues[1] *= std::sqrt(7.5);
      basisvalues[6] *= std::sqrt(10.5);
      basisvalues[15] *= std::sqrt(13.5);
      basisvalues[29] *= std::sqrt(16.5);
      basisvalues[5] *= std::sqrt(15.75);
      basisvalues[14] *= std::sqrt(20.25);
      basisvalues[28] *= std::sqrt(24.75);
      basisvalues[13] *= std::sqrt(27.0);
      basisvalues[27] *= std::sqrt(33.0);
      basisvalues[26] *= std::sqrt(41.25);
      basisvalues[4] *= std::sqrt(26.25);
      basisvalues[12] *= std::sqrt(33.75);
      basisvalues[25] *= std::sqrt(41.25);
      basisvalues[11] *= std::sqrt(45.0);
      basisvalues[24] *= std::sqrt(55.0);
      basisvalues[23] *= std::sqrt(68.75);
      basisvalues[10] *= std::sqrt(63.0);
      basisvalues[22] *= std::sqrt(77.0);
      basisvalues[21] *= std::sqrt(96.25);
      basisvalues[20] *= std::sqrt(123.75);
      
      // Table(s) of coefficients
      static const double coefficients0[35] = \
      {0.3519087355060579, 0.0, 0.0, 0.0, -0.1156622308679743, 0.0, 0.0, -0.1293143053250325, 0.0, -0.1343873681810586, 0.0, -0.09086244479999145, -0.07868918544675392, 0.0, 0.0, 0.0, 0.04063492063492061, -0.08797718387651439, 0.0, 0.07111111111111107, 0.0, 0.0, 0.0, 0.0, -0.08218817370980473, 0.02108949520691531, 0.0, 0.0, 0.0, 0.0, 0.0, 0.03675566867233688, 0.02357877244690934, 0.0, -0.0122518895574456};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {6.324555320336747, -2.755027706227415e-15, -2.845450780263579e-15, 0.0, 0.0, 3.434115684911919e-15, 0.0, 2.07530986352252e-15, 0.0, -2.664535259100376e-15, -1.97218461345412e-15, 0.0, 0.0, 3.949680510731901e-15, -1.666365494827482e-15, 0.0, 1.798799027049632e-15, -1.479384492657744e-15, 0.0, 0.0, 1.261560487716556e-15, 1.262458280342776e-15, 1.265523141579994e-15, 0.0, 1.736730957353046e-15, 0.0, 0.0, 0.0, 0.0, 2.273990930446873e-15, 0.0, -1.577061126068014e-15, 2.274296109755621e-15, 2.667662847487098e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-4.048575143458666e-15, 11.22497216032183, -1.83973105430069e-15, 3.114487435507202e-15, -1.438682838413679e-14, -6.879939285134489e-15, -4.440892098500628e-15, -4.717568587397275e-15, -8.703915638482587e-15, -9.134546682679095e-15, -4.589843803388605e-15, 6.343156136259677e-15, 8.179710594616145e-15, 0.0, 0.0, 0.0, 1.928148795969285e-15, 4.916685369160752e-15, 4.507207548235385e-15, 1.491575822290052e-15, -2.191096963719896e-15, 6.107002102519819e-15, -1.478981811491279e-15, -2.918819289458926e-15, -9.440008985674176e-15, -4.160528828714539e-15, -1.589083746995888e-15, -8.271829884818955e-15, 0.0, -1.332267629550189e-15, 0.0, 0.0, -2.593804223418825e-15, 0.0, -2.347908260727623e-15},
      {4.582575694955852, -1.622406062334875e-15, 8.366600265340768, -1.183215956619926, -1.842805819301693e-15, 4.541109533804991e-15, -5.57484696276128e-15, 6.62052486993336e-15, 3.498836623290358e-15, -6.217248937900877e-15, 0.0, -1.941346619839965e-15, 0.0, 6.028941348866923e-15, 0.0, 0.0, 2.111209744922652e-15, -2.829677156242869e-15, 0.0, 0.0, 0.0, 0.0, -1.50735692460685e-15, 0.0, 2.474293067264928e-15, -1.630442536615592e-15, 0.0, -3.114039809905149e-15, 0.0, 0.0, 3.292226399821669e-15, 0.0, 2.620247245756408e-15, 4.120251972598358e-15, -2.331468351712829e-15},
      {3.74165738677395, 0.0, 0.0, 8.694826047713669, -1.716976021051484e-15, -5.726176492621085e-15, 2.035856277875195e-15, 1.682578523685991e-15, 0.0, -7.105427357601002e-15, 0.0, 0.0, 1.551274817504744e-15, 1.068564539318173e-15, -1.345151901703455e-15, 1.221684733147963e-15, 1.153705772642015e-15, -1.749405174928944e-15, 1.95328767809869e-15, 1.77635683940025e-15, 0.0, 0.0, 3.567152407979823e-15, 0.0, 1.112545517195783e-15, -2.929268303461357e-15, 0.0, 0.0, -2.664074261051766e-15, 2.017784122626254e-15, 0.0, -4.036374844389451e-15, 1.17670297573725e-15, 2.449253286618944e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.499090833947007, -5.735100811903167e-14, -3.346640106136296, -2.366431913239837, 15.49193338482967, 2.139176679954885e-14, 5.431402292195526e-15, 0.692820323027548, 0.5656854249492469, 0.4000000000000017, -3.569878251939795e-15, -6.234607343894895e-15, -4.924174630633022e-15, -1.318716085327539e-15, -2.246683207512665e-15, 0.0, -3.47694096341484e-15, 3.769969838488061e-15, -4.750962412042415e-15, -2.664535259100376e-15, 6.99366026702654e-15, 6.540867247610042e-15, -1.690694067720011e-15, 0.0, 3.247104938060711e-15, 5.604232470696861e-15, -5.222607343501139e-15, 4.981846133441525e-15, 0.0, -5.020195116383891e-15, -2.693865455204308e-15, 8.544094271521541e-15, 0.0, 0.0, 0.0},
      {-1.887379141862766e-15, 4.898979485566356, -2.275957200481571e-15, 2.05391259555654e-15, -4.98428208109721e-15, 14.19859147943908, -0.8280786712108246, 1.635986988320833e-14, -3.774758283725532e-15, -1.332267629550188e-15, -1.955830788757261e-15, 1.066188548233794e-15, 3.577155384822135e-15, 1.071693090542965e-15, 1.731166850208373e-15, 2.664535259100376e-15, 0.0, 1.470463618064218e-15, 3.441691376337985e-15, 1.332267629550188e-15, 0.0, 6.494837451522405e-15, -1.268817556808332e-15, 1.978932697595798e-15, -1.623956313419655e-15, -2.663063075545806e-15, -3.408580383055741e-15, -4.564528840258146e-15, -1.365744426779923e-15, -1.332267629550188e-15, 4.57240239820399e-15, 0.0, 1.539289652441302e-15, 0.0, 0.0},
      {-6.217248937900877e-15, 4.242640687119284, 1.332267629550188e-15, 0.0, -1.417671493816131e-14, 4.319752003117554e-15, 14.34274331201273, 1.757442557811047e-15, -2.486899575160351e-14, -8.881784197001252e-15, 0.0, 3.737074088643337e-15, 1.43686423122722e-14, 1.7728627690158e-15, 3.120634904558517e-15, -3.552713678800501e-15, 3.677133800063797e-15, 0.0, 1.154631945610163e-14, 4.440892098500626e-15, 0.0, 2.000606337472281e-15, -3.876266343005611e-15, 0.0, -1.003624201584195e-14, -1.407920432704636e-14, 0.0, -1.032781848703591e-14, 2.844806243507375e-15, -1.77635683940025e-15, 1.463844565721619e-15, -1.104622970725999e-14, 1.910264028319188e-15, -4.440892098500626e-15, -1.77635683940025e-15},
      {3.600000000000036, 3.509831522637576e-15, 8.763560920082687, -1.549193338482975, 0.0, -6.809630078749682e-15, 2.530178933671563e-15, 9.524704719832569, -1.481312159636082, 0.2618614682831866, 0.0, -1.27899634168052e-15, 0.0, -4.216088498770323e-15, 2.016139072061903e-15, -1.386858362583727e-15, -4.548038568935696e-15, 0.0, -2.820015039631663e-15, 0.0, 0.0, 2.766639264603659e-15, -2.180485758854845e-15, 1.841953097377712e-15, 3.003571728566432e-15, 0.0, -5.68177630838458e-15, 5.490457595085064e-15, 1.777251499562728e-15, 0.0, 4.371033019966509e-15, 0.0, 0.0, 4.043211762736688e-15, -4.107825191113079e-15},
      {3.117691453623973, -1.302891757195759e-15, 3.162277660168381, 4.919349550499538, -1.911332321195395e-15, -1.499828280463508e-15, -1.482864437286311e-14, 6.169961854530472e-15, 10.69044967649699, -2.418972627259059, 0.0, -1.87949902427661e-15, -1.092433564133672e-15, 6.047005919393257e-15, 2.42750242926555e-15, 2.475327959771032e-15, 2.437307941846363e-15, -7.376559767245101e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.681378225430548e-15, 0.0, 6.683157031125933e-15, -3.199253497927707e-15, 0.0, -1.245497741249602e-14, 0.0, -1.666388192413884e-15, 1.869552183045199e-15, 1.196110026771607e-15, 6.945712781151267e-15, 5.65114044305385e-15, -2.664535259100376e-15},
      {2.545584412271563, -2.502698899666246e-15, 0.0, 7.668115805072293, 0.0, -2.849456626059804e-15, -7.700220574486444e-15, -2.953861969342892e-15, -7.567503470342655e-15, 10.36918511745257, 1.753593026242244e-15, 1.181091073439251e-15, 3.573213743350909e-15, -1.234505156253619e-15, 3.601066818979811e-15, 8.16278261914875e-15, 0.0, 0.0, 1.501364671568915e-15, 0.0, 0.0, 0.0, -3.772688649041988e-15, 0.0, -3.275539031370308e-15, 0.0, 0.0, -3.186957589912267e-15, -3.870132640944806e-15, 3.649413769702857e-15, 0.0, -5.92993473398581e-15, -1.976412476201982e-15, -2.896723765562349e-15, -1.77635683940025e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {-3.9310787294362e-14, 11.60576914947993, 4.001956868903256e-14, 2.847075854089674e-14, -8.785921877511338e-14, -4.204589329360403, -3.433032811627972, -1.306887697262931e-14, 0.0, 0.0, 19.62141687034856, 1.267144602064171e-14, 1.364234503426726e-14, 0.6116777418411926, 0.5297284633639738, 0.4325214791567842, 0.0, 3.036783728292513e-15, 0.0, 0.0, 0.0, 4.097296146260553e-15, 0.0, 0.0, 0.0, 0.0, -4.266676826333271e-15, -1.695808303895688e-15, -7.134201795988514e-15, -4.662936703425657e-15, 0.0, 6.730461214304475e-15, 3.39511014005864e-15, 4.140881688231607e-15, 3.276876550661915e-15},
      {4.531372124791035, -2.539226096237659e-14, 3.545621041711664, -2.507132682112023, 4.787135538781689, -5.522358011423292e-14, 1.287544618446194e-14, -5.566267450754883, -1.04880884817015, 0.7416198487095671, -1.468817669352862e-15, 18.80349511584024, -0.6031223870464545, 2.095174526506401e-14, 7.610658934864572e-15, 0.0, 1.68183573174416, 0.7012837812176597, 0.1321374945286807, -0.093435318430234, 1.00725962503955e-15, 5.884200300433031e-15, 0.0, -1.339740001460353e-15, -2.648613054656852e-15, 4.068356647206868e-15, -3.697743158673703e-15, 9.36601482958292e-15, -2.927782040804922e-15, -2.515742565011993e-15, -3.627419928904925e-15, 4.504583368522802e-15, 0.0, 0.0, 1.665334536937735e-15},
      {4.052982440952179, -2.152259520237065e-14, -1.585649934344179, 4.484895284651095, 4.281744192888375, 8.447609170217588e-15, -6.473485062297307e-14, 0.1914854215512668, -3.752332607858725, -4.311612227462004, 0.0, 0.0, 18.88071718662934, -2.654823279168817e-15, 9.957929291992912e-15, 1.944979397843448e-14, -3.839197106239302e-15, 0.8443713418650413, 1.181873680570551, 1.04463861754668, 2.348728562472955e-15, 1.829934939067215e-15, -2.012270324576156e-15, 0.0, -5.54175835938037e-15, 0.0, -1.442151133520087e-15, 8.425241402776434e-15, 3.735010912561873e-15, -5.121219609829988e-15, -1.285347927649349e-15, 1.342695743663144e-14, 1.374956100731459e-15, 1.395768924834553e-15, 1.77635683940025e-15},
      {-2.442490654175344e-15, 2.595128874940676, 0.0, 2.720046410331634e-15, -2.3066149316163e-15, 10.02853072844804, -0.7676494735787255, 2.150467933934768e-15, 1.176836406102666e-14, 1.554312234475219e-15, -3.422772109172248e-15, -2.052952761101463e-15, -1.87577665026702e-15, 16.41303613296578, -1.263476110611573, 0.09671474291232807, -6.73271722600326e-15, 0.0, 0.0, 0.0, -1.932021746935413e-15, 5.337660479309749e-15, 4.452628772819216e-15, 0.0, 3.20129528967574e-15, 0.0, -5.996082278382637e-15, 4.768805855914385e-15, 1.522591576628785e-15, 0.0, 0.0, 5.184825488813326e-15, 2.366957492022395e-15, 1.887379141862766e-15, 1.332267629550188e-15},
      {-6.661338147750939e-15, 2.321153829895989, -2.775557561562891e-15, 1.110223024625157e-15, -6.988277747972169e-15, 3.92428337406971, 5.492852498604766, 3.049354899469032e-15, -2.087219286295294e-14, -8.881784197001252e-15, 0.0, 2.434615692915347e-15, 7.923935198466143e-15, 1.685758676295454e-15, 17.30446313655655, -1.730085916627134, 3.102727117000264e-15, -1.096101048886776e-15, 9.325873406851315e-15, 3.552713678800501e-15, 0.0, 2.049297977675507e-15, -3.151845788226286e-15, 0.0, -6.677639498622327e-15, -6.620981080258314e-15, -1.540127647910206e-15, -8.997160640615388e-15, 0.0, 0.0, 1.571551665982311e-15, -9.470879667669305e-15, -1.04835054566382e-15, 0.0, 0.0},
      {-1.058450769817054e-15, 2.010178182781452, 4.781822069557355e-15, 0.0, -6.426838986247676e-15, 1.512951355355127e-14, 8.919280880686035, 4.198361428774304e-15, -6.173072891494512e-15, 2.029119325078094e-15, -2.755764687052095e-15, 0.0, 4.740643371767348e-15, -3.279418049690198e-15, -6.170592407788194e-15, 16.85585648844884, 2.083611625494555e-15, -5.503112545493948e-15, 6.59502269801618e-15, 2.949316276210574e-15, 0.0, 0.0, 1.013357603552909e-14, 0.0, 1.331684410856825e-15, -1.055301655769078e-14, 0.0, 0.0, 6.071674532507784e-15, 3.552713678800503e-15, 1.671615088995414e-15, -8.812094621262385e-15, 6.730149470805067e-15, -3.382701636654526e-15, 1.015640631177435e-15},
      {2.966479394838278, 3.752540353062854e-15, 8.124038404635987, -1.64130361329659, 2.015214910136166e-15, 0.0, 8.25866226464951e-15, 11.7728501222092, -2.403122968139592, 0.4855041562276039, -2.820215065656005e-15, -1.006247911104539e-15, 0.0, -6.187407006243949e-15, 0.0, -1.882726973621525e-15, 10.2761860629321, -1.483239697419139, 0.3027650354097497, -0.06116777418412045, 0.0, 3.738200028251806e-15, 0.0, 1.8733638192469e-15, 0.0, 0.0, -7.097390365125583e-15, 7.156897969431527e-15, 2.307410411902554e-15, 0.0, 1.011722212777124e-14, -3.752282461230039e-15, -1.902952660692775e-15, 1.578636002253172e-15, -4.746203430272544e-15},
      {2.65329983228433, 3.773512102890074e-15, 4.152206199905134, 2.936053160837746, -1.392112113557545e-15, 0.0, -9.773520748985242e-15, 2.632489316217643, 9.825913261807873, -2.822612771377419, 1.418758214399036e-15, -1.756672035243868e-15, -1.61766406315499e-15, -1.114665491880327e-15, 3.324679354090284e-15, 0.0, -2.198941142991339e-15, 11.6081867662439, -3.09487177319466, 0.6838765055402414, 0.0, 0.0, -5.19368587839225e-15, 0.0, 4.770153821428121e-15, -1.547787243736631e-15, -1.268564141238063e-15, 1.28503467691885e-15, 4.432107132278576e-15, -8.333839514883774e-15, 2.457289972022228e-15, 9.959611401258834e-15, -1.184989790008379e-15, 9.351440237254256e-15, -1.332267629550188e-15},
      {2.297825058615222, 0.0, 1.498298354528792, 5.509176018985347, 0.0, 0.0, -5.739664940819404e-15, -1.81844408363129e-15, 6.64803945320938, 4.136768925484859, 0.0, 0.0, 0.0, 0.0, 0.0, 7.865334062957912e-15, 0.0, -3.29658513360866e-15, 12.56361364238419, -3.553526561095076, 0.0, 0.0, -1.459993511031804e-15, 0.0, 3.282058401183255e-15, 0.0, 0.0, -1.189709993730401e-14, 0.0, 0.0, -1.903678994447867e-15, -3.352873534367971e-15, 3.175143809154473e-15, -2.945493452490758e-15, 0.0},
      {1.87616630392938, -3.530031553349299e-15, 0.0, 6.228309299857776, 1.972168468601441e-15, 3.91807440785619e-15, -5.996852278118952e-15, 0.0, -6.943281564394294e-15, 11.0541524195339, 0.0, 1.136660904013626e-15, 4.130573261531761e-15, 2.07722470780507e-15, 4.685375622814564e-15, 5.247915254628125e-15, 0.0, 1.940636752140892e-15, 0.0, 11.60576914947997, 1.374843100332199e-15, 0.0, -4.467769522624406e-15, 0.0, -7.081778709654535e-15, 1.216730270746813e-15, 0.0, -1.884369305148503e-15, 0.0, 4.979709690239972e-15, 0.0, -2.749226297647667e-15, -2.21063884452952e-15, -4.120859000254885e-15, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {5.47722557505165, -1.329362421436983e-15, -1.414574226099736e-15, 0.0, 1.396195189713662e-15, 3.069683934878525e-15, -1.658427266676841e-15, 2.328469446794946e-15, 3.077127207097918e-15, 0.0, -2.108496598849142e-15, -1.048736202845159e-15, 0.0, 3.852942452507938e-15, 0.0, 0.0, 1.315051672425221e-15, -1.878782734898891e-15, 0.0, 0.0, 2.159211868193399e-15, 0.0, 1.52412231416706e-15, 0.0, 1.742039818900007e-15, -1.230875920002761e-15, 1.386456564633847e-15, -1.276476604866704e-15, 0.0, 1.763231394185742e-15, 0.0, 0.0, 1.493624826189692e-15, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477961, 7.245688373094724, 4.18330013267038, -0.5916079783099704, -8.048337858292489e-15, -5.799543690418483e-15, -1.399644700599198e-15, 1.329065725165638e-14, -8.464633514906267e-15, -5.10702591327572e-15, 0.0, 3.434574573815911e-15, 5.108505780750707e-15, 3.345354504123634e-15, 1.092686183994497e-15, 2.016192424066845e-15, 5.272565701890842e-15, 0.0, 3.315338011311628e-15, 1.332267629550188e-15, -1.23590108101068e-15, 1.741406518253525e-15, -2.282569395360833e-15, 0.0, -2.211814146253804e-15, -3.508530526754831e-15, -1.163751801848492e-15, -8.943064283808133e-15, -1.986245838891168e-15, -1.967047591908562e-15, 6.371912441951958e-15, -3.251353402240118e-15, 0.0, 1.616036776449115e-15, -1.27675647831893e-15},
      {1.870828693386975, 0.0, 0.0, 4.347413023856834, 0.0, -2.863088246310543e-15, 1.017928138937598e-15, 0.0, 0.0, -3.552713678800501e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.783576203989912e-15, 0.0, 0.0, -1.464634151730679e-15, 0.0, 0.0, -1.332037130525883e-15, 1.008892061313127e-15, 0.0, -2.018187422194726e-15, 0.0, 1.224626643309472e-15, 0.0},
      {-2.645751311064608, 2.51339483499677e-15, 9.660917830792959, 0.6831300510639824, -4.819770964924065e-15, -4.380334128978213e-15, -4.00367498250746e-15, -1.674474917342019e-15, 0.0, -8.43769498715119e-15, 4.035122384254887e-15, -1.007315300997085e-15, 0.0, 1.468920740823023e-15, 2.621656533583805e-15, 0.0, 2.661681422335443e-15, -1.479325662741668e-15, 1.162276230747661e-15, 0.0, -1.199162491434167e-15, -1.580712154970756e-15, -3.191054458724836e-15, 0.0, 1.015476511627327e-15, -1.09033680393418e-15, 2.123613229772701e-15, -3.731825132570201e-15, 0.0, -1.565792760875096e-15, -1.194581470840224e-15, 0.0, -2.923651610352972e-15, 3.29374613195311e-15, -3.774758283725532e-15},
      {3.24037034920394, 0.0, 0.0, 7.529940238806686, -1.010971471332513e-15, -4.538265932249567e-15, -1.789610423706552e-15, 1.274394058754014e-15, 1.55431223447521e-15, -3.552713678800501e-15, 0.0, 0.0, 1.396036947324373e-15, 0.0, 0.0, 1.470215053435075e-15, 1.007109550284922e-15, -1.517660779559457e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 3.075438353563052e-15, 0.0, 1.364027303403125e-15, -2.29883407500468e-15, 0.0, 0.0, -1.648420920432117e-15, 2.159657348660556e-15, 0.0, -3.037707693669356e-15, 1.367491367337058e-15, 2.835075637394733e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724456, 2.449489742783177, 2.828427124746194, -0.9999999999999946, 9.165151389911681, 7.099295739719544, -0.4140393356054196, -2.049390153191914, -0.4780914437337579, 0.1690308509456986, 0.0, 0.0, 1.280402279841504e-15, 2.081409264323675e-15, 0.0, 3.427244415017231e-15, 2.678322910410816e-15, 2.731342386432818e-15, 0.0, 1.27675647831893e-15, 4.502113002163787e-15, 4.674830302644272e-15, -1.481495524157894e-15, 0.0, 1.363700042917362e-15, 0.0, 1.847564593594077e-15, -4.141117770544447e-15, 0.0, -4.743363573698719e-15, 1.180008443486585e-15, 3.03523701705503e-15, 0.0, 0.0, -1.27675647831893e-15},
      {2.012461179749804, 2.121320343559641, -0.408248290463863, 3.175426480542945, -7.16838490456369e-15, 1.296217261657858e-15, 7.171371656006371, 0.0, -1.380131118684721, -1.561440116717661, 0.0, 1.9766304945207e-15, 8.258593336277113e-15, 1.065547980178511e-15, 0.0, -1.997915999859389e-15, 2.651774692955171e-15, 0.0, 6.159586980139494e-15, 2.664535259100376e-15, 0.0, 0.0, 1.323187112599874e-15, 0.0, -4.183725863512894e-15, -8.822705093823078e-15, 0.0, -2.633168702655231e-15, 1.920370554475785e-15, 1.708489640165983e-15, 0.0, -7.55944276727256e-15, 0.0, 0.0, 0.0},
      {1.8, -5.692099788303092, 4.381780460041331, -0.7745966692414825, 2.418832757101776e-15, 10.99818166789403, 0.9621404708847371, 4.762352359916272, -0.7406560798180358, 0.1309307341415914, 2.065023223559757e-15, -2.33946627254091e-15, -3.431374492336455e-15, -4.164008132260251e-15, -1.562441250802877e-15, -2.025696810842051e-15, -1.536331676421082e-15, -3.408732355200782e-15, -2.353697090747215e-15, 0.0, 0.0, 1.436909234914408e-15, 0.0, 1.666689693919989e-15, 5.871715009063933e-15, -1.449655156973769e-15, -3.390207673258105e-15, 7.017756338592038e-15, 2.892029827514187e-15, 5.401953503190169e-15, 3.080209260146777e-15, 0.0, 1.642373890064121e-15, 2.188139335062117e-15, -3.164135620181696e-15},
      {1.558845726811981, 2.738612787525827, 1.581138830084192, 2.459674775249769, -1.000772897074004e-14, 1.077474598648897e-15, 9.258200997725506, 4.332218671159391e-15, 5.345224838248479, -1.209486313629536, 0.0, 1.531240527372331e-15, 9.355428223757078e-15, 3.915320626032612e-15, 3.395541411673956e-15, 0.0, 3.434802774973647e-15, -3.267544996022354e-15, 6.916970948489396e-15, 2.664535259100376e-15, 0.0, 1.364782596429919e-15, -4.002974006300064e-15, 0.0, -4.598282973107559e-15, -9.749536973787137e-15, 0.0, -1.148897847446572e-14, 2.679059303179043e-15, 1.16520734811834e-15, 1.879683695601941e-15, -7.561450835632283e-15, 2.412659700025916e-15, 1.049213382126674e-15, -3.996802888650564e-15},
      {1.272792206135781, -1.195838298601868e-15, 0.0, 3.834057902536151, 0.0, -1.97983982534248e-15, -2.961931867543092e-15, 0.0, -6.004197784421646e-15, 5.184592558726294, 0.0, 0.0, 1.80048465948327e-15, 0.0, 1.883800136336793e-15, 4.081391309574378e-15, 0.0, 0.0, 0.0, -1.77635683940025e-15, 0.0, 0.0, -1.886344324520997e-15, 0.0, -1.637769515685155e-15, 0.0, 0.0, -2.481657214656262e-15, -2.157110925397434e-15, 2.268796094701499e-15, 0.0, -2.742922762067878e-15, 0.0, -1.448361882781177e-15, 0.0},
      {5.196152422706649, 2.591658159516427e-15, -3.162277660168413, -2.236067977499797, 5.527768616384805e-15, -7.324158535936932e-15, 6.924434196167371e-15, 13.74772708486752, 0.534522483824855, 0.377964473009232, -3.800628773341716e-15, 0.0, 0.0, -9.952916379721188e-15, 1.060542007828727e-15, -2.18799035993188e-15, -5.968744935081518e-15, -1.040731760585573e-15, -1.217863850471554e-15, -3.33066907387547e-15, 2.979157182825326e-15, 5.580726845605063e-15, 0.0, 1.182262309624966e-15, 0.0, 1.05768502874959e-15, -1.279903109660152e-14, 1.290061725598517e-14, 2.914852313571631e-15, 0.0, 5.01079730454147e-15, 5.997265376977026e-15, 1.497110095456886e-15, -2.437302928702384e-15, 0.0},
      {-1.800000000000001, 0.0, 3.651483716701114, -2.840187787218778, 0.0, 1.604257392085126e-15, -2.43461345062357e-14, 4.842370320889456e-15, 12.34426799696738, 1.396594497510359, 2.571168362588695e-15, -1.349358535660661e-15, -1.440108310180002e-15, 4.327843197218228e-15, 5.599761828238781e-15, 3.803837844050796e-15, 0.0, -5.582769413062118e-15, 0.0, 0.0, 0.0, 0.0, -8.742698499099922e-15, 0.0, 3.58633349883306e-15, 0.0, 0.0, -1.189950738546718e-14, 1.408811998350821e-15, -3.926894183011852e-15, 2.179980219384608e-15, 2.236566217407696e-15, 1.417255330519658e-15, 3.504168200693125e-15, -3.108624468950438e-15},
      {2.204540768504856, -2.312938754892617e-15, 0.0, 6.640783086353573, 0.0, -3.813775705618189e-15, -4.488568091535529e-15, -2.013114869545338e-15, -7.854033707357099e-15, 8.979977728257456, 1.622775285628379e-15, 0.0, 3.235798472255282e-15, 0.0, 2.72711968322587e-15, 7.307163804046298e-15, 0.0, 1.047270555577935e-15, 0.0, -5.329070518200751e-15, 0.0, 0.0, -3.267244210639557e-15, 0.0, -3.074686702547557e-15, 0.0, 0.0, -5.955719877008059e-15, -3.617232375203582e-15, 3.38992838597657e-15, 0.0, -4.128302357568608e-15, -1.491714642272449e-15, 0.0, -8.881784197001252e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395512, 3.070597894314937, 1.772810520855828, -1.253566341056009, 2.393567769390784, 6.303768714031282, -0.9082951062292426, -2.783133725377426, -0.5244044240850673, 0.3708099243547867, 11.12429773064348, 9.401747557920135, -0.3015611935232214, -2.427520781138048, -0.794200206656963, 0.1144344270542664, 0.8409178658720747, 0.3506418906088279, 0.06606874726433914, -0.04671765921511706, 2.964874421059143e-15, 3.942320534812497e-15, 0.0, 5.39182293998908e-15, 1.386220500163306e-15, 0.0, -1.927889516845131e-15, 4.822662376361903e-15, -3.021352981062936e-15, -2.201560853437377e-15, -1.430226150473971e-15, 4.561775184551188e-15, 3.225483197016459e-15, 1.221688531654151e-15, 2.05391259555654e-15},
      {2.026491220476083, 2.746426249302367, -0.7928249671720874, 2.242447642325541, 2.140872096444186, -0.3316624790355366, 6.49923072370873, 0.09574271077563536, -1.876166303929375, -2.155806113731006, 0.0, 2.196143855877899e-15, 9.44035859331469, 0.0, -1.462494064565344, -2.047065262876623, 0.0, 0.4221856709325202, 0.5909368402852787, 0.5223193087733415, 0.0, 2.100365382020571e-15, -6.477058597589222e-15, 0.0, -7.397274740878086e-15, -4.822262984146618e-15, -1.686047074705007e-15, -2.057446929003474e-15, 3.607878913744459e-15, -6.335368088640531e-15, 0.0, -1.023412329485855e-15, 0.0, -2.854829216383222e-15, 0.0},
      {1.914854215512661, 1.297564437470339, 3.745745886321955, -1.059456926727943, -8.091735937126924, 5.014265364224015, -0.383824736789358, 1.809367161139374, -1.108006575534891, 0.3133915852640046, 0.0, 12.71348312073543, 1.019462903068669, 8.206518066482884, -0.631738055305785, 0.04835737145616281, -2.842821248876062, -0.2279588351800828, 0.1395957071376023, -0.03948362845661235, -3.970681873118029e-15, 2.425383055877211e-15, 0.0, 3.567393277555227e-15, 0.0, -1.254894228621712e-15, -3.921624936395956e-15, 8.682709884490026e-15, 1.632998177648536e-15, 0.0, -5.970112398361424e-15, 2.242686951530578e-15, 3.445913359344913e-15, 0.0, 1.054711873393899e-15},
      {1.712697677155351, 1.160576914947995, 1.34011878852098, 1.895214165917374, 2.53311402559511, 1.962141687034861, 2.746426249302365, -0.5664215155988794, 3.171299868688366, -1.821988709389521, 1.799618855713744e-15, 0.0, 11.16998292382394, 5.05451451718453e-15, 8.652231568278278, -0.8650429583135643, 0.0, -2.497684112518217, -0.9988655696858584, 0.4414403861366472, 0.0, 1.909900740388318e-15, -6.865233780517207e-15, 0.0, -2.127518770045263e-15, 0.0, 0.0, -1.277534701684133e-14, -2.324566169058799e-15, -3.783399722075486e-15, 0.0, 5.04166984585201e-15, 0.0, 2.366176862121134e-15, -3.774758283725532e-15},
      {1.483239697419124, 1.005089091390724, -0.1934294858246583, 3.556157828809256, -4.486693799788632e-15, 2.266888702170258e-15, 4.459640440343016, 0.0, -0.8582582029069983, 2.670272859251861, 0.0, 0.0, 3.955950590765764e-15, -2.377069257867669e-15, -1.870511567369906e-15, 8.427928244224425, 1.029621178251957e-15, -2.329916202503273e-15, -1.621955546837938, -2.293791531904489, 0.0, -1.028318938219762e-15, 4.369089707719544e-15, -1.138658961670159e-15, 0.0, -5.193070926993345e-15, 0.0, -1.625113899967339e-15, 0.0, 2.839416867447706e-15, 0.0, -6.474562064802835e-15, 1.68357319694187e-15, -1.901307847976613e-15, 0.0},
      {1.483239697419149, 7.035623639735132, 4.062019202317994, -0.8206518066482933, -2.006141938553798e-15, -6.797058187186524, -2.081165538826729, 5.886425061104597, -1.201561484069793, 0.2427520781138072, -6.459007017057078e-15, 1.587513057948397e-15, 0.0, 14.83239697419132, 0.8563488385776655, 0.2622022120425342, 5.138093031466042, -0.7416198487095664, 0.1513825177048734, -0.03058388709206037, 0.0, 5.374117450616815e-15, 4.893497398788375e-15, 0.0, -1.50980548759817e-15, 0.0, -1.326773543588305e-14, 5.962742288080403e-15, -2.628335154713185e-15, -2.412985984754417e-15, 1.246213431973125e-15, 4.681206051906223e-15, 0.0, 2.454652538064321e-15, 0.0},
      {1.326649916142163, -2.696937038151816, 2.076103099952564, 1.468026580418873, 6.017967839977709e-15, 3.039736830714135, -6.382117875081016, 1.316244658108819, 4.91295663090394, -1.411306385688702, 0.0, -2.421811526180231e-15, -7.778513190861347e-15, -1.503208868614004e-15, 13.40397950858874, 2.010178182781476, -1.997245685594832e-15, 5.804093383121949, -1.547435886597332, 0.3419382527701202, 0.0, 0.0, 0.0, 0.0, 6.683750651431404e-15, 5.444140671887186e-15, 0.0, 6.386494061291519e-15, 0.0, 3.382596810009177e-15, 0.0, 5.951935708723981e-15, 0.0, 4.453675513702097e-15, -1.554312234475219e-15},
      {1.148912529307637, 1.297564437470356, 0.7491491772644031, 2.754588009492666, -7.500530185348952e-15, 1.21205620590191e-14, 5.757371051840542, -2.116109315968642e-15, 3.324019726604688, 2.068384462742433, -2.430991152235967e-15, 1.374290570574074e-15, 3.23979944347681e-15, -2.527579207321033e-15, -5.650375285585896e-15, 10.88040857763744, 0.0, -3.333837627849207e-15, 6.281806821192099, -1.776763280547533, 0.0, 1.093857420238889e-15, 6.70027244222865e-15, -1.383162856853024e-15, 0.0, -6.903084549856064e-15, 1.25173934454342e-15, -5.678608304463442e-15, 3.560794931382322e-15, 0.0, -2.800222860222953e-15, -5.560059183965657e-15, 5.202787375569908e-15, -5.025460405045882e-15, 3.552713678800501e-15},
      {0.9380831519646962, -1.70950462544339e-15, 0.0, 3.114154649928883, 0.0, 3.735394043328338e-15, -3.442515348909542e-15, 0.0, -3.91572999204721e-15, 5.527076209766946, 0.0, 0.0, 1.954264328303364e-15, 1.052490141710349e-15, 2.231665508944767e-15, 2.179868417464e-15, 0.0, 1.136851829764214e-15, 0.0, 5.802884574739982, 0.0, 0.0, -2.372662639390343e-15, 0.0, -3.651911657289781e-15, 0.0, 0.0, -1.053206955036766e-15, 0.0, 2.489854845119983e-15, 0.0, -1.041546241436285e-15, 0.0, -2.060429500127442e-15, -2.220446049250313e-15},
      {-3.42539535431075, 0.0, 9.380831519646838, 1.89521416591739, 0.0, 1.578816219078524e-14, 3.402454266090031e-15, -3.398529093593323, -2.774887385102329, -0.5606119105814056, 0.0, -1.380224598940607e-15, 2.054202663790918e-15, 3.056943919411584e-15, -2.584093953932353e-15, 0.0, 17.79887636902959, 0.4281744192888391, 0.3496029493900509, 0.07063046178186538, 0.0, 0.0, 3.440427711354897e-15, 0.0, -4.361629291806106e-15, 0.0, 5.683207035918405e-15, -1.991964877130813e-15, 0.0, 2.281411036695393e-15, 8.848591703169032e-15, -1.163340040129818e-14, -6.859356187854917e-15, 2.982234464081677e-15, -5.273559366969494e-15},
      {3.829708431025364, 8.502341080179314e-15, -1.498298354528803, 4.23782770691181, 1.132894164909049e-15, 2.696048080861058e-15, 1.719663042340445e-14, 3.799671038392667, -3.545621041711701, -4.074090608432056, -1.883638219656959e-15, 0.0, 0.0, -1.007841193212288e-14, -5.454450013703927e-15, -4.110108487564111e-15, -6.771127607620475e-15, 16.75497438573591, 1.116765657100825, 0.9870907114153002, 0.0, 1.607904904024863e-15, 3.775142556742367e-15, 0.0, 1.783937651873978e-15, 0.0, -2.609965794246338e-15, 2.147119278757163e-14, 6.469089875557376e-15, -5.703720954646791e-15, 0.0, 1.466247766751613e-14, -1.647488562345754e-15, -2.233836013506134e-15, 3.108624468950438e-15},
      {-1.326649916142187, 1.007249149159698e-15, 1.730085916627132, -3.18072425757421, 0.0, 8.747882302136306e-15, -3.719534670202937e-15, 0.0, 7.67649473578737, -2.388364652703951, -2.021928768325171e-15, 0.0, -3.00748295734082e-15, 2.318072961399693e-15, -2.489004144414679e-15, 0.0, -1.214257805781448e-15, -1.92803225572918e-15, 14.50721143684991, 2.051629516620725, 2.102697003236259e-15, 1.012432136687228e-15, 0.0, 0.0, 3.180177729754381e-15, 0.0, 0.0, -7.523336686733945e-15, 6.008055095531492e-15, -1.112981965438206e-15, -1.280105793819319e-15, 3.826686614094393e-15, 3.963813404490263e-15, -2.740310660808809e-15, 0.0},
      {1.624807680927194, -3.787494779718653e-15, 0.0, 5.393874076303669, 1.616567151041412e-15, 5.724048027717893e-15, -5.677943133980667e-15, 0.0, -4.593681416433441e-15, 9.573176812621551, 0.0, 1.213324948748566e-15, 3.597890753056696e-15, 1.48724886770934e-15, 4.015167645649789e-15, 4.013629543155797e-15, 1.423678456159221e-15, 1.718855727951557e-15, 0.0, 10.05089091390735, 0.0, 0.0, -3.866818259342058e-15, 0.0, -6.244022569003111e-15, 1.672026882690242e-15, 0.0, -1.661660024656901e-15, 0.0, 4.779985138005864e-15, 0.0, -2.66934421747264e-15, -1.017747640454859e-15, -5.702105454474816e-15, -2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats2[35][35] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {3.162277660168373, -1.377513853113707e-15, -1.42272539013179e-15, 0.0, 0.0, 1.71705784245596e-15, 0.0, 1.03765493176126e-15, 0.0, -1.332267629550188e-15, 0.0, 0.0, 0.0, 1.974840255365951e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.136995465223437e-15, 0.0, 0.0, 1.137148054877811e-15, 1.333831423743549e-15, -1.110223024625157e-15},
      {1.82574185835055, 0.0, 0.0, 0.0, 0.0, 1.134250280755357e-15, 0.0, 1.146230823806701e-15, 0.0, -1.77635683940025e-15, 0.0, 0.0, 0.0, 1.062269545910948e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.163977794943212, -2.55712337204465e-15, -1.378119673540963e-15, -2.220446049250313e-15, 0.0, 2.983392196974792e-15, -1.195684674582258e-15, 2.093710497348303e-15, 0.0, -3.552713678800501e-15, -1.743735356522816e-15, -1.071301108763621e-15, 0.0, 3.899266800030941e-15, -1.224145188801324e-15, 0.0, 1.008367249660122e-15, 0.0, 0.0, 0.0, 1.274535489995855e-15, 0.0, 1.151416974512678e-15, 0.0, 1.744002442192462e-15, 0.0, 1.09165556285704e-15, 0.0, 1.019160200487154e-15, 0.0, 0.0, 0.0, 2.537287520138153e-15, 0.0, 0.0},
      {2.958039891549801, 5.612486080160911, -1.080123449734647, -0.7637626158259716, -5.8041659188976e-15, 2.070484993766556e-15, 0.0, 3.790378246279187e-15, -6.825343132349688e-15, 0.0, -4.175765397191937e-15, 2.840795476558801e-15, 3.873604354624122e-15, 1.637867269845033e-15, 0.0, 1.671382267336813e-15, 2.832994509678119e-15, 1.332697160933375e-15, 3.135240707344898e-15, 1.554312234475219e-15, 0.0, 4.556703484417877e-15, 0.0, -1.758449806949419e-15, -3.651385389059474e-15, -2.253864632287776e-15, 0.0, -3.583733732239485e-15, 0.0, 0.0, 1.29199079734845e-15, -2.773531411545137e-15, 2.021349598663447e-15, 0.0, 1.665334536937735e-15},
      {2.291287847477916, 1.449137674618944, 4.183300132670378, -0.5916079783099605, 0.0, 0.0, -4.286224564624598e-15, 1.39835635162406e-15, 2.637596731345307e-15, -3.774758283725532e-15, 0.0, 0.0, 1.260623766591979e-15, 2.769784993476454e-15, 0.0, 0.0, 1.898997038347228e-15, 0.0, 0.0, 0.0, 0.0, 0.0, -1.436932477287468e-15, 1.305854753151728e-15, 0.0, -1.196254688670928e-15, 0.0, -3.211864464663708e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.171947566599055e-15, 0.0},
      {1.870828693387012, 7.099295739719547, -1.308480831916757e-15, 4.347413023856838, -5.573898161800377e-15, -6.71727995612209e-15, -2.534785539862907e-15, 4.618128394985982e-15, -7.783231588844361e-15, -1.77635683940025e-15, -2.121431399951309e-15, 3.159719914651375e-15, 7.370128684588416e-15, 1.722551641182949e-15, 0.0, 1.499020786274114e-15, 3.055061297764658e-15, 0.0, 4.085268307999777e-15, 0.0, 0.0, 2.656145386631945e-15, 0.0, -1.078824284928423e-15, -3.271580186753084e-15, -2.737228625447823e-15, -1.212113431703028e-15, -6.998198510801372e-15, -3.911742562325871e-15, -3.432000037187497e-15, 4.390473695008361e-15, -3.647734566240858e-15, 0.0, 1.224626643309467e-15, 0.0},
      {1.322875655532309, 0.0, 3.864367132317192, -0.3415650255319895, 0.0, 1.695061671105608e-15, -2.462356829756677e-15, 3.648626579550293e-15, 0.0, -1.665334536937735e-15, 0.0, 0.0, 0.0, 1.888135524816112e-15, 0.0, 0.0, 1.977697329705468e-15, -1.937030086439633e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.049079962733242e-15, 0.0, 0.0, -1.886441505395633e-15, 0.0, 0.0, 1.607883755844221e-15, 0.0, 0.0, 0.0, 0.0},
      {1.080123449734641, 0.0, 7.099295739719548, 2.509980079602213, -1.810181176692017e-15, -3.436370060088953e-15, -3.515662160546603e-15, 7.71666890146026e-15, 0.0, -2.664535259100376e-15, 1.369829748127971e-15, -1.338604176184072e-15, 0.0, 2.413616339129081e-15, 1.235669691039856e-15, 1.123902762436759e-15, 4.173505776548605e-15, -3.321741799890756e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.549932791586503e-15, -1.656819977469127e-15, 1.315578638905701e-15, -3.951991201715326e-15, 0.0, 0.0, 4.00692101153847e-15, -3.396575580264771e-15, 1.868496785218947e-15, 2.721382051865167e-15, -1.332267629550188e-15},
      {-3.818813079129892, 2.018649569881804e-15, 1.553159567651604e-15, 8.874119674649428, -4.480656914385747e-15, -1.108864422304e-14, 0.0, -2.620552985028416e-15, -3.718966765992952e-15, 1.77635683940025e-15, 2.05050727532037e-15, 0.0, 0.0, -3.027727767019101e-15, 0.0, 1.789401885157812e-15, -1.084139402481084e-15, 0.0, 0.0, -1.77635683940025e-15, 0.0, 1.194466404281515e-15, 1.711596404978019e-15, 0.0, -1.064578562760769e-15, 0.0, 0.0, -1.340777723751541e-15, -3.484676358197428e-15, 0.0, -1.035629481905191e-15, -3.440050796895994e-15, 0.0, 0.0, 5.329070518200751e-15},
      {2.749545416973485, 5.796550698475745, -1.673320053068136, -1.183215956619908, 7.745966692414835, -1.199999999999994, -0.979795897113269, 0.3464101615137784, 0.2828427124746147, 0.1999999999999991, -3.678489581593858e-15, 0.0, 1.927129175588029e-15, 0.0, 0.0, 2.078949398791156e-15, 0.0, 3.495201924918583e-15, 0.0, 0.0, 2.323640842482583e-15, 6.482513152916032e-15, 0.0, -1.030904579385457e-15, -2.492367935558123e-15, 1.348805410540283e-15, -4.368885971342126e-15, -2.859271584500362e-15, -1.168126967396208e-15, -3.897876338973392e-15, 3.967516730705552e-15, 3.565571795202579e-15, 0.0, 0.0, 0.0},
      {2.323790007724446, 2.449489742783175, 2.828427124746189, -0.9999999999999991, 1.309307341415952, 7.099295739719539, -0.4140393356054155, -2.049390153191912, -0.4780914437337578, 0.1690308509457004, 0.0, 0.0, 1.88383670181008e-15, 3.384318714634279e-15, 0.0, 1.928380388012453e-15, 1.634596000492222e-15, 0.0, 1.403847942964789e-15, 0.0, 0.0, 3.412249031284737e-15, 0.0, 1.805336421687697e-15, 0.0, -1.544197553792045e-15, 3.760800838072586e-15, -5.295233723380199e-15, -1.545891271531431e-15, 0.0, 2.313655218932087e-15, 0.0, 0.0, 1.896780056834161e-15, -1.110223024625157e-15},
      {2.01246117974982, 2.121320343559646, -0.408248290463861, 3.175426480542949, 9.071147352221447, 0.0, 7.171371656006367, -1.085606238206101e-15, -1.380131118684717, -1.56144011671766, -1.619436088531354e-15, 0.0, 6.316566225528372e-15, -1.128969206382206e-15, 0.0, 0.0, 1.011611719393539e-15, 1.279238232107124e-15, 4.730712537567136e-15, 3.108624468950438e-15, 4.280369879324089e-15, 4.276025650631443e-15, 0.0, 0.0, -3.81175616704536e-15, -7.23413269695959e-15, -1.13417277446326e-15, -3.711116874002309e-15, 0.0, -4.640714462858146e-15, 0.0, -3.111605370188009e-15, 0.0, 0.0, 0.0},
      {1.800000000000008, 0.6324555320336759, 4.381780460041328, -0.7745966692414821, 0.0, 3.142337619398284, -0.1069044967649672, 4.762352359916269, -0.7406560798180414, 0.130930734141591, 0.0, 0.0, 0.0, -1.817717490202796e-15, 1.130423725290776e-15, 0.0, 0.0, -2.621250382345837e-15, 0.0, 0.0, 0.0, 1.763396704835514e-15, -1.110175716666318e-15, 0.0, 1.302256037891158e-15, 0.0, -3.263406147621488e-15, 2.539860477118777e-15, 0.0, 0.0, 4.234830901689643e-15, 0.0, 0.0, 1.522005520287024e-15, -2.386979502944087e-15},
      {1.558845726811981, 0.5477225575051626, 1.581138830084189, 2.459674775249769, -3.788731707478617e-15, 9.071147352221452, 1.851640199545096, 1.135197154162479e-14, 5.345224838248491, -1.20948631362953, 0.0, 0.0, 1.463547012721714e-15, 3.48794740859017e-15, 2.513506156434691e-15, 1.570730887273063e-15, 0.0, -3.47246309796415e-15, 5.140614109089145e-15, 0.0, 0.0, 2.890168360350836e-15, -1.379958227892694e-15, 0.0, 2.20106684884582e-15, -4.544630107499728e-15, 0.0, -7.908427843498789e-15, 1.332428644876817e-15, 0.0, 2.991004110663721e-15, -1.101678805260943e-15, 3.190137273095709e-15, 1.049213382126674e-15, -1.332267629550188e-15},
      {1.272792206135769, -6.260990336999445, 4.698957642508435e-15, 3.834057902536149, -5.499147724568134e-15, 9.499704134294986e-15, 10.58300524425835, -1.02282550435213e-14, -1.310962514202265e-14, 5.18459255872629, 4.020569493838736e-15, -1.687572270755087e-15, 5.866608249767686e-15, -2.9295705217617e-15, 2.913071741134497e-15, 0.0, 0.0, -2.844733854728345e-15, 5.191574434285081e-15, 0.0, 0.0, -3.20191850810336e-15, -2.893421088708276e-15, 0.0, -3.517551965730658e-15, -7.594224505701043e-15, 2.349762924085613e-15, 0.0, 0.0, 7.59786661290225e-15, -4.404946057500309e-15, -9.581918896312437e-15, 0.0, -4.112897141881552e-15, -2.664535259100376e-15},
      {1.039230484541334, 2.294043471957636e-15, 3.162277660168364, -0.4472135954999573, 0.0, -5.140482151450791e-15, 2.75588498095467e-15, 5.891883036371794, -0.5345224838248485, 0.07559289460184426, 0.0, 0.0, 0.0, -3.644688370391023e-15, 1.294216322437832e-15, 0.0, 0.0, -2.619359009427042e-15, 0.0, 0.0, 0.0, 1.194925741185562e-15, 0.0, 0.0, 1.077674666393519e-15, 0.0, -3.396084004326159e-15, 3.863677564200769e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.8999999999999969, 3.597625470452205e-15, 1.460593486680382, 1.420093893609391, 1.381390843607261e-15, -7.380314180779471e-15, -2.011582654947753e-15, 9.071147352221434, 4.937707198786957, -0.6982972487551793, 0.0, 0.0, -1.155543162962233e-15, -5.767525589228721e-15, 2.581930130244914e-15, 0.0, -3.527682879519772e-15, -2.632203991400011e-15, 0.0, 0.0, 0.0, 4.027518130294324e-15, -1.92779356626356e-15, 1.578928591515996e-15, 3.231420295363042e-15, 0.0, -8.432196178955177e-15, 2.948617104331394e-15, 1.319086099063573e-15, -2.455376291256845e-15, 1.697588481704532e-15, 2.169972815826074e-15, 1.250107837725232e-15, -1.933788015948892e-15, 0.0},
      {0.7348469228349388, -2.963508039459263e-15, -6.260990336999465, 2.213594362117853, 3.205738828164174e-15, 1.962717508763644e-15, -1.387940683548937e-14, 3.862198853968025e-15, 10.58300524425839, 2.993325909419153, 0.0, 0.0, 0.0, 0.0, 3.385215105426661e-15, 4.20062796744031e-15, -1.834492302982734e-15, -3.011036024402676e-15, 1.934960128632421e-15, -2.664535259100376e-15, 1.20213764673091e-15, 1.326648491695131e-15, -3.707068430959695e-15, 0.0, 1.304139020800299e-15, 0.0, -1.396029937099799e-15, -7.904014298144368e-15, 0.0, 0.0, 1.254318018241437e-15, 1.297583359611666e-15, 4.233382679061703e-15, -1.980785567458971e-15, 0.0},
      {5.715767664977276, -5.487444482324481e-15, -1.98185108201036e-15, -4.695742752749557, 4.926265871360128e-15, 8.044860579859264e-15, -1.034049455352974e-14, 2.132337030567945e-15, -9.688868074925593e-15, 12.69960629311002, 0.0, 0.0, 3.191418349807166e-15, 2.21552854850225e-15, 4.286158775906683e-15, 6.95696600246195e-15, 0.0, 2.65571920843267e-15, 0.0, -3.552713678800501e-15, 2.5573918135326e-15, 0.0, -7.935336668786758e-15, 0.0, -4.643009634524262e-15, 3.632663037265257e-15, 0.0, -3.761171039006338e-15, 0.0, 4.049822987038022e-15, 1.97104922828241e-15, -1.835705130761809e-15, -1.543452452355017e-15, -4.290232587019997e-15, -4.884981308350689e-15},
      {2.569046515733011, 5.802884574739962, -2.01017818278145, -1.421410624438012, 8.142152225127099, -2.102294664680199, -1.716516405813986, 0.7282562343414143, 0.5946187253790762, 0.4204589329360425, 9.810708435174288, -1.184508853698352, -1.025814758310359, 0.3058388709205958, 0.2648642316819865, 0.216260739578392, -0.1059456926727965, -0.09175166127617609, -0.07491491772644182, -0.05297284633639829, 0.0, 5.432392147647825e-15, 0.0, -1.414648943788355e-15, 0.0, 1.851882888867724e-15, -5.13764380909313e-15, 0.0, -4.213501474170275e-15, -3.798446555993807e-15, 0.0, 8.62822218043468e-15, 2.736151781734735e-15, 2.429109504567007e-15, 1.387778780781446e-15},
      {2.265686062395511, 3.070597894314938, 1.772810520855823, -1.253566341056007, 2.393567769390839, 6.303768714031277, -0.9082951062292399, -2.783133725377422, -0.524404424085079, 0.3708099243547806, 1.236033081182607, 9.401747557920132, -0.3015611935232257, -2.427520781138046, -0.7942002066569634, 0.1144344270542679, 0.8409178658720792, 0.3506418906088307, 0.06606874726434203, -0.04671765921511528, 1.071036602912885e-15, 8.11291538898904e-15, -1.222378880799858e-15, 0.0, -1.852005091563646e-15, 0.0, -1.475045488673559e-15, 0.0, -1.044546240954508e-15, -1.695021598452149e-15, 0.0, 0.0, 0.0, -1.664891332371255e-15, 0.0},
      {2.026491220476082, 2.746426249302347, -0.7928249671720843, 2.242447642325542, 2.140872096444118, -0.3316624790355274, 6.499230723708731, 0.095742710775629, -1.876166303929359, -2.155806113730998, 11.05541596785132, 8.860723963920631e-15, 9.440358593314693, -1.951854547423044e-15, -1.462494064565346, -2.047065262876626, -2.63438617131291e-15, 0.4221856709325185, 0.590936840285276, 0.5223193087733389, 2.288334317404159e-15, 2.754194978219067e-15, -2.936176246632068e-15, 1.358347154645709e-15, -3.35894806663724e-15, -7.188594088315395e-15, -1.574393841051513e-15, 0.0, 0.0, -3.837366283233929e-15, -4.588090099592806e-15, 4.736403136041817e-15, 3.190732104166485e-15, 0.0, 2.220446049250313e-15},
      {1.914854215512669, 1.29756443747034, 3.745745886321958, -1.05945692672794, 0.4045867968563349, 5.014265364224016, -0.3838247367893617, 1.80936716113938, -1.108006575534887, 0.3133915852640031, 0.0, 2.825218471274539, -0.05097314515343351, 8.206518066482889, -0.6317380553057853, 0.04835737145616503, -2.842821248876059, -0.2279588351800819, 0.1395957071376006, -0.03948362845661152, -1.67544786849511e-15, 2.273282785107618e-15, 0.0, 2.91563778878378e-15, 3.634076229321126e-15, 0.0, -6.967856436382362e-15, 4.3514571604661e-15, 0.0, -1.035270204131557e-15, -2.097742365837274e-15, 4.575822579667382e-15, 2.632626696553794e-15, 1.733371876814032e-15, 0.0},
      {1.712697677155345, 1.160576914947996, 1.340118788520979, 1.895214165917373, 0.3618734322278734, 1.962141687034859, 2.746426249302378, -0.5664215155988773, 3.17129986868836, -1.821988709389515, 0.0, 11.05541596785132, 1.595711846260565, -1.087484725589498e-15, 8.652231568278275, -0.8650429583135656, 1.923627217241001e-15, -2.497684112518221, -0.9988655696858532, 0.4414403861366474, 0.0, 4.055568567747562e-15, -2.74638737198475e-15, 1.758033230851219e-15, 0.0, -3.680344341985791e-15, 0.0, -4.772495941501818e-15, -3.100240308473809e-15, -1.731665722130397e-15, 0.0, -2.580495214549919e-15, 2.299830198447587e-15, 0.0, 0.0},
      {1.483239697419123, 1.005089091390726, -0.1934294858246603, 3.556157828809251, -8.461572802128115, 3.814099913064139e-15, 4.459640440343012, 2.033505286817821e-15, -0.8582582029070012, 2.670272859251858, 2.089357948769332e-15, 2.133443458477977e-15, 12.43734296383276, 0.0, 0.0, 8.427928244224427, 0.0, -1.65056800158681e-15, -1.621955546837939, -2.293791531904487, 0.0, -2.695374499306845e-15, -2.780632630334375e-15, 0.0, -3.768711868640517e-15, -3.469800486322313e-15, 0.0, -4.369860332954795e-15, 3.660925905348486e-15, 2.082727629572046e-15, 0.0, -3.596817813143604e-15, 0.0, -4.879643184876633e-15, -2.664535259100376e-15},
      {1.48323969741914, 0.3350296971302529, 4.062019202317994, -0.8206518066482944, 1.030810474083418e-15, 1.699264546796656, -0.09910312089650755, 5.886425061104595, -1.201561484069795, 0.2427520781138049, -2.472276730541945e-15, 0.0, 0.0, 4.944132324730427, -0.2140872096444209, 0.01248581962107189, 5.138093031466044, -0.7416198487095683, 0.1513825177048745, -0.03058388709206081, 0.0, 3.94251692312065e-15, 1.111758409267773e-15, 1.72255974436628e-15, 0.0, 0.0, -4.376043004428632e-15, 5.709418438216706e-15, 0.0, 0.0, 0.0, 2.256249980112084e-15, -1.005754995020394e-15, 1.566474118364196e-15, -1.27675647831893e-15},
      {1.326649916142163, 0.2996596709057522, 2.076103099952567, 1.468026580418874, 0.0, 0.8684962373468931, 0.7091242083423421, 1.31624465810882, 4.912956630903944, -1.411306385688708, 0.0, -2.73861393233234e-15, -1.761940884542054e-15, 11.05541596785133, 3.829708431025356, -0.2233531314201661, -4.104821193941962e-15, 5.80409338312195, -1.547435886597331, 0.341938252770122, 0.0, 3.408705479230852e-15, 0.0, 0.0, 4.314978787104634e-15, -1.445941062005045e-15, -8.39144020831911e-15, 9.650549753689481e-15, 2.037962394045881e-15, 1.162150760758864e-15, -1.463995761751609e-15, 6.281773710399129e-15, 2.934842257519165e-15, 4.897764723552159e-15, -1.110223024625157e-15},
      {1.148912529307606, 0.259512887494074, 0.7491491772643916, 2.754588009492676, 0.0, -8.461572802128106, 1.151474210368106, -2.479031051337224e-15, 3.324019726604679, 2.068384462742429, 0.0, 1.148362716204754e-15, 1.412730025989921e-15, -1.985638513073951e-15, 12.43734296383275, 2.176081715527494, 3.445256050147769e-15, -3.341509186313716e-15, 6.281806821192097, -1.776763280547534, 0.0, -2.191496422504729e-15, 0.0, 0.0, -1.422201091589263e-15, 0.0, -1.1122508880814e-15, -7.158696249810677e-15, 0.0, 0.0, 0.0, -8.470570044008668e-15, 3.734433399216251e-15, -5.025460405045879e-15, 0.0},
      {0.9380831519647022, 7.628089872441263, 0.0, 3.114154649928884, 0.0, 8.355058715479915e-15, -7.521398046336083, -1.283610512696056e-14, 1.695646287090573e-14, 5.527076209766944, -8.037774626389773e-15, 2.79754361984171e-15, -1.151061772715441e-15, -3.748171647853741e-15, -7.154438830755038e-15, 14.2141062443803, -3.068879030937173e-15, 5.421424029206731e-15, -2.854499567680649e-15, 5.802884574739982, 0.0, 6.012546901329439e-15, 1.073153914086776e-14, -3.764453990450407e-15, 0.0, 3.400858910063925e-15, 1.393632606047288e-15, 1.895302068680078e-15, 0.0, 0.0, -8.074188879667641e-15, 7.446707018654686e-15, -2.376301336653487e-15, 1.492284178673057e-15, 0.0},
      {0.8563488385776421, 1.206909029624218e-15, 2.680237577041946, -0.4738035414793293, 2.209971420187656e-15, 2.024139611486243e-15, 5.07573174525202e-15, 5.097793640389905, -0.7928249671720937, 0.1401529776453395, -2.229118990793571e-15, 0.0, 0.0, -3.142819333805001e-15, 0.0, 0.0, 7.910611719568701, -0.6422616289332556, 0.09988655696858671, -0.01765761544546627, 0.0, 1.664219727787279e-15, 0.0, 1.29494965905702e-15, -1.332408220259157e-15, 0.0, -2.285660079439968e-15, 3.084091503641552e-15, 1.487265339551165e-15, 1.071746431401883e-15, 3.407337931103051e-15, -3.374183627151049e-15, -1.38226214909169e-15, 0.0, 0.0},
      {0.7659416862050155, 2.538485801330488e-15, 1.498298354528752, 0.8475655413823908, 3.170444006272876e-15, 1.087566816343244e-14, 1.851443556855282e-15, 1.628430445025356, 3.545621041711658, -0.8148181216864243, -2.945231028106031e-15, 0.0, 0.0, -3.540310842402916e-15, -1.003031974959901e-15, 0.0, 11.05541596785132, 7.180703308172537, -1.11676565710081, 0.1974181422830608, 1.007046029560443e-15, 1.192382528659482e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 4.194420354066973e-15, 3.414003852836175e-15, -1.559861333836308e-15, 6.203640157060057e-15, -1.994039861710072e-15, -2.398674205449843e-15, -1.512857714536828e-15, 1.332267629550188e-15},
      {0.6633249580710916, 0.0, 0.6920343666509071, 1.59036212878708, -2.177345378465143e-15, 1.250635236634191e-14, -4.423629541542057e-15, -8.461572802128108, 3.070597894314846, 1.194182326351993, 0.0, 0.0, 0.0, 2.006685252646133e-15, -3.075252106892676e-15, 3.083440132040905e-15, 1.212445027307341e-15, 12.43734296383273, 5.802884574739989, -1.025814758310364, 0.0, -3.439657926401698e-15, -2.463733154121921e-15, 0.0, 1.809892425331357e-15, 0.0, 4.867165653635995e-15, -1.956079893920824e-15, 4.610433753195681e-15, -2.709657518974828e-15, 4.436689631271264e-15, 4.338277050078903e-15, -2.002701355722282e-15, -8.45616246368895e-15, 2.886579864025407e-15},
      {0.5416025603091125, 1.054334818917785e-15, 7.628089872441228, 1.797958025434556, 0.0, 4.131541292542829e-15, 1.321449958913039e-14, 3.224911279213526e-15, -7.521398046336088, 3.191058937540523, 0.0, 0.0, 1.238938529301479e-15, -1.23471409268577e-15, -4.385208067720001e-15, 1.1493531541712e-15, 3.139055503814198e-15, 0.0, 14.21410624438027, 3.350296971302452, 0.0, 0.0, 2.442193576886961e-15, 0.0, -2.633611216187931e-15, 0.0, 0.0, 0.0, 2.44187361990129e-15, 3.618587404182928e-15, 1.189187755021773e-15, -6.988883640572577e-15, 2.244729450581526e-15, -3.75107352586687e-15, 1.998401444325282e-15},
      {-5.361591803435511, 1.053281016544279e-15, 1.708826919208747e-15, 8.899438184514764, 0.0, 1.611497294682766e-15, 6.454940024035835e-15, 0.0, 7.029030776910563e-15, -5.264978632435261, -2.300728467150007e-15, 1.466287133358854e-15, 0.0, 2.47050619196598e-15, 0.0, -6.475698004187597e-15, 0.0, 1.110951249010398e-15, 0.0, 16.58312395177699, 0.0, 0.0, 5.434216342261197e-15, 0.0, -2.96676431435096e-15, -1.244863532758617e-15, 0.0, 4.949927511292215e-15, 2.857643840069517e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 7.105427357601002e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[81];
      for (unsigned int r = 0; r < 81; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[35][35] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 35; t++)
        {
          for (unsigned int u = 0; u < 35; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 2)
          {
          for (unsigned int t = 0; t < 35; t++)
          {
            for (unsigned int u = 0; u < 35; u++)
            {
              for (unsigned int tu = 0; tu < 35; tu++)
              {
                dmats[t][u] += dmats2[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 35; s++)
        {
          for (unsigned int t = 0; t < 35; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
}

void poisson3d_4_finite_element_2::_evaluate_basis_derivatives_all(std::size_t n,
                                                    double * values,
                                                    const double * x,
                                                    const double * coordinate_dofs,
                                                    int cell_orientation)
{
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 3;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 35; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 4)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[81];
    for (unsigned int r = 0; r < 81; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 35; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
}

double poisson3d_4_finite_element_2::evaluate_dof(std::size_t i,
                                   const ufc::function& f,
                                   const double * coordinate_dofs,
                                   int cell_orientation,
                                   const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      y[2] = coordinate_dofs[2];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[3];
      y[1] = coordinate_dofs[4];
      y[2] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[6];
      y[1] = coordinate_dofs[7];
      y[2] = coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[9];
      y[1] = coordinate_dofs[10];
      y[2] = coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 4:
      {
        y[0] = 0.75*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
      y[1] = 0.75*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
      y[2] = 0.75*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 5:
      {
        y[0] = 0.5*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
      y[1] = 0.5*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
      y[2] = 0.5*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 6:
      {
        y[0] = 0.25*coordinate_dofs[6] + 0.75*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[7] + 0.75*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[8] + 0.75*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 7:
      {
        y[0] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
      y[1] = 0.75*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
      y[2] = 0.75*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 8:
      {
        y[0] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[9];
      y[1] = 0.5*coordinate_dofs[4] + 0.5*coordinate_dofs[10];
      y[2] = 0.5*coordinate_dofs[5] + 0.5*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 9:
      {
        y[0] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[4] + 0.75*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[5] + 0.75*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 10:
      {
        y[0] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
      y[1] = 0.75*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
      y[2] = 0.75*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 11:
      {
        y[0] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[6];
      y[1] = 0.5*coordinate_dofs[4] + 0.5*coordinate_dofs[7];
      y[2] = 0.5*coordinate_dofs[5] + 0.5*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 12:
      {
        y[0] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[6];
      y[1] = 0.25*coordinate_dofs[4] + 0.75*coordinate_dofs[7];
      y[2] = 0.25*coordinate_dofs[5] + 0.75*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 13:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[9];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[10];
      y[2] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 14:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[9];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[10];
      y[2] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 15:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 16:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[6];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[7];
      y[2] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 17:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[6];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[7];
      y[2] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 18:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[6];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[7];
      y[2] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 19:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[3];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[4];
      y[2] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 20:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[3];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[4];
      y[2] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 21:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[3];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[4];
      y[2] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 22:
      {
        y[0] = 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
      y[1] = 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
      y[2] = 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 23:
      {
        y[0] = 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 24:
      {
        y[0] = 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 25:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
      y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
      y[2] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 26:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 27:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 28:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
      y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
      y[2] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 29:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 30:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 31:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
      y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
      y[2] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 32:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
      y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
      y[2] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 33:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[6];
      y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[7];
      y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[8];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 34:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
      y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
      y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
}

void poisson3d_4_finite_element_2::evaluate_dofs(double * values,
                                  const ufc::function& f,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::cell& c) const
{
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[3];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    y[2] = coordinate_dofs[2];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[3];
    y[1] = coordinate_dofs[4];
    y[2] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[6];
    y[1] = coordinate_dofs[7];
    y[2] = coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[9];
    y[1] = coordinate_dofs[10];
    y[2] = coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[3] = vals[0];
    y[0] = 0.75*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    y[1] = 0.75*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    y[2] = 0.75*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[4] = vals[0];
    y[0] = 0.5*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
    y[1] = 0.5*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
    y[2] = 0.5*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[5] = vals[0];
    y[0] = 0.25*coordinate_dofs[6] + 0.75*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[7] + 0.75*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[8] + 0.75*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[6] = vals[0];
    y[0] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
    y[1] = 0.75*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
    y[2] = 0.75*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[7] = vals[0];
    y[0] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[9];
    y[1] = 0.5*coordinate_dofs[4] + 0.5*coordinate_dofs[10];
    y[2] = 0.5*coordinate_dofs[5] + 0.5*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[8] = vals[0];
    y[0] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[4] + 0.75*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[5] + 0.75*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[9] = vals[0];
    y[0] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
    y[1] = 0.75*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
    y[2] = 0.75*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[10] = vals[0];
    y[0] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[6];
    y[1] = 0.5*coordinate_dofs[4] + 0.5*coordinate_dofs[7];
    y[2] = 0.5*coordinate_dofs[5] + 0.5*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[11] = vals[0];
    y[0] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[6];
    y[1] = 0.25*coordinate_dofs[4] + 0.75*coordinate_dofs[7];
    y[2] = 0.25*coordinate_dofs[5] + 0.75*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[12] = vals[0];
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[9];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[10];
    y[2] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[13] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[9];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[10];
    y[2] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[14] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[15] = vals[0];
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[6];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[7];
    y[2] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[16] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[6];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[7];
    y[2] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[17] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[6];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[7];
    y[2] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[18] = vals[0];
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[3];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[4];
    y[2] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[19] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[3];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[4];
    y[2] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[20] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[3];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[4];
    y[2] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[21] = vals[0];
    y[0] = 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    y[1] = 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    y[2] = 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[22] = vals[0];
    y[0] = 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[23] = vals[0];
    y[0] = 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[24] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    y[2] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[25] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[26] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[27] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
    y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
    y[2] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[28] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[29] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[30] = vals[0];
    y[0] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
    y[1] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
    y[2] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[31] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
    y[1] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
    y[2] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[32] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[6];
    y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[7];
    y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[8];
    f.evaluate(vals, y, c);
    values[33] = vals[0];
    y[0] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    y[1] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    y[2] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    f.evaluate(vals, y, c);
    values[34] = vals[0];
}

void poisson3d_4_finite_element_2::interpolate_vertex_values(double * vertex_values,
                                              const double * dof_values,
                                              const double * coordinate_dofs,
                                              int cell_orientation,
                                              const ufc::cell& c) const
{
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
    vertex_values[3] = dof_values[3];
}

void poisson3d_4_finite_element_2::tabulate_dof_coordinates(double * dof_coordinates,
                                             const double * coordinate_dofs) const
{
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[6];
    dof_coordinates[7] = coordinate_dofs[7];
    dof_coordinates[8] = coordinate_dofs[8];
    dof_coordinates[9] = coordinate_dofs[9];
    dof_coordinates[10] = coordinate_dofs[10];
    dof_coordinates[11] = coordinate_dofs[11];
    dof_coordinates[12] = 0.75*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    dof_coordinates[13] = 0.75*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    dof_coordinates[14] = 0.75*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    dof_coordinates[15] = 0.5*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
    dof_coordinates[16] = 0.5*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
    dof_coordinates[17] = 0.5*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
    dof_coordinates[18] = 0.25*coordinate_dofs[6] + 0.75*coordinate_dofs[9];
    dof_coordinates[19] = 0.25*coordinate_dofs[7] + 0.75*coordinate_dofs[10];
    dof_coordinates[20] = 0.25*coordinate_dofs[8] + 0.75*coordinate_dofs[11];
    dof_coordinates[21] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
    dof_coordinates[22] = 0.75*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
    dof_coordinates[23] = 0.75*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
    dof_coordinates[24] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[9];
    dof_coordinates[25] = 0.5*coordinate_dofs[4] + 0.5*coordinate_dofs[10];
    dof_coordinates[26] = 0.5*coordinate_dofs[5] + 0.5*coordinate_dofs[11];
    dof_coordinates[27] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[9];
    dof_coordinates[28] = 0.25*coordinate_dofs[4] + 0.75*coordinate_dofs[10];
    dof_coordinates[29] = 0.25*coordinate_dofs[5] + 0.75*coordinate_dofs[11];
    dof_coordinates[30] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
    dof_coordinates[31] = 0.75*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
    dof_coordinates[32] = 0.75*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
    dof_coordinates[33] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[6];
    dof_coordinates[34] = 0.5*coordinate_dofs[4] + 0.5*coordinate_dofs[7];
    dof_coordinates[35] = 0.5*coordinate_dofs[5] + 0.5*coordinate_dofs[8];
    dof_coordinates[36] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[6];
    dof_coordinates[37] = 0.25*coordinate_dofs[4] + 0.75*coordinate_dofs[7];
    dof_coordinates[38] = 0.25*coordinate_dofs[5] + 0.75*coordinate_dofs[8];
    dof_coordinates[39] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[9];
    dof_coordinates[40] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[10];
    dof_coordinates[41] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[11];
    dof_coordinates[42] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[9];
    dof_coordinates[43] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[10];
    dof_coordinates[44] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[11];
    dof_coordinates[45] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[9];
    dof_coordinates[46] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[10];
    dof_coordinates[47] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[11];
    dof_coordinates[48] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[6];
    dof_coordinates[49] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[7];
    dof_coordinates[50] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[8];
    dof_coordinates[51] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[6];
    dof_coordinates[52] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[7];
    dof_coordinates[53] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[8];
    dof_coordinates[54] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[6];
    dof_coordinates[55] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[7];
    dof_coordinates[56] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[8];
    dof_coordinates[57] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[3];
    dof_coordinates[58] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[4];
    dof_coordinates[59] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[5];
    dof_coordinates[60] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[3];
    dof_coordinates[61] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[4];
    dof_coordinates[62] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[5];
    dof_coordinates[63] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[3];
    dof_coordinates[64] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[4];
    dof_coordinates[65] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[5];
    dof_coordinates[66] = 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    dof_coordinates[67] = 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    dof_coordinates[68] = 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    dof_coordinates[69] = 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    dof_coordinates[70] = 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    dof_coordinates[71] = 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    dof_coordinates[72] = 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
    dof_coordinates[73] = 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
    dof_coordinates[74] = 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
    dof_coordinates[75] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    dof_coordinates[76] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    dof_coordinates[77] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    dof_coordinates[78] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    dof_coordinates[79] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    dof_coordinates[80] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
    dof_coordinates[81] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[6] + 0.5*coordinate_dofs[9];
    dof_coordinates[82] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[7] + 0.5*coordinate_dofs[10];
    dof_coordinates[83] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[8] + 0.5*coordinate_dofs[11];
    dof_coordinates[84] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
    dof_coordinates[85] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
    dof_coordinates[86] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
    dof_coordinates[87] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[9];
    dof_coordinates[88] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[10];
    dof_coordinates[89] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[11];
    dof_coordinates[90] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[9];
    dof_coordinates[91] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[10];
    dof_coordinates[92] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[11];
    dof_coordinates[93] = 0.5*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
    dof_coordinates[94] = 0.5*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
    dof_coordinates[95] = 0.5*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
    dof_coordinates[96] = 0.25*coordinate_dofs[0] + 0.5*coordinate_dofs[3] + 0.25*coordinate_dofs[6];
    dof_coordinates[97] = 0.25*coordinate_dofs[1] + 0.5*coordinate_dofs[4] + 0.25*coordinate_dofs[7];
    dof_coordinates[98] = 0.25*coordinate_dofs[2] + 0.5*coordinate_dofs[5] + 0.25*coordinate_dofs[8];
    dof_coordinates[99] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.5*coordinate_dofs[6];
    dof_coordinates[100] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.5*coordinate_dofs[7];
    dof_coordinates[101] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.5*coordinate_dofs[8];
    dof_coordinates[102] = 0.25*coordinate_dofs[0] + 0.25*coordinate_dofs[3] + 0.25*coordinate_dofs[6] + 0.25*coordinate_dofs[9];
    dof_coordinates[103] = 0.25*coordinate_dofs[1] + 0.25*coordinate_dofs[4] + 0.25*coordinate_dofs[7] + 0.25*coordinate_dofs[10];
    dof_coordinates[104] = 0.25*coordinate_dofs[2] + 0.25*coordinate_dofs[5] + 0.25*coordinate_dofs[8] + 0.25*coordinate_dofs[11];
}

std::size_t poisson3d_4_finite_element_2::num_sub_elements() const
{
    return 0;
}

ufc::finite_element * poisson3d_4_finite_element_2::create_sub_element(std::size_t i) const
{
    return 0;
}

ufc::finite_element * poisson3d_4_finite_element_2::create() const
{
    return new poisson3d_4_finite_element_2();
}


poisson3d_4_dofmap_0::poisson3d_4_dofmap_0() : ufc::dofmap()
{
    // Do nothing
}

poisson3d_4_dofmap_0::~poisson3d_4_dofmap_0()
{
    // Do nothing
}

const char * poisson3d_4_dofmap_0::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', tetrahedron, 1)";
}

bool poisson3d_4_dofmap_0::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    case 3:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson3d_4_dofmap_0::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_dofmap_0::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0];
}

std::size_t poisson3d_4_dofmap_0::num_element_dofs() const
{
    return 4;
}

std::size_t poisson3d_4_dofmap_0::num_facet_dofs() const
{
    return 3;
}

std::size_t poisson3d_4_dofmap_0::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    case 3:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_dofmap_0::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    case 3:
      {
        return 4;
        break;
      }
    }
    
    return 0;
}

void poisson3d_4_dofmap_0::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
    dofs[3] = entity_indices[0][3];
}

void poisson3d_4_dofmap_0::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
        break;
      }
    case 3:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    }
    
}

void poisson3d_4_dofmap_0::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    case 3:
      {
        
        break;
      }
    }
    
}

void poisson3d_4_dofmap_0::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 2;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 3;
          break;
        }
      case 2:
        {
          dofs[0] = 1;
        dofs[1] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 4:
        {
          dofs[0] = 0;
        dofs[1] = 2;
          break;
        }
      case 5:
        {
          dofs[0] = 0;
        dofs[1] = 1;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
        break;
      }
    }
    
}

std::size_t poisson3d_4_dofmap_0::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson3d_4_dofmap_0::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson3d_4_dofmap_0::create() const
{
    return new poisson3d_4_dofmap_0();
}


poisson3d_4_dofmap_1::poisson3d_4_dofmap_1() : ufc::dofmap()
{
    // Do nothing
}

poisson3d_4_dofmap_1::~poisson3d_4_dofmap_1()
{
    // Do nothing
}

const char * poisson3d_4_dofmap_1::signature() const
{
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', tetrahedron, 1), dim=3)";
}

bool poisson3d_4_dofmap_1::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    case 3:
      {
        return false;
        break;
      }
    }
    
    return false;
}

std::size_t poisson3d_4_dofmap_1::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_dofmap_1::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return 3*num_global_entities[0];
}

std::size_t poisson3d_4_dofmap_1::num_element_dofs() const
{
    return 12;
}

std::size_t poisson3d_4_dofmap_1::num_facet_dofs() const
{
    return 9;
}

std::size_t poisson3d_4_dofmap_1::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 3;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    case 3:
      {
        return 0;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_dofmap_1::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 3;
        break;
      }
    case 1:
      {
        return 6;
        break;
      }
    case 2:
      {
        return 9;
        break;
      }
    case 3:
      {
        return 12;
        break;
      }
    }
    
    return 0;
}

void poisson3d_4_dofmap_1::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    dofs[3] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
    dofs[4] = offset + entity_indices[0][0];
    dofs[5] = offset + entity_indices[0][1];
    dofs[6] = offset + entity_indices[0][2];
    dofs[7] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
    dofs[8] = offset + entity_indices[0][0];
    dofs[9] = offset + entity_indices[0][1];
    dofs[10] = offset + entity_indices[0][2];
    dofs[11] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
}

void poisson3d_4_dofmap_1::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 5;
      dofs[4] = 6;
      dofs[5] = 7;
      dofs[6] = 9;
      dofs[7] = 10;
      dofs[8] = 11;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 6;
      dofs[5] = 7;
      dofs[6] = 8;
      dofs[7] = 10;
      dofs[8] = 11;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 7;
      dofs[6] = 8;
      dofs[7] = 9;
      dofs[8] = 11;
        break;
      }
    case 3:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 6;
      dofs[6] = 8;
      dofs[7] = 9;
      dofs[8] = 10;
        break;
      }
    }
    
}

void poisson3d_4_dofmap_1::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 4;
        dofs[2] = 8;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 5;
        dofs[2] = 9;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 6;
        dofs[2] = 10;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
        dofs[1] = 7;
        dofs[2] = 11;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    case 3:
      {
        
        break;
      }
    }
    
}

void poisson3d_4_dofmap_1::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 4;
        dofs[2] = 8;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 5;
        dofs[2] = 9;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 6;
        dofs[2] = 10;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
        dofs[1] = 7;
        dofs[2] = 11;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 2;
        dofs[1] = 3;
        dofs[2] = 6;
        dofs[3] = 7;
        dofs[4] = 10;
        dofs[5] = 11;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 3;
        dofs[2] = 5;
        dofs[3] = 7;
        dofs[4] = 9;
        dofs[5] = 11;
          break;
        }
      case 2:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 5;
        dofs[3] = 6;
        dofs[4] = 9;
        dofs[5] = 10;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 3;
        dofs[2] = 4;
        dofs[3] = 7;
        dofs[4] = 8;
        dofs[5] = 11;
          break;
        }
      case 4:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 6;
        dofs[4] = 8;
        dofs[5] = 10;
          break;
        }
      case 5:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 4;
        dofs[3] = 5;
        dofs[4] = 8;
        dofs[5] = 9;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        dofs[4] = 6;
        dofs[5] = 7;
        dofs[6] = 9;
        dofs[7] = 10;
        dofs[8] = 11;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 6;
        dofs[5] = 7;
        dofs[6] = 8;
        dofs[7] = 10;
        dofs[8] = 11;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 7;
        dofs[6] = 8;
        dofs[7] = 9;
        dofs[8] = 11;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 6;
        dofs[6] = 8;
        dofs[7] = 9;
        dofs[8] = 10;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
        break;
      }
    }
    
}

std::size_t poisson3d_4_dofmap_1::num_sub_dofmaps() const
{
    return 3;
}

ufc::dofmap * poisson3d_4_dofmap_1::create_sub_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_4_dofmap_0();
        break;
      }
    case 1:
      {
        return new poisson3d_4_dofmap_0();
        break;
      }
    case 2:
      {
        return new poisson3d_4_dofmap_0();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson3d_4_dofmap_1::create() const
{
    return new poisson3d_4_dofmap_1();
}


poisson3d_4_dofmap_2::poisson3d_4_dofmap_2() : ufc::dofmap()
{
    // Do nothing
}

poisson3d_4_dofmap_2::~poisson3d_4_dofmap_2()
{
    // Do nothing
}

const char * poisson3d_4_dofmap_2::signature() const
{
    return "FFC dofmap for FiniteElement('Lagrange', tetrahedron, 4)";
}

bool poisson3d_4_dofmap_2::needs_mesh_entities(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return true;
        break;
      }
    case 2:
      {
        return true;
        break;
      }
    case 3:
      {
        return true;
        break;
      }
    }
    
    return false;
}

std::size_t poisson3d_4_dofmap_2::topological_dimension() const
{
    return 3;
}

std::size_t poisson3d_4_dofmap_2::global_dimension(const std::vector<std::size_t>&
                                            num_global_entities) const
{
    return num_global_entities[0] + 3*num_global_entities[1] + 3*num_global_entities[2] + num_global_entities[3];
}

std::size_t poisson3d_4_dofmap_2::num_element_dofs() const
{
    return 35;
}

std::size_t poisson3d_4_dofmap_2::num_facet_dofs() const
{
    return 15;
}

std::size_t poisson3d_4_dofmap_2::num_entity_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 3;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    case 3:
      {
        return 1;
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_dofmap_2::num_entity_closure_dofs(std::size_t d) const
{
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 5;
        break;
      }
    case 2:
      {
        return 15;
        break;
      }
    case 3:
      {
        return 35;
        break;
      }
    }
    
    return 0;
}

void poisson3d_4_dofmap_2::tabulate_dofs(std::size_t * dofs,
                                  const std::vector<std::size_t>& num_global_entities,
                                  const std::vector<std::vector<std::size_t>>& entity_indices) const
{
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    dofs[3] = offset + entity_indices[0][3];
    offset += num_global_entities[0];
    dofs[4] = offset + 3*entity_indices[1][0];
    dofs[5] = offset + 3*entity_indices[1][0] + 1;
    dofs[6] = offset + 3*entity_indices[1][0] + 2;
    dofs[7] = offset + 3*entity_indices[1][1];
    dofs[8] = offset + 3*entity_indices[1][1] + 1;
    dofs[9] = offset + 3*entity_indices[1][1] + 2;
    dofs[10] = offset + 3*entity_indices[1][2];
    dofs[11] = offset + 3*entity_indices[1][2] + 1;
    dofs[12] = offset + 3*entity_indices[1][2] + 2;
    dofs[13] = offset + 3*entity_indices[1][3];
    dofs[14] = offset + 3*entity_indices[1][3] + 1;
    dofs[15] = offset + 3*entity_indices[1][3] + 2;
    dofs[16] = offset + 3*entity_indices[1][4];
    dofs[17] = offset + 3*entity_indices[1][4] + 1;
    dofs[18] = offset + 3*entity_indices[1][4] + 2;
    dofs[19] = offset + 3*entity_indices[1][5];
    dofs[20] = offset + 3*entity_indices[1][5] + 1;
    dofs[21] = offset + 3*entity_indices[1][5] + 2;
    offset += 3*num_global_entities[1];
    dofs[22] = offset + 3*entity_indices[2][0];
    dofs[23] = offset + 3*entity_indices[2][0] + 1;
    dofs[24] = offset + 3*entity_indices[2][0] + 2;
    dofs[25] = offset + 3*entity_indices[2][1];
    dofs[26] = offset + 3*entity_indices[2][1] + 1;
    dofs[27] = offset + 3*entity_indices[2][1] + 2;
    dofs[28] = offset + 3*entity_indices[2][2];
    dofs[29] = offset + 3*entity_indices[2][2] + 1;
    dofs[30] = offset + 3*entity_indices[2][2] + 2;
    dofs[31] = offset + 3*entity_indices[2][3];
    dofs[32] = offset + 3*entity_indices[2][3] + 1;
    dofs[33] = offset + 3*entity_indices[2][3] + 2;
    offset += 3*num_global_entities[2];
    dofs[34] = offset + entity_indices[3][0];
    offset += num_global_entities[3];
}

void poisson3d_4_dofmap_2::tabulate_facet_dofs(std::size_t * dofs,
                                        std::size_t facet) const
{
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 6;
      dofs[6] = 7;
      dofs[7] = 8;
      dofs[8] = 9;
      dofs[9] = 10;
      dofs[10] = 11;
      dofs[11] = 12;
      dofs[12] = 22;
      dofs[13] = 23;
      dofs[14] = 24;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 4;
      dofs[4] = 5;
      dofs[5] = 6;
      dofs[6] = 13;
      dofs[7] = 14;
      dofs[8] = 15;
      dofs[9] = 16;
      dofs[10] = 17;
      dofs[11] = 18;
      dofs[12] = 25;
      dofs[13] = 26;
      dofs[14] = 27;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 7;
      dofs[4] = 8;
      dofs[5] = 9;
      dofs[6] = 13;
      dofs[7] = 14;
      dofs[8] = 15;
      dofs[9] = 19;
      dofs[10] = 20;
      dofs[11] = 21;
      dofs[12] = 28;
      dofs[13] = 29;
      dofs[14] = 30;
        break;
      }
    case 3:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 10;
      dofs[4] = 11;
      dofs[5] = 12;
      dofs[6] = 16;
      dofs[7] = 17;
      dofs[8] = 18;
      dofs[9] = 19;
      dofs[10] = 20;
      dofs[11] = 21;
      dofs[12] = 31;
      dofs[13] = 32;
      dofs[14] = 33;
        break;
      }
    }
    
}

void poisson3d_4_dofmap_2::tabulate_entity_dofs(std::size_t * dofs,
                                         std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 4;
        dofs[1] = 5;
        dofs[2] = 6;
          break;
        }
      case 1:
        {
          dofs[0] = 7;
        dofs[1] = 8;
        dofs[2] = 9;
          break;
        }
      case 2:
        {
          dofs[0] = 10;
        dofs[1] = 11;
        dofs[2] = 12;
          break;
        }
      case 3:
        {
          dofs[0] = 13;
        dofs[1] = 14;
        dofs[2] = 15;
          break;
        }
      case 4:
        {
          dofs[0] = 16;
        dofs[1] = 17;
        dofs[2] = 18;
          break;
        }
      case 5:
        {
          dofs[0] = 19;
        dofs[1] = 20;
        dofs[2] = 21;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 22;
        dofs[1] = 23;
        dofs[2] = 24;
          break;
        }
      case 1:
        {
          dofs[0] = 25;
        dofs[1] = 26;
        dofs[2] = 27;
          break;
        }
      case 2:
        {
          dofs[0] = 28;
        dofs[1] = 29;
        dofs[2] = 30;
          break;
        }
      case 3:
        {
          dofs[0] = 31;
        dofs[1] = 32;
        dofs[2] = 33;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 34;
        break;
      }
    }
    
}

void poisson3d_4_dofmap_2::tabulate_entity_closure_dofs(std::size_t * dofs,
                                             std::size_t d, std::size_t i) const
{
    if (d > 3)
    {
    throw std::runtime_error("d is larger than dimension (3)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      case 3:
        {
          dofs[0] = 3;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 5)
      {
      throw std::runtime_error("i is larger than number of entities (5)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 2;
        dofs[1] = 3;
        dofs[2] = 4;
        dofs[3] = 5;
        dofs[4] = 6;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 3;
        dofs[2] = 7;
        dofs[3] = 8;
        dofs[4] = 9;
          break;
        }
      case 2:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 10;
        dofs[3] = 11;
        dofs[4] = 12;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 3;
        dofs[2] = 13;
        dofs[3] = 14;
        dofs[4] = 15;
          break;
        }
      case 4:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 16;
        dofs[3] = 17;
        dofs[4] = 18;
          break;
        }
      case 5:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 19;
        dofs[3] = 20;
        dofs[4] = 21;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 3)
      {
      throw std::runtime_error("i is larger than number of entities (3)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 6;
        dofs[6] = 7;
        dofs[7] = 8;
        dofs[8] = 9;
        dofs[9] = 10;
        dofs[10] = 11;
        dofs[11] = 12;
        dofs[12] = 22;
        dofs[13] = 23;
        dofs[14] = 24;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 4;
        dofs[4] = 5;
        dofs[5] = 6;
        dofs[6] = 13;
        dofs[7] = 14;
        dofs[8] = 15;
        dofs[9] = 16;
        dofs[10] = 17;
        dofs[11] = 18;
        dofs[12] = 25;
        dofs[13] = 26;
        dofs[14] = 27;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 7;
        dofs[4] = 8;
        dofs[5] = 9;
        dofs[6] = 13;
        dofs[7] = 14;
        dofs[8] = 15;
        dofs[9] = 19;
        dofs[10] = 20;
        dofs[11] = 21;
        dofs[12] = 28;
        dofs[13] = 29;
        dofs[14] = 30;
          break;
        }
      case 3:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        dofs[3] = 10;
        dofs[4] = 11;
        dofs[5] = 12;
        dofs[6] = 16;
        dofs[7] = 17;
        dofs[8] = 18;
        dofs[9] = 19;
        dofs[10] = 20;
        dofs[11] = 21;
        dofs[12] = 31;
        dofs[13] = 32;
        dofs[14] = 33;
          break;
        }
      }
      
        break;
      }
    case 3:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
      dofs[12] = 12;
      dofs[13] = 13;
      dofs[14] = 14;
      dofs[15] = 15;
      dofs[16] = 16;
      dofs[17] = 17;
      dofs[18] = 18;
      dofs[19] = 19;
      dofs[20] = 20;
      dofs[21] = 21;
      dofs[22] = 22;
      dofs[23] = 23;
      dofs[24] = 24;
      dofs[25] = 25;
      dofs[26] = 26;
      dofs[27] = 27;
      dofs[28] = 28;
      dofs[29] = 29;
      dofs[30] = 30;
      dofs[31] = 31;
      dofs[32] = 32;
      dofs[33] = 33;
      dofs[34] = 34;
        break;
      }
    }
    
}

std::size_t poisson3d_4_dofmap_2::num_sub_dofmaps() const
{
    return 0;
}

ufc::dofmap * poisson3d_4_dofmap_2::create_sub_dofmap(std::size_t i) const
{
    return 0;
}

ufc::dofmap * poisson3d_4_dofmap_2::create() const
{
    return new poisson3d_4_dofmap_2();
}


poisson3d_4_cell_integral_0_otherwise::poisson3d_4_cell_integral_0_otherwise() : ufc::cell_integral()
{

}

poisson3d_4_cell_integral_0_otherwise::~poisson3d_4_cell_integral_0_otherwise()
{

}

const std::vector<bool> & poisson3d_4_cell_integral_0_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({});
return enabled;
}

void poisson3d_4_cell_integral_0_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 6
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 6
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           6
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE8_C0_D001_Q24[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c4 = coordinate_dofs[1] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[7] * FE8_C0_D001_Q24[0][0][1];
    const double J_c8 = coordinate_dofs[2] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[11] * FE8_C0_D001_Q24[0][0][1];
    const double J_c5 = coordinate_dofs[1] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[10] * FE8_C0_D001_Q24[0][0][1];
    const double J_c7 = coordinate_dofs[2] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[8] * FE8_C0_D001_Q24[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[3] * FE8_C0_D001_Q24[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[6] * FE8_C0_D001_Q24[0][0][1];
    const double J_c6 = coordinate_dofs[2] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[5] * FE8_C0_D001_Q24[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[4] * FE8_C0_D001_Q24[0][0][1];
    const double J_c2 = coordinate_dofs[0] * FE8_C0_D001_Q24[0][0][0] + coordinate_dofs[9] * FE8_C0_D001_Q24[0][0][1];
    alignas(32) double sp[80];
    sp[0] = J_c4 * J_c8;
    sp[1] = J_c5 * J_c7;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 * sp[2];
    sp[4] = J_c5 * J_c6;
    sp[5] = J_c3 * J_c8;
    sp[6] = sp[4] + -1 * sp[5];
    sp[7] = J_c1 * sp[6];
    sp[8] = sp[3] + sp[7];
    sp[9] = J_c3 * J_c7;
    sp[10] = J_c4 * J_c6;
    sp[11] = sp[9] + -1 * sp[10];
    sp[12] = J_c2 * sp[11];
    sp[13] = sp[8] + sp[12];
    sp[14] = sp[2] / sp[13];
    sp[15] = J_c3 * (-1 * J_c8);
    sp[16] = sp[4] + sp[15];
    sp[17] = sp[16] / sp[13];
    sp[18] = sp[11] / sp[13];
    sp[19] = sp[14] * sp[14];
    sp[20] = sp[14] * sp[17];
    sp[21] = sp[18] * sp[14];
    sp[22] = sp[17] * sp[17];
    sp[23] = sp[18] * sp[17];
    sp[24] = sp[18] * sp[18];
    sp[25] = J_c2 * J_c7;
    sp[26] = J_c8 * (-1 * J_c1);
    sp[27] = sp[25] + sp[26];
    sp[28] = sp[27] / sp[13];
    sp[29] = J_c0 * J_c8;
    sp[30] = J_c6 * (-1 * J_c2);
    sp[31] = sp[29] + sp[30];
    sp[32] = sp[31] / sp[13];
    sp[33] = J_c1 * J_c6;
    sp[34] = J_c0 * J_c7;
    sp[35] = sp[33] + -1 * sp[34];
    sp[36] = sp[35] / sp[13];
    sp[37] = sp[28] * sp[28];
    sp[38] = sp[28] * sp[32];
    sp[39] = sp[28] * sp[36];
    sp[40] = sp[32] * sp[32];
    sp[41] = sp[32] * sp[36];
    sp[42] = sp[36] * sp[36];
    sp[43] = sp[37] + sp[19];
    sp[44] = sp[38] + sp[20];
    sp[45] = sp[39] + sp[21];
    sp[46] = sp[40] + sp[22];
    sp[47] = sp[41] + sp[23];
    sp[48] = sp[24] + sp[42];
    sp[49] = J_c1 * J_c5;
    sp[50] = J_c2 * J_c4;
    sp[51] = sp[49] + -1 * sp[50];
    sp[52] = sp[51] / sp[13];
    sp[53] = J_c2 * J_c3;
    sp[54] = J_c0 * J_c5;
    sp[55] = sp[53] + -1 * sp[54];
    sp[56] = sp[55] / sp[13];
    sp[57] = J_c0 * J_c4;
    sp[58] = J_c1 * J_c3;
    sp[59] = sp[57] + -1 * sp[58];
    sp[60] = sp[59] / sp[13];
    sp[61] = sp[52] * sp[52];
    sp[62] = sp[52] * sp[56];
    sp[63] = sp[60] * sp[52];
    sp[64] = sp[56] * sp[56];
    sp[65] = sp[60] * sp[56];
    sp[66] = sp[60] * sp[60];
    sp[67] = sp[43] + sp[61];
    sp[68] = sp[44] + sp[62];
    sp[69] = sp[45] + sp[63];
    sp[70] = sp[46] + sp[64];
    sp[71] = sp[47] + sp[65];
    sp[72] = sp[48] + sp[66];
    sp[73] = std::abs(sp[13]);
    sp[74] = sp[67] * sp[73];
    sp[75] = sp[68] * sp[73];
    sp[76] = sp[69] * sp[73];
    sp[77] = sp[70] * sp[73];
    sp[78] = sp[71] * sp[73];
    sp[79] = sp[72] * sp[73];
    A[0] = 0.03791887125220478 * sp[74] + 0.03791887125220478 * sp[75] + 0.03791887125220477 * sp[76] + 0.03791887125220478 * sp[75] + 0.0379188712522048 * sp[77] + 0.03791887125220481 * sp[78] + 0.03791887125220477 * sp[76] + 0.03791887125220481 * sp[78] + 0.0379188712522048 * sp[79];
    A[1] = 0.00511463844797173 * sp[74] + 0.005114638447971751 * sp[75] + 0.005114638447971749 * sp[76];
    A[2] = 0.005114638447971808 * sp[75] + 0.005114638447971789 * sp[77] + 0.005114638447971803 * sp[78];
    A[3] = 0.005114638447971848 * sp[76] + 0.005114638447971834 * sp[78] + 0.005114638447971834 * sp[79];
    A[4] = 0.007760141093474405 * sp[75] + 0.007760141093474376 * sp[76] + 0.007760141093474407 * sp[77] + 0.007760141093474357 * sp[78] + 0.0077601410934744 * sp[78] + 0.007760141093474379 * sp[79];
    A[5] = 0.005114638447971729 * sp[75] + 0.005114638447971795 * sp[76] + 0.005114638447971705 * sp[77] + 0.005114638447971788 * sp[78] + 0.005114638447971716 * sp[78] + 0.005114638447971772 * sp[79];
    A[6] = 0.007760141093474561 * sp[75] + 0.007760141093474427 * sp[76] + 0.007760141093474545 * sp[77] + 0.007760141093474405 * sp[78] + 0.007760141093474514 * sp[78] + 0.00776014109347439 * sp[79];
    A[7] = 0.007760141093474334 * sp[74] + 0.00776014109347427 * sp[76] + 0.00776014109347424 * sp[75] + 0.007760141093474196 * sp[78] + 0.007760141093474256 * sp[76] + 0.007760141093474213 * sp[79];
    A[8] = 0.005114638447971604 * sp[74] + 0.005114638447971741 * sp[76] + 0.00511463844797166 * sp[75] + 0.005114638447971771 * sp[78] + 0.005114638447971705 * sp[76] + 0.005114638447971807 * sp[79];
    A[9] = 0.007760141093474576 * sp[74] + 0.007760141093474449 * sp[76] + 0.00776014109347456 * sp[75] + 0.007760141093474464 * sp[78] + 0.007760141093474528 * sp[76] + 0.007760141093474433 * sp[79];
    A[10] = 0.007760141093474322 * sp[74] + 0.007760141093474272 * sp[75] + 0.007760141093474229 * sp[75] + 0.0077601410934742 * sp[77] + 0.007760141093474255 * sp[76] + 0.007760141093474219 * sp[78];
    A[11] = 0.005114638447971536 * sp[74] + 0.005114638447971666 * sp[75] + 0.005114638447971673 * sp[75] + 0.005114638447971783 * sp[77] + 0.005114638447971648 * sp[76] + 0.005114638447971774 * sp[78];
    A[12] = 0.007760141093474413 * sp[74] + 0.007760141093474301 * sp[75] + 0.007760141093474391 * sp[75] + 0.00776014109347432 * sp[77] + 0.007760141093474416 * sp[76] + 0.007760141093474318 * sp[78];
    A[13] = -0.0246913580246911 * sp[74] + -0.02469135802469112 * sp[75] + -0.07054673721340426 * sp[76] + -0.02469135802469111 * sp[75] + -0.02469135802469115 * sp[77] + -0.07054673721340426 * sp[78] + -0.02469135802469115 * sp[76] + -0.02469135802469118 * sp[78] + -0.07054673721340426 * sp[79];
    A[14] = 0.02028218694885368 * sp[74] + 0.02028218694885366 * sp[75] + 0.05291005291005318 * sp[76] + 0.02028218694885368 * sp[75] + 0.02028218694885367 * sp[77] + 0.05291005291005316 * sp[78] + 0.0202821869488537 * sp[76] + 0.02028218694885369 * sp[78] + 0.05291005291005319 * sp[79];
    A[15] = -0.007760141093474598 * sp[74] + -0.007760141093474587 * sp[75] + -0.0253968253968255 * sp[76] + -0.00776014109347458 * sp[75] + -0.00776014109347457 * sp[77] + -0.02539682539682548 * sp[78] + -0.007760141093474551 * sp[76] + -0.007760141093474541 * sp[78] + -0.02539682539682551 * sp[79];
    A[16] = -0.024691358024691 * sp[74] + -0.07054673721340421 * sp[75] + -0.02469135802469103 * sp[76] + -0.02469135802469104 * sp[75] + -0.07054673721340421 * sp[77] + -0.02469135802469107 * sp[78] + -0.02469135802469104 * sp[76] + -0.07054673721340418 * sp[78] + -0.02469135802469107 * sp[79];
    A[17] = 0.02028218694885328 * sp[74] + 0.05291005291005306 * sp[75] + 0.02028218694885329 * sp[76] + 0.02028218694885342 * sp[75] + 0.05291005291005307 * sp[77] + 0.02028218694885342 * sp[78] + 0.02028218694885339 * sp[76] + 0.05291005291005303 * sp[78] + 0.02028218694885339 * sp[79];
    A[18] = -0.007760141093474413 * sp[74] + -0.02539682539682541 * sp[75] + -0.007760141093474392 * sp[76] + -0.007760141093474391 * sp[75] + -0.0253968253968254 * sp[77] + -0.007760141093474369 * sp[78] + -0.007760141093474414 * sp[76] + -0.0253968253968254 * sp[78] + -0.007760141093474393 * sp[79];
    A[19] = -0.07054673721340421 * sp[74] + -0.02469135802469108 * sp[75] + -0.02469135802469106 * sp[76] + -0.07054673721340425 * sp[75] + -0.02469135802469116 * sp[77] + -0.02469135802469114 * sp[78] + -0.07054673721340422 * sp[76] + -0.02469135802469117 * sp[78] + -0.02469135802469115 * sp[79];
    A[20] = 0.05291005291005305 * sp[74] + 0.02028218694885335 * sp[75] + 0.02028218694885336 * sp[76] + 0.05291005291005312 * sp[75] + 0.02028218694885327 * sp[77] + 0.02028218694885328 * sp[78] + 0.05291005291005309 * sp[76] + 0.02028218694885335 * sp[78] + 0.02028218694885336 * sp[79];
    A[21] = -0.02539682539682542 * sp[74] + -0.007760141093474317 * sp[75] + -0.007760141093474335 * sp[76] + -0.02539682539682546 * sp[75] + -0.007760141093474243 * sp[77] + -0.007760141093474261 * sp[78] + -0.02539682539682545 * sp[76] + -0.007760141093474261 * sp[78] + -0.007760141093474279 * sp[79];
    A[22] = 0.01834215167548478 * sp[74] + 0.01834215167548466 * sp[75] + 0.01834215167548466 * sp[76] + 0.01834215167548505 * sp[75] + 0.0183421516754847 * sp[77] + 0.01834215167548478 * sp[78] + 0.01834215167548506 * sp[76] + 0.01834215167548475 * sp[78] + 0.01834215167548478 * sp[79];
    A[23] = 0.01834215167548508 * sp[74] + 0.01834215167548516 * sp[75] + 0.01834215167548487 * sp[76] + 0.01834215167548502 * sp[75] + 0.01834215167548521 * sp[77] + 0.01834215167548495 * sp[78] + 0.01834215167548504 * sp[76] + 0.01834215167548523 * sp[78] + 0.01834215167548497 * sp[79];
    A[24] = 0.01834215167548514 * sp[74] + 0.01834215167548506 * sp[75] + 0.01834215167548517 * sp[76] + 0.01834215167548509 * sp[75] + 0.0183421516754851 * sp[77] + 0.01834215167548517 * sp[78] + 0.01834215167548504 * sp[76] + 0.01834215167548509 * sp[78] + 0.01834215167548519 * sp[79];
    A[25] = 0.04938271604938282 * sp[74] + 0.04232804232804195 * sp[75] + 0.04232804232804215 * sp[76] + 0.04938271604938293 * sp[75] + 0.04232804232804212 * sp[77] + 0.04232804232804221 * sp[78] + 0.04938271604938294 * sp[76] + 0.04232804232804214 * sp[78] + 0.0423280423280422 * sp[79];
    A[26] = -0.01834215167548508 * sp[74] + -0.02539682539682522 * sp[75] + -0.02539682539682513 * sp[76] + -0.01834215167548501 * sp[75] + -0.02539682539682536 * sp[77] + -0.02539682539682525 * sp[78] + -0.01834215167548505 * sp[76] + -0.02539682539682534 * sp[78] + -0.02539682539682521 * sp[79];
    A[27] = -0.01834215167548512 * sp[74] + -0.02539682539682538 * sp[75] + -0.02539682539682558 * sp[76] + -0.01834215167548507 * sp[75] + -0.02539682539682537 * sp[77] + -0.02539682539682557 * sp[78] + -0.01834215167548503 * sp[76] + -0.0253968253968254 * sp[78] + -0.02539682539682555 * sp[79];
    A[28] = 0.0423280423280418 * sp[74] + 0.04938271604938279 * sp[75] + 0.04232804232804206 * sp[76] + 0.04232804232804173 * sp[75] + 0.04938271604938269 * sp[77] + 0.04232804232804214 * sp[78] + 0.04232804232804185 * sp[76] + 0.04938271604938281 * sp[78] + 0.04232804232804215 * sp[79];
    A[29] = -0.02539682539682506 * sp[74] + -0.01834215167548466 * sp[75] + -0.025396825396825 * sp[76] + -0.02539682539682486 * sp[75] + -0.01834215167548469 * sp[77] + -0.02539682539682495 * sp[78] + -0.02539682539682497 * sp[76] + -0.01834215167548474 * sp[78] + -0.02539682539682506 * sp[79];
    A[30] = -0.02539682539682524 * sp[74] + -0.01834215167548503 * sp[75] + -0.02539682539682557 * sp[76] + -0.02539682539682531 * sp[75] + -0.01834215167548506 * sp[77] + -0.02539682539682561 * sp[78] + -0.02539682539682538 * sp[76] + -0.01834215167548505 * sp[78] + -0.02539682539682559 * sp[79];
    A[31] = 0.04232804232804181 * sp[74] + 0.04232804232804188 * sp[75] + 0.04938271604938252 * sp[76] + 0.04232804232804176 * sp[75] + 0.0423280423280421 * sp[77] + 0.04938271604938253 * sp[78] + 0.04232804232804181 * sp[76] + 0.04232804232804208 * sp[78] + 0.0493827160493826 * sp[79];
    A[32] = -0.02539682539682512 * sp[74] + -0.02539682539682497 * sp[75] + -0.01834215167548461 * sp[76] + -0.02539682539682492 * sp[75] + -0.02539682539682501 * sp[77] + -0.01834215167548474 * sp[78] + -0.02539682539682503 * sp[76] + -0.02539682539682508 * sp[78] + -0.01834215167548474 * sp[79];
    A[33] = -0.02539682539682482 * sp[74] + -0.0253968253968252 * sp[75] + -0.01834215167548483 * sp[76] + -0.02539682539682509 * sp[75] + -0.02539682539682534 * sp[77] + -0.01834215167548489 * sp[78] + -0.02539682539682504 * sp[76] + -0.02539682539682531 * sp[78] + -0.01834215167548493 * sp[79];
    A[34] = -0.06772486772486763 * sp[74] + -0.06772486772486802 * sp[75] + -0.06772486772486772 * sp[76] + -0.06772486772486801 * sp[75] + -0.06772486772486797 * sp[77] + -0.06772486772486776 * sp[78] + -0.06772486772486805 * sp[76] + -0.0677248677248681 * sp[78] + -0.06772486772486785 * sp[79];
    A[35] = 0.00511463844797173 * sp[74] + 0.005114638447971751 * sp[75] + 0.005114638447971749 * sp[76];
    A[36] = 0.0379188712522046 * sp[74];
    A[37] = -0.00511463844797178 * sp[75];
    A[38] = -0.005114638447971823 * sp[76];
    A[39] = -0.007760141093474575 * sp[75] + -0.007760141093474543 * sp[76];
    A[40] = -0.00511463844797164 * sp[75] + -0.005114638447971716 * sp[76];
    A[41] = -0.007760141093474567 * sp[75] + -0.007760141093474441 * sp[76];
    A[42] = -0.02469135802469159 * sp[74] + 0.04585537918871248 * sp[76];
    A[43] = 0.0202821869488537 * sp[74] + -0.03262786596119938 * sp[76];
    A[44] = -0.0077601410934746 * sp[74] + 0.01763668430335089 * sp[76];
    A[45] = -0.02469135802469155 * sp[74] + 0.04585537918871252 * sp[75];
    A[46] = 0.02028218694885365 * sp[74] + -0.03262786596119943 * sp[75];
    A[47] = -0.007760141093474573 * sp[74] + 0.0176366843033509 * sp[75];
    A[48] = 0.007760141093474646 * sp[74] + 0.007760141093474638 * sp[75];
    A[49] = 0.005114638447971682 * sp[74] + 0.005114638447971691 * sp[75];
    A[50] = 0.007760141093474602 * sp[74] + 0.007760141093474573 * sp[75];
    A[51] = 0.007760141093474616 * sp[74] + 0.007760141093474603 * sp[76];
    A[52] = 0.005114638447971594 * sp[74] + 0.005114638447971613 * sp[76];
    A[53] = 0.007760141093474576 * sp[74] + 0.007760141093474567 * sp[76];
    A[54] = -0.02539682539682534 * sp[74] + -0.01763668430335084 * sp[75] + -0.01763668430335084 * sp[76];
    A[55] = 0.05291005291005282 * sp[74] + 0.03262786596119917 * sp[75] + 0.03262786596119916 * sp[76];
    A[56] = -0.07054673721340386 * sp[74] + -0.04585537918871249 * sp[75] + -0.04585537918871253 * sp[76];
    A[57] = 0.0493827160493825 * sp[74] + 0.007054673721340087 * sp[75] + 0.007054673721340094 * sp[76];
    A[58] = -0.01834215167548509 * sp[74] + 0.007054673721340401 * sp[75] + 0.007054673721340262 * sp[76];
    A[59] = -0.01834215167548502 * sp[74] + 0.007054673721340251 * sp[75] + 0.007054673721340351 * sp[76];
    A[60] = 0.01834215167548496 * sp[74];
    A[61] = 0.01834215167548507 * sp[74];
    A[62] = 0.01834215167548505 * sp[74];
    A[63] = -0.02539682539682566 * sp[74] + -0.007054673721340483 * sp[75];
    A[64] = 0.04232804232804256 * sp[74] + -0.007054673721339992 * sp[75];
    A[65] = -0.02539682539682537 * sp[74] + -0.007054673721340241 * sp[75];
    A[66] = -0.02539682539682569 * sp[74] + -0.007054673721340621 * sp[76];
    A[67] = 0.04232804232804262 * sp[74] + -0.007054673721339957 * sp[76];
    A[68] = -0.02539682539682524 * sp[74] + -0.007054673721340255 * sp[76];
    A[69] = -0.06772486772486747 * sp[74];
    A[70] = 0.005114638447971808 * sp[75] + 0.005114638447971789 * sp[77] + 0.005114638447971803 * sp[78];
    A[71] = -0.00511463844797178 * sp[75];
    A[72] = 0.03791887125220476 * sp[77];
    A[73] = -0.005114638447971807 * sp[78];
    A[74] = -0.02469135802469163 * sp[77] + 0.04585537918871244 * sp[78];
    A[75] = 0.0202821869488537 * sp[77] + -0.03262786596119931 * sp[78];
    A[76] = -0.007760141093474585 * sp[77] + 0.01763668430335085 * sp[78];
    A[77] = -0.007760141093474662 * sp[75] + -0.007760141093474595 * sp[78];
    A[78] = -0.005114638447971583 * sp[75] + -0.00511463844797164 * sp[78];
    A[79] = -0.007760141093474608 * sp[75] + -0.007760141093474556 * sp[78];
    A[80] = 0.01763668430335094 * sp[75] + -0.007760141093474527 * sp[77];
    A[81] = -0.03262786596119946 * sp[75] + 0.02028218694885377 * sp[77];
    A[82] = 0.04585537918871271 * sp[75] + -0.02469135802469159 * sp[77];
    A[83] = 0.007760141093474556 * sp[75] + 0.007760141093474537 * sp[77];
    A[84] = 0.005114638447971736 * sp[75] + 0.005114638447971742 * sp[77];
    A[85] = 0.007760141093474611 * sp[75] + 0.007760141093474602 * sp[77];
    A[86] = -0.01763668430335097 * sp[75] + -0.02539682539682545 * sp[77] + -0.01763668430335091 * sp[78];
    A[87] = 0.03262786596119946 * sp[75] + 0.05291005291005312 * sp[77] + 0.03262786596119938 * sp[78];
    A[88] = -0.04585537918871272 * sp[75] + -0.07054673721340425 * sp[77] + -0.04585537918871267 * sp[78];
    A[89] = 0.007760141093474551 * sp[77] + 0.007760141093474593 * sp[78];
    A[90] = 0.005114638447971775 * sp[77] + 0.00511463844797183 * sp[78];
    A[91] = 0.007760141093474529 * sp[77] + 0.007760141093474605 * sp[78];
    A[92] = 0.007054673721340523 * sp[75] + -0.01834215167548512 * sp[77] + 0.007054673721340311 * sp[78];
    A[93] = 0.007054673721340141 * sp[75] + 0.04938271604938285 * sp[77] + 0.007054673721340266 * sp[78];
    A[94] = 0.007054673721340369 * sp[75] + -0.01834215167548501 * sp[77] + 0.007054673721340538 * sp[78];
    A[95] = -0.007054673721340292 * sp[75] + -0.02539682539682556 * sp[77];
    A[96] = -0.00705467372134014 * sp[75] + 0.0423280423280426 * sp[77];
    A[97] = -0.007054673721340357 * sp[75] + -0.02539682539682547 * sp[77];
    A[98] = 0.01834215167548529 * sp[77];
    A[99] = 0.01834215167548502 * sp[77];
    A[100] = 0.01834215167548502 * sp[77];
    A[101] = -0.02539682539682562 * sp[77] + -0.007054673721340358 * sp[78];
    A[102] = -0.02539682539682551 * sp[77] + -0.007054673721340429 * sp[78];
    A[103] = 0.04232804232804273 * sp[77] + -0.007054673721340233 * sp[78];
    A[104] = -0.06772486772486794 * sp[77];
    A[105] = 0.005114638447971848 * sp[76] + 0.005114638447971834 * sp[78] + 0.005114638447971834 * sp[79];
    A[106] = -0.005114638447971823 * sp[76];
    A[107] = -0.005114638447971807 * sp[78];
    A[108] = 0.03791887125220472 * sp[79];
    A[109] = 0.01763668430335103 * sp[78] + -0.007760141093474361 * sp[79];
    A[110] = -0.03262786596119955 * sp[78] + 0.02028218694885346 * sp[79];
    A[111] = 0.04585537918871276 * sp[78] + -0.02469135802469136 * sp[79];
    A[112] = 0.01763668430335108 * sp[76] + -0.007760141093474462 * sp[79];
    A[113] = -0.03262786596119971 * sp[76] + 0.0202821869488536 * sp[79];
    A[114] = 0.04585537918871292 * sp[76] + -0.02469135802469137 * sp[79];
    A[115] = -0.007760141093474582 * sp[76] + -0.007760141093474539 * sp[78];
    A[116] = -0.005114638447971723 * sp[76] + -0.005114638447971763 * sp[78];
    A[117] = -0.007760141093474524 * sp[76] + -0.007760141093474506 * sp[78];
    A[118] = -0.01763668430335115 * sp[76] + -0.01763668430335111 * sp[78] + -0.02539682539682556 * sp[79];
    A[119] = 0.03262786596119975 * sp[76] + 0.03262786596119967 * sp[78] + 0.05291005291005323 * sp[79];
    A[120] = -0.04585537918871292 * sp[76] + -0.04585537918871282 * sp[78] + -0.07054673721340424 * sp[79];
    A[121] = 0.007760141093474435 * sp[76] + 0.007760141093474385 * sp[79];
    A[122] = 0.005114638447971753 * sp[76] + 0.005114638447971773 * sp[79];
    A[123] = 0.007760141093474524 * sp[76] + 0.0077601410934745 * sp[79];
    A[124] = 0.007760141093474481 * sp[78] + 0.007760141093474458 * sp[79];
    A[125] = 0.0051146384479718 * sp[78] + 0.005114638447971769 * sp[79];
    A[126] = 0.007760141093474536 * sp[78] + 0.007760141093474485 * sp[79];
    A[127] = 0.007054673721340495 * sp[76] + 0.007054673721340339 * sp[78] + -0.01834215167548504 * sp[79];
    A[128] = 0.007054673721340313 * sp[76] + 0.007054673721340388 * sp[78] + -0.01834215167548507 * sp[79];
    A[129] = 0.007054673721339994 * sp[76] + 0.007054673721340116 * sp[78] + 0.04938271604938246 * sp[79];
    A[130] = -0.007054673721340382 * sp[76] + -0.02539682539682523 * sp[79];
    A[131] = -0.007054673721340306 * sp[76] + -0.02539682539682534 * sp[79];
    A[132] = -0.007054673721340037 * sp[76] + 0.04232804232804224 * sp[79];
    A[133] = -0.007054673721340406 * sp[78] + -0.02539682539682536 * sp[79];
    A[134] = -0.007054673721340356 * sp[78] + -0.02539682539682539 * sp[79];
    A[135] = -0.007054673721340099 * sp[78] + 0.04232804232804233 * sp[79];
    A[136] = 0.0183421516754851 * sp[79];
    A[137] = 0.01834215167548508 * sp[79];
    A[138] = 0.01834215167548508 * sp[79];
    A[139] = -0.06772486772486755 * sp[79];
    A[140] = 0.007760141093474405 * sp[75] + 0.007760141093474407 * sp[77] + 0.0077601410934744 * sp[78] + 0.007760141093474376 * sp[76] + 0.007760141093474357 * sp[78] + 0.007760141093474379 * sp[79];
    A[141] = -0.007760141093474575 * sp[75] + -0.007760141093474543 * sp[76];
    A[142] = -0.02469135802469163 * sp[77] + 0.04585537918871244 * sp[78];
    A[143] = 0.01763668430335103 * sp[78] + -0.007760141093474361 * sp[79];
    A[144] = 0.203174603174603 * sp[77] + 0.07901234567901176 * sp[78] + 0.07901234567901176 * sp[78] + 0.1580246913580236 * sp[79];
    A[145] = -0.1185185185185186 * sp[77] + 0.0423280423280421 * sp[78] + -0.03104056437389738 * sp[78] + -0.09029982363315629 * sp[79];
    A[146] = 0.04514991181657879 * sp[77] + -0.03386243386243379 * sp[78] + 0.01128747795414479 * sp[78] + 0.04514991181657826 * sp[79];
    A[147] = 0.0225749559082896 * sp[75] + 0.0112874779541446 * sp[78] + 0.01128747795414454 * sp[76] + 0.01128747795414442 * sp[79];
    A[148] = 0.01693121693121656 * sp[75] + 0.01410934744268108 * sp[78] + 0.002821869488536238 * sp[76] + 0.002821869488536513 * sp[79];
    A[149] = 0.04514991181657891 * sp[75] + 0.03386243386243386 * sp[78] + 0.01128747795414478 * sp[76] + 0.01128747795414461 * sp[79];
    A[150] = 0.03386243386243401 * sp[75] + 0.01128747795414481 * sp[77] + 0.04514991181657866 * sp[76] + 0.01128747795414479 * sp[78];
    A[151] = -0.05925925925925958 * sp[75] + -0.04232804232804262 * sp[77] + -0.09029982363315767 * sp[76] + -0.03104056437389784 * sp[78];
    A[152] = 0.07901234567901258 * sp[75] + 0.1015873015873019 * sp[77] + 0.1580246913580249 * sp[76] + 0.07901234567901202 * sp[78];
    A[153] = -0.02257495590828947 * sp[75] + -0.02257495590828928 * sp[77] + -0.0112874779541446 * sp[78] + -0.01128747795414472 * sp[76] + -0.01128747795414455 * sp[78];
    A[154] = -0.01693121693121663 * sp[75] + -0.01693121693121666 * sp[77] + -0.002821869488535994 * sp[78] + -0.002821869488535898 * sp[76] + -0.002821869488535908 * sp[78];
    A[155] = -0.04514991181657887 * sp[75] + -0.04514991181657885 * sp[77] + -0.01128747795414478 * sp[78] + -0.01128747795414476 * sp[76] + -0.0112874779541448 * sp[78];
    A[156] = -0.03386243386243376 * sp[75] + -0.02257495590828888 * sp[77] + -0.03386243386243355 * sp[78] + -0.04514991181657856 * sp[76] + -0.03386243386243352 * sp[78] + -0.04514991181657826 * sp[79];
    A[157] = 0.05925925925925925 * sp[75] + 0.01693121693121628 * sp[77] + 0.0592592592592588 * sp[78] + 0.09029982363315728 * sp[76] + 0.05925925925925905 * sp[78] + 0.09029982363315675 * sp[79];
    A[158] = -0.07901234567901264 * sp[75] + 0.02257495590828956 * sp[77] + -0.07901234567901225 * sp[78] + -0.1580246913580249 * sp[76] + -0.07901234567901255 * sp[78] + -0.1580246913580245 * sp[79];
    A[159] = -0.0112874779541446 * sp[77] + -0.01128747795414451 * sp[78] + -0.01128747795414449 * sp[78] + -0.01128747795414435 * sp[79];
    A[160] = -0.002821869488536108 * sp[77] + -0.002821869488536035 * sp[78] + -0.002821869488536282 * sp[78] + -0.002821869488536129 * sp[79];
    A[161] = -0.01128747795414477 * sp[77] + -0.01128747795414463 * sp[78] + -0.01128747795414472 * sp[78] + -0.01128747795414445 * sp[79];
    A[162] = -0.06772486772486798 * sp[75] + 0.02257495590828965 * sp[77] + -0.03386243386243383 * sp[78] + -0.02257495590828934 * sp[76] + 0.01128747795414484 * sp[78] + -0.02257495590828922 * sp[79];
    A[163] = 0.2031746031746032 * sp[75] + -0.0677248677248679 * sp[77] + 0.101587301587302 * sp[78] + 0.112874779541446 * sp[76] + 0.01128747795414481 * sp[78] + 0.1128747795414457 * sp[79];
    A[164] = -0.06772486772486767 * sp[75] + 0.06772486772486778 * sp[77] + -0.03386243386243396 * sp[78] + -0.02257495590828822 * sp[76] + 0.01128747795414537 * sp[78] + -0.02257495590828816 * sp[79];
    A[165] = 0.06772486772486815 * sp[75] + 0.09029982363315715 * sp[77] + 0.03386243386243353 * sp[78] + 0.02257495590828972 * sp[76] + 0.03386243386243377 * sp[78];
    A[166] = -0.2031746031746032 * sp[75] + -0.2708994708994709 * sp[77] + -0.1015873015873006 * sp[78] + -0.112874779541446 * sp[76] + -0.1015873015873012 * sp[78];
    A[167] = 0.06772486772486769 * sp[75] + 0.1354497354497353 * sp[77] + 0.0338624338624333 * sp[78] + 0.02257495590828824 * sp[76] + 0.0338624338624332 * sp[78];
    A[168] = -0.02257495590828903 * sp[77] + -0.01128747795414489 * sp[78] + -0.01128747795414417 * sp[78];
    A[169] = -0.02257495590828973 * sp[77] + -0.01128747795414473 * sp[78] + -0.01128747795414498 * sp[78];
    A[170] = -0.0677248677248677 * sp[77] + -0.01128747795414446 * sp[78] + -0.01128747795414524 * sp[78];
    A[171] = 0.04514991181657863 * sp[77] + 0.03386243386243427 * sp[78] + 0.03386243386243362 * sp[78] + 0.02257495590828928 * sp[79];
    A[172] = 0.0451499118165786 * sp[77] + 0.03386243386243347 * sp[78] + 0.03386243386243402 * sp[78] + 0.02257495590828876 * sp[79];
    A[173] = -0.1354497354497357 * sp[77] + -0.1015873015873017 * sp[78] + -0.1015873015873009 * sp[78] + -0.1128747795414455 * sp[79];
    A[174] = 0.090299823633157 * sp[77];
    A[175] = 0.005114638447971729 * sp[75] + 0.005114638447971705 * sp[77] + 0.005114638447971716 * sp[78] + 0.005114638447971795 * sp[76] + 0.005114638447971788 * sp[78] + 0.005114638447971772 * sp[79];
    A[176] = -0.00511463844797164 * sp[75] + -0.005114638447971716 * sp[76];
    A[177] = 0.0202821869488537 * sp[77] + -0.03262786596119931 * sp[78];
    A[178] = -0.03262786596119955 * sp[78] + 0.02028218694885346 * sp[79];
    A[179] = -0.1185185185185186 * sp[77] + -0.03104056437389738 * sp[78] + 0.0423280423280421 * sp[78] + -0.09029982363315629 * sp[79];
    A[180] = 0.2497354497354503 * sp[77] + 0.08253968253968251 * sp[78] + 0.08253968253968251 * sp[78] + 0.2497354497354484 * sp[79];
    A[181] = -0.09029982363315781 * sp[77] + 0.04232804232804201 * sp[78] + -0.03104056437389824 * sp[78] + -0.1185185185185184 * sp[79];
    A[182] = 0.01693121693121651 * sp[75] + 0.002821869488536421 * sp[78] + 0.01410934744268072 * sp[76] + 0.002821869488536401 * sp[79];
    A[183] = -0.02116402116402031 * sp[75] + -0.01058201058201091 * sp[78] + -0.01058201058201042 * sp[76] + -0.01340388007054693 * sp[79];
    A[184] = -0.09029982363315797 * sp[75] + -0.05925925925925944 * sp[78] + -0.03104056437389827 * sp[76] + -0.04232804232804274 * sp[79];
    A[185] = 0.01410934744268082 * sp[75] + 0.002821869488536301 * sp[77] + 0.01693121693121672 * sp[76] + 0.002821869488536125 * sp[78];
    A[186] = -0.01058201058201056 * sp[75] + -0.01340388007054683 * sp[77] + -0.02116402116402049 * sp[76] + -0.01058201058201046 * sp[78];
    A[187] = -0.03104056437389777 * sp[75] + -0.04232804232804241 * sp[77] + -0.09029982363315726 * sp[76] + -0.05925925925925913 * sp[78];
    A[188] = -0.01693121693121656 * sp[75] + -0.01693121693121661 * sp[77] + -0.01410934744268041 * sp[78] + -0.01410934744268048 * sp[76] + -0.01410934744268054 * sp[78] + -0.01128747795414448 * sp[79];
    A[189] = 0.02116402116402038 * sp[75] + 0.02116402116402047 * sp[77] + 0.01058201058201003 * sp[78] + 0.01058201058200995 * sp[76] + 0.01058201058201003 * sp[78] + -0.002821869488536233 * sp[79];
    A[190] = 0.0902998236331579 * sp[75] + 0.0902998236331579 * sp[77] + 0.03104056437389822 * sp[78] + 0.03104056437389822 * sp[76] + 0.03104056437389827 * sp[78] + -0.01128747795414465 * sp[79];
    A[191] = -0.01410934744268085 * sp[75] + -0.01128747795414464 * sp[77] + -0.01410934744268082 * sp[78] + -0.01693121693121674 * sp[76] + -0.0141093474426808 * sp[78] + -0.01693121693121673 * sp[79];
    A[192] = 0.01058201058201072 * sp[75] + -0.002821869488536001 * sp[77] + 0.01058201058201079 * sp[78] + 0.02116402116402074 * sp[76] + 0.01058201058201043 * sp[78] + 0.02116402116402086 * sp[79];
    A[193] = 0.03104056437389777 * sp[75] + -0.01128747795414473 * sp[77] + 0.03104056437389779 * sp[78] + 0.09029982363315719 * sp[76] + 0.03104056437389795 * sp[78] + 0.09029982363315719 * sp[79];
    A[194] = -0.002821869488536377 * sp[77] + -0.002821869488536395 * sp[78] + -0.002821869488536258 * sp[78] + -0.002821869488536326 * sp[79];
    A[195] = -0.009171075837742498 * sp[77] + -0.00917107583774252 * sp[78] + -0.009171075837742196 * sp[78] + -0.0091710758377423 * sp[79];
    A[196] = -0.00282186948853635 * sp[77] + -0.002821869488536384 * sp[78] + -0.002821869488536192 * sp[78] + -0.00282186948853635 * sp[79];
    A[197] = -0.08465608465608492 * sp[75] + -0.01693121693121737 * sp[77] + -0.01975308641975351 * sp[78] + -0.08465608465608471 * sp[76] + -0.01975308641975342 * sp[78] + -0.0169312169312173 * sp[79];
    A[198] = 0.05079365079365124 * sp[75] + 0.118518518518519 * sp[77] + -0.0423280423280423 * sp[78] + 0.1862433862433862 * sp[76] + 0.0931216931216934 * sp[78] + -0.08465608465608389 * sp[79];
    A[199] = 0.1862433862433864 * sp[75] + -0.08465608465608469 * sp[77] + 0.09312169312169381 * sp[78] + 0.05079365079364976 * sp[76] + -0.0423280423280433 * sp[78] + 0.1185185185185179 * sp[79];
    A[200] = 0.08465608465608458 * sp[75] + 0.06772486772486744 * sp[77] + 0.06490299823633115 * sp[78] + 0.08465608465608422 * sp[76] + 0.06490299823633126 * sp[78] + 0.06772486772486692 * sp[79];
    A[201] = -0.05079365079365126 * sp[75] + 0.06772486772486785 * sp[77] + -0.09312169312169377 * sp[78] + -0.1862433862433861 * sp[76] + -0.09312169312169274 * sp[78] + -0.2708994708994698 * sp[79];
    A[202] = -0.1862433862433864 * sp[75] + -0.2708994708994708 * sp[77] + -0.09312169312169193 * sp[78] + -0.05079365079364969 * sp[76] + -0.09312169312169243 * sp[78] + 0.06772486772486906 * sp[79];
    A[203] = 0.01693121693121698 * sp[77] + 0.01975308641975354 * sp[78] + 0.01975308641975292 * sp[78] + 0.02257495590828935 * sp[79];
    A[204] = 0.01693121693121732 * sp[77] + 0.01975308641975344 * sp[78] + 0.01975308641975333 * sp[78] + 0.02257495590828904 * sp[79];
    A[205] = 0.08465608465608469 * sp[77] + 0.04232804232804208 * sp[78] + 0.04232804232804323 * sp[78] + 0.02257495590828962 * sp[79];
    A[206] = 0.02257495590828957 * sp[77] + 0.01975308641975309 * sp[78] + 0.01975308641975331 * sp[78] + 0.01693121693121719 * sp[79];
    A[207] = 0.02257495590828939 * sp[77] + 0.01975308641975331 * sp[78] + 0.0197530864197527 * sp[78] + 0.01693121693121712 * sp[79];
    A[208] = 0.02257495590828919 * sp[77] + 0.04232804232804224 * sp[78] + 0.04232804232804201 * sp[78] + 0.08465608465608387 * sp[79];
    A[209] = -0.1354497354497358 * sp[77] + -0.1128747795414465 * sp[78] + -0.1128747795414463 * sp[78] + -0.1354497354497347 * sp[79];
    A[210] = 0.007760141093474561 * sp[75] + 0.007760141093474545 * sp[77] + 0.007760141093474514 * sp[78] + 0.007760141093474427 * sp[76] + 0.007760141093474405 * sp[78] + 0.00776014109347439 * sp[79];
    A[211] = -0.007760141093474567 * sp[75] + -0.007760141093474441 * sp[76];
    A[212] = -0.007760141093474585 * sp[77] + 0.01763668430335085 * sp[78];
    A[213] = 0.04585537918871276 * sp[78] + -0.02469135802469136 * sp[79];
    A[214] = 0.04514991181657879 * sp[77] + 0.01128747795414479 * sp[78] + -0.03386243386243379 * sp[78] + 0.04514991181657826 * sp[79];
    A[215] = -0.09029982363315781 * sp[77] + -0.03104056437389824 * sp[78] + 0.04232804232804201 * sp[78] + -0.1185185185185184 * sp[79];
    A[216] = 0.1580246913580257 * sp[77] + 0.07901234567901275 * sp[78] + 0.07901234567901275 * sp[78] + 0.2031746031746032 * sp[79];
    A[217] = 0.04514991181657905 * sp[75] + 0.0112874779541447 * sp[78] + 0.03386243386243409 * sp[76] + 0.01128747795414476 * sp[79];
    A[218] = -0.09029982363315832 * sp[75] + -0.03104056437389791 * sp[78] + -0.05925925925925964 * sp[76] + -0.04232804232804242 * sp[79];
    A[219] = 0.158024691358026 * sp[75] + 0.07901234567901272 * sp[78] + 0.0790123456790128 * sp[76] + 0.1015873015873019 * sp[79];
    A[220] = 0.01128747795414444 * sp[75] + 0.01128747795414466 * sp[77] + 0.02257495590828926 * sp[76] + 0.01128747795414486 * sp[78];
    A[221] = 0.002821869488536217 * sp[75] + 0.002821869488536169 * sp[77] + 0.01693121693121659 * sp[76] + 0.01410934744268059 * sp[78];
    A[222] = 0.0112874779541446 * sp[75] + 0.01128747795414464 * sp[77] + 0.04514991181657853 * sp[76] + 0.03386243386243377 * sp[78];
    A[223] = -0.04514991181657914 * sp[75] + -0.04514991181657893 * sp[77] + -0.03386243386243427 * sp[78] + -0.03386243386243425 * sp[76] + -0.03386243386243407 * sp[78] + -0.02257495590828933 * sp[79];
    A[224] = 0.09029982363315811 * sp[75] + 0.09029982363315786 * sp[77] + 0.05925925925926006 * sp[78] + 0.05925925925925977 * sp[76] + 0.0592592592592596 * sp[78] + 0.01693121693121708 * sp[79];
    A[225] = -0.158024691358026 * sp[75] + -0.1580246913580259 * sp[77] + -0.07901234567901329 * sp[78] + -0.07901234567901284 * sp[76] + -0.07901234567901284 * sp[78] + 0.02257495590828903 * sp[79];
    A[226] = -0.01128747795414453 * sp[75] + -0.01128747795414449 * sp[78] + -0.02257495590828922 * sp[76] + -0.01128747795414441 * sp[78] + -0.02257495590828911 * sp[79];
    A[227] = -0.00282186948853616 * sp[75] + -0.002821869488536178 * sp[78] + -0.01693121693121682 * sp[76] + -0.002821869488536206 * sp[78] + -0.01693121693121688 * sp[79];
    A[228] = -0.01128747795414456 * sp[75] + -0.01128747795414454 * sp[78] + -0.04514991181657846 * sp[76] + -0.01128747795414469 * sp[78] + -0.04514991181657838 * sp[79];
    A[229] = -0.01128747795414449 * sp[77] + -0.0112874779541445 * sp[78] + -0.01128747795414465 * sp[78] + -0.01128747795414459 * sp[79];
    A[230] = -0.002821869488536133 * sp[77] + -0.002821869488536125 * sp[78] + -0.002821869488536249 * sp[78] + -0.00282186948853615 * sp[79];
    A[231] = -0.01128747795414467 * sp[77] + -0.01128747795414469 * sp[78] + -0.01128747795414488 * sp[78] + -0.01128747795414477 * sp[79];
    A[232] = -0.02257495590828928 * sp[75] + -0.02257495590828942 * sp[77] + 0.01128747795414475 * sp[78] + -0.0677248677248677 * sp[76] + -0.03386243386243374 * sp[78] + 0.02257495590828944 * sp[79];
    A[233] = -0.02257495590828936 * sp[75] + -0.02257495590828934 * sp[77] + 0.01128747795414469 * sp[78] + -0.06772486772486817 * sp[76] + -0.03386243386243439 * sp[78] + 0.06772486772486706 * sp[79];
    A[234] = 0.1128747795414457 * sp[75] + 0.1128747795414461 * sp[77] + 0.01128747795414412 * sp[78] + 0.2031746031746032 * sp[76] + 0.1015873015873019 * sp[78] + -0.06772486772486758 * sp[79];
    A[235] = 0.02257495590828896 * sp[75] + 0.03386243386243373 * sp[78] + 0.06772486772486744 * sp[76] + 0.03386243386243383 * sp[78] + 0.09029982363315688 * sp[79];
    A[236] = 0.02257495590828943 * sp[75] + 0.03386243386243414 * sp[78] + 0.06772486772486819 * sp[76] + 0.03386243386243395 * sp[78] + 0.1354497354497352 * sp[79];
    A[237] = -0.112874779541446 * sp[75] + -0.1015873015873019 * sp[78] + -0.2031746031746033 * sp[76] + -0.1015873015873015 * sp[78] + -0.2708994708994711 * sp[79];
    A[238] = 0.02257495590828898 * sp[77] + 0.03386243386243351 * sp[78] + 0.03386243386243361 * sp[78] + 0.04514991181657829 * sp[79];
    A[239] = 0.02257495590828937 * sp[77] + 0.03386243386243406 * sp[78] + 0.03386243386243372 * sp[78] + 0.04514991181657871 * sp[79];
    A[240] = -0.112874779541446 * sp[77] + -0.1015873015873014 * sp[78] + -0.1015873015873019 * sp[78] + -0.1354497354497354 * sp[79];
    A[241] = -0.01128747795414427 * sp[78] + -0.01128747795414443 * sp[78] + -0.02257495590828926 * sp[79];
    A[242] = -0.01128747795414464 * sp[78] + -0.01128747795414422 * sp[78] + -0.02257495590828942 * sp[79];
    A[243] = -0.0112874779541446 * sp[78] + -0.01128747795414463 * sp[78] + -0.06772486772486695 * sp[79];
    A[244] = 0.09029982363315664 * sp[79];
    A[245] = 0.007760141093474334 * sp[74] + 0.00776014109347424 * sp[75] + 0.007760141093474256 * sp[76] + 0.00776014109347427 * sp[76] + 0.007760141093474196 * sp[78] + 0.007760141093474213 * sp[79];
    A[246] = -0.02469135802469159 * sp[74] + 0.04585537918871248 * sp[76];
    A[247] = -0.007760141093474662 * sp[75] + -0.007760141093474595 * sp[78];
    A[248] = 0.01763668430335108 * sp[76] + -0.007760141093474462 * sp[79];
    A[249] = 0.0225749559082896 * sp[75] + 0.01128747795414454 * sp[76] + 0.0112874779541446 * sp[78] + 0.01128747795414442 * sp[79];
    A[250] = 0.01693121693121651 * sp[75] + 0.01410934744268072 * sp[76] + 0.002821869488536421 * sp[78] + 0.002821869488536401 * sp[79];
    A[251] = 0.04514991181657905 * sp[75] + 0.03386243386243409 * sp[76] + 0.0112874779541447 * sp[78] + 0.01128747795414476 * sp[79];
    A[252] = 0.2031746031746031 * sp[74] + 0.07901234567901214 * sp[76] + 0.07901234567901214 * sp[76] + 0.1580246913580248 * sp[79];
    A[253] = -0.1185185185185192 * sp[74] + 0.04232804232804202 * sp[76] + -0.03104056437389813 * sp[76] + -0.0902998236331575 * sp[79];
    A[254] = 0.04514991181657921 * sp[74] + -0.03386243386243365 * sp[76] + 0.01128747795414471 * sp[76] + 0.04514991181657843 * sp[79];
    A[255] = 0.1015873015873015 * sp[74] + 0.07901234567901226 * sp[75] + 0.07901234567901205 * sp[76] + 0.1580246913580249 * sp[78];
    A[256] = -0.04232804232804223 * sp[74] + -0.05925925925925907 * sp[75] + -0.03104056437389769 * sp[76] + -0.09029982363315728 * sp[78];
    A[257] = 0.01128747795414449 * sp[74] + 0.03386243386243376 * sp[75] + 0.01128747795414445 * sp[76] + 0.04514991181657839 * sp[78];
    A[258] = -0.02257495590828926 * sp[74] + -0.02257495590828915 * sp[75] + -0.0112874779541444 * sp[76] + -0.01128747795414447 * sp[76] + -0.01128747795414436 * sp[78];
    A[259] = -0.01693121693121676 * sp[74] + -0.01693121693121686 * sp[75] + -0.002821869488535926 * sp[76] + -0.002821869488536249 * sp[76] + -0.002821869488536274 * sp[78];
    A[260] = -0.04514991181657919 * sp[74] + -0.04514991181657908 * sp[75] + -0.01128747795414498 * sp[76] + -0.01128747795414468 * sp[76] + -0.0112874779541447 * sp[78];
    A[261] = -0.01128747795414447 * sp[74] + -0.0112874779541443 * sp[76] + -0.01128747795414449 * sp[76] + -0.01128747795414427 * sp[79];
    A[262] = -0.002821869488536198 * sp[74] + -0.002821869488536304 * sp[76] + -0.002821869488536081 * sp[76] + -0.002821869488536239 * sp[79];
    A[263] = -0.01128747795414449 * sp[74] + -0.0112874779541444 * sp[76] + -0.01128747795414444 * sp[76] + -0.01128747795414432 * sp[79];
    A[264] = -0.02257495590828864 * sp[74] + -0.03386243386243338 * sp[75] + -0.03386243386243337 * sp[76] + -0.03386243386243327 * sp[76] + -0.04514991181657806 * sp[78] + -0.04514991181657806 * sp[79];
    A[265] = 0.01693121693121588 * sp[74] + 0.0592592592592587 * sp[75] + 0.05925925925925862 * sp[76] + 0.05925925925925826 * sp[76] + 0.09029982363315636 * sp[78] + 0.09029982363315632 * sp[79];
    A[266] = 0.02257495590828986 * sp[74] + -0.07901234567901232 * sp[75] + -0.07901234567901237 * sp[76] + -0.07901234567901184 * sp[76] + -0.1580246913580249 * sp[78] + -0.158024691358025 * sp[79];
    A[267] = -0.06772486772486848 * sp[74] + 0.2031746031746025 * sp[75] + 0.1015873015873015 * sp[76] + 0.01128747795414344 * sp[76] + 0.1128747795414453 * sp[78] + 0.1128747795414456 * sp[79];
    A[268] = 0.02257495590828947 * sp[74] + -0.06772486772486787 * sp[75] + -0.03386243386243382 * sp[76] + 0.01128747795414495 * sp[76] + -0.02257495590828916 * sp[78] + -0.0225749559082894 * sp[79];
    A[269] = 0.06772486772486792 * sp[74] + -0.0677248677248674 * sp[75] + -0.03386243386243389 * sp[76] + 0.011287477954145 * sp[76] + -0.02257495590828945 * sp[78] + -0.02257495590828916 * sp[79];
    A[270] = -0.02257495590828932 * sp[74] + -0.0112874779541452 * sp[76] + -0.01128747795414433 * sp[76];
    A[271] = -0.02257495590828934 * sp[74] + -0.01128747795414452 * sp[76] + -0.01128747795414487 * sp[76];
    A[272] = -0.06772486772486809 * sp[74] + -0.01128747795414457 * sp[76] + -0.01128747795414504 * sp[76];
    A[273] = 0.09029982363315626 * sp[74] + 0.06772486772486715 * sp[75] + 0.03386243386243281 * sp[76] + 0.03386243386243336 * sp[76] + 0.02257495590828887 * sp[78];
    A[274] = -0.2708994708994701 * sp[74] + -0.2031746031746023 * sp[75] + -0.1015873015873003 * sp[76] + -0.101587301587301 * sp[76] + -0.1128747795414451 * sp[78];
    A[275] = 0.1354497354497359 * sp[74] + 0.06772486772486745 * sp[75] + 0.03386243386243373 * sp[76] + 0.03386243386243437 * sp[76] + 0.02257495590828954 * sp[78];
    A[276] = 0.0451499118165784 * sp[74] + 0.03386243386243418 * sp[76] + 0.03386243386243357 * sp[76] + 0.02257495590828941 * sp[79];
    A[277] = -0.1354497354497354 * sp[74] + -0.1015873015873014 * sp[76] + -0.1015873015873011 * sp[76] + -0.1128747795414454 * sp[79];
    A[278] = 0.04514991181657842 * sp[74] + 0.03386243386243371 * sp[76] + 0.03386243386243375 * sp[76] + 0.02257495590828931 * sp[79];
    A[279] = 0.09029982363315775 * sp[74];
    A[280] = 0.005114638447971604 * sp[74] + 0.00511463844797166 * sp[75] + 0.005114638447971705 * sp[76] + 0.005114638447971741 * sp[76] + 0.005114638447971771 * sp[78] + 0.005114638447971807 * sp[79];
    A[281] = 0.0202821869488537 * sp[74] + -0.03262786596119938 * sp[76];
    A[282] = -0.005114638447971583 * sp[75] + -0.00511463844797164 * sp[78];
    A[283] = -0.03262786596119971 * sp[76] + 0.0202821869488536 * sp[79];
    A[284] = 0.01693121693121656 * sp[75] + 0.002821869488536238 * sp[76] + 0.01410934744268108 * sp[78] + 0.002821869488536513 * sp[79];
    A[285] = -0.02116402116402031 * sp[75] + -0.01058201058201042 * sp[76] + -0.01058201058201091 * sp[78] + -0.01340388007054693 * sp[79];
    A[286] = -0.09029982363315832 * sp[75] + -0.05925925925925964 * sp[76] + -0.03104056437389791 * sp[78] + -0.04232804232804242 * sp[79];
    A[287] = -0.1185185185185192 * sp[74] + -0.03104056437389813 * sp[76] + 0.04232804232804202 * sp[76] + -0.0902998236331575 * sp[79];
    A[288] = 0.2497354497354509 * sp[74] + 0.08253968253968316 * sp[76] + 0.08253968253968316 * sp[76] + 0.2497354497354505 * sp[79];
    A[289] = -0.09029982363315854 * sp[74] + 0.04232804232804168 * sp[76] + -0.03104056437389786 * sp[76] + -0.1185185185185186 * sp[79];
    A[290] = -0.04232804232804237 * sp[74] + -0.0310405643738981 * sp[75] + -0.05925925925925907 * sp[76] + -0.09029982363315751 * sp[78];
    A[291] = -0.01340388007054687 * sp[74] + -0.01058201058201052 * sp[75] + -0.01058201058201075 * sp[76] + -0.02116402116402076 * sp[78];
    A[292] = 0.002821869488536423 * sp[74] + 0.01410934744268095 * sp[75] + 0.002821869488536655 * sp[76] + 0.01693121693121719 * sp[78];
    A[293] = -0.01693121693121629 * sp[74] + -0.0169312169312165 * sp[75] + -0.01410934744268049 * sp[76] + -0.01410934744268062 * sp[76] + -0.01410934744268079 * sp[78] + -0.01128747795414471 * sp[79];
    A[294] = 0.0211640211640201 * sp[74] + 0.0211640211640203 * sp[75] + 0.01058201058201005 * sp[76] + 0.01058201058201039 * sp[76] + 0.01058201058201041 * sp[78] + -0.002821869488536143 * sp[79];
    A[295] = 0.09029982363315851 * sp[74] + 0.09029982363315836 * sp[75] + 0.03104056437389867 * sp[76] + 0.03104056437389788 * sp[76] + 0.03104056437389789 * sp[78] + -0.01128747795414437 * sp[79];
    A[296] = -0.002821869488536365 * sp[74] + -0.002821869488536417 * sp[76] + -0.002821869488536555 * sp[76] + -0.002821869488536667 * sp[79];
    A[297] = -0.00917107583774231 * sp[74] + -0.009171075837742322 * sp[76] + -0.009171075837742289 * sp[76] + -0.009171075837742288 * sp[79];
    A[298] = -0.002821869488536432 * sp[74] + -0.002821869488536431 * sp[76] + -0.002821869488536665 * sp[76] + -0.002821869488536678 * sp[79];
    A[299] = -0.0112874779541445 * sp[74] + -0.0141093474426807 * sp[75] + -0.01410934744268071 * sp[76] + -0.01410934744268066 * sp[76] + -0.0169312169312169 * sp[78] + -0.01693121693121687 * sp[79];
    A[300] = -0.002821869488536056 * sp[74] + 0.01058201058201052 * sp[75] + 0.01058201058201049 * sp[76] + 0.01058201058201053 * sp[76] + 0.02116402116402104 * sp[78] + 0.02116402116402094 * sp[79];
    A[301] = -0.01128747795414465 * sp[74] + 0.03104056437389797 * sp[75] + 0.03104056437389789 * sp[76] + 0.03104056437389781 * sp[76] + 0.09029982363315736 * sp[78] + 0.09029982363315724 * sp[79];
    A[302] = 0.1185185185185192 * sp[74] + 0.05079365079365158 * sp[75] + -0.04232804232804199 * sp[76] + 0.09312169312169455 * sp[76] + 0.1862433862433874 * sp[78] + -0.08465608465608371 * sp[79];
    A[303] = -0.01693121693121686 * sp[74] + -0.08465608465608458 * sp[75] + -0.01975308641975278 * sp[76] + -0.0197530864197531 * sp[76] + -0.08465608465608479 * sp[78] + -0.01693121693121648 * sp[79];
    A[304] = -0.08465608465608511 * sp[74] + 0.1862433862433857 * sp[75] + 0.09312169312169273 * sp[76] + -0.04232804232804269 * sp[76] + 0.05079365079365132 * sp[78] + 0.1185185185185184 * sp[79];
    A[305] = 0.01693121693121719 * sp[74] + 0.01975308641975353 * sp[76] + 0.01975308641975272 * sp[76] + 0.02257495590828965 * sp[79];
    A[306] = 0.01693121693121676 * sp[74] + 0.01975308641975311 * sp[76] + 0.01975308641975306 * sp[76] + 0.02257495590828953 * sp[79];
    A[307] = 0.08465608465608532 * sp[74] + 0.04232804232804235 * sp[76] + 0.04232804232804272 * sp[76] + 0.02257495590828914 * sp[79];
    A[308] = 0.06772486772486694 * sp[74] + 0.08465608465608419 * sp[75] + 0.06490299823633101 * sp[76] + 0.06490299823633058 * sp[76] + 0.08465608465608364 * sp[78] + 0.06772486772486702 * sp[79];
    A[309] = 0.06772486772486842 * sp[74] + -0.05079365079365118 * sp[75] + -0.09312169312169305 * sp[76] + -0.09312169312169204 * sp[76] + -0.186243386243387 * sp[78] + -0.2708994708994701 * sp[79];
    A[310] = -0.2708994708994709 * sp[74] + -0.1862433862433857 * sp[75] + -0.09312169312169247 * sp[76] + -0.09312169312169348 * sp[76] + -0.05079365079365132 * sp[78] + 0.06772486772486799 * sp[79];
    A[311] = 0.02257495590828923 * sp[74] + 0.01975308641975296 * sp[76] + 0.01975308641975337 * sp[76] + 0.0169312169312165 * sp[79];
    A[312] = 0.0225749559082895 * sp[74] + 0.04232804232804212 * sp[76] + 0.04232804232804225 * sp[76] + 0.08465608465608371 * sp[79];
    A[313] = 0.02257495590828922 * sp[74] + 0.01975308641975289 * sp[76] + 0.01975308641975313 * sp[76] + 0.01693121693121655 * sp[79];
    A[314] = -0.1354497354497363 * sp[74] + -0.1128747795414458 * sp[76] + -0.1128747795414472 * sp[76] + -0.1354497354497348 * sp[79];
    A[315] = 0.007760141093474576 * sp[74] + 0.00776014109347456 * sp[75] + 0.007760141093474528 * sp[76] + 0.007760141093474449 * sp[76] + 0.007760141093474464 * sp[78] + 0.007760141093474433 * sp[79];
    A[316] = -0.0077601410934746 * sp[74] + 0.01763668430335089 * sp[76];
    A[317] = -0.007760141093474608 * sp[75] + -0.007760141093474556 * sp[78];
    A[318] = 0.04585537918871292 * sp[76] + -0.02469135802469137 * sp[79];
    A[319] = 0.04514991181657891 * sp[75] + 0.01128747795414478 * sp[76] + 0.03386243386243386 * sp[78] + 0.01128747795414461 * sp[79];
    A[320] = -0.09029982363315797 * sp[75] + -0.03104056437389827 * sp[76] + -0.05925925925925944 * sp[78] + -0.04232804232804274 * sp[79];
    A[321] = 0.158024691358026 * sp[75] + 0.0790123456790128 * sp[76] + 0.07901234567901272 * sp[78] + 0.1015873015873019 * sp[79];
    A[322] = 0.04514991181657921 * sp[74] + 0.01128747795414471 * sp[76] + -0.03386243386243365 * sp[76] + 0.04514991181657843 * sp[79];
    A[323] = -0.09029982363315854 * sp[74] + -0.03104056437389786 * sp[76] + 0.04232804232804168 * sp[76] + -0.1185185185185186 * sp[79];
    A[324] = 0.1580246913580264 * sp[74] + 0.07901234567901277 * sp[76] + 0.07901234567901277 * sp[76] + 0.2031746031746033 * sp[79];
    A[325] = 0.01128747795414447 * sp[74] + 0.01128747795414467 * sp[75] + 0.0338624338624336 * sp[76] + 0.04514991181657847 * sp[78];
    A[326] = 0.002821869488536177 * sp[74] + 0.002821869488536141 * sp[75] + 0.0141093474426809 * sp[76] + 0.01693121693121692 * sp[78];
    A[327] = 0.01128747795414459 * sp[74] + 0.01128747795414463 * sp[75] + 0.01128747795414451 * sp[76] + 0.0225749559082893 * sp[78];
    A[328] = -0.04514991181657921 * sp[74] + -0.04514991181657899 * sp[75] + -0.03386243386243439 * sp[76] + -0.03386243386243399 * sp[76] + -0.03386243386243387 * sp[78] + -0.02257495590828946 * sp[79];
    A[329] = 0.09029982363315828 * sp[74] + 0.090299823633158 * sp[75] + 0.05925925925926021 * sp[76] + 0.05925925925925954 * sp[76] + 0.05925925925925944 * sp[78] + 0.01693121693121734 * sp[79];
    A[330] = -0.1580246913580264 * sp[74] + -0.1580246913580262 * sp[75] + -0.07901234567901352 * sp[76] + -0.0790123456790128 * sp[76] + -0.07901234567901283 * sp[78] + 0.02257495590828881 * sp[79];
    A[331] = -0.01128747795414449 * sp[74] + -0.01128747795414445 * sp[76] + -0.01128747795414418 * sp[76] + -0.01128747795414412 * sp[79];
    A[332] = -0.002821869488536189 * sp[74] + -0.002821869488536207 * sp[76] + -0.002821869488536408 * sp[76] + -0.002821869488536392 * sp[79];
    A[333] = -0.01128747795414456 * sp[74] + -0.01128747795414454 * sp[76] + -0.01128747795414447 * sp[76] + -0.01128747795414445 * sp[79];
    A[334] = -0.01128747795414447 * sp[75] + -0.01128747795414448 * sp[76] + -0.01128747795414457 * sp[76] + -0.02257495590828895 * sp[78] + -0.02257495590828896 * sp[79];
    A[335] = -0.002821869488536096 * sp[75] + -0.002821869488536089 * sp[76] + -0.002821869488536239 * sp[76] + -0.01693121693121688 * sp[78] + -0.01693121693121684 * sp[79];
    A[336] = -0.01128747795414469 * sp[75] + -0.0112874779541447 * sp[76] + -0.01128747795414463 * sp[76] + -0.04514991181657849 * sp[78] + -0.04514991181657847 * sp[79];
    A[337] = -0.02257495590828933 * sp[74] + -0.02257495590828937 * sp[75] + 0.01128747795414472 * sp[76] + -0.0338624338624345 * sp[76] + -0.06772486772486823 * sp[78] + 0.06772486772486741 * sp[79];
    A[338] = -0.02257495590828943 * sp[74] + -0.02257495590828945 * sp[75] + 0.0112874779541446 * sp[76] + -0.03386243386243396 * sp[76] + -0.0677248677248679 * sp[78] + 0.02257495590828943 * sp[79];
    A[339] = 0.1128747795414459 * sp[74] + 0.1128747795414463 * sp[75] + 0.01128747795414427 * sp[76] + 0.1015873015873015 * sp[76] + 0.2031746031746031 * sp[78] + -0.06772486772486826 * sp[79];
    A[340] = 0.02257495590828889 * sp[74] + 0.03386243386243361 * sp[76] + 0.03386243386243382 * sp[76] + 0.04514991181657792 * sp[79];
    A[341] = 0.02257495590828949 * sp[74] + 0.03386243386243419 * sp[76] + 0.03386243386243399 * sp[76] + 0.04514991181657895 * sp[79];
    A[342] = -0.1128747795414461 * sp[74] + -0.1015873015873019 * sp[76] + -0.1015873015873015 * sp[76] + -0.1354497354497356 * sp[79];
    A[343] = 0.022574955908289 * sp[75] + 0.03386243386243346 * sp[76] + 0.03386243386243386 * sp[76] + 0.06772486772486788 * sp[78] + 0.09029982363315639 * sp[79];
    A[344] = 0.02257495590828933 * sp[75] + 0.03386243386243398 * sp[76] + 0.03386243386243375 * sp[76] + 0.06772486772486824 * sp[78] + 0.1354497354497353 * sp[79];
    A[345] = -0.1128747795414462 * sp[75] + -0.1015873015873014 * sp[76] + -0.1015873015873012 * sp[76] + -0.203174603174603 * sp[78] + -0.2708994708994706 * sp[79];
    A[346] = -0.01128747795414422 * sp[76] + -0.01128747795414473 * sp[76] + -0.02257495590828868 * sp[79];
    A[347] = -0.01128747795414461 * sp[76] + -0.0112874779541447 * sp[76] + -0.06772486772486719 * sp[79];
    A[348] = -0.01128747795414451 * sp[76] + -0.01128747795414452 * sp[76] + -0.02257495590828932 * sp[79];
    A[349] = 0.09029982363315654 * sp[79];
    A[350] = 0.007760141093474322 * sp[74] + 0.007760141093474229 * sp[75] + 0.007760141093474255 * sp[76] + 0.007760141093474272 * sp[75] + 0.0077601410934742 * sp[77] + 0.007760141093474219 * sp[78];
    A[351] = -0.02469135802469155 * sp[74] + 0.04585537918871252 * sp[75];
    A[352] = 0.01763668430335094 * sp[75] + -0.007760141093474527 * sp[77];
    A[353] = -0.007760141093474582 * sp[76] + -0.007760141093474539 * sp[78];
    A[354] = 0.03386243386243401 * sp[75] + 0.04514991181657866 * sp[76] + 0.01128747795414481 * sp[77] + 0.01128747795414479 * sp[78];
    A[355] = 0.01410934744268082 * sp[75] + 0.01693121693121672 * sp[76] + 0.002821869488536301 * sp[77] + 0.002821869488536125 * sp[78];
    A[356] = 0.01128747795414444 * sp[75] + 0.02257495590828926 * sp[76] + 0.01128747795414466 * sp[77] + 0.01128747795414486 * sp[78];
    A[357] = 0.1015873015873015 * sp[74] + 0.07901234567901205 * sp[76] + 0.07901234567901226 * sp[75] + 0.1580246913580249 * sp[78];
    A[358] = -0.04232804232804237 * sp[74] + -0.05925925925925907 * sp[76] + -0.0310405643738981 * sp[75] + -0.09029982363315751 * sp[78];
    A[359] = 0.01128747795414447 * sp[74] + 0.0338624338624336 * sp[76] + 0.01128747795414467 * sp[75] + 0.04514991181657847 * sp[78];
    A[360] = 0.2031746031746028 * sp[74] + 0.07901234567901207 * sp[75] + 0.07901234567901207 * sp[75] + 0.1580246913580251 * sp[77];
    A[361] = -0.1185185185185185 * sp[74] + 0.04232804232804245 * sp[75] + -0.0310405643738975 * sp[75] + -0.09029982363315728 * sp[77];
    A[362] = 0.04514991181657887 * sp[74] + -0.03386243386243364 * sp[75] + 0.01128747795414482 * sp[75] + 0.04514991181657879 * sp[77];
    A[363] = -0.01128747795414456 * sp[74] + -0.0112874779541445 * sp[75] + -0.01128747795414473 * sp[75] + -0.01128747795414463 * sp[77];
    A[364] = -0.002821869488536449 * sp[74] + -0.002821869488536444 * sp[75] + -0.002821869488536312 * sp[75] + -0.002821869488536338 * sp[77];
    A[365] = -0.01128747795414445 * sp[74] + -0.01128747795414444 * sp[75] + -0.01128747795414465 * sp[75] + -0.01128747795414466 * sp[77];
    A[366] = -0.02257495590828941 * sp[74] + -0.01128747795414413 * sp[75] + -0.02257495590828919 * sp[76] + -0.01128747795414492 * sp[75] + -0.01128747795414469 * sp[78];
    A[367] = -0.0169312169312163 * sp[74] + -0.002821869488536351 * sp[75] + -0.01693121693121647 * sp[76] + -0.002821869488535612 * sp[75] + -0.002821869488535773 * sp[78];
    A[368] = -0.04514991181657887 * sp[74] + -0.01128747795414454 * sp[75] + -0.04514991181657876 * sp[76] + -0.01128747795414482 * sp[75] + -0.0112874779541447 * sp[78];
    A[369] = -0.02257495590828867 * sp[74] + -0.03386243386243355 * sp[75] + -0.03386243386243354 * sp[76] + -0.03386243386243327 * sp[75] + -0.04514991181657841 * sp[77] + -0.04514991181657842 * sp[78];
    A[370] = 0.01693121693121586 * sp[74] + 0.05925925925925856 * sp[75] + 0.0592592592592586 * sp[76] + 0.05925925925925826 * sp[75] + 0.09029982363315664 * sp[77] + 0.09029982363315664 * sp[78];
    A[371] = 0.02257495590828997 * sp[74] + -0.07901234567901222 * sp[75] + -0.07901234567901214 * sp[76] + -0.0790123456790119 * sp[75] + -0.158024691358025 * sp[77] + -0.1580246913580251 * sp[78];
    A[372] = -0.06772486772486833 * sp[74] + 0.1015873015873013 * sp[75] + 0.2031746031746028 * sp[76] + 0.01128747795414373 * sp[75] + 0.1128747795414455 * sp[77] + 0.1128747795414458 * sp[78];
    A[373] = 0.06772486772486808 * sp[74] + -0.03386243386243391 * sp[75] + -0.06772486772486715 * sp[76] + 0.01128747795414526 * sp[75] + -0.02257495590828887 * sp[77] + -0.02257495590828861 * sp[78];
    A[374] = 0.02257495590828904 * sp[74] + -0.03386243386243402 * sp[75] + -0.0677248677248679 * sp[76] + 0.01128747795414475 * sp[75] + -0.02257495590828957 * sp[77] + -0.02257495590828942 * sp[78];
    A[375] = -0.02257495590828871 * sp[74] + -0.01128747795414416 * sp[75] + -0.01128747795414416 * sp[75];
    A[376] = -0.06772486772486795 * sp[74] + -0.01128747795414543 * sp[75] + -0.01128747795414519 * sp[75];
    A[377] = -0.02257495590828908 * sp[74] + -0.01128747795414444 * sp[75] + -0.01128747795414478 * sp[75];
    A[378] = 0.04514991181657844 * sp[74] + 0.03386243386243389 * sp[75] + 0.03386243386243391 * sp[75] + 0.02257495590828908 * sp[77];
    A[379] = -0.1354497354497353 * sp[74] + -0.1015873015873013 * sp[75] + -0.1015873015873014 * sp[75] + -0.1128747795414453 * sp[77];
    A[380] = 0.04514991181657883 * sp[74] + 0.03386243386243415 * sp[75] + 0.03386243386243441 * sp[75] + 0.02257495590828966 * sp[77];
    A[381] = 0.09029982363315683 * sp[74] + 0.03386243386243387 * sp[75] + 0.06772486772486822 * sp[76] + 0.03386243386243411 * sp[75] + 0.02257495590828983 * sp[78];
    A[382] = -0.2708994708994703 * sp[74] + -0.1015873015873007 * sp[75] + -0.2031746031746026 * sp[76] + -0.1015873015873013 * sp[75] + -0.1128747795414456 * sp[78];
    A[383] = 0.1354497354497347 * sp[74] + 0.03386243386243295 * sp[75] + 0.06772486772486708 * sp[76] + 0.03386243386243308 * sp[75] + 0.02257495590828851 * sp[78];
    A[384] = 0.09029982363315699 * sp[74];
    A[385] = 0.005114638447971536 * sp[74] + 0.005114638447971673 * sp[75] + 0.005114638447971648 * sp[76] + 0.005114638447971666 * sp[75] + 0.005114638447971783 * sp[77] + 0.005114638447971774 * sp[78];
    A[386] = 0.02028218694885365 * sp[74] + -0.03262786596119943 * sp[75];
    A[387] = -0.03262786596119946 * sp[75] + 0.02028218694885377 * sp[77];
    A[388] = -0.005114638447971723 * sp[76] + -0.005114638447971763 * sp[78];
    A[389] = -0.05925925925925958 * sp[75] + -0.09029982363315767 * sp[76] + -0.04232804232804262 * sp[77] + -0.03104056437389784 * sp[78];
    A[390] = -0.01058201058201056 * sp[75] + -0.02116402116402049 * sp[76] + -0.01340388007054683 * sp[77] + -0.01058201058201046 * sp[78];
    A[391] = 0.002821869488536217 * sp[75] + 0.01693121693121659 * sp[76] + 0.002821869488536169 * sp[77] + 0.01410934744268059 * sp[78];
    A[392] = -0.04232804232804223 * sp[74] + -0.03104056437389769 * sp[76] + -0.05925925925925907 * sp[75] + -0.09029982363315728 * sp[78];
    A[393] = -0.01340388007054687 * sp[74] + -0.01058201058201075 * sp[76] + -0.01058201058201052 * sp[75] + -0.02116402116402076 * sp[78];
    A[394] = 0.002821869488536177 * sp[74] + 0.0141093474426809 * sp[76] + 0.002821869488536141 * sp[75] + 0.01693121693121692 * sp[78];
    A[395] = -0.1185185185185185 * sp[74] + -0.0310405643738975 * sp[75] + 0.04232804232804245 * sp[75] + -0.09029982363315728 * sp[77];
    A[396] = 0.2497354497354498 * sp[74] + 0.08253968253968215 * sp[75] + 0.08253968253968215 * sp[75] + 0.2497354497354496 * sp[77];
    A[397] = -0.09029982363315817 * sp[74] + 0.04232804232804178 * sp[75] + -0.03104056437389817 * sp[75] + -0.118518518518519 * sp[77];
    A[398] = -0.002821869488536123 * sp[74] + -0.002821869488536287 * sp[75] + -0.002821869488535946 * sp[75] + -0.002821869488536167 * sp[77];
    A[399] = -0.009171075837742345 * sp[74] + -0.009171075837742302 * sp[75] + -0.009171075837742401 * sp[75] + -0.009171075837742314 * sp[77];
    A[400] = -0.002821869488536185 * sp[74] + -0.002821869488536212 * sp[75] + -0.002821869488536149 * sp[75] + -0.002821869488536176 * sp[77];
    A[401] = -0.01693121693121597 * sp[74] + -0.01410934744268053 * sp[75] + -0.01693121693121641 * sp[76] + -0.01410934744267978 * sp[75] + -0.01128747795414465 * sp[77] + -0.0141093474426802 * sp[78];
    A[402] = 0.02116402116401951 * sp[74] + 0.01058201058201037 * sp[75] + 0.02116402116402005 * sp[76] + 0.01058201058200942 * sp[75] + -0.002821869488536099 * sp[77] + 0.01058201058200992 * sp[78];
    A[403] = 0.09029982363315817 * sp[74] + 0.03104056437389796 * sp[75] + 0.09029982363315792 * sp[76] + 0.03104056437389817 * sp[75] + -0.01128747795414504 * sp[77] + 0.03104056437389788 * sp[78];
    A[404] = -0.01128747795414443 * sp[74] + -0.01410934744268056 * sp[75] + -0.01410934744268055 * sp[76] + -0.0141093474426806 * sp[75] + -0.0169312169312163 * sp[77] + -0.0169312169312163 * sp[78];
    A[405] = -0.002821869488535942 * sp[74] + 0.01058201058201078 * sp[75] + 0.01058201058201076 * sp[76] + 0.0105820105820106 * sp[75] + 0.0211640211640208 * sp[77] + 0.02116402116402086 * sp[78];
    A[406] = -0.01128747795414476 * sp[74] + 0.0310405643738977 * sp[75] + 0.03104056437389762 * sp[76] + 0.03104056437389783 * sp[75] + 0.09029982363315733 * sp[77] + 0.09029982363315731 * sp[78];
    A[407] = 0.1185185185185185 * sp[74] + -0.04232804232804256 * sp[75] + 0.05079365079365098 * sp[76] + 0.09312169312169316 * sp[75] + -0.08465608465608444 * sp[77] + 0.1862433862433863 * sp[78];
    A[408] = -0.08465608465608536 * sp[74] + 0.09312169312169281 * sp[75] + 0.1862433862433849 * sp[76] + -0.04232804232804314 * sp[75] + 0.1185185185185179 * sp[77] + 0.05079365079364962 * sp[78];
    A[409] = -0.01693121693121696 * sp[74] + -0.01975308641975327 * sp[75] + -0.08465608465608485 * sp[76] + -0.01975308641975319 * sp[75] + -0.0169312169312169 * sp[77] + -0.08465608465608479 * sp[78];
    A[410] = 0.01693121693121595 * sp[74] + 0.01975308641975269 * sp[75] + 0.01975308641975208 * sp[75] + 0.02257495590828869 * sp[77];
    A[411] = 0.08465608465608529 * sp[74] + 0.04232804232804339 * sp[75] + 0.04232804232804316 * sp[75] + 0.02257495590829024 * sp[77];
    A[412] = 0.01693121693121701 * sp[74] + 0.01975308641975289 * sp[75] + 0.01975308641975324 * sp[75] + 0.02257495590828924 * sp[77];
    A[413] = 0.02257495590828943 * sp[74] + 0.0197530864197528 * sp[75] + 0.01975308641975309 * sp[75] + 0.01693121693121678 * sp[77];
    A[414] = 0.0225749559082889 * sp[74] + 0.04232804232804256 * sp[75] + 0.04232804232804196 * sp[75] + 0.08465608465608429 * sp[77];
    A[415] = 0.02257495590828908 * sp[74] + 0.01975308641975333 * sp[75] + 0.01975308641975292 * sp[75] + 0.01693121693121698 * sp[77];
    A[416] = 0.06772486772486655 * sp[74] + 0.06490299823633003 * sp[75] + 0.08465608465608274 * sp[76] + 0.06490299823632976 * sp[75] + 0.06772486772486593 * sp[77] + 0.0846560846560826 * sp[78];
    A[417] = 0.06772486772486788 * sp[74] + -0.09312169312169316 * sp[75] + -0.05079365079365068 * sp[76] + -0.09312169312169237 * sp[75] + -0.27089947089947 * sp[77] + -0.186243386243386 * sp[78];
    A[418] = -0.2708994708994692 * sp[74] + -0.09312169312169108 * sp[75] + -0.1862433862433847 * sp[76] + -0.09312169312169156 * sp[75] + 0.06772486772486949 * sp[77] + -0.05079365079364938 * sp[78];
    A[419] = -0.1354497354497345 * sp[74] + -0.1128747795414458 * sp[75] + -0.1128747795414453 * sp[75] + -0.1354497354497347 * sp[77];
    A[420] = 0.007760141093474413 * sp[74] + 0.007760141093474391 * sp[75] + 0.007760141093474416 * sp[76] + 0.007760141093474301 * sp[75] + 0.00776014109347432 * sp[77] + 0.007760141093474318 * sp[78];
    A[421] = -0.007760141093474573 * sp[74] + 0.0176366843033509 * sp[75];
    A[422] = 0.04585537918871271 * sp[75] + -0.02469135802469159 * sp[77];
    A[423] = -0.007760141093474524 * sp[76] + -0.007760141093474506 * sp[78];
    A[424] = 0.07901234567901258 * sp[75] + 0.1580246913580249 * sp[76] + 0.1015873015873019 * sp[77] + 0.07901234567901202 * sp[78];
    A[425] = -0.03104056437389777 * sp[75] + -0.09029982363315726 * sp[76] + -0.04232804232804241 * sp[77] + -0.05925925925925913 * sp[78];
    A[426] = 0.0112874779541446 * sp[75] + 0.04514991181657853 * sp[76] + 0.01128747795414464 * sp[77] + 0.03386243386243377 * sp[78];
    A[427] = 0.01128747795414449 * sp[74] + 0.01128747795414445 * sp[76] + 0.03386243386243376 * sp[75] + 0.04514991181657839 * sp[78];
    A[428] = 0.002821869488536423 * sp[74] + 0.002821869488536655 * sp[76] + 0.01410934744268095 * sp[75] + 0.01693121693121719 * sp[78];
    A[429] = 0.01128747795414459 * sp[74] + 0.01128747795414451 * sp[76] + 0.01128747795414463 * sp[75] + 0.0225749559082893 * sp[78];
    A[430] = 0.04514991181657887 * sp[74] + 0.01128747795414482 * sp[75] + -0.03386243386243364 * sp[75] + 0.04514991181657879 * sp[77];
    A[431] = -0.09029982363315817 * sp[74] + -0.03104056437389817 * sp[75] + 0.04232804232804178 * sp[75] + -0.118518518518519 * sp[77];
    A[432] = 0.1580246913580263 * sp[74] + 0.07901234567901314 * sp[75] + 0.07901234567901314 * sp[75] + 0.2031746031746039 * sp[77];
    A[433] = -0.0112874779541447 * sp[74] + -0.01128747795414453 * sp[75] + -0.01128747795414475 * sp[75] + -0.01128747795414457 * sp[77];
    A[434] = -0.002821869488536023 * sp[74] + -0.002821869488536031 * sp[75] + -0.002821869488536098 * sp[75] + -0.002821869488536114 * sp[77];
    A[435] = -0.01128747795414457 * sp[74] + -0.01128747795414461 * sp[75] + -0.01128747795414462 * sp[75] + -0.01128747795414465 * sp[77];
    A[436] = -0.04514991181657875 * sp[74] + -0.03386243386243369 * sp[75] + -0.04514991181657847 * sp[76] + -0.03386243386243398 * sp[75] + -0.02257495590828883 * sp[77] + -0.03386243386243378 * sp[78];
    A[437] = 0.09029982363315774 * sp[74] + 0.05925925925925919 * sp[75] + 0.09029982363315718 * sp[76] + 0.05925925925925955 * sp[75] + 0.01693121693121641 * sp[77] + 0.05925925925925914 * sp[78];
    A[438] = -0.1580246913580263 * sp[74] + -0.07901234567901286 * sp[75] + -0.1580246913580258 * sp[76] + -0.07901234567901311 * sp[75] + 0.02257495590828956 * sp[77] + -0.0790123456790127 * sp[78];
    A[439] = -0.01128747795414454 * sp[75] + -0.01128747795414439 * sp[76] + -0.0112874779541445 * sp[75] + -0.02257495590828947 * sp[77] + -0.02257495590828935 * sp[78];
    A[440] = -0.002821869488536289 * sp[75] + -0.002821869488536135 * sp[76] + -0.002821869488536152 * sp[75] + -0.01693121693121694 * sp[77] + -0.01693121693121686 * sp[78];
    A[441] = -0.01128747795414475 * sp[75] + -0.01128747795414448 * sp[76] + -0.01128747795414456 * sp[75] + -0.04514991181657867 * sp[77] + -0.04514991181657848 * sp[78];
    A[442] = -0.02257495590828963 * sp[74] + 0.01128747795414488 * sp[75] + -0.02257495590828967 * sp[76] + -0.03386243386243417 * sp[75] + 0.06772486772486795 * sp[77] + -0.06772486772486784 * sp[78];
    A[443] = 0.1128747795414472 * sp[74] + 0.01128747795414485 * sp[75] + 0.1128747795414475 * sp[76] + 0.1015873015873025 * sp[75] + -0.06772486772486766 * sp[77] + 0.2031746031746043 * sp[78];
    A[444] = -0.02257495590828926 * sp[74] + 0.0112874779541449 * sp[75] + -0.02257495590828913 * sp[76] + -0.03386243386243391 * sp[75] + 0.02257495590828948 * sp[77] + -0.0677248677248678 * sp[78];
    A[445] = 0.02257495590828993 * sp[74] + 0.03386243386243405 * sp[75] + 0.03386243386243456 * sp[75] + 0.04514991181657891 * sp[77];
    A[446] = -0.1128747795414472 * sp[74] + -0.1015873015873023 * sp[75] + -0.1015873015873025 * sp[75] + -0.1354497354497363 * sp[77];
    A[447] = 0.02257495590828929 * sp[74] + 0.03386243386243371 * sp[75] + 0.03386243386243393 * sp[75] + 0.0451499118165784 * sp[77];
    A[448] = -0.01128747795414422 * sp[75] + -0.01128747795414464 * sp[75] + -0.02257495590828925 * sp[77];
    A[449] = -0.01128747795414502 * sp[75] + -0.01128747795414427 * sp[75] + -0.06772486772486788 * sp[77];
    A[450] = -0.01128747795414478 * sp[75] + -0.01128747795414478 * sp[75] + -0.02257495590828935 * sp[77];
    A[451] = 0.03386243386243395 * sp[75] + 0.02257495590828963 * sp[76] + 0.03386243386243394 * sp[75] + 0.09029982363315738 * sp[77] + 0.06772486772486801 * sp[78];
    A[452] = 0.03386243386243437 * sp[75] + 0.0225749559082892 * sp[76] + 0.0338624338624337 * sp[75] + 0.1354497354497355 * sp[77] + 0.06772486772486749 * sp[78];
    A[453] = -0.1015873015873022 * sp[75] + -0.1128747795414472 * sp[76] + -0.1015873015873014 * sp[75] + -0.2708994708994716 * sp[77] + -0.203174603174604 * sp[78];
    A[454] = 0.090299823633157 * sp[77];
    A[455] = -0.0246913580246911 * sp[74] + -0.02469135802469111 * sp[75] + -0.02469135802469115 * sp[76] + -0.02469135802469112 * sp[75] + -0.02469135802469115 * sp[77] + -0.02469135802469118 * sp[78] + -0.07054673721340426 * sp[76] + -0.07054673721340426 * sp[78] + -0.07054673721340426 * sp[79];
    A[456] = 0.007760141093474646 * sp[74] + 0.007760141093474638 * sp[75];
    A[457] = 0.007760141093474556 * sp[75] + 0.007760141093474537 * sp[77];
    A[458] = -0.01763668430335115 * sp[76] + -0.01763668430335111 * sp[78] + -0.02539682539682556 * sp[79];
    A[459] = -0.02257495590828947 * sp[75] + -0.01128747795414472 * sp[76] + -0.02257495590828928 * sp[77] + -0.01128747795414455 * sp[78] + -0.0112874779541446 * sp[78];
    A[460] = -0.01693121693121656 * sp[75] + -0.01410934744268048 * sp[76] + -0.01693121693121661 * sp[77] + -0.01410934744268054 * sp[78] + -0.01410934744268041 * sp[78] + -0.01128747795414448 * sp[79];
    A[461] = -0.04514991181657914 * sp[75] + -0.03386243386243425 * sp[76] + -0.04514991181657893 * sp[77] + -0.03386243386243407 * sp[78] + -0.03386243386243427 * sp[78] + -0.02257495590828933 * sp[79];
    A[462] = -0.02257495590828926 * sp[74] + -0.01128747795414447 * sp[76] + -0.02257495590828915 * sp[75] + -0.01128747795414436 * sp[78] + -0.0112874779541444 * sp[76];
    A[463] = -0.01693121693121629 * sp[74] + -0.01410934744268062 * sp[76] + -0.0169312169312165 * sp[75] + -0.01410934744268079 * sp[78] + -0.01410934744268049 * sp[76] + -0.01128747795414471 * sp[79];
    A[464] = -0.04514991181657921 * sp[74] + -0.03386243386243399 * sp[76] + -0.04514991181657899 * sp[75] + -0.03386243386243387 * sp[78] + -0.03386243386243439 * sp[76] + -0.02257495590828946 * sp[79];
    A[465] = -0.01128747795414456 * sp[74] + -0.01128747795414473 * sp[75] + -0.0112874779541445 * sp[75] + -0.01128747795414463 * sp[77];
    A[466] = -0.002821869488536123 * sp[74] + -0.002821869488535946 * sp[75] + -0.002821869488536287 * sp[75] + -0.002821869488536167 * sp[77];
    A[467] = -0.0112874779541447 * sp[74] + -0.01128747795414475 * sp[75] + -0.01128747795414453 * sp[75] + -0.01128747795414457 * sp[77];
    A[468] = 0.2031746031746037 * sp[74] + 0.2031746031746036 * sp[75] + 0.1241622574955908 * sp[76] + 0.2031746031746036 * sp[75] + 0.2031746031746034 * sp[77] + 0.1241622574955908 * sp[78] + 0.1241622574955908 * sp[76] + 0.1241622574955908 * sp[78] + 0.203174603174604 * sp[79];
    A[469] = -0.1185185185185188 * sp[74] + -0.1185185185185188 * sp[75] + -0.1608465608465611 * sp[76] + -0.1185185185185188 * sp[75] + -0.1185185185185188 * sp[77] + -0.160846560846561 * sp[78] + -0.08747795414462124 * sp[76] + -0.08747795414462123 * sp[78] + -0.2201058201058207 * sp[79];
    A[470] = 0.04514991181657929 * sp[74] + 0.04514991181657928 * sp[75] + 0.07901234567901289 * sp[76] + 0.0451499118165791 * sp[75] + 0.0451499118165791 * sp[77] + 0.0790123456790128 * sp[78] + 0.03386243386243444 * sp[76] + 0.03386243386243441 * sp[78] + 0.1128747795414465 * sp[79];
    A[471] = 0.1015873015873018 * sp[74] + 0.0225749559082888 * sp[75] + 0.1015873015873017 * sp[76] + 0.1015873015873016 * sp[75] + 0.02257495590828882 * sp[77] + 0.1015873015873015 * sp[78] + 0.02257495590828894 * sp[76] + 0.1015873015873021 * sp[78] + 0.022574955908289 * sp[79];
    A[472] = -0.04232804232804236 * sp[74] + 0.01693121693121721 * sp[75] + -0.04232804232804229 * sp[76] + -0.04232804232804226 * sp[75] + 0.01693121693121721 * sp[77] + -0.0423280423280422 * sp[78] + -0.01128747795414423 * sp[76] + -0.04232804232804244 * sp[78] + -0.01128747795414425 * sp[79];
    A[473] = 0.01128747795414469 * sp[74] + -0.02257495590828933 * sp[75] + 0.01128747795414458 * sp[76] + 0.01128747795414452 * sp[75] + -0.02257495590828928 * sp[77] + 0.01128747795414441 * sp[78] + 0.01128747795414449 * sp[78];
    A[474] = 0.02257495590828868 * sp[74] + 0.1015873015873015 * sp[75] + 0.1015873015873016 * sp[76] + 0.02257495590828877 * sp[75] + 0.1015873015873014 * sp[77] + 0.1015873015873015 * sp[78] + 0.1015873015873023 * sp[76] + 0.02257495590828917 * sp[78] + 0.02257495590828919 * sp[79];
    A[475] = 0.01693121693121746 * sp[74] + -0.04232804232804209 * sp[75] + -0.04232804232804203 * sp[76] + 0.01693121693121741 * sp[75] + -0.04232804232804217 * sp[77] + -0.04232804232804209 * sp[78] + -0.04232804232804278 * sp[76] + -0.01128747795414439 * sp[78] + -0.01128747795414438 * sp[79];
    A[476] = -0.02257495590828957 * sp[74] + 0.01128747795414454 * sp[75] + 0.01128747795414453 * sp[76] + -0.02257495590828955 * sp[75] + 0.01128747795414443 * sp[77] + 0.01128747795414443 * sp[78] + 0.01128747795414472 * sp[76];
    A[477] = -0.02257495590828873 * sp[74] + -0.02257495590828845 * sp[75] + -0.0112874779541442 * sp[76] + -0.0225749559082891 * sp[75] + -0.02257495590828861 * sp[77] + -0.01128747795414442 * sp[78] + -0.0112874779541452 * sp[76] + -0.01128747795414419 * sp[78];
    A[478] = -0.02257495590828919 * sp[74] + -0.02257495590828932 * sp[75] + -0.01128747795414472 * sp[76] + -0.02257495590828909 * sp[75] + -0.0225749559082895 * sp[77] + -0.01128747795414472 * sp[78] + -0.01128747795414436 * sp[76] + -0.01128747795414513 * sp[78];
    A[479] = -0.06772486772486801 * sp[74] + -0.06772486772486803 * sp[75] + -0.05643738977072316 * sp[76] + -0.0677248677248678 * sp[75] + -0.06772486772486798 * sp[77] + -0.05643738977072324 * sp[78] + -0.05643738977072307 * sp[76] + -0.05643738977072345 * sp[78] + -0.04514991181657864 * sp[79];
    A[480] = -0.0677248677248678 * sp[74] + -0.2708994708994716 * sp[75] + -0.1693121693121696 * sp[76] + -0.06772486772486792 * sp[75] + -0.2708994708994714 * sp[77] + -0.1693121693121695 * sp[78] + -0.07901234567901286 * sp[76] + -0.1693121693121693 * sp[78] + -0.06772486772486799 * sp[79];
    A[481] = 0.02257495590828919 * sp[74] + 0.09029982363315756 * sp[75] + 0.05643738977072292 * sp[76] + 0.02257495590828909 * sp[75] + 0.09029982363315732 * sp[77] + 0.05643738977072289 * sp[78] + 0.01128747795414437 * sp[76] + 0.05643738977072305 * sp[78] + 0.02257495590828867 * sp[79];
    A[482] = 0.06772486772486798 * sp[74] + 0.1354497354497352 * sp[75] + 0.1015873015873019 * sp[76] + 0.06772486772486777 * sp[75] + 0.1354497354497352 * sp[77] + 0.1015873015873018 * sp[78] + 0.05643738977072307 * sp[76] + 0.1015873015873015 * sp[78] + 0.06772486772486835 * sp[79];
    A[483] = -0.2708994708994714 * sp[74] + -0.06772486772486758 * sp[75] + -0.1693121693121695 * sp[76] + -0.2708994708994714 * sp[75] + -0.06772486772486799 * sp[77] + -0.1693121693121696 * sp[78] + -0.1693121693121691 * sp[76] + -0.07901234567901304 * sp[78] + -0.06772486772486815 * sp[79];
    A[484] = 0.09029982363315697 * sp[74] + 0.02257495590828863 * sp[75] + 0.05643738977072234 * sp[76] + 0.09029982363315708 * sp[75] + 0.02257495590828879 * sp[77] + 0.05643738977072257 * sp[78] + 0.05643738977072276 * sp[76] + 0.01128747795414432 * sp[78] + 0.022574955908289 * sp[79];
    A[485] = 0.1354497354497351 * sp[74] + 0.06772486772486778 * sp[75] + 0.1015873015873019 * sp[76] + 0.1354497354497352 * sp[75] + 0.06772486772486773 * sp[77] + 0.1015873015873019 * sp[78] + 0.1015873015873017 * sp[76] + 0.05643738977072334 * sp[78] + 0.06772486772486849 * sp[79];
    A[486] = -0.1354497354497359 * sp[74] + -0.1354497354497358 * sp[75] + -0.03386243386243409 * sp[76] + -0.135449735449736 * sp[75] + -0.1354497354497356 * sp[77] + -0.03386243386243432 * sp[78] + -0.03386243386243361 * sp[76] + -0.03386243386243388 * sp[78] + -0.0451499118165787 * sp[79];
    A[487] = 0.04514991181657881 * sp[74] + 0.04514991181657832 * sp[75] + 0.01128747795414436 * sp[76] + 0.04514991181657883 * sp[75] + 0.0451499118165786 * sp[77] + 0.01128747795414458 * sp[78] + 0.0112874779541443 * sp[76] + 0.0112874779541447 * sp[78];
    A[488] = 0.04514991181657846 * sp[74] + 0.04514991181657869 * sp[75] + 0.01128747795414461 * sp[76] + 0.04514991181657851 * sp[75] + 0.04514991181657844 * sp[77] + 0.01128747795414461 * sp[78] + 0.01128747795414442 * sp[76] + 0.01128747795414452 * sp[78];
    A[489] = 0.09029982363315664 * sp[74] + 0.09029982363315701 * sp[75] + 0.09029982363315729 * sp[76] + 0.09029982363315713 * sp[75] + 0.09029982363315764 * sp[77] + 0.09029982363315758 * sp[78] + 0.09029982363315821 * sp[76] + 0.09029982363315833 * sp[78] + 0.09029982363315739 * sp[79];
    A[490] = 0.02028218694885368 * sp[74] + 0.02028218694885368 * sp[75] + 0.0202821869488537 * sp[76] + 0.02028218694885366 * sp[75] + 0.02028218694885367 * sp[77] + 0.02028218694885369 * sp[78] + 0.05291005291005318 * sp[76] + 0.05291005291005316 * sp[78] + 0.05291005291005319 * sp[79];
    A[491] = 0.005114638447971682 * sp[74] + 0.005114638447971691 * sp[75];
    A[492] = 0.005114638447971736 * sp[75] + 0.005114638447971742 * sp[77];
    A[493] = 0.03262786596119975 * sp[76] + 0.03262786596119967 * sp[78] + 0.05291005291005323 * sp[79];
    A[494] = -0.01693121693121663 * sp[75] + -0.002821869488535898 * sp[76] + -0.01693121693121666 * sp[77] + -0.002821869488535908 * sp[78] + -0.002821869488535994 * sp[78];
    A[495] = 0.02116402116402038 * sp[75] + 0.01058201058200995 * sp[76] + 0.02116402116402047 * sp[77] + 0.01058201058201003 * sp[78] + 0.01058201058201003 * sp[78] + -0.002821869488536233 * sp[79];
    A[496] = 0.09029982363315811 * sp[75] + 0.05925925925925977 * sp[76] + 0.09029982363315786 * sp[77] + 0.0592592592592596 * sp[78] + 0.05925925925926006 * sp[78] + 0.01693121693121708 * sp[79];
    A[497] = -0.01693121693121676 * sp[74] + -0.002821869488536249 * sp[76] + -0.01693121693121686 * sp[75] + -0.002821869488536274 * sp[78] + -0.002821869488535926 * sp[76];
    A[498] = 0.0211640211640201 * sp[74] + 0.01058201058201039 * sp[76] + 0.0211640211640203 * sp[75] + 0.01058201058201041 * sp[78] + 0.01058201058201005 * sp[76] + -0.002821869488536143 * sp[79];
    A[499] = 0.09029982363315828 * sp[74] + 0.05925925925925954 * sp[76] + 0.090299823633158 * sp[75] + 0.05925925925925944 * sp[78] + 0.05925925925926021 * sp[76] + 0.01693121693121734 * sp[79];
    A[500] = -0.002821869488536449 * sp[74] + -0.002821869488536312 * sp[75] + -0.002821869488536444 * sp[75] + -0.002821869488536338 * sp[77];
    A[501] = -0.009171075837742345 * sp[74] + -0.009171075837742401 * sp[75] + -0.009171075837742302 * sp[75] + -0.009171075837742314 * sp[77];
    A[502] = -0.002821869488536023 * sp[74] + -0.002821869488536098 * sp[75] + -0.002821869488536031 * sp[75] + -0.002821869488536114 * sp[77];
    A[503] = -0.1185185185185188 * sp[74] + -0.1185185185185188 * sp[75] + -0.08747795414462124 * sp[76] + -0.1185185185185188 * sp[75] + -0.1185185185185188 * sp[77] + -0.08747795414462123 * sp[78] + -0.1608465608465611 * sp[76] + -0.160846560846561 * sp[78] + -0.2201058201058207 * sp[79];
    A[504] = 0.2497354497354505 * sp[74] + 0.2497354497354504 * sp[75] + 0.1671957671957681 * sp[76] + 0.2497354497354504 * sp[75] + 0.2497354497354504 * sp[77] + 0.1671957671957681 * sp[78] + 0.1671957671957681 * sp[76] + 0.1671957671957681 * sp[78] + 0.3343915343915349 * sp[79];
    A[505] = -0.09029982363315837 * sp[74] + -0.09029982363315826 * sp[75] + -0.1326278659612004 * sp[76] + -0.09029982363315811 * sp[75] + -0.09029982363315801 * sp[77] + -0.1326278659612004 * sp[78] + -0.05925925925926031 * sp[76] + -0.05925925925926023 * sp[78] + -0.2201058201058207 * sp[79];
    A[506] = -0.0423280423280424 * sp[74] + -0.01128747795414472 * sp[75] + -0.0423280423280423 * sp[76] + -0.04232804232804242 * sp[75] + -0.01128747795414472 * sp[77] + -0.04232804232804232 * sp[78] + 0.01693121693121689 * sp[76] + -0.04232804232804267 * sp[78] + 0.01693121693121683 * sp[79];
    A[507] = -0.01340388007054646 * sp[74] + -0.002821869488535942 * sp[75] + -0.01340388007054646 * sp[76] + -0.01340388007054645 * sp[75] + -0.002821869488535972 * sp[77] + -0.01340388007054646 * sp[78] + -0.002821869488536284 * sp[76] + -0.01340388007054648 * sp[78] + -0.002821869488536239 * sp[79];
    A[508] = 0.002821869488536068 * sp[74] + -0.01128747795414477 * sp[75] + 0.002821869488536134 * sp[76] + 0.00282186948853608 * sp[75] + -0.01128747795414475 * sp[77] + 0.002821869488536144 * sp[78] + 0.002821869488536104 * sp[78];
    A[509] = -0.01128747795414463 * sp[74] + -0.04232804232804228 * sp[75] + -0.04232804232804221 * sp[76] + -0.01128747795414464 * sp[75] + -0.0423280423280423 * sp[77] + -0.04232804232804225 * sp[78] + -0.04232804232804293 * sp[76] + 0.01693121693121676 * sp[78] + 0.0169312169312167 * sp[79];
    A[510] = -0.002821869488536189 * sp[74] + -0.01340388007054681 * sp[75] + -0.01340388007054679 * sp[76] + -0.0028218694885362 * sp[75] + -0.01340388007054682 * sp[77] + -0.01340388007054681 * sp[78] + -0.0134038800705463 * sp[76] + -0.002821869488536138 * sp[78] + -0.002821869488536138 * sp[79];
    A[511] = -0.0112874779541447 * sp[74] + 0.002821869488536264 * sp[75] + 0.002821869488536287 * sp[76] + -0.01128747795414468 * sp[75] + 0.002821869488536289 * sp[77] + 0.002821869488536312 * sp[78] + 0.002821869488535898 * sp[76];
    A[512] = 0.01693121693121676 * sp[74] + 0.0169312169312164 * sp[75] + -0.002821869488536475 * sp[76] + 0.01693121693121692 * sp[75] + 0.01693121693121646 * sp[77] + -0.002821869488536343 * sp[78] + -0.002821869488535238 * sp[76] + -0.002821869488535769 * sp[78];
    A[513] = 0.01693121693121644 * sp[74] + 0.01693121693121666 * sp[75] + -0.002821869488536046 * sp[76] + 0.01693121693121661 * sp[75] + 0.01693121693121684 * sp[77] + -0.002821869488535914 * sp[78] + -0.002821869488536418 * sp[76] + -0.002821869488535911 * sp[78];
    A[514] = 0.08465608465608507 * sp[74] + 0.08465608465608519 * sp[75] + 0.04232804232804239 * sp[76] + 0.08465608465608472 * sp[75] + 0.08465608465608494 * sp[77] + 0.04232804232804226 * sp[78] + 0.04232804232804251 * sp[76] + 0.04232804232804294 * sp[78] + 0.02257495590828962 * sp[79];
    A[515] = 0.1185185185185188 * sp[74] + 0.06772486772486795 * sp[75] + 0.1608465608465606 * sp[76] + 0.1185185185185187 * sp[75] + 0.06772486772486802 * sp[77] + 0.1608465608465606 * sp[78] + 0.02539682539682593 * sp[76] + 0.1608465608465608 * sp[78] + -0.01693121693121626 * sp[79];
    A[516] = -0.01693121693121648 * sp[74] + 0.06772486772486748 * sp[75] + 0.002821869488536223 * sp[76] + -0.01693121693121664 * sp[75] + 0.06772486772486744 * sp[77] + 0.002821869488536143 * sp[78] + 0.002821869488536388 * sp[76] + 0.002821869488536281 * sp[78] + 0.005643738977072518 * sp[79];
    A[517] = -0.08465608465608505 * sp[74] + -0.2708994708994707 * sp[75] + -0.1777777777777778 * sp[76] + -0.08465608465608472 * sp[75] + -0.2708994708994708 * sp[77] + -0.1777777777777776 * sp[78] + -0.04232804232804249 * sp[76] + -0.1777777777777779 * sp[78] + -0.01693121693121767 * sp[79];
    A[518] = 0.0677248677248673 * sp[74] + 0.1185185185185183 * sp[75] + 0.1608465608465604 * sp[76] + 0.0677248677248674 * sp[75] + 0.1185185185185183 * sp[77] + 0.1608465608465605 * sp[78] + 0.1608465608465608 * sp[76] + 0.02539682539682615 * sp[78] + -0.01693121693121623 * sp[79];
    A[519] = 0.0677248677248682 * sp[74] + -0.01693121693121636 * sp[75] + 0.002821869488536546 * sp[76] + 0.06772486772486822 * sp[75] + -0.01693121693121643 * sp[77] + 0.002821869488536537 * sp[78] + 0.00282186948853619 * sp[76] + 0.002821869488535583 * sp[78] + 0.005643738977072047 * sp[79];
    A[520] = -0.2708994708994707 * sp[74] + -0.08465608465608503 * sp[75] + -0.1777777777777778 * sp[76] + -0.2708994708994708 * sp[75] + -0.08465608465608475 * sp[77] + -0.1777777777777777 * sp[78] + -0.1777777777777782 * sp[76] + -0.04232804232804274 * sp[78] + -0.01693121693121775 * sp[79];
    A[521] = 0.02257495590828957 * sp[74] + 0.02257495590828964 * sp[75] + -0.01975308641975251 * sp[76] + 0.02257495590828956 * sp[75] + 0.02257495590828966 * sp[77] + -0.01975308641975257 * sp[78] + -0.01975308641975305 * sp[76] + -0.01975308641975304 * sp[78] + 0.02257495590828942 * sp[79];
    A[522] = 0.02257495590828933 * sp[74] + 0.02257495590828929 * sp[75] + 0.002821869488536574 * sp[76] + 0.02257495590828935 * sp[75] + 0.02257495590828921 * sp[77] + 0.002821869488536447 * sp[78] + 0.002821869488536339 * sp[76] + 0.002821869488536142 * sp[78];
    A[523] = 0.02257495590828884 * sp[74] + 0.02257495590828888 * sp[75] + 0.002821869488536174 * sp[76] + 0.0225749559082888 * sp[75] + 0.02257495590828891 * sp[77] + 0.00282186948853604 * sp[78] + 0.002821869488536243 * sp[76] + 0.002821869488536312 * sp[78];
    A[524] = -0.1354497354497359 * sp[74] + -0.1354497354497355 * sp[75] + -0.02257495590829018 * sp[76] + -0.135449735449736 * sp[75] + -0.1354497354497356 * sp[77] + -0.02257495590829001 * sp[78] + -0.02257495590829078 * sp[76] + -0.02257495590829051 * sp[78] + -0.04514991181657929 * sp[79];
    A[525] = -0.007760141093474598 * sp[74] + -0.00776014109347458 * sp[75] + -0.007760141093474551 * sp[76] + -0.007760141093474587 * sp[75] + -0.00776014109347457 * sp[77] + -0.007760141093474541 * sp[78] + -0.0253968253968255 * sp[76] + -0.02539682539682548 * sp[78] + -0.02539682539682551 * sp[79];
    A[526] = 0.007760141093474602 * sp[74] + 0.007760141093474573 * sp[75];
    A[527] = 0.007760141093474611 * sp[75] + 0.007760141093474602 * sp[77];
    A[528] = -0.04585537918871292 * sp[76] + -0.04585537918871282 * sp[78] + -0.07054673721340424 * sp[79];
    A[529] = -0.04514991181657887 * sp[75] + -0.01128747795414476 * sp[76] + -0.04514991181657885 * sp[77] + -0.0112874779541448 * sp[78] + -0.01128747795414478 * sp[78];
    A[530] = 0.0902998236331579 * sp[75] + 0.03104056437389822 * sp[76] + 0.0902998236331579 * sp[77] + 0.03104056437389827 * sp[78] + 0.03104056437389822 * sp[78] + -0.01128747795414465 * sp[79];
    A[531] = -0.158024691358026 * sp[75] + -0.07901234567901284 * sp[76] + -0.1580246913580259 * sp[77] + -0.07901234567901284 * sp[78] + -0.07901234567901329 * sp[78] + 0.02257495590828903 * sp[79];
    A[532] = -0.04514991181657919 * sp[74] + -0.01128747795414468 * sp[76] + -0.04514991181657908 * sp[75] + -0.0112874779541447 * sp[78] + -0.01128747795414498 * sp[76];
    A[533] = 0.09029982363315851 * sp[74] + 0.03104056437389788 * sp[76] + 0.09029982363315836 * sp[75] + 0.03104056437389789 * sp[78] + 0.03104056437389867 * sp[76] + -0.01128747795414437 * sp[79];
    A[534] = -0.1580246913580264 * sp[74] + -0.0790123456790128 * sp[76] + -0.1580246913580262 * sp[75] + -0.07901234567901283 * sp[78] + -0.07901234567901352 * sp[76] + 0.02257495590828881 * sp[79];
    A[535] = -0.01128747795414445 * sp[74] + -0.01128747795414465 * sp[75] + -0.01128747795414444 * sp[75] + -0.01128747795414466 * sp[77];
    A[536] = -0.002821869488536185 * sp[74] + -0.002821869488536149 * sp[75] + -0.002821869488536212 * sp[75] + -0.002821869488536176 * sp[77];
    A[537] = -0.01128747795414457 * sp[74] + -0.01128747795414462 * sp[75] + -0.01128747795414461 * sp[75] + -0.01128747795414465 * sp[77];
    A[538] = 0.04514991181657929 * sp[74] + 0.0451499118165791 * sp[75] + 0.03386243386243444 * sp[76] + 0.04514991181657928 * sp[75] + 0.0451499118165791 * sp[77] + 0.03386243386243441 * sp[78] + 0.07901234567901289 * sp[76] + 0.0790123456790128 * sp[78] + 0.1128747795414465 * sp[79];
    A[539] = -0.09029982363315837 * sp[74] + -0.09029982363315811 * sp[75] + -0.05925925925926031 * sp[76] + -0.09029982363315826 * sp[75] + -0.09029982363315801 * sp[77] + -0.05925925925926023 * sp[78] + -0.1326278659612004 * sp[76] + -0.1326278659612004 * sp[78] + -0.2201058201058207 * sp[79];
    A[540] = 0.1580246913580264 * sp[74] + 0.1580246913580262 * sp[75] + 0.07901234567901358 * sp[76] + 0.1580246913580262 * sp[75] + 0.1580246913580261 * sp[77] + 0.07901234567901345 * sp[78] + 0.07901234567901358 * sp[76] + 0.07901234567901345 * sp[78] + 0.2031746031746039 * sp[79];
    A[541] = 0.01128747795414454 * sp[74] + 0.01128747795414449 * sp[76] + 0.01128747795414459 * sp[75] + 0.01128747795414456 * sp[78] + -0.02257495590828909 * sp[76] + 0.01128747795414468 * sp[78] + -0.022574955908289 * sp[79];
    A[542] = 0.002821869488536153 * sp[74] + 0.002821869488536174 * sp[76] + 0.002821869488536128 * sp[75] + 0.002821869488536148 * sp[78] + -0.01128747795414455 * sp[76] + 0.002821869488536053 * sp[78] + -0.0112874779541446 * sp[79];
    A[543] = 0.01128747795414453 * sp[74] + 0.01128747795414452 * sp[76] + 0.01128747795414457 * sp[75] + 0.01128747795414455 * sp[78] + 0.0112874779541446 * sp[78];
    A[544] = 0.0112874779541445 * sp[75] + 0.01128747795414451 * sp[76] + 0.01128747795414455 * sp[77] + 0.01128747795414456 * sp[78] + 0.01128747795414477 * sp[76] + -0.02257495590828906 * sp[78] + -0.02257495590828905 * sp[79];
    A[545] = 0.002821869488536108 * sp[75] + 0.002821869488536099 * sp[76] + 0.002821869488536104 * sp[77] + 0.002821869488536095 * sp[78] + 0.002821869488536092 * sp[76] + -0.0112874779541445 * sp[78] + -0.01128747795414449 * sp[79];
    A[546] = 0.01128747795414466 * sp[75] + 0.01128747795414468 * sp[76] + 0.01128747795414467 * sp[77] + 0.01128747795414469 * sp[78] + 0.01128747795414468 * sp[76];
    A[547] = 0.02257495590828941 * sp[74] + 0.02257495590828945 * sp[75] + -0.01128747795414467 * sp[76] + 0.02257495590828928 * sp[75] + 0.02257495590828942 * sp[77] + -0.01128747795414474 * sp[78] + -0.01128747795414525 * sp[76] + -0.01128747795414483 * sp[78];
    A[548] = 0.02257495590828943 * sp[74] + 0.02257495590828947 * sp[75] + -0.01128747795414456 * sp[76] + 0.02257495590828943 * sp[75] + 0.02257495590828944 * sp[77] + -0.01128747795414464 * sp[78] + -0.01128747795414454 * sp[76] + -0.01128747795414501 * sp[78];
    A[549] = -0.112874779541446 * sp[74] + -0.1128747795414463 * sp[75] + -0.01128747795414427 * sp[76] + -0.1128747795414459 * sp[75] + -0.1128747795414463 * sp[77] + -0.01128747795414421 * sp[78] + -0.01128747795414476 * sp[76] + -0.01128747795414477 * sp[78] + -0.04514991181657847 * sp[79];
    A[550] = -0.02257495590828913 * sp[74] + -0.03386243386243382 * sp[76] + -0.02257495590828906 * sp[75] + -0.03386243386243386 * sp[78] + 0.01128747795414452 * sp[76] + -0.03386243386243399 * sp[78] + 0.06772486772486701 * sp[79];
    A[551] = -0.02257495590828949 * sp[74] + -0.03386243386243411 * sp[76] + -0.02257495590828949 * sp[75] + -0.03386243386243414 * sp[78] + 0.01128747795414455 * sp[76] + -0.03386243386243412 * sp[78] + 0.02257495590828942 * sp[79];
    A[552] = 0.1128747795414462 * sp[74] + 0.1015873015873021 * sp[76] + 0.1128747795414461 * sp[75] + 0.1015873015873021 * sp[78] + 0.01128747795414478 * sp[76] + 0.101587301587302 * sp[78] + -0.06772486772486708 * sp[79];
    A[553] = -0.02257495590828914 * sp[75] + -0.0338624338624336 * sp[76] + -0.02257495590828904 * sp[77] + -0.03386243386243361 * sp[78] + -0.0338624338624337 * sp[76] + 0.01128747795414463 * sp[78] + 0.06772486772486723 * sp[79];
    A[554] = -0.02257495590828941 * sp[75] + -0.033862433862434 * sp[76] + -0.02257495590828937 * sp[77] + -0.03386243386243401 * sp[78] + -0.03386243386243416 * sp[76] + 0.01128747795414489 * sp[78] + 0.0225749559082891 * sp[79];
    A[555] = 0.1128747795414462 * sp[75] + 0.1015873015873016 * sp[76] + 0.1128747795414462 * sp[77] + 0.1015873015873016 * sp[78] + 0.1015873015873019 * sp[76] + 0.01128747795414465 * sp[78] + -0.06772486772486708 * sp[79];
    A[556] = 0.01128747795414412 * sp[76] + 0.01128747795414422 * sp[78] + 0.01128747795414465 * sp[76] + 0.0112874779541446 * sp[78] + -0.04514991181657809 * sp[79];
    A[557] = 0.01128747795414456 * sp[76] + 0.01128747795414463 * sp[78] + 0.01128747795414432 * sp[76] + 0.01128747795414469 * sp[78];
    A[558] = 0.01128747795414447 * sp[76] + 0.01128747795414455 * sp[78] + 0.01128747795414468 * sp[76] + 0.01128747795414425 * sp[78];
    A[559] = 0.09029982363315686 * sp[79];
    A[560] = -0.024691358024691 * sp[74] + -0.02469135802469104 * sp[75] + -0.02469135802469104 * sp[76] + -0.07054673721340421 * sp[75] + -0.07054673721340421 * sp[77] + -0.07054673721340418 * sp[78] + -0.02469135802469103 * sp[76] + -0.02469135802469107 * sp[78] + -0.02469135802469107 * sp[79];
    A[561] = 0.007760141093474616 * sp[74] + 0.007760141093474603 * sp[76];
    A[562] = -0.01763668430335097 * sp[75] + -0.02539682539682545 * sp[77] + -0.01763668430335091 * sp[78];
    A[563] = 0.007760141093474435 * sp[76] + 0.007760141093474385 * sp[79];
    A[564] = -0.03386243386243376 * sp[75] + -0.04514991181657856 * sp[76] + -0.02257495590828888 * sp[77] + -0.03386243386243352 * sp[78] + -0.03386243386243355 * sp[78] + -0.04514991181657826 * sp[79];
    A[565] = -0.01410934744268085 * sp[75] + -0.01693121693121674 * sp[76] + -0.01128747795414464 * sp[77] + -0.0141093474426808 * sp[78] + -0.01410934744268082 * sp[78] + -0.01693121693121673 * sp[79];
    A[566] = -0.01128747795414453 * sp[75] + -0.02257495590828922 * sp[76] + -0.01128747795414441 * sp[78] + -0.01128747795414449 * sp[78] + -0.02257495590828911 * sp[79];
    A[567] = -0.01128747795414447 * sp[74] + -0.01128747795414449 * sp[76] + -0.0112874779541443 * sp[76] + -0.01128747795414427 * sp[79];
    A[568] = -0.002821869488536365 * sp[74] + -0.002821869488536555 * sp[76] + -0.002821869488536417 * sp[76] + -0.002821869488536667 * sp[79];
    A[569] = -0.01128747795414449 * sp[74] + -0.01128747795414418 * sp[76] + -0.01128747795414445 * sp[76] + -0.01128747795414412 * sp[79];
    A[570] = -0.02257495590828941 * sp[74] + -0.01128747795414492 * sp[75] + -0.01128747795414413 * sp[75] + -0.02257495590828919 * sp[76] + -0.01128747795414469 * sp[78];
    A[571] = -0.01693121693121597 * sp[74] + -0.01410934744267978 * sp[75] + -0.01410934744268053 * sp[75] + -0.01128747795414465 * sp[77] + -0.01693121693121641 * sp[76] + -0.0141093474426802 * sp[78];
    A[572] = -0.04514991181657875 * sp[74] + -0.03386243386243398 * sp[75] + -0.03386243386243369 * sp[75] + -0.02257495590828883 * sp[77] + -0.04514991181657847 * sp[76] + -0.03386243386243378 * sp[78];
    A[573] = 0.1015873015873018 * sp[74] + 0.1015873015873016 * sp[75] + 0.02257495590828894 * sp[76] + 0.0225749559082888 * sp[75] + 0.02257495590828882 * sp[77] + 0.1015873015873021 * sp[78] + 0.1015873015873017 * sp[76] + 0.1015873015873015 * sp[78] + 0.022574955908289 * sp[79];
    A[574] = -0.0423280423280424 * sp[74] + -0.04232804232804242 * sp[75] + 0.01693121693121689 * sp[76] + -0.01128747795414472 * sp[75] + -0.01128747795414472 * sp[77] + -0.04232804232804267 * sp[78] + -0.0423280423280423 * sp[76] + -0.04232804232804232 * sp[78] + 0.01693121693121683 * sp[79];
    A[575] = 0.01128747795414454 * sp[74] + 0.01128747795414459 * sp[75] + -0.02257495590828909 * sp[76] + 0.01128747795414468 * sp[78] + 0.01128747795414449 * sp[76] + 0.01128747795414456 * sp[78] + -0.022574955908289 * sp[79];
    A[576] = 0.2031746031746031 * sp[74] + 0.1241622574955902 * sp[75] + 0.203174603174603 * sp[76] + 0.1241622574955902 * sp[75] + 0.2031746031746036 * sp[77] + 0.1241622574955902 * sp[78] + 0.203174603174603 * sp[76] + 0.1241622574955902 * sp[78] + 0.2031746031746027 * sp[79];
    A[577] = -0.1185185185185179 * sp[74] + -0.1608465608465603 * sp[75] + -0.1185185185185177 * sp[76] + -0.08747795414462024 * sp[75] + -0.22010582010582 * sp[77] + -0.08747795414462015 * sp[78] + -0.118518518518518 * sp[76] + -0.1608465608465602 * sp[78] + -0.1185185185185178 * sp[79];
    A[578] = 0.04514991181657877 * sp[74] + 0.07901234567901233 * sp[75] + 0.04514991181657858 * sp[76] + 0.03386243386243371 * sp[75] + 0.1128747795414462 * sp[77] + 0.03386243386243364 * sp[78] + 0.04514991181657849 * sp[76] + 0.07901234567901229 * sp[78] + 0.0451499118165783 * sp[79];
    A[579] = 0.02257495590828857 * sp[74] + 0.1015873015873013 * sp[75] + 0.1015873015873013 * sp[76] + 0.1015873015873023 * sp[75] + 0.02257495590828888 * sp[77] + 0.02257495590828885 * sp[78] + 0.02257495590828863 * sp[76] + 0.1015873015873012 * sp[78] + 0.1015873015873012 * sp[79];
    A[580] = 0.01693121693121757 * sp[74] + -0.04232804232804205 * sp[75] + -0.04232804232804204 * sp[76] + -0.04232804232804268 * sp[75] + -0.01128747795414401 * sp[77] + -0.01128747795414407 * sp[78] + 0.01693121693121752 * sp[76] + -0.04232804232804206 * sp[78] + -0.04232804232804207 * sp[79];
    A[581] = -0.02257495590828968 * sp[74] + 0.01128747795414467 * sp[75] + 0.01128747795414457 * sp[76] + 0.01128747795414462 * sp[75] + -0.02257495590828964 * sp[76] + 0.01128747795414444 * sp[78] + 0.01128747795414434 * sp[79];
    A[582] = -0.02257495590828826 * sp[74] + -0.01128747795414423 * sp[75] + -0.02257495590828784 * sp[76] + -0.01128747795414465 * sp[75] + -0.01128747795414363 * sp[78] + -0.02257495590828867 * sp[76] + -0.01128747795414416 * sp[78] + -0.0225749559082881 * sp[79];
    A[583] = -0.06772486772486794 * sp[74] + -0.0564373897707229 * sp[75] + -0.0677248677248673 * sp[76] + -0.05643738977072277 * sp[75] + -0.04514991181657879 * sp[77] + -0.05643738977072267 * sp[78] + -0.0677248677248674 * sp[76] + -0.05643738977072286 * sp[78] + -0.06772486772486722 * sp[79];
    A[584] = -0.02257495590828915 * sp[74] + -0.01128747795414464 * sp[75] + -0.0225749559082898 * sp[76] + -0.01128747795414466 * sp[75] + -0.01128747795414519 * sp[78] + -0.02257495590828913 * sp[76] + -0.01128747795414469 * sp[78] + -0.02257495590828975 * sp[79];
    A[585] = -0.06772486772486715 * sp[74] + -0.1693121693121692 * sp[75] + -0.2708994708994709 * sp[76] + -0.0790123456790128 * sp[75] + -0.06772486772486724 * sp[77] + -0.1693121693121691 * sp[78] + -0.06772486772486759 * sp[76] + -0.1693121693121694 * sp[78] + -0.2708994708994707 * sp[79];
    A[586] = 0.06772486772486794 * sp[74] + 0.1015873015873014 * sp[75] + 0.1354497354497349 * sp[76] + 0.05643738977072279 * sp[75] + 0.06772486772486729 * sp[77] + 0.1015873015873012 * sp[78] + 0.06772486772486741 * sp[76] + 0.1015873015873014 * sp[78] + 0.135449735449735 * sp[79];
    A[587] = 0.02257495590828909 * sp[74] + 0.05643738977072322 * sp[75] + 0.09029982363315704 * sp[76] + 0.01128747795414461 * sp[75] + 0.02257495590828935 * sp[77] + 0.05643738977072345 * sp[78] + 0.02257495590828907 * sp[76] + 0.05643738977072309 * sp[78] + 0.09029982363315694 * sp[79];
    A[588] = -0.1354497354497359 * sp[74] + -0.03386243386243373 * sp[75] + -0.1354497354497355 * sp[76] + -0.03386243386243323 * sp[75] + -0.04514991181657889 * sp[77] + -0.03386243386243392 * sp[78] + -0.1354497354497359 * sp[76] + -0.03386243386243403 * sp[78] + -0.1354497354497354 * sp[79];
    A[589] = 0.04514991181657865 * sp[74] + 0.01128747795414432 * sp[75] + 0.0451499118165781 * sp[76] + 0.01128747795414383 * sp[75] + 0.0112874779541442 * sp[78] + 0.04514991181657853 * sp[76] + 0.01128747795414425 * sp[78] + 0.04514991181657823 * sp[79];
    A[590] = 0.04514991181657866 * sp[74] + 0.01128747795414449 * sp[75] + 0.04514991181657849 * sp[76] + 0.01128747795414482 * sp[75] + 0.01128747795414503 * sp[78] + 0.04514991181657863 * sp[76] + 0.01128747795414454 * sp[78] + 0.04514991181657836 * sp[79];
    A[591] = -0.270899470899471 * sp[74] + -0.1693121693121686 * sp[75] + -0.06772486772486692 * sp[76] + -0.1693121693121684 * sp[75] + -0.06772486772486733 * sp[77] + -0.07901234567901208 * sp[78] + -0.270899470899471 * sp[76] + -0.1693121693121688 * sp[78] + -0.0677248677248676 * sp[79];
    A[592] = 0.09029982363315724 * sp[74] + 0.05643738977072218 * sp[75] + 0.02257495590828837 * sp[76] + 0.05643738977072232 * sp[75] + 0.02257495590828859 * sp[77] + 0.01128747795414388 * sp[78] + 0.09029982363315722 * sp[76] + 0.05643738977072262 * sp[78] + 0.02257495590828863 * sp[79];
    A[593] = 0.1354497354497339 * sp[74] + 0.1015873015873008 * sp[75] + 0.06772486772486713 * sp[76] + 0.1015873015873008 * sp[75] + 0.06772486772486726 * sp[77] + 0.05643738977072264 * sp[78] + 0.1354497354497345 * sp[76] + 0.1015873015873009 * sp[78] + 0.06772486772486702 * sp[79];
    A[594] = 0.09029982363315545 * sp[74] + 0.09029982363315647 * sp[75] + 0.09029982363315658 * sp[76] + 0.09029982363315749 * sp[75] + 0.09029982363315754 * sp[77] + 0.09029982363315711 * sp[78] + 0.09029982363315633 * sp[76] + 0.09029982363315672 * sp[78] + 0.09029982363315725 * sp[79];
    A[595] = 0.02028218694885328 * sp[74] + 0.02028218694885342 * sp[75] + 0.02028218694885339 * sp[76] + 0.05291005291005306 * sp[75] + 0.05291005291005307 * sp[77] + 0.05291005291005303 * sp[78] + 0.02028218694885329 * sp[76] + 0.02028218694885342 * sp[78] + 0.02028218694885339 * sp[79];
    A[596] = 0.005114638447971594 * sp[74] + 0.005114638447971613 * sp[76];
    A[597] = 0.03262786596119946 * sp[75] + 0.05291005291005312 * sp[77] + 0.03262786596119938 * sp[78];
    A[598] = 0.005114638447971753 * sp[76] + 0.005114638447971773 * sp[79];
    A[599] = 0.05925925925925925 * sp[75] + 0.09029982363315728 * sp[76] + 0.01693121693121628 * sp[77] + 0.05925925925925905 * sp[78] + 0.0592592592592588 * sp[78] + 0.09029982363315675 * sp[79];
    A[600] = 0.01058201058201072 * sp[75] + 0.02116402116402074 * sp[76] + -0.002821869488536001 * sp[77] + 0.01058201058201043 * sp[78] + 0.01058201058201079 * sp[78] + 0.02116402116402086 * sp[79];
    A[601] = -0.00282186948853616 * sp[75] + -0.01693121693121682 * sp[76] + -0.002821869488536206 * sp[78] + -0.002821869488536178 * sp[78] + -0.01693121693121688 * sp[79];
    A[602] = -0.002821869488536198 * sp[74] + -0.002821869488536081 * sp[76] + -0.002821869488536304 * sp[76] + -0.002821869488536239 * sp[79];
    A[603] = -0.00917107583774231 * sp[74] + -0.009171075837742289 * sp[76] + -0.009171075837742322 * sp[76] + -0.009171075837742288 * sp[79];
    A[604] = -0.002821869488536189 * sp[74] + -0.002821869488536408 * sp[76] + -0.002821869488536207 * sp[76] + -0.002821869488536392 * sp[79];
    A[605] = -0.0169312169312163 * sp[74] + -0.002821869488535612 * sp[75] + -0.002821869488536351 * sp[75] + -0.01693121693121647 * sp[76] + -0.002821869488535773 * sp[78];
    A[606] = 0.02116402116401951 * sp[74] + 0.01058201058200942 * sp[75] + 0.01058201058201037 * sp[75] + -0.002821869488536099 * sp[77] + 0.02116402116402005 * sp[76] + 0.01058201058200992 * sp[78];
    A[607] = 0.09029982363315774 * sp[74] + 0.05925925925925955 * sp[75] + 0.05925925925925919 * sp[75] + 0.01693121693121641 * sp[77] + 0.09029982363315718 * sp[76] + 0.05925925925925914 * sp[78];
    A[608] = -0.04232804232804236 * sp[74] + -0.04232804232804226 * sp[75] + -0.01128747795414423 * sp[76] + 0.01693121693121721 * sp[75] + 0.01693121693121721 * sp[77] + -0.04232804232804244 * sp[78] + -0.04232804232804229 * sp[76] + -0.0423280423280422 * sp[78] + -0.01128747795414425 * sp[79];
    A[609] = -0.01340388007054646 * sp[74] + -0.01340388007054645 * sp[75] + -0.002821869488536284 * sp[76] + -0.002821869488535942 * sp[75] + -0.002821869488535972 * sp[77] + -0.01340388007054648 * sp[78] + -0.01340388007054646 * sp[76] + -0.01340388007054646 * sp[78] + -0.002821869488536239 * sp[79];
    A[610] = 0.002821869488536153 * sp[74] + 0.002821869488536128 * sp[75] + -0.01128747795414455 * sp[76] + 0.002821869488536053 * sp[78] + 0.002821869488536174 * sp[76] + 0.002821869488536148 * sp[78] + -0.0112874779541446 * sp[79];
    A[611] = -0.1185185185185179 * sp[74] + -0.08747795414462024 * sp[75] + -0.118518518518518 * sp[76] + -0.1608465608465603 * sp[75] + -0.22010582010582 * sp[77] + -0.1608465608465602 * sp[78] + -0.1185185185185177 * sp[76] + -0.08747795414462015 * sp[78] + -0.1185185185185178 * sp[79];
    A[612] = 0.2497354497354493 * sp[74] + 0.1671957671957668 * sp[75] + 0.2497354497354492 * sp[76] + 0.1671957671957668 * sp[75] + 0.3343915343915343 * sp[77] + 0.1671957671957667 * sp[78] + 0.2497354497354492 * sp[76] + 0.1671957671957667 * sp[78] + 0.2497354497354492 * sp[79];
    A[613] = -0.09029982363315774 * sp[74] + -0.1326278659611997 * sp[75] + -0.09029982363315756 * sp[76] + -0.05925925925925921 * sp[75] + -0.2201058201058204 * sp[77] + -0.05925925925925914 * sp[78] + -0.09029982363315721 * sp[76] + -0.1326278659611996 * sp[78] + -0.09029982363315706 * sp[79];
    A[614] = -0.01128747795414418 * sp[74] + -0.04232804232804213 * sp[75] + -0.0423280423280421 * sp[76] + -0.04232804232804278 * sp[75] + 0.01693121693121706 * sp[77] + 0.01693121693121709 * sp[78] + -0.01128747795414425 * sp[76] + -0.04232804232804211 * sp[78] + -0.04232804232804208 * sp[79];
    A[615] = -0.002821869488536249 * sp[74] + -0.01340388007054686 * sp[75] + -0.0134038800705469 * sp[76] + -0.01340388007054626 * sp[75] + -0.002821869488536125 * sp[77] + -0.00282186948853609 * sp[78] + -0.002821869488536178 * sp[76] + -0.01340388007054685 * sp[78] + -0.01340388007054688 * sp[79];
    A[616] = -0.01128747795414456 * sp[74] + 0.002821869488536012 * sp[75] + 0.002821869488536027 * sp[76] + 0.002821869488535841 * sp[75] + -0.01128747795414457 * sp[76] + 0.002821869488536174 * sp[78] + 0.002821869488536187 * sp[79];
    A[617] = 0.01693121693121643 * sp[74] + -0.00282186948853606 * sp[75] + 0.01693121693121629 * sp[76] + -0.002821869488535595 * sp[75] + -0.002821869488536416 * sp[78] + 0.01693121693121685 * sp[76] + -0.002821869488536039 * sp[78] + 0.01693121693121681 * sp[79];
    A[618] = 0.08465608465608526 * sp[74] + 0.04232804232804251 * sp[75] + 0.08465608465608437 * sp[76] + 0.04232804232804184 * sp[75] + 0.02257495590828992 * sp[77] + 0.04232804232804192 * sp[78] + 0.08465608465608442 * sp[76] + 0.04232804232804243 * sp[78] + 0.084656084656084 * sp[79];
    A[619] = 0.01693121693121703 * sp[74] + -0.002821869488536092 * sp[75] + 0.0169312169312177 * sp[76] + -0.002821869488535904 * sp[75] + -0.002821869488535439 * sp[78] + 0.0169312169312171 * sp[76] + -0.002821869488536103 * sp[78] + 0.01693121693121757 * sp[79];
    A[620] = 0.1185185185185185 * sp[74] + 0.1608465608465606 * sp[75] + 0.06772486772486731 * sp[76] + 0.02539682539682553 * sp[75] + -0.01693121693121761 * sp[77] + 0.1608465608465603 * sp[78] + 0.1185185185185187 * sp[76] + 0.1608465608465606 * sp[78] + 0.06772486772486719 * sp[79];
    A[621] = -0.08465608465608529 * sp[74] + -0.1777777777777776 * sp[75] + -0.2708994708994709 * sp[76] + -0.04232804232804185 * sp[75] + -0.01693121693121589 * sp[77] + -0.1777777777777778 * sp[78] + -0.08465608465608447 * sp[76] + -0.1777777777777771 * sp[78] + -0.270899470899471 * sp[79];
    A[622] = -0.01693121693121695 * sp[74] + 0.002821869488535795 * sp[75] + 0.06772486772486751 * sp[76] + 0.002821869488535928 * sp[75] + 0.005643738977071959 * sp[77] + 0.002821869488536079 * sp[78] + -0.01693121693121702 * sp[76] + 0.002821869488535729 * sp[78] + 0.06772486772486754 * sp[79];
    A[623] = 0.02257495590828941 * sp[74] + -0.01975308641975286 * sp[75] + 0.02257495590828947 * sp[76] + -0.01975308641975332 * sp[75] + 0.02257495590828986 * sp[77] + -0.01975308641975301 * sp[78] + 0.02257495590828941 * sp[76] + -0.01975308641975269 * sp[78] + 0.02257495590828947 * sp[79];
    A[624] = 0.02257495590828922 * sp[74] + 0.002821869488535965 * sp[75] + 0.02257495590828964 * sp[76] + 0.00282186948853647 * sp[75] + 0.002821869488536161 * sp[78] + 0.02257495590828926 * sp[76] + 0.002821869488535947 * sp[78] + 0.02257495590828962 * sp[79];
    A[625] = 0.02257495590828896 * sp[74] + 0.002821869488536157 * sp[75] + 0.02257495590828891 * sp[76] + 0.00282186948853596 * sp[75] + 0.002821869488535887 * sp[78] + 0.02257495590828897 * sp[76] + 0.002821869488536171 * sp[78] + 0.02257495590828887 * sp[79];
    A[626] = 0.06772486772486655 * sp[74] + 0.1608465608465601 * sp[75] + 0.1185185185185179 * sp[76] + 0.1608465608465601 * sp[75] + -0.01693121693121753 * sp[77] + 0.02539682539682529 * sp[78] + 0.06772486772486654 * sp[76] + 0.1608465608465602 * sp[78] + 0.1185185185185182 * sp[79];
    A[627] = 0.06772486772486762 * sp[74] + 0.002821869488536863 * sp[75] + -0.0169312169312166 * sp[76] + 0.002821869488536661 * sp[75] + 0.00564373897707203 * sp[77] + 0.002821869488536028 * sp[78] + 0.06772486772486762 * sp[76] + 0.002821869488536349 * sp[78] + -0.01693121693121711 * sp[79];
    A[628] = -0.270899470899469 * sp[74] + -0.177777777777777 * sp[75] + -0.08465608465608401 * sp[76] + -0.1777777777777773 * sp[75] + -0.01693121693121578 * sp[77] + -0.04232804232804188 * sp[78] + -0.2708994708994695 * sp[76] + -0.1777777777777767 * sp[78] + -0.08465608465608362 * sp[79];
    A[629] = -0.1354497354497349 * sp[74] + -0.02257495590828957 * sp[75] + -0.1354497354497358 * sp[76] + -0.02257495590828983 * sp[75] + -0.04514991181657966 * sp[77] + -0.02257495590828963 * sp[78] + -0.1354497354497354 * sp[76] + -0.02257495590828965 * sp[78] + -0.135449735449736 * sp[79];
    A[630] = -0.007760141093474413 * sp[74] + -0.007760141093474391 * sp[75] + -0.007760141093474414 * sp[76] + -0.02539682539682541 * sp[75] + -0.0253968253968254 * sp[77] + -0.0253968253968254 * sp[78] + -0.007760141093474392 * sp[76] + -0.007760141093474369 * sp[78] + -0.007760141093474393 * sp[79];
    A[631] = 0.007760141093474576 * sp[74] + 0.007760141093474567 * sp[76];
    A[632] = -0.04585537918871272 * sp[75] + -0.07054673721340425 * sp[77] + -0.04585537918871267 * sp[78];
    A[633] = 0.007760141093474524 * sp[76] + 0.0077601410934745 * sp[79];
    A[634] = -0.07901234567901264 * sp[75] + -0.1580246913580249 * sp[76] + 0.02257495590828956 * sp[77] + -0.07901234567901255 * sp[78] + -0.07901234567901225 * sp[78] + -0.1580246913580245 * sp[79];
    A[635] = 0.03104056437389777 * sp[75] + 0.09029982363315719 * sp[76] + -0.01128747795414473 * sp[77] + 0.03104056437389795 * sp[78] + 0.03104056437389779 * sp[78] + 0.09029982363315719 * sp[79];
    A[636] = -0.01128747795414456 * sp[75] + -0.04514991181657846 * sp[76] + -0.01128747795414469 * sp[78] + -0.01128747795414454 * sp[78] + -0.04514991181657838 * sp[79];
    A[637] = -0.01128747795414449 * sp[74] + -0.01128747795414444 * sp[76] + -0.0112874779541444 * sp[76] + -0.01128747795414432 * sp[79];
    A[638] = -0.002821869488536432 * sp[74] + -0.002821869488536665 * sp[76] + -0.002821869488536431 * sp[76] + -0.002821869488536678 * sp[79];
    A[639] = -0.01128747795414456 * sp[74] + -0.01128747795414447 * sp[76] + -0.01128747795414454 * sp[76] + -0.01128747795414445 * sp[79];
    A[640] = -0.04514991181657887 * sp[74] + -0.01128747795414482 * sp[75] + -0.01128747795414454 * sp[75] + -0.04514991181657876 * sp[76] + -0.0112874779541447 * sp[78];
    A[641] = 0.09029982363315817 * sp[74] + 0.03104056437389817 * sp[75] + 0.03104056437389796 * sp[75] + -0.01128747795414504 * sp[77] + 0.09029982363315792 * sp[76] + 0.03104056437389788 * sp[78];
    A[642] = -0.1580246913580263 * sp[74] + -0.07901234567901311 * sp[75] + -0.07901234567901286 * sp[75] + 0.02257495590828956 * sp[77] + -0.1580246913580258 * sp[76] + -0.0790123456790127 * sp[78];
    A[643] = 0.01128747795414469 * sp[74] + 0.01128747795414452 * sp[75] + -0.02257495590828933 * sp[75] + -0.02257495590828928 * sp[77] + 0.01128747795414449 * sp[78] + 0.01128747795414458 * sp[76] + 0.01128747795414441 * sp[78];
    A[644] = 0.002821869488536068 * sp[74] + 0.00282186948853608 * sp[75] + -0.01128747795414477 * sp[75] + -0.01128747795414475 * sp[77] + 0.002821869488536104 * sp[78] + 0.002821869488536134 * sp[76] + 0.002821869488536144 * sp[78];
    A[645] = 0.01128747795414453 * sp[74] + 0.01128747795414457 * sp[75] + 0.0112874779541446 * sp[78] + 0.01128747795414452 * sp[76] + 0.01128747795414455 * sp[78];
    A[646] = 0.04514991181657877 * sp[74] + 0.03386243386243371 * sp[75] + 0.04514991181657849 * sp[76] + 0.07901234567901233 * sp[75] + 0.1128747795414462 * sp[77] + 0.07901234567901229 * sp[78] + 0.04514991181657858 * sp[76] + 0.03386243386243364 * sp[78] + 0.0451499118165783 * sp[79];
    A[647] = -0.09029982363315774 * sp[74] + -0.05925925925925921 * sp[75] + -0.09029982363315721 * sp[76] + -0.1326278659611997 * sp[75] + -0.2201058201058204 * sp[77] + -0.1326278659611996 * sp[78] + -0.09029982363315756 * sp[76] + -0.05925925925925914 * sp[78] + -0.09029982363315706 * sp[79];
    A[648] = 0.1580246913580264 * sp[74] + 0.07901234567901286 * sp[75] + 0.1580246913580259 * sp[76] + 0.07901234567901286 * sp[75] + 0.2031746031746038 * sp[77] + 0.07901234567901282 * sp[78] + 0.1580246913580259 * sp[76] + 0.07901234567901282 * sp[78] + 0.1580246913580255 * sp[79];
    A[649] = 0.01128747795414454 * sp[75] + 0.01128747795414439 * sp[76] + 0.01128747795414461 * sp[75] + -0.02257495590828936 * sp[77] + -0.0225749559082894 * sp[78] + 0.01128747795414444 * sp[78] + 0.01128747795414429 * sp[79];
    A[650] = 0.002821869488536289 * sp[75] + 0.002821869488536134 * sp[76] + 0.002821869488536156 * sp[75] + -0.01128747795414449 * sp[77] + -0.01128747795414455 * sp[78] + 0.002821869488536236 * sp[78] + 0.002821869488536083 * sp[79];
    A[651] = 0.01128747795414476 * sp[75] + 0.01128747795414447 * sp[76] + 0.01128747795414466 * sp[75] + 0.01128747795414463 * sp[78] + 0.01128747795414435 * sp[79];
    A[652] = 0.02257495590828958 * sp[74] + -0.0112874779541449 * sp[75] + 0.02257495590828966 * sp[76] + -0.01128747795414517 * sp[75] + -0.01128747795414463 * sp[78] + 0.02257495590828941 * sp[76] + -0.01128747795414481 * sp[78] + 0.02257495590828945 * sp[79];
    A[653] = -0.1128747795414473 * sp[74] + -0.01128747795414497 * sp[75] + -0.1128747795414475 * sp[76] + -0.01128747795414466 * sp[75] + -0.04514991181657949 * sp[77] + -0.01128747795414493 * sp[78] + -0.1128747795414466 * sp[76] + -0.01128747795414472 * sp[78] + -0.112874779541447 * sp[79];
    A[654] = 0.0225749559082893 * sp[74] + -0.01128747795414486 * sp[75] + 0.02257495590828907 * sp[76] + -0.01128747795414489 * sp[75] + -0.01128747795414514 * sp[78] + 0.02257495590828933 * sp[76] + -0.01128747795414485 * sp[78] + 0.02257495590828917 * sp[79];
    A[655] = -0.02257495590828992 * sp[74] + -0.03386243386243405 * sp[75] + 0.01128747795414444 * sp[75] + 0.06772486772486785 * sp[77] + -0.03386243386243368 * sp[78] + -0.02257495590828984 * sp[76] + -0.03386243386243389 * sp[78];
    A[656] = 0.1128747795414473 * sp[74] + 0.1015873015873024 * sp[75] + 0.01128747795414467 * sp[75] + -0.06772486772486806 * sp[77] + 0.1015873015873022 * sp[78] + 0.1128747795414466 * sp[76] + 0.1015873015873019 * sp[78];
    A[657] = -0.02257495590828933 * sp[74] + -0.03386243386243375 * sp[75] + 0.01128747795414488 * sp[75] + 0.02257495590828953 * sp[77] + -0.03386243386243377 * sp[78] + -0.02257495590828937 * sp[76] + -0.03386243386243384 * sp[78];
    A[658] = 0.01128747795414424 * sp[75] + 0.01128747795414489 * sp[75] + -0.04514991181657858 * sp[77] + 0.01128747795414486 * sp[78] + 0.01128747795414414 * sp[78];
    A[659] = 0.01128747795414504 * sp[75] + 0.01128747795414394 * sp[75] + 0.01128747795414446 * sp[78] + 0.01128747795414495 * sp[78];
    A[660] = 0.01128747795414473 * sp[75] + 0.01128747795414459 * sp[75] + 0.01128747795414457 * sp[78] + 0.01128747795414472 * sp[78];
    A[661] = -0.03386243386243392 * sp[75] + -0.02257495590828962 * sp[76] + -0.03386243386243345 * sp[75] + 0.06772486772486792 * sp[77] + 0.01128747795414456 * sp[78] + -0.03386243386243377 * sp[78] + -0.02257495590828967 * sp[79];
    A[662] = -0.03386243386243436 * sp[75] + -0.02257495590828919 * sp[76] + -0.03386243386243441 * sp[75] + 0.02257495590828972 * sp[77] + 0.01128747795414484 * sp[78] + -0.03386243386243402 * sp[78] + -0.02257495590828898 * sp[79];
    A[663] = 0.1015873015873022 * sp[75] + 0.1128747795414473 * sp[76] + 0.1015873015873019 * sp[75] + -0.06772486772486827 * sp[77] + 0.01128747795414485 * sp[78] + 0.1015873015873017 * sp[78] + 0.1128747795414467 * sp[79];
    A[664] = 0.09029982363315793 * sp[77];
    A[665] = -0.07054673721340421 * sp[74] + -0.07054673721340425 * sp[75] + -0.07054673721340422 * sp[76] + -0.02469135802469108 * sp[75] + -0.02469135802469116 * sp[77] + -0.02469135802469117 * sp[78] + -0.02469135802469106 * sp[76] + -0.02469135802469114 * sp[78] + -0.02469135802469115 * sp[79];
    A[666] = -0.02539682539682534 * sp[74] + -0.01763668430335084 * sp[75] + -0.01763668430335084 * sp[76];
    A[667] = 0.007760141093474551 * sp[77] + 0.007760141093474593 * sp[78];
    A[668] = 0.007760141093474481 * sp[78] + 0.007760141093474458 * sp[79];
    A[669] = -0.0112874779541446 * sp[77] + -0.01128747795414449 * sp[78] + -0.01128747795414451 * sp[78] + -0.01128747795414435 * sp[79];
    A[670] = -0.002821869488536377 * sp[77] + -0.002821869488536258 * sp[78] + -0.002821869488536395 * sp[78] + -0.002821869488536326 * sp[79];
    A[671] = -0.01128747795414449 * sp[77] + -0.01128747795414465 * sp[78] + -0.0112874779541445 * sp[78] + -0.01128747795414459 * sp[79];
    A[672] = -0.02257495590828864 * sp[74] + -0.03386243386243327 * sp[76] + -0.03386243386243338 * sp[75] + -0.04514991181657806 * sp[78] + -0.03386243386243337 * sp[76] + -0.04514991181657806 * sp[79];
    A[673] = -0.0112874779541445 * sp[74] + -0.01410934744268066 * sp[76] + -0.0141093474426807 * sp[75] + -0.0169312169312169 * sp[78] + -0.01410934744268071 * sp[76] + -0.01693121693121687 * sp[79];
    A[674] = -0.01128747795414457 * sp[76] + -0.01128747795414447 * sp[75] + -0.02257495590828895 * sp[78] + -0.01128747795414448 * sp[76] + -0.02257495590828896 * sp[79];
    A[675] = -0.02257495590828867 * sp[74] + -0.03386243386243327 * sp[75] + -0.03386243386243355 * sp[75] + -0.04514991181657841 * sp[77] + -0.03386243386243354 * sp[76] + -0.04514991181657842 * sp[78];
    A[676] = -0.01128747795414443 * sp[74] + -0.0141093474426806 * sp[75] + -0.01410934744268056 * sp[75] + -0.0169312169312163 * sp[77] + -0.01410934744268055 * sp[76] + -0.0169312169312163 * sp[78];
    A[677] = -0.0112874779541445 * sp[75] + -0.01128747795414454 * sp[75] + -0.02257495590828947 * sp[77] + -0.01128747795414439 * sp[76] + -0.02257495590828935 * sp[78];
    A[678] = 0.02257495590828868 * sp[74] + 0.02257495590828877 * sp[75] + 0.1015873015873023 * sp[76] + 0.1015873015873015 * sp[75] + 0.1015873015873014 * sp[77] + 0.02257495590828917 * sp[78] + 0.1015873015873016 * sp[76] + 0.1015873015873015 * sp[78] + 0.02257495590828919 * sp[79];
    A[679] = -0.01128747795414463 * sp[74] + -0.01128747795414464 * sp[75] + -0.04232804232804293 * sp[76] + -0.04232804232804228 * sp[75] + -0.0423280423280423 * sp[77] + 0.01693121693121676 * sp[78] + -0.04232804232804221 * sp[76] + -0.04232804232804225 * sp[78] + 0.0169312169312167 * sp[79];
    A[680] = 0.01128747795414477 * sp[76] + 0.0112874779541445 * sp[75] + 0.01128747795414455 * sp[77] + -0.02257495590828906 * sp[78] + 0.01128747795414451 * sp[76] + 0.01128747795414456 * sp[78] + -0.02257495590828905 * sp[79];
    A[681] = 0.02257495590828857 * sp[74] + 0.1015873015873023 * sp[75] + 0.02257495590828863 * sp[76] + 0.1015873015873013 * sp[75] + 0.02257495590828888 * sp[77] + 0.1015873015873012 * sp[78] + 0.1015873015873013 * sp[76] + 0.02257495590828885 * sp[78] + 0.1015873015873012 * sp[79];
    A[682] = -0.01128747795414418 * sp[74] + -0.04232804232804278 * sp[75] + -0.01128747795414425 * sp[76] + -0.04232804232804213 * sp[75] + 0.01693121693121706 * sp[77] + -0.04232804232804211 * sp[78] + -0.0423280423280421 * sp[76] + 0.01693121693121709 * sp[78] + -0.04232804232804208 * sp[79];
    A[683] = 0.01128747795414461 * sp[75] + 0.01128747795414454 * sp[75] + -0.02257495590828936 * sp[77] + 0.01128747795414444 * sp[78] + 0.01128747795414439 * sp[76] + -0.0225749559082894 * sp[78] + 0.01128747795414429 * sp[79];
    A[684] = 0.2031746031746036 * sp[74] + 0.1241622574955902 * sp[75] + 0.1241622574955902 * sp[76] + 0.1241622574955902 * sp[75] + 0.2031746031746027 * sp[77] + 0.2031746031746028 * sp[78] + 0.1241622574955902 * sp[76] + 0.2031746031746028 * sp[78] + 0.2031746031746027 * sp[79];
    A[685] = -0.2201058201058201 * sp[74] + -0.08747795414461994 * sp[75] + -0.08747795414461991 * sp[76] + -0.1608465608465601 * sp[75] + -0.1185185185185176 * sp[77] + -0.1185185185185175 * sp[78] + -0.16084656084656 * sp[76] + -0.1185185185185176 * sp[78] + -0.1185185185185175 * sp[79];
    A[686] = 0.1128747795414461 * sp[74] + 0.03386243386243343 * sp[75] + 0.03386243386243348 * sp[76] + 0.07901234567901193 * sp[75] + 0.0451499118165783 * sp[77] + 0.04514991181657833 * sp[78] + 0.07901234567901189 * sp[76] + 0.04514991181657831 * sp[78] + 0.04514991181657833 * sp[79];
    A[687] = -0.04514991181657789 * sp[74] + -0.05643738977072191 * sp[75] + -0.05643738977072195 * sp[76] + -0.05643738977072214 * sp[75] + -0.06772486772486674 * sp[77] + -0.06772486772486659 * sp[78] + -0.05643738977072209 * sp[76] + -0.0677248677248667 * sp[78] + -0.06772486772486659 * sp[79];
    A[688] = -0.01128747795414499 * sp[75] + -0.01128747795414458 * sp[76] + -0.01128747795414489 * sp[75] + -0.02257495590828926 * sp[77] + -0.02257495590828918 * sp[78] + -0.0112874779541446 * sp[76] + -0.02257495590828904 * sp[78] + -0.02257495590828883 * sp[79];
    A[689] = -0.01128747795414453 * sp[75] + -0.01128747795414476 * sp[76] + -0.01128747795414454 * sp[75] + -0.02257495590828892 * sp[77] + -0.02257495590828924 * sp[78] + -0.01128747795414466 * sp[76] + -0.02257495590828902 * sp[78] + -0.02257495590828939 * sp[79];
    A[690] = -0.04514991181657907 * sp[74] + -0.03386243386243358 * sp[75] + -0.03386243386243369 * sp[76] + -0.03386243386243412 * sp[75] + -0.1354497354497358 * sp[77] + -0.1354497354497354 * sp[78] + -0.03386243386243388 * sp[76] + -0.1354497354497358 * sp[78] + -0.1354497354497354 * sp[79];
    A[691] = 0.01128747795414476 * sp[75] + 0.01128747795414439 * sp[76] + 0.01128747795414487 * sp[75] + 0.04514991181657906 * sp[77] + 0.04514991181657858 * sp[78] + 0.01128747795414458 * sp[76] + 0.04514991181657892 * sp[78] + 0.04514991181657862 * sp[79];
    A[692] = 0.01128747795414477 * sp[75] + 0.01128747795414503 * sp[76] + 0.01128747795414449 * sp[75] + 0.04514991181657871 * sp[77] + 0.04514991181657861 * sp[78] + 0.01128747795414462 * sp[76] + 0.04514991181657865 * sp[78] + 0.04514991181657851 * sp[79];
    A[693] = -0.06772486772486662 * sp[74] + -0.07901234567901239 * sp[75] + -0.1693121693121689 * sp[76] + -0.1693121693121689 * sp[75] + -0.06772486772486727 * sp[77] + -0.2708994708994707 * sp[78] + -0.169312169312169 * sp[76] + -0.06772486772486701 * sp[78] + -0.2708994708994705 * sp[79];
    A[694] = 0.06772486772486659 * sp[74] + 0.0564373897707218 * sp[75] + 0.1015873015873005 * sp[76] + 0.1015873015873009 * sp[75] + 0.06772486772486667 * sp[77] + 0.1354497354497341 * sp[78] + 0.1015873015873008 * sp[76] + 0.06772486772486665 * sp[78] + 0.135449735449734 * sp[79];
    A[695] = 0.0225749559082891 * sp[74] + 0.01128747795414449 * sp[75] + 0.05643738977072359 * sp[76] + 0.05643738977072293 * sp[75] + 0.02257495590828876 * sp[77] + 0.09029982363315721 * sp[78] + 0.05643738977072288 * sp[76] + 0.02257495590828886 * sp[78] + 0.0902998236331571 * sp[79];
    A[696] = -0.06772486772486645 * sp[74] + -0.1693121693121686 * sp[75] + -0.0790123456790119 * sp[76] + -0.1693121693121687 * sp[75] + -0.2708994708994705 * sp[77] + -0.06772486772486722 * sp[78] + -0.1693121693121687 * sp[76] + -0.2708994708994706 * sp[78] + -0.0677248677248671 * sp[79];
    A[697] = 0.06772486772486655 * sp[74] + 0.1015873015873005 * sp[75] + 0.05643738977072179 * sp[76] + 0.1015873015873009 * sp[75] + 0.1354497354497343 * sp[77] + 0.06772486772486672 * sp[78] + 0.101587301587301 * sp[76] + 0.1354497354497343 * sp[78] + 0.06772486772486669 * sp[79];
    A[698] = 0.02257495590828858 * sp[74] + 0.05643738977072318 * sp[75] + 0.01128747795414456 * sp[76] + 0.05643738977072267 * sp[75] + 0.09029982363315717 * sp[77] + 0.02257495590828903 * sp[78] + 0.05643738977072262 * sp[76] + 0.09029982363315701 * sp[78] + 0.02257495590828867 * sp[79];
    A[699] = 0.09029982363315697 * sp[74] + 0.09029982363315747 * sp[75] + 0.09029982363315681 * sp[76] + 0.09029982363315632 * sp[75] + 0.0902998236331566 * sp[77] + 0.09029982363315658 * sp[78] + 0.09029982363315603 * sp[76] + 0.09029982363315613 * sp[78] + 0.0902998236331566 * sp[79];
    A[700] = 0.05291005291005305 * sp[74] + 0.05291005291005312 * sp[75] + 0.05291005291005309 * sp[76] + 0.02028218694885335 * sp[75] + 0.02028218694885327 * sp[77] + 0.02028218694885335 * sp[78] + 0.02028218694885336 * sp[76] + 0.02028218694885328 * sp[78] + 0.02028218694885336 * sp[79];
    A[701] = 0.05291005291005282 * sp[74] + 0.03262786596119917 * sp[75] + 0.03262786596119916 * sp[76];
    A[702] = 0.005114638447971775 * sp[77] + 0.00511463844797183 * sp[78];
    A[703] = 0.0051146384479718 * sp[78] + 0.005114638447971769 * sp[79];
    A[704] = -0.002821869488536108 * sp[77] + -0.002821869488536282 * sp[78] + -0.002821869488536035 * sp[78] + -0.002821869488536129 * sp[79];
    A[705] = -0.009171075837742498 * sp[77] + -0.009171075837742196 * sp[78] + -0.00917107583774252 * sp[78] + -0.0091710758377423 * sp[79];
    A[706] = -0.002821869488536133 * sp[77] + -0.002821869488536249 * sp[78] + -0.002821869488536125 * sp[78] + -0.00282186948853615 * sp[79];
    A[707] = 0.01693121693121588 * sp[74] + 0.05925925925925826 * sp[76] + 0.0592592592592587 * sp[75] + 0.09029982363315636 * sp[78] + 0.05925925925925862 * sp[76] + 0.09029982363315632 * sp[79];
    A[708] = -0.002821869488536056 * sp[74] + 0.01058201058201053 * sp[76] + 0.01058201058201052 * sp[75] + 0.02116402116402104 * sp[78] + 0.01058201058201049 * sp[76] + 0.02116402116402094 * sp[79];
    A[709] = -0.002821869488536239 * sp[76] + -0.002821869488536096 * sp[75] + -0.01693121693121688 * sp[78] + -0.002821869488536089 * sp[76] + -0.01693121693121684 * sp[79];
    A[710] = 0.01693121693121586 * sp[74] + 0.05925925925925826 * sp[75] + 0.05925925925925856 * sp[75] + 0.09029982363315664 * sp[77] + 0.0592592592592586 * sp[76] + 0.09029982363315664 * sp[78];
    A[711] = -0.002821869488535942 * sp[74] + 0.0105820105820106 * sp[75] + 0.01058201058201078 * sp[75] + 0.0211640211640208 * sp[77] + 0.01058201058201076 * sp[76] + 0.02116402116402086 * sp[78];
    A[712] = -0.002821869488536152 * sp[75] + -0.002821869488536289 * sp[75] + -0.01693121693121694 * sp[77] + -0.002821869488536135 * sp[76] + -0.01693121693121686 * sp[78];
    A[713] = 0.01693121693121746 * sp[74] + 0.01693121693121741 * sp[75] + -0.04232804232804278 * sp[76] + -0.04232804232804209 * sp[75] + -0.04232804232804217 * sp[77] + -0.01128747795414439 * sp[78] + -0.04232804232804203 * sp[76] + -0.04232804232804209 * sp[78] + -0.01128747795414438 * sp[79];
    A[714] = -0.002821869488536189 * sp[74] + -0.0028218694885362 * sp[75] + -0.0134038800705463 * sp[76] + -0.01340388007054681 * sp[75] + -0.01340388007054682 * sp[77] + -0.002821869488536138 * sp[78] + -0.01340388007054679 * sp[76] + -0.01340388007054681 * sp[78] + -0.002821869488536138 * sp[79];
    A[715] = 0.002821869488536092 * sp[76] + 0.002821869488536108 * sp[75] + 0.002821869488536104 * sp[77] + -0.0112874779541445 * sp[78] + 0.002821869488536099 * sp[76] + 0.002821869488536095 * sp[78] + -0.01128747795414449 * sp[79];
    A[716] = 0.01693121693121757 * sp[74] + -0.04232804232804268 * sp[75] + 0.01693121693121752 * sp[76] + -0.04232804232804205 * sp[75] + -0.01128747795414401 * sp[77] + -0.04232804232804206 * sp[78] + -0.04232804232804204 * sp[76] + -0.01128747795414407 * sp[78] + -0.04232804232804207 * sp[79];
    A[717] = -0.002821869488536249 * sp[74] + -0.01340388007054626 * sp[75] + -0.002821869488536178 * sp[76] + -0.01340388007054686 * sp[75] + -0.002821869488536125 * sp[77] + -0.01340388007054685 * sp[78] + -0.0134038800705469 * sp[76] + -0.00282186948853609 * sp[78] + -0.01340388007054688 * sp[79];
    A[718] = 0.002821869488536156 * sp[75] + 0.002821869488536289 * sp[75] + -0.01128747795414449 * sp[77] + 0.002821869488536236 * sp[78] + 0.002821869488536134 * sp[76] + -0.01128747795414455 * sp[78] + 0.002821869488536083 * sp[79];
    A[719] = -0.2201058201058201 * sp[74] + -0.1608465608465601 * sp[75] + -0.16084656084656 * sp[76] + -0.08747795414461994 * sp[75] + -0.1185185185185176 * sp[77] + -0.1185185185185176 * sp[78] + -0.08747795414461991 * sp[76] + -0.1185185185185175 * sp[78] + -0.1185185185185175 * sp[79];
    A[720] = 0.334391534391534 * sp[74] + 0.1671957671957661 * sp[75] + 0.167195767195766 * sp[76] + 0.1671957671957661 * sp[75] + 0.2497354497354491 * sp[77] + 0.249735449735449 * sp[78] + 0.167195767195766 * sp[76] + 0.249735449735449 * sp[78] + 0.249735449735449 * sp[79];
    A[721] = -0.2201058201058198 * sp[74] + -0.05925925925925839 * sp[75] + -0.05925925925925846 * sp[76] + -0.1326278659611988 * sp[75] + -0.09029982363315661 * sp[77] + -0.09029982363315665 * sp[78] + -0.1326278659611988 * sp[76] + -0.09029982363315657 * sp[78] + -0.09029982363315661 * sp[79];
    A[722] = 0.02257495590828861 * sp[74] + 0.04232804232804055 * sp[75] + 0.04232804232804066 * sp[76] + 0.04232804232804181 * sp[75] + 0.08465608465608353 * sp[77] + 0.08465608465608372 * sp[78] + 0.04232804232804174 * sp[76] + 0.08465608465608333 * sp[78] + 0.08465608465608372 * sp[79];
    A[723] = -0.002821869488535706 * sp[75] + -0.002821869488535759 * sp[76] + -0.002821869488535894 * sp[75] + 0.01693121693121726 * sp[77] + 0.01693121693121722 * sp[78] + -0.002821869488535618 * sp[76] + 0.0169312169312175 * sp[78] + 0.0169312169312176 * sp[79];
    A[724] = -0.002821869488536084 * sp[75] + -0.002821869488535977 * sp[76] + -0.002821869488535941 * sp[75] + 0.01693121693121714 * sp[77] + 0.01693121693121697 * sp[78] + -0.002821869488536003 * sp[76] + 0.01693121693121707 * sp[78] + 0.01693121693121682 * sp[79];
    A[725] = 0.0225749559082899 * sp[74] + -0.01975308641975325 * sp[75] + -0.01975308641975346 * sp[76] + -0.01975308641975295 * sp[75] + 0.02257495590828918 * sp[77] + 0.02257495590828926 * sp[78] + -0.01975308641975297 * sp[76] + 0.02257495590828906 * sp[78] + 0.02257495590828923 * sp[79];
    A[726] = 0.00282186948853587 * sp[75] + 0.002821869488536133 * sp[76] + 0.002821869488535945 * sp[75] + 0.02257495590828903 * sp[77] + 0.02257495590828914 * sp[78] + 0.002821869488535669 * sp[76] + 0.02257495590828903 * sp[78] + 0.02257495590828927 * sp[79];
    A[727] = 0.002821869488536048 * sp[75] + 0.002821869488535998 * sp[76] + 0.002821869488535946 * sp[75] + 0.02257495590828923 * sp[77] + 0.02257495590828892 * sp[78] + 0.002821869488536008 * sp[76] + 0.02257495590828923 * sp[78] + 0.02257495590828886 * sp[79];
    A[728] = -0.01693121693121806 * sp[74] + 0.02539682539682523 * sp[75] + 0.1608465608465602 * sp[76] + 0.1608465608465602 * sp[75] + 0.1185185185185183 * sp[77] + 0.06772486772486655 * sp[78] + 0.1608465608465601 * sp[76] + 0.1185185185185183 * sp[78] + 0.06772486772486648 * sp[79];
    A[729] = -0.0169312169312153 * sp[74] + -0.04232804232804036 * sp[75] + -0.1777777777777769 * sp[76] + -0.1777777777777768 * sp[75] + -0.08465608465608343 * sp[77] + -0.2708994708994705 * sp[78] + -0.1777777777777767 * sp[76] + -0.08465608465608326 * sp[78] + -0.2708994708994703 * sp[79];
    A[730] = 0.005643738977072251 * sp[74] + 0.002821869488536079 * sp[75] + 0.002821869488535775 * sp[76] + 0.002821869488536322 * sp[75] + -0.01693121693121708 * sp[77] + 0.06772486772486765 * sp[78] + 0.002821869488536327 * sp[76] + -0.01693121693121701 * sp[78] + 0.06772486772486762 * sp[79];
    A[731] = -0.01693121693121823 * sp[74] + 0.1608465608465603 * sp[75] + 0.02539682539682511 * sp[76] + 0.1608465608465602 * sp[75] + 0.06772486772486638 * sp[77] + 0.1185185185185182 * sp[78] + 0.1608465608465602 * sp[76] + 0.06772486772486629 * sp[78] + 0.1185185185185182 * sp[79];
    A[732] = -0.01693121693121518 * sp[74] + -0.1777777777777769 * sp[75] + -0.04232804232804046 * sp[76] + -0.1777777777777768 * sp[75] + -0.2708994708994706 * sp[77] + -0.0846560846560836 * sp[78] + -0.1777777777777767 * sp[76] + -0.2708994708994707 * sp[78] + -0.08465608465608357 * sp[79];
    A[733] = 0.005643738977072191 * sp[74] + 0.002821869488535715 * sp[75] + 0.00282186948853582 * sp[76] + 0.002821869488536115 * sp[75] + 0.06772486772486822 * sp[77] + -0.01693121693121705 * sp[78] + 0.002821869488536162 * sp[76] + 0.06772486772486819 * sp[78] + -0.01693121693121742 * sp[79];
    A[734] = -0.04514991181657853 * sp[74] + -0.02257495590828964 * sp[75] + -0.02257495590828919 * sp[76] + -0.02257495590828887 * sp[75] + -0.1354497354497358 * sp[77] + -0.1354497354497354 * sp[78] + -0.02257495590828876 * sp[76] + -0.135449735449736 * sp[78] + -0.1354497354497352 * sp[79];
    A[735] = -0.02539682539682542 * sp[74] + -0.02539682539682546 * sp[75] + -0.02539682539682545 * sp[76] + -0.007760141093474317 * sp[75] + -0.007760141093474243 * sp[77] + -0.007760141093474261 * sp[78] + -0.007760141093474335 * sp[76] + -0.007760141093474261 * sp[78] + -0.007760141093474279 * sp[79];
    A[736] = -0.07054673721340386 * sp[74] + -0.04585537918871249 * sp[75] + -0.04585537918871253 * sp[76];
    A[737] = 0.007760141093474529 * sp[77] + 0.007760141093474605 * sp[78];
    A[738] = 0.007760141093474536 * sp[78] + 0.007760141093474485 * sp[79];
    A[739] = -0.01128747795414477 * sp[77] + -0.01128747795414472 * sp[78] + -0.01128747795414463 * sp[78] + -0.01128747795414445 * sp[79];
    A[740] = -0.00282186948853635 * sp[77] + -0.002821869488536192 * sp[78] + -0.002821869488536384 * sp[78] + -0.00282186948853635 * sp[79];
    A[741] = -0.01128747795414467 * sp[77] + -0.01128747795414488 * sp[78] + -0.01128747795414469 * sp[78] + -0.01128747795414477 * sp[79];
    A[742] = 0.02257495590828986 * sp[74] + -0.07901234567901184 * sp[76] + -0.07901234567901232 * sp[75] + -0.1580246913580249 * sp[78] + -0.07901234567901237 * sp[76] + -0.158024691358025 * sp[79];
    A[743] = -0.01128747795414465 * sp[74] + 0.03104056437389781 * sp[76] + 0.03104056437389797 * sp[75] + 0.09029982363315736 * sp[78] + 0.03104056437389789 * sp[76] + 0.09029982363315724 * sp[79];
    A[744] = -0.01128747795414463 * sp[76] + -0.01128747795414469 * sp[75] + -0.04514991181657849 * sp[78] + -0.0112874779541447 * sp[76] + -0.04514991181657847 * sp[79];
    A[745] = 0.02257495590828997 * sp[74] + -0.0790123456790119 * sp[75] + -0.07901234567901222 * sp[75] + -0.158024691358025 * sp[77] + -0.07901234567901214 * sp[76] + -0.1580246913580251 * sp[78];
    A[746] = -0.01128747795414476 * sp[74] + 0.03104056437389783 * sp[75] + 0.0310405643738977 * sp[75] + 0.09029982363315733 * sp[77] + 0.03104056437389762 * sp[76] + 0.09029982363315731 * sp[78];
    A[747] = -0.01128747795414456 * sp[75] + -0.01128747795414475 * sp[75] + -0.04514991181657867 * sp[77] + -0.01128747795414448 * sp[76] + -0.04514991181657848 * sp[78];
    A[748] = -0.02257495590828957 * sp[74] + -0.02257495590828955 * sp[75] + 0.01128747795414472 * sp[76] + 0.01128747795414454 * sp[75] + 0.01128747795414443 * sp[77] + 0.01128747795414453 * sp[76] + 0.01128747795414443 * sp[78];
    A[749] = -0.0112874779541447 * sp[74] + -0.01128747795414468 * sp[75] + 0.002821869488535898 * sp[76] + 0.002821869488536264 * sp[75] + 0.002821869488536289 * sp[77] + 0.002821869488536287 * sp[76] + 0.002821869488536312 * sp[78];
    A[750] = 0.01128747795414468 * sp[76] + 0.01128747795414466 * sp[75] + 0.01128747795414467 * sp[77] + 0.01128747795414468 * sp[76] + 0.01128747795414469 * sp[78];
    A[751] = -0.02257495590828968 * sp[74] + 0.01128747795414462 * sp[75] + -0.02257495590828964 * sp[76] + 0.01128747795414467 * sp[75] + 0.01128747795414444 * sp[78] + 0.01128747795414457 * sp[76] + 0.01128747795414434 * sp[79];
    A[752] = -0.01128747795414456 * sp[74] + 0.002821869488535841 * sp[75] + -0.01128747795414457 * sp[76] + 0.002821869488536012 * sp[75] + 0.002821869488536174 * sp[78] + 0.002821869488536027 * sp[76] + 0.002821869488536187 * sp[79];
    A[753] = 0.01128747795414466 * sp[75] + 0.01128747795414476 * sp[75] + 0.01128747795414463 * sp[78] + 0.01128747795414447 * sp[76] + 0.01128747795414435 * sp[79];
    A[754] = 0.1128747795414461 * sp[74] + 0.07901234567901193 * sp[75] + 0.07901234567901189 * sp[76] + 0.03386243386243343 * sp[75] + 0.0451499118165783 * sp[77] + 0.04514991181657831 * sp[78] + 0.03386243386243348 * sp[76] + 0.04514991181657833 * sp[78] + 0.04514991181657833 * sp[79];
    A[755] = -0.2201058201058198 * sp[74] + -0.1326278659611988 * sp[75] + -0.1326278659611988 * sp[76] + -0.05925925925925839 * sp[75] + -0.09029982363315661 * sp[77] + -0.09029982363315657 * sp[78] + -0.05925925925925846 * sp[76] + -0.09029982363315665 * sp[78] + -0.09029982363315661 * sp[79];
    A[756] = 0.2031746031746032 * sp[74] + 0.07901234567901194 * sp[75] + 0.07901234567901198 * sp[76] + 0.07901234567901194 * sp[75] + 0.1580246913580251 * sp[77] + 0.1580246913580251 * sp[78] + 0.07901234567901198 * sp[76] + 0.1580246913580251 * sp[78] + 0.1580246913580252 * sp[79];
    A[757] = -0.04514991181657813 * sp[74] + -0.01128747795414353 * sp[75] + -0.01128747795414359 * sp[76] + -0.0112874779541441 * sp[75] + -0.1128747795414459 * sp[77] + -0.112874779541446 * sp[78] + -0.01128747795414426 * sp[76] + -0.1128747795414461 * sp[78] + -0.1128747795414462 * sp[79];
    A[758] = -0.01128747795414507 * sp[75] + -0.01128747795414489 * sp[76] + -0.01128747795414538 * sp[75] + 0.02257495590828872 * sp[77] + 0.02257495590828877 * sp[78] + -0.01128747795414495 * sp[76] + 0.02257495590828898 * sp[78] + 0.02257495590828927 * sp[79];
    A[759] = -0.01128747795414488 * sp[75] + -0.01128747795414499 * sp[76] + -0.01128747795414498 * sp[75] + 0.02257495590828925 * sp[77] + 0.02257495590828894 * sp[78] + -0.01128747795414518 * sp[76] + 0.02257495590828901 * sp[78] + 0.02257495590828863 * sp[79];
    A[760] = -0.04514991181657883 * sp[74] + 0.01128747795414491 * sp[75] + 0.01128747795414494 * sp[76] + 0.01128747795414437 * sp[75] + 0.01128747795414419 * sp[76];
    A[761] = 0.01128747795414454 * sp[75] + 0.01128747795414469 * sp[76] + 0.01128747795414531 * sp[75] + 0.01128747795414488 * sp[76];
    A[762] = 0.01128747795414482 * sp[75] + 0.01128747795414472 * sp[76] + 0.011287477954145 * sp[75] + 0.01128747795414521 * sp[76];
    A[763] = 0.06772486772486837 * sp[74] + 0.01128747795414462 * sp[75] + -0.03386243386243339 * sp[76] + -0.03386243386243354 * sp[75] + -0.02257495590828907 * sp[77] + -0.03386243386243361 * sp[76] + -0.02257495590828927 * sp[78];
    A[764] = -0.06772486772486866 * sp[74] + 0.01128747795414338 * sp[75] + 0.1015873015873015 * sp[76] + 0.1015873015873013 * sp[75] + 0.1128747795414458 * sp[77] + 0.1015873015873014 * sp[76] + 0.112874779541446 * sp[78];
    A[765] = 0.02257495590828933 * sp[74] + 0.01128747795414488 * sp[75] + -0.03386243386243363 * sp[76] + -0.03386243386243423 * sp[75] + -0.02257495590828934 * sp[77] + -0.03386243386243418 * sp[76] + -0.0225749559082891 * sp[78];
    A[766] = 0.06772486772486859 * sp[74] + -0.03386243386243325 * sp[75] + 0.01128747795414486 * sp[76] + -0.03386243386243367 * sp[75] + -0.02257495590828941 * sp[78] + -0.03386243386243371 * sp[76] + -0.02257495590828965 * sp[79];
    A[767] = -0.06772486772486887 * sp[74] + 0.1015873015873014 * sp[75] + 0.01128747795414339 * sp[76] + 0.1015873015873012 * sp[75] + 0.1128747795414458 * sp[78] + 0.1015873015873013 * sp[76] + 0.1128747795414459 * sp[79];
    A[768] = 0.02257495590828933 * sp[74] + -0.03386243386243398 * sp[75] + 0.0112874779541448 * sp[76] + -0.03386243386243369 * sp[75] + -0.02257495590828867 * sp[78] + -0.03386243386243364 * sp[76] + -0.02257495590828918 * sp[79];
    A[769] = 0.09029982363315701 * sp[74];
    A[770] = 0.01834215167548478 * sp[74] + 0.01834215167548505 * sp[75] + 0.01834215167548506 * sp[76] + 0.01834215167548466 * sp[75] + 0.0183421516754847 * sp[77] + 0.01834215167548475 * sp[78] + 0.01834215167548466 * sp[76] + 0.01834215167548478 * sp[78] + 0.01834215167548478 * sp[79];
    A[771] = 0.0493827160493825 * sp[74] + 0.007054673721340087 * sp[75] + 0.007054673721340094 * sp[76];
    A[772] = 0.007054673721340523 * sp[75] + -0.01834215167548512 * sp[77] + 0.007054673721340311 * sp[78];
    A[773] = 0.007054673721340495 * sp[76] + 0.007054673721340339 * sp[78] + -0.01834215167548504 * sp[79];
    A[774] = -0.06772486772486798 * sp[75] + -0.02257495590828934 * sp[76] + 0.02257495590828965 * sp[77] + 0.01128747795414484 * sp[78] + -0.03386243386243383 * sp[78] + -0.02257495590828922 * sp[79];
    A[775] = -0.08465608465608492 * sp[75] + -0.08465608465608471 * sp[76] + -0.01693121693121737 * sp[77] + -0.01975308641975342 * sp[78] + -0.01975308641975351 * sp[78] + -0.0169312169312173 * sp[79];
    A[776] = -0.02257495590828928 * sp[75] + -0.0677248677248677 * sp[76] + -0.02257495590828942 * sp[77] + -0.03386243386243374 * sp[78] + 0.01128747795414475 * sp[78] + 0.02257495590828944 * sp[79];
    A[777] = -0.06772486772486848 * sp[74] + 0.01128747795414344 * sp[76] + 0.2031746031746025 * sp[75] + 0.1128747795414453 * sp[78] + 0.1015873015873015 * sp[76] + 0.1128747795414456 * sp[79];
    A[778] = 0.1185185185185192 * sp[74] + 0.09312169312169455 * sp[76] + 0.05079365079365158 * sp[75] + 0.1862433862433874 * sp[78] + -0.04232804232804199 * sp[76] + -0.08465608465608371 * sp[79];
    A[779] = -0.02257495590828933 * sp[74] + -0.0338624338624345 * sp[76] + -0.02257495590828937 * sp[75] + -0.06772486772486823 * sp[78] + 0.01128747795414472 * sp[76] + 0.06772486772486741 * sp[79];
    A[780] = -0.06772486772486833 * sp[74] + 0.01128747795414373 * sp[75] + 0.1015873015873013 * sp[75] + 0.1128747795414455 * sp[77] + 0.2031746031746028 * sp[76] + 0.1128747795414458 * sp[78];
    A[781] = 0.1185185185185185 * sp[74] + 0.09312169312169316 * sp[75] + -0.04232804232804256 * sp[75] + -0.08465608465608444 * sp[77] + 0.05079365079365098 * sp[76] + 0.1862433862433863 * sp[78];
    A[782] = -0.02257495590828963 * sp[74] + -0.03386243386243417 * sp[75] + 0.01128747795414488 * sp[75] + 0.06772486772486795 * sp[77] + -0.02257495590828967 * sp[76] + -0.06772486772486784 * sp[78];
    A[783] = -0.02257495590828873 * sp[74] + -0.0225749559082891 * sp[75] + -0.0112874779541452 * sp[76] + -0.02257495590828845 * sp[75] + -0.02257495590828861 * sp[77] + -0.01128747795414419 * sp[78] + -0.0112874779541442 * sp[76] + -0.01128747795414442 * sp[78];
    A[784] = 0.01693121693121676 * sp[74] + 0.01693121693121692 * sp[75] + -0.002821869488535238 * sp[76] + 0.0169312169312164 * sp[75] + 0.01693121693121646 * sp[77] + -0.002821869488535769 * sp[78] + -0.002821869488536475 * sp[76] + -0.002821869488536343 * sp[78];
    A[785] = 0.02257495590828941 * sp[74] + 0.02257495590828928 * sp[75] + -0.01128747795414525 * sp[76] + 0.02257495590828945 * sp[75] + 0.02257495590828942 * sp[77] + -0.01128747795414483 * sp[78] + -0.01128747795414467 * sp[76] + -0.01128747795414474 * sp[78];
    A[786] = -0.02257495590828826 * sp[74] + -0.01128747795414465 * sp[75] + -0.02257495590828867 * sp[76] + -0.01128747795414423 * sp[75] + -0.01128747795414416 * sp[78] + -0.02257495590828784 * sp[76] + -0.01128747795414363 * sp[78] + -0.0225749559082881 * sp[79];
    A[787] = 0.01693121693121643 * sp[74] + -0.002821869488535595 * sp[75] + 0.01693121693121685 * sp[76] + -0.00282186948853606 * sp[75] + -0.002821869488536039 * sp[78] + 0.01693121693121629 * sp[76] + -0.002821869488536416 * sp[78] + 0.01693121693121681 * sp[79];
    A[788] = 0.02257495590828958 * sp[74] + -0.01128747795414517 * sp[75] + 0.02257495590828941 * sp[76] + -0.0112874779541449 * sp[75] + -0.01128747795414481 * sp[78] + 0.02257495590828966 * sp[76] + -0.01128747795414463 * sp[78] + 0.02257495590828945 * sp[79];
    A[789] = -0.04514991181657789 * sp[74] + -0.05643738977072214 * sp[75] + -0.05643738977072209 * sp[76] + -0.05643738977072191 * sp[75] + -0.06772486772486674 * sp[77] + -0.0677248677248667 * sp[78] + -0.05643738977072195 * sp[76] + -0.06772486772486659 * sp[78] + -0.06772486772486659 * sp[79];
    A[790] = 0.02257495590828861 * sp[74] + 0.04232804232804181 * sp[75] + 0.04232804232804174 * sp[76] + 0.04232804232804055 * sp[75] + 0.08465608465608353 * sp[77] + 0.08465608465608333 * sp[78] + 0.04232804232804066 * sp[76] + 0.08465608465608372 * sp[78] + 0.08465608465608372 * sp[79];
    A[791] = -0.04514991181657813 * sp[74] + -0.0112874779541441 * sp[75] + -0.01128747795414426 * sp[76] + -0.01128747795414353 * sp[75] + -0.1128747795414459 * sp[77] + -0.1128747795414461 * sp[78] + -0.01128747795414359 * sp[76] + -0.112874779541446 * sp[78] + -0.1128747795414462 * sp[79];
    A[792] = 0.632098765432099 * sp[74] + 0.2708994708994712 * sp[75] + 0.270899470899471 * sp[76] + 0.2708994708994712 * sp[75] + 0.5417989417989427 * sp[77] + 0.2708994708994715 * sp[78] + 0.270899470899471 * sp[76] + 0.2708994708994715 * sp[78] + 0.5417989417989424 * sp[79];
    A[793] = -0.1354497354497372 * sp[74] + 0.2257495590828909 * sp[75] + 0.06772486772486636 * sp[76] + -0.04514991181657911 * sp[75] + -0.1354497354497371 * sp[77] + -0.06772486772486809 * sp[78] + -0.06772486772486898 * sp[76] + 0.06772486772486624 * sp[78];
    A[794] = -0.1354497354497351 * sp[74] + 0.06772486772486888 * sp[75] + 0.2257495590828923 * sp[76] + -0.06772486772486784 * sp[75] + 0.06772486772486765 * sp[78] + -0.04514991181657832 * sp[76] + -0.06772486772486672 * sp[78] + -0.1354497354497354 * sp[79];
    A[795] = 0.0902998236331574 * sp[74] + 0.04514991181657933 * sp[75] + 0.04514991181657897 * sp[76] + 0.04514991181657873 * sp[75] + 0.02257495590828873 * sp[78] + 0.04514991181657863 * sp[76] + 0.02257495590828971 * sp[78];
    A[796] = 0.1354497354497371 * sp[74] + 0.04514991181657788 * sp[75] + 0.0677248677248678 * sp[76] + 0.0451499118165792 * sp[75] + 0.02257495590828964 * sp[78] + 0.06772486772486912 * sp[76] + 0.02257495590828874 * sp[78];
    A[797] = 0.1354497354497354 * sp[74] + 0.06772486772486767 * sp[75] + 0.0451499118165775 * sp[76] + 0.06772486772486788 * sp[75] + 0.02257495590828919 * sp[78] + 0.04514991181657838 * sp[76] + 0.02257495590828963 * sp[78];
    A[798] = 0.04514991181657758 * sp[74] + 0.09029982363315643 * sp[75] + 0.04514991181657675 * sp[76] + 0.0902998236331547 * sp[75] + 0.1354497354497338 * sp[77] + 0.06772486772486493 * sp[78] + 0.04514991181657804 * sp[76] + 0.06772486772486747 * sp[78];
    A[799] = 0.04514991181657955 * sp[74] + -0.2708994708994703 * sp[75] + -0.1354497354497347 * sp[76] + -0.2708994708994686 * sp[75] + -0.5417989417989416 * sp[77] + -0.2708994708994689 * sp[78] + -0.1354497354497353 * sp[76] + -0.270899470899471 * sp[78];
    A[800] = -0.1354497354497358 * sp[74] + -0.06772486772486842 * sp[75] + 0.04514991181657879 * sp[76] + -0.06772486772486783 * sp[75] + 0.06772486772486827 * sp[78] + 0.04514991181657849 * sp[76] + 0.06772486772486712 * sp[78];
    A[801] = 0.04514991181657716 * sp[74] + 0.04514991181657701 * sp[75] + 0.09029982363315628 * sp[76] + 0.04514991181657765 * sp[75] + 0.06772486772486777 * sp[78] + 0.09029982363315464 * sp[76] + 0.06772486772486555 * sp[78] + 0.1354497354497348 * sp[79];
    A[802] = 0.04514991181657946 * sp[74] + -0.1354497354497347 * sp[75] + -0.2708994708994698 * sp[76] + -0.1354497354497347 * sp[75] + -0.2708994708994706 * sp[78] + -0.2708994708994695 * sp[76] + -0.2708994708994696 * sp[78] + -0.5417989417989411 * sp[79];
    A[803] = -0.1354497354497348 * sp[74] + 0.04514991181657903 * sp[75] + -0.06772486772486612 * sp[76] + 0.04514991181657871 * sp[75] + 0.06772486772486802 * sp[78] + -0.06772486772486726 * sp[76] + 0.06772486772486808 * sp[78];
    A[804] = -0.7223985890652561 * sp[74] + -0.3160493827160484 * sp[75] + -0.31604938271605 * sp[76] + -0.3160493827160499 * sp[75] + -0.1354497354497357 * sp[78] + -0.3160493827160497 * sp[76] + -0.1354497354497344 * sp[78];
    A[805] = 0.01834215167548508 * sp[74] + 0.01834215167548502 * sp[75] + 0.01834215167548504 * sp[76] + 0.01834215167548516 * sp[75] + 0.01834215167548521 * sp[77] + 0.01834215167548523 * sp[78] + 0.01834215167548487 * sp[76] + 0.01834215167548495 * sp[78] + 0.01834215167548497 * sp[79];
    A[806] = -0.01834215167548509 * sp[74] + 0.007054673721340401 * sp[75] + 0.007054673721340262 * sp[76];
    A[807] = 0.007054673721340141 * sp[75] + 0.04938271604938285 * sp[77] + 0.007054673721340266 * sp[78];
    A[808] = 0.007054673721340313 * sp[76] + 0.007054673721340388 * sp[78] + -0.01834215167548507 * sp[79];
    A[809] = 0.2031746031746032 * sp[75] + 0.112874779541446 * sp[76] + -0.0677248677248679 * sp[77] + 0.01128747795414481 * sp[78] + 0.101587301587302 * sp[78] + 0.1128747795414457 * sp[79];
    A[810] = 0.05079365079365124 * sp[75] + 0.1862433862433862 * sp[76] + 0.118518518518519 * sp[77] + 0.0931216931216934 * sp[78] + -0.0423280423280423 * sp[78] + -0.08465608465608389 * sp[79];
    A[811] = -0.02257495590828936 * sp[75] + -0.06772486772486817 * sp[76] + -0.02257495590828934 * sp[77] + -0.03386243386243439 * sp[78] + 0.01128747795414469 * sp[78] + 0.06772486772486706 * sp[79];
    A[812] = 0.02257495590828947 * sp[74] + 0.01128747795414495 * sp[76] + -0.06772486772486787 * sp[75] + -0.02257495590828916 * sp[78] + -0.03386243386243382 * sp[76] + -0.0225749559082894 * sp[79];
    A[813] = -0.01693121693121686 * sp[74] + -0.0197530864197531 * sp[76] + -0.08465608465608458 * sp[75] + -0.08465608465608479 * sp[78] + -0.01975308641975278 * sp[76] + -0.01693121693121648 * sp[79];
    A[814] = -0.02257495590828943 * sp[74] + -0.03386243386243396 * sp[76] + -0.02257495590828945 * sp[75] + -0.0677248677248679 * sp[78] + 0.0112874779541446 * sp[76] + 0.02257495590828943 * sp[79];
    A[815] = 0.06772486772486808 * sp[74] + 0.01128747795414526 * sp[75] + -0.03386243386243391 * sp[75] + -0.02257495590828887 * sp[77] + -0.06772486772486715 * sp[76] + -0.02257495590828861 * sp[78];
    A[816] = -0.08465608465608536 * sp[74] + -0.04232804232804314 * sp[75] + 0.09312169312169281 * sp[75] + 0.1185185185185179 * sp[77] + 0.1862433862433849 * sp[76] + 0.05079365079364962 * sp[78];
    A[817] = 0.1128747795414472 * sp[74] + 0.1015873015873025 * sp[75] + 0.01128747795414485 * sp[75] + -0.06772486772486766 * sp[77] + 0.1128747795414475 * sp[76] + 0.2031746031746043 * sp[78];
    A[818] = -0.02257495590828919 * sp[74] + -0.02257495590828909 * sp[75] + -0.01128747795414436 * sp[76] + -0.02257495590828932 * sp[75] + -0.0225749559082895 * sp[77] + -0.01128747795414513 * sp[78] + -0.01128747795414472 * sp[76] + -0.01128747795414472 * sp[78];
    A[819] = 0.01693121693121644 * sp[74] + 0.01693121693121661 * sp[75] + -0.002821869488536418 * sp[76] + 0.01693121693121666 * sp[75] + 0.01693121693121684 * sp[77] + -0.002821869488535911 * sp[78] + -0.002821869488536046 * sp[76] + -0.002821869488535914 * sp[78];
    A[820] = 0.02257495590828943 * sp[74] + 0.02257495590828943 * sp[75] + -0.01128747795414454 * sp[76] + 0.02257495590828947 * sp[75] + 0.02257495590828944 * sp[77] + -0.01128747795414501 * sp[78] + -0.01128747795414456 * sp[76] + -0.01128747795414464 * sp[78];
    A[821] = -0.06772486772486794 * sp[74] + -0.05643738977072277 * sp[75] + -0.0677248677248674 * sp[76] + -0.0564373897707229 * sp[75] + -0.04514991181657879 * sp[77] + -0.05643738977072286 * sp[78] + -0.0677248677248673 * sp[76] + -0.05643738977072267 * sp[78] + -0.06772486772486722 * sp[79];
    A[822] = 0.08465608465608526 * sp[74] + 0.04232804232804184 * sp[75] + 0.08465608465608442 * sp[76] + 0.04232804232804251 * sp[75] + 0.02257495590828992 * sp[77] + 0.04232804232804243 * sp[78] + 0.08465608465608437 * sp[76] + 0.04232804232804192 * sp[78] + 0.084656084656084 * sp[79];
    A[823] = -0.1128747795414473 * sp[74] + -0.01128747795414466 * sp[75] + -0.1128747795414466 * sp[76] + -0.01128747795414497 * sp[75] + -0.04514991181657949 * sp[77] + -0.01128747795414472 * sp[78] + -0.1128747795414475 * sp[76] + -0.01128747795414493 * sp[78] + -0.112874779541447 * sp[79];
    A[824] = -0.01128747795414489 * sp[75] + -0.0112874779541446 * sp[76] + -0.01128747795414499 * sp[75] + -0.02257495590828926 * sp[77] + -0.02257495590828904 * sp[78] + -0.01128747795414458 * sp[76] + -0.02257495590828918 * sp[78] + -0.02257495590828883 * sp[79];
    A[825] = -0.002821869488535894 * sp[75] + -0.002821869488535618 * sp[76] + -0.002821869488535706 * sp[75] + 0.01693121693121726 * sp[77] + 0.0169312169312175 * sp[78] + -0.002821869488535759 * sp[76] + 0.01693121693121722 * sp[78] + 0.0169312169312176 * sp[79];
    A[826] = -0.01128747795414538 * sp[75] + -0.01128747795414495 * sp[76] + -0.01128747795414507 * sp[75] + 0.02257495590828872 * sp[77] + 0.02257495590828898 * sp[78] + -0.01128747795414489 * sp[76] + 0.02257495590828877 * sp[78] + 0.02257495590828927 * sp[79];
    A[827] = -0.1354497354497372 * sp[74] + -0.04514991181657911 * sp[75] + -0.06772486772486898 * sp[76] + 0.2257495590828909 * sp[75] + -0.1354497354497371 * sp[77] + 0.06772486772486624 * sp[78] + 0.06772486772486636 * sp[76] + -0.06772486772486809 * sp[78];
    A[828] = 0.5417989417989442 * sp[74] + 0.2708994708994723 * sp[75] + 0.2708994708994732 * sp[76] + 0.2708994708994723 * sp[75] + 0.6320987654321 * sp[77] + 0.2708994708994717 * sp[78] + 0.2708994708994732 * sp[76] + 0.2708994708994717 * sp[78] + 0.5417989417989439 * sp[79];
    A[829] = -0.06772486772486733 * sp[75] + 0.06772486772486877 * sp[76] + 0.06772486772486883 * sp[75] + -0.135449735449735 * sp[77] + 0.2257495590828935 * sp[78] + -0.06772486772486715 * sp[76] + -0.04514991181657781 * sp[78] + -0.135449735449735 * sp[79];
    A[830] = 0.1354497354497366 * sp[74] + 0.09029982363315708 * sp[75] + 0.06772486772486658 * sp[76] + 0.09029982363315768 * sp[75] + 0.04514991181657893 * sp[77] + 0.04514991181657826 * sp[78] + 0.06772486772486863 * sp[76] + 0.04514991181657879 * sp[78];
    A[831] = -0.5417989417989441 * sp[74] + -0.2708994708994714 * sp[75] + -0.2708994708994708 * sp[76] + -0.2708994708994723 * sp[75] + 0.0451499118165784 * sp[77] + -0.1354497354497365 * sp[78] + -0.2708994708994732 * sp[76] + -0.1354497354497362 * sp[78];
    A[832] = -0.06772486772486798 * sp[75] + 0.06772486772486828 * sp[76] + -0.06772486772486865 * sp[75] + -0.1354497354497358 * sp[77] + 0.04514991181657887 * sp[78] + 0.06772486772486733 * sp[76] + 0.04514991181657804 * sp[78];
    A[833] = 0.04514991181657923 * sp[75] + 0.02257495590828924 * sp[76] + 0.04514991181657982 * sp[75] + 0.09029982363315786 * sp[77] + 0.04514991181657889 * sp[78] + 0.02257495590829011 * sp[76] + 0.04514991181657937 * sp[78];
    A[834] = 0.0451499118165786 * sp[75] + 0.02257495590828928 * sp[76] + 0.04514991181657751 * sp[75] + 0.1354497354497365 * sp[77] + 0.06772486772486781 * sp[78] + 0.02257495590828873 * sp[76] + 0.06772486772486767 * sp[78];
    A[835] = 0.06772486772486758 * sp[75] + 0.02257495590828939 * sp[76] + 0.06772486772486781 * sp[75] + 0.1354497354497353 * sp[77] + 0.04514991181657842 * sp[78] + 0.02257495590828887 * sp[76] + 0.04514991181657815 * sp[78];
    A[836] = 0.04514991181657903 * sp[75] + 0.06772486772486837 * sp[76] + 0.04514991181657818 * sp[75] + 0.04514991181657826 * sp[77] + 0.09029982363315668 * sp[78] + 0.06772486772486687 * sp[76] + 0.09029982363315608 * sp[78] + 0.1354497354497347 * sp[79];
    A[837] = 0.04514991181657917 * sp[75] + 0.06772486772486787 * sp[76] + 0.04514991181657873 * sp[75] + -0.1354497354497346 * sp[77] + -0.06772486772486674 * sp[78] + 0.06772486772486776 * sp[76] + -0.06772486772486701 * sp[78];
    A[838] = -0.1354497354497362 * sp[75] + -0.2708994708994725 * sp[76] + -0.1354497354497354 * sp[75] + 0.04514991181657894 * sp[77] + -0.2708994708994711 * sp[78] + -0.2708994708994696 * sp[76] + -0.2708994708994705 * sp[78] + -0.5417989417989429 * sp[79];
    A[839] = -0.3160493827160505 * sp[75] + -0.1354497354497362 * sp[76] + -0.3160493827160489 * sp[75] + -0.7223985890652566 * sp[77] + -0.3160493827160505 * sp[78] + -0.1354497354497353 * sp[76] + -0.3160493827160504 * sp[78];
    A[840] = 0.01834215167548514 * sp[74] + 0.01834215167548509 * sp[75] + 0.01834215167548504 * sp[76] + 0.01834215167548506 * sp[75] + 0.0183421516754851 * sp[77] + 0.01834215167548509 * sp[78] + 0.01834215167548517 * sp[76] + 0.01834215167548517 * sp[78] + 0.01834215167548519 * sp[79];
    A[841] = -0.01834215167548502 * sp[74] + 0.007054673721340251 * sp[75] + 0.007054673721340351 * sp[76];
    A[842] = 0.007054673721340369 * sp[75] + -0.01834215167548501 * sp[77] + 0.007054673721340538 * sp[78];
    A[843] = 0.007054673721339994 * sp[76] + 0.007054673721340116 * sp[78] + 0.04938271604938246 * sp[79];
    A[844] = -0.06772486772486767 * sp[75] + -0.02257495590828822 * sp[76] + 0.06772486772486778 * sp[77] + 0.01128747795414537 * sp[78] + -0.03386243386243396 * sp[78] + -0.02257495590828816 * sp[79];
    A[845] = 0.1862433862433864 * sp[75] + 0.05079365079364976 * sp[76] + -0.08465608465608469 * sp[77] + -0.0423280423280433 * sp[78] + 0.09312169312169381 * sp[78] + 0.1185185185185179 * sp[79];
    A[846] = 0.1128747795414457 * sp[75] + 0.2031746031746032 * sp[76] + 0.1128747795414461 * sp[77] + 0.1015873015873019 * sp[78] + 0.01128747795414412 * sp[78] + -0.06772486772486758 * sp[79];
    A[847] = 0.06772486772486792 * sp[74] + 0.011287477954145 * sp[76] + -0.0677248677248674 * sp[75] + -0.02257495590828945 * sp[78] + -0.03386243386243389 * sp[76] + -0.02257495590828916 * sp[79];
    A[848] = -0.08465608465608511 * sp[74] + -0.04232804232804269 * sp[76] + 0.1862433862433857 * sp[75] + 0.05079365079365132 * sp[78] + 0.09312169312169273 * sp[76] + 0.1185185185185184 * sp[79];
    A[849] = 0.1128747795414459 * sp[74] + 0.1015873015873015 * sp[76] + 0.1128747795414463 * sp[75] + 0.2031746031746031 * sp[78] + 0.01128747795414427 * sp[76] + -0.06772486772486826 * sp[79];
    A[850] = 0.02257495590828904 * sp[74] + 0.01128747795414475 * sp[75] + -0.03386243386243402 * sp[75] + -0.02257495590828957 * sp[77] + -0.0677248677248679 * sp[76] + -0.02257495590828942 * sp[78];
    A[851] = -0.01693121693121696 * sp[74] + -0.01975308641975319 * sp[75] + -0.01975308641975327 * sp[75] + -0.0169312169312169 * sp[77] + -0.08465608465608485 * sp[76] + -0.08465608465608479 * sp[78];
    A[852] = -0.02257495590828926 * sp[74] + -0.03386243386243391 * sp[75] + 0.0112874779541449 * sp[75] + 0.02257495590828948 * sp[77] + -0.02257495590828913 * sp[76] + -0.0677248677248678 * sp[78];
    A[853] = -0.06772486772486801 * sp[74] + -0.0677248677248678 * sp[75] + -0.05643738977072307 * sp[76] + -0.06772486772486803 * sp[75] + -0.06772486772486798 * sp[77] + -0.05643738977072345 * sp[78] + -0.05643738977072316 * sp[76] + -0.05643738977072324 * sp[78] + -0.04514991181657864 * sp[79];
    A[854] = 0.08465608465608507 * sp[74] + 0.08465608465608472 * sp[75] + 0.04232804232804251 * sp[76] + 0.08465608465608519 * sp[75] + 0.08465608465608494 * sp[77] + 0.04232804232804294 * sp[78] + 0.04232804232804239 * sp[76] + 0.04232804232804226 * sp[78] + 0.02257495590828962 * sp[79];
    A[855] = -0.112874779541446 * sp[74] + -0.1128747795414459 * sp[75] + -0.01128747795414476 * sp[76] + -0.1128747795414463 * sp[75] + -0.1128747795414463 * sp[77] + -0.01128747795414477 * sp[78] + -0.01128747795414427 * sp[76] + -0.01128747795414421 * sp[78] + -0.04514991181657847 * sp[79];
    A[856] = -0.02257495590828915 * sp[74] + -0.01128747795414466 * sp[75] + -0.02257495590828913 * sp[76] + -0.01128747795414464 * sp[75] + -0.01128747795414469 * sp[78] + -0.0225749559082898 * sp[76] + -0.01128747795414519 * sp[78] + -0.02257495590828975 * sp[79];
    A[857] = 0.01693121693121703 * sp[74] + -0.002821869488535904 * sp[75] + 0.0169312169312171 * sp[76] + -0.002821869488536092 * sp[75] + -0.002821869488536103 * sp[78] + 0.0169312169312177 * sp[76] + -0.002821869488535439 * sp[78] + 0.01693121693121757 * sp[79];
    A[858] = 0.0225749559082893 * sp[74] + -0.01128747795414489 * sp[75] + 0.02257495590828933 * sp[76] + -0.01128747795414486 * sp[75] + -0.01128747795414485 * sp[78] + 0.02257495590828907 * sp[76] + -0.01128747795414514 * sp[78] + 0.02257495590828917 * sp[79];
    A[859] = -0.01128747795414454 * sp[75] + -0.01128747795414466 * sp[76] + -0.01128747795414453 * sp[75] + -0.02257495590828892 * sp[77] + -0.02257495590828902 * sp[78] + -0.01128747795414476 * sp[76] + -0.02257495590828924 * sp[78] + -0.02257495590828939 * sp[79];
    A[860] = -0.002821869488535941 * sp[75] + -0.002821869488536003 * sp[76] + -0.002821869488536084 * sp[75] + 0.01693121693121714 * sp[77] + 0.01693121693121707 * sp[78] + -0.002821869488535977 * sp[76] + 0.01693121693121697 * sp[78] + 0.01693121693121682 * sp[79];
    A[861] = -0.01128747795414498 * sp[75] + -0.01128747795414518 * sp[76] + -0.01128747795414488 * sp[75] + 0.02257495590828925 * sp[77] + 0.02257495590828901 * sp[78] + -0.01128747795414499 * sp[76] + 0.02257495590828894 * sp[78] + 0.02257495590828863 * sp[79];
    A[862] = -0.1354497354497351 * sp[74] + -0.06772486772486784 * sp[75] + -0.04514991181657832 * sp[76] + 0.06772486772486888 * sp[75] + -0.06772486772486672 * sp[78] + 0.2257495590828923 * sp[76] + 0.06772486772486765 * sp[78] + -0.1354497354497354 * sp[79];
    A[863] = 0.06772486772486883 * sp[75] + -0.06772486772486715 * sp[76] + -0.06772486772486733 * sp[75] + -0.135449735449735 * sp[77] + -0.04514991181657781 * sp[78] + 0.06772486772486877 * sp[76] + 0.2257495590828935 * sp[78] + -0.135449735449735 * sp[79];
    A[864] = 0.5417989417989405 * sp[74] + 0.2708994708994699 * sp[75] + 0.2708994708994709 * sp[76] + 0.2708994708994699 * sp[75] + 0.5417989417989412 * sp[77] + 0.27089947089947 * sp[78] + 0.2708994708994709 * sp[76] + 0.27089947089947 * sp[78] + 0.6320987654320986 * sp[79];
    A[865] = 0.1354497354497346 * sp[74] + 0.06772486772486719 * sp[75] + 0.09029982363315614 * sp[76] + 0.06772486772486712 * sp[75] + 0.04514991181657849 * sp[78] + 0.09029982363315711 * sp[76] + 0.04514991181657901 * sp[78] + 0.04514991181657886 * sp[79];
    A[866] = 0.06772486772486816 * sp[75] + -0.06772486772486798 * sp[76] + 0.06772486772486734 * sp[75] + 0.04514991181657911 * sp[78] + -0.06772486772486876 * sp[76] + 0.04514991181657801 * sp[78] + -0.1354497354497362 * sp[79];
    A[867] = -0.5417989417989408 * sp[74] + -0.2708994708994709 * sp[75] + -0.2708994708994699 * sp[76] + -0.27089947089947 * sp[75] + -0.1354497354497359 * sp[78] + -0.2708994708994708 * sp[76] + -0.135449735449736 * sp[78] + 0.0451499118165786 * sp[79];
    A[868] = 0.06772486772486697 * sp[75] + 0.04514991181657799 * sp[76] + 0.06772486772486672 * sp[75] + 0.1354497354497344 * sp[77] + 0.09029982363315557 * sp[78] + 0.04514991181657762 * sp[76] + 0.09029982363315593 * sp[78] + 0.04514991181657806 * sp[79];
    A[869] = 0.06772486772486797 * sp[75] + 0.04514991181657922 * sp[76] + 0.06772486772486862 * sp[75] + -0.06772486772486726 * sp[78] + 0.04514991181657937 * sp[76] + -0.06772486772486713 * sp[78] + -0.1354497354497337 * sp[79];
    A[870] = -0.2708994708994699 * sp[75] + -0.1354497354497347 * sp[76] + -0.2708994708994708 * sp[75] + -0.5417989417989412 * sp[77] + -0.2708994708994698 * sp[78] + -0.135449735449735 * sp[76] + -0.2708994708994699 * sp[78] + 0.04514991181657884 * sp[79];
    A[871] = 0.02257495590828988 * sp[75] + 0.04514991181657915 * sp[76] + 0.02257495590828991 * sp[75] + 0.04514991181657906 * sp[78] + 0.04514991181657953 * sp[76] + 0.0451499118165796 * sp[78] + 0.09029982363315767 * sp[79];
    A[872] = 0.02257495590828936 * sp[75] + 0.04514991181657829 * sp[76] + 0.02257495590828863 * sp[75] + 0.06772486772486701 * sp[78] + 0.04514991181657796 * sp[76] + 0.06772486772486799 * sp[78] + 0.1354497354497353 * sp[79];
    A[873] = 0.02257495590828867 * sp[75] + 0.06772486772486731 * sp[76] + 0.0225749559082894 * sp[75] + 0.0451499118165781 * sp[78] + 0.06772486772486724 * sp[76] + 0.04514991181657763 * sp[78] + 0.1354497354497352 * sp[79];
    A[874] = -0.1354497354497361 * sp[75] + -0.3160493827160495 * sp[76] + -0.1354497354497359 * sp[75] + -0.3160493827160492 * sp[78] + -0.3160493827160494 * sp[76] + -0.3160493827160501 * sp[78] + -0.7223985890652554 * sp[79];
    A[875] = 0.04938271604938282 * sp[74] + 0.04938271604938293 * sp[75] + 0.04938271604938294 * sp[76] + 0.04232804232804195 * sp[75] + 0.04232804232804212 * sp[77] + 0.04232804232804214 * sp[78] + 0.04232804232804215 * sp[76] + 0.04232804232804221 * sp[78] + 0.0423280423280422 * sp[79];
    A[876] = 0.01834215167548496 * sp[74];
    A[877] = -0.007054673721340292 * sp[75] + -0.02539682539682556 * sp[77];
    A[878] = -0.007054673721340382 * sp[76] + -0.02539682539682523 * sp[79];
    A[879] = 0.06772486772486815 * sp[75] + 0.02257495590828972 * sp[76] + 0.09029982363315715 * sp[77] + 0.03386243386243377 * sp[78] + 0.03386243386243353 * sp[78];
    A[880] = 0.08465608465608458 * sp[75] + 0.08465608465608422 * sp[76] + 0.06772486772486744 * sp[77] + 0.06490299823633126 * sp[78] + 0.06490299823633115 * sp[78] + 0.06772486772486692 * sp[79];
    A[881] = 0.02257495590828896 * sp[75] + 0.06772486772486744 * sp[76] + 0.03386243386243383 * sp[78] + 0.03386243386243373 * sp[78] + 0.09029982363315688 * sp[79];
    A[882] = -0.02257495590828932 * sp[74] + -0.01128747795414433 * sp[76] + -0.0112874779541452 * sp[76];
    A[883] = 0.01693121693121719 * sp[74] + 0.01975308641975272 * sp[76] + 0.01975308641975353 * sp[76] + 0.02257495590828965 * sp[79];
    A[884] = 0.02257495590828889 * sp[74] + 0.03386243386243382 * sp[76] + 0.03386243386243361 * sp[76] + 0.04514991181657792 * sp[79];
    A[885] = -0.02257495590828871 * sp[74] + -0.01128747795414416 * sp[75] + -0.01128747795414416 * sp[75];
    A[886] = 0.01693121693121595 * sp[74] + 0.01975308641975208 * sp[75] + 0.01975308641975269 * sp[75] + 0.02257495590828869 * sp[77];
    A[887] = 0.02257495590828993 * sp[74] + 0.03386243386243456 * sp[75] + 0.03386243386243405 * sp[75] + 0.04514991181657891 * sp[77];
    A[888] = -0.0677248677248678 * sp[74] + -0.06772486772486792 * sp[75] + -0.07901234567901286 * sp[76] + -0.2708994708994716 * sp[75] + -0.2708994708994714 * sp[77] + -0.1693121693121693 * sp[78] + -0.1693121693121696 * sp[76] + -0.1693121693121695 * sp[78] + -0.06772486772486799 * sp[79];
    A[889] = 0.1185185185185188 * sp[74] + 0.1185185185185187 * sp[75] + 0.02539682539682593 * sp[76] + 0.06772486772486795 * sp[75] + 0.06772486772486802 * sp[77] + 0.1608465608465608 * sp[78] + 0.1608465608465606 * sp[76] + 0.1608465608465606 * sp[78] + -0.01693121693121626 * sp[79];
    A[890] = -0.02257495590828913 * sp[74] + -0.02257495590828906 * sp[75] + 0.01128747795414452 * sp[76] + -0.03386243386243399 * sp[78] + -0.03386243386243382 * sp[76] + -0.03386243386243386 * sp[78] + 0.06772486772486701 * sp[79];
    A[891] = -0.06772486772486715 * sp[74] + -0.0790123456790128 * sp[75] + -0.06772486772486759 * sp[76] + -0.1693121693121692 * sp[75] + -0.06772486772486724 * sp[77] + -0.1693121693121694 * sp[78] + -0.2708994708994709 * sp[76] + -0.1693121693121691 * sp[78] + -0.2708994708994707 * sp[79];
    A[892] = 0.1185185185185185 * sp[74] + 0.02539682539682553 * sp[75] + 0.1185185185185187 * sp[76] + 0.1608465608465606 * sp[75] + -0.01693121693121761 * sp[77] + 0.1608465608465606 * sp[78] + 0.06772486772486731 * sp[76] + 0.1608465608465603 * sp[78] + 0.06772486772486719 * sp[79];
    A[893] = -0.02257495590828992 * sp[74] + 0.01128747795414444 * sp[75] + -0.02257495590828984 * sp[76] + -0.03386243386243405 * sp[75] + 0.06772486772486785 * sp[77] + -0.03386243386243389 * sp[78] + -0.03386243386243368 * sp[78];
    A[894] = -0.04514991181657907 * sp[74] + -0.03386243386243412 * sp[75] + -0.03386243386243388 * sp[76] + -0.03386243386243358 * sp[75] + -0.1354497354497358 * sp[77] + -0.1354497354497358 * sp[78] + -0.03386243386243369 * sp[76] + -0.1354497354497354 * sp[78] + -0.1354497354497354 * sp[79];
    A[895] = 0.0225749559082899 * sp[74] + -0.01975308641975295 * sp[75] + -0.01975308641975297 * sp[76] + -0.01975308641975325 * sp[75] + 0.02257495590828918 * sp[77] + 0.02257495590828906 * sp[78] + -0.01975308641975346 * sp[76] + 0.02257495590828926 * sp[78] + 0.02257495590828923 * sp[79];
    A[896] = -0.04514991181657883 * sp[74] + 0.01128747795414437 * sp[75] + 0.01128747795414419 * sp[76] + 0.01128747795414491 * sp[75] + 0.01128747795414494 * sp[76];
    A[897] = 0.0902998236331574 * sp[74] + 0.04514991181657873 * sp[75] + 0.04514991181657863 * sp[76] + 0.04514991181657933 * sp[75] + 0.02257495590828971 * sp[78] + 0.04514991181657897 * sp[76] + 0.02257495590828873 * sp[78];
    A[898] = 0.1354497354497366 * sp[74] + 0.09029982363315768 * sp[75] + 0.06772486772486863 * sp[76] + 0.09029982363315708 * sp[75] + 0.04514991181657893 * sp[77] + 0.04514991181657879 * sp[78] + 0.06772486772486658 * sp[76] + 0.04514991181657826 * sp[78];
    A[899] = 0.1354497354497346 * sp[74] + 0.06772486772486712 * sp[75] + 0.09029982363315711 * sp[76] + 0.06772486772486719 * sp[75] + 0.04514991181657901 * sp[78] + 0.09029982363315614 * sp[76] + 0.04514991181657849 * sp[78] + 0.04514991181657886 * sp[79];
    A[900] = 0.6320987654320984 * sp[74] + 0.3611992945326279 * sp[75] + 0.3611992945326271 * sp[76] + 0.3611992945326279 * sp[75] + 0.6320987654320999 * sp[77] + 0.3611992945326284 * sp[78] + 0.3611992945326271 * sp[76] + 0.3611992945326284 * sp[78] + 0.6320987654320981 * sp[79];
    A[901] = -0.1354497354497366 * sp[74] + -0.3611992945326281 * sp[75] + -0.2031746031746032 * sp[76] + -0.09029982363315717 * sp[75] + -0.4514991181657854 * sp[77] + -0.225749559082892 * sp[78] + -0.06772486772486662 * sp[76] + -0.2257495590828922 * sp[78] + -0.1354497354497344 * sp[79];
    A[902] = -0.1354497354497345 * sp[74] + -0.2031746031746032 * sp[75] + -0.3611992945326264 * sp[76] + -0.06772486772486704 * sp[75] + -0.1354497354497352 * sp[77] + -0.2257495590828924 * sp[78] + -0.0902998236331561 * sp[76] + -0.2257495590828916 * sp[78] + -0.4514991181657835 * sp[79];
    A[903] = 0.0451499118165779 * sp[74] + 0.3160493827160485 * sp[75] + 0.1805996472663133 * sp[76] + 0.3160493827160508 * sp[75] + 0.04514991181657897 * sp[77] + 0.1805996472663152 * sp[78] + 0.1805996472663146 * sp[76] + 0.1805996472663134 * sp[78] + 0.3160493827160489 * sp[79];
    A[904] = 0.04514991181657918 * sp[74] + -0.04514991181657865 * sp[75] + -0.04514991181657901 * sp[75] + -0.02257495590828911 * sp[78] + -0.02257495590828876 * sp[78] + -0.04514991181657838 * sp[79];
    A[905] = -0.1354497354497358 * sp[74] + -0.06772486772486709 * sp[75] + -0.1805996472663136 * sp[76] + -0.06772486772486828 * sp[75] + -0.04514991181657921 * sp[78] + -0.1805996472663141 * sp[76] + -0.04514991181657835 * sp[78] + -0.2257495590828917 * sp[79];
    A[906] = 0.04514991181657724 * sp[74] + 0.1805996472663138 * sp[75] + 0.3160493827160488 * sp[76] + 0.180599647266314 * sp[75] + 0.3160493827160498 * sp[77] + 0.1805996472663139 * sp[78] + 0.3160493827160503 * sp[76] + 0.1805996472663141 * sp[78] + 0.04514991181657874 * sp[79];
    A[907] = 0.04514991181657869 * sp[74] + -0.04514991181657833 * sp[76] + -0.04514991181657854 * sp[77] + -0.02257495590828994 * sp[78] + -0.04514991181657907 * sp[76] + -0.0225749559082896 * sp[78];
    A[908] = -0.1354497354497344 * sp[74] + -0.1805996472663139 * sp[75] + -0.06772486772486788 * sp[76] + -0.1805996472663133 * sp[75] + -0.2257495590828922 * sp[77] + -0.0451499118165784 * sp[78] + -0.06772486772486745 * sp[76] + -0.04514991181657805 * sp[78];
    A[909] = -0.7223985890652563 * sp[74] + -0.406349206349207 * sp[75] + -0.4063492063492067 * sp[76] + -0.4063492063492077 * sp[75] + -0.09029982363315793 * sp[77] + -0.2257495590828931 * sp[78] + -0.4063492063492065 * sp[76] + -0.225749559082892 * sp[78] + -0.09029982363315747 * sp[79];
    A[910] = -0.01834215167548508 * sp[74] + -0.01834215167548501 * sp[75] + -0.01834215167548505 * sp[76] + -0.02539682539682522 * sp[75] + -0.02539682539682536 * sp[77] + -0.02539682539682534 * sp[78] + -0.02539682539682513 * sp[76] + -0.02539682539682525 * sp[78] + -0.02539682539682521 * sp[79];
    A[911] = 0.01834215167548507 * sp[74];
    A[912] = -0.00705467372134014 * sp[75] + 0.0423280423280426 * sp[77];
    A[913] = -0.007054673721340306 * sp[76] + -0.02539682539682534 * sp[79];
    A[914] = -0.2031746031746032 * sp[75] + -0.112874779541446 * sp[76] + -0.2708994708994709 * sp[77] + -0.1015873015873012 * sp[78] + -0.1015873015873006 * sp[78];
    A[915] = -0.05079365079365126 * sp[75] + -0.1862433862433861 * sp[76] + 0.06772486772486785 * sp[77] + -0.09312169312169274 * sp[78] + -0.09312169312169377 * sp[78] + -0.2708994708994698 * sp[79];
    A[916] = 0.02257495590828943 * sp[75] + 0.06772486772486819 * sp[76] + 0.03386243386243395 * sp[78] + 0.03386243386243414 * sp[78] + 0.1354497354497352 * sp[79];
    A[917] = -0.02257495590828934 * sp[74] + -0.01128747795414487 * sp[76] + -0.01128747795414452 * sp[76];
    A[918] = 0.01693121693121676 * sp[74] + 0.01975308641975306 * sp[76] + 0.01975308641975311 * sp[76] + 0.02257495590828953 * sp[79];
    A[919] = 0.02257495590828949 * sp[74] + 0.03386243386243399 * sp[76] + 0.03386243386243419 * sp[76] + 0.04514991181657895 * sp[79];
    A[920] = -0.06772486772486795 * sp[74] + -0.01128747795414519 * sp[75] + -0.01128747795414543 * sp[75];
    A[921] = 0.08465608465608529 * sp[74] + 0.04232804232804316 * sp[75] + 0.04232804232804339 * sp[75] + 0.02257495590829024 * sp[77];
    A[922] = -0.1128747795414472 * sp[74] + -0.1015873015873025 * sp[75] + -0.1015873015873023 * sp[75] + -0.1354497354497363 * sp[77];
    A[923] = 0.02257495590828919 * sp[74] + 0.02257495590828909 * sp[75] + 0.01128747795414437 * sp[76] + 0.09029982363315756 * sp[75] + 0.09029982363315732 * sp[77] + 0.05643738977072305 * sp[78] + 0.05643738977072292 * sp[76] + 0.05643738977072289 * sp[78] + 0.02257495590828867 * sp[79];
    A[924] = -0.01693121693121648 * sp[74] + -0.01693121693121664 * sp[75] + 0.002821869488536388 * sp[76] + 0.06772486772486748 * sp[75] + 0.06772486772486744 * sp[77] + 0.002821869488536281 * sp[78] + 0.002821869488536223 * sp[76] + 0.002821869488536143 * sp[78] + 0.005643738977072518 * sp[79];
    A[925] = -0.02257495590828949 * sp[74] + -0.02257495590828949 * sp[75] + 0.01128747795414455 * sp[76] + -0.03386243386243412 * sp[78] + -0.03386243386243411 * sp[76] + -0.03386243386243414 * sp[78] + 0.02257495590828942 * sp[79];
    A[926] = 0.06772486772486794 * sp[74] + 0.05643738977072279 * sp[75] + 0.06772486772486741 * sp[76] + 0.1015873015873014 * sp[75] + 0.06772486772486729 * sp[77] + 0.1015873015873014 * sp[78] + 0.1354497354497349 * sp[76] + 0.1015873015873012 * sp[78] + 0.135449735449735 * sp[79];
    A[927] = -0.08465608465608529 * sp[74] + -0.04232804232804185 * sp[75] + -0.08465608465608447 * sp[76] + -0.1777777777777776 * sp[75] + -0.01693121693121589 * sp[77] + -0.1777777777777771 * sp[78] + -0.2708994708994709 * sp[76] + -0.1777777777777778 * sp[78] + -0.270899470899471 * sp[79];
    A[928] = 0.1128747795414473 * sp[74] + 0.01128747795414467 * sp[75] + 0.1128747795414466 * sp[76] + 0.1015873015873024 * sp[75] + -0.06772486772486806 * sp[77] + 0.1015873015873019 * sp[78] + 0.1015873015873022 * sp[78];
    A[929] = 0.01128747795414487 * sp[75] + 0.01128747795414458 * sp[76] + 0.01128747795414476 * sp[75] + 0.04514991181657906 * sp[77] + 0.04514991181657892 * sp[78] + 0.01128747795414439 * sp[76] + 0.04514991181657858 * sp[78] + 0.04514991181657862 * sp[79];
    A[930] = 0.002821869488535945 * sp[75] + 0.002821869488535669 * sp[76] + 0.00282186948853587 * sp[75] + 0.02257495590828903 * sp[77] + 0.02257495590828903 * sp[78] + 0.002821869488536133 * sp[76] + 0.02257495590828914 * sp[78] + 0.02257495590828927 * sp[79];
    A[931] = 0.01128747795414531 * sp[75] + 0.01128747795414488 * sp[76] + 0.01128747795414454 * sp[75] + 0.01128747795414469 * sp[76];
    A[932] = 0.1354497354497371 * sp[74] + 0.0451499118165792 * sp[75] + 0.06772486772486912 * sp[76] + 0.04514991181657788 * sp[75] + 0.02257495590828874 * sp[78] + 0.0677248677248678 * sp[76] + 0.02257495590828964 * sp[78];
    A[933] = -0.5417989417989441 * sp[74] + -0.2708994708994723 * sp[75] + -0.2708994708994732 * sp[76] + -0.2708994708994714 * sp[75] + 0.0451499118165784 * sp[77] + -0.1354497354497362 * sp[78] + -0.2708994708994708 * sp[76] + -0.1354497354497365 * sp[78];
    A[934] = 0.06772486772486734 * sp[75] + -0.06772486772486876 * sp[76] + 0.06772486772486816 * sp[75] + 0.04514991181657801 * sp[78] + -0.06772486772486798 * sp[76] + 0.04514991181657911 * sp[78] + -0.1354497354497362 * sp[79];
    A[935] = -0.1354497354497366 * sp[74] + -0.09029982363315717 * sp[75] + -0.06772486772486662 * sp[76] + -0.3611992945326281 * sp[75] + -0.4514991181657854 * sp[77] + -0.2257495590828922 * sp[78] + -0.2031746031746032 * sp[76] + -0.225749559082892 * sp[78] + -0.1354497354497344 * sp[79];
    A[936] = 0.5417989417989441 * sp[74] + 0.2708994708994715 * sp[75] + 0.2708994708994707 * sp[76] + 0.2708994708994715 * sp[75] + 0.6320987654320991 * sp[77] + 0.2708994708994696 * sp[78] + 0.2708994708994707 * sp[76] + 0.2708994708994696 * sp[78] + 0.5417989417989422 * sp[79];
    A[937] = 0.06772486772486802 * sp[75] + -0.06772486772486828 * sp[76] + -0.0677248677248683 * sp[75] + -0.1354497354497354 * sp[77] + 0.0902998236331571 * sp[78] + 0.06772486772486783 * sp[76] + 0.09029982363315747 * sp[78] + -0.1354497354497367 * sp[79];
    A[938] = -0.04514991181657922 * sp[75] + -0.02257495590828925 * sp[76] + -0.0451499118165795 * sp[75] + 0.04514991181657828 * sp[77] + -0.02257495590828948 * sp[76] + -0.04514991181657906 * sp[79];
    A[939] = -0.04514991181657869 * sp[75] + -0.02257495590828931 * sp[76] + -0.04514991181657791 * sp[75] + -0.02257495590828871 * sp[78] + -0.02257495590828898 * sp[76] + -0.02257495590828946 * sp[78] + -0.04514991181657906 * sp[79];
    A[940] = -0.06772486772486759 * sp[75] + -0.02257495590828939 * sp[76] + -0.06772486772486695 * sp[75] + -0.04514991181657822 * sp[78] + -0.0225749559082892 * sp[76] + -0.04514991181657912 * sp[78] + -0.04514991181657826 * sp[79];
    A[941] = -0.04514991181657908 * sp[75] + -0.0677248677248684 * sp[76] + -0.04514991181657822 * sp[75] + -0.2257495590828927 * sp[77] + -0.1805996472663136 * sp[78] + -0.06772486772486713 * sp[76] + -0.180599647266314 * sp[78] + -0.1354497354497357 * sp[79];
    A[942] = -0.04514991181657923 * sp[75] + -0.06772486772486799 * sp[76] + -0.04514991181657782 * sp[75] + -0.04514991181657873 * sp[77] + -0.02257495590828828 * sp[78] + -0.06772486772486759 * sp[76] + -0.022574955908289 * sp[78];
    A[943] = 0.1354497354497363 * sp[75] + 0.2708994708994726 * sp[76] + 0.1354497354497342 * sp[75] + 0.3160493827160494 * sp[77] + 0.1354497354497357 * sp[78] + 0.2708994708994709 * sp[76] + 0.1354497354497349 * sp[78];
    A[944] = 0.3160493827160505 * sp[75] + 0.1354497354497363 * sp[76] + 0.3160493827160504 * sp[75] + -0.09029982363315679 * sp[77] + 0.1354497354497353 * sp[78] + 0.135449735449736 * sp[76] + 0.1354497354497366 * sp[78] + 0.2708994708994716 * sp[79];
    A[945] = -0.01834215167548512 * sp[74] + -0.01834215167548507 * sp[75] + -0.01834215167548503 * sp[76] + -0.02539682539682538 * sp[75] + -0.02539682539682537 * sp[77] + -0.0253968253968254 * sp[78] + -0.02539682539682558 * sp[76] + -0.02539682539682557 * sp[78] + -0.02539682539682555 * sp[79];
    A[946] = 0.01834215167548505 * sp[74];
    A[947] = -0.007054673721340357 * sp[75] + -0.02539682539682547 * sp[77];
    A[948] = -0.007054673721340037 * sp[76] + 0.04232804232804224 * sp[79];
    A[949] = 0.06772486772486769 * sp[75] + 0.02257495590828824 * sp[76] + 0.1354497354497353 * sp[77] + 0.0338624338624332 * sp[78] + 0.0338624338624333 * sp[78];
    A[950] = -0.1862433862433864 * sp[75] + -0.05079365079364969 * sp[76] + -0.2708994708994708 * sp[77] + -0.09312169312169243 * sp[78] + -0.09312169312169193 * sp[78] + 0.06772486772486906 * sp[79];
    A[951] = -0.112874779541446 * sp[75] + -0.2031746031746033 * sp[76] + -0.1015873015873015 * sp[78] + -0.1015873015873019 * sp[78] + -0.2708994708994711 * sp[79];
    A[952] = -0.06772486772486809 * sp[74] + -0.01128747795414504 * sp[76] + -0.01128747795414457 * sp[76];
    A[953] = 0.08465608465608532 * sp[74] + 0.04232804232804272 * sp[76] + 0.04232804232804235 * sp[76] + 0.02257495590828914 * sp[79];
    A[954] = -0.1128747795414461 * sp[74] + -0.1015873015873015 * sp[76] + -0.1015873015873019 * sp[76] + -0.1354497354497356 * sp[79];
    A[955] = -0.02257495590828908 * sp[74] + -0.01128747795414478 * sp[75] + -0.01128747795414444 * sp[75];
    A[956] = 0.01693121693121701 * sp[74] + 0.01975308641975324 * sp[75] + 0.01975308641975289 * sp[75] + 0.02257495590828924 * sp[77];
    A[957] = 0.02257495590828929 * sp[74] + 0.03386243386243393 * sp[75] + 0.03386243386243371 * sp[75] + 0.0451499118165784 * sp[77];
    A[958] = 0.06772486772486798 * sp[74] + 0.06772486772486777 * sp[75] + 0.05643738977072307 * sp[76] + 0.1354497354497352 * sp[75] + 0.1354497354497352 * sp[77] + 0.1015873015873015 * sp[78] + 0.1015873015873019 * sp[76] + 0.1015873015873018 * sp[78] + 0.06772486772486835 * sp[79];
    A[959] = -0.08465608465608505 * sp[74] + -0.08465608465608472 * sp[75] + -0.04232804232804249 * sp[76] + -0.2708994708994707 * sp[75] + -0.2708994708994708 * sp[77] + -0.1777777777777779 * sp[78] + -0.1777777777777778 * sp[76] + -0.1777777777777776 * sp[78] + -0.01693121693121767 * sp[79];
    A[960] = 0.1128747795414462 * sp[74] + 0.1128747795414461 * sp[75] + 0.01128747795414478 * sp[76] + 0.101587301587302 * sp[78] + 0.1015873015873021 * sp[76] + 0.1015873015873021 * sp[78] + -0.06772486772486708 * sp[79];
    A[961] = 0.02257495590828909 * sp[74] + 0.01128747795414461 * sp[75] + 0.02257495590828907 * sp[76] + 0.05643738977072322 * sp[75] + 0.02257495590828935 * sp[77] + 0.05643738977072309 * sp[78] + 0.09029982363315704 * sp[76] + 0.05643738977072345 * sp[78] + 0.09029982363315694 * sp[79];
    A[962] = -0.01693121693121695 * sp[74] + 0.002821869488535928 * sp[75] + -0.01693121693121702 * sp[76] + 0.002821869488535795 * sp[75] + 0.005643738977071959 * sp[77] + 0.002821869488535729 * sp[78] + 0.06772486772486751 * sp[76] + 0.002821869488536079 * sp[78] + 0.06772486772486754 * sp[79];
    A[963] = -0.02257495590828933 * sp[74] + 0.01128747795414488 * sp[75] + -0.02257495590828937 * sp[76] + -0.03386243386243375 * sp[75] + 0.02257495590828953 * sp[77] + -0.03386243386243384 * sp[78] + -0.03386243386243377 * sp[78];
    A[964] = 0.01128747795414449 * sp[75] + 0.01128747795414462 * sp[76] + 0.01128747795414477 * sp[75] + 0.04514991181657871 * sp[77] + 0.04514991181657865 * sp[78] + 0.01128747795414503 * sp[76] + 0.04514991181657861 * sp[78] + 0.04514991181657851 * sp[79];
    A[965] = 0.002821869488535946 * sp[75] + 0.002821869488536008 * sp[76] + 0.002821869488536048 * sp[75] + 0.02257495590828923 * sp[77] + 0.02257495590828923 * sp[78] + 0.002821869488535998 * sp[76] + 0.02257495590828892 * sp[78] + 0.02257495590828886 * sp[79];
    A[966] = 0.011287477954145 * sp[75] + 0.01128747795414521 * sp[76] + 0.01128747795414482 * sp[75] + 0.01128747795414472 * sp[76];
    A[967] = 0.1354497354497354 * sp[74] + 0.06772486772486788 * sp[75] + 0.04514991181657838 * sp[76] + 0.06772486772486767 * sp[75] + 0.02257495590828963 * sp[78] + 0.0451499118165775 * sp[76] + 0.02257495590828919 * sp[78];
    A[968] = -0.06772486772486865 * sp[75] + 0.06772486772486733 * sp[76] + -0.06772486772486798 * sp[75] + -0.1354497354497358 * sp[77] + 0.04514991181657804 * sp[78] + 0.06772486772486828 * sp[76] + 0.04514991181657887 * sp[78];
    A[969] = -0.5417989417989408 * sp[74] + -0.27089947089947 * sp[75] + -0.2708994708994708 * sp[76] + -0.2708994708994709 * sp[75] + -0.135449735449736 * sp[78] + -0.2708994708994699 * sp[76] + -0.1354497354497359 * sp[78] + 0.0451499118165786 * sp[79];
    A[970] = -0.1354497354497345 * sp[74] + -0.06772486772486704 * sp[75] + -0.0902998236331561 * sp[76] + -0.2031746031746032 * sp[75] + -0.1354497354497352 * sp[77] + -0.2257495590828916 * sp[78] + -0.3611992945326264 * sp[76] + -0.2257495590828924 * sp[78] + -0.4514991181657835 * sp[79];
    A[971] = -0.0677248677248683 * sp[75] + 0.06772486772486783 * sp[76] + 0.06772486772486802 * sp[75] + -0.1354497354497354 * sp[77] + 0.09029982363315747 * sp[78] + -0.06772486772486828 * sp[76] + 0.0902998236331571 * sp[78] + -0.1354497354497367 * sp[79];
    A[972] = 0.5417989417989412 * sp[74] + 0.2708994708994708 * sp[75] + 0.27089947089947 * sp[76] + 0.2708994708994708 * sp[75] + 0.5417989417989412 * sp[77] + 0.2708994708994693 * sp[78] + 0.27089947089947 * sp[76] + 0.2708994708994693 * sp[78] + 0.6320987654320973 * sp[79];
    A[973] = -0.06772486772486697 * sp[75] + -0.04514991181657795 * sp[76] + -0.06772486772486747 * sp[75] + -0.1354497354497353 * sp[77] + -0.180599647266314 * sp[78] + -0.04514991181657858 * sp[76] + -0.1805996472663128 * sp[78] + -0.2257495590828911 * sp[79];
    A[974] = -0.06772486772486802 * sp[75] + -0.04514991181657928 * sp[76] + -0.06772486772486791 * sp[75] + -0.02257495590828974 * sp[78] + -0.04514991181657874 * sp[76] + -0.02257495590828922 * sp[78] + -0.04514991181657814 * sp[79];
    A[975] = 0.2708994708994699 * sp[75] + 0.1354497354497348 * sp[76] + 0.2708994708994708 * sp[75] + 0.1354497354497355 * sp[78] + 0.1354497354497353 * sp[76] + 0.1354497354497358 * sp[78] + 0.3160493827160482 * sp[79];
    A[976] = -0.02257495590828976 * sp[75] + -0.04514991181657903 * sp[76] + -0.02257495590828946 * sp[75] + -0.04514991181657905 * sp[77] + -0.04514991181657925 * sp[76] + 0.04514991181657799 * sp[79];
    A[977] = -0.02257495590828943 * sp[75] + -0.04514991181657836 * sp[76] + -0.02257495590828933 * sp[75] + -0.0451499118165786 * sp[77] + -0.02257495590828954 * sp[78] + -0.04514991181657794 * sp[76] + -0.02257495590828887 * sp[78];
    A[978] = -0.02257495590828878 * sp[75] + -0.06772486772486748 * sp[76] + -0.02257495590828873 * sp[75] + -0.04514991181657815 * sp[77] + -0.0451499118165781 * sp[78] + -0.0677248677248674 * sp[76] + -0.04514991181657765 * sp[78];
    A[979] = 0.1354497354497359 * sp[75] + 0.3160493827160494 * sp[76] + 0.135449735449736 * sp[75] + 0.2708994708994715 * sp[77] + 0.1354497354497364 * sp[78] + 0.3160493827160493 * sp[76] + 0.1354497354497344 * sp[78] + -0.09029982363315643 * sp[79];
    A[980] = 0.0423280423280418 * sp[74] + 0.04232804232804173 * sp[75] + 0.04232804232804185 * sp[76] + 0.04938271604938279 * sp[75] + 0.04938271604938269 * sp[77] + 0.04938271604938281 * sp[78] + 0.04232804232804206 * sp[76] + 0.04232804232804214 * sp[78] + 0.04232804232804215 * sp[79];
    A[981] = -0.02539682539682566 * sp[74] + -0.007054673721340483 * sp[75];
    A[982] = 0.01834215167548529 * sp[77];
    A[983] = -0.007054673721340406 * sp[78] + -0.02539682539682536 * sp[79];
    A[984] = -0.02257495590828903 * sp[77] + -0.01128747795414417 * sp[78] + -0.01128747795414489 * sp[78];
    A[985] = 0.01693121693121698 * sp[77] + 0.01975308641975292 * sp[78] + 0.01975308641975354 * sp[78] + 0.02257495590828935 * sp[79];
    A[986] = 0.02257495590828898 * sp[77] + 0.03386243386243361 * sp[78] + 0.03386243386243351 * sp[78] + 0.04514991181657829 * sp[79];
    A[987] = 0.09029982363315626 * sp[74] + 0.03386243386243336 * sp[76] + 0.06772486772486715 * sp[75] + 0.02257495590828887 * sp[78] + 0.03386243386243281 * sp[76];
    A[988] = 0.06772486772486694 * sp[74] + 0.06490299823633058 * sp[76] + 0.08465608465608419 * sp[75] + 0.08465608465608364 * sp[78] + 0.06490299823633101 * sp[76] + 0.06772486772486702 * sp[79];
    A[989] = 0.03386243386243386 * sp[76] + 0.022574955908289 * sp[75] + 0.06772486772486788 * sp[78] + 0.03386243386243346 * sp[76] + 0.09029982363315639 * sp[79];
    A[990] = 0.04514991181657844 * sp[74] + 0.03386243386243391 * sp[75] + 0.03386243386243389 * sp[75] + 0.02257495590828908 * sp[77];
    A[991] = 0.02257495590828943 * sp[74] + 0.01975308641975309 * sp[75] + 0.0197530864197528 * sp[75] + 0.01693121693121678 * sp[77];
    A[992] = -0.01128747795414464 * sp[75] + -0.01128747795414422 * sp[75] + -0.02257495590828925 * sp[77];
    A[993] = -0.2708994708994714 * sp[74] + -0.2708994708994714 * sp[75] + -0.1693121693121691 * sp[76] + -0.06772486772486758 * sp[75] + -0.06772486772486799 * sp[77] + -0.07901234567901304 * sp[78] + -0.1693121693121695 * sp[76] + -0.1693121693121696 * sp[78] + -0.06772486772486815 * sp[79];
    A[994] = 0.0677248677248673 * sp[74] + 0.0677248677248674 * sp[75] + 0.1608465608465608 * sp[76] + 0.1185185185185183 * sp[75] + 0.1185185185185183 * sp[77] + 0.02539682539682615 * sp[78] + 0.1608465608465604 * sp[76] + 0.1608465608465605 * sp[78] + -0.01693121693121623 * sp[79];
    A[995] = -0.0338624338624337 * sp[76] + -0.02257495590828914 * sp[75] + -0.02257495590828904 * sp[77] + 0.01128747795414463 * sp[78] + -0.0338624338624336 * sp[76] + -0.03386243386243361 * sp[78] + 0.06772486772486723 * sp[79];
    A[996] = -0.1354497354497359 * sp[74] + -0.03386243386243323 * sp[75] + -0.1354497354497359 * sp[76] + -0.03386243386243373 * sp[75] + -0.04514991181657889 * sp[77] + -0.03386243386243403 * sp[78] + -0.1354497354497355 * sp[76] + -0.03386243386243392 * sp[78] + -0.1354497354497354 * sp[79];
    A[997] = 0.02257495590828941 * sp[74] + -0.01975308641975332 * sp[75] + 0.02257495590828941 * sp[76] + -0.01975308641975286 * sp[75] + 0.02257495590828986 * sp[77] + -0.01975308641975269 * sp[78] + 0.02257495590828947 * sp[76] + -0.01975308641975301 * sp[78] + 0.02257495590828947 * sp[79];
    A[998] = 0.01128747795414489 * sp[75] + 0.01128747795414424 * sp[75] + -0.04514991181657858 * sp[77] + 0.01128747795414414 * sp[78] + 0.01128747795414486 * sp[78];
    A[999] = -0.06772486772486662 * sp[74] + -0.1693121693121689 * sp[75] + -0.169312169312169 * sp[76] + -0.07901234567901239 * sp[75] + -0.06772486772486727 * sp[77] + -0.06772486772486701 * sp[78] + -0.1693121693121689 * sp[76] + -0.2708994708994707 * sp[78] + -0.2708994708994705 * sp[79];
    A[1000] = -0.01693121693121806 * sp[74] + 0.1608465608465602 * sp[75] + 0.1608465608465601 * sp[76] + 0.02539682539682523 * sp[75] + 0.1185185185185183 * sp[77] + 0.1185185185185183 * sp[78] + 0.1608465608465602 * sp[76] + 0.06772486772486655 * sp[78] + 0.06772486772486648 * sp[79];
    A[1001] = 0.06772486772486837 * sp[74] + -0.03386243386243354 * sp[75] + -0.03386243386243361 * sp[76] + 0.01128747795414462 * sp[75] + -0.02257495590828907 * sp[77] + -0.02257495590828927 * sp[78] + -0.03386243386243339 * sp[76];
    A[1002] = 0.04514991181657758 * sp[74] + 0.0902998236331547 * sp[75] + 0.04514991181657804 * sp[76] + 0.09029982363315643 * sp[75] + 0.1354497354497338 * sp[77] + 0.06772486772486747 * sp[78] + 0.04514991181657675 * sp[76] + 0.06772486772486493 * sp[78];
    A[1003] = 0.04514991181657982 * sp[75] + 0.02257495590829011 * sp[76] + 0.04514991181657923 * sp[75] + 0.09029982363315786 * sp[77] + 0.04514991181657937 * sp[78] + 0.02257495590828924 * sp[76] + 0.04514991181657889 * sp[78];
    A[1004] = 0.06772486772486672 * sp[75] + 0.04514991181657762 * sp[76] + 0.06772486772486697 * sp[75] + 0.1354497354497344 * sp[77] + 0.09029982363315593 * sp[78] + 0.04514991181657799 * sp[76] + 0.09029982363315557 * sp[78] + 0.04514991181657806 * sp[79];
    A[1005] = 0.0451499118165779 * sp[74] + 0.3160493827160508 * sp[75] + 0.1805996472663146 * sp[76] + 0.3160493827160485 * sp[75] + 0.04514991181657897 * sp[77] + 0.1805996472663134 * sp[78] + 0.1805996472663133 * sp[76] + 0.1805996472663152 * sp[78] + 0.3160493827160489 * sp[79];
    A[1006] = -0.0451499118165795 * sp[75] + -0.02257495590828948 * sp[76] + -0.04514991181657922 * sp[75] + 0.04514991181657828 * sp[77] + -0.02257495590828925 * sp[76] + -0.04514991181657906 * sp[79];
    A[1007] = -0.06772486772486747 * sp[75] + -0.04514991181657858 * sp[76] + -0.06772486772486697 * sp[75] + -0.1354497354497353 * sp[77] + -0.1805996472663128 * sp[78] + -0.04514991181657795 * sp[76] + -0.180599647266314 * sp[78] + -0.2257495590828911 * sp[79];
    A[1008] = 0.6320987654320989 * sp[74] + 0.3611992945326266 * sp[75] + 0.3611992945326274 * sp[76] + 0.3611992945326266 * sp[75] + 0.6320987654320975 * sp[77] + 0.3611992945326258 * sp[78] + 0.3611992945326274 * sp[76] + 0.3611992945326258 * sp[78] + 0.6320987654320984 * sp[79];
    A[1009] = -0.4514991181657839 * sp[74] + -0.0902998236331551 * sp[75] + -0.2257495590828902 * sp[76] + -0.3611992945326263 * sp[75] + -0.1354497354497338 * sp[77] + -0.2031746031746016 * sp[78] + -0.2257495590828908 * sp[76] + -0.06772486772486502 * sp[78] + -0.1354497354497327 * sp[79];
    A[1010] = -0.1354497354497341 * sp[74] + -0.06772486772486654 * sp[75] + -0.2257495590828923 * sp[76] + -0.2031746031746025 * sp[75] + -0.1354497354497345 * sp[77] + -0.3611992945326272 * sp[78] + -0.2257495590828914 * sp[76] + -0.09029982363315545 * sp[78] + -0.4514991181657842 * sp[79];
    A[1011] = 0.3160493827160496 * sp[74] + 0.1805996472663137 * sp[75] + 0.1805996472663133 * sp[76] + 0.1805996472663133 * sp[75] + 0.04514991181657765 * sp[77] + 0.3160493827160488 * sp[78] + 0.1805996472663138 * sp[76] + 0.3160493827160502 * sp[78] + 0.04514991181657774 * sp[79];
    A[1012] = -0.2257495590828922 * sp[74] + -0.1805996472663142 * sp[75] + -0.04514991181657824 * sp[76] + -0.1805996472663134 * sp[75] + -0.1354497354497359 * sp[77] + -0.06772486772486713 * sp[78] + -0.04514991181657781 * sp[76] + -0.06772486772486686 * sp[78];
    A[1013] = -0.04514991181657874 * sp[74] + -0.02257495590828986 * sp[76] + 0.04514991181657894 * sp[77] + -0.04514991181657874 * sp[78] + -0.02257495590828945 * sp[76] + -0.04514991181657897 * sp[78];
    A[1014] = -0.09029982363315565 * sp[74] + -0.4063492063492065 * sp[75] + -0.2257495590828911 * sp[76] + -0.4063492063492055 * sp[75] + -0.722398589065256 * sp[77] + -0.4063492063492057 * sp[78] + -0.2257495590828905 * sp[76] + -0.406349206349205 * sp[78] + -0.090299823633156 * sp[79];
    A[1015] = -0.02539682539682506 * sp[74] + -0.02539682539682486 * sp[75] + -0.02539682539682497 * sp[76] + -0.01834215167548466 * sp[75] + -0.01834215167548469 * sp[77] + -0.01834215167548474 * sp[78] + -0.025396825396825 * sp[76] + -0.02539682539682495 * sp[78] + -0.02539682539682506 * sp[79];
    A[1016] = 0.04232804232804256 * sp[74] + -0.007054673721339992 * sp[75];
    A[1017] = 0.01834215167548502 * sp[77];
    A[1018] = -0.007054673721340356 * sp[78] + -0.02539682539682539 * sp[79];
    A[1019] = -0.02257495590828973 * sp[77] + -0.01128747795414498 * sp[78] + -0.01128747795414473 * sp[78];
    A[1020] = 0.01693121693121732 * sp[77] + 0.01975308641975333 * sp[78] + 0.01975308641975344 * sp[78] + 0.02257495590828904 * sp[79];
    A[1021] = 0.02257495590828937 * sp[77] + 0.03386243386243372 * sp[78] + 0.03386243386243406 * sp[78] + 0.04514991181657871 * sp[79];
    A[1022] = -0.2708994708994701 * sp[74] + -0.101587301587301 * sp[76] + -0.2031746031746023 * sp[75] + -0.1128747795414451 * sp[78] + -0.1015873015873003 * sp[76];
    A[1023] = 0.06772486772486842 * sp[74] + -0.09312169312169204 * sp[76] + -0.05079365079365118 * sp[75] + -0.186243386243387 * sp[78] + -0.09312169312169305 * sp[76] + -0.2708994708994701 * sp[79];
    A[1024] = 0.03386243386243375 * sp[76] + 0.02257495590828933 * sp[75] + 0.06772486772486824 * sp[78] + 0.03386243386243398 * sp[76] + 0.1354497354497353 * sp[79];
    A[1025] = -0.1354497354497353 * sp[74] + -0.1015873015873014 * sp[75] + -0.1015873015873013 * sp[75] + -0.1128747795414453 * sp[77];
    A[1026] = 0.0225749559082889 * sp[74] + 0.04232804232804196 * sp[75] + 0.04232804232804256 * sp[75] + 0.08465608465608429 * sp[77];
    A[1027] = -0.01128747795414427 * sp[75] + -0.01128747795414502 * sp[75] + -0.06772486772486788 * sp[77];
    A[1028] = 0.09029982363315697 * sp[74] + 0.09029982363315708 * sp[75] + 0.05643738977072276 * sp[76] + 0.02257495590828863 * sp[75] + 0.02257495590828879 * sp[77] + 0.01128747795414432 * sp[78] + 0.05643738977072234 * sp[76] + 0.05643738977072257 * sp[78] + 0.022574955908289 * sp[79];
    A[1029] = 0.0677248677248682 * sp[74] + 0.06772486772486822 * sp[75] + 0.00282186948853619 * sp[76] + -0.01693121693121636 * sp[75] + -0.01693121693121643 * sp[77] + 0.002821869488535583 * sp[78] + 0.002821869488536546 * sp[76] + 0.002821869488536537 * sp[78] + 0.005643738977072047 * sp[79];
    A[1030] = -0.03386243386243416 * sp[76] + -0.02257495590828941 * sp[75] + -0.02257495590828937 * sp[77] + 0.01128747795414489 * sp[78] + -0.033862433862434 * sp[76] + -0.03386243386243401 * sp[78] + 0.0225749559082891 * sp[79];
    A[1031] = 0.04514991181657865 * sp[74] + 0.01128747795414383 * sp[75] + 0.04514991181657853 * sp[76] + 0.01128747795414432 * sp[75] + 0.01128747795414425 * sp[78] + 0.0451499118165781 * sp[76] + 0.0112874779541442 * sp[78] + 0.04514991181657823 * sp[79];
    A[1032] = 0.02257495590828922 * sp[74] + 0.00282186948853647 * sp[75] + 0.02257495590828926 * sp[76] + 0.002821869488535965 * sp[75] + 0.002821869488535947 * sp[78] + 0.02257495590828964 * sp[76] + 0.002821869488536161 * sp[78] + 0.02257495590828962 * sp[79];
    A[1033] = 0.01128747795414394 * sp[75] + 0.01128747795414504 * sp[75] + 0.01128747795414495 * sp[78] + 0.01128747795414446 * sp[78];
    A[1034] = 0.06772486772486659 * sp[74] + 0.1015873015873009 * sp[75] + 0.1015873015873008 * sp[76] + 0.0564373897707218 * sp[75] + 0.06772486772486667 * sp[77] + 0.06772486772486665 * sp[78] + 0.1015873015873005 * sp[76] + 0.1354497354497341 * sp[78] + 0.135449735449734 * sp[79];
    A[1035] = -0.0169312169312153 * sp[74] + -0.1777777777777768 * sp[75] + -0.1777777777777767 * sp[76] + -0.04232804232804036 * sp[75] + -0.08465608465608343 * sp[77] + -0.08465608465608326 * sp[78] + -0.1777777777777769 * sp[76] + -0.2708994708994705 * sp[78] + -0.2708994708994703 * sp[79];
    A[1036] = -0.06772486772486866 * sp[74] + 0.1015873015873013 * sp[75] + 0.1015873015873014 * sp[76] + 0.01128747795414338 * sp[75] + 0.1128747795414458 * sp[77] + 0.112874779541446 * sp[78] + 0.1015873015873015 * sp[76];
    A[1037] = 0.04514991181657955 * sp[74] + -0.2708994708994686 * sp[75] + -0.1354497354497353 * sp[76] + -0.2708994708994703 * sp[75] + -0.5417989417989416 * sp[77] + -0.270899470899471 * sp[78] + -0.1354497354497347 * sp[76] + -0.2708994708994689 * sp[78];
    A[1038] = 0.04514991181657751 * sp[75] + 0.02257495590828873 * sp[76] + 0.0451499118165786 * sp[75] + 0.1354497354497365 * sp[77] + 0.06772486772486767 * sp[78] + 0.02257495590828928 * sp[76] + 0.06772486772486781 * sp[78];
    A[1039] = 0.06772486772486862 * sp[75] + 0.04514991181657937 * sp[76] + 0.06772486772486797 * sp[75] + -0.06772486772486713 * sp[78] + 0.04514991181657922 * sp[76] + -0.06772486772486726 * sp[78] + -0.1354497354497337 * sp[79];
    A[1040] = 0.04514991181657918 * sp[74] + -0.04514991181657901 * sp[75] + -0.04514991181657865 * sp[75] + -0.02257495590828876 * sp[78] + -0.02257495590828911 * sp[78] + -0.04514991181657838 * sp[79];
    A[1041] = -0.04514991181657791 * sp[75] + -0.02257495590828898 * sp[76] + -0.04514991181657869 * sp[75] + -0.02257495590828946 * sp[78] + -0.02257495590828931 * sp[76] + -0.02257495590828871 * sp[78] + -0.04514991181657906 * sp[79];
    A[1042] = -0.06772486772486791 * sp[75] + -0.04514991181657874 * sp[76] + -0.06772486772486802 * sp[75] + -0.02257495590828922 * sp[78] + -0.04514991181657928 * sp[76] + -0.02257495590828974 * sp[78] + -0.04514991181657814 * sp[79];
    A[1043] = -0.4514991181657839 * sp[74] + -0.3611992945326263 * sp[75] + -0.2257495590828908 * sp[76] + -0.0902998236331551 * sp[75] + -0.1354497354497338 * sp[77] + -0.06772486772486502 * sp[78] + -0.2257495590828902 * sp[76] + -0.2031746031746016 * sp[78] + -0.1354497354497327 * sp[79];
    A[1044] = 0.6320987654320971 * sp[74] + 0.2708994708994688 * sp[75] + 0.2708994708994682 * sp[76] + 0.2708994708994688 * sp[75] + 0.5417989417989404 * sp[77] + 0.2708994708994684 * sp[78] + 0.2708994708994682 * sp[76] + 0.2708994708994684 * sp[78] + 0.5417989417989396 * sp[79];
    A[1045] = -0.1354497354497367 * sp[74] + -0.0677248677248686 * sp[75] + 0.09029982363315667 * sp[76] + 0.0677248677248674 * sp[75] + -0.06772486772486806 * sp[78] + 0.0902998236331564 * sp[76] + 0.06772486772486719 * sp[78] + -0.135449735449736 * sp[79];
    A[1046] = -0.2257495590828922 * sp[74] + -0.04514991181657763 * sp[75] + -0.1805996472663133 * sp[76] + -0.04514991181657772 * sp[75] + -0.06772486772486773 * sp[78] + -0.1805996472663134 * sp[76] + -0.06772486772486611 * sp[78] + -0.1354497354497348 * sp[79];
    A[1047] = 0.3160493827160489 * sp[74] + 0.1354497354497357 * sp[75] + 0.1354497354497352 * sp[76] + 0.1354497354497346 * sp[75] + 0.27089947089947 * sp[78] + 0.135449735449735 * sp[76] + 0.2708994708994717 * sp[78];
    A[1048] = -0.04514991181657817 * sp[74] + -0.04514991181657869 * sp[75] + -0.02257495590828876 * sp[76] + -0.0451499118165786 * sp[75] + -0.0677248677248676 * sp[78] + -0.02257495590828974 * sp[76] + -0.06772486772486851 * sp[78];
    A[1049] = -0.09029982363315862 * sp[74] + 0.316049382716049 * sp[75] + 0.135449735449734 * sp[76] + 0.316049382716049 * sp[75] + 0.1354497354497351 * sp[78] + 0.1354497354497341 * sp[76] + 0.135449735449735 * sp[78] + 0.2708994708994686 * sp[79];
    A[1050] = -0.02539682539682524 * sp[74] + -0.02539682539682531 * sp[75] + -0.02539682539682538 * sp[76] + -0.01834215167548503 * sp[75] + -0.01834215167548506 * sp[77] + -0.01834215167548505 * sp[78] + -0.02539682539682557 * sp[76] + -0.02539682539682561 * sp[78] + -0.02539682539682559 * sp[79];
    A[1051] = -0.02539682539682537 * sp[74] + -0.007054673721340241 * sp[75];
    A[1052] = 0.01834215167548502 * sp[77];
    A[1053] = -0.007054673721340099 * sp[78] + 0.04232804232804233 * sp[79];
    A[1054] = -0.0677248677248677 * sp[77] + -0.01128747795414524 * sp[78] + -0.01128747795414446 * sp[78];
    A[1055] = 0.08465608465608469 * sp[77] + 0.04232804232804323 * sp[78] + 0.04232804232804208 * sp[78] + 0.02257495590828962 * sp[79];
    A[1056] = -0.112874779541446 * sp[77] + -0.1015873015873019 * sp[78] + -0.1015873015873014 * sp[78] + -0.1354497354497354 * sp[79];
    A[1057] = 0.1354497354497359 * sp[74] + 0.03386243386243437 * sp[76] + 0.06772486772486745 * sp[75] + 0.02257495590828954 * sp[78] + 0.03386243386243373 * sp[76];
    A[1058] = -0.2708994708994709 * sp[74] + -0.09312169312169348 * sp[76] + -0.1862433862433857 * sp[75] + -0.05079365079365132 * sp[78] + -0.09312169312169247 * sp[76] + 0.06772486772486799 * sp[79];
    A[1059] = -0.1015873015873012 * sp[76] + -0.1128747795414462 * sp[75] + -0.203174603174603 * sp[78] + -0.1015873015873014 * sp[76] + -0.2708994708994706 * sp[79];
    A[1060] = 0.04514991181657883 * sp[74] + 0.03386243386243441 * sp[75] + 0.03386243386243415 * sp[75] + 0.02257495590828966 * sp[77];
    A[1061] = 0.02257495590828908 * sp[74] + 0.01975308641975292 * sp[75] + 0.01975308641975333 * sp[75] + 0.01693121693121698 * sp[77];
    A[1062] = -0.01128747795414478 * sp[75] + -0.01128747795414478 * sp[75] + -0.02257495590828935 * sp[77];
    A[1063] = 0.1354497354497351 * sp[74] + 0.1354497354497352 * sp[75] + 0.1015873015873017 * sp[76] + 0.06772486772486778 * sp[75] + 0.06772486772486773 * sp[77] + 0.05643738977072334 * sp[78] + 0.1015873015873019 * sp[76] + 0.1015873015873019 * sp[78] + 0.06772486772486849 * sp[79];
    A[1064] = -0.2708994708994707 * sp[74] + -0.2708994708994708 * sp[75] + -0.1777777777777782 * sp[76] + -0.08465608465608503 * sp[75] + -0.08465608465608475 * sp[77] + -0.04232804232804274 * sp[78] + -0.1777777777777778 * sp[76] + -0.1777777777777777 * sp[78] + -0.01693121693121775 * sp[79];
    A[1065] = 0.1015873015873019 * sp[76] + 0.1128747795414462 * sp[75] + 0.1128747795414462 * sp[77] + 0.01128747795414465 * sp[78] + 0.1015873015873016 * sp[76] + 0.1015873015873016 * sp[78] + -0.06772486772486708 * sp[79];
    A[1066] = 0.04514991181657866 * sp[74] + 0.01128747795414482 * sp[75] + 0.04514991181657863 * sp[76] + 0.01128747795414449 * sp[75] + 0.01128747795414454 * sp[78] + 0.04514991181657849 * sp[76] + 0.01128747795414503 * sp[78] + 0.04514991181657836 * sp[79];
    A[1067] = 0.02257495590828896 * sp[74] + 0.00282186948853596 * sp[75] + 0.02257495590828897 * sp[76] + 0.002821869488536157 * sp[75] + 0.002821869488536171 * sp[78] + 0.02257495590828891 * sp[76] + 0.002821869488535887 * sp[78] + 0.02257495590828887 * sp[79];
    A[1068] = 0.01128747795414459 * sp[75] + 0.01128747795414473 * sp[75] + 0.01128747795414472 * sp[78] + 0.01128747795414457 * sp[78];
    A[1069] = 0.0225749559082891 * sp[74] + 0.05643738977072293 * sp[75] + 0.05643738977072288 * sp[76] + 0.01128747795414449 * sp[75] + 0.02257495590828876 * sp[77] + 0.02257495590828886 * sp[78] + 0.05643738977072359 * sp[76] + 0.09029982363315721 * sp[78] + 0.0902998236331571 * sp[79];
    A[1070] = 0.005643738977072251 * sp[74] + 0.002821869488536322 * sp[75] + 0.002821869488536327 * sp[76] + 0.002821869488536079 * sp[75] + -0.01693121693121708 * sp[77] + -0.01693121693121701 * sp[78] + 0.002821869488535775 * sp[76] + 0.06772486772486765 * sp[78] + 0.06772486772486762 * sp[79];
    A[1071] = 0.02257495590828933 * sp[74] + -0.03386243386243423 * sp[75] + -0.03386243386243418 * sp[76] + 0.01128747795414488 * sp[75] + -0.02257495590828934 * sp[77] + -0.0225749559082891 * sp[78] + -0.03386243386243363 * sp[76];
    A[1072] = -0.1354497354497358 * sp[74] + -0.06772486772486783 * sp[75] + 0.04514991181657849 * sp[76] + -0.06772486772486842 * sp[75] + 0.06772486772486712 * sp[78] + 0.04514991181657879 * sp[76] + 0.06772486772486827 * sp[78];
    A[1073] = 0.06772486772486781 * sp[75] + 0.02257495590828887 * sp[76] + 0.06772486772486758 * sp[75] + 0.1354497354497353 * sp[77] + 0.04514991181657815 * sp[78] + 0.02257495590828939 * sp[76] + 0.04514991181657842 * sp[78];
    A[1074] = -0.2708994708994708 * sp[75] + -0.135449735449735 * sp[76] + -0.2708994708994699 * sp[75] + -0.5417989417989412 * sp[77] + -0.2708994708994699 * sp[78] + -0.1354497354497347 * sp[76] + -0.2708994708994698 * sp[78] + 0.04514991181657884 * sp[79];
    A[1075] = -0.1354497354497358 * sp[74] + -0.06772486772486828 * sp[75] + -0.1805996472663141 * sp[76] + -0.06772486772486709 * sp[75] + -0.04514991181657835 * sp[78] + -0.1805996472663136 * sp[76] + -0.04514991181657921 * sp[78] + -0.2257495590828917 * sp[79];
    A[1076] = -0.06772486772486695 * sp[75] + -0.0225749559082892 * sp[76] + -0.06772486772486759 * sp[75] + -0.04514991181657912 * sp[78] + -0.02257495590828939 * sp[76] + -0.04514991181657822 * sp[78] + -0.04514991181657826 * sp[79];
    A[1077] = 0.2708994708994708 * sp[75] + 0.1354497354497353 * sp[76] + 0.2708994708994699 * sp[75] + 0.1354497354497358 * sp[78] + 0.1354497354497348 * sp[76] + 0.1354497354497355 * sp[78] + 0.3160493827160482 * sp[79];
    A[1078] = -0.1354497354497341 * sp[74] + -0.2031746031746025 * sp[75] + -0.2257495590828914 * sp[76] + -0.06772486772486654 * sp[75] + -0.1354497354497345 * sp[77] + -0.09029982363315545 * sp[78] + -0.2257495590828923 * sp[76] + -0.3611992945326272 * sp[78] + -0.4514991181657842 * sp[79];
    A[1079] = -0.1354497354497367 * sp[74] + 0.0677248677248674 * sp[75] + 0.0902998236331564 * sp[76] + -0.0677248677248686 * sp[75] + 0.06772486772486719 * sp[78] + 0.09029982363315667 * sp[76] + -0.06772486772486806 * sp[78] + -0.135449735449736 * sp[79];
    A[1080] = 0.5417989417989414 * sp[74] + 0.2708994708994705 * sp[75] + 0.2708994708994702 * sp[76] + 0.2708994708994705 * sp[75] + 0.5417989417989409 * sp[77] + 0.2708994708994698 * sp[78] + 0.2708994708994702 * sp[76] + 0.2708994708994698 * sp[78] + 0.6320987654320975 * sp[79];
    A[1081] = -0.04514991181657876 * sp[74] + -0.02257495590828952 * sp[75] + -0.02257495590828982 * sp[75] + -0.04514991181657908 * sp[78] + -0.04514991181657953 * sp[78] + 0.04514991181657774 * sp[79];
    A[1082] = -0.04514991181657881 * sp[74] + -0.02257495590828918 * sp[75] + -0.04514991181657873 * sp[76] + -0.02257495590828869 * sp[75] + -0.06772486772486741 * sp[78] + -0.04514991181657801 * sp[76] + -0.0677248677248678 * sp[78];
    A[1083] = -0.04514991181657813 * sp[74] + -0.02257495590828889 * sp[75] + -0.0225749559082891 * sp[76] + -0.02257495590828952 * sp[75] + -0.04514991181657847 * sp[78] + -0.02257495590828897 * sp[76] + -0.04514991181657781 * sp[78];
    A[1084] = 0.2708994708994718 * sp[74] + 0.1354497354497356 * sp[75] + 0.1354497354497358 * sp[76] + 0.1354497354497354 * sp[75] + 0.3160493827160491 * sp[78] + 0.1354497354497352 * sp[76] + 0.3160493827160489 * sp[78] + -0.09029982363315611 * sp[79];
    A[1085] = 0.04232804232804181 * sp[74] + 0.04232804232804176 * sp[75] + 0.04232804232804181 * sp[76] + 0.04232804232804188 * sp[75] + 0.0423280423280421 * sp[77] + 0.04232804232804208 * sp[78] + 0.04938271604938252 * sp[76] + 0.04938271604938253 * sp[78] + 0.0493827160493826 * sp[79];
    A[1086] = -0.02539682539682569 * sp[74] + -0.007054673721340621 * sp[76];
    A[1087] = -0.02539682539682562 * sp[77] + -0.007054673721340358 * sp[78];
    A[1088] = 0.0183421516754851 * sp[79];
    A[1089] = 0.04514991181657863 * sp[77] + 0.03386243386243362 * sp[78] + 0.03386243386243427 * sp[78] + 0.02257495590828928 * sp[79];
    A[1090] = 0.02257495590828957 * sp[77] + 0.01975308641975331 * sp[78] + 0.01975308641975309 * sp[78] + 0.01693121693121719 * sp[79];
    A[1091] = -0.01128747795414443 * sp[78] + -0.01128747795414427 * sp[78] + -0.02257495590828926 * sp[79];
    A[1092] = 0.0451499118165784 * sp[74] + 0.03386243386243357 * sp[76] + 0.03386243386243418 * sp[76] + 0.02257495590828941 * sp[79];
    A[1093] = 0.02257495590828923 * sp[74] + 0.01975308641975337 * sp[76] + 0.01975308641975296 * sp[76] + 0.0169312169312165 * sp[79];
    A[1094] = -0.01128747795414473 * sp[76] + -0.01128747795414422 * sp[76] + -0.02257495590828868 * sp[79];
    A[1095] = 0.09029982363315683 * sp[74] + 0.03386243386243411 * sp[75] + 0.03386243386243387 * sp[75] + 0.06772486772486822 * sp[76] + 0.02257495590828983 * sp[78];
    A[1096] = 0.06772486772486655 * sp[74] + 0.06490299823632976 * sp[75] + 0.06490299823633003 * sp[75] + 0.06772486772486593 * sp[77] + 0.08465608465608274 * sp[76] + 0.0846560846560826 * sp[78];
    A[1097] = 0.03386243386243394 * sp[75] + 0.03386243386243395 * sp[75] + 0.09029982363315738 * sp[77] + 0.02257495590828963 * sp[76] + 0.06772486772486801 * sp[78];
    A[1098] = -0.1354497354497359 * sp[74] + -0.135449735449736 * sp[75] + -0.03386243386243361 * sp[76] + -0.1354497354497358 * sp[75] + -0.1354497354497356 * sp[77] + -0.03386243386243388 * sp[78] + -0.03386243386243409 * sp[76] + -0.03386243386243432 * sp[78] + -0.0451499118165787 * sp[79];
    A[1099] = 0.02257495590828957 * sp[74] + 0.02257495590828956 * sp[75] + -0.01975308641975305 * sp[76] + 0.02257495590828964 * sp[75] + 0.02257495590828966 * sp[77] + -0.01975308641975304 * sp[78] + -0.01975308641975251 * sp[76] + -0.01975308641975257 * sp[78] + 0.02257495590828942 * sp[79];
    A[1100] = 0.01128747795414465 * sp[76] + 0.0112874779541446 * sp[78] + 0.01128747795414412 * sp[76] + 0.01128747795414422 * sp[78] + -0.04514991181657809 * sp[79];
    A[1101] = -0.270899470899471 * sp[74] + -0.1693121693121684 * sp[75] + -0.270899470899471 * sp[76] + -0.1693121693121686 * sp[75] + -0.06772486772486733 * sp[77] + -0.1693121693121688 * sp[78] + -0.06772486772486692 * sp[76] + -0.07901234567901208 * sp[78] + -0.0677248677248676 * sp[79];
    A[1102] = 0.06772486772486655 * sp[74] + 0.1608465608465601 * sp[75] + 0.06772486772486654 * sp[76] + 0.1608465608465601 * sp[75] + -0.01693121693121753 * sp[77] + 0.1608465608465602 * sp[78] + 0.1185185185185179 * sp[76] + 0.02539682539682529 * sp[78] + 0.1185185185185182 * sp[79];
    A[1103] = -0.03386243386243345 * sp[75] + -0.03386243386243392 * sp[75] + 0.06772486772486792 * sp[77] + -0.03386243386243377 * sp[78] + -0.02257495590828962 * sp[76] + 0.01128747795414456 * sp[78] + -0.02257495590828967 * sp[79];
    A[1104] = -0.06772486772486645 * sp[74] + -0.1693121693121687 * sp[75] + -0.1693121693121687 * sp[76] + -0.1693121693121686 * sp[75] + -0.2708994708994705 * sp[77] + -0.2708994708994706 * sp[78] + -0.0790123456790119 * sp[76] + -0.06772486772486722 * sp[78] + -0.0677248677248671 * sp[79];
    A[1105] = -0.01693121693121823 * sp[74] + 0.1608465608465602 * sp[75] + 0.1608465608465602 * sp[76] + 0.1608465608465603 * sp[75] + 0.06772486772486638 * sp[77] + 0.06772486772486629 * sp[78] + 0.02539682539682511 * sp[76] + 0.1185185185185182 * sp[78] + 0.1185185185185182 * sp[79];
    A[1106] = 0.06772486772486859 * sp[74] + -0.03386243386243367 * sp[75] + -0.03386243386243371 * sp[76] + -0.03386243386243325 * sp[75] + 0.01128747795414486 * sp[76] + -0.02257495590828941 * sp[78] + -0.02257495590828965 * sp[79];
    A[1107] = 0.04514991181657716 * sp[74] + 0.04514991181657765 * sp[75] + 0.09029982363315464 * sp[76] + 0.04514991181657701 * sp[75] + 0.06772486772486555 * sp[78] + 0.09029982363315628 * sp[76] + 0.06772486772486777 * sp[78] + 0.1354497354497348 * sp[79];
    A[1108] = 0.04514991181657818 * sp[75] + 0.06772486772486687 * sp[76] + 0.04514991181657903 * sp[75] + 0.04514991181657826 * sp[77] + 0.09029982363315608 * sp[78] + 0.06772486772486837 * sp[76] + 0.09029982363315668 * sp[78] + 0.1354497354497347 * sp[79];
    A[1109] = 0.02257495590828991 * sp[75] + 0.04514991181657953 * sp[76] + 0.02257495590828988 * sp[75] + 0.0451499118165796 * sp[78] + 0.04514991181657915 * sp[76] + 0.04514991181657906 * sp[78] + 0.09029982363315767 * sp[79];
    A[1110] = 0.04514991181657724 * sp[74] + 0.180599647266314 * sp[75] + 0.3160493827160503 * sp[76] + 0.1805996472663138 * sp[75] + 0.3160493827160498 * sp[77] + 0.1805996472663141 * sp[78] + 0.3160493827160488 * sp[76] + 0.1805996472663139 * sp[78] + 0.04514991181657874 * sp[79];
    A[1111] = -0.04514991181657822 * sp[75] + -0.06772486772486713 * sp[76] + -0.04514991181657908 * sp[75] + -0.2257495590828927 * sp[77] + -0.180599647266314 * sp[78] + -0.0677248677248684 * sp[76] + -0.1805996472663136 * sp[78] + -0.1354497354497357 * sp[79];
    A[1112] = -0.02257495590828946 * sp[75] + -0.04514991181657925 * sp[76] + -0.02257495590828976 * sp[75] + -0.04514991181657905 * sp[77] + -0.04514991181657903 * sp[76] + 0.04514991181657799 * sp[79];
    A[1113] = 0.3160493827160496 * sp[74] + 0.1805996472663133 * sp[75] + 0.1805996472663138 * sp[76] + 0.1805996472663137 * sp[75] + 0.04514991181657765 * sp[77] + 0.3160493827160502 * sp[78] + 0.1805996472663133 * sp[76] + 0.3160493827160488 * sp[78] + 0.04514991181657774 * sp[79];
    A[1114] = -0.2257495590828922 * sp[74] + -0.04514991181657772 * sp[75] + -0.1805996472663134 * sp[76] + -0.04514991181657763 * sp[75] + -0.06772486772486611 * sp[78] + -0.1805996472663133 * sp[76] + -0.06772486772486773 * sp[78] + -0.1354497354497348 * sp[79];
    A[1115] = -0.04514991181657876 * sp[74] + -0.02257495590828982 * sp[75] + -0.02257495590828952 * sp[75] + -0.04514991181657953 * sp[78] + -0.04514991181657908 * sp[78] + 0.04514991181657774 * sp[79];
    A[1116] = 0.6320987654320985 * sp[74] + 0.3611992945326259 * sp[75] + 0.3611992945326257 * sp[76] + 0.3611992945326259 * sp[75] + 0.6320987654320983 * sp[77] + 0.3611992945326258 * sp[78] + 0.3611992945326257 * sp[76] + 0.3611992945326258 * sp[78] + 0.6320987654320968 * sp[79];
    A[1117] = -0.4514991181657844 * sp[74] + -0.2257495590828907 * sp[75] + -0.09029982363315509 * sp[76] + -0.2257495590828913 * sp[75] + -0.1354497354497329 * sp[77] + -0.06772486772486586 * sp[78] + -0.3611992945326272 * sp[76] + -0.2031746031746017 * sp[78] + -0.1354497354497345 * sp[79];
    A[1118] = -0.135449735449733 * sp[74] + -0.2257495590828908 * sp[75] + -0.06772486772486665 * sp[76] + -0.2257495590828901 * sp[75] + -0.4514991181657844 * sp[77] + -0.09029982363315564 * sp[78] + -0.2031746031746005 * sp[76] + -0.3611992945326263 * sp[78] + -0.1354497354497338 * sp[79];
    A[1119] = -0.09029982363315434 * sp[74] + -0.2257495590828914 * sp[75] + -0.4063492063492056 * sp[76] + -0.2257495590828908 * sp[75] + -0.09029982363315578 * sp[77] + -0.406349206349206 * sp[78] + -0.4063492063492052 * sp[76] + -0.4063492063492058 * sp[78] + -0.7223985890652558 * sp[79];
    A[1120] = -0.02539682539682512 * sp[74] + -0.02539682539682492 * sp[75] + -0.02539682539682503 * sp[76] + -0.02539682539682497 * sp[75] + -0.02539682539682501 * sp[77] + -0.02539682539682508 * sp[78] + -0.01834215167548461 * sp[76] + -0.01834215167548474 * sp[78] + -0.01834215167548474 * sp[79];
    A[1121] = 0.04232804232804262 * sp[74] + -0.007054673721339957 * sp[76];
    A[1122] = -0.02539682539682551 * sp[77] + -0.007054673721340429 * sp[78];
    A[1123] = 0.01834215167548508 * sp[79];
    A[1124] = 0.0451499118165786 * sp[77] + 0.03386243386243402 * sp[78] + 0.03386243386243347 * sp[78] + 0.02257495590828876 * sp[79];
    A[1125] = 0.02257495590828939 * sp[77] + 0.0197530864197527 * sp[78] + 0.01975308641975331 * sp[78] + 0.01693121693121712 * sp[79];
    A[1126] = -0.01128747795414422 * sp[78] + -0.01128747795414464 * sp[78] + -0.02257495590828942 * sp[79];
    A[1127] = -0.1354497354497354 * sp[74] + -0.1015873015873011 * sp[76] + -0.1015873015873014 * sp[76] + -0.1128747795414454 * sp[79];
    A[1128] = 0.0225749559082895 * sp[74] + 0.04232804232804225 * sp[76] + 0.04232804232804212 * sp[76] + 0.08465608465608371 * sp[79];
    A[1129] = -0.0112874779541447 * sp[76] + -0.01128747795414461 * sp[76] + -0.06772486772486719 * sp[79];
    A[1130] = -0.2708994708994703 * sp[74] + -0.1015873015873013 * sp[75] + -0.1015873015873007 * sp[75] + -0.2031746031746026 * sp[76] + -0.1128747795414456 * sp[78];
    A[1131] = 0.06772486772486788 * sp[74] + -0.09312169312169237 * sp[75] + -0.09312169312169316 * sp[75] + -0.27089947089947 * sp[77] + -0.05079365079365068 * sp[76] + -0.186243386243386 * sp[78];
    A[1132] = 0.0338624338624337 * sp[75] + 0.03386243386243437 * sp[75] + 0.1354497354497355 * sp[77] + 0.0225749559082892 * sp[76] + 0.06772486772486749 * sp[78];
    A[1133] = 0.04514991181657881 * sp[74] + 0.04514991181657883 * sp[75] + 0.0112874779541443 * sp[76] + 0.04514991181657832 * sp[75] + 0.0451499118165786 * sp[77] + 0.0112874779541447 * sp[78] + 0.01128747795414436 * sp[76] + 0.01128747795414458 * sp[78];
    A[1134] = 0.02257495590828933 * sp[74] + 0.02257495590828935 * sp[75] + 0.002821869488536339 * sp[76] + 0.02257495590828929 * sp[75] + 0.02257495590828921 * sp[77] + 0.002821869488536142 * sp[78] + 0.002821869488536574 * sp[76] + 0.002821869488536447 * sp[78];
    A[1135] = 0.01128747795414432 * sp[76] + 0.01128747795414469 * sp[78] + 0.01128747795414456 * sp[76] + 0.01128747795414463 * sp[78];
    A[1136] = 0.09029982363315724 * sp[74] + 0.05643738977072232 * sp[75] + 0.09029982363315722 * sp[76] + 0.05643738977072218 * sp[75] + 0.02257495590828859 * sp[77] + 0.05643738977072262 * sp[78] + 0.02257495590828837 * sp[76] + 0.01128747795414388 * sp[78] + 0.02257495590828863 * sp[79];
    A[1137] = 0.06772486772486762 * sp[74] + 0.002821869488536661 * sp[75] + 0.06772486772486762 * sp[76] + 0.002821869488536863 * sp[75] + 0.00564373897707203 * sp[77] + 0.002821869488536349 * sp[78] + -0.0169312169312166 * sp[76] + 0.002821869488536028 * sp[78] + -0.01693121693121711 * sp[79];
    A[1138] = -0.03386243386243441 * sp[75] + -0.03386243386243436 * sp[75] + 0.02257495590828972 * sp[77] + -0.03386243386243402 * sp[78] + -0.02257495590828919 * sp[76] + 0.01128747795414484 * sp[78] + -0.02257495590828898 * sp[79];
    A[1139] = 0.06772486772486655 * sp[74] + 0.1015873015873009 * sp[75] + 0.101587301587301 * sp[76] + 0.1015873015873005 * sp[75] + 0.1354497354497343 * sp[77] + 0.1354497354497343 * sp[78] + 0.05643738977072179 * sp[76] + 0.06772486772486672 * sp[78] + 0.06772486772486669 * sp[79];
    A[1140] = -0.01693121693121518 * sp[74] + -0.1777777777777768 * sp[75] + -0.1777777777777767 * sp[76] + -0.1777777777777769 * sp[75] + -0.2708994708994706 * sp[77] + -0.2708994708994707 * sp[78] + -0.04232804232804046 * sp[76] + -0.0846560846560836 * sp[78] + -0.08465608465608357 * sp[79];
    A[1141] = -0.06772486772486887 * sp[74] + 0.1015873015873012 * sp[75] + 0.1015873015873013 * sp[76] + 0.1015873015873014 * sp[75] + 0.01128747795414339 * sp[76] + 0.1128747795414458 * sp[78] + 0.1128747795414459 * sp[79];
    A[1142] = 0.04514991181657946 * sp[74] + -0.1354497354497347 * sp[75] + -0.2708994708994695 * sp[76] + -0.1354497354497347 * sp[75] + -0.2708994708994696 * sp[78] + -0.2708994708994698 * sp[76] + -0.2708994708994706 * sp[78] + -0.5417989417989411 * sp[79];
    A[1143] = 0.04514991181657873 * sp[75] + 0.06772486772486776 * sp[76] + 0.04514991181657917 * sp[75] + -0.1354497354497346 * sp[77] + -0.06772486772486701 * sp[78] + 0.06772486772486787 * sp[76] + -0.06772486772486674 * sp[78];
    A[1144] = 0.02257495590828863 * sp[75] + 0.04514991181657796 * sp[76] + 0.02257495590828936 * sp[75] + 0.06772486772486799 * sp[78] + 0.04514991181657829 * sp[76] + 0.06772486772486701 * sp[78] + 0.1354497354497353 * sp[79];
    A[1145] = 0.04514991181657869 * sp[74] + -0.04514991181657907 * sp[76] + -0.04514991181657854 * sp[77] + -0.0225749559082896 * sp[78] + -0.04514991181657833 * sp[76] + -0.02257495590828994 * sp[78];
    A[1146] = -0.04514991181657782 * sp[75] + -0.06772486772486759 * sp[76] + -0.04514991181657923 * sp[75] + -0.04514991181657873 * sp[77] + -0.022574955908289 * sp[78] + -0.06772486772486799 * sp[76] + -0.02257495590828828 * sp[78];
    A[1147] = -0.02257495590828933 * sp[75] + -0.04514991181657794 * sp[76] + -0.02257495590828943 * sp[75] + -0.0451499118165786 * sp[77] + -0.02257495590828887 * sp[78] + -0.04514991181657836 * sp[76] + -0.02257495590828954 * sp[78];
    A[1148] = -0.2257495590828922 * sp[74] + -0.1805996472663134 * sp[75] + -0.04514991181657781 * sp[76] + -0.1805996472663142 * sp[75] + -0.1354497354497359 * sp[77] + -0.06772486772486686 * sp[78] + -0.04514991181657824 * sp[76] + -0.06772486772486713 * sp[78];
    A[1149] = 0.3160493827160489 * sp[74] + 0.1354497354497346 * sp[75] + 0.135449735449735 * sp[76] + 0.1354497354497357 * sp[75] + 0.2708994708994717 * sp[78] + 0.1354497354497352 * sp[76] + 0.27089947089947 * sp[78];
    A[1150] = -0.04514991181657881 * sp[74] + -0.02257495590828869 * sp[75] + -0.04514991181657801 * sp[76] + -0.02257495590828918 * sp[75] + -0.0677248677248678 * sp[78] + -0.04514991181657873 * sp[76] + -0.06772486772486741 * sp[78];
    A[1151] = -0.4514991181657844 * sp[74] + -0.2257495590828913 * sp[75] + -0.3611992945326272 * sp[76] + -0.2257495590828907 * sp[75] + -0.1354497354497329 * sp[77] + -0.2031746031746017 * sp[78] + -0.09029982363315509 * sp[76] + -0.06772486772486586 * sp[78] + -0.1354497354497345 * sp[79];
    A[1152] = 0.6320987654320973 * sp[74] + 0.2708994708994692 * sp[75] + 0.2708994708994692 * sp[76] + 0.2708994708994692 * sp[75] + 0.5417989417989408 * sp[77] + 0.2708994708994691 * sp[78] + 0.2708994708994692 * sp[76] + 0.2708994708994691 * sp[78] + 0.5417989417989397 * sp[79];
    A[1153] = -0.1354497354497357 * sp[74] + 0.09029982363315692 * sp[75] + -0.06772486772486776 * sp[76] + 0.09029982363315626 * sp[75] + -0.1354497354497372 * sp[77] + 0.06772486772486658 * sp[78] + 0.06772486772486727 * sp[76] + -0.06772486772486756 * sp[78];
    A[1154] = -0.09029982363315821 * sp[74] + 0.1354497354497346 * sp[75] + 0.3160493827160492 * sp[76] + 0.1354497354497343 * sp[75] + 0.2708994708994707 * sp[77] + 0.1354497354497351 * sp[78] + 0.3160493827160483 * sp[76] + 0.1354497354497346 * sp[78];
    A[1155] = -0.02539682539682482 * sp[74] + -0.02539682539682509 * sp[75] + -0.02539682539682504 * sp[76] + -0.0253968253968252 * sp[75] + -0.02539682539682534 * sp[77] + -0.02539682539682531 * sp[78] + -0.01834215167548483 * sp[76] + -0.01834215167548489 * sp[78] + -0.01834215167548493 * sp[79];
    A[1156] = -0.02539682539682524 * sp[74] + -0.007054673721340255 * sp[76];
    A[1157] = 0.04232804232804273 * sp[77] + -0.007054673721340233 * sp[78];
    A[1158] = 0.01834215167548508 * sp[79];
    A[1159] = -0.1354497354497357 * sp[77] + -0.1015873015873009 * sp[78] + -0.1015873015873017 * sp[78] + -0.1128747795414455 * sp[79];
    A[1160] = 0.02257495590828919 * sp[77] + 0.04232804232804201 * sp[78] + 0.04232804232804224 * sp[78] + 0.08465608465608387 * sp[79];
    A[1161] = -0.01128747795414463 * sp[78] + -0.0112874779541446 * sp[78] + -0.06772486772486695 * sp[79];
    A[1162] = 0.04514991181657842 * sp[74] + 0.03386243386243375 * sp[76] + 0.03386243386243371 * sp[76] + 0.02257495590828931 * sp[79];
    A[1163] = 0.02257495590828922 * sp[74] + 0.01975308641975313 * sp[76] + 0.01975308641975289 * sp[76] + 0.01693121693121655 * sp[79];
    A[1164] = -0.01128747795414452 * sp[76] + -0.01128747795414451 * sp[76] + -0.02257495590828932 * sp[79];
    A[1165] = 0.1354497354497347 * sp[74] + 0.03386243386243308 * sp[75] + 0.03386243386243295 * sp[75] + 0.06772486772486708 * sp[76] + 0.02257495590828851 * sp[78];
    A[1166] = -0.2708994708994692 * sp[74] + -0.09312169312169156 * sp[75] + -0.09312169312169108 * sp[75] + 0.06772486772486949 * sp[77] + -0.1862433862433847 * sp[76] + -0.05079365079364938 * sp[78];
    A[1167] = -0.1015873015873014 * sp[75] + -0.1015873015873022 * sp[75] + -0.2708994708994716 * sp[77] + -0.1128747795414472 * sp[76] + -0.203174603174604 * sp[78];
    A[1168] = 0.04514991181657846 * sp[74] + 0.04514991181657851 * sp[75] + 0.01128747795414442 * sp[76] + 0.04514991181657869 * sp[75] + 0.04514991181657844 * sp[77] + 0.01128747795414452 * sp[78] + 0.01128747795414461 * sp[76] + 0.01128747795414461 * sp[78];
    A[1169] = 0.02257495590828884 * sp[74] + 0.0225749559082888 * sp[75] + 0.002821869488536243 * sp[76] + 0.02257495590828888 * sp[75] + 0.02257495590828891 * sp[77] + 0.002821869488536312 * sp[78] + 0.002821869488536174 * sp[76] + 0.00282186948853604 * sp[78];
    A[1170] = 0.01128747795414468 * sp[76] + 0.01128747795414425 * sp[78] + 0.01128747795414447 * sp[76] + 0.01128747795414455 * sp[78];
    A[1171] = 0.1354497354497339 * sp[74] + 0.1015873015873008 * sp[75] + 0.1354497354497345 * sp[76] + 0.1015873015873008 * sp[75] + 0.06772486772486726 * sp[77] + 0.1015873015873009 * sp[78] + 0.06772486772486713 * sp[76] + 0.05643738977072264 * sp[78] + 0.06772486772486702 * sp[79];
    A[1172] = -0.270899470899469 * sp[74] + -0.1777777777777773 * sp[75] + -0.2708994708994695 * sp[76] + -0.177777777777777 * sp[75] + -0.01693121693121578 * sp[77] + -0.1777777777777767 * sp[78] + -0.08465608465608401 * sp[76] + -0.04232804232804188 * sp[78] + -0.08465608465608362 * sp[79];
    A[1173] = 0.1015873015873019 * sp[75] + 0.1015873015873022 * sp[75] + -0.06772486772486827 * sp[77] + 0.1015873015873017 * sp[78] + 0.1128747795414473 * sp[76] + 0.01128747795414485 * sp[78] + 0.1128747795414467 * sp[79];
    A[1174] = 0.02257495590828858 * sp[74] + 0.05643738977072267 * sp[75] + 0.05643738977072262 * sp[76] + 0.05643738977072318 * sp[75] + 0.09029982363315717 * sp[77] + 0.09029982363315701 * sp[78] + 0.01128747795414456 * sp[76] + 0.02257495590828903 * sp[78] + 0.02257495590828867 * sp[79];
    A[1175] = 0.005643738977072191 * sp[74] + 0.002821869488536115 * sp[75] + 0.002821869488536162 * sp[76] + 0.002821869488535715 * sp[75] + 0.06772486772486822 * sp[77] + 0.06772486772486819 * sp[78] + 0.00282186948853582 * sp[76] + -0.01693121693121705 * sp[78] + -0.01693121693121742 * sp[79];
    A[1176] = 0.02257495590828933 * sp[74] + -0.03386243386243369 * sp[75] + -0.03386243386243364 * sp[76] + -0.03386243386243398 * sp[75] + 0.0112874779541448 * sp[76] + -0.02257495590828867 * sp[78] + -0.02257495590828918 * sp[79];
    A[1177] = -0.1354497354497348 * sp[74] + 0.04514991181657871 * sp[75] + -0.06772486772486726 * sp[76] + 0.04514991181657903 * sp[75] + 0.06772486772486808 * sp[78] + -0.06772486772486612 * sp[76] + 0.06772486772486802 * sp[78];
    A[1178] = -0.1354497354497354 * sp[75] + -0.2708994708994696 * sp[76] + -0.1354497354497362 * sp[75] + 0.04514991181657894 * sp[77] + -0.2708994708994705 * sp[78] + -0.2708994708994725 * sp[76] + -0.2708994708994711 * sp[78] + -0.5417989417989429 * sp[79];
    A[1179] = 0.0225749559082894 * sp[75] + 0.06772486772486724 * sp[76] + 0.02257495590828867 * sp[75] + 0.04514991181657763 * sp[78] + 0.06772486772486731 * sp[76] + 0.0451499118165781 * sp[78] + 0.1354497354497352 * sp[79];
    A[1180] = -0.1354497354497344 * sp[74] + -0.1805996472663133 * sp[75] + -0.06772486772486745 * sp[76] + -0.1805996472663139 * sp[75] + -0.2257495590828922 * sp[77] + -0.04514991181657805 * sp[78] + -0.06772486772486788 * sp[76] + -0.0451499118165784 * sp[78];
    A[1181] = 0.1354497354497342 * sp[75] + 0.2708994708994709 * sp[76] + 0.1354497354497363 * sp[75] + 0.3160493827160494 * sp[77] + 0.1354497354497349 * sp[78] + 0.2708994708994726 * sp[76] + 0.1354497354497357 * sp[78];
    A[1182] = -0.02257495590828873 * sp[75] + -0.0677248677248674 * sp[76] + -0.02257495590828878 * sp[75] + -0.04514991181657815 * sp[77] + -0.04514991181657765 * sp[78] + -0.06772486772486748 * sp[76] + -0.0451499118165781 * sp[78];
    A[1183] = -0.04514991181657874 * sp[74] + -0.02257495590828945 * sp[76] + 0.04514991181657894 * sp[77] + -0.04514991181657897 * sp[78] + -0.02257495590828986 * sp[76] + -0.04514991181657874 * sp[78];
    A[1184] = -0.04514991181657817 * sp[74] + -0.0451499118165786 * sp[75] + -0.02257495590828974 * sp[76] + -0.04514991181657869 * sp[75] + -0.06772486772486851 * sp[78] + -0.02257495590828876 * sp[76] + -0.0677248677248676 * sp[78];
    A[1185] = -0.04514991181657813 * sp[74] + -0.02257495590828952 * sp[75] + -0.02257495590828897 * sp[76] + -0.02257495590828889 * sp[75] + -0.04514991181657781 * sp[78] + -0.0225749559082891 * sp[76] + -0.04514991181657847 * sp[78];
    A[1186] = -0.135449735449733 * sp[74] + -0.2257495590828901 * sp[75] + -0.2031746031746005 * sp[76] + -0.2257495590828908 * sp[75] + -0.4514991181657844 * sp[77] + -0.3611992945326263 * sp[78] + -0.06772486772486665 * sp[76] + -0.09029982363315564 * sp[78] + -0.1354497354497338 * sp[79];
    A[1187] = -0.1354497354497357 * sp[74] + 0.09029982363315626 * sp[75] + 0.06772486772486727 * sp[76] + 0.09029982363315692 * sp[75] + -0.1354497354497372 * sp[77] + -0.06772486772486756 * sp[78] + -0.06772486772486776 * sp[76] + 0.06772486772486658 * sp[78];
    A[1188] = 0.5417989417989384 * sp[74] + 0.2708994708994682 * sp[75] + 0.2708994708994689 * sp[76] + 0.2708994708994682 * sp[75] + 0.6320987654320983 * sp[77] + 0.27089947089947 * sp[78] + 0.2708994708994689 * sp[76] + 0.27089947089947 * sp[78] + 0.5417989417989418 * sp[79];
    A[1189] = 0.2708994708994692 * sp[74] + 0.1354497354497354 * sp[75] + 0.1354497354497349 * sp[76] + 0.1354497354497348 * sp[75] + -0.09029982363315819 * sp[77] + 0.316049382716049 * sp[78] + 0.1354497354497342 * sp[76] + 0.316049382716049 * sp[78];
    A[1190] = -0.06772486772486763 * sp[74] + -0.06772486772486801 * sp[75] + -0.06772486772486805 * sp[76] + -0.06772486772486802 * sp[75] + -0.06772486772486797 * sp[77] + -0.0677248677248681 * sp[78] + -0.06772486772486772 * sp[76] + -0.06772486772486776 * sp[78] + -0.06772486772486785 * sp[79];
    A[1191] = -0.06772486772486747 * sp[74];
    A[1192] = -0.06772486772486794 * sp[77];
    A[1193] = -0.06772486772486755 * sp[79];
    A[1194] = 0.090299823633157 * sp[77];
    A[1195] = -0.1354497354497358 * sp[77] + -0.1128747795414463 * sp[78] + -0.1128747795414465 * sp[78] + -0.1354497354497347 * sp[79];
    A[1196] = 0.09029982363315664 * sp[79];
    A[1197] = 0.09029982363315775 * sp[74];
    A[1198] = -0.1354497354497363 * sp[74] + -0.1128747795414472 * sp[76] + -0.1128747795414458 * sp[76] + -0.1354497354497348 * sp[79];
    A[1199] = 0.09029982363315654 * sp[79];
    A[1200] = 0.09029982363315699 * sp[74];
    A[1201] = -0.1354497354497345 * sp[74] + -0.1128747795414453 * sp[75] + -0.1128747795414458 * sp[75] + -0.1354497354497347 * sp[77];
    A[1202] = 0.090299823633157 * sp[77];
    A[1203] = 0.09029982363315664 * sp[74] + 0.09029982363315713 * sp[75] + 0.09029982363315821 * sp[76] + 0.09029982363315701 * sp[75] + 0.09029982363315764 * sp[77] + 0.09029982363315833 * sp[78] + 0.09029982363315729 * sp[76] + 0.09029982363315758 * sp[78] + 0.09029982363315739 * sp[79];
    A[1204] = -0.1354497354497359 * sp[74] + -0.135449735449736 * sp[75] + -0.02257495590829078 * sp[76] + -0.1354497354497355 * sp[75] + -0.1354497354497356 * sp[77] + -0.02257495590829051 * sp[78] + -0.02257495590829018 * sp[76] + -0.02257495590829001 * sp[78] + -0.04514991181657929 * sp[79];
    A[1205] = 0.09029982363315686 * sp[79];
    A[1206] = 0.09029982363315545 * sp[74] + 0.09029982363315749 * sp[75] + 0.09029982363315633 * sp[76] + 0.09029982363315647 * sp[75] + 0.09029982363315754 * sp[77] + 0.09029982363315672 * sp[78] + 0.09029982363315658 * sp[76] + 0.09029982363315711 * sp[78] + 0.09029982363315725 * sp[79];
    A[1207] = -0.1354497354497349 * sp[74] + -0.02257495590828983 * sp[75] + -0.1354497354497354 * sp[76] + -0.02257495590828957 * sp[75] + -0.04514991181657966 * sp[77] + -0.02257495590828965 * sp[78] + -0.1354497354497358 * sp[76] + -0.02257495590828963 * sp[78] + -0.135449735449736 * sp[79];
    A[1208] = 0.09029982363315793 * sp[77];
    A[1209] = 0.09029982363315697 * sp[74] + 0.09029982363315632 * sp[75] + 0.09029982363315603 * sp[76] + 0.09029982363315747 * sp[75] + 0.0902998236331566 * sp[77] + 0.09029982363315613 * sp[78] + 0.09029982363315681 * sp[76] + 0.09029982363315658 * sp[78] + 0.0902998236331566 * sp[79];
    A[1210] = -0.04514991181657853 * sp[74] + -0.02257495590828887 * sp[75] + -0.02257495590828876 * sp[76] + -0.02257495590828964 * sp[75] + -0.1354497354497358 * sp[77] + -0.135449735449736 * sp[78] + -0.02257495590828919 * sp[76] + -0.1354497354497354 * sp[78] + -0.1354497354497352 * sp[79];
    A[1211] = 0.09029982363315701 * sp[74];
    A[1212] = -0.7223985890652561 * sp[74] + -0.3160493827160499 * sp[75] + -0.3160493827160497 * sp[76] + -0.3160493827160484 * sp[75] + -0.1354497354497344 * sp[78] + -0.31604938271605 * sp[76] + -0.1354497354497357 * sp[78];
    A[1213] = -0.3160493827160489 * sp[75] + -0.1354497354497353 * sp[76] + -0.3160493827160505 * sp[75] + -0.7223985890652566 * sp[77] + -0.3160493827160504 * sp[78] + -0.1354497354497362 * sp[76] + -0.3160493827160505 * sp[78];
    A[1214] = -0.1354497354497359 * sp[75] + -0.3160493827160494 * sp[76] + -0.1354497354497361 * sp[75] + -0.3160493827160501 * sp[78] + -0.3160493827160495 * sp[76] + -0.3160493827160492 * sp[78] + -0.7223985890652554 * sp[79];
    A[1215] = -0.7223985890652563 * sp[74] + -0.4063492063492077 * sp[75] + -0.4063492063492065 * sp[76] + -0.406349206349207 * sp[75] + -0.09029982363315793 * sp[77] + -0.225749559082892 * sp[78] + -0.4063492063492067 * sp[76] + -0.2257495590828931 * sp[78] + -0.09029982363315747 * sp[79];
    A[1216] = 0.3160493827160504 * sp[75] + 0.135449735449736 * sp[76] + 0.3160493827160505 * sp[75] + -0.09029982363315679 * sp[77] + 0.1354497354497366 * sp[78] + 0.1354497354497363 * sp[76] + 0.1354497354497353 * sp[78] + 0.2708994708994716 * sp[79];
    A[1217] = 0.135449735449736 * sp[75] + 0.3160493827160493 * sp[76] + 0.1354497354497359 * sp[75] + 0.2708994708994715 * sp[77] + 0.1354497354497344 * sp[78] + 0.3160493827160494 * sp[76] + 0.1354497354497364 * sp[78] + -0.09029982363315643 * sp[79];
    A[1218] = -0.09029982363315565 * sp[74] + -0.4063492063492055 * sp[75] + -0.2257495590828905 * sp[76] + -0.4063492063492065 * sp[75] + -0.722398589065256 * sp[77] + -0.406349206349205 * sp[78] + -0.2257495590828911 * sp[76] + -0.4063492063492057 * sp[78] + -0.090299823633156 * sp[79];
    A[1219] = -0.09029982363315862 * sp[74] + 0.316049382716049 * sp[75] + 0.1354497354497341 * sp[76] + 0.316049382716049 * sp[75] + 0.135449735449735 * sp[78] + 0.135449735449734 * sp[76] + 0.1354497354497351 * sp[78] + 0.2708994708994686 * sp[79];
    A[1220] = 0.2708994708994718 * sp[74] + 0.1354497354497354 * sp[75] + 0.1354497354497352 * sp[76] + 0.1354497354497356 * sp[75] + 0.3160493827160489 * sp[78] + 0.1354497354497358 * sp[76] + 0.3160493827160491 * sp[78] + -0.09029982363315611 * sp[79];
    A[1221] = -0.09029982363315434 * sp[74] + -0.2257495590828908 * sp[75] + -0.4063492063492052 * sp[76] + -0.2257495590828914 * sp[75] + -0.09029982363315578 * sp[77] + -0.4063492063492058 * sp[78] + -0.4063492063492056 * sp[76] + -0.406349206349206 * sp[78] + -0.7223985890652558 * sp[79];
    A[1222] = -0.09029982363315821 * sp[74] + 0.1354497354497343 * sp[75] + 0.3160493827160483 * sp[76] + 0.1354497354497346 * sp[75] + 0.2708994708994707 * sp[77] + 0.1354497354497346 * sp[78] + 0.3160493827160492 * sp[76] + 0.1354497354497351 * sp[78];
    A[1223] = 0.2708994708994692 * sp[74] + 0.1354497354497348 * sp[75] + 0.1354497354497342 * sp[76] + 0.1354497354497354 * sp[75] + -0.09029982363315819 * sp[77] + 0.316049382716049 * sp[78] + 0.1354497354497349 * sp[76] + 0.316049382716049 * sp[78];
    A[1224] = 1.444797178130513 * sp[74] + 0.7223985890652563 * sp[75] + 0.7223985890652571 * sp[76] + 0.7223985890652563 * sp[75] + 1.444797178130512 * sp[77] + 0.7223985890652571 * sp[78] + 0.7223985890652571 * sp[76] + 0.7223985890652571 * sp[78] + 1.444797178130512 * sp[79];
}


poisson3d_4_cell_integral_1_otherwise::poisson3d_4_cell_integral_1_otherwise() : ufc::cell_integral()
{

}

poisson3d_4_cell_integral_1_otherwise::~poisson3d_4_cell_integral_1_otherwise()
{

}

const std::vector<bool> & poisson3d_4_cell_integral_1_otherwise::enabled_coefficients() const
{
static const std::vector<bool> enabled({true});
return enabled;
}

void poisson3d_4_cell_integral_1_otherwise::tabulate_tensor(double * A,
                                    const double * const * w,
                                    const double * coordinate_dofs,
                                    int cell_orientation) const
{
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 8
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 8
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           8
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Quadrature rules
    alignas(32) static const double weights125[125] = { 0.0009374398217669896, 0.00144688123847005, 0.001022687015780538, 0.0003675200380073259, 4.716533650593668e-5, 0.00161927658526932, 0.002499254732643926, 0.001766527408224398, 0.0006348317815652555, 8.147053631288457e-5, 0.001417924532550919, 0.00218848010941899, 0.001546865169503061, 0.000555892406098535, 7.133992621705589e-5, 0.0007158915019438664, 0.0011049349077046, 0.0007809919386245139, 0.0002806627859136635, 3.601859320129841e-5, 0.0001525364704986181, 0.0002354307468301134, 0.0001664075540527897, 5.980139538929234e-5, 7.674555521798026e-6, 0.001893772314860291, 0.002922922163836156, 0.002065984730200279, 0.0007424468824279085, 9.528121850813992e-5, 0.003271187222988238, 0.005048878136564872, 0.003568656484883998, 0.00128245763045955, 0.0001645829871568122, 0.002864425173708474, 0.004421065701079484, 0.003124905049696836, 0.001122987976685449, 0.0001441175999536503, 0.001446210706378578, 0.002232138094997412, 0.001577723579854278, 0.000566981902660168, 7.276308627071377e-5, 0.0003081470811558803, 0.0004756062416607817, 0.0003361687988193031, 0.0001208079967893717, 1.550378001720074e-5, 0.00225090157446144, 0.00347412941301363, 0.002455589959537544, 0.0008824581727683852, 0.0001132494350422472, 0.003888070605322779, 0.006001000045085255, 0.004241636883961954, 0.001524304625709162, 0.0001956201925721813, 0.00340460100870312, 0.00525479418474413, 0.003714202410295571, 0.00133476204345559, 0.0001712954245332323, 0.001718938401647658, 0.002653076672955637, 0.001875252089225375, 0.0006739038517854064, 8.648481349327676e-5, 0.0003662577305079242, 0.0005652964877443141, 0.000399563808494583, 0.0001435900757693727, 1.842749657758908e-5, 0.001893772314860291, 0.002922922163836156, 0.002065984730200279, 0.0007424468824279085, 9.528121850813992e-5, 0.003271187222988238, 0.005048878136564872, 0.003568656484883998, 0.00128245763045955, 0.0001645829871568122, 0.002864425173708474, 0.004421065701079484, 0.003124905049696836, 0.001122987976685449, 0.0001441175999536503, 0.001446210706378578, 0.002232138094997412, 0.001577723579854278, 0.000566981902660168, 7.276308627071377e-5, 0.0003081470811558803, 0.0004756062416607817, 0.0003361687988193031, 0.0001208079967893717, 1.550378001720074e-5, 0.0009374398217669897, 0.00144688123847005, 0.001022687015780538, 0.000367520038007326, 4.716533650593669e-5, 0.00161927658526932, 0.002499254732643926, 0.001766527408224398, 0.0006348317815652555, 8.147053631288457e-5, 0.001417924532550919, 0.002188480109418991, 0.001546865169503061, 0.0005558924060985351, 7.133992621705591e-5, 0.0007158915019438664, 0.0011049349077046, 0.0007809919386245139, 0.0002806627859136635, 3.601859320129841e-5, 0.0001525364704986181, 0.0002354307468301134, 0.0001664075540527897, 5.980139538929235e-5, 7.674555521798026e-6 };
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE11_C0_Q125[1][125][35] =
        { { { 0.3056635451225204, -0.03089560263777415, -0.02848613965062154, -0.0264567387485711, 0.005537192654111686, 0.003876453322753179, 0.005685150503339748, 0.006048490355209489, 0.004281258226563778, 0.006432425094469172, 0.006722684097752766, 0.004673328833782206, 0.006963348270947702, 0.3166833328790704, -0.2668309357797834, 0.1306900334822619, 0.3519823759222684, -0.2912668752815561, 0.1414770021125194, 0.3982480791604773, -0.321682889512789, 0.154540818103216, -0.001527638682314703, -0.001565007970467022, -0.001593519373486176, 0.095210622103163, -0.03179686371104683, -0.03237614075826646, 0.107725414571985, -0.035117302597923, -0.03663176553605663, 0.1197330059133173, -0.03903164556221914, -0.03998644254854885, 0.01307094762169419 },
            { 0.006690843711503991, -0.02786989772001725, -0.02552167167239571, -0.02665480921729697, 0.02469686349179408, 0.006068756454277287, 0.006085065396913874, 0.02713284359297074, 0.006729661048754568, 0.006884906096610958, 0.005146226673233592, 0.003621314230994687, 0.005299906069221718, 0.7268804203624039, -0.3254097733326211, 0.1398832625446331, 0.1378658080824757, -0.1751070424701735, 0.1076802125896524, 0.1559873363173106, -0.1941766903899372, 0.1183012720309061, -0.005787538089367532, -0.005905180159076322, -0.002081391283241186, 0.2798538357535026, -0.119977797078753, -0.04228842038601809, 0.3166387301139671, -0.1330437155946823, -0.04784694729483135, 0.06005617041604501, -0.02523410845433275, -0.02574703687052505, 0.04114858503609641 },
            { -0.02053451905131565, -0.02226886746828294, -0.02018790612716794, 0.02306868295823366, 0.04338357691568699, -0.01913588053374868, -0.006223641760033802, 0.04806699603416348, -0.02134491891810026, -0.007041697385620594, 0.002994402956018356, 0.002145536639303018, 0.003057886690550231, 0.1670937202553853, 0.6009395761513255, -0.1430688509517219, 0.01040934468859274, -0.06040490870858281, 0.06212824993743095, 0.01177758266074892, -0.06737802717601778, 0.06883522649955134, -0.007412255565028184, -0.007518602030932813, 0.004659710472515823, 0.2086828127417312, -0.1527583044857083, 0.09467311452944335, 0.2361127573800833, -0.1703926619714926, 0.1071172552622835, 0.01470898531187703, -0.01061485702848229, -0.01076715244263247, 0.03719763351994363 },
            { 0.02075076579393005, -0.01455188986905499, -0.01305200265879779, -0.04040605971477423, 0.04503040295118439, -0.05347701744396705, 0.02034110872501599, 0.05033608982018091, -0.06001447776471432, 0.02301480992196333, 0.001155148111690021, 0.0008437068147440054, 0.001169221522662082, -0.1267610567651157, 0.441928259975204, 0.4676006692834355, -0.002909002186724163, -0.006212798952127209, 0.02375551952812918, -0.003291370853728316, -0.006972301418263752, 0.02655450287640676, -0.004546253438393488, -0.004583503422845921, 0.007482043536301657, 0.03347721993536706, -0.09312478684172512, 0.1520155316096514, 0.03787757412557766, -0.1045091090787258, 0.171996945322831, 0.000869241301476956, -0.002398348787876867, -0.002417999794199144, 0.01302921783528125 },
            { -0.03689485245927278, -0.006383645426197112, -0.00567499956394012, 0.193565613495663, 0.02596384270286388, -0.04737889847365301, 0.04543103359859865, 0.0292366119663366, -0.05343535173275049, 0.05140263576410639, 0.0002036988886705013, 0.0001511791554585909, 0.0002046743201537327, 0.2046595848769283, -0.5073439612622463, 1.044366951876962, 0.001425915220381544, 0.001435376190172059, 0.004158446209790353, 0.001613342134175544, 0.00161886059114057, 0.004682622661441415, -0.001054299169241386, -0.001057676664449433, 0.002604661531928856, -0.01001008320397233, -0.02148922010909465, 0.05291990156409586, -0.01132584095374989, -0.02423619104674914, 0.05987586478454045, -7.891000565307237e-5, -0.0001688596882398552, -0.0001694006379102603, 0.001181372863711366 },
            { -0.01102591150869176, -0.02739449228397737, -0.02070490865233491, -0.02645673874857107, 0.005124628831690105, 0.005361881137819172, 0.02827782277230298, 0.00530923083978036, 0.003699925586712416, 0.005372601098003435, 0.02935156902481182, 0.005586380723032351, 0.005382707212706293, 0.1263970029757738, -0.1716559976004295, 0.1091571852097643, 0.698773601926539, -0.2591770384333492, 0.1093625149958886, 0.1327624071766725, -0.1788431580894694, 0.1133020276008207, -0.006566685471276647, -0.00180804417049401, -0.006620201507015153, 0.3046577340766972, -0.0367347228625228, -0.13450515845961, 0.05788297386950353, -0.02534851809399209, -0.02555509905575231, 0.3200004208071711, -0.1401368297904486, -0.03858469836607798, 0.04535558722832311 },
            { -0.04007962075476745, -0.02447531302518723, -0.02972368152675265, -0.02665480921729683, 0.03517748253151905, 0.01200475223875597, 0.03026699130493021, 0.02362472601947029, 0.005782904813926428, 0.005750530089515878, 0.0222876553178487, 0.006155630695155919, 0.006305230771333798, 0.2352233128815208, -0.2049044215683619, 0.1168357126437115, 0.2219105574348304, -0.2181111374930239, 0.1281057779168782, 0.04216155232787764, -0.1050680532087434, 0.08603412430339934, -0.02473721008368848, -0.009756555131284716, -0.008647042476714151, 0.8765082404964715, -0.1982276510107367, -0.1756852593240495, 0.1665308242865405, -0.09548982057143421, -0.03337904847723588, 0.1571058055207385, -0.09008545561566908, -0.03553043011995631, 0.1427836980104774 },
            { 0.01027233067587228, -0.01928018940651663, -0.03971898125558423, 0.02306868295823371, 0.09844979659654111, -0.05447853760033639, -0.0309562673116839, 0.04135680830732884, -0.01819084089180312, -0.005881488015822077, 0.01281487216264311, 0.005205604765194608, 0.00579589774391154, -0.05647858358663622, 0.3521773959096313, -0.1194964347698705, -0.01750052429605973, -0.1007812855516264, 0.1177574645778425, -0.003324984982250497, -0.03365171700808842, 0.04946757695458788, -0.03142046823202643, -0.01787820639436125, 0.01935854863497349, 0.6083049566555486, -0.3632383367030433, 0.3933150144955556, 0.1155739571735884, -0.1212883289423591, 0.07472727641569869, 0.03581189040276749, -0.03758255276052093, -0.02138442464058196, 0.1290740779192513 },
            { 0.0091251172827846, -0.01241026984982741, -0.03974059720891061, -0.04040605971477426, 0.1488137364235412, -0.2006373486991843, 0.1011762603611382, 0.04276983431439064, -0.05070882241035074, 0.01922282673192722, 0.004882022385396911, 0.00267462964338698, 0.003227333514336788, -0.04921064378975332, 0.1286635315904434, 0.3905575008373494, -0.005617217565431012, -0.006786339718755183, 0.06557096567043816, -0.001067234542870168, -0.001715170669099278, 0.01884543325743426, -0.01910667596866336, -0.01436322691643388, 0.03108379899154558, 0.04847938268392301, -0.2918231583040319, 0.6315413971091547, 0.009210765154567455, -0.07375500526501397, 0.1199887286536976, 0.001051375634066921, -0.00841886793603292, -0.006328788468651288, 0.04521078678825943 },
            { -0.04061590762108407, -0.005376068580257511, -0.023516750826114, 0.1935656134956629, 0.1111108550453821, -0.2129097496555521, 0.2259730354911518, 0.02458542446408939, -0.0448339756433932, 0.04293339654805581, 0.0008520073250235941, 0.0005700081743521936, 0.0007315781665419374, 0.2173467560795984, -0.5074589290345993, 0.8722941892004586, 0.007532146883223937, 0.006451708409677216, 0.01486375257793079, 0.001431058569854407, 0.001358583804478957, 0.003288892575872915, -0.004399936871004317, -0.00396984336412233, 0.01082094418545809, -0.04980123266647329, -0.08065682142534453, 0.2198532493014446, -0.00946190799271459, -0.0169845015228644, 0.04177067725855737, -0.0003279022060517908, -0.0005885975135588731, -0.0005310621497184968, 0.004099309516037222 },
            { -0.005880697701746452, -0.02096141170324608, 0.01968046068523588, -0.02645673874857102, -0.008320196683643533, -0.03483895378318278, 0.06254613548872683, 0.004001525804963237, 0.002724744548458303, 0.003765071908764956, 0.04893052194972212, -0.02673075685123112, -0.006124358617264933, 0.003493026207667933, -0.06586001995159906, 0.07649640168257882, 0.04271260610471719, 0.6461112769413265, -0.1244309293917708, 0.002571158587791487, -0.05053217701368624, 0.05984396689510618, -0.01069629891074977, 0.008232763448964668, -0.01026158390310872, 0.2585411025297019, 0.1672681943427365, -0.2084885131474689, 0.01556332513255107, -0.0130819973384467, -0.0125503236613742, 0.1903078123510853, -0.1599662201655968, 0.1231233402728502, 0.04926774268973667 },
            { 0.01601553293727537, -0.01847186527917361, 0.0231559130793074, -0.02665480921729676, -0.04141279782232524, -0.03444320211700756, 0.06694586617356139, 0.01760211513184505, 0.004224851213614437, 0.004029921244030128, 0.03672966543223829, -0.0129029273094945, -0.005201869839527036, -0.03616904734717516, -0.0724944037069553, 0.0818774466205659, -0.07547257804609402, 0.2214018847247759, -0.1056883731273782, -0.004543201290743671, -0.0271574639953151, 0.04492183599540935, -0.03997335545981984, 0.01961713137447242, -0.01340327054917008, 0.685904525794329, 0.3985687386177593, -0.2723193587359518, 0.04128919943628401, -0.04888899740905699, -0.01639273089820836, 0.08615660503867553, -0.1020148149641141, 0.05006429918812091, 0.1550995351125425 },
            { 0.01962515553554521, -0.01425387190434583, 0.005514304491641808, 0.02306868295823371, -0.01781289440329101, 0.0160562855400304, -0.06847043724307712, 0.03028903273713753, -0.01313358888935455, -0.004121695414598815, 0.02075903594430446, -0.001107698265463649, -0.0007349013810425365, -0.07232353807336973, 0.08762601645679266, -0.08374205743970041, -0.04956800501072154, 0.007390454144438095, -0.0149312715941614, -0.002983831083744957, -0.006045183127609773, 0.02538912340035506, -0.05017620467325414, 0.00369260001571799, 0.03000654449108387, 0.3347707144999614, 0.07502396259627739, 0.6096544066403048, 0.02015209737887168, -0.06136748621798291, 0.03669919272486222, 0.01381153757769866, -0.04205911305476372, 0.003095241709460965, 0.1402073889337637 },
            { -0.01905813911559174, -0.008973334256543701, -0.03076743722716268, -0.04040605971477432, 0.1323516525356928, -0.2245148383223399, 0.2237861146434754, 0.03075310074583007, -0.03615546366635049, 0.01347118902282388, 0.007764359267656431, 0.002133965199228201, 0.002011494612634446, 0.08726677047625245, -0.1654221201286563, 0.2736992842641158, 0.02203259319135841, 0.009763532582370277, 0.04086830307602302, 0.001326289738827636, 0.00157230163571757, 0.009496118996089833, -0.03013214590133542, -0.01126351571166119, 0.0481811635251757, -0.1378636298243346, -0.2288451437624541, 0.978915071973998, -0.008298937669546782, -0.03685280822573055, 0.05892747185347915, -0.002095266234738555, -0.009304376994421087, -0.003478013043181288, 0.0491104524580727 },
            { -0.04079742454249183, -0.003814784988892703, -0.03827576649250287, 0.193565613495663, 0.1902826731863673, -0.3945927279594245, 0.4998171255416422, 0.01740627747298321, -0.03163480281153058, 0.03008734918939368, 0.001334215658241456, 0.0007454053268318873, 0.000877995254786719, 0.2072217899598285, -0.4445986454400344, 0.6112961465086306, 0.01588384175320352, 0.01047600013781209, 0.01783856439214633, 0.0009561550992870909, 0.0008398689968945675, 0.001631798609562803, -0.006866870205114083, -0.00515603169099161, 0.01677290737332818, -0.09650767257172146, -0.1047570619844012, 0.3407815550156927, -0.005809444886416139, -0.008398454315490172, 0.02051393023388387, -0.0004453021242008673, -0.0006437533395721364, -0.0004833661509349371, 0.00445289629753897 },
            { 0.009324359815204169, -0.01243849295391361, -0.04065529414352159, -0.02645673874857103, 0.07155728382479873, -0.1348907822337632, 0.09931759007824136, 0.002336892767461283, 0.001553087517671239, 0.002040120141441186, 0.04537521571298808, -0.05899273903177214, 0.02854061558263109, -0.002745301598304561, -0.004036158982654071, 0.0414498988603882, -0.05330524958387282, 0.1533101456584007, 0.5798705700134293, -0.001094963271208439, -0.001765161930352344, 0.01893721042355132, -0.009681203729766785, 0.01727210517714632, -0.008829224515081892, 0.02515948196878641, 0.3509239471519606, -0.1793867212679453, 0.0005168104247421446, -0.004040421390908782, -0.003684850416502225, 0.01003485689713127, -0.07845246249062347, 0.1399659816452208, 0.02296959262756715 },
            { -0.003430005826947755, -0.01081123142856225, -0.02610225289337173, -0.02665480921729683, 0.1033929806787113, -0.1586234197313433, 0.1063039633401005, 0.01016285519708456, 0.00238940091495447, 0.002183629874167401, 0.03367390981544247, -0.03360699223188841, 0.007037176325369998, 0.004666028929682822, 0.002059050198733516, 0.04436564082388977, 0.01546056047511834, -0.0289605999565844, 0.142976994846623, 0.0003175812139461689, 0.0004362438040427905, 0.01405370544114451, -0.03589830175085725, 0.0489532756297688, -0.01153237999439415, -0.03093512055330148, 0.9946023680278828, -0.2343077619191361, -0.0006354499990286026, -0.01498204875551774, -0.004813004262493779, -0.002105519122779456, -0.04964197057423306, 0.06769504265664238, 0.07231046002443044 },
            { -0.02548023059023469, -0.008169392142769946, 0.01944774835584457, 0.02306868295823365, -0.09312492294621721, 0.2581706538315077, -0.1087248439164008, 0.01718712183196412, -0.007340695513561365, -0.002233358096729234, 0.01870469467558214, -0.009954903623483918, -0.002081818985837013, 0.06936039437777893, -0.04507031899996927, -0.04537598808424596, 0.07548471536412321, -0.06112100428297293, -0.04229711018275133, 0.001550560057528265, 0.001737884129220767, 0.007806348320640451, -0.04453252212150089, 0.0321718864559728, 0.02581809209329851, -0.2734202738938528, 0.6536484850377737, 0.524556022117167, -0.005616429148248225, -0.01858551477618477, 0.0107751034352763, -0.006112343498353781, -0.02022656164748483, 0.01461239143253991, 0.06536744797634636 },
            { -0.04130331670948098, -0.005025994237166837, 0.00142320657028372, -0.04040605971477436, -0.007285068764193808, 0.01709393778786669, 0.3553520521402793, 0.01712276270660279, -0.01995099403091164, 0.007299420760236798, 0.006864615891585904, -8.96551013661929e-5, -5.999369754557159e-5, 0.1627674341250551, -0.2382425061571529, 0.1483051150298991, 0.06525441799743256, -0.00107060610644961, -0.001218914830070015, 0.001340415654162487, 0.001249545675449576, 0.002864926889562106, -0.02640257935344752, 0.0004646794937178921, 0.04145581366174608, -0.3152833720682104, 0.009441070467300253, 0.8422735742615279, -0.00647635486434079, -0.01101903744333337, 0.01730145971223002, -0.00259640861016898, -0.004417596671728473, 7.77487137670744e-5, 0.0228962608216353 },
            { -0.03078128641256888, -0.002094760627224215, -0.04145451836505668, 0.193565613495663, 0.2183125263152957, -0.4965181115031936, 0.7936642608011621, 0.009535077667581687, -0.01726677661017439, 0.01630295743912863, 0.001160566572255537, 0.0005119465825091625, 0.0005458257854892993, 0.1482609575943982, -0.2926412638196373, 0.3312334029993755, 0.01804565388488182, 0.008676587315397728, 0.01108975062024648, 0.0003706825943623118, 0.0003017346023088015, 0.0004843589841724803, -0.005951557980299983, -0.003515475406071542, 0.01443166731063072, -0.1008683605731343, -0.07142525436022978, 0.2932136878908868, -0.002071975104080671, -0.002483864903999766, 0.006023013143403616, -0.0002521914480590418, -0.0003023248135021854, -0.0001785776850414655, 0.002076028013123711 },
            { -0.04158768254624902, -0.004317839866583443, 0.2564946004984638, -0.02645673874857106, 0.2949230850789761, -0.257360821304334, 0.1287360490666405, 0.0008010667001296518, 0.0005223619461845186, 0.0006600979641718553, 0.02016148887177368, -0.03785596519342841, 0.03806018604376975, 0.008724298463542134, 0.006887021968319694, 0.01341146204925842, 0.2195757810907698, -0.4991076892626898, 0.7732833131128737, 0.001125881422727007, 0.00101303245225011, 0.002100383263435278, -0.004220646359933734, 0.01066247643713045, -0.003702961645710082, -0.05564663431873006, 0.2166335996311234, -0.07523448378396208, -0.0002853297914076911, -0.0004396984286062222, -0.0003857670787738316, -0.007181266445498435, -0.01106646297224594, 0.02795683187392432, 0.003116969811258318 },
            { -0.04053297281954694, -0.003714268244648606, -0.004745786847815445, -0.02665480921729688, 0.6691449677790829, -0.3133858744525394, 0.1377918275075796, 0.003454141374027709, 0.0007990346536136533, 0.0007065317405397786, 0.01483514921867699, -0.02220334174223499, 0.01473602139519525, 0.0418315906646366, 0.01136753316963886, 0.01435487479003842, 0.1796619832154951, -0.3158776939024001, 0.2993973658845057, 0.0009212222234519086, 0.000805388003440026, 0.001545495936716263, -0.01556053398424053, 0.03129295068592959, -0.004836660425844828, -0.2213732350694789, 0.635790811838522, -0.09826827420649016, -0.001135097922073514, -0.00162106505915692, -0.0005038735320576568, -0.004875118076632715, -0.006962292344662858, 0.01400149064442231, 0.009812517121606683 },
            { -0.03611689332502446, -0.002762156689831434, -0.01759858691004887, 0.02306868295823361, 0.1372262556288497, 0.5759284463220433, -0.140929787262841, 0.005765290649501674, -0.002433180766941611, -0.0007226217235793905, 0.008132848419400113, -0.007360984100622945, 0.0009925831573748588, 0.08131331741585207, -0.03854041567105913, -0.01468178111095552, 0.1147052117968849, -0.1165944556362289, 0.02016669050414512, 0.0005881544240013308, 0.0004925879053164521, 0.0008472637518393933, -0.01913323741442657, 0.02322153007914385, 0.01082806362252853, -0.3030612986523162, 0.4718006815442324, 0.2199978976192229, -0.00155395592539969, -0.00199326209964865, 0.001128045837924852, -0.002192099021546346, -0.002811809412935237, 0.003412622518866573, 0.008870351568043366 },
            { -0.02632578093983314, -0.001669343251192108, 0.02005278463846138, -0.04040605971477433, -0.1210392777590414, 0.409587603262319, 0.4606094366992159, 0.005660331185964321, -0.006548500987364148, 0.002361788742530416, 0.002941428182952899, -0.0007051102844327969, -0.0003225157641577945, 0.09333673492099263, -0.1155536995952477, 0.04798536248866888, 0.04850304577268893, -0.01244225237899134, -0.006552675763389422, 0.0002487008262471516, 0.0001989271680582741, 0.0003064320579381349, -0.0112330506905863, 0.003602556841826744, 0.01738649727605516, -0.1982164418304146, 0.07319452109670842, 0.3532480950459384, -0.001016360768147428, -0.001170236574187741, 0.00181129023360551, -0.0005281585315871726, -0.0006081211022726258, 0.000195030797776473, 0.003107018697670594 },
            { -0.01259644450649998, -0.0006849996747422789, -0.03732553226575755, 0.193565613495663, 0.2063633124252942, -0.5087168207405977, 1.028752320112141, 0.003112039978153708, -0.005619251595900626, 0.005274958467860025, 0.0004909813474318261, 0.0001706997395263645, 0.0001669400476843304, 0.05826131060272241, -0.1080781959153139, 0.1071733426596648, 0.009191789624705857, 0.00328316317153129, 0.003391784607045199, 4.713117780407068e-5, 3.626559834258442e-5, 5.11494469167123e-5, -0.002510567367868102, -0.001165407253343978, 0.006052616562601559, -0.04828714059377412, -0.02367802356392179, 0.1229733187102094, -0.0002475937659477748, -0.0002615458468734622, 0.0006305493909171678, -3.906245474814569e-5, -4.126365124305659e-5, -1.915461782599388e-5, 0.0002817166481420899 },
            { -0.02771404479110617, -0.01262713981557432, -0.02848613965062155, -0.02645673874857111, 0.00553719265411168, 0.003876453322753182, 0.0056851505033397, 0.003257949451411056, 0.00367985906664875, 0.03164311145346185, 0.00362109612184803, 0.004016854525083635, 0.03425488866031784, 0.1038019607210037, -0.1574201661900563, 0.1054793471232691, 0.1153722250798742, -0.1718364468440876, 0.1141854617231494, 0.6421529517453903, -0.1631217647297313, 0.06718394782667175, -0.001313047416948585, -0.007698763826667307, -0.007839020338041602, 0.05617066818259894, -0.02566310785484651, -0.02613063979371097, 0.3126416288668669, -0.02436160383093965, -0.1454411359658686, 0.3474901641975257, -0.02707706502812891, -0.1587603966773187, 0.05189631027689208 },
            { -0.03618205086727391, -0.02345996111730957, -0.0255216716723957, -0.02665480921729696, 0.02469686349179407, 0.006068756454277312, 0.006085065396913763, 0.02871844888648756, 0.01040295457869606, 0.03386900706375943, 0.005446964936318998, 0.005597959122650658, 0.02607189605448592, 0.1799523328936176, -0.1869606183277099, 0.1128991615774845, 0.03413116256224915, -0.1006058318362078, 0.08690822260438817, 0.18997143177811, -0.1724567309347761, 0.1010601750910157, -0.008946586675016067, -0.02904942866526289, -0.010239014895097, 0.1607869537476217, -0.09683354857256639, -0.03413079677416207, 0.8949278466260233, -0.1659903499314689, -0.1899693958296838, 0.1697389932295774, -0.03148302401072418, -0.1022248923961468, 0.1633745156276259 },
            { 0.01425169802776674, -0.03713344901196352, -0.02018790612716792, 0.02306868295823362, 0.04338357691568699, -0.01913588053374871, -0.00622364176003383, 0.09419353716058988, -0.05417748655495008, -0.03464031246727392, 0.005867922470358333, 0.005445782337005056, 0.01504270130472864, -0.07424487525474936, 0.315595803207861, -0.1154702358700685, -0.004625191758894719, -0.0317228826959172, 0.05014343532325249, -0.02574346241746157, -0.08981379496549539, 0.1088704038318376, -0.01881372226134985, -0.03698635561937606, 0.0229225736261528, 0.1095940798652242, -0.1232905508972649, 0.07641025137580629, 0.6099922388646906, -0.3490600890723918, 0.425293595842598, 0.0380003477210527, -0.02174520250451069, -0.04274942415300019, 0.1476878330927727 },
            { 0.006384739309514833, -0.04093237841029047, -0.01305200265879777, -0.04040605971477428, 0.04503040295118442, -0.05347701744396711, 0.02034110872501605, 0.1552508497133714, -0.2136211186622523, 0.1132170502952494, 0.003562806060727627, 0.003003168573676431, 0.005751766466304431, -0.03375646270612676, 0.08464280865275237, 0.3773984289101495, -0.0007746671283292042, -0.001189941446452008, 0.01917297458448678, -0.004311737792456469, -0.004753380706020409, 0.06610246412854223, -0.01618235768107848, -0.02254768730710078, 0.03680651294679115, 0.006411913828218136, -0.07516060295747005, 0.1226910621991615, 0.0356882203517939, -0.3002391092571213, 0.6828890375428205, 0.0008189984660353488, -0.006890098959867995, -0.009600319058806841, 0.05173062818511531 },
            { -0.04099979151831726, -0.02557815590343029, -0.005674999563940093, 0.193565613495663, 0.02596384270286391, -0.04737889847365301, 0.04543103359859865, 0.1214420892979637, -0.2344553949722823, 0.252865646874597, 0.0008461178284371361, 0.0006633205818854784, 0.001006857014138573, 0.2180859889617277, -0.5041765291597238, 0.8429039407664708, 0.001519460381977629, 0.001426414899664849, 0.00335626351580553, 0.008457199890802307, 0.007058641704834391, 0.01569843332739843, -0.004625891289715515, -0.005203042411434836, 0.01281314495589432, -0.009947588602064905, -0.01734385436210914, 0.04271141814012995, -0.055367514834202, -0.08582639858272333, 0.2377284759215496, -0.0003857595145826025, -0.0005979742806730198, -0.0006725807738298785, 0.004690470382278197 },
            { -0.03240419913090803, -0.02495652929806445, -0.0207049086523349, -0.02645673874857107, 0.005124628831690119, 0.00536188113781912, 0.02827782277230295, 0.006041846787381764, 0.006075743364837806, 0.02642950564403647, 0.03340176540986737, 0.009173540066134122, 0.02647922078400472, 0.02902548365002268, -0.09812408341868196, 0.08810028066373124, 0.1604645781172023, -0.1481539223502042, 0.08826600142459014, 0.1499761670891584, -0.1678786208714964, 0.1040640551066651, -0.01078332381180028, -0.008894334929592088, -0.03256684237349014, 0.1741521492437134, -0.02964843210342465, -0.108558517593135, 0.1627690805059432, -0.03359572135228228, -0.1014628310156253, 0.8998531135204917, -0.1857306950794884, -0.1531949737923247, 0.1800778104018305 },
            { -0.003357685596893425, -0.03280377145867346, -0.02972368152675263, -0.02665480921729687, 0.03517748253151905, 0.01200475223875587, 0.03026699130493014, 0.03812711034200977, 0.01261027312837129, 0.02828865659010938, 0.0359692591934385, 0.01342304375412975, 0.03101740278463073, 0.009703884312666895, -0.1125841458311082, 0.09429758614311798, 0.009154680931611831, -0.1198405379588695, 0.1033936059035812, 0.00855630552958872, -0.1258853065399808, 0.1120631477085379, -0.05394226355550389, -0.04799554707392455, -0.04253750720995687, 0.4815949349209145, -0.1599886590680968, -0.1417947945908066, 0.4501165508080964, -0.1680585028466757, -0.1325266925289345, 0.4246416457486891, -0.158547023215991, -0.1410684427130845, 0.5669020570578501 },
            { 0.02343428556274766, -0.04071692449822357, -0.0397189812555842, 0.02306868295823367, 0.09844979659654114, -0.05447853760033647, -0.03095626731168392, 0.09967243709134714, -0.05402994244200248, -0.02893287960039849, 0.03088462557296404, 0.01546154614358784, 0.02851183427556085, -0.09782049610383142, 0.1660499124006592, -0.09644504318529393, -0.03031078083060839, -0.04751788113558405, 0.09504152804619317, -0.02832958391062419, -0.04712660243482145, 0.09622184151452619, -0.09332422289736535, -0.08794849053294117, 0.09523075714638957, 0.2868127992844252, -0.2931680525644633, 0.3174428059841395, 0.2680659171856123, -0.2907540052212062, 0.29669386147487, 0.08306323917376701, -0.09009339840729294, -0.08490377043501761, 0.5124699899557138 },
            { -0.00845414648597783, -0.03882422922489401, -0.0397405972089106, -0.0404060597147743, 0.1488137364235412, -0.2006373486991844, 0.1011762603611383, 0.1443738861696729, -0.1925204755329318, 0.09456309864408378, 0.01647975858325769, 0.01015446516687876, 0.01587626324315243, 0.04090465035196592, -0.08593400912262306, 0.3152172289251929, 0.00466911836078673, 0.004532577118721392, 0.05292203594162251, 0.004363931801353305, 0.004349209695719286, 0.05134310969222126, -0.07254016497511619, -0.0706572068035243, 0.1529109319488566, -0.03237924268300442, -0.2355291784169413, 0.5097142641518435, -0.03026284534459588, -0.2260007407628521, 0.4763979224893451, -0.003454394686967827, -0.02579716973907683, -0.0251275408296197, 0.1795029011616399 },
            { -0.04162279872719085, -0.02232219308626734, -0.02351675082611398, 0.193565613495663, 0.111110855045382, -0.2129097496555521, 0.2259730354911518, 0.1051854336230484, -0.2007330594015492, 0.2112028095304115, 0.003645198807265663, 0.002552070903363431, 0.003598861878813273, 0.2153019879091378, -0.4756336109937083, 0.7040247762181031, 0.007461285488833376, 0.0060470891187413, 0.01199646886565947, 0.006973595121758632, 0.00570124525176741, 0.01135671018879679, -0.01969963128666914, -0.0195289014918688, 0.0532316098304128, -0.04667794528742535, -0.06509776329759788, 0.1774425836564897, -0.04362694498652746, -0.06137470551754996, 0.1658444429758222, -0.001511890785177047, -0.002126939022285105, -0.002108505587793819, 0.01627571655265416 },
            { 0.02047850070830766, -0.03902719790271404, 0.0196804606852359, -0.02645673874857102, -0.008320196683643553, -0.03483895378318286, 0.0625461354887268, 0.008639841861519806, 0.007449010630835926, 0.01852156663927385, 0.1056476935180243, -0.07307756320414259, -0.03012763607208074, -0.008515715793573164, -0.0333053616823684, 0.06173990695207001, -0.1041298841652334, 0.3267379782362995, -0.1004276519369549, -0.03083561556019457, -0.06986072798072863, 0.1042858797995486, -0.02924195016441206, 0.04049953906335862, -0.05047994160310089, 0.1307440376701704, 0.1350014187283426, -0.1682701554474767, 0.03871677102787918, -0.02886501728909024, -0.0498292480129825, 0.4734273641949981, -0.3529604533078611, 0.4888434453307888, 0.1956104588029307 },
            { 0.02291807830838189, -0.04122892014780984, 0.02315591307930743, -0.02665480921729681, -0.04141279782232524, -0.03444320211700773, 0.06694586617356139, 0.04450755756350883, 0.01300536454864517, 0.01982444337877607, 0.09287223076709857, -0.03971909658354203, -0.02558962516953212, -0.04050038720119523, -0.03258267678117415, 0.06608292448582009, -0.08451062049268941, 0.0995092818183709, -0.08530061779737318, -0.02502583216294531, -0.03757358220137007, 0.09167509457119571, -0.1230500279660215, 0.09650280654078489, -0.06593488110619028, 0.3082804233695214, 0.321683063451447, -0.2197877481789317, 0.09128999514368398, -0.1214638956941006, -0.06508497115902044, 0.1904913673057355, -0.2534541001194389, 0.1987730713685734, 0.6158003100435522 },
            { 0.004450038028120755, -0.04072125066349075, 0.005514304491641834, 0.02306868295823368, -0.01781289440329102, 0.01605628554003032, -0.06847043724307714, 0.09466301193507795, -0.04719525032977109, -0.02027590923577418, 0.06487869336768085, -0.003980488301319013, -0.003615209810624764, -0.01427315562842505, 0.01267802473855716, -0.06758784361852495, -0.00978231801921608, 0.001069275590298776, -0.01205096316457919, -0.00289680335425576, -0.003142989020084729, 0.06404239782991027, -0.1803070402235228, 0.01816505472421164, 0.1476115800370624, 0.04843574513361241, 0.06055150788778381, 0.4920493710943263, 0.01434310647980405, -0.1779828569618004, 0.1457088458835142, 0.009830259868357097, -0.1219831797603042, 0.01228921029945553, 0.5566731938503815 },
            { -0.03136678397027907, -0.03258424621130697, -0.03076743722716268, -0.04040605971477432, 0.1323516525356928, -0.2245148383223399, 0.2237861146434754, 0.1176773535525723, -0.1499002116504075, 0.06626899332669947, 0.02971047564278819, 0.008847399606622399, 0.009895171304887462, 0.1344592595949341, -0.2267129190140597, 0.2209014799602402, 0.03394747108548726, 0.01338103374516345, 0.03298462638377002, 0.01005274495429043, 0.008934018818040939, 0.02932750340775426, -0.1249275929572685, -0.05540875762834402, 0.2370182170788948, -0.1889436909588625, -0.1846999018457712, 0.7900780184202788, -0.05595122921376437, -0.1233172586069368, 0.2339630187229396, -0.01412623230005733, -0.031134405198363, -0.01380894861336874, 0.194985960648534 },
            { -0.03807444216141948, -0.0166949234470742, -0.03827576649250287, 0.193565613495663, 0.1902826731863672, -0.3945927279594245, 0.4998171255416422, 0.07778091366060169, -0.1458880708144913, 0.1480090836281691, 0.005962016466724366, 0.003437535101900892, 0.004319133343148607, 0.189049666937128, -0.3912790452831658, 0.493374412069855, 0.01449092295606215, 0.009219639723041587, 0.01439742630378448, 0.004291145937284269, 0.003408667614719469, 0.005885165230849839, -0.03166747878044095, -0.02536413297621135, 0.08251117885059844, -0.08493374951466559, -0.08454896069918133, 0.2750432835384225, -0.02515113186877556, -0.0312592804980487, 0.08144759807997615, -0.001927869644379816, -0.002396067830734685, -0.001919135511233468, 0.01767958181581015 },
            { -0.008250213363943939, -0.0388609269646536, -0.04065529414352158, -0.02645673874857103, 0.07155728382479881, -0.1348907822337632, 0.09931759007824138, 0.007879570167104319, 0.005891740649324944, 0.01003598923671577, 0.1529968345301563, -0.2237928736235231, 0.1404002171137844, 0.002178398618789238, 0.00257050400901645, 0.03345402976511364, 0.04229775050561464, -0.09763845917155835, 0.468010968482276, 0.00427416501424578, 0.004264638912402563, 0.05153528848523036, -0.03672628934303898, 0.08496688902390834, -0.04343371765317593, -0.01602329084247545, 0.2832291633051988, -0.1447822281298513, -0.001619144950106022, -0.01237084363279739, -0.01463016653982646, -0.03143877733913197, -0.2402034471610158, 0.5557147210669308, 0.09119745105210125 },
            { -0.01984886518320742, -0.03635734686787387, -0.02610225289337172, -0.02665480921729684, 0.1033929806787113, -0.1586234197313434, 0.1063039633401005, 0.03646275517499356, 0.009470543015015025, 0.01074195850967597, 0.1208167887443207, -0.1332034584675043, 0.03461807195746701, 0.02475565406210066, 0.009274242332481097, 0.03580731218838128, 0.08202612810508408, -0.1304424837513079, 0.1153960992145259, 0.008288696273676815, 0.007788012359363309, 0.04069579662166465, -0.1422852099744589, 0.2408164780802119, -0.05673138515053423, -0.1393359932518014, 0.8027391655774399, -0.1891087567629961, -0.01407982742493621, -0.04792719643993684, -0.01910933849630197, -0.04665252330470052, -0.158803412951156, 0.2687733926869817, 0.2870982409465321 },
            { -0.03538565054157838, -0.03062008488988912, 0.01944774835584459, 0.02306868295823364, -0.09312492294621721, 0.2581706538315075, -0.1087248439164008, 0.06753193549861421, -0.03099862159280509, -0.01098658719416134, 0.073494808886703, -0.04203801803890899, -0.01024111889797476, 0.09090396072936961, -0.05341828190673384, -0.03662275898681382, 0.09893051593325763, -0.07244188880075964, -0.0341378102706136, 0.009996875601861879, 0.008698117563231342, 0.02475591204075914, -0.1880539520086901, 0.1582635745995425, 0.1270072723157647, -0.3240634101100584, 0.5275567968942041, 0.4233668418947008, -0.03274643387254761, -0.06334389007012611, 0.04278099242128464, -0.03563784869209502, -0.06893697123399894, 0.0580163903657516, 0.2595320140797411 },
            { -0.04133309679808719, -0.02112183444024161, 0.001423206570283728, -0.04040605971477433, -0.007285068764193822, 0.01709393778786666, 0.3553520521402793, 0.07399278649510717, -0.0899360086693545, 0.03590813437695331, 0.02966414163067076, -0.000404151390212644, -0.0002951277675310158, 0.1578649471058827, -0.2196489795143267, 0.1196964014131826, 0.06328898222770551, -0.0009870511460635533, -0.0009837807600845444, 0.006395317727097005, 0.00519315335829071, 0.009992037425467441, -0.1190187617692607, 0.002285903806714628, 0.2039341170440557, -0.2906772265354589, 0.007619846154303545, 0.6797952708792181, -0.02937277791950107, -0.04009015115750496, 0.0686929477078469, -0.01177571876344914, -0.01607237648780617, 0.000308690042227396, 0.09090629770469699 },
            { -0.02662785624763458, -0.009682098480128246, -0.04145451836505668, 0.193565613495663, 0.2183125263152957, -0.4965181115031936, 0.7936642608011621, 0.04456863824272114, -0.08208288517114543, 0.08019934809827173, 0.005424693276627366, 0.00243369411063685, 0.002685087802928672, 0.1267598619661149, -0.2457156461655035, 0.2673370123402324, 0.01542863767138065, 0.007285279016661006, 0.008950488602807128, 0.001559055565939273, 0.001204380478999654, 0.001827247823874445, -0.02829254477054609, -0.01729372335511228, 0.0709938865144695, -0.08469391524757178, -0.05764700641118901, 0.2366514686870478, -0.008558274734317868, -0.009530030220618754, 0.02391350405024067, -0.001041674532615302, -0.001159952219816515, -0.000709016914432422, 0.008242569477807403 },
            { -0.03987149506809759, -0.01858506351847889, 0.2564946004984638, -0.02645673874857107, 0.2949230850789762, -0.2573608213043341, 0.1287360490666405, 0.003530822036592086, 0.002386623605426762, 0.003247228400444004, 0.08886479638643559, -0.1729604171910536, 0.1872299624535173, 0.008148134771083046, 0.006168625717409807, 0.01082433161298627, 0.2050747191043495, -0.4470449697859731, 0.624113536703126, 0.005172789260791654, 0.004145650733360568, 0.007471893318004208, -0.01928374435838462, 0.05245205739902629, -0.01821602682382568, -0.04984204509943892, 0.1748440186692277, -0.06072141860584641, -0.0012572119896219, -0.001621407874395256, -0.001531632487106182, -0.03164189141068968, -0.04080808353529623, 0.1109985643948327, 0.01237547859041811 },
            { -0.03763593792610803, -0.01630849757557702, -0.004745786847815475, -0.02665480921729688, 0.6691449677790829, -0.3133858744525396, 0.1377918275075797, 0.01547691146568517, 0.003691624224627332, 0.003475650673418412, 0.06647159631742799, -0.1025817764881593, 0.07249109947501946, 0.03799560475880862, 0.00997162717358099, 0.01158575585715983, 0.1631868546230181, -0.2770886655037874, 0.2416422878046817, 0.004116212923674947, 0.003264050211996392, 0.005589037465426367, -0.0718913052701172, 0.1539398145676033, -0.02379304580618497, -0.1941891291083409, 0.5131439479568484, -0.07931188882615012, -0.004898211959042411, -0.006044735208017391, -0.002000557107013485, -0.0210372701776155, -0.025961458749954, 0.055590896991734, 0.03895918244634541 },
            { -0.03209534726556355, -0.01250399737956946, -0.01759858691004886, 0.02306868295823362, 0.1372262556288498, 0.5759284463220433, -0.140929787262841, 0.02649074818163203, -0.01143434379185652, -0.003554802333816366, 0.0373693630686831, -0.03459176728522127, 0.00488282708533196, 0.07112435886035021, -0.03288994993425999, -0.01184960050071857, 0.1003320846605091, -0.0995003749107848, 0.01627644657618802, 0.002530768942712249, 0.001975456328670719, 0.003142075440051294, -0.08991358859160316, 0.1142339714217734, 0.0532666325687122, -0.258629046058044, 0.3807882402016032, 0.1775593286730393, -0.006523639568157557, -0.007560077433519267, 0.004478743126040682, -0.009202618736179467, -0.01066467721120922, 0.01354932497802085, 0.03521845015094759 },
            { -0.02241723928834154, -0.007816863792841458, 0.02005278463846138, -0.04040605971477432, -0.1210392777590414, 0.4095876032623191, 0.4606094366992159, 0.0267417912642991, -0.03135470659495675, 0.01161837772097454, 0.01389654702228364, -0.003376120142325014, -0.001586555944432185, 0.07875024653515701, -0.09612767010257033, 0.03872877351022472, 0.04092308152345894, -0.01035055334627977, -0.005288635583115032, 0.001032240724490912, 0.0007923544577106948, 0.001168443760199696, -0.05378467671444845, 0.0177221041814198, 0.0855296195465344, -0.1648937662395971, 0.05907497375711544, 0.2851049727754592, -0.004159267933663363, -0.004522301101170922, 0.007191466348520671, -0.00216139083007467, -0.002350043393885873, 0.0007743416229571325, 0.01233596913071529 },
            { -0.01037776598911576, -0.003303304988079629, -0.03732553226575754, 0.193565613495663, 0.2063633124252942, -0.5087168207405977, 1.028752320112141, 0.01506156939890521, -0.02734367440406618, 0.02594917099841554, 0.002376238637621389, 0.00083063696629528, 0.0008212303225206665, 0.04782410688948832, -0.08822672903069129, 0.08649913012910923, 0.007545129434439496, 0.002680121971366066, 0.00273749433220888, 0.0001903177762729389, 0.0001440573214020885, 0.0001997979213415046, -0.01221659779863553, -0.005733002882217272, 0.0297747144603604, -0.03941790879052, -0.01911042793504847, 0.09925122081245057, -0.0009942743609014162, -0.001027190959437208, 0.002503505314460031, -0.0001568650045820413, -0.0001620582013324113, -7.605064442970343e-5, 0.001118515275655541 },
            { 0.01103970844534176, 0.01103970844534152, -0.02848613965062158, -0.02645673874857111, 0.005537192654111686, 0.003876453322753172, 0.005685150503339686, -0.005329609463948139, -0.04717471444980517, 0.06856122928836553, -0.00592367329471862, -0.05149489743361114, 0.07422017519173366, -0.005329609463948027, -0.04717471444980502, 0.0685612292883655, -0.005923673294718697, -0.05149489743361089, 0.07422017519173361, -0.07143774342473315, 0.6266700201944331, -0.07143774342473276, 0.01683288295331644, -0.01668093584075689, -0.01698483006587612, 0.01683288295331671, -0.01668093584075691, -0.01698483006587636, 0.202999577068119, 0.2029995770681194, -0.204832014189666, 0.2256268834802781, 0.2256268834802783, -0.2235901941291009, 0.07308816513590927 },
            { 0.02264726276258683, 0.02264726276258661, -0.02552167167239572, -0.02665480921729703, 0.02469686349179412, 0.006068756454277291, 0.006085065396913739, -0.04449539832045502, -0.04949183678180903, 0.07338408432062198, -0.00843934418035742, -0.02663217234234919, 0.05649005932943708, -0.04449539832045474, -0.04949183678180909, 0.07338408432062195, -0.008439344180357411, -0.02663217234234904, 0.05649005932943708, -0.1017759883494756, 0.2171903151235436, -0.1017759883494753, 0.04256319722677196, -0.06294148861891471, -0.02218490583462935, 0.04256319722677223, -0.06294148861891469, -0.02218490583462952, 0.5132995375577847, 0.5132995375577848, -0.2675433860150797, 0.09735639253906801, 0.09735639253906815, -0.1439684204250057, 0.2300884882466877 },
            { 0.01269123850780219, 0.01269123850780192, -0.02018790612716792, 0.02306868295823351, 0.04338357691568706, -0.01913588053374873, -0.006223641760033802, -0.04330148207643075, 0.04387485250125835, -0.07505527416867117, -0.002697528379711626, -0.00441018792091293, 0.03259306831399059, -0.04330148207643064, 0.0438748525012586, -0.07505527416867122, -0.002697528379711718, -0.004410187920912767, 0.03259306831399055, -0.03253139237820266, 0.01011170320548477, -0.03253139237820235, 0.01523602037867035, -0.0801384532583205, 0.04966641250097965, 0.01523602037867062, -0.08013845325832045, 0.04966641250097951, 0.1837418879255004, 0.1837418879255003, 0.5989622074929918, 0.0114464663437144, 0.01144646634371444, -0.0602061486700867, 0.2079961499393064 },
            { -0.02598176496926861, -0.02598176496926883, -0.01305200265879774, -0.04040605971477434, 0.04503040295118439, -0.05347701744396716, 0.0203411087250161, 0.1147618624713509, -0.203918001595269, 0.2453077396026995, 0.002633636208163721, 0.002866758389024488, 0.01246237052539561, 0.1147618624713509, -0.2039180015952686, 0.2453077396026995, 0.002633636208163539, 0.002866758389024663, 0.01246237052539557, 0.03176087173487865, 0.01093149299806953, 0.03176087173487895, -0.01544732122034563, -0.04885414513228539, 0.07974878757297627, -0.01544732122034541, -0.04885414513228517, 0.07974878757297617, -0.1862901134203923, -0.1862901134203923, 0.9617467307238582, -0.004275116988880841, -0.004275116988880762, -0.01352060870963157, 0.0728548267729463 },
            { -0.03958128003666928, -0.03958128003666935, -0.005674999563940093, 0.193565613495663, 0.02596384270286385, -0.04737889847365301, 0.04543103359859865, 0.1985923017186838, -0.4178541657524038, 0.5478847938205339, 0.001383642920225686, 0.001182191897963865, 0.002181560264972079, 0.1985923017186839, -0.4178541657524035, 0.5478847938205339, 0.001383642920225511, 0.001182191897964022, 0.002181560264972062, 0.01668632333499096, 0.01042624090464394, 0.0166863233349912, -0.008244416580620306, -0.01127344838677206, 0.02776228154801209, -0.008244416580620039, -0.01127344838677187, 0.02776228154801193, -0.09942521929730092, -0.09942521929730071, 0.334804883294351, -0.0006927207126461105, -0.0006927207126459787, -0.0009472290882074708, 0.006605823651738237 },
            { 0.02319260896167058, 0.02319260896167035, -0.02070490865233492, -0.02645673874857109, 0.005124628831690126, 0.005361881137819068, 0.02827782277230292, -0.008840301102126984, -0.02530799986958489, 0.05726489315388391, -0.04887274933593424, -0.03821161244909613, 0.05737261110429742, -0.008840301102126899, -0.02530799986958475, 0.05726489315388385, -0.04887274933593431, -0.03821161244909586, 0.0573726111042974, -0.09897129603627199, 0.1803582470445573, -0.09897129603627167, 0.04491703174991037, -0.01927138351650828, -0.07056267998331241, 0.04491703174991069, -0.01927138351650833, -0.07056267998331264, 0.09096064589765963, 0.0909606458976599, -0.1428951713302999, 0.5028671303199708, 0.502867130319971, -0.2157521311782029, 0.2536125723339225 },
            { 0.02031186795647099, 0.02031186795647079, -0.02972368152675263, -0.02665480921729696, 0.03517748253151909, 0.01200475223875576, 0.03026699130493011, -0.03367369525999789, -0.02292830329986491, 0.0612931213666138, -0.03176789066736996, -0.02440610249032691, 0.06720550434410599, -0.03367369525999775, -0.02292830329986487, 0.06129312136661373, -0.03176789066737003, -0.0244061024903268, 0.06720550434410595, -0.06433256476071531, 0.04661408325106736, -0.06433256476071499, 0.09807912698569611, -0.1039921030710107, -0.09216615090038166, 0.0980791269856965, -0.1039921030710107, -0.0921661509003818, 0.1986182165680465, 0.1986182165680465, -0.1866439586319418, 0.1873771719962442, 0.1873771719962441, -0.1986737319371706, 0.7983964744518685 },
            { -0.001801091269247245, -0.001801091269247451, -0.03971898125558419, 0.02306868295823357, 0.09844979659654117, -0.05447853760033652, -0.03095626731168391, 0.005558310115915819, -0.004567474346681664, -0.06268896139284609, 0.001722304899509481, 0.001307057016517653, 0.06177668116087705, 0.005558310115915944, -0.004567474346681474, -0.06268896139284619, 0.001722304899509362, 0.001307057016517786, 0.06177668116087695, 0.003487807630841455, 0.0001095835104162096, 0.003487807630841707, -0.007889255008281191, -0.1905582715487023, 0.2063367815652647, -0.007889255008281061, -0.1905582715487021, 0.2063367815652645, -0.01597638363995506, -0.0159763836399548, 0.4178487801268898, -0.004950462145094687, -0.004950462145094581, -0.1195742194600493, 0.7217370763593364 },
            { -0.03447148749511586, -0.03447148749511603, -0.03974059720891059, -0.04040605971477433, 0.1488137364235412, -0.2006373486991844, 0.1011762603611383, 0.1449618774546609, -0.2364957723510666, 0.2048901637846385, 0.01654687566850587, 0.01247393595826746, 0.03439914959238752, 0.1449618774546609, -0.2364957723510663, 0.2048901637846383, 0.01654687566850571, 0.0124739359582676, 0.03439914959238742, 0.03350877027617841, 0.01470330991629677, 0.03350877027617867, -0.08910970272005876, -0.1530931926102328, 0.3313125980503503, -0.08910970272005853, -0.1530931926102326, 0.3313125980503498, -0.1804544022475655, -0.1804544022475653, 0.6709349825359231, -0.02059821940950599, -0.02059821940950593, -0.03538837046055465, 0.2528028989436369 },
            { -0.03683978085470201, -0.0368397808547021, -0.02351675082611397, 0.193565613495663, 0.111110855045382, -0.2129097496555521, 0.2259730354911518, 0.1816824192751108, -0.3720446188415562, 0.4576137928742575, 0.00629620010329695, 0.004730084069506001, 0.007797665372236415, 0.1816824192751108, -0.3720446188415557, 0.4576137928742571, 0.006296200103296763, 0.004730084069506162, 0.007797665372236368, 0.01275031777000565, 0.008265484918257142, 0.01275031777000591, -0.03651188217435912, -0.04231333239473346, 0.1153370967434512, -0.03651188217435881, -0.0423133323947332, 0.1153370967434509, -0.07393953376105651, -0.07393953376105633, 0.2335670102636767, -0.002562372858978501, -0.002562372858978376, -0.002969513704701282, 0.02292190432727775 },
            { 0.006746848191584858, 0.006746848191584617, 0.0196804606852359, -0.02645673874857105, -0.008320196683643526, -0.03483895378318298, 0.0625461354887268, -0.001949418458884942, -0.002754290465431984, 0.04013073679567201, -0.02383742285838807, 0.02702061327942555, -0.06527764400451784, -0.001949418458885063, -0.002754290465431705, 0.0401307367956719, -0.02383742285838829, 0.02702061327942587, -0.06527764400451791, -0.01529452355676767, 0.002136189794584494, -0.01529452355676736, 0.01081228481471903, 0.08775047889585055, -0.1093750485252887, 0.0108122848147194, 0.08775047889585072, -0.1093750485252889, 0.006937358362252763, 0.006937358362252979, -0.07017701813365142, 0.08482978297835218, 0.08482978297835211, 0.688462633804094, 0.2754879766792507 },
            { -0.00609144832973567, -0.006091448329735909, 0.02315591307930745, -0.02665480921729688, -0.04141279782232517, -0.0344432021170079, 0.06694586617356134, 0.008164340325242412, 0.003500065711416457, 0.04295368393229823, 0.01703621902112013, -0.01068939263643962, -0.05544512148345264, 0.00816434032524224, 0.003500065711416707, 0.04295368393229809, 0.01703621902111979, -0.01068939263643931, -0.05544512148345269, 0.01093074761834333, 0.001086239790236902, 0.01093074761834367, -0.0331158101767776, 0.2090929349961158, -0.1428613146425609, -0.03311581017677714, 0.209092934996116, -0.142861314642561, -0.02124770541929379, -0.02124770541929374, -0.09166241481438273, -0.04433678029076705, -0.04433678029076718, 0.2799420418762811, 0.8672623258006068 },
            { -0.0273059160603582, -0.02730591606035842, 0.00551430449164186, 0.02306868295823362, -0.017812894403291, 0.01605628554003024, -0.06847043724307714, 0.07360606878045117, -0.04700871157106172, -0.04393187642714944, 0.05044700637332813, -0.003964755460798088, -0.007833086487601958, 0.07360606878045108, -0.04700871157106139, -0.04393187642714957, 0.05044700637332791, -0.00396475546079787, -0.007833086487602035, 0.03236771575219857, 0.01160779343651897, 0.03236771575219884, -0.1795943784358461, 0.03935828130599766, 0.3198304755656945, -0.1795943784358459, 0.03935828130599787, 0.3198304755656943, -0.1152310158681228, -0.1152310158681227, 0.2052090434344234, -0.07897527864506929, -0.0789752786450692, 0.01730750851003115, 0.7839906556321634 },
            { -0.04149525727604114, -0.04149525727604132, -0.03076743722716265, -0.04040605971477431, 0.1323516525356928, -0.2245148383223399, 0.2237861146434754, 0.1626704441286403, -0.2360759569199994, 0.1435852366434698, 0.04107006252419123, 0.01393365830101771, 0.02143989884432879, 0.1626704441286404, -0.2360759569199991, 0.1435852366434699, 0.04107006252419108, 0.01393365830101789, 0.02143989884432872, 0.02635129822908344, 0.01465115509241488, 0.02635129822908371, -0.1967468940062647, -0.1200543297370577, 0.5135481177495869, -0.1967468940062644, -0.1200543297370575, 0.5135481177495868, -0.1262363814652377, -0.1262363814652377, 0.3295018018984711, -0.03187140790926368, -0.03187140790926363, -0.01944783186361856, 0.2746084647449323 },
            { -0.03014890320122789, -0.03014890320122799, -0.03827576649250286, 0.1935656134956629, 0.1902826731863671, -0.3945927279594243, 0.499817125541642, 0.1449328843728634, -0.2852131186853869, 0.320691747849012, 0.0111093095019602, 0.006720426841824117, 0.009358279823466585, 0.1449328843728636, -0.2852131186853866, 0.320691747849012, 0.01110930950196002, 0.006720426841824285, 0.009358279823466514, 0.007127934797588985, 0.004857549981637491, 0.007127934797589237, -0.06191034217840719, -0.05495654683769637, 0.1787772311945105, -0.06191034217840694, -0.0549565468376962, 0.1787772311945102, -0.03972280025741078, -0.03972280025741062, 0.1147067193530925, -0.003044808528124198, -0.003044808528124103, -0.002702814369939407, 0.02489903787751797 },
            { -0.03437691823049988, -0.03437691823050004, -0.04065529414352155, -0.02645673874857104, 0.07155728382479881, -0.1348907822337633, 0.09931759007824136, 0.007885389847846907, 0.007218236097192122, 0.02174500950091477, 0.153109834695484, -0.2741787011396611, 0.3042055927980301, 0.007885389847846667, 0.007218236097192519, 0.02174500950091465, 0.1531098346954839, -0.274178701139661, 0.3042055927980303, 0.0335225090290039, 0.01467177048627304, 0.03352250902900415, -0.04499502663652012, 0.1840980261645532, -0.09410797289151346, -0.04499502663651964, 0.1840980261645536, -0.09410797289151375, -0.009851399746351752, -0.009851399746351496, -0.02060439407586974, -0.1912836544276725, -0.1912836544276723, 0.7826407905511711, 0.1284379241396264 },
            { -0.03891874703260562, -0.03891874703260586, -0.02610225289337169, -0.02665480921729686, 0.1033929806787114, -0.1586234197313436, 0.1063039633401005, 0.04326948665953381, 0.01327404122741954, 0.0232746353490287, 0.1433704173952627, -0.1866997696467039, 0.07500708558599634, 0.04326948665953353, 0.01327404122741995, 0.02327463534902859, 0.1433704173952625, -0.1866997696467035, 0.07500708558599652, 0.03139012017865182, 0.01562354691153095, 0.03139012017865212, -0.1994288754360305, 0.5217778218288253, -0.1229200709567649, -0.1994288754360302, 0.5217778218288263, -0.1229200709567653, -0.0436637939734231, -0.04366379397342293, -0.02691263560364533, -0.1446769270984885, -0.1446769270984885, 0.3785269897615768, 0.4043347885923321 },
            { -0.04164408453309126, -0.04164408453309148, 0.01944774835584462, 0.02306868295823364, -0.0931249229462172, 0.2581706538315076, -0.1087248439164008, 0.09883718681790254, -0.05094325945844279, -0.02380467309048752, 0.1075642227998955, -0.06908544799849782, -0.02218946458429419, 0.09883718681790236, -0.05094325945844246, -0.02380467309048766, 0.1075642227998952, -0.06908544799849753, -0.02218946458429421, 0.02355056183803483, 0.01363221516449767, 0.02355056183803509, -0.309048621426053, 0.3429101857468728, 0.2751870571052327, -0.3090486214260529, 0.3429101857468737, 0.2751870571052328, -0.06766440067524743, -0.06766440067524734, 0.06025060783863111, -0.07363897035296206, -0.07363897035296199, 0.08170737952307824, 0.3655118948130987 },
            { -0.03560394004953685, -0.03560394004953703, 0.001423206570283742, -0.0404060597147743, -0.007285068764193849, 0.01709393778786671, 0.3553520521402793, 0.1301114580408743, -0.1688178744117105, 0.07780226789506797, 0.05216244585345892, -0.0007586280472715681, -0.0006394542638077376, 0.1301114580408742, -0.1688178744117101, 0.0778022678950679, 0.05216244585345874, -0.0007586280472713408, -0.0006394542638078001, 0.0114206645547967, 0.007492128262006582, 0.01142066455479695, -0.2234087844710731, 0.004952874980509014, 0.441864693961637, -0.2234087844710728, 0.004952874980509243, 0.4418646939616367, -0.04891405577888242, -0.04891405577888228, 0.09674370834758647, -0.01960993154989841, -0.0196099315498983, 0.0004347436004940555, 0.1280278783421234 },
            { -0.01909146182069396, -0.01909146182069408, -0.04145451836505668, 0.193565613495663, 0.2183125263152957, -0.4965181115031935, 0.7936642608011621, 0.08935742916864653, -0.168781804564629, 0.1737681802192521, 0.01087618254315918, 0.005004250068636691, 0.005817788202867953, 0.08935742916864656, -0.1687818045646287, 0.173768180219252, 0.01087618254315898, 0.005004250068636863, 0.005817788202867874, 0.00238127699784454, 0.001701098786749178, 0.002381276997844805, -0.05817615635880411, -0.03747036488315075, 0.1538226776007588, -0.05817615635880394, -0.03747036488315056, 0.1538226776007586, -0.01273733154169685, -0.01273733154169676, 0.03367858184284958, -0.001550330445371055, -0.001550330445370941, -0.0009985439244081622, 0.01160842217729763 },
            { -0.03264061575451477, -0.03264061575451485, 0.2564946004984638, -0.02645673874857107, 0.2949230850789762, -0.2573608213043341, 0.1287360490666405, 0.006427220519096451, 0.004590345673672384, 0.007035780006715184, 0.1617622289769978, -0.3326658216922729, 0.4056717495783215, 0.006427220519096308, 0.004590345673672799, 0.007035780006715111, 0.1617622289769979, -0.3326658216922732, 0.4056717495783217, 0.008840751791977497, 0.005933502650654356, 0.008840751791977741, -0.03708965765964585, 0.1136480380341266, -0.03946872271483585, -0.03708965765964525, 0.1136480380341273, -0.0394687227148362, -0.002027052047267491, -0.002027052047267185, -0.002157074511614782, -0.05101745870459833, -0.05101745870459809, 0.156324820802352, 0.01742900445188551 },
            { -0.02961172058828926, -0.0296117205882894, -0.004745786847815461, -0.02665480921729689, 0.6691449677790829, -0.3133858744525396, 0.1377918275075797, 0.02897053398713011, 0.0072400893800748, 0.007530703265289176, 0.1244251893901746, -0.2011854905454444, 0.1570666936398504, 0.02897053398713004, 0.007240089380075209, 0.007530703265289065, 0.1244251893901746, -0.2011854905454444, 0.1570666936398507, 0.006800179640358161, 0.004647946995274729, 0.0068001796403584, -0.1409947069730294, 0.3335418812622256, -0.05155246731616727, -0.1409947069730291, 0.3335418812622263, -0.05155246731616776, -0.007705749458413128, -0.00770574945841292, -0.002817484468955137, -0.03309532838373646, -0.03309532838373625, 0.07829143609067592, 0.05486816201394559 },
            { -0.02385873900776729, -0.02385873900776744, -0.01759858691004886, 0.02306868295823363, 0.1372262556288498, 0.5759284463220433, -0.140929787262841, 0.05168309597268545, -0.02307659409226858, -0.007702201417267428, 0.07290712835570386, -0.0698125040759922, 0.01057963683075997, 0.05168309597268539, -0.02307659409226825, -0.007702201417267542, 0.07290712835570377, -0.06981250407599192, 0.01057963683076, 0.003984575569555707, 0.002797282942724302, 0.003984575569555971, -0.1814620432162821, 0.2475111058116877, 0.1154129806208758, -0.1814620432162819, 0.2475111058116888, 0.1154129806208757, -0.009917400952532809, -0.009917400952532594, 0.00630763758446112, -0.01399005246480207, -0.01399005246480197, 0.01908219093399875, 0.04959990193386436 },
            { -0.01572782937938802, -0.01572782937938818, 0.02005278463846139, -0.0404060597147743, -0.1210392777590414, 0.4095876032623192, 0.4606094366992159, 0.05451857796946852, -0.06520950575194921, 0.02517357561559966, 0.02833093620591509, -0.007021437919486824, -0.003437595763773588, 0.05451857796946842, -0.06520950575194882, 0.02517357561559957, 0.02833093620591492, -0.007021437919486576, -0.003437595763773625, 0.001548363772030187, 0.001117867075933855, 0.001548363772030453, -0.1118579175651321, 0.03839853896926748, 0.185317296160997, -0.1118579175651319, 0.03839853896926775, 0.1853172961609966, -0.006113343587157621, -0.006113343587157493, 0.0101281011548918, -0.003176839045024091, -0.003176839045023959, 0.00109054397332573, 0.01737336130693397 },
            { -0.006949591278799756, -0.006949591278799874, -0.03732553226575755, 0.193565613495663, 0.2063633124252942, -0.5087168207405977, 1.028752320112141, 0.03185557075892972, -0.05829635483192344, 0.0562241505637624, 0.005025800171020179, 0.001770907106634593, 0.00177936232736482, 0.03185557075892967, -0.05829635483192314, 0.05622415056376237, 0.005025800171019975, 0.001770907106634785, 0.001779362327364741, 0.0002746738354747428, 0.0002029369284709745, 0.0002746738354750256, -0.02604562611388645, -0.01242171540863297, 0.06451296763640577, -0.02604562611388625, -0.01242171540863277, 0.0645129676364052, -0.001423465274902315, -0.001423465274902252, 0.003525811543549251, -0.0002245777379469528, -0.0002245777379467741, -0.0001071059200377558, 0.001575260914272583 },
            { -0.01262713981557409, -0.02771404479110645, -0.02848613965062156, -0.02645673874857111, 0.0055371926541117, 0.003876453322753161, 0.005685150503339714, 0.1038019607210036, -0.1574201661900562, 0.1054793471232692, 0.1153722250798742, -0.1718364468440879, 0.1141854617231494, 0.003257949451411165, 0.003679859066648911, 0.03164311145346185, 0.003621096121847998, 0.004016854525083752, 0.03425488866031784, 0.06718394782667152, -0.1631217647297306, 0.6421529517453908, 0.05617066818259873, -0.02566310785484644, -0.02613063979371073, -0.001313047416948501, -0.007698763826667293, -0.007839020338041795, -0.02436160383093989, 0.3126416288668674, -0.1454411359658689, -0.02707706502812916, 0.3474901641975259, -0.1587603966773188, 0.05189631027689216 },
            { -0.02345996111730929, -0.03618205086727411, -0.02552167167239573, -0.02665480921729708, 0.02469686349179419, 0.006068756454277249, 0.006085065396913818, 0.1799523328936171, -0.1869606183277099, 0.1128991615774846, 0.03413116256224907, -0.1006058318362078, 0.08690822260438816, 0.02871844888648774, 0.01040295457869612, 0.03386900706375951, 0.005446964936318918, 0.005597959122650735, 0.02607189605448599, 0.1010601750910153, -0.1724567309347756, 0.1899714317781101, 0.1607869537476215, -0.09683354857256642, -0.03413079677416182, -0.008946586675015803, -0.02904942866526296, -0.01023901489509708, -0.1659903499314689, 0.8949278466260235, -0.1899693958296841, -0.03148302401072425, 0.1697389932295776, -0.1022248923961468, 0.1633745156276261 },
            { -0.03713344901196321, 0.01425169802776655, -0.02018790612716793, 0.02306868295823344, 0.04338357691568713, -0.01913588053374872, -0.00622364176003376, -0.0742448752547495, 0.3155958032078607, -0.1154702358700684, -0.004625191758894717, -0.03172288269591739, 0.05014343532325254, 0.09419353716058994, -0.05417748655494987, -0.03464031246727387, 0.005867922470358172, 0.005445782337005243, 0.01504270130472862, 0.1088704038318373, -0.08981379496549535, -0.0257434624174613, 0.1095940798652238, -0.123290550897265, 0.0764102513758065, -0.01881372226134967, -0.03698635561937604, 0.02292257362615282, -0.3490600890723919, 0.6099922388646907, 0.425293595842598, -0.0217452025045108, 0.03800034772105278, -0.04274942415300029, 0.1476878330927732 },
            { -0.04093237841029028, 0.006384739309514701, -0.01305200265879773, -0.04040605971477437, 0.04503040295118442, -0.05347701744396708, 0.02034110872501609, -0.03375646270612685, 0.08464280865275212, 0.3773984289101497, -0.0007746671283291409, -0.00118994144645222, 0.01917297458448684, 0.1552508497133713, -0.213621118662252, 0.1132170502952494, 0.003562806060727415, 0.00300316857367661, 0.005751766466304398, 0.06610246412854195, -0.004753380706020497, -0.004311737792456219, 0.006411913828217944, -0.07516060295747007, 0.1226910621991616, -0.01618235768107818, -0.0225476873071005, 0.03680651294679092, -0.3002391092571215, 0.03568822035179418, 0.6828890375428207, -0.006890098959868113, 0.0008189984660354472, -0.009600319058806775, 0.05173062818511569 },
            { -0.02557815590343019, -0.04099979151831734, -0.005674999563940065, 0.193565613495663, 0.0259638427028638, -0.04737889847365301, 0.04543103359859865, 0.2180859889617275, -0.504176529159724, 0.8429039407664713, 0.001519460381977728, 0.001426414899664621, 0.003356263515805592, 0.1214420892979636, -0.2344553949722817, 0.2528656468745965, 0.000846117828436928, 0.0006633205818855868, 0.001006857014138605, 0.01569843332739811, 0.00705864170483436, 0.008457199890802477, -0.009947588602064995, -0.01734385436210921, 0.04271141814012995, -0.004625891289715148, -0.005203042411434558, 0.01281314495589388, -0.0858263985827234, -0.05536751483420162, 0.2377284759215495, -0.0005979742806731187, -0.0003857595145824377, -0.0006725807738297953, 0.004690470382278128 },
            { -0.02495652929806426, -0.03240419913090826, -0.02070490865233491, -0.02645673874857111, 0.005124628831690126, 0.005361881137819002, 0.02827782277230294, 0.02902548365002267, -0.09812408341868215, 0.08810028066373139, 0.160464578117202, -0.1481539223502045, 0.08826600142459008, 0.006041846787381903, 0.006075743364837927, 0.0264295056440365, 0.03340176540986724, 0.009173540066134163, 0.0264792207840047, 0.1040640551066646, -0.1678786208714959, 0.1499761670891586, 0.1741521492437128, -0.02964843210342448, -0.1085585175931348, -0.01078332381180017, -0.008894334929591985, -0.03256684237349032, -0.03359572135228247, 0.1627690805059436, -0.1014628310156255, -0.1857306950794884, 0.8998531135204924, -0.1531949737923248, 0.180077810401831 },
            { -0.03280377145867325, -0.003357685596893608, -0.02972368152675259, -0.02665480921729706, 0.03517748253151914, 0.01200475223875569, 0.03026699130493015, 0.009703884312666682, -0.1125841458311084, 0.09429758614311826, 0.009154680931611691, -0.1198405379588697, 0.1033936059035812, 0.03812711034200993, 0.01261027312837132, 0.0282886565901095, 0.03596925919343834, 0.0134230437541298, 0.0310174027846307, 0.1120631477085374, -0.1258853065399806, 0.008556305529588866, 0.4815949349209139, -0.1599886590680968, -0.1417947945908064, -0.05394226355550361, -0.04799554707392453, -0.04253750720995697, -0.1680585028466757, 0.4501165508080966, -0.1325266925289348, -0.1585470232159911, 0.4246416457486892, -0.1410684427130846, 0.5669020570578507 },
            { -0.04071692449822333, 0.02343428556274746, -0.03971898125558416, 0.02306868295823348, 0.0984497965965412, -0.0544785376003365, -0.03095626731168391, -0.09782049610383155, 0.1660499124006589, -0.09644504318529371, -0.0303107808306084, -0.04751788113558418, 0.09504152804619323, 0.09967243709134718, -0.05402994244200229, -0.02893287960039846, 0.03088462557296385, 0.01546154614358793, 0.02851183427556075, 0.09622184151452588, -0.04712660243482143, -0.02832958391062396, 0.2868127992844248, -0.2931680525644633, 0.3174428059841397, -0.09332422289736511, -0.08794849053294108, 0.0952307571463895, -0.2907540052212063, 0.2680659171856125, 0.2966938614748701, -0.09009339840729308, 0.08306323917376711, -0.08490377043501762, 0.5124699899557145 },
            { -0.03882422922489384, -0.008454146485977981, -0.03974059720891056, -0.04040605971477434, 0.1488137364235412, -0.2006373486991843, 0.1011762603611383, 0.04090465035196576, -0.08593400912262331, 0.315217228925193, 0.004669118360786781, 0.004532577118721179, 0.05292203594162259, 0.144373886169673, -0.1925204755329315, 0.0945630986440838, 0.0164797585832575, 0.01015446516687884, 0.01587626324315239, 0.05134310969222098, 0.004349209695719216, 0.004363931801353533, -0.03237924268300457, -0.2355291784169414, 0.5097142641518437, -0.07254016497511584, -0.07065720680352404, 0.1529109319488562, -0.2260007407628522, -0.03026284534459559, 0.4763979224893453, -0.02579716973907692, -0.003454394686967745, -0.02512754082961963, 0.1795029011616402 },
            { -0.02232219308626723, -0.04162279872719096, -0.02351675082611397, 0.193565613495663, 0.111110855045382, -0.2129097496555521, 0.2259730354911518, 0.2153019879091377, -0.4756336109937085, 0.7040247762181038, 0.007461285488833487, 0.006047089118741081, 0.01199646886565956, 0.1051854336230482, -0.2007330594015487, 0.2112028095304111, 0.003645198807265479, 0.00255207090336351, 0.003598861878813298, 0.01135671018879649, 0.005701245251767384, 0.00697359512175884, -0.04667794528742543, -0.06509776329759806, 0.1774425836564898, -0.01969963128666878, -0.01952890149186851, 0.05323160983041218, -0.06137470551755003, -0.04362694498652713, 0.1658444429758221, -0.002126939022285203, -0.001511890785176876, -0.002108505587793734, 0.01627571655265399 },
            { -0.03902719790271385, 0.02047850070830743, 0.01968046068523593, -0.02645673874857108, -0.008320196683643463, -0.03483895378318309, 0.0625461354887268, -0.00851571579357298, -0.0333053616823687, 0.06173990695207018, -0.1041298841652333, 0.3267379782362987, -0.1004276519369549, 0.008639841861519778, 0.007449010630836175, 0.01852156663927381, 0.1056476935180241, -0.07307756320414251, -0.03012763607208086, 0.1042858797995482, -0.0698607279807285, -0.03083561556019436, 0.1307440376701699, 0.1350014187283426, -0.1682701554474765, -0.02924195016441179, 0.04049953906335874, -0.05047994160310106, -0.02886501728909037, 0.03871677102787952, -0.04982924801298259, -0.3529604533078611, 0.4734273641949985, 0.488843445330789, 0.1956104588029308 },
            { -0.04122892014780966, 0.02291807830838166, 0.02315591307930752, -0.02665480921729699, -0.04141279782232511, -0.03444320211700805, 0.06694586617356135, -0.04050038720119509, -0.03258267678117441, 0.0660829244858204, -0.08451062049268929, 0.09950928181837045, -0.08530061779737322, 0.04450755756350878, 0.01300536454864535, 0.01982444337877611, 0.09287223076709829, -0.03971909658354183, -0.02558962516953225, 0.09167509457119535, -0.03757358220136997, -0.02502583216294513, 0.3082804233695208, 0.3216830634514469, -0.2197877481789315, -0.1230500279660212, 0.09650280654078508, -0.06593488110619039, -0.1214638956941006, 0.09128999514368427, -0.06508497115902064, -0.253454100119439, 0.1904913673057357, 0.1987730713685736, 0.6158003100435526 },
            { -0.04072125066349055, 0.004450038028120515, 0.005514304491641908, 0.02306868295823356, -0.01781289440329098, 0.01605628554003024, -0.06847043724307716, -0.01427315562842497, 0.01267802473855686, -0.06758784361852474, -0.009782318019215943, 0.001069275590298453, -0.01205096316457918, 0.09466301193507796, -0.0471952503297708, -0.02027590923577425, 0.0648786933676806, -0.00398048830131885, -0.003615209810624876, 0.06404239782990996, -0.003142989020084746, -0.002896803354255521, 0.04843574513361195, 0.06055150788778364, 0.4920493710943264, -0.1803070402235225, 0.01816505472421188, 0.1476115800370624, -0.1779828569618005, 0.01434310647980426, 0.1457088458835143, -0.1219831797603043, 0.009830259868357142, 0.01228921029945556, 0.5566731938503819 },
            { -0.0325842462113068, -0.03136678397027926, -0.03076743722716263, -0.0404060597147743, 0.1323516525356927, -0.2245148383223398, 0.2237861146434754, 0.134459259594934, -0.2267129190140598, 0.2209014799602402, 0.03394747108548733, 0.01338103374516317, 0.03298462638377014, 0.1176773535525723, -0.1499002116504072, 0.06626899332669939, 0.02971047564278799, 0.008847399606622475, 0.009895171304887429, 0.029327503407754, 0.008934018818040887, 0.01005274495429068, -0.1889436909588626, -0.1846999018457714, 0.7900780184202789, -0.1249275929572681, -0.05540875762834371, 0.2370182170788943, -0.1233172586069369, -0.05595122921376412, 0.2339630187229399, -0.03113440519836308, -0.01412623230005725, -0.01380894861336865, 0.1949859606485341 },
            { -0.01669492344707409, -0.0380744421614196, -0.03827576649250286, 0.193565613495663, 0.1902826731863672, -0.3945927279594245, 0.4998171255416422, 0.189049666937128, -0.3912790452831663, 0.4933744120698556, 0.01449092295606229, 0.009219639723041366, 0.0143974263037846, 0.07778091366060157, -0.1458880708144907, 0.1480090836281687, 0.005962016466724147, 0.003437535101900981, 0.004319133343148573, 0.00588516523084954, 0.003408667614719444, 0.004291145937284494, -0.08493374951466576, -0.08454896069918157, 0.2750432835384228, -0.0316674787804405, -0.02536413297621103, 0.08251117885059765, -0.03125928049804876, -0.02515113186877532, 0.08144759807997604, -0.002396067830734757, -0.001927869644379646, -0.001919135511233393, 0.01767958181581004 },
            { -0.03886092696465353, -0.008250213363944145, -0.04065529414352154, -0.02645673874857107, 0.0715572838247989, -0.1348907822337635, 0.09931759007824138, 0.002178398618789501, 0.002570504009016053, 0.03345402976511377, 0.04229775050561486, -0.09763845917155907, 0.4680109684822757, 0.007879570167104225, 0.00589174064932531, 0.0100359892367157, 0.1529968345301564, -0.2237928736235234, 0.1404002171137847, 0.0515352884852302, 0.004264638912402592, 0.004274165014246059, -0.01602329084247608, 0.2832291633051983, -0.1447822281298511, -0.03672628934303854, 0.0849668890239087, -0.04343371765317618, -0.01237084363279751, -0.001619144950105631, -0.01463016653982654, -0.2402034471610161, -0.03143877733913178, 0.5557147210669315, 0.09119745105210127 },
            { -0.03635734686787375, -0.01984886518320766, -0.02610225289337165, -0.02665480921729693, 0.1033929806787115, -0.1586234197313437, 0.1063039633401005, 0.02475565406210098, 0.009274242332480732, 0.03580731218838147, 0.08202612810508435, -0.1304424837513084, 0.1153960992145258, 0.03646275517499344, 0.009470543015015407, 0.0107419585096759, 0.1208167887443206, -0.1332034584675042, 0.03461807195746702, 0.04069579662166441, 0.0077880123593633, 0.008288696273677067, -0.1393359932518021, 0.8027391655774393, -0.1891087567629957, -0.1422852099744586, 0.2408164780802123, -0.05673138515053443, -0.04792719643993698, -0.01407982742493591, -0.01910933849630198, -0.1588034129511562, -0.04665252330470031, 0.2687733926869819, 0.2870982409465322 },
            { -0.03062008488988902, -0.03538565054157865, 0.01944774835584464, 0.02306868295823363, -0.09312492294621717, 0.2581706538315076, -0.1087248439164009, 0.09090396072936988, -0.05341828190673412, -0.03662275898681373, 0.0989305159332579, -0.07244188880076013, -0.03413781027061361, 0.06753193549861419, -0.03099862159280473, -0.0109865871941615, 0.07349480888670291, -0.04203801803890883, -0.01024111889797484, 0.02475591204075895, 0.008698117563231302, 0.009996875601862187, -0.3240634101100588, 0.5275567968942034, 0.4233668418947007, -0.1880539520086903, 0.1582635745995432, 0.1270072723157648, -0.06334389007012636, -0.03274643387254753, 0.04278099242128487, -0.06893697123399914, -0.03563784869209501, 0.05801639036575176, 0.2595320140797419 },
            { -0.02112183444024145, -0.04133309679808737, 0.001423206570283756, -0.04040605971477428, -0.007285068764193877, 0.0170939377878668, 0.3553520521402793, 0.1578649471058826, -0.2196489795143269, 0.1196964014131826, 0.06328898222770565, -0.0009870511460638776, -0.0009837807600844455, 0.07399278649510707, -0.08993600866935408, 0.03590813437695317, 0.02966414163067058, -0.0004041513902125139, -0.0002951277675310418, 0.009992037425467198, 0.005193153358290672, 0.006395317727097282, -0.2906772265354591, 0.007619846154303399, 0.6797952708792185, -0.1190187617692603, 0.002285903806714926, 0.2039341170440552, -0.04009015115750508, -0.02937277791950091, 0.06869294770784698, -0.01607237648780629, -0.01177571876344904, 0.0003086900422274654, 0.09090629770469702 },
            { -0.009682098480128108, -0.02662785624763475, -0.04145451836505666, 0.193565613495663, 0.2183125263152956, -0.4965181115031935, 0.7936642608011621, 0.1267598619661151, -0.2457156461655039, 0.2673370123402329, 0.01542863767138082, 0.007285279016660797, 0.008950488602807248, 0.04456863824272091, -0.08208288517114459, 0.08019934809827114, 0.005424693276627137, 0.002433694110636962, 0.002685087802928613, 0.001827247823874155, 0.001204380478999654, 0.001559055565939507, -0.08469391524757203, -0.05764700641118921, 0.2366514686870486, -0.02829254477054563, -0.01729372335511198, 0.07099388651446865, -0.009530030220618747, -0.008558274734317722, 0.02391350405024062, -0.001159952219816641, -0.001041674532615198, -0.0007090169144323699, 0.008242569477807347 },
            { -0.01858506351847881, -0.03987149506809774, 0.2564946004984638, -0.02645673874857108, 0.2949230850789762, -0.2573608213043342, 0.1287360490666405, 0.008148134771083247, 0.006168625717409414, 0.01082433161298639, 0.2050747191043495, -0.4470449697859734, 0.624113536703126, 0.003530822036592027, 0.002386623605427169, 0.003247228400443921, 0.0888647963864357, -0.1729604171910537, 0.1872299624535174, 0.007471893318004024, 0.004145650733360568, 0.005172789260791946, -0.04984204509943961, 0.1748440186692274, -0.06072141860584605, -0.01928374435838408, 0.05245205739902653, -0.01821602682382605, -0.001621407874395468, -0.001257211989621483, -0.001531632487106161, -0.0408080835352965, -0.03164189141068944, 0.1109985643948328, 0.012375478590418 },
            { -0.0163084975755769, -0.03763593792610825, -0.004745786847815461, -0.0266548092172969, 0.6691449677790831, -0.3133858744525397, 0.1377918275075797, 0.03799560475880878, 0.009971627173580615, 0.01158575585715996, 0.1631868546230182, -0.2770886655037878, 0.2416422878046816, 0.01547691146568515, 0.003691624224627765, 0.00347565067341829, 0.0664715963174279, -0.1025817764881591, 0.07249109947501949, 0.005589037465426158, 0.003264050211996375, 0.004116212923675226, -0.1941891291083415, 0.5131439479568479, -0.0793118888261497, -0.07189130527011679, 0.1539398145676036, -0.02379304580618529, -0.006044735208017543, -0.004898211959042144, -0.00200055710701345, -0.02596145874995422, -0.02103727017761525, 0.05559089699173404, 0.0389591824463453 },
            { -0.01250399737956941, -0.03209534726556369, -0.01759858691004886, 0.02306868295823363, 0.1372262556288499, 0.5759284463220431, -0.1409297872628409, 0.07112435886035022, -0.03288994993426022, -0.01184960050071847, 0.1003320846605091, -0.09950037491078499, 0.01627644657618792, 0.02649074818163211, -0.01143434379185615, -0.003554802333816526, 0.03736936306868315, -0.03459176728522124, 0.004882827085332027, 0.003142075440051085, 0.001975456328670687, 0.002530768942712525, -0.2586290460580438, 0.3807882402016016, 0.1775593286730392, -0.08991358859160344, 0.1142339714217746, 0.05326663256871228, -0.007560077433519451, -0.006523639568157397, 0.004478743126040796, -0.01066467721120942, -0.009202618736179398, 0.013549324978021, 0.03521845015094776 },
            { -0.007816863792841317, -0.02241723928834172, 0.02005278463846139, -0.04040605971477429, -0.1210392777590414, 0.4095876032623192, 0.4606094366992159, 0.07875024653515708, -0.09612767010257063, 0.03872877351022479, 0.04092308152345907, -0.01035055334628005, -0.00528863558311499, 0.02674179126429896, -0.03135470659495636, 0.01161837772097442, 0.01389654702228343, -0.003376120142324811, -0.001586555944432218, 0.00116844376019944, 0.0007923544577106948, 0.001032240724491168, -0.1648937662395973, 0.05907497375711522, 0.2851049727754595, -0.05378467671444803, 0.01772210418142005, 0.08552961954653406, -0.004522301101171022, -0.004159267933663263, 0.007191466348520754, -0.002350043393885991, -0.002161390830074545, 0.0007743416229571464, 0.01233596913071529 },
            { -0.003303304988079469, -0.01037776598911595, -0.03732553226575755, 0.193565613495663, 0.2063633124252942, -0.5087168207405977, 1.028752320112141, 0.0478241068894886, -0.08822672903069198, 0.0864991301291097, 0.00754512943443973, 0.002680121971365875, 0.002737494332209008, 0.01506156939890493, -0.02734367440406549, 0.02594917099841512, 0.002376238637621139, 0.0008306369662954369, 0.000821230322520591, 0.0001997979213412219, 0.0001440573214020954, 0.0001903177762732355, -0.03941790879052046, -0.01911042793504882, 0.09925122081245155, -0.01221659779863505, -0.005733002882216981, 0.02977471446035947, -0.001027190959437325, -0.000994274360901326, 0.002503505314460031, -0.0001620582013325258, -0.0001568650045818938, -7.605064442969649e-5, 0.001118515275655492 },
            { -0.0308956026377741, 0.3056635451225198, -0.02848613965062154, -0.02645673874857112, 0.005537192654111676, 0.003876453322753102, 0.005685150503339762, 0.3166833328790703, -0.2668309357797835, 0.130690033482262, 0.3519823759222681, -0.2912668752815564, 0.1414770021125195, 0.006048490355209549, 0.004281258226563932, 0.006432425094469141, 0.006722684097752803, 0.004673328833782274, 0.006963348270947751, 0.154540818103216, -0.3216828895127892, 0.3982480791604781, 0.09521062210316295, -0.03179686371104665, -0.03237614075826629, -0.001527638682314793, -0.001565007970466862, -0.001593519373486329, -0.0351173025979233, 0.1077254145719858, -0.03663176553605666, -0.03903164556221954, 0.1197330059133176, -0.03998644254854885, 0.01307094762169419 },
            { -0.02786989772001709, 0.006690843711503558, -0.02552167167239568, -0.02665480921729706, 0.02469686349179415, 0.006068756454277183, 0.006085065396913912, 0.7268804203624042, -0.3254097733326213, 0.1398832625446333, 0.1378658080824756, -0.1751070424701736, 0.1076802125896524, 0.0271328435929708, 0.006729661048754772, 0.006884906096610976, 0.005146226673233475, 0.003621314230994781, 0.005299906069221783, 0.1183012720309058, -0.1941766903899371, 0.1559873363173109, 0.2798538357535027, -0.1199777970787529, -0.04228842038601792, -0.005787538089367323, -0.005905180159076315, -0.0020813912832412, -0.1330437155946825, 0.3166387301139672, -0.04784694729483113, -0.02523410845433297, 0.0600561704160452, -0.02574703687052503, 0.04114858503609646 },
            { -0.02226886746828282, -0.02053451905131588, -0.0201879061271679, 0.02306868295823346, 0.04338357691568713, -0.01913588053374873, -0.006223641760033746, 0.1670937202553848, 0.600939576151325, -0.1430688509517217, 0.01040934468859268, -0.060404908708583, 0.06212824993743098, 0.04806699603416377, -0.02134491891810013, -0.007041697385620528, 0.00299440295601814, 0.002145536639303225, 0.003057886690550198, 0.0688352264995513, -0.06737802717601805, 0.01177758266074922, 0.2086828127417306, -0.1527583044857082, 0.09467311452944345, -0.00741225556502805, -0.007518602030932743, 0.004659710472515902, -0.1703926619714934, 0.2361127573800842, 0.1071172552622843, -0.01061485702848261, 0.0147089853118772, -0.01076715244263253, 0.03719763351994457 },
            { -0.0145518898690549, 0.02075076579392997, -0.01305200265879773, -0.04040605971477435, 0.04503040295118445, -0.05347701744396708, 0.02034110872501604, -0.1267610567651159, 0.4419282599752039, 0.4676006692834356, -0.002909002186724195, -0.006212798952127456, 0.0237555195281292, 0.05033608982018094, -0.06001447776471423, 0.02301480992196347, 0.001155148111689828, 0.0008437068147441706, 0.001169221522662048, 0.02655450287640652, -0.006972301418263889, -0.003291370853728091, 0.0334772199353668, -0.09312478684172509, 0.1520155316096513, -0.0045462534383932, -0.004583503422845612, 0.007482043536301226, -0.1045091090787262, 0.03787757412557817, 0.1719969453228314, -0.002398348787877118, 0.0008692413014770371, -0.002417999794199072, 0.0130292178352819 },
            { -0.006383645426197035, -0.03689485245927284, -0.005674999563940079, 0.193565613495663, 0.02596384270286382, -0.04737889847365312, 0.04543103359859865, 0.204659584876928, -0.5073439612622463, 1.044366951876962, 0.001425915220381596, 0.001435376190171786, 0.004158446209790446, 0.02923661196633653, -0.0534353517327501, 0.051402635764106, 0.0002036988886702862, 0.0001511791554586576, 0.0002046743201537995, 0.004682622661441038, 0.001618860591140515, 0.001613342134175688, -0.01001008320397232, -0.02148922010909469, 0.05291990156409553, -0.001054299169240949, -0.001057676664449086, 0.002604661531928079, -0.02423619104674907, -0.01132584095374949, 0.05987586478454011, -0.0001688596882398917, -7.891000565283645e-5, -0.0001694006379100452, 0.001181372863711297 },
            { -0.0273944922839773, -0.0110259115086922, -0.02070490865233483, -0.02645673874857114, 0.005124628831690105, 0.005361881137818911, 0.02827782277230299, 0.1263970029757738, -0.1716559976004299, 0.1091571852097644, 0.6987736019265388, -0.2591770384333494, 0.1093625149958885, 0.005309230839780438, 0.003699925586712616, 0.005372601098003452, 0.02935156902481178, 0.005586380723032277, 0.005382707212706276, 0.1133020276008207, -0.1788431580894696, 0.1327624071766731, 0.3046577340766969, -0.03673472286252245, -0.1345051584596098, -0.006566685471276716, -0.001808044170493685, -0.006620201507015196, -0.02534851809399235, 0.05788297386950403, -0.02555509905575241, -0.1401368297904494, 0.3200004208071721, -0.03858469836607804, 0.04535558722832309 },
            { -0.02447531302518714, -0.04007962075476779, -0.02972368152675251, -0.02665480921729711, 0.03517748253151911, 0.01200475223875566, 0.03026699130493017, 0.2352233128815205, -0.2049044215683622, 0.1168357126437118, 0.2219105574348302, -0.218111137493024, 0.1281057779168781, 0.02362472601947049, 0.005782904813926525, 0.005750530089516051, 0.02228765531784859, 0.006155630695155993, 0.006305230771333706, 0.08603412430339916, -0.1050680532087435, 0.04216155232787795, 0.8765082404964711, -0.1982276510107363, -0.1756852593240493, -0.02473721008368835, -0.009756555131284603, -0.008647042476714115, -0.09548982057143462, 0.1665308242865412, -0.03337904847723597, -0.09008545561566958, 0.157105805520739, -0.03553043011995634, 0.1427836980104777 },
            { -0.01928018940651649, 0.01027233067587207, -0.03971898125558412, 0.02306868295823344, 0.0984497965965412, -0.05447853760033643, -0.03095626731168392, -0.05647858358663643, 0.3521773959096308, -0.1194964347698702, -0.01750052429605986, -0.1007812855516265, 0.1177574645778425, 0.04135680830732899, -0.01819084089180304, -0.005881488015821938, 0.01281487216264298, 0.005205604765194733, 0.005795897743911432, 0.04946757695458762, -0.03365171700808844, -0.003324984982250268, 0.6083049566555481, -0.3632383367030432, 0.3933150144955558, -0.03142046823202618, -0.01787820639436112, 0.01935854863497343, -0.1212883289423595, 0.1155739571735889, 0.07472727641569905, -0.0375825527605213, 0.03581189040276768, -0.02138442464058197, 0.1290740779192522 },
            { -0.0124102698498273, 0.00912511728278448, -0.03974059720891056, -0.04040605971477432, 0.1488137364235412, -0.2006373486991842, 0.1011762603611382, -0.04921064378975361, 0.1286635315904434, 0.3905575008373494, -0.005617217565431072, -0.006786339718755458, 0.06557096567043826, 0.04276983431439079, -0.05070882241035054, 0.01922282673192728, 0.004882022385396746, 0.002674629643387042, 0.003227333514336758, 0.01884543325743401, -0.001715170669099381, -0.00106723454286995, 0.04847938268392291, -0.291823158304032, 0.6315413971091547, -0.01910667596866294, -0.01436322691643355, 0.03108379899154504, -0.07375500526501422, 0.009210765154567877, 0.1199887286536978, -0.00841886793603314, 0.001051375634066997, -0.006328788468651168, 0.04521078678825995 },
            { -0.005376068580257361, -0.04061590762108414, -0.02351675082611394, 0.193565613495663, 0.111110855045382, -0.212909749655552, 0.2259730354911518, 0.2173467560795982, -0.5074589290345994, 0.8722941892004598, 0.007532146883223987, 0.006451708409676948, 0.0148637525779309, 0.02458542446408887, -0.04483397564339209, 0.04293339654805486, 0.0008520073250233842, 0.0005700081743522309, 0.0007315781665419747, 0.003288892575872514, 0.001358583804478901, 0.001431058569854577, -0.04980123266647332, -0.08065682142534469, 0.2198532493014447, -0.004399936871003735, -0.003969843364121928, 0.01082094418545719, -0.0169845015228642, -0.009461907992714121, 0.04177067725855668, -0.0005885975135589512, -0.0003279022060515583, -0.0005310621497182904, 0.004099309516036924 },
            { -0.02096141170324594, -0.005880697701746635, 0.01968046068523601, -0.0264567387485711, -0.008320196683643401, -0.03483895378318317, 0.0625461354887268, 0.003493026207668041, -0.06586001995159937, 0.07649640168257904, 0.04271260610471696, 0.6461112769413258, -0.1244309293917708, 0.004001525804963268, 0.0027247445484585, 0.00376507190876499, 0.04893052194972216, -0.02673075685123125, -0.006124358617265021, 0.05984396689510615, -0.05053217701368639, 0.002571158587791733, 0.2585411025297015, 0.1672681943427365, -0.2084885131474686, -0.01069629891074939, 0.008232763448964838, -0.01026158390310881, -0.01308199733844674, 0.01556332513255158, -0.01255032366137435, -0.1599662201655974, 0.1903078123510865, 0.1231233402728507, 0.04926774268973688 },
            { -0.01847186527917351, 0.01601553293727515, 0.02315591307930759, -0.02665480921729705, -0.04141279782232504, -0.03444320211700808, 0.06694586617356134, -0.03616904734717517, -0.07249440370695562, 0.08187744662056623, -0.0754725780460941, 0.2214018847247753, -0.1056883731273783, 0.01760211513184522, 0.004224851213614569, 0.004029921244030305, 0.03672966543223821, -0.01290292730949438, -0.005201869839527205, 0.04492183599540909, -0.02715746399531511, -0.004543201290743534, 0.685904525794328, 0.3985687386177593, -0.2723193587359515, -0.03997335545981968, 0.01961713137447255, -0.01340327054917009, -0.04888899740905724, 0.04128919943628462, -0.01639273089820855, -0.1020148149641146, 0.0861566050386762, 0.05006429918812112, 0.1550995351125434 },
            { -0.01425387190434579, 0.01962515553554497, 0.005514304491641961, 0.02306868295823352, -0.01781289440329097, 0.01605628554003031, -0.06847043724307719, -0.0723235380733698, 0.08762601645679237, -0.08374205743970024, -0.04956800501072156, 0.00739045414443772, -0.01493127159416141, 0.03028903273713784, -0.01313358888935439, -0.004121695414598801, 0.02075903594430437, -0.0011076982654635, -0.0007349013810426697, 0.02538912340035494, -0.006045183127609834, -0.002983831083744754, 0.3347707144999606, 0.07502396259627718, 0.6096544066403051, -0.05017620467325412, 0.003692600015718228, 0.03000654449108393, -0.06136748621798345, 0.02015209737887214, 0.03669919272486265, -0.04205911305476417, 0.01381153757769889, 0.003095241709461026, 0.140207388933765 },
            { -0.008973334256543584, -0.01905813911559191, -0.03076743722716262, -0.04040605971477428, 0.1323516525356927, -0.2245148383223397, 0.2237861146434753, 0.08726677047625223, -0.1654221201286563, 0.2736992842641158, 0.02203259319135837, 0.009763532582369921, 0.04086830307602315, 0.03075310074583007, -0.03615546366635011, 0.01347118902282379, 0.007764359267656239, 0.002133965199228217, 0.002011494612634437, 0.00949611899608958, 0.001572301635717483, 0.001326289738827871, -0.1378636298243347, -0.2288451437624542, 0.9789150719739977, -0.03013214590133492, -0.01126351571166089, 0.04818116352517522, -0.03685280822573071, -0.008298937669546459, 0.0589274718534794, -0.009304376994421229, -0.002095266234738448, -0.003478013043181153, 0.04911045245807301 },
            { -0.003814784988892646, -0.04079742454249195, -0.03827576649250285, 0.193565613495663, 0.1902826731863672, -0.3945927279594244, 0.4998171255416422, 0.2072217899598283, -0.4445986454400346, 0.6112961465086306, 0.01588384175320362, 0.0104760001378118, 0.01783856439214647, 0.01740627747298323, -0.03163480281153033, 0.03008734918939357, 0.001334215658241253, 0.0007454053268319202, 0.0008779952547867467, 0.0016317986095625, 0.000839868996894557, 0.0009561550992873112, -0.09650767257172141, -0.1047570619844012, 0.3407815550156928, -0.006866870205113611, -0.005156031690991332, 0.0167729073733275, -0.008398454315490165, -0.005809444886415868, 0.02051393023388401, -0.0006437533395722119, -0.000445302124200667, -0.0004833661509347897, 0.004452896297538846 },
            { -0.01243849295391363, 0.009324359815203982, -0.04065529414352152, -0.02645673874857108, 0.07155728382479898, -0.1348907822337635, 0.09931759007824136, -0.002745301598304323, -0.004036158982654419, 0.04144989886038832, -0.05330524958387266, 0.1533101456583994, 0.579870570013429, 0.002336892767461309, 0.001553087517671539, 0.002040120141441186, 0.04537521571298866, -0.05899273903177298, 0.0285406155826315, 0.01893721042355136, -0.001765161930352368, -0.001094963271208119, 0.02515948196878571, 0.3509239471519602, -0.1793867212679449, -0.009681203729766347, 0.01727210517714664, -0.008829224515082185, -0.004040421390908871, 0.0005168104247426503, -0.003684850416502315, -0.07845246249062431, 0.01003485689713162, 0.1399659816452224, 0.0229695926275672 },
            { -0.01081123142856227, -0.003430005826948028, -0.02610225289337161, -0.02665480921729696, 0.1033929806787116, -0.1586234197313438, 0.1063039633401005, 0.004666028929683107, 0.002059050198733203, 0.04436564082388997, 0.01546056047511859, -0.02896059995658526, 0.1429769948466227, 0.01016285519708468, 0.002389400914954817, 0.002183629874167415, 0.03367390981544267, -0.03360699223188854, 0.007037176325369978, 0.01405370544114441, 0.0004362438040427749, 0.0003175812139464219, -0.03093512055330247, 0.9946023680278823, -0.2343077619191357, -0.03589830175085724, 0.04895327562976952, -0.01153237999439439, -0.01498204875551797, -0.0006354499990281759, -0.004813004262493793, -0.04964197057423366, -0.002105519122779137, 0.06769504265664307, 0.07231046002443099 },
            { -0.008169392142769967, -0.025480230590235, 0.01944774835584468, 0.02306868295823362, -0.09312492294621713, 0.2581706538315076, -0.1087248439164009, 0.06936039437777919, -0.04507031899996947, -0.04537598808424589, 0.07548471536412349, -0.06112100428297357, -0.0422971101827514, 0.01718712183196434, -0.007340695513561042, -0.002233358096729393, 0.01870469467558226, -0.009954903623483903, -0.002081818985837095, 0.007806348320640366, 0.001737884129220724, 0.00155056005752856, -0.2734202738938535, 0.6536484850377728, 0.5245560221171668, -0.04453252212150146, 0.0321718864559738, 0.02581809209329876, -0.01858551477618524, -0.005616429148248059, 0.01077510343527672, -0.02022656164748531, -0.006112343498353732, 0.01461239143254029, 0.06536744797634766 },
            { -0.005025994237166712, -0.04130331670948118, 0.001423206570283765, -0.04040605971477425, -0.007285068764193905, 0.0170939377878668, 0.3553520521402793, 0.162767434125055, -0.238242506157153, 0.1483051150298991, 0.06525441799743262, -0.001070606106450011, -0.0012189148300699, 0.01712276270660272, -0.01995099403091118, 0.007299420760236611, 0.0068646158915857, -8.965510136612351e-5, -5.999369754557159e-5, 0.002864926889561884, 0.001249545675449509, 0.001340415654162761, -0.3152833720682106, 0.009441070467300108, 0.842273574261528, -0.02640257935344708, 0.0004646794937182043, 0.04145581366174561, -0.01101903744333353, -0.006476354864340533, 0.01730145971223031, -0.004417596671728561, -0.002596408610168875, 7.77487137671993e-5, 0.02289626082163539 },
            { -0.002094760627224065, -0.03078128641256904, -0.04145451836505666, 0.193565613495663, 0.2183125263152956, -0.4965181115031935, 0.7936642608011621, 0.1482609575943982, -0.2926412638196378, 0.331233402999376, 0.01804565388488196, 0.008676587315397475, 0.01108975062024662, 0.009535077667581507, -0.01726677661017356, 0.01630295743912816, 0.001160566572255309, 0.0005119465825092484, 0.0005458257854892689, 0.0004843589841721872, 0.0003017346023087911, 0.0003706825943625459, -0.1008683605731345, -0.07142525436023001, 0.2932136878908875, -0.005951557980299511, -0.00351547540607125, 0.01443166731062984, -0.002483864903999773, -0.002071975104080498, 0.00602301314340345, -0.0003023248135022496, -0.0002521914480588597, -0.0001785776850413978, 0.002076028013123558 },
            { -0.004317839866583405, -0.04158768254624919, 0.2564946004984638, -0.02645673874857109, 0.2949230850789764, -0.2573608213043342, 0.1287360490666405, 0.008724298463542352, 0.006887021968319293, 0.01341146204925853, 0.2195757810907698, -0.4991076892626901, 0.7732833131128737, 0.0008010667001296344, 0.0005223619461849054, 0.0006600979641717807, 0.02016148887177391, -0.03785596519342847, 0.03806018604376973, 0.002100383263435128, 0.001013032452250103, 0.001125881422727322, -0.05564663431873069, 0.2166335996311231, -0.07523448378396165, -0.004220646359933119, 0.0106624764371308, -0.003702961645710382, -0.0004396984286063896, -0.0002853297914072045, -0.0003857670787737761, -0.01106646297224623, -0.007181266445498122, 0.02795683187392454, 0.003116969811258096 },
            { -0.003714268244648559, -0.04053297281954719, -0.004745786847815461, -0.0266548092172969, 0.6691449677790831, -0.3133858744525397, 0.1377918275075797, 0.04183159066463678, 0.01136753316963848, 0.01435487479003855, 0.1796619832154952, -0.3158776939024004, 0.2993973658845056, 0.003454141374027784, 0.0007990346536140905, 0.0007065317405396988, 0.01483514921867715, -0.02220334174223516, 0.01473602139519556, 0.001545495936716122, 0.0008053880034400262, 0.0009212222234522348, -0.2213732350694795, 0.6357908118385213, -0.09826827420648965, -0.01556053398424033, 0.03129295068593045, -0.004836660425845258, -0.001621065059157108, -0.001135097922073194, -0.0005038735320576186, -0.006962292344663164, -0.004875118076632632, 0.01400149064442268, 0.009812517121606686 },
            { -0.002762156689831416, -0.03611689332502466, -0.01759858691004883, 0.02306868295823364, 0.1372262556288498, 0.5759284463220433, -0.140929787262841, 0.0813133174158521, -0.03854041567105934, -0.01468178111095545, 0.114705211796885, -0.1165944556362292, 0.02016669050414501, 0.005765290649501797, -0.002433180766941226, -0.0007226217235795779, 0.00813284841940029, -0.007360984100622965, 0.0009925831573748887, 0.0008472637518391888, 0.0004925879053164278, 0.0005881544240016428, -0.3030612986523162, 0.4718006815442312, 0.2199978976192229, -0.0191332374144269, 0.02322153007914522, 0.01082806362252868, -0.00199326209964891, -0.001553955925399555, 0.001128045837925005, -0.002811809412935541, -0.00219209902154625, 0.003412622518866805, 0.008870351568043616 },
            { -0.001669343251191971, -0.02632578093983332, 0.02005278463846139, -0.04040605971477428, -0.1210392777590414, 0.4095876032623192, 0.4606094366992159, 0.09333673492099268, -0.115553699595248, 0.04798536248866896, 0.04850304577268907, -0.01244225237899166, -0.00655267576338938, 0.005660331185964193, -0.006548500987363731, 0.002361788742530277, 0.002941428182952717, -0.000705110284432639, -0.0003225157641578258, 0.000306432057937879, 0.0001989271680582464, 0.0002487008262474213, -0.1982164418304148, 0.07319452109670815, 0.3532480950459388, -0.01123305069058601, 0.003602556841827073, 0.01738649727605464, -0.001170236574187855, -0.001016360768147328, 0.001811290233605593, -0.0006081211022727993, -0.0005281585315870755, 0.0001950307977765147, 0.00310701869767065 },
            { -0.000684999674742174, -0.0125964445065001, -0.03732553226575754, 0.193565613495663, 0.2063633124252942, -0.5087168207405977, 1.028752320112141, 0.05826131060272247, -0.108078195915314, 0.1071733426596649, 0.009191789624706043, 0.003283163171531084, 0.003391784607045323, 0.003112039978153763, -0.005619251595900321, 0.005274958467859941, 0.0004909813474315936, 0.0001706997395265111, 0.0001669400476842688, 5.114944691641567e-5, 3.626559834257748e-5, 4.71311778043465e-5, -0.04828714059377424, -0.023678023563922, 0.12297331871021, -0.002510567367867859, -0.00116540725334377, 0.006052616562601074, -0.0002615458468735246, -0.0002475937659477123, 0.0006305493909171678, -4.126365124320405e-5, -3.90624547479913e-5, -1.915461782597307e-5, 0.0002817166481420205 } } };
    alignas(32) static const double FE8_C0_D001_Q125[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[3] * FE8_C0_D001_Q125[0][0][1];
    const double J_c4 = coordinate_dofs[1] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[7] * FE8_C0_D001_Q125[0][0][1];
    const double J_c8 = coordinate_dofs[2] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[11] * FE8_C0_D001_Q125[0][0][1];
    const double J_c5 = coordinate_dofs[1] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[10] * FE8_C0_D001_Q125[0][0][1];
    const double J_c7 = coordinate_dofs[2] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[8] * FE8_C0_D001_Q125[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[6] * FE8_C0_D001_Q125[0][0][1];
    const double J_c6 = coordinate_dofs[2] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[5] * FE8_C0_D001_Q125[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[4] * FE8_C0_D001_Q125[0][0][1];
    const double J_c2 = coordinate_dofs[0] * FE8_C0_D001_Q125[0][0][0] + coordinate_dofs[9] * FE8_C0_D001_Q125[0][0][1];
    alignas(32) double sp[15];
    sp[0] = J_c4 * J_c8;
    sp[1] = J_c5 * J_c7;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 * sp[2];
    sp[4] = J_c5 * J_c6;
    sp[5] = J_c3 * J_c8;
    sp[6] = sp[4] + -1 * sp[5];
    sp[7] = J_c1 * sp[6];
    sp[8] = sp[3] + sp[7];
    sp[9] = J_c3 * J_c7;
    sp[10] = J_c4 * J_c6;
    sp[11] = sp[9] + -1 * sp[10];
    sp[12] = J_c2 * sp[11];
    sp[13] = sp[8] + sp[12];
    sp[14] = std::abs(sp[13]);
    alignas(32) double BF0[35] = {};
    for (int iq = 0; iq < 125; ++iq)
    {
        // Quadrature loop body setup (num_points=125)
        // Unstructured varying computations for num_points=125
        double w0 = 0.0;
        for (int ic = 0; ic < 35; ++ic)
            w0 += w[0][ic] * FE11_C0_Q125[0][iq][ic];
        alignas(32) double sv125[1];
        sv125[0] = sp[14] * w0;
        const double fw0 = sv125[0] * weights125[iq];
        for (int i = 0; i < 35; ++i)
            BF0[i] += fw0 * FE11_C0_Q125[0][iq][i];
    }
    std::fill(&A[0], &A[35], 0.0);
    for (int i = 0; i < 35; ++i)
        A[i] += BF0[i];
}


poisson3d_4_form_0::poisson3d_4_form_0() : ufc::form()
{
    // Do nothing
}

poisson3d_4_form_0::~poisson3d_4_form_0()
{
    // Do nothing
}

const char * poisson3d_4_form_0::signature() const
{
    return "0c6ff9aa78ad4ac2466c1f2e4627e995f5fc20503363e4f15ab3d33215505b47f71a961ffa3570c8a175eeec9f15dff96fc16d22349fd2812c035438a0195537";
}

std::size_t poisson3d_4_form_0::rank() const
{
    return 2;
}

std::size_t poisson3d_4_form_0::num_coefficients() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({});
    return position[i];
}

ufc::finite_element * poisson3d_4_form_0::create_coordinate_finite_element() const
{
    return new poisson3d_4_finite_element_1();
}

ufc::dofmap * poisson3d_4_form_0::create_coordinate_dofmap() const
{
    return new poisson3d_4_dofmap_1();
}

ufc::coordinate_mapping * poisson3d_4_form_0::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson3d_4_form_0::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_4_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson3d_4_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson3d_4_form_0::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_4_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson3d_4_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_form_0::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_0::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson3d_4_form_0::has_cell_integrals() const
{
    return true;
}

bool poisson3d_4_form_0::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson3d_4_form_0::has_interior_facet_integrals() const
{
    return false;
}

bool poisson3d_4_form_0::has_vertex_integrals() const
{
    return false;
}

bool poisson3d_4_form_0::has_custom_integrals() const
{
    return false;
}

bool poisson3d_4_form_0::has_cutcell_integrals() const
{
    return false;
}

bool poisson3d_4_form_0::has_interface_integrals() const
{
    return false;
}

bool poisson3d_4_form_0::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson3d_4_form_0::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson3d_4_form_0::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_4_form_0::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson3d_4_form_0::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson3d_4_form_0::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_4_form_0::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson3d_4_form_0::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson3d_4_form_0::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson3d_4_form_0::create_default_cell_integral() const
{
    return new poisson3d_4_cell_integral_0_otherwise();
}

ufc::exterior_facet_integral * poisson3d_4_form_0::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_4_form_0::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson3d_4_form_0::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson3d_4_form_0::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_4_form_0::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson3d_4_form_0::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson3d_4_form_0::create_default_overlap_integral() const
{
    return 0;
}


poisson3d_4_form_1::poisson3d_4_form_1() : ufc::form()
{
    // Do nothing
}

poisson3d_4_form_1::~poisson3d_4_form_1()
{
    // Do nothing
}

const char * poisson3d_4_form_1::signature() const
{
    return "f610698a9137b23719b4cd9f8562575da647e47828c8e8164b531cbc8c48dec6ccfe83ff1339a91fc091e024aa03eee3466f7ca19c58e1066ef81ba65b82f459";
}

std::size_t poisson3d_4_form_1::rank() const
{
    return 1;
}

std::size_t poisson3d_4_form_1::num_coefficients() const
{
    return 1;
}

std::size_t poisson3d_4_form_1::original_coefficient_position(std::size_t i) const
{
    static const std::vector<std::size_t> position({0});
    return position[i];
}

ufc::finite_element * poisson3d_4_form_1::create_coordinate_finite_element() const
{
    return new poisson3d_4_finite_element_1();
}

ufc::dofmap * poisson3d_4_form_1::create_coordinate_dofmap() const
{
    return new poisson3d_4_dofmap_1();
}

ufc::coordinate_mapping * poisson3d_4_form_1::create_coordinate_mapping() const
{
    return nullptr;
}

ufc::finite_element * poisson3d_4_form_1::create_finite_element(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_4_finite_element_2();
        break;
      }
    case 1:
      {
        return new poisson3d_4_finite_element_2();
        break;
      }
    }
    
    return 0;
}

ufc::dofmap * poisson3d_4_form_1::create_dofmap(std::size_t i) const
{
    switch (i)
    {
    case 0:
      {
        return new poisson3d_4_dofmap_2();
        break;
      }
    case 1:
      {
        return new poisson3d_4_dofmap_2();
        break;
      }
    }
    
    return 0;
}

std::size_t poisson3d_4_form_1::max_cell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_exterior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_interior_facet_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_vertex_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_custom_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_cutcell_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_interface_subdomain_id() const
{
    return 0;
}

std::size_t poisson3d_4_form_1::max_overlap_subdomain_id() const
{
    return 0;
}

bool poisson3d_4_form_1::has_cell_integrals() const
{
    return true;
}

bool poisson3d_4_form_1::has_exterior_facet_integrals() const
{
    return false;
}

bool poisson3d_4_form_1::has_interior_facet_integrals() const
{
    return false;
}

bool poisson3d_4_form_1::has_vertex_integrals() const
{
    return false;
}

bool poisson3d_4_form_1::has_custom_integrals() const
{
    return false;
}

bool poisson3d_4_form_1::has_cutcell_integrals() const
{
    return false;
}

bool poisson3d_4_form_1::has_interface_integrals() const
{
    return false;
}

bool poisson3d_4_form_1::has_overlap_integrals() const
{
    return false;
}

ufc::cell_integral * poisson3d_4_form_1::create_cell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::exterior_facet_integral * poisson3d_4_form_1::create_exterior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_4_form_1::create_interior_facet_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::vertex_integral * poisson3d_4_form_1::create_vertex_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::custom_integral * poisson3d_4_form_1::create_custom_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_4_form_1::create_cutcell_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::interface_integral * poisson3d_4_form_1::create_interface_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::overlap_integral * poisson3d_4_form_1::create_overlap_integral(std::size_t subdomain_id) const
{
    return 0;
}

ufc::cell_integral * poisson3d_4_form_1::create_default_cell_integral() const
{
    return new poisson3d_4_cell_integral_1_otherwise();
}

ufc::exterior_facet_integral * poisson3d_4_form_1::create_default_exterior_facet_integral() const
{
    return 0;
}

ufc::interior_facet_integral * poisson3d_4_form_1::create_default_interior_facet_integral() const
{
    return 0;
}

ufc::vertex_integral * poisson3d_4_form_1::create_default_vertex_integral() const
{
    return 0;
}

ufc::custom_integral * poisson3d_4_form_1::create_default_custom_integral() const
{
    return 0;
}

ufc::cutcell_integral * poisson3d_4_form_1::create_default_cutcell_integral() const
{
    return 0;
}

ufc::interface_integral * poisson3d_4_form_1::create_default_interface_integral() const
{
    return 0;
}

ufc::overlap_integral * poisson3d_4_form_1::create_default_overlap_integral() const
{
    return 0;
}

