// This code conforms with the UFC specification version 2017.1.0
// and was automatically generated by FFC version 2017.1.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
// 
// This code was generated with the following parameters:
// 
//   add_tabulate_tensor_timing:     False
//   convert_exceptions_to_warnings: False
//   cpp_optimize:                   True
//   cpp_optimize_flags:             '-O2'
//   epsilon:                        1e-14
//   error_control:                  False
//   form_postfix:                   True
//   format:                         'dolfin'
//   generate_dummy_tabulate_tensor: False
//   max_signature_length:           0
//   optimize:                       True
//   precision:                      None
//   quadrature_degree:              None
//   quadrature_rule:                None
//   representation:                 'auto'
//   split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  static void _evaluate_basis(std::size_t i,
                              double * values,
                              const double * x,
                              const double * coordinate_dofs,
                              int cell_orientation)
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation) const final override
  {
    _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_all(double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation)
  {
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation) const final override
  {
    _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives(std::size_t i,
                                          std::size_t n,
                                          double * values,
                                          const double * x,
                                          const double * coordinate_dofs,
                                          int cell_orientation)
  {
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation) const final override
  {
    _evaluate_basis_derivatives(i, n, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives_all(std::size_t n,
                                              double * values,
                                              const double * x,
                                              const double * coordinate_dofs,
                                              int cell_orientation)
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 3; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[2];
    for (unsigned int r = 0; r < 2; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation) const final override
  {
    _evaluate_basis_derivatives_all(n, values, x, coordinate_dofs, cell_orientation);
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::cell& c) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return 0;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  static void _evaluate_basis(std::size_t i,
                              double * values,
                              const double * x,
                              const double * coordinate_dofs,
                              int cell_orientation)
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation) const final override
  {
    _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_all(double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation)
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2; s++)
      {
        values[r*2 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation) const final override
  {
    _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives(std::size_t i,
                                          std::size_t n,
                                          double * values,
                                          const double * x,
                                          const double * coordinate_dofs,
                                          int cell_orientation)
  {
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 2*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation) const final override
  {
    _evaluate_basis_derivatives(i, n, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives_all(std::size_t n,
                                              double * values,
                                              const double * x,
                                              const double * coordinate_dofs,
                                              int cell_orientation)
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 6; r++)
    {
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[4];
    for (unsigned int r = 0; r < 4; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation) const final override
  {
    _evaluate_basis_derivatives_all(n, values, x, coordinate_dofs, cell_orientation);
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 4:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 5:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    }
    
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::cell& c) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[0];
    dof_coordinates[7] = coordinate_dofs[1];
    dof_coordinates[8] = coordinate_dofs[2];
    dof_coordinates[9] = coordinate_dofs[3];
    dof_coordinates[10] = coordinate_dofs[4];
    dof_coordinates[11] = coordinate_dofs[5];
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_finite_element_0();
        break;
      }
    case 1:
      {
        return new forms_finite_element_0();
        break;
      }
    }
    
    return 0;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  static void _evaluate_basis(std::size_t i,
                              double * values,
                              const double * x,
                              const double * coordinate_dofs,
                              int cell_orientation)
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.1695331725611231, 0.08417937871268399, -0.1166423687039603, 0.0, -0.1468200342221035, 0.07290148043997539, -0.1010152544552207};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.3216783274236694, -0.1346870059402953, 0.09720197391996714, 0.2605797108646141, -0.1298792610426305, 0.09768798378956739, -0.06313453403451315};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.07824607964359512, -0.168358757425368, 0.3499271061118821, 0.0, 0.06776309271789381, -0.1458029608799508, 0.3030457633656625};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.1651861681364797, 0.2357022603955164, -0.2721655269759084, -0.1202675588605915, 0.1468200342221041, -0.2245365597551247, 0.1767766952966369};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.03912303982179762, -0.08417937871268416, -0.3499271061118825, 0.0, -0.03388154635894694, -0.07290148043997542, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.06085806194501905, 0.0, 0.2138443426239285, 0.06013377943029563, 0.03952847075210441, 0.1122682798775625, -0.1388959748759293};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268369, 0.1166423687039605, 0.0, 0.1468200342221034, 0.07290148043997541, 0.1010152544552208};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.4912114999847916, 0.2188663846529791, 0.2138443426239285, -0.2605797108646136, 0.01694077317947361, -0.02478650334959184, 0.03788072042070796};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.07824607964359513, -0.168358757425368, -0.3499271061118824, 0.0, -0.06776309271789385, -0.1458029608799509, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.2434322477800734, -0.4040610178208842, -0.6220926330877914, 0.120267558860591, 0.0790569415042093, 0.07873359887517371, -0.1262690680690267};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.03912303982179744, -0.08417937871268387, 0.3499271061118823, 0.0, 0.03388154635894679, -0.07290148043997519, 0.3030457633656628};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.09998110176681536, -0.08417937871268388, 0.563771448735811, -0.06013377943029587, 0.07341001711105213, -0.1851697603175378, 0.1641497884897344};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686874, 0.3030457633656632, 0.3110463165438962, 0.0, -0.09035079029052523, -0.1458029608799509, -0.2020305089104421};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268406, 0.1166423687039612, 0.1603567451474546, 0.06776309271789367, 0.03207665139358951, -0.07576144084141609};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.7650727787373747, 0.0, -0.1555231582719484, 0.0, 0.1807015805810505, 0.0, 0.1010152544552208};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.3825363893686876, 0.06734350297014811, -0.07776157913597406, -0.3207134902949095, 0.0903507902905256, -0.06415330278717883, 0.05050762722761064};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686874, -0.3030457633656637, 0.3110463165438965, 0.0, -0.0903507902905251, 0.145802960879951, -0.2020305089104418};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.2130032168075653, -0.2188663846529795, 0.1944039478399346, 0.1603567451474549, -0.1581138830084197, 0.1778796122735406, -0.1262690680690265};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {3.999999999999999, -1.410980707272635e-15, 1.04115934623783e-15, -0.3688555567816594, -0.4761904761904762, -1.649572197684646, 0.0, -0.3194382824999707, -0.4123930494211604, 0.5714285714285697};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.6147592613027624, 0.4761904761904756, -0.5498573992282144, 0.5669467095138401, 0.1597191412499854, -0.4536323543632764, 0.3571428571428569};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 3.999999999999997, 0.0, -0.6776309271789386, 1.807956714911393, 0.0, 0.0, -0.5868455973269647, -1.262690680690261, 0.0};
      
      static const double coefficients1[10] = \
      {-1.462311407113082e-15, 0.0, 0.0, 1.054092553389458, 1.166423687039607, -0.3367175148507336, 1.041547612244118, 0.6846531968814582, -0.5808377131175197, 0.2187044413199258};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {2.668682218084598e-15, 0.0, 4.0, 0.1304101327393259, -0.8417937871268398, 0.9331389496316862, 0.0, 0.1129384878631569, -0.7290148043997537, -2.02030508910442};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 1.611883369834199e-15, -0.3477603539715319, 0.3367175148507399, 1.360827634879544, -0.2004459314343188, 0.6211616832473602, 0.5977921396077993, -0.8838834764831863};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {-1.334341109042299e-15, 0.0, 0.0, 0.0, 0.9523809523809508, 1.885427577952292e-15, 0.0, 0.0, 0.8247860988423215, 1.137978600240785e-15};
      
      static const double coefficients1[10] = \
      {3.999999999999999, 0.0, 0.0, -1.598374079387187, 0.4761904761904745, -0.5498573992282157, 1.443289932012704e-15, -0.6388765649999417, 0.4123930494211615, -0.1428571428571425};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 1.355261854357877, 2.246466901389965e-15, -2.561319212279756e-15, 0.0, 1.173691194653928, 0.0, -1.221245327087672e-15};
      
      static const double coefficients1[10] = \
      {0.0, 3.999999999999997, 0.0, 0.6776309271789377, -0.5248906591678199, 0.0, -2.08309522448824, 0.586845597326966, -0.1010152544552226, 0.0};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 1.599415044850616e-15, 1.68358757425368, 2.808517307606451e-15, 0.0, 0.0, 1.458029608799508, 1.77635683940025e-15};
      
      static const double coefficients1[10] = \
      {1.93116522616465e-15, 0.0, 3.999999999999998, 0.8259308406823971, 0.8417937871268389, -1.788516320127402, 3.108624468950438e-15, -1.129384878631567, 0.7290148043997547, -0.2525381361380514};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    }
    
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation) const final override
  {
    _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_all(double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation)
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 15; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2; s++)
      {
        values[r*2 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation) const final override
  {
    _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives(std::size_t i,
                                          std::size_t n,
                                          double * values,
                                          const double * x,
                                          const double * coordinate_dofs,
                                          int cell_orientation)
  {
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 2*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[8][3];
    for (unsigned int row = 0; row < 8; row++)
    {
      for (unsigned int col = 0; col < 3; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[8][8];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.1695331725611231, 0.08417937871268399, -0.1166423687039603, 0.0, -0.1468200342221035, 0.07290148043997539, -0.1010152544552207};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.3216783274236694, -0.1346870059402953, 0.09720197391996714, 0.2605797108646141, -0.1298792610426305, 0.09768798378956739, -0.06313453403451315};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.07824607964359512, -0.168358757425368, 0.3499271061118821, 0.0, 0.06776309271789381, -0.1458029608799508, 0.3030457633656625};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.1651861681364797, 0.2357022603955164, -0.2721655269759084, -0.1202675588605915, 0.1468200342221041, -0.2245365597551247, 0.1767766952966369};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.03912303982179762, -0.08417937871268416, -0.3499271061118825, 0.0, -0.03388154635894694, -0.07290148043997542, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.06085806194501905, 0.0, 0.2138443426239285, 0.06013377943029563, 0.03952847075210441, 0.1122682798775625, -0.1388959748759293};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.1695331725611229, 0.08417937871268369, 0.1166423687039605, 0.0, 0.1468200342221034, 0.07290148043997541, 0.1010152544552208};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.4912114999847916, 0.2188663846529791, 0.2138443426239285, -0.2605797108646136, 0.01694077317947361, -0.02478650334959184, 0.03788072042070796};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.07824607964359513, -0.168358757425368, -0.3499271061118824, 0.0, -0.06776309271789385, -0.1458029608799509, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.2434322477800734, -0.4040610178208842, -0.6220926330877914, 0.120267558860591, 0.0790569415042093, 0.07873359887517371, -0.1262690680690267};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.03912303982179744, -0.08417937871268387, 0.3499271061118823, 0.0, 0.03388154635894679, -0.07290148043997519, 0.3030457633656628};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.09998110176681536, -0.08417937871268388, 0.563771448735811, -0.06013377943029587, 0.07341001711105213, -0.1851697603175378, 0.1641497884897344};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686874, 0.3030457633656632, 0.3110463165438962, 0.0, -0.09035079029052523, -0.1458029608799509, -0.2020305089104421};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268406, 0.1166423687039612, 0.1603567451474546, 0.06776309271789367, 0.03207665139358951, -0.07576144084141609};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.7650727787373747, 0.0, -0.1555231582719484, 0.0, 0.1807015805810505, 0.0, 0.1010152544552208};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.3825363893686876, 0.06734350297014811, -0.07776157913597406, -0.3207134902949095, 0.0903507902905256, -0.06415330278717883, 0.05050762722761064};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686874, -0.3030457633656637, 0.3110463165438965, 0.0, -0.0903507902905251, 0.145802960879951, -0.2020305089104418};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.2130032168075653, -0.2188663846529795, 0.1944039478399346, 0.1603567451474549, -0.1581138830084197, 0.1778796122735406, -0.1262690680690265};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {3.999999999999999, -1.410980707272635e-15, 1.04115934623783e-15, -0.3688555567816594, -0.4761904761904762, -1.649572197684646, 0.0, -0.3194382824999707, -0.4123930494211604, 0.5714285714285697};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.6147592613027624, 0.4761904761904756, -0.5498573992282144, 0.5669467095138401, 0.1597191412499854, -0.4536323543632764, 0.3571428571428569};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 3.999999999999997, 0.0, -0.6776309271789386, 1.807956714911393, 0.0, 0.0, -0.5868455973269647, -1.262690680690261, 0.0};
      
      static const double coefficients1[10] = \
      {-1.462311407113082e-15, 0.0, 0.0, 1.054092553389458, 1.166423687039607, -0.3367175148507336, 1.041547612244118, 0.6846531968814582, -0.5808377131175197, 0.2187044413199258};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {2.668682218084598e-15, 0.0, 4.0, 0.1304101327393259, -0.8417937871268398, 0.9331389496316862, 0.0, 0.1129384878631569, -0.7290148043997537, -2.02030508910442};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 1.611883369834199e-15, -0.3477603539715319, 0.3367175148507399, 1.360827634879544, -0.2004459314343188, 0.6211616832473602, 0.5977921396077993, -0.8838834764831863};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {-1.334341109042299e-15, 0.0, 0.0, 0.0, 0.9523809523809508, 1.885427577952292e-15, 0.0, 0.0, 0.8247860988423215, 1.137978600240785e-15};
      
      static const double coefficients1[10] = \
      {3.999999999999999, 0.0, 0.0, -1.598374079387187, 0.4761904761904745, -0.5498573992282157, 1.443289932012704e-15, -0.6388765649999417, 0.4123930494211615, -0.1428571428571425};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 1.355261854357877, 2.246466901389965e-15, -2.561319212279756e-15, 0.0, 1.173691194653928, 0.0, -1.221245327087672e-15};
      
      static const double coefficients1[10] = \
      {0.0, 3.999999999999997, 0.0, 0.6776309271789377, -0.5248906591678199, 0.0, -2.08309522448824, 0.586845597326966, -0.1010152544552226, 0.0};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 1.599415044850616e-15, 1.68358757425368, 2.808517307606451e-15, 0.0, 0.0, 1.458029608799508, 1.77635683940025e-15};
      
      static const double coefficients1[10] = \
      {1.93116522616465e-15, 0.0, 3.999999999999998, 0.8259308406823971, 0.8417937871268389, -1.788516320127402, 3.108624468950438e-15, -1.129384878631567, 0.7290148043997547, -0.2525381361380514};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 3.362464864173654e-15, 1.77635683940025e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 9.486832980505145, -3.789561257387202e-15, 0.0, 1.554312234475219e-15, 1.696576164295288e-15, -1.05101294980483e-15, 0.0, -5.773159728050814e-15, -1.090070107137102e-15},
      {3.999999999999996, 0.0, 7.071067811865471, 0.0, -1.86517468137026e-15, 0.0, 0.0, 1.915097775362179e-15, -1.034784266683435e-15, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.29150262212919, -4.456246818794374e-14, -2.993325909419156, 13.66260102127946, 7.895528791751667e-15, 0.6110100926607789, 0.0, 2.548788367359986e-15, 3.572939600000593e-15, 3.885780586188048e-15},
      {4.440892098500626e-15, 4.38178046004133, 7.105427357601002e-15, 0.0, 12.52198067399882, 3.552713678800501e-15, 0.0, -1.712915523707384e-15, -1.77635683940025e-15, 1.77635683940025e-15},
      {3.464101615137757, -2.848235108281928e-15, 7.838367176906174, 0.0, -2.597807418599654e-15, 8.400000000000006, 0.0, 0.0, -1.998401444325282e-15, -3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783183, 1.459187827161796e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119287, 2.943864162443713e-15, 1.332267629550188e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.581988897471621, 4.743416490252575, -0.9128709291752823, 0.0, 0.0, 0.0, 0.0, 0.0, -2.397769917339404e-15, 0.0},
      {1.999999999999913, 6.123724356957936, 3.535533905932732, -1.419906445892009e-15, 0.0, 0.0, 0.0, 0.0, -2.737838182592019e-15, 0.0},
      {-2.309401076758493, -6.798030147986831e-15, 8.16496580927727, 0.0, -1.008651514360451e-15, 1.77635683940025e-15, -1.241742303660746e-15, 0.0, -1.712915523707386e-15, 2.664535259100376e-15},
      {2.645751311064571, 5.184592558726255, -1.496662954709567, 6.831300510639725, -1.058300524425829, 0.3055050463303874, 0.0, 0.0, -1.044598912793852e-15, 1.554312234475219e-15},
      {2.236067977499824, 2.19089023002067, 2.529822128134686, 8.082903768654774, 6.260990336999407, -1.807392228230123, 1.807838169294361e-15, -1.145115748256231e-15, 3.929002183625715e-15, 0.0},
      {1.73205080756888, -5.091168824543144, 3.91918358845309, 0.0, 9.699484522385688, 4.200000000000004, 0.0, 0.0, 0.0, 0.0},
      {5.000000000000028, 2.535087336876732e-15, -2.82842712474624, 1.040362542677879e-15, -1.332267629550184e-15, 12.12435565298216, 0.0, -1.021385480193167e-15, 0.0, -3.108624468950438e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation) const final override
  {
    _evaluate_basis_derivatives(i, n, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives_all(std::size_t n,
                                              double * values,
                                              const double * x,
                                              const double * coordinate_dofs,
                                              int cell_orientation)
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 15; r++)
    {
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[16];
    for (unsigned int r = 0; r < 16; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 15; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation) const final override
  {
    _evaluate_basis_derivatives_all(n, values, x, coordinate_dofs, cell_orientation);
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
      {
        y[0] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
      y[1] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 1:
      {
        y[0] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 2:
      {
        y[0] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 3:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 4:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 5:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 6:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return (J[0]*vals[0] + J[2]*vals[1]);
        break;
      }
    case 7:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return (J[0]*vals[0] + J[2]*vals[1]);
        break;
      }
    case 8:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return (J[0]*vals[0] + J[2]*vals[1]);
        break;
      }
    case 9:
      {
        result = 0.0;
      double X_9[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_9[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
      double W_9[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
      double copy_9[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_9[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_9[D_9[r][s]]*W_9[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 10:
      {
        result = 0.0;
      double X_10[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_10[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
      double W_10[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
      double copy_10[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_10[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_10[D_10[r][s]]*W_10[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 11:
      {
        result = 0.0;
      double X_11[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_11[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
      double W_11[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
      double copy_11[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_11[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_11[D_11[r][s]]*W_11[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 12:
      {
        result = 0.0;
      double X_12[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_12[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
      double W_12[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
      double copy_12[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_12[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_12[D_12[r][s]]*W_12[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 13:
      {
        result = 0.0;
      double X_13[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_13[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
      double W_13[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
      double copy_13[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_13[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_13[D_13[r][s]]*W_13[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 14:
      {
        result = 0.0;
      double X_14[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_14[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
      double W_14[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
      double copy_14[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_14[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_14[D_14[r][s]]*W_14[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    }
    
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    y[1] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = (J[0]*vals[0] + J[2]*vals[1]);
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = (J[0]*vals[0] + J[2]*vals[1]);
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = (J[0]*vals[0] + J[2]*vals[1]);
    result = 0.0;
    double X_9[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_9[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
    double W_9[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
    double copy_9[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_9[r][0] - X_9[r][1];
      const double w1 = X_9[r][0];
      const double w2 = X_9[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_9[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_9[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_9[D_9[r][s]]*W_9[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[9] = result;
    result = 0.0;
    double X_10[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_10[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
    double W_10[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
    double copy_10[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_10[r][0] - X_10[r][1];
      const double w1 = X_10[r][0];
      const double w2 = X_10[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_10[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_10[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_10[D_10[r][s]]*W_10[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[10] = result;
    result = 0.0;
    double X_11[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_11[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
    double W_11[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
    double copy_11[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_11[r][0] - X_11[r][1];
      const double w1 = X_11[r][0];
      const double w2 = X_11[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_11[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_11[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_11[D_11[r][s]]*W_11[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[11] = result;
    result = 0.0;
    double X_12[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_12[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    double W_12[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
    double copy_12[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_12[r][0] - X_12[r][1];
      const double w1 = X_12[r][0];
      const double w2 = X_12[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_12[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_12[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_12[D_12[r][s]]*W_12[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[12] = result;
    result = 0.0;
    double X_13[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_13[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    double W_13[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
    double copy_13[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_13[r][0] - X_13[r][1];
      const double w1 = X_13[r][0];
      const double w2 = X_13[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_13[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_13[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_13[D_13[r][s]]*W_13[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[13] = result;
    result = 0.0;
    double X_14[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_14[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    double W_14[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
    double copy_14[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_14[r][0] - X_14[r][1];
      const double w1 = X_14[r][0];
      const double w2 = X_14[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_14[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_14[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_14[D_14[r][s]]*W_14[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::cell& c) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    // Evaluate function and change variables
    vertex_values[0] = dof_values[1]*(K[2]*(-1.99840144433e-15)) + dof_values[2]*(K[2]*(2.22044604925e-15)) + dof_values[3]*K[2]*3.0 + dof_values[4]*(K[2]*(-3.0)) + dof_values[5]*K[2]*1.0 + dof_values[6]*K[0]*3.0 + dof_values[7]*(K[0]*(-3.0)) + dof_values[8]*K[0] + dof_values[9]*(K[2]*(-6.66133814775e-15)) + dof_values[10]*(K[0]*(5.3290705182e-15)) + dof_values[11]*(K[2]*(1.57651669497e-14)) + dof_values[13]*(K[0]*(1.75630567887e-15) + K[2]*(7.1054273576e-15)) + dof_values[14]*(K[0]*(-2.18401455695e-15) + K[2]*(1.7763568394e-15));
    vertex_values[2] = dof_values[0]*K[2]*3.0 + dof_values[1]*(K[2]*(-3.0)) + dof_values[2]*K[2]*1.0 + dof_values[3]*(K[2]*(-1.33226762955e-15)) + dof_values[4]*(K[2]*(2.88657986403e-15)) + dof_values[5]*(K[2]*(-5.99520433298e-15)) + dof_values[6]*(K[0] + K[2]*1.0) + dof_values[7]*(K[0]*(-3.0) + K[2]*(-3.0)) + dof_values[8]*(K[0]*3.0 + K[2]*3.0) + dof_values[9]*(K[2]*(-5.77315972805e-15)) + dof_values[10]*(K[0]*(7.1054273576e-15) + K[2]*(-2.55351295664e-15)) + dof_values[11]*(K[0]*(-1.55431223448e-15)) + dof_values[12]*(K[0]*(-1.83395304404e-15) + K[2]*(1.42108547152e-14)) + dof_values[13]*(K[0]*(-8.74461995212e-15) + K[2]*(-2.39808173319e-14)) + dof_values[14]*(K[0]*(9.99084324049e-15) + K[2]*(3.73034936274e-14));
    vertex_values[4] = dof_values[0]*(K[0]*(-1.0)) + dof_values[1]*(K[0]*3.0 + K[2]*(1.33226762955e-15)) + dof_values[2]*(K[0]*(-3.0)) + dof_values[3]*(K[0]*1.0 + K[2]) + dof_values[4]*(K[0]*(-3.0) + K[2]*(-3.0)) + dof_values[5]*(K[0]*3.0 + K[2]*3.0) + dof_values[6]*(K[0]*(2.6645352591e-15)) + dof_values[7]*(K[0]*(-3.44169137634e-15)) + dof_values[8]*(K[0]*(5.3290705182e-15)) + dof_values[9]*(K[0]*(-1.06581410364e-14) + K[2]*(1.7763568394e-15)) + dof_values[10]*(K[0]*(-8.29064809831e-15) + K[2]*(5.10702591328e-15)) + dof_values[11]*(K[0]*(5.77315972805e-15) + K[2]*(-5.3290705182e-15)) + dof_values[12]*(K[0]*(1.20778854552e-14)) + dof_values[13]*(K[0]*(-1.72425591149e-14)) + dof_values[14]*(K[0]*(2.06691514456e-14) + K[2]*(-1.7763568394e-15));
    vertex_values[1] = dof_values[1]*(K[3]*(-1.99840144433e-15)) + dof_values[2]*(K[3]*(2.22044604925e-15)) + dof_values[3]*K[3]*3.0 + dof_values[4]*(K[3]*(-3.0)) + dof_values[5]*K[3]*1.0 + dof_values[6]*K[1]*3.0 + dof_values[7]*(K[1]*(-3.0)) + dof_values[8]*K[1] + dof_values[9]*(K[3]*(-6.66133814775e-15)) + dof_values[10]*(K[1]*(5.3290705182e-15)) + dof_values[11]*(K[3]*(1.57651669497e-14)) + dof_values[13]*(K[1]*(1.75630567887e-15) + K[3]*(7.1054273576e-15)) + dof_values[14]*(K[1]*(-2.18401455695e-15) + K[3]*(1.7763568394e-15));
    vertex_values[3] = dof_values[0]*K[3]*3.0 + dof_values[1]*(K[3]*(-3.0)) + dof_values[2]*K[3]*1.0 + dof_values[3]*(K[3]*(-1.33226762955e-15)) + dof_values[4]*(K[3]*(2.88657986403e-15)) + dof_values[5]*(K[3]*(-5.99520433298e-15)) + dof_values[6]*(K[1] + K[3]*1.0) + dof_values[7]*(K[1]*(-3.0) + K[3]*(-3.0)) + dof_values[8]*(K[1]*3.0 + K[3]*3.0) + dof_values[9]*(K[3]*(-5.77315972805e-15)) + dof_values[10]*(K[1]*(7.1054273576e-15) + K[3]*(-2.55351295664e-15)) + dof_values[11]*(K[1]*(-1.55431223448e-15)) + dof_values[12]*(K[1]*(-1.83395304404e-15) + K[3]*(1.42108547152e-14)) + dof_values[13]*(K[1]*(-8.74461995212e-15) + K[3]*(-2.39808173319e-14)) + dof_values[14]*(K[1]*(9.99084324049e-15) + K[3]*(3.73034936274e-14));
    vertex_values[5] = dof_values[0]*(K[1]*(-1.0)) + dof_values[1]*(K[1]*3.0 + K[3]*(1.33226762955e-15)) + dof_values[2]*(K[1]*(-3.0)) + dof_values[3]*(K[1]*1.0 + K[3]) + dof_values[4]*(K[1]*(-3.0) + K[3]*(-3.0)) + dof_values[5]*(K[1]*3.0 + K[3]*3.0) + dof_values[6]*(K[1]*(2.6645352591e-15)) + dof_values[7]*(K[1]*(-3.44169137634e-15)) + dof_values[8]*(K[1]*(5.3290705182e-15)) + dof_values[9]*(K[1]*(-1.06581410364e-14) + K[3]*(1.7763568394e-15)) + dof_values[10]*(K[1]*(-8.29064809831e-15) + K[3]*(5.10702591328e-15)) + dof_values[11]*(K[1]*(5.77315972805e-15) + K[3]*(-5.3290705182e-15)) + dof_values[12]*(K[1]*(1.20778854552e-14)) + dof_values[13]*(K[1]*(-1.72425591149e-14)) + dof_values[14]*(K[1]*(2.06691514456e-14) + K[3]*(-1.7763568394e-15));
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return 0;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    }
    
    return 0;
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
        break;
      }
    }
    
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    }
    
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return 0;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2*num_global_entities[0];
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 4;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 5;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 5;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 4;
        break;
      }
    }
    
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
        break;
      }
    }
    
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_dofmap_0();
        break;
      }
    case 1:
      {
        return new forms_dofmap_0();
        break;
      }
    }
    
    return 0;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return false;
        break;
      }
    case 1:
      {
        return true;
        break;
      }
    case 2:
      {
        return true;
        break;
      }
    }
    
    return false;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3*num_global_entities[1] + 6*num_global_entities[2];
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 0;
        break;
      }
    case 1:
      {
        return 3;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 0;
        break;
      }
    case 1:
      {
        return 3;
        break;
      }
    case 2:
      {
        return 15;
        break;
      }
    }
    
    return 0;
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    unsigned int offset = 0;
    dofs[0] = offset + 3*entity_indices[1][0];
    dofs[1] = offset + 3*entity_indices[1][0] + 1;
    dofs[2] = offset + 3*entity_indices[1][0] + 2;
    dofs[3] = offset + 3*entity_indices[1][1];
    dofs[4] = offset + 3*entity_indices[1][1] + 1;
    dofs[5] = offset + 3*entity_indices[1][1] + 2;
    dofs[6] = offset + 3*entity_indices[1][2];
    dofs[7] = offset + 3*entity_indices[1][2] + 1;
    dofs[8] = offset + 3*entity_indices[1][2] + 2;
    offset += 3*num_global_entities[1];
    dofs[9] = offset + 6*entity_indices[2][0];
    dofs[10] = offset + 6*entity_indices[2][0] + 1;
    dofs[11] = offset + 6*entity_indices[2][0] + 2;
    dofs[12] = offset + 6*entity_indices[2][0] + 3;
    dofs[13] = offset + 6*entity_indices[2][0] + 4;
    dofs[14] = offset + 6*entity_indices[2][0] + 5;
    offset += 6*num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    case 1:
      {
        dofs[0] = 3;
      dofs[1] = 4;
      dofs[2] = 5;
        break;
      }
    case 2:
      {
        dofs[0] = 6;
      dofs[1] = 7;
      dofs[2] = 8;
        break;
      }
    }
    
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 9;
      dofs[1] = 10;
      dofs[2] = 11;
      dofs[3] = 12;
      dofs[4] = 13;
      dofs[5] = 14;
        break;
      }
    }
    
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          
          break;
        }
      case 1:
        {
          
          break;
        }
      case 2:
        {
          
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
      dofs[12] = 12;
      dofs[13] = 13;
      dofs[14] = 14;
        break;
      }
    }
    
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return 0;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 4
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 4
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           4
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333337 * sp[33] + 0.3583333333333412 * sp[34] + -0.6083333333333351 * sp[28] + -0.6083333333333285 * sp[31] + 0.3583333333333412 * sp[34] + 0.858333333333347 * sp[35] + -1.875000000000021 * sp[29] + -0.6083333333333393 * sp[32] + -0.6083333333333351 * sp[28] + -1.875000000000021 * sp[29] + 6.191666666666707 * sp[26] + 1.691666666666668 * sp[27] + -0.6083333333333285 * sp[31] + -0.6083333333333393 * sp[32] + 1.691666666666668 * sp[27] + 0.6333333333333305 * sp[30];
    A[1] = -2.016666666666663 * sp[33] + 1.116666666666661 * sp[34] + -0.6166666666666651 * sp[28] + -0.616666666666679 * sp[31] + 0.2833333333333324 * sp[34] + -0.8000000000000074 * sp[35] + 1.0 * sp[29] + -0.6166666666666809 * sp[32] + 0.2166666666666676 * sp[28] + 1.666666666666681 * sp[29] + -3.466666666666698 * sp[26] + 2.783333333333351 * sp[27] + 0.2166666666666608 * sp[31] + 0.2166666666666748 * sp[32] + -0.7166666666666723 * sp[27] + 0.8166666666666679 * sp[30];
    A[2] = -0.03333333333332972 * sp[33] + -0.8916666666666611 * sp[34] + -0.1916666666666683 * sp[28] + -0.1916666666666648 * sp[31] + 0.44166666666667 * sp[34] + 1.275000000000007 * sp[35] + -0.7916666666666757 * sp[29] + -0.1916666666666612 * sp[32] + -0.1916666666666653 * sp[28] + -0.7916666666666682 * sp[29] + 1.27500000000001 * sp[26] + -0.891666666666676 * sp[27] + -0.1916666666666677 * sp[31] + -0.1916666666666713 * sp[32] + 0.4416666666666691 * sp[27] + -0.03333333333333571 * sp[30];
    A[3] = -1.591666666666676 * sp[33] + -0.650000000000007 * sp[34] + -2.283333333333351 * sp[28] + -0.6500000000000137 * sp[31] + -0.9416666666666756 * sp[34] + -1.295833333333346 * sp[35] + -0.1125000000000015 * sp[29] + -0.4666666666666724 * sp[32] + 0.6916666666666655 * sp[28] + 1.520833333333345 * sp[29] + -1.095833333333342 * sp[26] + -0.2666666666666651 * sp[27] + 0.6916666666666647 * sp[31] + 0.6916666666666689 * sp[32] + 0.6916666666666633 * sp[27] + 0.5083333333333351 * sp[30];
    A[4] = -0.0666666666666591 * sp[33] + -0.5333333333333264 * sp[34] + -0.09999999999998854 * sp[28] + -0.5333333333333258 * sp[31] + 0.8833333333333391 * sp[34] + 1.675000000000008 * sp[35] + 0.1416666666666668 * sp[29] + 0.9333333333333274 * sp[32] + -0.3833333333333299 * sp[28] + -0.9583333333333321 * sp[29] + 0.4416666666666719 * sp[26] + -0.1333333333333273 * sp[27] + -0.3833333333333346 * sp[31] + -0.3833333333333362 * sp[32] + -0.383333333333334 * sp[27] + -0.5999999999999981 * sp[30];
    A[5] = -1.008333333333328 * sp[33] + 1.183333333333329 * sp[34] + -2.116666666666666 * sp[28] + 1.18333333333333 * sp[31] + 0.1416666666666661 * sp[34] + -0.8375000000000052 * sp[35] + 0.5125000000000037 * sp[29] + -0.4666666666666649 * sp[32] + 0.1083333333333331 * sp[28] + 1.145833333333339 * sp[29] + -0.6375000000000119 * sp[26] + 0.4000000000000046 * sp[27] + 0.1083333333333299 * sp[31] + 0.1083333333333394 * sp[32] + 0.1083333333333251 * sp[27] + 0.09166666666667078 * sp[30];
    A[6] = -1.091666666666676 * sp[33] + -1.108333333333344 * sp[34] + -1.108333333333336 * sp[28] + -1.108333333333336 * sp[31] + -0.7333333333333433 * sp[34] + -0.3624999999999935 * sp[35] + -1.479166666666683 * sp[29] + -1.10833333333334 * sp[32] + 2.133333333333347 * sp[28] + 1.154166666666652 * sp[29] + 3.170833333333348 * sp[26] + 2.191666666666667 * sp[27] + 1.149999999999999 * sp[31] + 1.116666666666656 * sp[32] + 1.149999999999999 * sp[27] + 1.008333333333328 * sp[30];
    A[7] = 2.600000000000013 * sp[33] + 1.216666666666669 * sp[34] + 1.216666666666669 * sp[28] + 1.216666666666664 * sp[31] + 1.466666666666684 * sp[34] + 0.3083333333333398 * sp[35] + 2.375000000000027 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333361 * sp[28] + -1.05833333333333 * sp[29] + -7.258333333333377 * sp[26] + -3.383333333333338 * sp[27] + -2.13333333333333 * sp[31] + -0.8999999999999959 * sp[32] + -2.133333333333333 * sp[27] + -1.266666666666661 * sp[30];
    A[8] = -1.508333333333341 * sp[33] + 0.3083333333333466 * sp[34] + 0.3083333333333338 * sp[28] + 0.3083333333333445 * sp[31] + -0.7333333333333399 * sp[34] + 0.7625000000000095 * sp[35] + -1.187500000000012 * sp[29] + 0.3083333333333416 * sp[32] + 2.800000000000014 * sp[28] + -2.887500000000014 * sp[29] + 4.295833333333366 * sp[26] + -1.391666666666682 * sp[27] + 0.9833333333333304 * sp[31] + -0.7166666666666662 * sp[32] + 0.9833333333333369 * sp[27] + -0.4083333333333354 * sp[30];
    A[9] = 1.649915822768642 * sp[33] + 0.4714045207910367 * sp[34] + -5.185449728701348 * sp[28] + -5.185449728701377 * sp[31] + 3.064129385141736 * sp[34] + 1.767766952966342 * sp[35] + -3.889087296526057 * sp[29] + -5.185449728701422 * sp[32] + -1.649915822768609 * sp[28] + 5.067598598503628 * sp[29] + 10.72445284799601 * sp[26] + 17.44196726926823 * sp[27] + -1.649915822768617 * sp[31] + -0.235702260395505 * sp[32] + 4.006938426723753 * sp[27] + 5.892556509887884 * sp[30];
    A[10] = 10.96965511460288 * sp[33] + 0.7216878364869684 * sp[34] + -10.53664241271069 * sp[28] + -10.53664241271072 * sp[31] + 0.1443375672973224 * sp[34] + -1.732050807568891 * sp[35] + -8.660254037844483 * sp[29] + -10.53664241271078 * sp[32] + 0.721687836487088 * sp[28] + 11.54700538379248 * sp[29] + 18.47520861406807 * sp[26] + 29.30052616137358 * sp[27] + 0.7216878364870853 * sp[31] + 5.051814855409198 * sp[32] + 7.649891066762516 * sp[27] + 10.96965511460285 * sp[30];
    A[11] = -6.833333333333313 * sp[33] + 1.583333333333339 * sp[34] + 0.08333333333332504 * sp[28] + 0.08333333333333304 * sp[31] + 2.416666666666667 * sp[34] + 3.749999999999986 * sp[35] + -1.250000000000011 * sp[29] + 0.08333333333338566 * sp[32] + 0.08333333333334944 * sp[28] + -4.916666666666647 * sp[29] + -5.916666666666714 * sp[26] + -10.91666666666673 * sp[27] + 0.0833333333333158 * sp[31] + 0.5833333333333499 * sp[32] + -0.916666666666657 * sp[27] + -1.83333333333334 * sp[30];
    A[12] = 5.89255650988787 * sp[33] + -1.649915822768611 * sp[34] + 16.73486048808166 * sp[28] + 4.006938426723798 * sp[31] + -3.299831645537235 * sp[34] + -2.474873734152918 * sp[35] + 3.18198051533951 * sp[29] + 4.006938426723845 * sp[32] + 0.471404520791013 * sp[28] + -2.003469213361935 * sp[29] + -7.660323462854269 * sp[26] + -10.13519719700728 * sp[27] + 0.4714045207910498 * sp[31] + 0.4714045207910156 * sp[32] + -5.185449728701311 * sp[27] + -4.00693842672379 * sp[30];
    A[13] = -16.88749537379662 * sp[33] + -7.361215932167775 * sp[34] + -7.361215932167797 * sp[28] + 3.897114317029944 * sp[31] + -5.196152422706684 * sp[34] + -6.278684177437283 * sp[35] + 4.979646071760493 * sp[29] + 3.897114317029918 * sp[32] + 5.19615242270662 * sp[28] + 11.90784930203616 * sp[29] + -21.86714144555718 * sp[26] + -15.1554445662276 * sp[27] + 5.196152422706602 * sp[31] + 5.196152422706653 * sp[32] + -1.732050807568862 * sp[27] + -3.897114317029894 * sp[30];
    A[14] = 10.4166666666666 * sp[33] + -2.916666666666675 * sp[34] + 10.08333333333329 * sp[28] + -1.416666666666691 * sp[31] + -5.833333333333363 * sp[34] + -4.375000000000009 * sp[35] + -2.875000000000024 * sp[29] + -1.416666666666779 * sp[32] + 0.8333333333333279 * sp[28] + -3.541666666666728 * sp[29] + 7.958333333333448 * sp[26] + 3.583333333333359 * sp[27] + 0.8333333333333767 * sp[31] + 0.8333333333333139 * sp[32] + 1.833333333333381 * sp[27] + 2.916666666666688 * sp[30];
    A[15] = -2.016666666666663 * sp[33] + 0.2833333333333324 * sp[34] + 0.2166666666666676 * sp[28] + 0.2166666666666608 * sp[31] + 1.116666666666661 * sp[34] + -0.8000000000000074 * sp[35] + 1.666666666666681 * sp[29] + 0.2166666666666748 * sp[32] + -0.6166666666666651 * sp[28] + 1.0 * sp[29] + -3.466666666666698 * sp[26] + -0.7166666666666723 * sp[27] + -0.616666666666679 * sp[31] + -0.6166666666666809 * sp[32] + 2.783333333333351 * sp[27] + 0.8166666666666679 * sp[30];
    A[16] = 2.533333333333329 * sp[33] + -1.733333333333336 * sp[34] + 0.7333333333333328 * sp[28] + 0.7333333333333458 * sp[31] + -1.733333333333336 * sp[34] + 2.76666666666667 * sp[35] + -2.166666666666674 * sp[29] + 0.7333333333333424 * sp[32] + 0.7333333333333328 * sp[28] + -2.166666666666674 * sp[29] + 2.766666666666689 * sp[26] + -1.733333333333345 * sp[27] + 0.7333333333333458 * sp[31] + 0.7333333333333424 * sp[32] + -1.733333333333345 * sp[27] + 2.533333333333336 * sp[30];
    A[17] = 0.8166666666666671 * sp[33] + 2.783333333333338 * sp[34] + -0.6166666666666714 * sp[28] + -0.6166666666666725 * sp[31] + -0.7166666666666726 * sp[34] + -3.466666666666685 * sp[35] + 1.0 * sp[29] + -0.6166666666666729 * sp[32] + 0.2166666666666668 * sp[28] + 1.666666666666672 * sp[29] + -0.8000000000000093 * sp[26] + 1.116666666666673 * sp[27] + 0.2166666666666701 * sp[31] + 0.2166666666666667 * sp[32] + 0.2833333333333365 * sp[27] + -2.016666666666671 * sp[30];
    A[18] = -0.06666666666666654 * sp[33] + -0.9499999999999991 * sp[34] + 0.3166666666666738 * sp[28] + -0.9499999999999932 * sp[31] + 0.4666666666666782 * sp[34] + 1.25833333333335 * sp[35] + -0.1083333333333357 * sp[29] + 0.6833333333333417 * sp[32] + 0.03333333333333188 * sp[28] + -0.7083333333333425 * sp[29] + 0.8583333333333376 * sp[26] + 0.1166666666666635 * sp[27] + 0.03333333333333624 * sp[31] + 0.03333333333334179 * sp[32] + 0.03333333333332686 * sp[27] + -0.1833333333333398 * sp[30];
    A[19] = 1.633333333333333 * sp[33] + 3.06666666666667 * sp[34] + 1.19999999999999 * sp[28] + 3.066666666666663 * sp[31] + -1.433333333333345 * sp[34] + -3.683333333333358 * sp[35] + -0.2833333333333315 * sp[29] + -2.533333333333331 * sp[32] + 0.4333333333333337 * sp[28] + 1.583333333333339 * sp[29] + -0.216666666666669 * sp[26] + 0.933333333333338 * sp[27] + 0.4333333333333403 * sp[31] + 0.4333333333333342 * sp[32] + 0.433333333333347 * sp[27] + 1.200000000000018 * sp[30];
    A[20] = 1.266666666666661 * sp[33] + -2.11666666666667 * sp[34] + 2.483333333333333 * sp[28] + -2.116666666666672 * sp[31] + -0.8666666666666656 * sp[34] + 3.008333333333341 * sp[35] + -2.025000000000009 * sp[29] + 1.849999999999994 * sp[32] + 0.3666666666666654 * sp[28] + -1.958333333333338 * sp[29] + 1.275000000000009 * sp[26] + -1.050000000000003 * sp[27] + 0.3666666666666719 * sp[31] + 0.3666666666666704 * sp[32] + 0.3666666666666726 * sp[27] + -1.016666666666667 * sp[30];
    A[21] = 0.1833333333333408 * sp[33] + -0.03333333333332283 * sp[34] + -0.03333333333333777 * sp[28] + -0.0333333333333346 * sp[31] + -0.1166666666666625 * sp[34] + -0.8583333333333498 * sp[35] + 0.7083333333333525 * sp[29] + -0.03333333333332855 * sp[32] + -0.6833333333333449 * sp[28] + 0.1083333333333365 * sp[29] + -1.258333333333348 * sp[26] + -0.4666666666666709 * sp[27] + 0.9500000000000004 * sp[31] + -0.3166666666666911 * sp[32] + 0.9500000000000076 * sp[27] + 0.06666666666666277 * sp[30];
    A[22] = -1.200000000000005 * sp[33] + -0.433333333333333 * sp[34] + -0.4333333333333331 * sp[28] + -0.4333333333333288 * sp[31] + -0.9333333333333407 * sp[34] + 0.2166666666666593 * sp[35] + -1.583333333333354 * sp[29] + -0.4333333333333461 * sp[32] + 2.533333333333359 * sp[28] + 0.2833333333333371 * sp[29] + 3.683333333333369 * sp[26] + 1.433333333333343 * sp[27] + -3.066666666666677 * sp[31] + -1.199999999999989 * sp[32] + -3.066666666666687 * sp[27] + -1.633333333333332 * sp[30];
    A[23] = 1.01666666666667 * sp[33] + -0.3666666666666852 * sp[34] + -0.366666666666668 * sp[28] + -0.3666666666666785 * sp[31] + 1.049999999999998 * sp[34] + -1.275000000000007 * sp[35] + 1.958333333333343 * sp[29] + -0.3666666666666708 * sp[32] + -1.850000000000012 * sp[28] + 2.025000000000009 * sp[29] + -3.008333333333359 * sp[26] + 0.8666666666666751 * sp[27] + 2.116666666666678 * sp[31] + -2.483333333333339 * sp[32] + 2.116666666666679 * sp[27] + -1.266666666666671 * sp[30];
    A[24] = 3.771236166328257 * sp[33] + 6.128258770283434 * sp[34] + 3.299831645537218 * sp[28] + 3.299831645537247 * sp[31] + -3.771236166328294 * sp[34] + 1.178511301977597 * sp[35] + -1.64991582276857 * sp[29] + 3.299831645537283 * sp[32] + 0.9428090415820654 * sp[28] + -5.421151989096876 * sp[29] + -2.592724864350711 * sp[26] + -8.956685895029661 * sp[27] + 0.9428090415820742 * sp[31] + 12.25651754056685 * sp[32] + 3.771236166328281 * sp[27] + 11.7851130197758 * sp[30];
    A[25] = -8.948929172439154 * sp[33] + -1.443375672973966 * sp[34] + 3.752776749732555 * sp[28] + 3.752776749732602 * sp[31] + -3.175426480542799 * sp[34] + 2.02072594216368 * sp[35] + -1.44337567297396 * sp[29] + 3.752776749732656 * sp[32] + 1.44337567297402 * sp[28] + -7.216878364870325 * sp[29] + -3.752776749732631 * sp[26] + -12.41303078757704 * sp[27] + 1.443375672973947 * sp[31] + 10.10362971081831 * sp[32] + 4.90747728811187 * sp[27] + 14.14508159514582 * sp[30];
    A[26] = 11.16666666666665 * sp[33] + 1.833333333333331 * sp[34] + -5.166666666666707 * sp[28] + -5.166666666666694 * sp[31] + -8.166666666666693 * sp[34] + -16.6666666666667 * sp[35] + 3.333333333333386 * sp[29] + -5.16666666666673 * sp[32] + 3.166666666666663 * sp[28] + 10.66666666666668 * sp[29] + 2.666666666666693 * sp[26] + 10.16666666666672 * sp[27] + 3.166666666666722 * sp[31] + -7.833333333333407 * sp[32] + -4.833333333333367 * sp[27] + -17.1666666666667 * sp[30];
    A[27] = -11.78511301977579 * sp[33] + -3.771236166328261 * sp[34] + -12.25651754056681 * sp[28] + -0.9428090415820516 * sp[31] + 8.956685895029644 * sp[34] + 2.592724864350731 * sp[35] + 5.421151989096844 * sp[29] + -0.9428090415821115 * sp[32] + -3.299831645537219 * sp[28] + 1.649915822768618 * sp[29] + -1.178511301977569 * sp[26] + 3.771236166328315 * sp[27] + -3.299831645537282 * sp[31] + -3.299831645537258 * sp[32] + -6.128258770283479 * sp[27] + -3.771236166328308 * sp[30];
    A[28] = 7.794228634059966 * sp[33] + 1.732050807568882 * sp[34] + 1.732050807568894 * sp[28] + -3.464101615137762 * sp[31] + -2.598076211353294 * sp[34] + -0.4330127018921388 * sp[35] + -5.629165124598773 * sp[29] + -3.464101615137684 * sp[32] + 2.598076211353332 * sp[28] + -2.165063509461169 * sp[29] + 13.42339375865888 * sp[26] + 8.660254037844382 * sp[27] + 2.598076211353373 * sp[31] + 2.598076211353403 * sp[32] + -0.8660254037845523 * sp[27] + -5.196152422706608 * sp[30];
    A[29] = -20.8333333333333 * sp[33] + -6.666666666666672 * sp[34] + -12.66666666666662 * sp[28] + 0.3333333333333816 * sp[31] + 15.8333333333334 * sp[34] + 4.58333333333343 * sp[35] + 11.58333333333334 * sp[29] + 0.3333333333335413 * sp[32] + -5.833333333333336 * sp[28] + 2.91666666666667 * sp[29] + -10.08333333333341 * sp[26] + -1.333333333333377 * sp[27] + -5.83333333333342 * sp[31] + -5.833333333333378 * sp[32] + 2.16666666666664 * sp[27] + 13.33333333333326 * sp[30];
    A[30] = -0.03333333333332972 * sp[33] + 0.44166666666667 * sp[34] + -0.1916666666666653 * sp[28] + -0.1916666666666677 * sp[31] + -0.8916666666666611 * sp[34] + 1.275000000000007 * sp[35] + -0.7916666666666682 * sp[29] + -0.1916666666666713 * sp[32] + -0.1916666666666683 * sp[28] + -0.7916666666666757 * sp[29] + 1.27500000000001 * sp[26] + 0.4416666666666691 * sp[27] + -0.1916666666666648 * sp[31] + -0.1916666666666612 * sp[32] + -0.891666666666676 * sp[27] + -0.03333333333333571 * sp[30];
    A[31] = 0.8166666666666671 * sp[33] + -0.7166666666666726 * sp[34] + 0.2166666666666668 * sp[28] + 0.2166666666666701 * sp[31] + 2.783333333333338 * sp[34] + -3.466666666666685 * sp[35] + 1.666666666666672 * sp[29] + 0.2166666666666667 * sp[32] + -0.6166666666666714 * sp[28] + 1.0 * sp[29] + -0.8000000000000093 * sp[26] + 0.2833333333333365 * sp[27] + -0.6166666666666725 * sp[31] + -0.6166666666666729 * sp[32] + 1.116666666666673 * sp[27] + -2.016666666666671 * sp[30];
    A[32] = 0.6333333333333359 * sp[33] + 1.691666666666674 * sp[34] + -0.6083333333333375 * sp[28] + -0.6083333333333366 * sp[31] + 1.691666666666674 * sp[34] + 6.191666666666696 * sp[35] + -1.875000000000013 * sp[29] + -0.6083333333333304 * sp[32] + -0.6083333333333375 * sp[28] + -1.875000000000013 * sp[29] + 0.8583333333333406 * sp[26] + 0.3583333333333341 * sp[27] + -0.6083333333333366 * sp[31] + -0.6083333333333304 * sp[32] + 0.3583333333333341 * sp[27] + 2.633333333333345 * sp[30];
    A[33] = -1.008333333333337 * sp[33] + -1.150000000000002 * sp[34] + -1.11666666666667 * sp[28] + -1.150000000000002 * sp[31] + -2.191666666666677 * sp[34] + -3.170833333333342 * sp[35] + -1.154166666666672 * sp[29] + -2.133333333333341 * sp[32] + 1.10833333333334 * sp[28] + 1.479166666666674 * sp[29] + 0.3625000000000074 * sp[26] + 0.7333333333333412 * sp[27] + 1.108333333333335 * sp[31] + 1.108333333333328 * sp[32] + 1.108333333333344 * sp[27] + 1.091666666666674 * sp[30];
    A[34] = 1.26666666666667 * sp[33] + 2.13333333333334 * sp[34] + 0.899999999999999 * sp[28] + 2.133333333333336 * sp[31] + 3.383333333333345 * sp[34] + 7.258333333333361 * sp[35] + 1.05833333333333 * sp[29] + 4.933333333333341 * sp[32] + -1.216666666666674 * sp[28] + -2.375000000000012 * sp[29] + -0.3083333333333377 * sp[26] + -1.466666666666678 * sp[27] + -1.216666666666672 * sp[31] + -1.216666666666663 * sp[32] + -1.216666666666676 * sp[27] + -2.600000000000016 * sp[30];
    A[35] = 0.4083333333333327 * sp[33] + -0.9833333333333399 * sp[34] + 0.7166666666666683 * sp[28] + -0.9833333333333409 * sp[31] + 1.391666666666666 * sp[34] + -4.295833333333357 * sp[35] + 2.887500000000009 * sp[29] + -2.800000000000018 * sp[32] + -0.3083333333333351 * sp[28] + 1.187500000000013 * sp[29] + -0.7625000000000068 * sp[26] + 0.7333333333333478 * sp[27] + -0.3083333333333357 * sp[31] + -0.3083333333333381 * sp[32] + -0.3083333333333358 * sp[27] + 1.50833333333334 * sp[30];
    A[36] = -0.5083333333333322 * sp[33] + -0.6916666666666642 * sp[34] + -0.6916666666666702 * sp[28] + -0.6916666666666681 * sp[31] + 0.2666666666666709 * sp[34] + 1.095833333333349 * sp[35] + -1.520833333333345 * sp[29] + -0.6916666666666658 * sp[32] + 0.4666666666666728 * sp[28] + 0.112500000000002 * sp[29] + 1.295833333333342 * sp[26] + 0.9416666666666709 * sp[27] + 0.6500000000000031 * sp[31] + 2.283333333333359 * sp[32] + 0.649999999999998 * sp[27] + 1.591666666666676 * sp[30];
    A[37] = 0.6000000000000014 * sp[33] + 0.3833333333333344 * sp[34] + 0.3833333333333326 * sp[28] + 0.383333333333334 * sp[31] + 0.1333333333333391 * sp[34] + -0.4416666666666617 * sp[35] + 0.9583333333333376 * sp[29] + 0.3833333333333388 * sp[32] + -0.9333333333333476 * sp[28] + -0.1416666666666712 * sp[29] + -1.675000000000012 * sp[26] + -0.8833333333333381 * sp[27] + 0.5333333333333333 * sp[31] + 0.09999999999999287 * sp[32] + 0.5333333333333444 * sp[27] + 0.06666666666666543 * sp[30];
    A[38] = -0.09166666666666737 * sp[33] + -0.108333333333341 * sp[34] + -0.1083333333333335 * sp[28] + -0.1083333333333365 * sp[31] + -0.4000000000000029 * sp[34] + 0.637499999999991 * sp[35] + -1.14583333333334 * sp[29] + -0.1083333333333367 * sp[32] + 0.4666666666666731 * sp[28] + -0.5124999999999981 * sp[29] + 0.8375000000000095 * sp[26] + -0.1416666666666683 * sp[27] + -1.183333333333337 * sp[31] + 2.116666666666679 * sp[32] + -1.18333333333334 * sp[27] + 1.008333333333337 * sp[30];
    A[39] = 4.006938426723789 * sp[33] + 5.18544972870137 * sp[34] + -0.4714045207910283 * sp[28] + -0.471404520791022 * sp[31] + 10.13519719700723 * sp[34] + 7.66032346285428 * sp[35] + 2.003469213361889 * sp[29] + -0.4714045207910425 * sp[32] + -4.006938426723801 * sp[28] + -3.181980515339487 * sp[29] + 2.474873734152924 * sp[26] + 3.299831645537242 * sp[27] + -4.00693842672379 * sp[31] + -16.73486048808169 * sp[32] + 1.649915822768594 * sp[27] + -5.892556509887912 * sp[30];
    A[40] = -0.577350269189601 * sp[33] + -0.7216878364869936 * sp[34] + -3.319764047840357 * sp[28] + -3.319764047840339 * sp[31] + 4.474464586219614 * sp[34] + 4.041451884327445 * sp[35] + -2.886751345948156 * sp[29] + -3.319764047840351 * sp[32] + -0.7216878364870334 * sp[28] + 6.928203230275537 * sp[26] + 7.649891066762579 * sp[27] + -0.7216878364870114 * sp[31] + -5.05181485540916 * sp[32] + 6.206515393788456 * sp[27] + -0.5773502691896075 * sp[30];
    A[41] = 4.833333333333337 * sp[33] + 2.416666666666664 * sp[34] + -4.08333333333337 * sp[28] + -4.083333333333356 * sp[31] + 14.91666666666669 * sp[34] + 22.91666666666674 * sp[35] + -12.08333333333343 * sp[29] + -4.083333333333301 * sp[32] + -4.083333333333355 * sp[28] + -5.749999999999998 * sp[29] + 3.250000000000027 * sp[26] + 1.583333333333335 * sp[27] + -4.083333333333357 * sp[31] + 11.41666666666677 * sp[32] + 4.916666666666704 * sp[27] + 19.83333333333343 * sp[30];
    A[42] = -5.892556509887912 * sp[33] + -4.006938426723774 * sp[34] + 0.2357022603955312 * sp[28] + 1.649915822768632 * sp[31] + -17.44196726926823 * sp[34] + -10.72445284799601 * sp[35] + -5.067598598503574 * sp[29] + 1.649915822768651 * sp[32] + 5.185449728701382 * sp[28] + 3.889087296526012 * sp[29] + -1.767766952966381 * sp[26] + -3.064129385141755 * sp[27] + 5.185449728701383 * sp[31] + 5.185449728701364 * sp[32] + -0.4714045207910211 * sp[27] + -1.649915822768606 * sp[30];
    A[43] = -3.897114317029984 * sp[33] + -3.031088913245552 * sp[34] + -3.031088913245564 * sp[28] + -0.4330127018922491 * sp[31] + -5.196152422706619 * sp[34] + -4.113620667976107 * sp[35] + -1.51554445662285 * sp[29] + -0.4330127018922791 * sp[32] + 5.196152422706641 * sp[28] + 5.412658773652788 * sp[29] + -2.381569860407196 * sp[26] + -2.165063509461067 * sp[27] + 5.196152422706631 * sp[31] + 5.196152422706608 * sp[32] + -1.7320508075688 * sp[27] + 0.4330127018922143 * sp[30];
    A[44] = -10.41666666666669 * sp[33] + -7.08333333333334 * sp[34] + -4.083333333333325 * sp[28] + -0.5833333333333084 * sp[31] + -30.83333333333341 * sp[34] + -18.95833333333339 * sp[35] + -12.45833333333333 * sp[29] + -0.5833333333333715 * sp[32] + 9.166666666666728 * sp[28] + 6.875000000000004 * sp[29] + 3.375000000000048 * sp[26] + 1.083333333333321 * sp[27] + 9.166666666666721 * sp[31] + 9.166666666666687 * sp[32] + 0.1666666666666816 * sp[27] + -12.91666666666671 * sp[30];
    A[45] = -1.591666666666676 * sp[33] + -0.9416666666666756 * sp[34] + 0.6916666666666655 * sp[28] + 0.6916666666666647 * sp[31] + -0.650000000000007 * sp[34] + -1.295833333333346 * sp[35] + 1.520833333333345 * sp[29] + 0.6916666666666689 * sp[32] + -2.283333333333351 * sp[28] + -0.1125000000000015 * sp[29] + -1.095833333333342 * sp[26] + 0.6916666666666633 * sp[27] + -0.6500000000000137 * sp[31] + -0.4666666666666724 * sp[32] + -0.2666666666666651 * sp[27] + 0.5083333333333351 * sp[30];
    A[46] = -0.06666666666666654 * sp[33] + 0.4666666666666782 * sp[34] + 0.03333333333333188 * sp[28] + 0.03333333333333624 * sp[31] + -0.9499999999999991 * sp[34] + 1.25833333333335 * sp[35] + -0.7083333333333425 * sp[29] + 0.03333333333334179 * sp[32] + 0.3166666666666738 * sp[28] + -0.1083333333333357 * sp[29] + 0.8583333333333376 * sp[26] + 0.03333333333332686 * sp[27] + -0.9499999999999932 * sp[31] + 0.6833333333333417 * sp[32] + 0.1166666666666635 * sp[27] + -0.1833333333333398 * sp[30];
    A[47] = -1.008333333333337 * sp[33] + -2.191666666666677 * sp[34] + 1.10833333333334 * sp[28] + 1.108333333333335 * sp[31] + -1.150000000000002 * sp[34] + -3.170833333333342 * sp[35] + 1.479166666666674 * sp[29] + 1.108333333333328 * sp[32] + -1.11666666666667 * sp[28] + -1.154166666666672 * sp[29] + 0.3625000000000074 * sp[26] + 1.108333333333344 * sp[27] + -1.150000000000002 * sp[31] + -2.133333333333341 * sp[32] + 0.7333333333333412 * sp[27] + 1.091666666666674 * sp[30];
    A[48] = 2.633333333333343 * sp[33] + 2.275000000000004 * sp[34] + 3.241666666666679 * sp[28] + 2.275000000000007 * sp[31] + 2.275000000000004 * sp[34] + 2.775000000000004 * sp[35] + 1.008333333333335 * sp[29] + 1.508333333333335 * sp[32] + 3.241666666666679 * sp[28] + 1.008333333333335 * sp[29] + 10.04166666666667 * sp[26] + 5.508333333333338 * sp[27] + 2.275000000000007 * sp[31] + 1.508333333333335 * sp[32] + 5.508333333333338 * sp[27] + 3.683333333333333 * sp[30];
    A[49] = -2.016666666666673 * sp[33] + -3.133333333333342 * sp[34] + -1.400000000000001 * sp[28] + -3.133333333333334 * sp[31] + -2.300000000000002 * sp[34] + -4.216666666666672 * sp[35] + -0.6833333333333292 * sp[29] + -2.599999999999993 * sp[32] + -2.233333333333338 * sp[28] + -1.683333333333338 * sp[29] + -5.083333333333325 * sp[26] + -7.933333333333321 * sp[27] + -2.300000000000002 * sp[31] + -2.766666666666673 * sp[32] + -3.433333333333324 * sp[27] + -5.86666666666666 * sp[30];
    A[50] = -0.03333333333333353 * sp[33] + 0.8583333333333444 * sp[34] + 0.1583333333333335 * sp[28] + 0.8583333333333449 * sp[31] + -0.4749999999999986 * sp[34] + 1.691666666666681 * sp[35] + -1.075000000000002 * sp[29] + 1.091666666666679 * sp[32] + 0.1583333333333365 * sp[28] + 0.2583333333333323 * sp[29] + 1.625000000000006 * sp[26] + 2.424999999999994 * sp[27] + -0.4749999999999954 * sp[31] + 1.091666666666674 * sp[32] + -0.2416666666666635 * sp[27] + 2.18333333333334 * sp[30];
    A[51] = 1.508333333333335 * sp[33] + 1.816666666666665 * sp[34] + 1.816666666666672 * sp[28] + 1.816666666666668 * sp[31] + 0.7750000000000016 * sp[34] + 0.3208333333333232 * sp[35] + 2.270833333333342 * sp[29] + 1.816666666666667 * sp[32] + 4.308333333333329 * sp[28] + 7.504166666666663 * sp[29] + 0.3208333333333393 * sp[26] + 1.81666666666667 * sp[27] + 2.591666666666663 * sp[31] + 4.308333333333326 * sp[32] + 0.7750000000000072 * sp[27] + 1.508333333333336 * sp[30];
    A[52] = -2.600000000000008 * sp[33] + -1.383333333333334 * sp[34] + -1.383333333333333 * sp[28] + -1.383333333333332 * sp[31] + -1.133333333333346 * sp[34] + -0.2250000000000022 * sp[35] + -2.29166666666668 * sp[29] + -1.383333333333338 * sp[32] + -7.533333333333331 * sp[28] + -5.258333333333328 * sp[29] + 0.9416666666666754 * sp[26] + -1.383333333333327 * sp[27] + -3.933333333333339 * sp[31] + -2.866666666666664 * sp[32] + 0.03333333333333127 * sp[27] + -1.016666666666667 * sp[30];
    A[53] = 1.091666666666673 * sp[33] + -0.01666666666666317 * sp[34] + -0.01666666666666616 * sp[28] + -0.01666666666666879 * sp[31] + 0.358333333333342 * sp[34] + -0.3874999999999983 * sp[35] + 0.7291666666666771 * sp[29] + -0.01666666666667013 * sp[32] + 3.225000000000004 * sp[28] + 0.9625000000000037 * sp[29] + -1.054166666666672 * sp[26] + -0.01666666666666437 * sp[27] + 1.341666666666675 * sp[31] + 0.5583333333333432 * sp[32] + -0.3083333333333296 * sp[27] + 0.09166666666667204 * sp[30];
    A[54] = -7.542472332656545 * sp[33] + -8.720983634634106 * sp[34] + 4.006938426723762 * sp[28] + 4.006938426723769 * sp[31] + -7.778174593052048 * sp[34] + -8.249579113843033 * sp[35] + 4.478342947514811 * sp[29] + 4.006938426723802 * sp[32] + -8.720983634634123 * sp[28] + -12.96362432175341 * sp[29] + -0.2357022603955286 * sp[26] + 4.006938426723734 * sp[27] + -7.778174593052052 * sp[31] + -11.07800623858927 * sp[32] + 0.2357022603955121 * sp[27] + 2.357022603955139 * sp[30];
    A[55] = -5.917840259193724 * sp[33] + 0.7216878364869955 * sp[34] + 11.98001808568475 * sp[28] + 11.98001808568474 * sp[31] + -0.8660254037844606 * sp[34] + -2.237232293109835 * sp[35] + 13.35122497501012 * sp[29] + 11.98001808568477 * sp[32] + -11.83568051838743 * sp[28] + 18.25870226312183 * sp[29] + 2.670244995002054 * sp[26] + 11.98001808568471 * sp[27] + -0.8660254037845663 * sp[31] + 10.96965511460279 * sp[32] + 4.041451884327408 * sp[27] + 8.804591605141775 * sp[30];
    A[56] = -3.583333333333332 * sp[33] + -4.916666666666674 * sp[34] + 6.583333333333384 * sp[28] + 6.583333333333354 * sp[31] + -6.999999999999988 * sp[34] + -7.708333333333334 * sp[35] + 7.291666666666694 * sp[29] + 6.583333333333293 * sp[32] + -2.666666666666641 * sp[28] + 4.458333333333301 * sp[29] + 5.458333333333416 * sp[26] + 6.583333333333427 * sp[27] + -6.999999999999972 * sp[31] + 2.166666666666631 * sp[32] + 6.166666666666726 * sp[27] + 6.916666666666718 * sp[30];
    A[57] = 5.892556509887914 * sp[33] + 7.542472332656502 * sp[34] + -10.84230397819378 * sp[28] + -5.185449728701395 * sp[31] + 9.192388155425125 * sp[34] + 8.367430244040783 * sp[35] + -4.360491817317082 * sp[29] + -5.185449728701418 * sp[32] + 5.421151989096863 * sp[28] + 5.067598598503621 * sp[29] + -18.97403196183911 * sp[26] + -5.185449728701359 * sp[27] + 9.19238815542511 * sp[31] + 5.892556509887898 * sp[32] + -6.835365551470032 * sp[27] + -4.006938426723806 * sp[30];
    A[58] = 16.8874953737966 * sp[33] + 9.526279441628871 * sp[34] + 9.526279441628894 * sp[28] + -1.732050807568819 * sp[31] + 11.69134295108993 * sp[34] + 10.60881119635943 * sp[35] + -0.6495190528383068 * sp[29] + -1.732050807568818 * sp[32] + 22.08364779650328 * sp[28] + 2.814582562299463 * sp[29] + 36.58957330989261 * sp[26] + -1.732050807568835 * sp[27] + 11.69134295108998 * sp[31] + 3.897114317030009 * sp[32] + 19.48557158514988 * sp[27] + 0.4330127018922438 * sp[30];
    A[59] = 10.41666666666671 * sp[33] + 13.33333333333333 * sp[34] + 0.3333333333333246 * sp[28] + 1.833333333333294 * sp[31] + 16.25000000000001 * sp[34] + 14.79166666666662 * sp[35] + 3.291666666666674 * sp[29] + 1.833333333333322 * sp[32] + 9.58333333333333 * sp[28] + 8.958333333333389 * sp[29] + 7.458333333333254 * sp[26] + 1.833333333333304 * sp[27] + 16.24999999999998 * sp[31] + 10.41666666666667 * sp[32] + 9.416666666666613 * sp[27] + 2.916666666666585 * sp[30];
    A[60] = -0.0666666666666591 * sp[33] + 0.8833333333333391 * sp[34] + -0.3833333333333299 * sp[28] + -0.3833333333333346 * sp[31] + -0.5333333333333264 * sp[34] + 1.675000000000008 * sp[35] + -0.9583333333333321 * sp[29] + -0.3833333333333362 * sp[32] + -0.09999999999998854 * sp[28] + 0.1416666666666668 * sp[29] + 0.4416666666666719 * sp[26] + -0.383333333333334 * sp[27] + -0.5333333333333258 * sp[31] + 0.9333333333333274 * sp[32] + -0.1333333333333273 * sp[27] + -0.5999999999999981 * sp[30];
    A[61] = 1.633333333333333 * sp[33] + -1.433333333333345 * sp[34] + 0.4333333333333337 * sp[28] + 0.4333333333333403 * sp[31] + 3.06666666666667 * sp[34] + -3.683333333333358 * sp[35] + 1.583333333333339 * sp[29] + 0.4333333333333342 * sp[32] + 1.19999999999999 * sp[28] + -0.2833333333333315 * sp[29] + -0.216666666666669 * sp[26] + 0.433333333333347 * sp[27] + 3.066666666666663 * sp[31] + -2.533333333333331 * sp[32] + 0.933333333333338 * sp[27] + 1.200000000000018 * sp[30];
    A[62] = 1.26666666666667 * sp[33] + 3.383333333333345 * sp[34] + -1.216666666666674 * sp[28] + -1.216666666666672 * sp[31] + 2.13333333333334 * sp[34] + 7.258333333333361 * sp[35] + -2.375000000000012 * sp[29] + -1.216666666666663 * sp[32] + 0.899999999999999 * sp[28] + 1.05833333333333 * sp[29] + -0.3083333333333377 * sp[26] + -1.216666666666676 * sp[27] + 2.133333333333336 * sp[31] + 4.933333333333341 * sp[32] + -1.466666666666678 * sp[27] + -2.600000000000016 * sp[30];
    A[63] = -2.016666666666673 * sp[33] + -2.300000000000002 * sp[34] + -2.233333333333338 * sp[28] + -2.300000000000002 * sp[31] + -3.133333333333342 * sp[34] + -4.216666666666672 * sp[35] + -1.683333333333338 * sp[29] + -2.766666666666673 * sp[32] + -1.400000000000001 * sp[28] + -0.6833333333333292 * sp[29] + -5.083333333333325 * sp[26] + -3.433333333333324 * sp[27] + -3.133333333333334 * sp[31] + -2.599999999999993 * sp[32] + -7.933333333333321 * sp[27] + -5.86666666666666 * sp[30];
    A[64] = 2.533333333333339 * sp[33] + 4.266666666666677 * sp[34] + 1.799999999999996 * sp[28] + 4.266666666666668 * sp[31] + 4.266666666666677 * sp[34] + 8.766666666666694 * sp[35] + 1.36666666666666 * sp[29] + 5.866666666666672 * sp[32] + 1.799999999999996 * sp[28] + 1.36666666666666 * sp[29] + 3.833333333333315 * sp[26] + 5.866666666666646 * sp[27] + 4.266666666666668 * sp[31] + 5.866666666666672 * sp[32] + 5.866666666666646 * sp[27] + 11.73333333333333 * sp[30];
    A[65] = 0.8166666666666645 * sp[33] + -1.966666666666679 * sp[34] + 1.433333333333335 * sp[28] + -1.966666666666681 * sp[31] + 1.533333333333331 * sp[34] + -4.716666666666696 * sp[35] + 3.150000000000008 * sp[29] + -3.100000000000024 * sp[32] + 0.5999999999999933 * sp[28] + -0.5166666666666635 * sp[29] + 0.4166666666666612 * sp[26] + -2.433333333333327 * sp[27] + 1.533333333333328 * sp[31] + -3.266666666666668 * sp[32] + 2.066666666666673 * sp[27] + -5.86666666666667 * sp[30];
    A[66] = -1.016666666666662 * sp[33] + -1.383333333333326 * sp[34] + -1.383333333333339 * sp[28] + -1.383333333333334 * sp[31] + 0.03333333333334093 * sp[34] + 0.9416666666666856 * sp[35] + -2.291666666666676 * sp[29] + -1.38333333333333 * sp[32] + -2.866666666666656 * sp[28] + -5.258333333333317 * sp[29] + -0.2250000000000022 * sp[26] + -1.383333333333333 * sp[27] + -3.933333333333317 * sp[31] + -7.533333333333323 * sp[32] + -1.133333333333337 * sp[27] + -2.600000000000002 * sp[30];
    A[67] = 1.200000000000001 * sp[33] + 0.7666666666666671 * sp[34] + 0.7666666666666639 * sp[28] + 0.7666666666666666 * sp[31] + 0.2666666666666715 * sp[34] + -0.3833333333333306 * sp[35] + 1.416666666666667 * sp[29] + 0.766666666666669 * sp[32] + 3.733333333333321 * sp[28] + 3.01666666666666 * sp[29] + -0.3833333333333396 * sp[26] + 0.7666666666666629 * sp[27] + 5.866666666666651 * sp[31] + 3.733333333333324 * sp[32] + 0.2666666666666573 * sp[27] + 1.199999999999994 * sp[30];
    A[68] = -0.1833333333333353 * sp[33] + -0.2166666666666821 * sp[34] + -0.216666666666667 * sp[28] + -0.2166666666666731 * sp[31] + -0.3000000000000048 * sp[34] + 0.524999999999986 * sp[35] + -1.041666666666673 * sp[29] + -0.2166666666666711 * sp[32] + -0.8666666666666649 * sp[28] + -1.008333333333349 * sp[29] + 0.3583333333333355 * sp[26] + -0.2166666666666768 * sp[27] + -1.93333333333333 * sp[31] + -1.533333333333357 * sp[32] + -0.4666666666666712 * sp[27] + -0.6000000000000124 * sp[30];
    A[69] = 8.013876853447572 * sp[33] + 10.37089945740273 * sp[34] + -0.9428090415820529 * sp[28] + -0.9428090415820395 * sp[31] + 13.19932658214894 * sp[34] + 11.7851130197758 * sp[35] + 0.4714045207910482 * sp[29] + -0.9428090415820611 * sp[32] + 5.656854249492383 * sp[28] + 11.7851130197758 * sp[29] + 0.471404520791042 * sp[26] + -0.9428090415820127 * sp[27] + 13.19932658214891 * sp[31] + 24.51303508113372 * sp[32] + 1.885618083164166 * sp[27];
    A[70] = -1.154700538379182 * sp[33] + -1.443375672973976 * sp[34] + -6.639528095680702 * sp[28] + -6.639528095680664 * sp[31] + 4.618802153517066 * sp[34] + 5.91784025919376 * sp[35] + -7.938566201357359 * sp[29] + -6.639528095680671 * sp[32] + -5.196152422706535 * sp[28] + -14.86676943163272 * sp[29] + -1.01036297108185 * sp[26] + -6.639528095680628 * sp[27] + 4.618802153517111 * sp[31] + -16.16580753730938 * sp[32] + -2.309401076758475 * sp[27] + -10.39230484541318 * sp[30];
    A[71] = 9.666666666666664 * sp[33] + 4.83333333333334 * sp[34] + -8.166666666666734 * sp[28] + -8.166666666666707 * sp[31] + 17.33333333333335 * sp[34] + 24.58333333333341 * sp[35] + -15.41666666666677 * sp[29] + -8.166666666666639 * sp[32] + 6.999999999999954 * sp[28] + -11.41666666666667 * sp[29] + -3.416666666666716 * sp[26] + -8.166666666666735 * sp[27] + 17.33333333333331 * sp[31] + -2.666666666666655 * sp[32] + -10.66666666666677 * sp[27] + -18.00000000000012 * sp[30];
    A[72] = -11.78511301977581 * sp[33] + -8.013876853447542 * sp[34] + 0.4714045207910615 * sp[28] + 3.299831645537259 * sp[31] + -20.74179891480544 * sp[34] + -14.37783788412648 * sp[35] + -3.064129385141687 * sp[29] + 3.299831645537272 * sp[32] + -8.485281374238534 * sp[28] + -3.064129385141702 * sp[29] + 2.59272486435072 * sp[26] + 3.299831645537231 * sp[27] + -20.7417989148054 * sp[31] + -9.42809041582067 * sp[32] + 1.88561808316413 * sp[27] + 5.656854249492373 * sp[30];
    A[73] = -7.794228634059962 * sp[33] + -6.062177826491094 * sp[34] + -6.062177826491116 * sp[28] + -0.866025403784493 * sp[31] + -10.39230484541324 * sp[34] + -8.227241335952186 * sp[35] + -3.031088913245617 * sp[29] + -0.8660254037845138 * sp[32] + -5.196152422706664 * sp[28] + -1.299038105676672 * sp[29] + -16.88749537379655 * sp[26] + -0.8660254037844799 * sp[27] + -10.39230484541322 * sp[31] + -3.464101615137729 * sp[32] + -17.32050807568877 * sp[27] + 3.464101615137721 * sp[30];
    A[74] = -20.83333333333336 * sp[33] + -14.16666666666667 * sp[34] + -8.166666666666639 * sp[28] + -1.166666666666602 * sp[31] + -36.66666666666674 * sp[34] + -25.41666666666668 * sp[35] + -12.41666666666665 * sp[29] + -1.166666666666647 * sp[32] + -14.99999999999993 * sp[28] + -5.41666666666666 * sp[29] + -12.41666666666658 * sp[26] + -1.166666666666595 * sp[27] + -36.66666666666665 * sp[31] + -16.66666666666671 * sp[32] + -24.66666666666661 * sp[27] + 10.00000000000011 * sp[30];
    A[75] = -1.008333333333328 * sp[33] + 0.1416666666666661 * sp[34] + 0.1083333333333331 * sp[28] + 0.1083333333333299 * sp[31] + 1.183333333333329 * sp[34] + -0.8375000000000052 * sp[35] + 1.145833333333339 * sp[29] + 0.1083333333333394 * sp[32] + -2.116666666666666 * sp[28] + 0.5125000000000037 * sp[29] + -0.6375000000000119 * sp[26] + 0.1083333333333251 * sp[27] + 1.18333333333333 * sp[31] + -0.4666666666666649 * sp[32] + 0.4000000000000046 * sp[27] + 0.09166666666667078 * sp[30];
    A[76] = 1.266666666666661 * sp[33] + -0.8666666666666656 * sp[34] + 0.3666666666666654 * sp[28] + 0.3666666666666719 * sp[31] + -2.11666666666667 * sp[34] + 3.008333333333341 * sp[35] + -1.958333333333338 * sp[29] + 0.3666666666666704 * sp[32] + 2.483333333333333 * sp[28] + -2.025000000000009 * sp[29] + 1.275000000000009 * sp[26] + 0.3666666666666726 * sp[27] + -2.116666666666672 * sp[31] + 1.849999999999994 * sp[32] + -1.050000000000003 * sp[27] + -1.016666666666667 * sp[30];
    A[77] = 0.4083333333333327 * sp[33] + 1.391666666666666 * sp[34] + -0.3083333333333351 * sp[28] + -0.3083333333333357 * sp[31] + -0.9833333333333399 * sp[34] + -4.295833333333357 * sp[35] + 1.187500000000013 * sp[29] + -0.3083333333333381 * sp[32] + 0.7166666666666683 * sp[28] + 2.887500000000009 * sp[29] + -0.7625000000000068 * sp[26] + -0.3083333333333358 * sp[27] + -0.9833333333333409 * sp[31] + -2.800000000000018 * sp[32] + 0.7333333333333478 * sp[27] + 1.50833333333334 * sp[30];
    A[78] = -0.03333333333333353 * sp[33] + -0.4749999999999986 * sp[34] + 0.1583333333333365 * sp[28] + -0.4749999999999954 * sp[31] + 0.8583333333333444 * sp[34] + 1.691666666666681 * sp[35] + 0.2583333333333323 * sp[29] + 1.091666666666674 * sp[32] + 0.1583333333333335 * sp[28] + -1.075000000000002 * sp[29] + 1.625000000000006 * sp[26] + -0.2416666666666635 * sp[27] + 0.8583333333333449 * sp[31] + 1.091666666666679 * sp[32] + 2.424999999999994 * sp[27] + 2.18333333333334 * sp[30];
    A[79] = 0.8166666666666645 * sp[33] + 1.533333333333331 * sp[34] + 0.5999999999999933 * sp[28] + 1.533333333333328 * sp[31] + -1.966666666666679 * sp[34] + -4.716666666666696 * sp[35] + -0.5166666666666635 * sp[29] + -3.266666666666668 * sp[32] + 1.433333333333335 * sp[28] + 3.150000000000008 * sp[29] + 0.4166666666666612 * sp[26] + 2.066666666666673 * sp[27] + -1.966666666666681 * sp[31] + -3.100000000000024 * sp[32] + -2.433333333333327 * sp[27] + -5.86666666666667 * sp[30];
    A[80] = 0.633333333333329 * sp[33] + -1.058333333333332 * sp[34] + 1.241666666666664 * sp[28] + -1.058333333333333 * sp[31] + -1.058333333333332 * sp[34] + 3.441666666666681 * sp[35] + -2.32500000000001 * sp[29] + 2.175000000000002 * sp[32] + 1.241666666666664 * sp[28] + -2.32500000000001 * sp[29] + 2.708333333333339 * sp[26] + -1.825000000000012 * sp[27] + -1.058333333333333 * sp[31] + 2.175000000000002 * sp[32] + -1.825000000000012 * sp[27] + 3.683333333333323 * sp[30];
    A[81] = 0.09166666666666987 * sp[33] + -0.01666666666666167 * sp[34] + -0.01666666666666947 * sp[28] + -0.01666666666666779 * sp[31] + -0.3083333333333351 * sp[34] + -1.054166666666686 * sp[35] + 0.7291666666666813 * sp[29] + -0.01666666666666572 * sp[32] + 0.5583333333333337 * sp[28] + 0.9625000000000054 * sp[29] + -0.3875000000000088 * sp[26] + -0.0166666666666706 * sp[27] + 1.341666666666662 * sp[31] + 3.224999999999992 * sp[32] + 0.3583333333333494 * sp[27] + 1.091666666666677 * sp[30];
    A[82] = -0.6000000000000009 * sp[33] + -0.2166666666666659 * sp[34] + -0.2166666666666654 * sp[28] + -0.2166666666666635 * sp[31] + -0.4666666666666681 * sp[34] + 0.3583333333333287 * sp[35] + -1.041666666666677 * sp[29] + -0.2166666666666746 * sp[32] + -1.533333333333326 * sp[28] + -1.008333333333329 * sp[29] + 0.5250000000000143 * sp[26] + -0.2166666666666569 * sp[27] + -1.933333333333325 * sp[31] + -0.8666666666666683 * sp[32] + -0.3000000000000083 * sp[27] + -0.1833333333333423 * sp[30];
    A[83] = 0.5083333333333337 * sp[33] + -0.1833333333333421 * sp[34] + -0.1833333333333336 * sp[28] + -0.1833333333333388 * sp[31] + 0.774999999999997 * sp[34] + -1.012500000000001 * sp[35] + 1.604166666666673 * sp[29] + -0.1833333333333337 * sp[32] + 0.9749999999999981 * sp[28] + 0.1708333333333206 * sp[29] + -1.012500000000011 * sp[26] + -0.1833333333333409 * sp[27] + 0.591666666666658 * sp[31] + 0.9750000000000014 * sp[32] + 0.7750000000000039 * sp[27] + 0.5083333333333349 * sp[30];
    A[84] = 1.885618083164125 * sp[33] + 3.064129385141711 * sp[34] + 1.649915822768602 * sp[28] + 1.649915822768618 * sp[31] + -5.421151989096908 * sp[34] + -1.178511301977574 * sp[35] + -2.592724864350657 * sp[29] + 1.649915822768643 * sp[32] + 3.064129385141715 * sp[28] + 3.535533905932757 * sp[29] + 2.121320343559625 * sp[26] + 1.649915822768603 * sp[27] + -5.421151989096912 * sp[31] + -13.43502884254444 * sp[32] + -2.121320343559627 * sp[27] + -2.35702260395514 * sp[30];
    A[85] = -4.474464586219566 * sp[33] + -0.7216878364869816 * sp[34] + 1.876388374866269 * sp[28] + 1.876388374866293 * sp[31] + -3.752776749732482 * sp[34] + -0.07216878364874374 * sp[35] + -1.804219591217515 * sp[29] + 1.876388374866321 * sp[32] + -8.94892917243919 * sp[28] + 0.2165063509461638 * sp[29] + 1.948557158514958 * sp[26] + 1.876388374866267 * sp[27] + -3.752776749732459 * sp[31] + 5.196152422706615 * sp[32] + -1.732050807568803 * sp[27] + 1.587713240271536 * sp[30];
    A[86] = 5.583333333333312 * sp[33] + 0.9166666666666623 * sp[34] + -2.583333333333348 * sp[28] + -2.583333333333342 * sp[31] + -10.33333333333337 * sp[34] + -18.95833333333341 * sp[35] + 6.041666666666741 * sp[29] + -2.583333333333382 * sp[32] + 10.66666666666667 * sp[28] + 4.874999999999998 * sp[29] + -4.125000000000021 * sp[26] + -2.58333333333333 * sp[27] + -10.33333333333337 * sp[31] + 0.5 * sp[32] + 4.500000000000095 * sp[27] + 11.08333333333337 * sp[30];
    A[87] = -5.892556509887879 * sp[33] + -1.885618083164127 * sp[34] + -6.128258770283389 * sp[28] + -0.4714045207910231 * sp[31] + 11.54941075938033 * sp[34] + 4.831896338108136 * sp[35] + 6.246109900481163 * sp[29] + -0.4714045207910615 * sp[32] + -11.07800623858926 * sp[28] + -3.181980515339465 * sp[29] + -13.08147545195113 * sp[26] + -0.4714045207909972 * sp[27] + 11.54941075938034 * sp[31] + 3.535533905932835 * sp[32] + 4.949747468305836 * sp[27] + -1.649915822768617 * sp[30];
    A[88] = 3.89711431702997 * sp[33] + 0.8660254037844354 * sp[34] + 0.8660254037844459 * sp[28] + -1.732050807568876 * sp[31] + -1.299038105676654 * sp[34] + -0.2165063509460623 * sp[35] + -2.814582562299338 * sp[29] + -1.732050807568808 * sp[32] + 9.09326673973664 * sp[28] + 0.6495190528383139 * sp[29] + 8.443747686898329 * sp[26] + -1.732050807568871 * sp[27] + -1.299038105676636 * sp[31] + -0.4330127018921797 * sp[32] + -2.165063509461013 * sp[27] + -3.897114317029934 * sp[30];
    A[89] = -10.41666666666663 * sp[33] + -3.333333333333329 * sp[34] + -6.333333333333291 * sp[28] + 0.1666666666666898 * sp[31] + 20.41666666666674 * sp[34] + 8.541666666666767 * sp[35] + 12.04166666666666 * sp[29] + 0.1666666666668211 * sp[32] + -19.58333333333333 * sp[28] + -5.624999999999995 * sp[29] + -12.12500000000001 * sp[26] + 0.1666666666667 * sp[27] + 20.41666666666676 * sp[31] + 6.25000000000016 * sp[32] + 15.24999999999999 * sp[27] + -12.91666666666651 * sp[30];
    A[90] = -1.091666666666676 * sp[33] + -0.7333333333333433 * sp[34] + 2.133333333333347 * sp[28] + 1.149999999999999 * sp[31] + -1.108333333333344 * sp[34] + -0.3624999999999935 * sp[35] + 1.154166666666652 * sp[29] + 1.116666666666656 * sp[32] + -1.108333333333336 * sp[28] + -1.479166666666683 * sp[29] + 3.170833333333348 * sp[26] + 1.149999999999999 * sp[27] + -1.108333333333336 * sp[31] + -1.10833333333334 * sp[32] + 2.191666666666667 * sp[27] + 1.008333333333328 * sp[30];
    A[91] = 0.1833333333333408 * sp[33] + -0.1166666666666625 * sp[34] + -0.6833333333333449 * sp[28] + 0.9500000000000004 * sp[31] + -0.03333333333332283 * sp[34] + -0.8583333333333498 * sp[35] + 0.1083333333333365 * sp[29] + -0.3166666666666911 * sp[32] + -0.03333333333333777 * sp[28] + 0.7083333333333525 * sp[29] + -1.258333333333348 * sp[26] + 0.9500000000000076 * sp[27] + -0.0333333333333346 * sp[31] + -0.03333333333332855 * sp[32] + -0.4666666666666709 * sp[27] + 0.06666666666666277 * sp[30];
    A[92] = -0.5083333333333322 * sp[33] + 0.2666666666666709 * sp[34] + 0.4666666666666728 * sp[28] + 0.6500000000000031 * sp[31] + -0.6916666666666642 * sp[34] + 1.095833333333349 * sp[35] + 0.112500000000002 * sp[29] + 2.283333333333359 * sp[32] + -0.6916666666666702 * sp[28] + -1.520833333333345 * sp[29] + 1.295833333333342 * sp[26] + 0.649999999999998 * sp[27] + -0.6916666666666681 * sp[31] + -0.6916666666666658 * sp[32] + 0.9416666666666709 * sp[27] + 1.591666666666676 * sp[30];
    A[93] = 1.508333333333335 * sp[33] + 0.7750000000000016 * sp[34] + 4.308333333333329 * sp[28] + 2.591666666666663 * sp[31] + 1.816666666666665 * sp[34] + 0.3208333333333232 * sp[35] + 7.504166666666663 * sp[29] + 4.308333333333326 * sp[32] + 1.816666666666672 * sp[28] + 2.270833333333342 * sp[29] + 0.3208333333333393 * sp[26] + 0.7750000000000072 * sp[27] + 1.816666666666668 * sp[31] + 1.816666666666667 * sp[32] + 1.81666666666667 * sp[27] + 1.508333333333336 * sp[30];
    A[94] = -1.016666666666662 * sp[33] + 0.03333333333334093 * sp[34] + -2.866666666666656 * sp[28] + -3.933333333333317 * sp[31] + -1.383333333333326 * sp[34] + 0.9416666666666856 * sp[35] + -5.258333333333317 * sp[29] + -7.533333333333323 * sp[32] + -1.383333333333339 * sp[28] + -2.291666666666676 * sp[29] + -0.2250000000000022 * sp[26] + -1.133333333333337 * sp[27] + -1.383333333333334 * sp[31] + -1.38333333333333 * sp[32] + -1.383333333333333 * sp[27] + -2.600000000000002 * sp[30];
    A[95] = 0.09166666666666987 * sp[33] + -0.3083333333333351 * sp[34] + 0.5583333333333337 * sp[28] + 1.341666666666662 * sp[31] + -0.01666666666666167 * sp[34] + -1.054166666666686 * sp[35] + 0.9625000000000054 * sp[29] + 3.224999999999992 * sp[32] + -0.01666666666666947 * sp[28] + 0.7291666666666813 * sp[29] + -0.3875000000000088 * sp[26] + 0.3583333333333494 * sp[27] + -0.01666666666666779 * sp[31] + -0.01666666666666572 * sp[32] + -0.0166666666666706 * sp[27] + 1.091666666666677 * sp[30];
    A[96] = 3.683333333333333 * sp[33] + 5.50833333333332 * sp[34] + 1.50833333333334 * sp[28] + 2.275000000000001 * sp[31] + 5.50833333333332 * sp[34] + 10.04166666666667 * sp[35] + 1.008333333333327 * sp[29] + 3.24166666666667 * sp[32] + 1.50833333333334 * sp[28] + 1.008333333333327 * sp[29] + 2.775000000000009 * sp[26] + 2.275000000000001 * sp[27] + 2.275000000000001 * sp[31] + 3.24166666666667 * sp[32] + 2.275000000000001 * sp[27] + 2.633333333333336 * sp[30];
    A[97] = -5.866666666666672 * sp[33] + -3.433333333333326 * sp[34] + -2.766666666666679 * sp[28] + -2.299999999999997 * sp[31] + -7.933333333333313 * sp[34] + -5.083333333333316 * sp[35] + -1.683333333333312 * sp[29] + -2.233333333333314 * sp[32] + -2.600000000000015 * sp[28] + -0.6833333333333333 * sp[29] + -4.216666666666682 * sp[26] + -2.300000000000001 * sp[27] + -3.133333333333335 * sp[31] + -1.399999999999995 * sp[32] + -3.133333333333332 * sp[27] + -2.016666666666661 * sp[30];
    A[98] = 2.183333333333341 * sp[33] + -0.2416666666666654 * sp[34] + 1.091666666666677 * sp[28] + -0.4750000000000017 * sp[31] + 2.424999999999995 * sp[34] + 1.625000000000024 * sp[35] + 0.2583333333333256 * sp[29] + 0.1583333333333438 * sp[32] + 1.091666666666675 * sp[28] + -1.075 * sp[29] + 1.691666666666679 * sp[26] + -0.475000000000006 * sp[27] + 0.8583333333333343 * sp[31] + 0.1583333333333449 * sp[32] + 0.8583333333333353 * sp[27] + -0.03333333333333299 * sp[30];
    A[99] = -4.006938426723773 * sp[33] + -6.835365551469948 * sp[34] + 5.892556509887899 * sp[28] + 9.19238815542511 * sp[31] + -5.185449728701339 * sp[34] + -18.97403196183912 * sp[35] + 5.067598598503542 * sp[29] + 5.421151989096739 * sp[32] + -5.18544972870138 * sp[28] + -4.360491817317049 * sp[29] + 8.367430244040817 * sp[26] + 9.192388155425137 * sp[27] + -5.185449728701366 * sp[31] + -10.84230397819378 * sp[32] + 7.542472332656491 * sp[27] + 5.892556509887863 * sp[30];
    A[100] = 2.742413778650671 * sp[33] + 17.89785834487831 * sp[34] + 10.96965511460291 * sp[28] + 19.91858428704208 * sp[31] + 0.7216878364868595 * sp[34] + 24.75389279150504 * sp[35] + 9.165435523385247 * sp[29] + 19.34123401785232 * sp[32] + 0.7216878364870318 * sp[28] + 2.525907427704574 * sp[29] + 18.11436469582452 * sp[26] + 19.91858428704212 * sp[27] + 0.721687836486995 * sp[31] + 5.051814855409167 * sp[32] + 16.31014510460691 * sp[27] + 17.46484564298615 * sp[30];
    A[101] = -1.083333333333295 * sp[33] + 12.16666666666668 * sp[34] + -1.833333333333324 * sp[28] + 2.00000000000003 * sp[31] + -2.416666666666613 * sp[34] + 27.9583333333334 * sp[35] + -2.041666666666615 * sp[29] + 14.33333333333356 * sp[32] + -2.416666666666679 * sp[28] + -2.208333333333316 * sp[29] + 1.791666666666686 * sp[26] + 1.999999999999991 * sp[27] + -2.416666666666663 * sp[31] + 8.08333333333341 * sp[32] + 1.583333333333361 * sp[27] + 9.416666666666751 * sp[30];
    A[102] = 2.357022603955125 * sp[33] + 0.2357022603954859 * sp[34] + -11.07800623858929 * sp[28] + -7.778174593052075 * sp[31] + 4.006938426723721 * sp[34] + -0.2357022603955108 * sp[35] + -12.9636243217534 * sp[29] + -8.720983634634067 * sp[32] + 4.006938426723793 * sp[28] + 4.478342947514772 * sp[29] + -8.249579113843067 * sp[26] + -7.778174593052103 * sp[27] + 4.006938426723774 * sp[31] + 4.006938426723748 * sp[32] + -8.720983634634091 * sp[27] + -7.542472332656549 * sp[30];
    A[103] = 10.3923048454133 * sp[33] + 7.361215932167798 * sp[34] + 7.361215932167699 * sp[28] + -6.495190528383224 * sp[31] + 11.69134295108996 * sp[34] + 6.062177826491066 * sp[35] + 12.99038105676656 * sp[29] + -8.227241335952124 * sp[32] + 11.69134295108994 * sp[28] + 12.99038105676666 * sp[29] + -7.794228634059939 * sp[26] + -6.495190528383203 * sp[27] + 11.69134295108993 * sp[31] + 11.69134295108996 * sp[32] + -3.897114317029964 * sp[27] + -6.062177826491002 * sp[30];
    A[104] = 4.166666666666622 * sp[33] + 0.4166666666666279 * sp[34] + 8.416666666666661 * sp[28] + 2.749999999999959 * sp[31] + 7.083333333333255 * sp[34] + -0.4166666666666474 * sp[35] + 13.58333333333326 * sp[29] + -8.916666666666881 * sp[32] + 7.083333333333394 * sp[28] + 7.916666666666629 * sp[29] + 1.916666666666736 * sp[26] + 2.749999999999971 * sp[27] + 7.083333333333357 * sp[31] + 7.083333333333307 * sp[32] + 3.083333333333357 * sp[27] + -3.333333333333438 * sp[30];
    A[105] = 2.600000000000013 * sp[33] + 1.466666666666684 * sp[34] + -4.933333333333361 * sp[28] + -2.13333333333333 * sp[31] + 1.216666666666669 * sp[34] + 0.3083333333333398 * sp[35] + -1.05833333333333 * sp[29] + -0.8999999999999959 * sp[32] + 1.216666666666669 * sp[28] + 2.375000000000027 * sp[29] + -7.258333333333377 * sp[26] + -2.133333333333333 * sp[27] + 1.216666666666664 * sp[31] + 1.216666666666679 * sp[32] + -3.383333333333338 * sp[27] + -1.266666666666661 * sp[30];
    A[106] = -1.200000000000005 * sp[33] + -0.9333333333333407 * sp[34] + 2.533333333333359 * sp[28] + -3.066666666666677 * sp[31] + -0.433333333333333 * sp[34] + 0.2166666666666593 * sp[35] + 0.2833333333333371 * sp[29] + -1.199999999999989 * sp[32] + -0.4333333333333331 * sp[28] + -1.583333333333354 * sp[29] + 3.683333333333369 * sp[26] + -3.066666666666687 * sp[27] + -0.4333333333333288 * sp[31] + -0.4333333333333461 * sp[32] + 1.433333333333343 * sp[27] + -1.633333333333332 * sp[30];
    A[107] = 0.6000000000000014 * sp[33] + 0.1333333333333391 * sp[34] + -0.9333333333333476 * sp[28] + 0.5333333333333333 * sp[31] + 0.3833333333333344 * sp[34] + -0.4416666666666617 * sp[35] + -0.1416666666666712 * sp[29] + 0.09999999999999287 * sp[32] + 0.3833333333333326 * sp[28] + 0.9583333333333376 * sp[29] + -1.675000000000012 * sp[26] + 0.5333333333333444 * sp[27] + 0.383333333333334 * sp[31] + 0.3833333333333388 * sp[32] + -0.8833333333333381 * sp[27] + 0.06666666666666543 * sp[30];
    A[108] = -2.600000000000008 * sp[33] + -1.133333333333346 * sp[34] + -7.533333333333331 * sp[28] + -3.933333333333339 * sp[31] + -1.383333333333334 * sp[34] + -0.2250000000000022 * sp[35] + -5.258333333333328 * sp[29] + -2.866666666666664 * sp[32] + -1.383333333333333 * sp[28] + -2.29166666666668 * sp[29] + 0.9416666666666754 * sp[26] + 0.03333333333333127 * sp[27] + -1.383333333333332 * sp[31] + -1.383333333333338 * sp[32] + -1.383333333333327 * sp[27] + -1.016666666666667 * sp[30];
    A[109] = 1.200000000000001 * sp[33] + 0.2666666666666715 * sp[34] + 3.733333333333321 * sp[28] + 5.866666666666651 * sp[31] + 0.7666666666666671 * sp[34] + -0.3833333333333306 * sp[35] + 3.01666666666666 * sp[29] + 3.733333333333324 * sp[32] + 0.7666666666666639 * sp[28] + 1.416666666666667 * sp[29] + -0.3833333333333396 * sp[26] + 0.2666666666666573 * sp[27] + 0.7666666666666666 * sp[31] + 0.766666666666669 * sp[32] + 0.7666666666666629 * sp[27] + 1.199999999999994 * sp[30];
    A[110] = -0.6000000000000009 * sp[33] + -0.4666666666666681 * sp[34] + -1.533333333333326 * sp[28] + -1.933333333333325 * sp[31] + -0.2166666666666659 * sp[34] + 0.3583333333333287 * sp[35] + -1.008333333333329 * sp[29] + -0.8666666666666683 * sp[32] + -0.2166666666666654 * sp[28] + -1.041666666666677 * sp[29] + 0.5250000000000143 * sp[26] + -0.3000000000000083 * sp[27] + -0.2166666666666635 * sp[31] + -0.2166666666666746 * sp[32] + -0.2166666666666569 * sp[27] + -0.1833333333333423 * sp[30];
    A[111] = -5.866666666666672 * sp[33] + -7.933333333333313 * sp[34] + -2.600000000000015 * sp[28] + -3.133333333333335 * sp[31] + -3.433333333333326 * sp[34] + -5.083333333333316 * sp[35] + -0.6833333333333333 * sp[29] + -1.399999999999995 * sp[32] + -2.766666666666679 * sp[28] + -1.683333333333312 * sp[29] + -4.216666666666682 * sp[26] + -3.133333333333332 * sp[27] + -2.299999999999997 * sp[31] + -2.233333333333314 * sp[32] + -2.300000000000001 * sp[27] + -2.016666666666661 * sp[30];
    A[112] = 11.73333333333335 * sp[33] + 5.866666666666655 * sp[34] + 5.866666666666696 * sp[28] + 4.266666666666661 * sp[31] + 5.866666666666655 * sp[34] + 3.833333333333321 * sp[35] + 1.36666666666666 * sp[29] + 1.799999999999988 * sp[32] + 5.866666666666696 * sp[28] + 1.36666666666666 * sp[29] + 8.766666666666712 * sp[26] + 4.26666666666667 * sp[27] + 4.266666666666661 * sp[31] + 1.799999999999988 * sp[32] + 4.26666666666667 * sp[27] + 2.533333333333323 * sp[30];
    A[113] = -5.86666666666668 * sp[33] + 2.066666666666681 * sp[34] + -3.266666666666691 * sp[28] + 1.533333333333347 * sp[31] + -2.43333333333333 * sp[34] + 0.4166666666666587 * sp[35] + -0.5166666666666676 * sp[29] + 0.5999999999999955 * sp[32] + -3.100000000000016 * sp[28] + 3.150000000000014 * sp[29] + -4.716666666666701 * sp[26] + 1.533333333333351 * sp[27] + -1.966666666666664 * sp[31] + 1.433333333333328 * sp[32] + -1.966666666666673 * sp[27] + 0.8166666666666687 * sp[30];
    A[114] = 5.656854249492401 * sp[33] + 1.885618083164116 * sp[34] + -9.428090415820645 * sp[28] + -20.74179891480541 * sp[31] + 3.299831645537233 * sp[34] + 2.592724864350692 * sp[35] + -3.06412938514168 * sp[29] + -8.485281374238507 * sp[32] + 3.299831645537228 * sp[28] + -3.064129385141749 * sp[29] + -14.3778378841265 * sp[26] + -20.74179891480546 * sp[27] + 3.299831645537231 * sp[31] + 0.4714045207910398 * sp[32] + -8.01387685344752 * sp[27] + -11.78511301977575 * sp[30];
    A[115] = 10.39230484541329 * sp[33] + -30.02221399786044 * sp[34] + -16.16580753730958 * sp[28] + -36.95041722813607 * sp[31] + -1.443375672974019 * sp[34] + -19.19689645055493 * sp[35] + -5.34048999000402 * sp[29] + -15.5884572681198 * sp[32] + -1.443375672974115 * sp[28] + -12.26869322027948 * sp[29] + -26.12509968083061 * sp[26] + -36.95041722813611 * sp[27] + -1.443375672974077 * sp[31] + -10.10362971081835 * sp[32] + -15.29978213352506 * sp[27] + -21.93931022920571 * sp[30];
    A[116] = -2.000000000000027 * sp[33] + -2.666666666666622 * sp[34] + 5.333333333333316 * sp[28] + 9.333333333333313 * sp[31] + -0.1666666666666705 * sp[34] + -8.416666666666659 * sp[35] + 1.583333333333294 * sp[29] + 2.999999999999931 * sp[32] + -0.1666666666666821 * sp[28] + 3.583333333333314 * sp[29] + 5.583333333333375 * sp[26] + 9.333333333333401 * sp[27] + -0.1666666666666597 * sp[31] + -1.166666666666694 * sp[32] + 1.833333333333319 * sp[27] + 3.666666666666637 * sp[30];
    A[117] = 1.885618083164133 * sp[34] + 24.5130350811337 * sp[28] + 13.19932658214896 * sp[31] + -0.9428090415820651 * sp[34] + 0.471404520791042 * sp[35] + 11.78511301977579 * sp[29] + 5.656854249492399 * sp[32] + -0.9428090415820478 * sp[28] + 0.4714045207910968 * sp[29] + 11.7851130197758 * sp[26] + 13.19932658214902 * sp[27] + -0.9428090415820723 * sp[31] + -0.9428090415820312 * sp[32] + 10.37089945740266 * sp[27] + 8.013876853447586 * sp[30];
    A[118] = -20.78460969082659 * sp[33] + -10.3923048454134 * sp[34] + -10.39230484541322 * sp[28] + 17.32050807568866 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137787 * sp[35] + -17.32050807568876 * sp[29] + 3.464101615137664 * sp[32] + -10.39230484541326 * sp[28] + -17.32050807568893 * sp[29] + 24.24871130596438 * sp[26] + 17.32050807568865 * sp[27] + -10.39230484541324 * sp[31] + -10.39230484541332 * sp[32] + 3.464101615137778 * sp[27] + 7.794228634059823 * sp[30];
    A[119] = 3.333333333333316 * sp[34] + -12.66666666666672 * sp[28] + -4.666666666666691 * sp[31] + -1.666666666666682 * sp[34] + 0.8333333333333384 * sp[35] + -7.166666666666662 * sp[29] + -7.999999999999941 * sp[32] + -1.666666666666676 * sp[28] + 0.8333333333334156 * sp[29] + -7.166666666666796 * sp[26] + -4.666666666666678 * sp[27] + -1.666666666666705 * sp[31] + -1.666666666666628 * sp[32] + -3.666666666666718 * sp[27] + -5.833333333333286 * sp[30];
    A[120] = -1.508333333333341 * sp[33] + -0.7333333333333399 * sp[34] + 2.800000000000014 * sp[28] + 0.9833333333333304 * sp[31] + 0.3083333333333466 * sp[34] + 0.7625000000000095 * sp[35] + -2.887500000000014 * sp[29] + -0.7166666666666662 * sp[32] + 0.3083333333333338 * sp[28] + -1.187500000000012 * sp[29] + 4.295833333333366 * sp[26] + 0.9833333333333369 * sp[27] + 0.3083333333333445 * sp[31] + 0.3083333333333416 * sp[32] + -1.391666666666682 * sp[27] + -0.4083333333333354 * sp[30];
    A[121] = 1.01666666666667 * sp[33] + 1.049999999999998 * sp[34] + -1.850000000000012 * sp[28] + 2.116666666666678 * sp[31] + -0.3666666666666852 * sp[34] + -1.275000000000007 * sp[35] + 2.025000000000009 * sp[29] + -2.483333333333339 * sp[32] + -0.366666666666668 * sp[28] + 1.958333333333343 * sp[29] + -3.008333333333359 * sp[26] + 2.116666666666679 * sp[27] + -0.3666666666666785 * sp[31] + -0.3666666666666708 * sp[32] + 0.8666666666666751 * sp[27] + -1.266666666666671 * sp[30];
    A[122] = -0.09166666666666737 * sp[33] + -0.4000000000000029 * sp[34] + 0.4666666666666731 * sp[28] + -1.183333333333337 * sp[31] + -0.108333333333341 * sp[34] + 0.637499999999991 * sp[35] + -0.5124999999999981 * sp[29] + 2.116666666666679 * sp[32] + -0.1083333333333335 * sp[28] + -1.14583333333334 * sp[29] + 0.8375000000000095 * sp[26] + -1.18333333333334 * sp[27] + -0.1083333333333365 * sp[31] + -0.1083333333333367 * sp[32] + -0.1416666666666683 * sp[27] + 1.008333333333337 * sp[30];
    A[123] = 1.091666666666673 * sp[33] + 0.358333333333342 * sp[34] + 3.225000000000004 * sp[28] + 1.341666666666675 * sp[31] + -0.01666666666666317 * sp[34] + -0.3874999999999983 * sp[35] + 0.9625000000000037 * sp[29] + 0.5583333333333432 * sp[32] + -0.01666666666666616 * sp[28] + 0.7291666666666771 * sp[29] + -1.054166666666672 * sp[26] + -0.3083333333333296 * sp[27] + -0.01666666666666879 * sp[31] + -0.01666666666667013 * sp[32] + -0.01666666666666437 * sp[27] + 0.09166666666667204 * sp[30];
    A[124] = -0.1833333333333353 * sp[33] + -0.3000000000000048 * sp[34] + -0.8666666666666649 * sp[28] + -1.93333333333333 * sp[31] + -0.2166666666666821 * sp[34] + 0.524999999999986 * sp[35] + -1.008333333333349 * sp[29] + -1.533333333333357 * sp[32] + -0.216666666666667 * sp[28] + -1.041666666666673 * sp[29] + 0.3583333333333355 * sp[26] + -0.4666666666666712 * sp[27] + -0.2166666666666731 * sp[31] + -0.2166666666666711 * sp[32] + -0.2166666666666768 * sp[27] + -0.6000000000000124 * sp[30];
    A[125] = 0.5083333333333337 * sp[33] + 0.774999999999997 * sp[34] + 0.9749999999999981 * sp[28] + 0.591666666666658 * sp[31] + -0.1833333333333421 * sp[34] + -1.012500000000001 * sp[35] + 0.1708333333333206 * sp[29] + 0.9750000000000014 * sp[32] + -0.1833333333333336 * sp[28] + 1.604166666666673 * sp[29] + -1.012500000000011 * sp[26] + 0.7750000000000039 * sp[27] + -0.1833333333333388 * sp[31] + -0.1833333333333337 * sp[32] + -0.1833333333333409 * sp[27] + 0.5083333333333349 * sp[30];
    A[126] = 2.183333333333341 * sp[33] + 2.424999999999995 * sp[34] + 1.091666666666675 * sp[28] + 0.8583333333333343 * sp[31] + -0.2416666666666654 * sp[34] + 1.625000000000024 * sp[35] + -1.075 * sp[29] + 0.1583333333333449 * sp[32] + 1.091666666666677 * sp[28] + 0.2583333333333256 * sp[29] + 1.691666666666679 * sp[26] + 0.8583333333333353 * sp[27] + -0.4750000000000017 * sp[31] + 0.1583333333333438 * sp[32] + -0.475000000000006 * sp[27] + -0.03333333333333299 * sp[30];
    A[127] = -5.86666666666668 * sp[33] + -2.43333333333333 * sp[34] + -3.100000000000016 * sp[28] + -1.966666666666664 * sp[31] + 2.066666666666681 * sp[34] + 0.4166666666666587 * sp[35] + 3.150000000000014 * sp[29] + 1.433333333333328 * sp[32] + -3.266666666666691 * sp[28] + -0.5166666666666676 * sp[29] + -4.716666666666701 * sp[26] + -1.966666666666673 * sp[27] + 1.533333333333347 * sp[31] + 0.5999999999999955 * sp[32] + 1.533333333333351 * sp[27] + 0.8166666666666687 * sp[30];
    A[128] = 3.683333333333342 * sp[33] + -1.825000000000015 * sp[34] + 2.175000000000011 * sp[28] + -1.058333333333346 * sp[31] + -1.825000000000015 * sp[34] + 2.708333333333338 * sp[35] + -2.32500000000001 * sp[29] + 1.241666666666672 * sp[32] + 2.175000000000011 * sp[28] + -2.32500000000001 * sp[29] + 3.441666666666693 * sp[26] + -1.058333333333344 * sp[27] + -1.058333333333346 * sp[31] + 1.241666666666672 * sp[32] + -1.058333333333344 * sp[27] + 0.6333333333333372 * sp[30];
    A[129] = -1.649915822768622 * sp[33] + 4.949747468305838 * sp[34] + 3.535533905932752 * sp[28] + 11.5494107593803 * sp[31] + -0.4714045207910689 * sp[34] + -13.08147545195119 * sp[35] + -3.181980515339478 * sp[29] + -11.07800623858925 * sp[32] + -0.4714045207910336 * sp[28] + 6.246109900481186 * sp[29] + 4.831896338108105 * sp[26] + 11.54941075938033 * sp[27] + -0.4714045207910431 * sp[31] + -6.128258770283437 * sp[32] + -1.885618083164153 * sp[27] + -5.892556509887918 * sp[30];
    A[130] = -13.13471862406397 * sp[33] + 12.12435565298213 * sp[34] + 5.196152422706676 * sp[28] + 17.031832941094 * sp[31] + -0.7216878364868751 * sp[34] + -6.278684177437055 * sp[35] + -4.546633369868301 * sp[29] + -12.41303078757691 * sp[32] + -0.7216878364869785 * sp[28] + 9.021097956087893 * sp[29] + 7.28904714851907 * sp[26] + 17.03183294109403 * sp[27] + -0.721687836486921 * sp[31] + -5.051814855409154 * sp[32] + -2.45373864405595 * sp[27] + -7.072540797572936 * sp[30];
    A[131] = 3.083333333333346 * sp[33] + -9.500000000000039 * sp[34] + -3.500000000000001 * sp[28] + -11.33333333333335 * sp[31] + -1.583333333333423 * sp[34] + 13.37500000000008 * sp[35] + 3.37500000000006 * sp[29] + 17.66666666666675 * sp[32] + -1.583333333333336 * sp[28] + -8.458333333333348 * sp[29] + -4.458333333333362 * sp[26] + -11.33333333333339 * sp[27] + -1.583333333333384 * sp[31] + 3.916666666666721 * sp[32] + 2.416666666666698 * sp[27] + 8.583333333333364 * sp[30];
    A[132] = -2.357022603955167 * sp[33] + -2.121320343559626 * sp[34] + -13.43502884254444 * sp[28] + -5.421151989096892 * sp[31] + 1.649915822768711 * sp[34] + 2.121320343559709 * sp[35] + 3.535533905932812 * sp[29] + 3.064129385141744 * sp[32] + 1.649915822768613 * sp[28] + -2.592724864350687 * sp[29] + -1.178511301977574 * sp[26] + -5.42115198909693 * sp[27] + 1.649915822768665 * sp[31] + 1.649915822768639 * sp[32] + 3.064129385141774 * sp[27] + 1.885618083164162 * sp[30];
    A[133] = 10.39230484541331 * sp[33] + 3.031088913245604 * sp[34] + 3.031088913245541 * sp[28] + -10.82531754730544 * sp[31] + -1.299038105676684 * sp[34] + -2.598076211353357 * sp[35] + 4.330127018922288 * sp[29] + 4.763139720814402 * sp[32] + -1.299038105676679 * sp[28] + 4.330127018922273 * sp[29] + -16.45448267190442 * sp[26] + -10.82531754730545 * sp[27] + -1.299038105676709 * sp[31] + -1.29903810567671 * sp[32] + 0.4330127018923056 * sp[27] + 2.598076211353337 * sp[30];
    A[134] = -4.166666666666664 * sp[33] + -3.749999999999958 * sp[34] + 4.250000000000028 * sp[28] + 1.916666666666735 * sp[31] + 2.916666666666828 * sp[34] + 3.750000000000103 * sp[35] + -2.249999999999952 * sp[29] + -13.08333333333324 * sp[32] + 2.916666666666681 * sp[28] + -4.583333333333343 * sp[29] + 9.416666666666766 * sp[26] + 1.916666666666713 * sp[27] + 2.916666666666753 * sp[31] + 2.916666666666708 * sp[32] + -1.083333333333303 * sp[27] + -6.666666666666601 * sp[30];
    A[135] = 1.649915822768642 * sp[33] + 3.064129385141736 * sp[34] + -1.649915822768609 * sp[28] + -1.649915822768617 * sp[31] + 0.4714045207910367 * sp[34] + 1.767766952966342 * sp[35] + 5.067598598503628 * sp[29] + -0.235702260395505 * sp[32] + -5.185449728701348 * sp[28] + -3.889087296526057 * sp[29] + 10.72445284799601 * sp[26] + 4.006938426723753 * sp[27] + -5.185449728701377 * sp[31] + -5.185449728701422 * sp[32] + 17.44196726926823 * sp[27] + 5.892556509887884 * sp[30];
    A[136] = 3.771236166328257 * sp[33] + -3.771236166328294 * sp[34] + 0.9428090415820654 * sp[28] + 0.9428090415820742 * sp[31] + 6.128258770283434 * sp[34] + 1.178511301977597 * sp[35] + -5.421151989096876 * sp[29] + 12.25651754056685 * sp[32] + 3.299831645537218 * sp[28] + -1.64991582276857 * sp[29] + -2.592724864350711 * sp[26] + 3.771236166328281 * sp[27] + 3.299831645537247 * sp[31] + 3.299831645537283 * sp[32] + -8.956685895029661 * sp[27] + 11.7851130197758 * sp[30];
    A[137] = 4.006938426723789 * sp[33] + 10.13519719700723 * sp[34] + -4.006938426723801 * sp[28] + -4.00693842672379 * sp[31] + 5.18544972870137 * sp[34] + 7.66032346285428 * sp[35] + -3.181980515339487 * sp[29] + -16.73486048808169 * sp[32] + -0.4714045207910283 * sp[28] + 2.003469213361889 * sp[29] + 2.474873734152924 * sp[26] + 1.649915822768594 * sp[27] + -0.471404520791022 * sp[31] + -0.4714045207910425 * sp[32] + 3.299831645537242 * sp[27] + -5.892556509887912 * sp[30];
    A[138] = -7.542472332656545 * sp[33] + -7.778174593052048 * sp[34] + -8.720983634634123 * sp[28] + -7.778174593052052 * sp[31] + -8.720983634634106 * sp[34] + -8.249579113843033 * sp[35] + -12.96362432175341 * sp[29] + -11.07800623858927 * sp[32] + 4.006938426723762 * sp[28] + 4.478342947514811 * sp[29] + -0.2357022603955286 * sp[26] + 0.2357022603955121 * sp[27] + 4.006938426723769 * sp[31] + 4.006938426723802 * sp[32] + 4.006938426723734 * sp[27] + 2.357022603955139 * sp[30];
    A[139] = 8.013876853447572 * sp[33] + 13.19932658214894 * sp[34] + 5.656854249492383 * sp[28] + 13.19932658214891 * sp[31] + 10.37089945740273 * sp[34] + 11.7851130197758 * sp[35] + 11.7851130197758 * sp[29] + 24.51303508113372 * sp[32] + -0.9428090415820529 * sp[28] + 0.4714045207910482 * sp[29] + 0.471404520791042 * sp[26] + 1.885618083164166 * sp[27] + -0.9428090415820395 * sp[31] + -0.9428090415820611 * sp[32] + -0.9428090415820127 * sp[27];
    A[140] = 1.885618083164125 * sp[33] + -5.421151989096908 * sp[34] + 3.064129385141715 * sp[28] + -5.421151989096912 * sp[31] + 3.064129385141711 * sp[34] + -1.178511301977574 * sp[35] + 3.535533905932757 * sp[29] + -13.43502884254444 * sp[32] + 1.649915822768602 * sp[28] + -2.592724864350657 * sp[29] + 2.121320343559625 * sp[26] + -2.121320343559627 * sp[27] + 1.649915822768618 * sp[31] + 1.649915822768643 * sp[32] + 1.649915822768603 * sp[27] + -2.35702260395514 * sp[30];
    A[141] = -4.006938426723773 * sp[33] + -5.185449728701339 * sp[34] + -5.18544972870138 * sp[28] + -5.185449728701366 * sp[31] + -6.835365551469948 * sp[34] + -18.97403196183912 * sp[35] + -4.360491817317049 * sp[29] + -10.84230397819378 * sp[32] + 5.892556509887899 * sp[28] + 5.067598598503542 * sp[29] + 8.367430244040817 * sp[26] + 7.542472332656491 * sp[27] + 9.19238815542511 * sp[31] + 5.421151989096739 * sp[32] + 9.192388155425137 * sp[27] + 5.892556509887863 * sp[30];
    A[142] = 5.656854249492401 * sp[33] + 3.299831645537233 * sp[34] + 3.299831645537228 * sp[28] + 3.299831645537231 * sp[31] + 1.885618083164116 * sp[34] + 2.592724864350692 * sp[35] + -3.064129385141749 * sp[29] + 0.4714045207910398 * sp[32] + -9.428090415820645 * sp[28] + -3.06412938514168 * sp[29] + -14.3778378841265 * sp[26] + -8.01387685344752 * sp[27] + -20.74179891480541 * sp[31] + -8.485281374238507 * sp[32] + -20.74179891480546 * sp[27] + -11.78511301977575 * sp[30];
    A[143] = -1.649915822768622 * sp[33] + -0.4714045207910689 * sp[34] + -0.4714045207910336 * sp[28] + -0.4714045207910431 * sp[31] + 4.949747468305838 * sp[34] + -13.08147545195119 * sp[35] + 6.246109900481186 * sp[29] + -6.128258770283437 * sp[32] + 3.535533905932752 * sp[28] + -3.181980515339478 * sp[29] + 4.831896338108105 * sp[26] + -1.885618083164153 * sp[27] + 11.5494107593803 * sp[31] + -11.07800623858925 * sp[32] + 11.54941075938033 * sp[27] + -5.892556509887918 * sp[30];
    A[144] = 26.66666666666683 * sp[33] + 33.33333333333348 * sp[34] + -6.666666666666671 * sp[28] + -6.666666666666648 * sp[31] + 33.33333333333348 * sp[34] + 113.3333333333337 * sp[35] + -6.666666666666559 * sp[29] + 33.33333333333343 * sp[32] + -6.666666666666671 * sp[28] + -6.666666666666559 * sp[29] + 33.33333333333331 * sp[26] + 33.33333333333336 * sp[27] + -6.666666666666648 * sp[31] + 33.33333333333343 * sp[32] + 33.33333333333336 * sp[27] + 66.66666666666659 * sp[30];
    A[145] = 4.082482904638768 * sp[33] + -4.082482904638428 * sp[34] + -28.57738033247054 * sp[28] + -28.57738033247043 * sp[31] + 8.164965809277405 * sp[34] + 14.28869016623505 * sp[35] + -34.70110468942826 * sp[29] + -4.082482904638713 * sp[32] + 8.164965809277291 * sp[28] + 14.28869016623504 * sp[29] + 63.27848502189871 * sp[26] + 69.40220937885665 * sp[27] + 8.164965809276971 * sp[31] + 57.15476066494016 * sp[32] + 57.15476066494086 * sp[27] + 102.0620726159655 * sp[30];
    A[146] = 25.92724864350678 * sp[33] + 16.4991582276861 * sp[34] + -25.92724864350699 * sp[28] + -25.92724864350689 * sp[31] + 37.71236166328263 * sp[34] + -64.81812160876714 * sp[35] + -36.53385036130527 * sp[29] + -124.9221980096239 * sp[32] + 9.428090415820661 * sp[28] + 20.03469213361894 * sp[29] + -8.249579113843108 * sp[26] + 2.357022603955095 * sp[27] + 9.428090415820785 * sp[31] + -18.85618083164141 * sp[32] + -18.85618083164132 * sp[27] + -58.92556509887901 * sp[30];
    A[147] = -33.33333333333346 * sp[33] + -26.66666666666671 * sp[34] + 13.33333333333349 * sp[28] + 13.33333333333351 * sp[31] + -46.66666666666686 * sp[34] + -36.66666666666681 * sp[35] + 3.333333333333339 * sp[29] + 13.33333333333331 * sp[32] + -6.666666666666704 * sp[28] + 3.333333333333156 * sp[29] + -36.66666666666664 * sp[26] + -26.66666666666686 * sp[27] + -6.666666666666829 * sp[31] + -6.666666666666872 * sp[32] + -46.66666666666677 * sp[27] + -33.33333333333361 * sp[30];
    A[148] = -36.74234614174783 * sp[33] + -24.49489742783197 * sp[34] + -24.49489742783202 * sp[28] + -36.7423461417477 * sp[34] + -30.6186217847896 * sp[35] + -6.12372435695827 * sp[29] + 36.74234614174767 * sp[28] + 42.86607049870583 * sp[29] + -30.61862178478979 * sp[26] + -24.49489742783146 * sp[27] + 36.74234614174776 * sp[31] + 36.74234614174806 * sp[32] + -12.24744871391624 * sp[27] + -36.74234614174724 * sp[30];
    A[149] = -58.92556509887916 * sp[33] + -47.14045207910325 * sp[34] + -18.85618083164122 * sp[28] + -4.714045207910209 * sp[31] + -82.4957911384308 * sp[34] + -64.81812160876706 * sp[35] + -22.39171473757398 * sp[29] + 80.13876853447569 * sp[32] + -11.78511301977576 * sp[28] + 5.892556509887655 * sp[29] + -8.24957911384289 * sp[26] + 9.428090415820545 * sp[27] + -11.78511301977596 * sp[31] + -11.78511301977606 * sp[32] + 16.49915822768617 * sp[27] + 54.21151989096833 * sp[30];
    A[150] = 10.96965511460288 * sp[33] + 0.1443375672973224 * sp[34] + 0.721687836487088 * sp[28] + 0.7216878364870853 * sp[31] + 0.7216878364869684 * sp[34] + -1.732050807568891 * sp[35] + 11.54700538379248 * sp[29] + 5.051814855409198 * sp[32] + -10.53664241271069 * sp[28] + -8.660254037844483 * sp[29] + 18.47520861406807 * sp[26] + 7.649891066762516 * sp[27] + -10.53664241271072 * sp[31] + -10.53664241271078 * sp[32] + 29.30052616137358 * sp[27] + 10.96965511460285 * sp[30];
    A[151] = -8.948929172439154 * sp[33] + -3.175426480542799 * sp[34] + 1.44337567297402 * sp[28] + 1.443375672973947 * sp[31] + -1.443375672973966 * sp[34] + 2.02072594216368 * sp[35] + -7.216878364870325 * sp[29] + 10.10362971081831 * sp[32] + 3.752776749732555 * sp[28] + -1.44337567297396 * sp[29] + -3.752776749732631 * sp[26] + 4.90747728811187 * sp[27] + 3.752776749732602 * sp[31] + 3.752776749732656 * sp[32] + -12.41303078757704 * sp[27] + 14.14508159514582 * sp[30];
    A[152] = -0.577350269189601 * sp[33] + 4.474464586219614 * sp[34] + -0.7216878364870334 * sp[28] + -0.7216878364870114 * sp[31] + -0.7216878364869936 * sp[34] + 4.041451884327445 * sp[35] + -5.05181485540916 * sp[32] + -3.319764047840357 * sp[28] + -2.886751345948156 * sp[29] + 6.928203230275537 * sp[26] + 6.206515393788456 * sp[27] + -3.319764047840339 * sp[31] + -3.319764047840351 * sp[32] + 7.649891066762579 * sp[27] + -0.5773502691896075 * sp[30];
    A[153] = -5.917840259193724 * sp[33] + -0.8660254037844606 * sp[34] + -11.83568051838743 * sp[28] + -0.8660254037845663 * sp[31] + 0.7216878364869955 * sp[34] + -2.237232293109835 * sp[35] + 18.25870226312183 * sp[29] + 10.96965511460279 * sp[32] + 11.98001808568475 * sp[28] + 13.35122497501012 * sp[29] + 2.670244995002054 * sp[26] + 4.041451884327408 * sp[27] + 11.98001808568474 * sp[31] + 11.98001808568477 * sp[32] + 11.98001808568471 * sp[27] + 8.804591605141775 * sp[30];
    A[154] = -1.154700538379182 * sp[33] + 4.618802153517066 * sp[34] + -5.196152422706535 * sp[28] + 4.618802153517111 * sp[31] + -1.443375672973976 * sp[34] + 5.91784025919376 * sp[35] + -14.86676943163272 * sp[29] + -16.16580753730938 * sp[32] + -6.639528095680702 * sp[28] + -7.938566201357359 * sp[29] + -1.01036297108185 * sp[26] + -2.309401076758475 * sp[27] + -6.639528095680664 * sp[31] + -6.639528095680671 * sp[32] + -6.639528095680628 * sp[27] + -10.39230484541318 * sp[30];
    A[155] = -4.474464586219566 * sp[33] + -3.752776749732482 * sp[34] + -8.94892917243919 * sp[28] + -3.752776749732459 * sp[31] + -0.7216878364869816 * sp[34] + -0.07216878364874374 * sp[35] + 0.2165063509461638 * sp[29] + 5.196152422706615 * sp[32] + 1.876388374866269 * sp[28] + -1.804219591217515 * sp[29] + 1.948557158514958 * sp[26] + -1.732050807568803 * sp[27] + 1.876388374866293 * sp[31] + 1.876388374866321 * sp[32] + 1.876388374866267 * sp[27] + 1.587713240271536 * sp[30];
    A[156] = 2.742413778650671 * sp[33] + 0.7216878364868595 * sp[34] + 0.7216878364870318 * sp[28] + 0.721687836486995 * sp[31] + 17.89785834487831 * sp[34] + 24.75389279150504 * sp[35] + 2.525907427704574 * sp[29] + 5.051814855409167 * sp[32] + 10.96965511460291 * sp[28] + 9.165435523385247 * sp[29] + 18.11436469582452 * sp[26] + 16.31014510460691 * sp[27] + 19.91858428704208 * sp[31] + 19.34123401785232 * sp[32] + 19.91858428704212 * sp[27] + 17.46484564298615 * sp[30];
    A[157] = 10.39230484541329 * sp[33] + -1.443375672974019 * sp[34] + -1.443375672974115 * sp[28] + -1.443375672974077 * sp[31] + -30.02221399786044 * sp[34] + -19.19689645055493 * sp[35] + -12.26869322027948 * sp[29] + -10.10362971081835 * sp[32] + -16.16580753730958 * sp[28] + -5.34048999000402 * sp[29] + -26.12509968083061 * sp[26] + -15.29978213352506 * sp[27] + -36.95041722813607 * sp[31] + -15.5884572681198 * sp[32] + -36.95041722813611 * sp[27] + -21.93931022920571 * sp[30];
    A[158] = -13.13471862406397 * sp[33] + -0.7216878364868751 * sp[34] + -0.7216878364869785 * sp[28] + -0.721687836486921 * sp[31] + 12.12435565298213 * sp[34] + -6.278684177437055 * sp[35] + 9.021097956087893 * sp[29] + -5.051814855409154 * sp[32] + 5.196152422706676 * sp[28] + -4.546633369868301 * sp[29] + 7.28904714851907 * sp[26] + -2.45373864405595 * sp[27] + 17.031832941094 * sp[31] + -12.41303078757691 * sp[32] + 17.03183294109403 * sp[27] + -7.072540797572936 * sp[30];
    A[159] = 4.082482904638768 * sp[33] + 8.164965809277405 * sp[34] + 8.164965809277291 * sp[28] + 8.164965809276971 * sp[31] + -4.082482904638428 * sp[34] + 14.28869016623505 * sp[35] + 14.28869016623504 * sp[29] + 57.15476066494016 * sp[32] + -28.57738033247054 * sp[28] + -34.70110468942826 * sp[29] + 63.27848502189871 * sp[26] + 57.15476066494086 * sp[27] + -28.57738033247043 * sp[31] + -4.082482904638713 * sp[32] + 69.40220937885665 * sp[27] + 102.0620726159655 * sp[30];
    A[160] = 189.9999999999992 * sp[33] + 57.49999999999878 * sp[34] + 12.4999999999999 * sp[28] + 12.49999999999937 * sp[31] + 57.49999999999878 * sp[34] + 132.4999999999985 * sp[35] + 12.49999999999972 * sp[29] + 87.49999999999895 * sp[32] + 12.4999999999999 * sp[28] + 12.49999999999972 * sp[29] + 132.4999999999999 * sp[26] + 132.4999999999999 * sp[27] + 12.49999999999937 * sp[31] + 87.49999999999895 * sp[32] + 132.4999999999999 * sp[27] + 189.9999999999995 * sp[30];
    A[161] = -31.75426480542917 * sp[33] + 105.3664241271069 * sp[34] + -7.216878364870434 * sp[28] + -7.216878364870279 * sp[31] + -7.216878364869843 * sp[34] + 57.73502691896244 * sp[35] + -28.86751345948128 * sp[29] + -50.51814855409166 * sp[32] + 1.443375672974081 * sp[28] + 23.09401076758521 * sp[29] + 5.773502691896311 * sp[26] + 27.42413778650716 * sp[27] + 1.443375672974301 * sp[31] + 10.10362971081852 * sp[32] + -15.8771324027147 * sp[27] + -31.75426480542914 * sp[30];
    A[162] = 28.57738033247013 * sp[33] + -4.082482904639212 * sp[34] + 69.40220937885667 * sp[28] + -4.08248290463901 * sp[31] + 8.16496580927674 * sp[34] + -22.45365597551271 * sp[35] + -22.45365597551266 * sp[29] + -28.57738033247043 * sp[32] + 8.164965809277286 * sp[28] + 26.53613888015079 * sp[29] + -71.44345083117612 * sp[26] + -53.07227776030264 * sp[27] + 8.164965809277041 * sp[31] + 8.164965809276913 * sp[32] + -89.81462390205003 * sp[27] + -69.40220937885719 * sp[30];
    A[163] = -67.50000000000014 * sp[33] + 7.500000000000167 * sp[34] + 7.499999999999041 * sp[28] + 52.50000000000023 * sp[31] + 3.750000000000082 * sp[35] + 48.74999999999934 * sp[29] + -22.49999999999968 * sp[32] + 90.00000000000014 * sp[28] + 93.75000000000045 * sp[29] + -41.24999999999982 * sp[26] + -37.49999999999935 * sp[27] + 90.00000000000016 * sp[31] + 90.0000000000006 * sp[32] + -30.00000000000041 * sp[27] + -67.49999999999929 * sp[30];
    A[164] = 50.51814855409172 * sp[33] + -7.216878364871281 * sp[34] + 44.74464586219584 * sp[28] + 105.3664241271055 * sp[31] + 14.43375672973977 * sp[34] + -39.6928310067871 * sp[35] + 72.89047148518972 * sp[29] + 62.06515393788351 * sp[32] + 14.43375672974085 * sp[28] + 46.90970937165667 * sp[29] + -13.71206889325332 * sp[26] + 18.76388374866259 * sp[27] + 14.43375672974045 * sp[31] + 14.43375672974019 * sp[32] + 31.75426480542954 * sp[27] + 50.51814855409138 * sp[30];
    A[165] = -6.833333333333313 * sp[33] + 2.416666666666667 * sp[34] + 0.08333333333334944 * sp[28] + 0.0833333333333158 * sp[31] + 1.583333333333339 * sp[34] + 3.749999999999986 * sp[35] + -4.916666666666647 * sp[29] + 0.5833333333333499 * sp[32] + 0.08333333333332504 * sp[28] + -1.250000000000011 * sp[29] + -5.916666666666714 * sp[26] + -0.916666666666657 * sp[27] + 0.08333333333333304 * sp[31] + 0.08333333333338566 * sp[32] + -10.91666666666673 * sp[27] + -1.83333333333334 * sp[30];
    A[166] = 11.16666666666665 * sp[33] + -8.166666666666693 * sp[34] + 3.166666666666663 * sp[28] + 3.166666666666722 * sp[31] + 1.833333333333331 * sp[34] + -16.6666666666667 * sp[35] + 10.66666666666668 * sp[29] + -7.833333333333407 * sp[32] + -5.166666666666707 * sp[28] + 3.333333333333386 * sp[29] + 2.666666666666693 * sp[26] + -4.833333333333367 * sp[27] + -5.166666666666694 * sp[31] + -5.16666666666673 * sp[32] + 10.16666666666672 * sp[27] + -17.1666666666667 * sp[30];
    A[167] = 4.833333333333337 * sp[33] + 14.91666666666669 * sp[34] + -4.083333333333355 * sp[28] + -4.083333333333357 * sp[31] + 2.416666666666664 * sp[34] + 22.91666666666674 * sp[35] + -5.749999999999998 * sp[29] + 11.41666666666677 * sp[32] + -4.08333333333337 * sp[28] + -12.08333333333343 * sp[29] + 3.250000000000027 * sp[26] + 4.916666666666704 * sp[27] + -4.083333333333356 * sp[31] + -4.083333333333301 * sp[32] + 1.583333333333335 * sp[27] + 19.83333333333343 * sp[30];
    A[168] = -3.583333333333332 * sp[33] + -6.999999999999988 * sp[34] + -2.666666666666641 * sp[28] + -6.999999999999972 * sp[31] + -4.916666666666674 * sp[34] + -7.708333333333334 * sp[35] + 4.458333333333301 * sp[29] + 2.166666666666631 * sp[32] + 6.583333333333384 * sp[28] + 7.291666666666694 * sp[29] + 5.458333333333416 * sp[26] + 6.166666666666726 * sp[27] + 6.583333333333354 * sp[31] + 6.583333333333293 * sp[32] + 6.583333333333427 * sp[27] + 6.916666666666718 * sp[30];
    A[169] = 9.666666666666664 * sp[33] + 17.33333333333335 * sp[34] + 6.999999999999954 * sp[28] + 17.33333333333331 * sp[31] + 4.83333333333334 * sp[34] + 24.58333333333341 * sp[35] + -11.41666666666667 * sp[29] + -2.666666666666655 * sp[32] + -8.166666666666734 * sp[28] + -15.41666666666677 * sp[29] + -3.416666666666716 * sp[26] + -10.66666666666677 * sp[27] + -8.166666666666707 * sp[31] + -8.166666666666639 * sp[32] + -8.166666666666735 * sp[27] + -18.00000000000012 * sp[30];
    A[170] = 5.583333333333312 * sp[33] + -10.33333333333337 * sp[34] + 10.66666666666667 * sp[28] + -10.33333333333337 * sp[31] + 0.9166666666666623 * sp[34] + -18.95833333333341 * sp[35] + 4.874999999999998 * sp[29] + 0.5 * sp[32] + -2.583333333333348 * sp[28] + 6.041666666666741 * sp[29] + -4.125000000000021 * sp[26] + 4.500000000000095 * sp[27] + -2.583333333333342 * sp[31] + -2.583333333333382 * sp[32] + -2.58333333333333 * sp[27] + 11.08333333333337 * sp[30];
    A[171] = -1.083333333333295 * sp[33] + -2.416666666666613 * sp[34] + -2.416666666666679 * sp[28] + -2.416666666666663 * sp[31] + 12.16666666666668 * sp[34] + 27.9583333333334 * sp[35] + -2.208333333333316 * sp[29] + 8.08333333333341 * sp[32] + -1.833333333333324 * sp[28] + -2.041666666666615 * sp[29] + 1.791666666666686 * sp[26] + 1.583333333333361 * sp[27] + 2.00000000000003 * sp[31] + 14.33333333333356 * sp[32] + 1.999999999999991 * sp[27] + 9.416666666666751 * sp[30];
    A[172] = -2.000000000000027 * sp[33] + -0.1666666666666705 * sp[34] + -0.1666666666666821 * sp[28] + -0.1666666666666597 * sp[31] + -2.666666666666622 * sp[34] + -8.416666666666659 * sp[35] + 3.583333333333314 * sp[29] + -1.166666666666694 * sp[32] + 5.333333333333316 * sp[28] + 1.583333333333294 * sp[29] + 5.583333333333375 * sp[26] + 1.833333333333319 * sp[27] + 9.333333333333313 * sp[31] + 2.999999999999931 * sp[32] + 9.333333333333401 * sp[27] + 3.666666666666637 * sp[30];
    A[173] = 3.083333333333346 * sp[33] + -1.583333333333423 * sp[34] + -1.583333333333336 * sp[28] + -1.583333333333384 * sp[31] + -9.500000000000039 * sp[34] + 13.37500000000008 * sp[35] + -8.458333333333348 * sp[29] + 3.916666666666721 * sp[32] + -3.500000000000001 * sp[28] + 3.37500000000006 * sp[29] + -4.458333333333362 * sp[26] + 2.416666666666698 * sp[27] + -11.33333333333335 * sp[31] + 17.66666666666675 * sp[32] + -11.33333333333339 * sp[27] + 8.583333333333364 * sp[30];
    A[174] = 25.92724864350678 * sp[33] + 37.71236166328263 * sp[34] + 9.428090415820661 * sp[28] + 9.428090415820785 * sp[31] + 16.4991582276861 * sp[34] + -64.81812160876714 * sp[35] + 20.03469213361894 * sp[29] + -18.85618083164141 * sp[32] + -25.92724864350699 * sp[28] + -36.53385036130527 * sp[29] + -8.249579113843108 * sp[26] + -18.85618083164132 * sp[27] + -25.92724864350689 * sp[31] + -124.9221980096239 * sp[32] + 2.357022603955095 * sp[27] + -58.92556509887901 * sp[30];
    A[175] = -31.75426480542917 * sp[33] + -7.216878364869843 * sp[34] + 1.443375672974081 * sp[28] + 1.443375672974301 * sp[31] + 105.3664241271069 * sp[34] + 57.73502691896244 * sp[35] + 23.09401076758521 * sp[29] + 10.10362971081852 * sp[32] + -7.216878364870434 * sp[28] + -28.86751345948128 * sp[29] + 5.773502691896311 * sp[26] + -15.8771324027147 * sp[27] + -7.216878364870279 * sp[31] + -50.51814855409166 * sp[32] + 27.42413778650716 * sp[27] + -31.75426480542914 * sp[30];
    A[176] = 53.33333333333326 * sp[33] + 14.16666666666664 * sp[34] + -30.83333333333355 * sp[28] + -30.83333333333346 * sp[31] + 14.16666666666664 * sp[34] + 219.1666666666675 * sp[35] + -30.83333333333332 * sp[29] + 84.1666666666674 * sp[32] + -30.83333333333355 * sp[28] + -30.83333333333332 * sp[29] + 39.16666666666703 * sp[26] + 39.16666666666692 * sp[27] + -30.83333333333346 * sp[31] + 84.1666666666674 * sp[32] + 39.16666666666692 * sp[27] + 153.333333333334 * sp[30];
    A[177] = -58.92556509887896 * sp[33] + -25.92724864350675 * sp[34] + -40.06938426723764 * sp[28] + 2.357022603955231 * sp[31] + -18.85618083164127 * sp[34] + -22.39171473757407 * sp[35] + 5.8925565098879 * sp[29] + -11.78511301977593 * sp[32] + 37.71236166328287 * sp[28] + 34.17682775734995 * sp[29] + 5.892556509887834 * sp[26] + 2.357022603955079 * sp[27] + 37.71236166328274 * sp[31] + 37.71236166328269 * sp[32] + 9.428090415820584 * sp[27] + -2.357022603955089 * sp[30];
    A[178] = 12.99038105676669 * sp[33] + -4.330127018922168 * sp[34] + -4.330127018922195 * sp[28] + -12.99038105676671 * sp[31] + -25.98076211353289 * sp[34] + 10.82531754730572 * sp[35] + 2.165063509460829 * sp[29] + 12.99038105676662 * sp[32] + 25.98076211353326 * sp[28] + 10.8253175473055 * sp[29] + 36.80607966083907 * sp[26] + 21.65063509461105 * sp[27] + 25.98076211353325 * sp[31] + 25.98076211353295 * sp[32] + -8.660254037843853 * sp[27] + 12.99038105676633 * sp[30];
    A[179] = -104.1666666666666 * sp[33] + -45.83333333333329 * sp[34] + -55.8333333333331 * sp[28] + -0.8333333333330499 * sp[31] + -33.33333333333331 * sp[34] + -39.58333333333341 * sp[35] + 5.416666666666652 * sp[29] + -25.83333333333374 * sp[32] + 66.66666666666718 * sp[28] + 60.41666666666688 * sp[29] + 5.416666666666711 * sp[26] + -0.8333333333334831 * sp[27] + 66.66666666666697 * sp[31] + 66.66666666666686 * sp[32] + -3.333333333333332 * sp[27] + -104.166666666667 * sp[30];
    A[180] = 5.89255650988787 * sp[33] + -3.299831645537235 * sp[34] + 0.471404520791013 * sp[28] + 0.4714045207910498 * sp[31] + -1.649915822768611 * sp[34] + -2.474873734152918 * sp[35] + -2.003469213361935 * sp[29] + 0.4714045207910156 * sp[32] + 16.73486048808166 * sp[28] + 3.18198051533951 * sp[29] + -7.660323462854269 * sp[26] + -5.185449728701311 * sp[27] + 4.006938426723798 * sp[31] + 4.006938426723845 * sp[32] + -10.13519719700728 * sp[27] + -4.00693842672379 * sp[30];
    A[181] = -11.78511301977579 * sp[33] + 8.956685895029644 * sp[34] + -3.299831645537219 * sp[28] + -3.299831645537282 * sp[31] + -3.771236166328261 * sp[34] + 2.592724864350731 * sp[35] + 1.649915822768618 * sp[29] + -3.299831645537258 * sp[32] + -12.25651754056681 * sp[28] + 5.421151989096844 * sp[29] + -1.178511301977569 * sp[26] + -6.128258770283479 * sp[27] + -0.9428090415820516 * sp[31] + -0.9428090415821115 * sp[32] + 3.771236166328315 * sp[27] + -3.771236166328308 * sp[30];
    A[182] = -5.892556509887912 * sp[33] + -17.44196726926823 * sp[34] + 5.185449728701382 * sp[28] + 5.185449728701383 * sp[31] + -4.006938426723774 * sp[34] + -10.72445284799601 * sp[35] + 3.889087296526012 * sp[29] + 5.185449728701364 * sp[32] + 0.2357022603955312 * sp[28] + -5.067598598503574 * sp[29] + -1.767766952966381 * sp[26] + -0.4714045207910211 * sp[27] + 1.649915822768632 * sp[31] + 1.649915822768651 * sp[32] + -3.064129385141755 * sp[27] + -1.649915822768606 * sp[30];
    A[183] = 5.892556509887914 * sp[33] + 9.192388155425125 * sp[34] + 5.421151989096863 * sp[28] + 9.19238815542511 * sp[31] + 7.542472332656502 * sp[34] + 8.367430244040783 * sp[35] + 5.067598598503621 * sp[29] + 5.892556509887898 * sp[32] + -10.84230397819378 * sp[28] + -4.360491817317082 * sp[29] + -18.97403196183911 * sp[26] + -6.835365551470032 * sp[27] + -5.185449728701395 * sp[31] + -5.185449728701418 * sp[32] + -5.185449728701359 * sp[27] + -4.006938426723806 * sp[30];
    A[184] = -11.78511301977581 * sp[33] + -20.74179891480544 * sp[34] + -8.485281374238534 * sp[28] + -20.7417989148054 * sp[31] + -8.013876853447542 * sp[34] + -14.37783788412648 * sp[35] + -3.064129385141702 * sp[29] + -9.42809041582067 * sp[32] + 0.4714045207910615 * sp[28] + -3.064129385141687 * sp[29] + 2.59272486435072 * sp[26] + 1.88561808316413 * sp[27] + 3.299831645537259 * sp[31] + 3.299831645537272 * sp[32] + 3.299831645537231 * sp[27] + 5.656854249492373 * sp[30];
    A[185] = -5.892556509887879 * sp[33] + 11.54941075938033 * sp[34] + -11.07800623858926 * sp[28] + 11.54941075938034 * sp[31] + -1.885618083164127 * sp[34] + 4.831896338108136 * sp[35] + -3.181980515339465 * sp[29] + 3.535533905932835 * sp[32] + -6.128258770283389 * sp[28] + 6.246109900481163 * sp[29] + -13.08147545195113 * sp[26] + 4.949747468305836 * sp[27] + -0.4714045207910231 * sp[31] + -0.4714045207910615 * sp[32] + -0.4714045207909972 * sp[27] + -1.649915822768617 * sp[30];
    A[186] = 2.357022603955125 * sp[33] + 4.006938426723721 * sp[34] + 4.006938426723793 * sp[28] + 4.006938426723774 * sp[31] + 0.2357022603954859 * sp[34] + -0.2357022603955108 * sp[35] + 4.478342947514772 * sp[29] + 4.006938426723748 * sp[32] + -11.07800623858929 * sp[28] + -12.9636243217534 * sp[29] + -8.249579113843067 * sp[26] + -8.720983634634091 * sp[27] + -7.778174593052075 * sp[31] + -8.720983634634067 * sp[32] + -7.778174593052103 * sp[27] + -7.542472332656549 * sp[30];
    A[187] = -0.9428090415820651 * sp[34] + -0.9428090415820478 * sp[28] + -0.9428090415820723 * sp[31] + 1.885618083164133 * sp[34] + 0.471404520791042 * sp[35] + 0.4714045207910968 * sp[29] + -0.9428090415820312 * sp[32] + 24.5130350811337 * sp[28] + 11.78511301977579 * sp[29] + 11.7851130197758 * sp[26] + 10.37089945740266 * sp[27] + 13.19932658214896 * sp[31] + 5.656854249492399 * sp[32] + 13.19932658214902 * sp[27] + 8.013876853447586 * sp[30];
    A[188] = -2.357022603955167 * sp[33] + 1.649915822768711 * sp[34] + 1.649915822768613 * sp[28] + 1.649915822768665 * sp[31] + -2.121320343559626 * sp[34] + 2.121320343559709 * sp[35] + -2.592724864350687 * sp[29] + 1.649915822768639 * sp[32] + -13.43502884254444 * sp[28] + 3.535533905932812 * sp[29] + -1.178511301977574 * sp[26] + 3.064129385141774 * sp[27] + -5.421151989096892 * sp[31] + 3.064129385141744 * sp[32] + -5.42115198909693 * sp[27] + 1.885618083164162 * sp[30];
    A[189] = -33.33333333333346 * sp[33] + -46.66666666666686 * sp[34] + -6.666666666666704 * sp[28] + -6.666666666666829 * sp[31] + -26.66666666666671 * sp[34] + -36.66666666666681 * sp[35] + 3.333333333333156 * sp[29] + -6.666666666666872 * sp[32] + 13.33333333333349 * sp[28] + 3.333333333333339 * sp[29] + -36.66666666666664 * sp[26] + -46.66666666666677 * sp[27] + 13.33333333333351 * sp[31] + 13.33333333333331 * sp[32] + -26.66666666666686 * sp[27] + -33.33333333333361 * sp[30];
    A[190] = 28.57738033247013 * sp[33] + 8.16496580927674 * sp[34] + 8.164965809277286 * sp[28] + 8.164965809277041 * sp[31] + -4.082482904639212 * sp[34] + -22.45365597551271 * sp[35] + 26.53613888015079 * sp[29] + 8.164965809276913 * sp[32] + 69.40220937885667 * sp[28] + -22.45365597551266 * sp[29] + -71.44345083117612 * sp[26] + -89.81462390205003 * sp[27] + -4.08248290463901 * sp[31] + -28.57738033247043 * sp[32] + -53.07227776030264 * sp[27] + -69.40220937885719 * sp[30];
    A[191] = -58.92556509887896 * sp[33] + -18.85618083164127 * sp[34] + 37.71236166328287 * sp[28] + 37.71236166328274 * sp[31] + -25.92724864350675 * sp[34] + -22.39171473757407 * sp[35] + 34.17682775734995 * sp[29] + 37.71236166328269 * sp[32] + -40.06938426723764 * sp[28] + 5.8925565098879 * sp[29] + 5.892556509887834 * sp[26] + 9.428090415820584 * sp[27] + 2.357022603955231 * sp[31] + -11.78511301977593 * sp[32] + 2.357022603955079 * sp[27] + -2.357022603955089 * sp[30];
    A[192] = 66.66666666666674 * sp[33] + 33.33333333333339 * sp[34] + 33.33333333333326 * sp[28] + -6.666666666666796 * sp[31] + 33.33333333333339 * sp[34] + 33.33333333333324 * sp[35] + -6.666666666666654 * sp[29] + -6.66666666666667 * sp[32] + 33.33333333333326 * sp[28] + -6.666666666666654 * sp[29] + 113.3333333333336 * sp[26] + 33.33333333333351 * sp[27] + -6.666666666666796 * sp[31] + -6.66666666666667 * sp[32] + 33.33333333333351 * sp[27] + 26.66666666666706 * sp[30];
    A[193] = 12.24744871391593 * sp[34] + 12.247448713916 * sp[28] + 12.24744871391609 * sp[31] + 36.74234614174754 * sp[34] + 24.4948974278316 * sp[35] + 24.49489742783182 * sp[29] + 12.24744871391591 * sp[32] + -110.2270384252434 * sp[28] + -48.9897948556639 * sp[29] + -48.98979485566399 * sp[26] + 36.74234614174733 * sp[27] + -36.74234614174794 * sp[31] + -36.74234614174822 * sp[32] + 12.24744871391583 * sp[27] + 24.49489742783146 * sp[30];
    A[194] = 117.851130197758 * sp[33] + 58.92556509887901 * sp[34] + 58.92556509887878 * sp[28] + 2.357022603954843 * sp[31] + 58.92556509887902 * sp[34] + 58.92556509887876 * sp[35] + 2.357022603955119 * sp[29] + 2.357022603954473 * sp[32] + 58.92556509887865 * sp[28] + -11.78511301977584 * sp[29] + 44.78342947514784 * sp[26] + -11.78511301977598 * sp[27] + -11.78511301977609 * sp[31] + -11.78511301977586 * sp[32] + -11.78511301977603 * sp[27] + -9.428090415821016 * sp[30];
    A[195] = -16.88749537379662 * sp[33] + -5.196152422706684 * sp[34] + 5.19615242270662 * sp[28] + 5.196152422706602 * sp[31] + -7.361215932167775 * sp[34] + -6.278684177437283 * sp[35] + 11.90784930203616 * sp[29] + 5.196152422706653 * sp[32] + -7.361215932167797 * sp[28] + 4.979646071760493 * sp[29] + -21.86714144555718 * sp[26] + -1.732050807568862 * sp[27] + 3.897114317029944 * sp[31] + 3.897114317029918 * sp[32] + -15.1554445662276 * sp[27] + -3.897114317029894 * sp[30];
    A[196] = 7.794228634059966 * sp[33] + -2.598076211353294 * sp[34] + 2.598076211353332 * sp[28] + 2.598076211353373 * sp[31] + 1.732050807568882 * sp[34] + -0.4330127018921388 * sp[35] + -2.165063509461169 * sp[29] + 2.598076211353403 * sp[32] + 1.732050807568894 * sp[28] + -5.629165124598773 * sp[29] + 13.42339375865888 * sp[26] + -0.8660254037845523 * sp[27] + -3.464101615137762 * sp[31] + -3.464101615137684 * sp[32] + 8.660254037844382 * sp[27] + -5.196152422706608 * sp[30];
    A[197] = -3.897114317029984 * sp[33] + -5.196152422706619 * sp[34] + 5.196152422706641 * sp[28] + 5.196152422706631 * sp[31] + -3.031088913245552 * sp[34] + -4.113620667976107 * sp[35] + 5.412658773652788 * sp[29] + 5.196152422706608 * sp[32] + -3.031088913245564 * sp[28] + -1.51554445662285 * sp[29] + -2.381569860407196 * sp[26] + -1.7320508075688 * sp[27] + -0.4330127018922491 * sp[31] + -0.4330127018922791 * sp[32] + -2.165063509461067 * sp[27] + 0.4330127018922143 * sp[30];
    A[198] = 16.8874953737966 * sp[33] + 11.69134295108993 * sp[34] + 22.08364779650328 * sp[28] + 11.69134295108998 * sp[31] + 9.526279441628871 * sp[34] + 10.60881119635943 * sp[35] + 2.814582562299463 * sp[29] + 3.897114317030009 * sp[32] + 9.526279441628894 * sp[28] + -0.6495190528383068 * sp[29] + 36.58957330989261 * sp[26] + 19.48557158514988 * sp[27] + -1.732050807568819 * sp[31] + -1.732050807568818 * sp[32] + -1.732050807568835 * sp[27] + 0.4330127018922438 * sp[30];
    A[199] = -7.794228634059962 * sp[33] + -10.39230484541324 * sp[34] + -5.196152422706664 * sp[28] + -10.39230484541322 * sp[31] + -6.062177826491094 * sp[34] + -8.227241335952186 * sp[35] + -1.299038105676672 * sp[29] + -3.464101615137729 * sp[32] + -6.062177826491116 * sp[28] + -3.031088913245617 * sp[29] + -16.88749537379655 * sp[26] + -17.32050807568877 * sp[27] + -0.866025403784493 * sp[31] + -0.8660254037845138 * sp[32] + -0.8660254037844799 * sp[27] + 3.464101615137721 * sp[30];
    A[200] = 3.89711431702997 * sp[33] + -1.299038105676654 * sp[34] + 9.09326673973664 * sp[28] + -1.299038105676636 * sp[31] + 0.8660254037844354 * sp[34] + -0.2165063509460623 * sp[35] + 0.6495190528383139 * sp[29] + -0.4330127018921797 * sp[32] + 0.8660254037844459 * sp[28] + -2.814582562299338 * sp[29] + 8.443747686898329 * sp[26] + -2.165063509461013 * sp[27] + -1.732050807568876 * sp[31] + -1.732050807568808 * sp[32] + -1.732050807568871 * sp[27] + -3.897114317029934 * sp[30];
    A[201] = 10.3923048454133 * sp[33] + 11.69134295108996 * sp[34] + 11.69134295108994 * sp[28] + 11.69134295108993 * sp[31] + 7.361215932167798 * sp[34] + 6.062177826491066 * sp[35] + 12.99038105676666 * sp[29] + 11.69134295108996 * sp[32] + 7.361215932167699 * sp[28] + 12.99038105676656 * sp[29] + -7.794228634059939 * sp[26] + -3.897114317029964 * sp[27] + -6.495190528383224 * sp[31] + -8.227241335952124 * sp[32] + -6.495190528383203 * sp[27] + -6.062177826491002 * sp[30];
    A[202] = -20.78460969082659 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541326 * sp[28] + -10.39230484541324 * sp[31] + -10.3923048454134 * sp[34] + -3.464101615137787 * sp[35] + -17.32050807568893 * sp[29] + -10.39230484541332 * sp[32] + -10.39230484541322 * sp[28] + -17.32050807568876 * sp[29] + 24.24871130596438 * sp[26] + 3.464101615137778 * sp[27] + 17.32050807568866 * sp[31] + 3.464101615137664 * sp[32] + 17.32050807568865 * sp[27] + 7.794228634059823 * sp[30];
    A[203] = 10.39230484541331 * sp[33] + -1.299038105676684 * sp[34] + -1.299038105676679 * sp[28] + -1.299038105676709 * sp[31] + 3.031088913245604 * sp[34] + -2.598076211353357 * sp[35] + 4.330127018922273 * sp[29] + -1.29903810567671 * sp[32] + 3.031088913245541 * sp[28] + 4.330127018922288 * sp[29] + -16.45448267190442 * sp[26] + 0.4330127018923056 * sp[27] + -10.82531754730544 * sp[31] + 4.763139720814402 * sp[32] + -10.82531754730545 * sp[27] + 2.598076211353337 * sp[30];
    A[204] = -36.74234614174783 * sp[33] + -36.7423461417477 * sp[34] + 36.74234614174767 * sp[28] + 36.74234614174776 * sp[31] + -24.49489742783197 * sp[34] + -30.6186217847896 * sp[35] + 42.86607049870583 * sp[29] + 36.74234614174806 * sp[32] + -24.49489742783202 * sp[28] + -6.12372435695827 * sp[29] + -30.61862178478979 * sp[26] + -12.24744871391624 * sp[27] + -24.49489742783146 * sp[27] + -36.74234614174724 * sp[30];
    A[205] = -67.50000000000014 * sp[33] + 90.00000000000014 * sp[28] + 90.00000000000016 * sp[31] + 7.500000000000167 * sp[34] + 3.750000000000082 * sp[35] + 93.75000000000045 * sp[29] + 90.0000000000006 * sp[32] + 7.499999999999041 * sp[28] + 48.74999999999934 * sp[29] + -41.24999999999982 * sp[26] + -30.00000000000041 * sp[27] + 52.50000000000023 * sp[31] + -22.49999999999968 * sp[32] + -37.49999999999935 * sp[27] + -67.49999999999929 * sp[30];
    A[206] = 12.99038105676669 * sp[33] + -25.98076211353289 * sp[34] + 25.98076211353326 * sp[28] + 25.98076211353325 * sp[31] + -4.330127018922168 * sp[34] + 10.82531754730572 * sp[35] + 10.8253175473055 * sp[29] + 25.98076211353295 * sp[32] + -4.330127018922195 * sp[28] + 2.165063509460829 * sp[29] + 36.80607966083907 * sp[26] + -8.660254037843853 * sp[27] + -12.99038105676671 * sp[31] + 12.99038105676662 * sp[32] + 21.65063509461105 * sp[27] + 12.99038105676633 * sp[30];
    A[207] = 36.74234614174754 * sp[34] + -110.2270384252434 * sp[28] + -36.74234614174794 * sp[31] + 12.24744871391593 * sp[34] + 24.4948974278316 * sp[35] + -48.9897948556639 * sp[29] + -36.74234614174822 * sp[32] + 12.247448713916 * sp[28] + 24.49489742783182 * sp[29] + -48.98979485566399 * sp[26] + 12.24744871391583 * sp[27] + 12.24744871391609 * sp[31] + 12.24744871391591 * sp[32] + 36.74234614174733 * sp[27] + 24.49489742783146 * sp[30];
    A[208] = 135.0000000000004 * sp[33] + 67.50000000000036 * sp[34] + 67.50000000000051 * sp[28] + -22.49999999999962 * sp[31] + 67.50000000000036 * sp[34] + 67.50000000000063 * sp[35] + -22.49999999999993 * sp[29] + -22.49999999999968 * sp[32] + 67.50000000000051 * sp[28] + -22.49999999999993 * sp[29] + 247.5000000000001 * sp[26] + 67.50000000000004 * sp[27] + -22.49999999999962 * sp[31] + -22.49999999999968 * sp[32] + 67.50000000000004 * sp[27] + 59.99999999999979 * sp[30];
    A[209] = 64.9519052838327 * sp[34] + -38.9711431702998 * sp[28] + 12.99038105676651 * sp[31] + 21.65063509461114 * sp[34] + 43.30127018922168 * sp[35] + -8.660254037844151 * sp[29] + 12.99038105676675 * sp[32] + 21.65063509461113 * sp[28] + 43.30127018922197 * sp[29] + -8.660254037844902 * sp[26] + 99.59292143520966 * sp[27] + 21.65063509461125 * sp[31] + 21.65063509461095 * sp[32] + -12.99038105676659 * sp[27] + 43.30127018922231 * sp[30];
    A[210] = 10.4166666666666 * sp[33] + -5.833333333333363 * sp[34] + 0.8333333333333279 * sp[28] + 0.8333333333333767 * sp[31] + -2.916666666666675 * sp[34] + -4.375000000000009 * sp[35] + -3.541666666666728 * sp[29] + 0.8333333333333139 * sp[32] + 10.08333333333329 * sp[28] + -2.875000000000024 * sp[29] + 7.958333333333448 * sp[26] + 1.833333333333381 * sp[27] + -1.416666666666691 * sp[31] + -1.416666666666779 * sp[32] + 3.583333333333359 * sp[27] + 2.916666666666688 * sp[30];
    A[211] = -20.8333333333333 * sp[33] + 15.8333333333334 * sp[34] + -5.833333333333336 * sp[28] + -5.83333333333342 * sp[31] + -6.666666666666672 * sp[34] + 4.58333333333343 * sp[35] + 2.91666666666667 * sp[29] + -5.833333333333378 * sp[32] + -12.66666666666662 * sp[28] + 11.58333333333334 * sp[29] + -10.08333333333341 * sp[26] + 2.16666666666664 * sp[27] + 0.3333333333333816 * sp[31] + 0.3333333333335413 * sp[32] + -1.333333333333377 * sp[27] + 13.33333333333326 * sp[30];
    A[212] = -10.41666666666669 * sp[33] + -30.83333333333341 * sp[34] + 9.166666666666728 * sp[28] + 9.166666666666721 * sp[31] + -7.08333333333334 * sp[34] + -18.95833333333339 * sp[35] + 6.875000000000004 * sp[29] + 9.166666666666687 * sp[32] + -4.083333333333325 * sp[28] + -12.45833333333333 * sp[29] + 3.375000000000048 * sp[26] + 0.1666666666666816 * sp[27] + -0.5833333333333084 * sp[31] + -0.5833333333333715 * sp[32] + 1.083333333333321 * sp[27] + -12.91666666666671 * sp[30];
    A[213] = 10.41666666666671 * sp[33] + 16.25000000000001 * sp[34] + 9.58333333333333 * sp[28] + 16.24999999999998 * sp[31] + 13.33333333333333 * sp[34] + 14.79166666666662 * sp[35] + 8.958333333333389 * sp[29] + 10.41666666666667 * sp[32] + 0.3333333333333246 * sp[28] + 3.291666666666674 * sp[29] + 7.458333333333254 * sp[26] + 9.416666666666613 * sp[27] + 1.833333333333294 * sp[31] + 1.833333333333322 * sp[32] + 1.833333333333304 * sp[27] + 2.916666666666585 * sp[30];
    A[214] = -20.83333333333336 * sp[33] + -36.66666666666674 * sp[34] + -14.99999999999993 * sp[28] + -36.66666666666665 * sp[31] + -14.16666666666667 * sp[34] + -25.41666666666668 * sp[35] + -5.41666666666666 * sp[29] + -16.66666666666671 * sp[32] + -8.166666666666639 * sp[28] + -12.41666666666665 * sp[29] + -12.41666666666658 * sp[26] + -24.66666666666661 * sp[27] + -1.166666666666602 * sp[31] + -1.166666666666647 * sp[32] + -1.166666666666595 * sp[27] + 10.00000000000011 * sp[30];
    A[215] = -10.41666666666663 * sp[33] + 20.41666666666674 * sp[34] + -19.58333333333333 * sp[28] + 20.41666666666676 * sp[31] + -3.333333333333329 * sp[34] + 8.541666666666767 * sp[35] + -5.624999999999995 * sp[29] + 6.25000000000016 * sp[32] + -6.333333333333291 * sp[28] + 12.04166666666666 * sp[29] + -12.12500000000001 * sp[26] + 15.24999999999999 * sp[27] + 0.1666666666666898 * sp[31] + 0.1666666666668211 * sp[32] + 0.1666666666667 * sp[27] + -12.91666666666651 * sp[30];
    A[216] = 4.166666666666622 * sp[33] + 7.083333333333255 * sp[34] + 7.083333333333394 * sp[28] + 7.083333333333357 * sp[31] + 0.4166666666666279 * sp[34] + -0.4166666666666474 * sp[35] + 7.916666666666629 * sp[29] + 7.083333333333307 * sp[32] + 8.416666666666661 * sp[28] + 13.58333333333326 * sp[29] + 1.916666666666736 * sp[26] + 3.083333333333357 * sp[27] + 2.749999999999959 * sp[31] + -8.916666666666881 * sp[32] + 2.749999999999971 * sp[27] + -3.333333333333438 * sp[30];
    A[217] = -1.666666666666682 * sp[34] + -1.666666666666676 * sp[28] + -1.666666666666705 * sp[31] + 3.333333333333316 * sp[34] + 0.8333333333333384 * sp[35] + 0.8333333333334156 * sp[29] + -1.666666666666628 * sp[32] + -12.66666666666672 * sp[28] + -7.166666666666662 * sp[29] + -7.166666666666796 * sp[26] + -3.666666666666718 * sp[27] + -4.666666666666691 * sp[31] + -7.999999999999941 * sp[32] + -4.666666666666678 * sp[27] + -5.833333333333286 * sp[30];
    A[218] = -4.166666666666664 * sp[33] + 2.916666666666828 * sp[34] + 2.916666666666681 * sp[28] + 2.916666666666753 * sp[31] + -3.749999999999958 * sp[34] + 3.750000000000103 * sp[35] + -4.583333333333343 * sp[29] + 2.916666666666708 * sp[32] + 4.250000000000028 * sp[28] + -2.249999999999952 * sp[29] + 9.416666666666766 * sp[26] + -1.083333333333303 * sp[27] + 1.916666666666735 * sp[31] + -13.08333333333324 * sp[32] + 1.916666666666713 * sp[27] + -6.666666666666601 * sp[30];
    A[219] = -58.92556509887916 * sp[33] + -82.4957911384308 * sp[34] + -11.78511301977576 * sp[28] + -11.78511301977596 * sp[31] + -47.14045207910325 * sp[34] + -64.81812160876706 * sp[35] + 5.892556509887655 * sp[29] + -11.78511301977606 * sp[32] + -18.85618083164122 * sp[28] + -22.39171473757398 * sp[29] + -8.24957911384289 * sp[26] + 16.49915822768617 * sp[27] + -4.714045207910209 * sp[31] + 80.13876853447569 * sp[32] + 9.428090415820545 * sp[27] + 54.21151989096833 * sp[30];
    A[220] = 50.51814855409172 * sp[33] + 14.43375672973977 * sp[34] + 14.43375672974085 * sp[28] + 14.43375672974045 * sp[31] + -7.216878364871281 * sp[34] + -39.6928310067871 * sp[35] + 46.90970937165667 * sp[29] + 14.43375672974019 * sp[32] + 44.74464586219584 * sp[28] + 72.89047148518972 * sp[29] + -13.71206889325332 * sp[26] + 31.75426480542954 * sp[27] + 105.3664241271055 * sp[31] + 62.06515393788351 * sp[32] + 18.76388374866259 * sp[27] + 50.51814855409138 * sp[30];
    A[221] = -104.1666666666666 * sp[33] + -33.33333333333331 * sp[34] + 66.66666666666718 * sp[28] + 66.66666666666697 * sp[31] + -45.83333333333329 * sp[34] + -39.58333333333341 * sp[35] + 60.41666666666688 * sp[29] + 66.66666666666686 * sp[32] + -55.8333333333331 * sp[28] + 5.416666666666652 * sp[29] + 5.416666666666711 * sp[26] + -3.333333333333332 * sp[27] + -0.8333333333330499 * sp[31] + -25.83333333333374 * sp[32] + -0.8333333333334831 * sp[27] + -104.166666666667 * sp[30];
    A[222] = 117.851130197758 * sp[33] + 58.92556509887902 * sp[34] + 58.92556509887865 * sp[28] + -11.78511301977609 * sp[31] + 58.92556509887901 * sp[34] + 58.92556509887876 * sp[35] + -11.78511301977584 * sp[29] + -11.78511301977586 * sp[32] + 58.92556509887878 * sp[28] + 2.357022603955119 * sp[29] + 44.78342947514784 * sp[26] + -11.78511301977603 * sp[27] + 2.357022603954843 * sp[31] + 2.357022603954473 * sp[32] + -11.78511301977598 * sp[27] + -9.428090415821016 * sp[30];
    A[223] = 21.65063509461114 * sp[34] + 21.65063509461113 * sp[28] + 21.65063509461125 * sp[31] + 64.9519052838327 * sp[34] + 43.30127018922168 * sp[35] + 43.30127018922197 * sp[29] + 21.65063509461095 * sp[32] + -38.9711431702998 * sp[28] + -8.660254037844151 * sp[29] + -8.660254037844902 * sp[26] + -12.99038105676659 * sp[27] + 12.99038105676651 * sp[31] + 12.99038105676675 * sp[32] + 99.59292143520966 * sp[27] + 43.30127018922231 * sp[30];
    A[224] = 208.3333333333333 * sp[33] + 104.1666666666667 * sp[34] + 104.1666666666662 * sp[28] + 4.166666666666181 * sp[31] + 104.1666666666667 * sp[34] + 104.1666666666662 * sp[35] + 4.166666666666595 * sp[29] + 4.166666666665552 * sp[32] + 104.1666666666662 * sp[28] + 4.166666666666595 * sp[29] + 104.1666666666666 * sp[26] + 4.166666666666552 * sp[27] + 4.166666666666181 * sp[31] + 4.166666666665552 * sp[32] + 4.166666666666552 * sp[27] + 183.3333333333321 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 6
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 6
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           6
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698428 * sp[19] + -0.01116071428571434 * sp[18] + -0.01116071428571434 * sp[18] + 0.05734126984127039 * sp[17];
    A[1] = -0.02986111111111113 * sp[19] + 0.005952380952380886 * sp[18] + 0.009920634920634981 * sp[18] + -0.04871031746031784 * sp[17];
    A[2] = 0.01765873015873006 * sp[19] + -0.004712301587301551 * sp[18] + -0.004712301587301582 * sp[18] + 0.01765873015873019 * sp[17];
    A[3] = -0.01542658730158738 * sp[19] + -0.02447916666666679 * sp[18] + 0.009052579365079375 * sp[18] + 0.01860119047619059 * sp[17];
    A[4] = 0.01746031746031736 * sp[19] + 0.02167658730158713 * sp[18] + -0.005704365079365056 * sp[18] + -0.01190476190476182 * sp[17];
    A[5] = -0.02385912698412693 * sp[19] + -0.03266369047619048 * sp[18] + 0.006820436507936535 * sp[18] + 0.01116071428571414 * sp[17];
    A[6] = -0.01314484126984129 * sp[19] + -0.008804563492063541 * sp[18] + 0.03067956349206366 * sp[18] + 0.0238591269841271 * sp[17];
    A[7] = 0.027777777777778 * sp[19] + 0.01413690476190486 * sp[18] + -0.07276785714285779 * sp[18] + -0.06111111111111169 * sp[17];
    A[8] = -0.02058531746031757 * sp[19] + -0.007068452380952341 * sp[18] + 0.05820932539682574 * sp[18] + 0.05114087301587347 * sp[17];
    A[9] = 0.0434926790015507 * sp[19] + -0.02314932914598859 * sp[18] + -0.06243303921190646 * sp[18] + 0.03507474113028571 * sp[17];
    A[10] = 0.0652955661583518 * sp[19] + -0.05154913117764597 * sp[18] + -0.1271545235715238 * sp[18] + 0.06529556615835108 * sp[17];
    A[11] = -0.01686507936508123 * sp[19] + -0.007440476190475729 * sp[18] + 0.07192460317460278 * sp[18] + -0.01091269841269988 * sp[17];
    A[12] = 0.03507474113028562 * sp[19] + 0.128373552536842 * sp[18] + -0.01192541198429724 * sp[18] + -0.1248660784238151 * sp[17];
    A[13] = -0.1005208057964091 * sp[19] + -0.06314768569261567 * sp[18] + 0.07088005536926208 * sp[18] + -0.08505606644311423 * sp[17];
    A[14] = 0.06200396825396903 * sp[19] + 0.09598214285714132 * sp[18] + -0.02108134920634953 * sp[18] + 0.05307539682539919 * sp[17];
    A[15] = -0.02986111111111113 * sp[19] + 0.009920634920634981 * sp[18] + 0.005952380952380886 * sp[18] + -0.04871031746031784 * sp[17];
    A[16] = 0.06865079365079391 * sp[19] + -0.01289682539682548 * sp[18] + -0.01289682539682548 * sp[18] + 0.06865079365079434 * sp[17];
    A[17] = -0.04871031746031757 * sp[19] + 0.005952380952380894 * sp[18] + 0.009920634920634977 * sp[18] + -0.02986111111111133 * sp[17];
    A[18] = 0.01746031746031735 * sp[19] + 0.02316468253968253 * sp[18] + -0.004216269841269757 * sp[18] + -0.01041666666666666 * sp[17];
    A[19] = -0.04384920634920637 * sp[19] + -0.05327380952380969 * sp[18] + 0.009424603174603195 * sp[18] + 0.01785714285714286 * sp[17];
    A[20] = 0.06111111111111132 * sp[19] + 0.07524801587301626 * sp[18] + -0.01165674603174612 * sp[18] + -0.02529761904761913 * sp[17];
    A[21] = 0.0104166666666667 * sp[19] + 0.004216269841269761 * sp[18] + -0.0231646825396826 * sp[18] + -0.01746031746031749 * sp[17];
    A[22] = -0.01785714285714301 * sp[19] + -0.009424603174603223 * sp[18] + 0.05327380952380993 * sp[18] + 0.04384920634920664 * sp[17];
    A[23] = 0.02529761904761932 * sp[19] + 0.01165674603174611 * sp[18] + -0.07524801587301654 * sp[18] + -0.06111111111111172 * sp[17];
    A[24] = -0.07856742013183729 * sp[19] + -0.009820927516479984 * sp[18] + 0.1360899955855052 * sp[18] + 0.07014948226057122 * sp[17];
    A[25] = -0.05326743555023457 * sp[19] + -0.008591521862941312 * sp[18] + 0.1838585678669347 * sp[18] + 0.08419691425682213 * sp[17];
    A[26] = -0.004960317460314811 * sp[19] + 0.01984126984126909 * sp[18] + -0.1626984126984118 * sp[18] + -0.1021825396825401 * sp[17];
    A[27] = -0.07014948226057119 * sp[19] + -0.1360899955855052 * sp[18] + 0.009820927516480034 * sp[18] + 0.07856742013183707 * sp[17];
    A[28] = 0.04639421805987969 * sp[19] + 0.04897167461876192 * sp[18] + -0.01288728279441019 * sp[18] + 0.03092947870658607 * sp[17];
    A[29] = -0.1240079365079382 * sp[19] + -0.2405753968253957 * sp[18] + 0.01736111111111139 * sp[18] + 0.04365079365079504 * sp[17];
    A[30] = 0.01765873015873006 * sp[19] + -0.004712301587301582 * sp[18] + -0.004712301587301551 * sp[18] + 0.01765873015873019 * sp[17];
    A[31] = -0.04871031746031757 * sp[19] + 0.009920634920634977 * sp[18] + 0.005952380952380894 * sp[18] + -0.02986111111111133 * sp[17];
    A[32] = 0.05734126984127022 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.02162698412698438 * sp[17];
    A[33] = -0.02385912698412701 * sp[19] + -0.0306795634920637 * sp[18] + 0.008804563492063528 * sp[18] + 0.01314484126984134 * sp[17];
    A[34] = 0.0611111111111115 * sp[19] + 0.07276785714285777 * sp[18] + -0.01413690476190486 * sp[18] + -0.02777777777777801 * sp[17];
    A[35] = -0.05114087301587324 * sp[19] + -0.0582093253968257 * sp[18] + 0.007068452380952361 * sp[18] + 0.02058531746031756 * sp[17];
    A[36] = -0.0186011904761907 * sp[19] + -0.009052579365079395 * sp[18] + 0.0244791666666669 * sp[18] + 0.01542658730158745 * sp[17];
    A[37] = 0.01190476190476202 * sp[19] + 0.005704365079365081 * sp[18] + -0.02167658730158733 * sp[18] + -0.0174603174603175 * sp[17];
    A[38] = -0.01116071428571437 * sp[19] + -0.006820436507936541 * sp[18] + 0.03266369047619071 * sp[18] + 0.02385912698412713 * sp[17];
    A[39] = 0.1248660784238154 * sp[19] + 0.01192541198429716 * sp[18] + -0.1283735525368424 * sp[18] + -0.03507474113028568 * sp[17];
    A[40] = -0.003436608745177769 * sp[19] + -0.01718304372588166 * sp[18] + -0.05154913117764426 * sp[18] + -0.003436608745176426 * sp[17];
    A[41] = 0.1001984126984122 * sp[19] + -0.07192460317460359 * sp[18] + 0.1026785714285716 * sp[18] + 0.1180555555555573 * sp[17];
    A[42] = -0.0350747411302857 * sp[19] + 0.06243303921190654 * sp[18] + 0.0231493291459886 * sp[18] + -0.04349267900155111 * sp[17];
    A[43] = -0.02319710902993935 * sp[19] + 0.001288728279440788 * sp[18] + 0.03221820698602819 * sp[18] + -0.01804219591217493 * sp[17];
    A[44] = -0.06200396825396925 * sp[19] + 0.1460813492063478 * sp[18] + 0.04092261904761979 * sp[18] + -0.06498015873016035 * sp[17];
    A[45] = -0.01542658730158738 * sp[19] + 0.009052579365079375 * sp[18] + -0.02447916666666679 * sp[18] + 0.01860119047619059 * sp[17];
    A[46] = 0.01746031746031735 * sp[19] + -0.004216269841269757 * sp[18] + 0.02316468253968253 * sp[18] + -0.01041666666666666 * sp[17];
    A[47] = -0.02385912698412701 * sp[19] + 0.008804563492063528 * sp[18] + -0.0306795634920637 * sp[18] + 0.01314484126984134 * sp[17];
    A[48] = 0.02162698412698429 * sp[19] + 0.03278769841269865 * sp[18] + 0.03278769841269865 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.0298611111111112 * sp[19] + -0.0358134920634921 * sp[18] + -0.03978174603174632 * sp[18] + -0.09444444444444487 * sp[17];
    A[50] = 0.01765873015873007 * sp[19] + 0.02237103174603163 * sp[18] + 0.02237103174603177 * sp[18] + 0.04474206349206346 * sp[17];
    A[51] = 0.02058531746031755 * sp[19] + 0.01351686507936519 * sp[18] + 0.07879464285714328 * sp[18] + 0.02058531746031761 * sp[17];
    A[52] = -0.02777777777777796 * sp[19] + -0.01364087301587308 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761922 * sp[17];
    A[53] = 0.01314484126984128 * sp[19] + 0.004340277777777709 * sp[18] + 0.0438244047619049 * sp[18] + 0.01116071428571432 * sp[17];
    A[54] = -0.07856742013183668 * sp[19] + 0.02665680325901706 * sp[18] + -0.1529258713280413 * sp[18] + 0.04208968935634258 * sp[17];
    A[55] = -0.0352252396380577 * sp[19] + 0.07947157723220398 * sp[18] + 0.02104922856420371 * sp[18] + 0.1159855451497028 * sp[17];
    A[56] = -0.04513888888888806 * sp[19] + 0.04340277777777802 * sp[18] + 0.005704365079364412 * sp[18] + 0.05208333333333347 * sp[17];
    A[57] = 0.03507474113028551 * sp[19] + -0.09329881140655683 * sp[18] + 0.04700015311458276 * sp[18] + -0.2062394778460752 * sp[17];
    A[58] = 0.1005208057964092 * sp[19] + 0.03737312010379365 * sp[18] + 0.1714008611656715 * sp[18] + 0.1933092419161693 * sp[17];
    A[59] = 0.06200396825396904 * sp[19] + -0.03397817460317261 * sp[18] + 0.08308531746031887 * sp[18] + 0.04017857142857393 * sp[17];
    A[60] = 0.01746031746031736 * sp[19] + -0.005704365079365056 * sp[18] + 0.02167658730158713 * sp[18] + -0.01190476190476182 * sp[17];
    A[61] = -0.04384920634920637 * sp[19] + 0.009424603174603195 * sp[18] + -0.05327380952380969 * sp[18] + 0.01785714285714286 * sp[17];
    A[62] = 0.0611111111111115 * sp[19] + -0.01413690476190486 * sp[18] + 0.07276785714285777 * sp[18] + -0.02777777777777801 * sp[17];
    A[63] = -0.0298611111111112 * sp[19] + -0.03978174603174632 * sp[18] + -0.0358134920634921 * sp[18] + -0.09444444444444487 * sp[17];
    A[64] = 0.06865079365079411 * sp[19] + 0.08154761904761967 * sp[18] + 0.08154761904761967 * sp[18] + 0.1630952380952395 * sp[17];
    A[65] = -0.04871031746031763 * sp[19] + -0.05466269841269859 * sp[18] + -0.05863095238095271 * sp[18] + -0.09444444444444498 * sp[17];
    A[66] = -0.0252976190476193 * sp[19] + -0.01364087301587309 * sp[18] + -0.1005456349206357 * sp[18] + -0.02777777777777798 * sp[17];
    A[67] = 0.01785714285714297 * sp[19] + 0.008432539682539682 * sp[18] + 0.07113095238095253 * sp[18] + 0.01785714285714282 * sp[17];
    A[68] = -0.0104166666666667 * sp[19] + -0.006200396825396825 * sp[18] + -0.03358134920634915 * sp[18] + -0.01190476190476186 * sp[17];
    A[69] = 0.1487169023924089 * sp[19] + 0.002805979290422942 * sp[18] + 0.2946278254943954 * sp[18];
    A[70] = -0.00687321749035422 * sp[19] + -0.047253370246175 * sp[18] + -0.177844502562879 * sp[18] + -0.1030982623552912 * sp[17];
    A[71] = 0.1289682539682535 * sp[19] + -0.09176587301587376 * sp[18] + -0.01636904761904628 * sp[18] + -0.1785714285714304 * sp[17];
    A[72] = -0.07014948226057129 * sp[19] + 0.06594051332493439 * sp[18] + -0.0799704097770513 * sp[18] + 0.1346870059402923 * sp[17];
    A[73] = -0.04639421805988008 * sp[19] + 0.002577456558881659 * sp[18] + -0.05928150085429042 * sp[18] + -0.04123930494211495 * sp[17];
    A[74] = -0.1240079365079383 * sp[19] + 0.116567460317458 * sp[18] + -0.1413690476190498 * sp[18] + 0.1428571428571438 * sp[17];
    A[75] = -0.02385912698412693 * sp[19] + 0.006820436507936535 * sp[18] + -0.03266369047619048 * sp[18] + 0.01116071428571414 * sp[17];
    A[76] = 0.06111111111111132 * sp[19] + -0.01165674603174612 * sp[18] + 0.07524801587301626 * sp[18] + -0.02529761904761913 * sp[17];
    A[77] = -0.05114087301587324 * sp[19] + 0.007068452380952361 * sp[18] + -0.0582093253968257 * sp[18] + 0.02058531746031756 * sp[17];
    A[78] = 0.01765873015873007 * sp[19] + 0.02237103174603177 * sp[18] + 0.02237103174603163 * sp[18] + 0.04474206349206346 * sp[17];
    A[79] = -0.04871031746031763 * sp[19] + -0.05863095238095271 * sp[18] + -0.05466269841269859 * sp[18] + -0.09444444444444498 * sp[17];
    A[80] = 0.05734126984127008 * sp[19] + 0.06850198412698449 * sp[18] + 0.06850198412698449 * sp[18] + 0.1012896825396833 * sp[17];
    A[81] = 0.01116071428571437 * sp[19] + 0.004340277777777716 * sp[18] + 0.04382440476190495 * sp[18] + 0.01314484126984124 * sp[17];
    A[82] = -0.011904761904762 * sp[19] + -0.006200396825396833 * sp[18] + -0.03358134920634906 * sp[18] + -0.01041666666666648 * sp[17];
    A[83] = 0.01860119047619067 * sp[19] + 0.009548611111111185 * sp[18] + 0.04308035714285741 * sp[18] + 0.01860119047619047 * sp[17];
    A[84] = -0.08979133729352923 * sp[19] + -0.01543288609732573 * sp[18] + -0.1950155606843834 * sp[18] + -0.04208968935634295 * sp[17];
    A[85] = -0.02663371777511688 * sp[19] + -0.01073940232867661 * sp[18] + -0.007302793583500236 * sp[18] + -0.01288728279441203 * sp[17];
    A[86] = -0.03819444444444274 * sp[19] + 0.03596230158730124 * sp[18] + 0.1054067460317485 * sp[18] + 0.1264880952380963 * sp[17];
    A[87] = -0.03507474113028547 * sp[19] + -0.09750778034219149 * sp[18] + -0.05822407027627412 * sp[18] + -0.1641497884897314 * sp[17];
    A[88] = 0.02319710902993906 * sp[19] + 0.02448583730938073 * sp[18] + 0.0554153160159671 * sp[18] + 0.07474624020758447 * sp[17];
    A[89] = -0.0620039682539689 * sp[19] + -0.2080853174603163 * sp[18] + -0.1029265873015888 * sp[18] + -0.3139880952380974 * sp[17];
    A[90] = -0.01314484126984129 * sp[19] + 0.03067956349206366 * sp[18] + -0.008804563492063541 * sp[18] + 0.0238591269841271 * sp[17];
    A[91] = 0.0104166666666667 * sp[19] + -0.0231646825396826 * sp[18] + 0.004216269841269761 * sp[18] + -0.01746031746031749 * sp[17];
    A[92] = -0.0186011904761907 * sp[19] + 0.0244791666666669 * sp[18] + -0.009052579365079395 * sp[18] + 0.01542658730158745 * sp[17];
    A[93] = 0.02058531746031755 * sp[19] + 0.07879464285714328 * sp[18] + 0.01351686507936519 * sp[18] + 0.02058531746031761 * sp[17];
    A[94] = -0.0252976190476193 * sp[19] + -0.1005456349206357 * sp[18] + -0.01364087301587309 * sp[18] + -0.02777777777777798 * sp[17];
    A[95] = 0.01116071428571437 * sp[19] + 0.04382440476190495 * sp[18] + 0.004340277777777716 * sp[18] + 0.01314484126984124 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269875 * sp[18] + 0.03278769841269875 * sp[18] + 0.02162698412698436 * sp[17];
    A[97] = -0.09444444444444484 * sp[19] + -0.03978174603174629 * sp[18] + -0.03581349206349225 * sp[18] + -0.02986111111111131 * sp[17];
    A[98] = 0.04474206349206349 * sp[19] + 0.02237103174603181 * sp[18] + 0.02237103174603176 * sp[18] + 0.0176587301587302 * sp[17];
    A[99] = -0.2062394778460754 * sp[19] + 0.04700015311458258 * sp[18] + -0.09329881140655705 * sp[18] + 0.03507474113028554 * sp[17];
    A[100] = 0.1314502845029976 * sp[19] + 0.1576544261849668 * sp[18] + -0.01073940232867412 * sp[18] + 0.1039574145415858 * sp[17];
    A[101] = 0.1473214285714276 * sp[19] + 0.1068948412698425 * sp[18] + 0.04935515873015904 * sp[18] + 0.05605158730158805 * sp[17];
    A[102] = 0.04208968935634275 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901707 * sp[18] + -0.07856742013183692 * sp[17];
    A[103] = 0.1030982623552905 * sp[19] + 0.01546473935329246 * sp[18] + 0.07732369676646848 * sp[18] + -0.05670404429540898 * sp[17];
    A[104] = 0.07440476190476311 * sp[19] + 0.01537698412698327 * sp[18] + 0.04712301587301668 * sp[18] + -0.007936507936507678 * sp[17];
    A[105] = 0.027777777777778 * sp[19] + -0.07276785714285779 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111169 * sp[17];
    A[106] = -0.01785714285714301 * sp[19] + 0.05327380952380993 * sp[18] + -0.009424603174603223 * sp[18] + 0.04384920634920664 * sp[17];
    A[107] = 0.01190476190476202 * sp[19] + -0.02167658730158733 * sp[18] + 0.005704365079365081 * sp[18] + -0.0174603174603175 * sp[17];
    A[108] = -0.02777777777777796 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587308 * sp[18] + -0.02529761904761922 * sp[17];
    A[109] = 0.01785714285714297 * sp[19] + 0.07113095238095253 * sp[18] + 0.008432539682539682 * sp[18] + 0.01785714285714282 * sp[17];
    A[110] = -0.011904761904762 * sp[19] + -0.03358134920634906 * sp[18] + -0.006200396825396833 * sp[18] + -0.01041666666666648 * sp[17];
    A[111] = -0.09444444444444484 * sp[19] + -0.03581349206349225 * sp[18] + -0.03978174603174629 * sp[18] + -0.02986111111111131 * sp[17];
    A[112] = 0.1630952380952394 * sp[19] + 0.08154761904761977 * sp[18] + 0.08154761904761977 * sp[18] + 0.06865079365079431 * sp[17];
    A[113] = -0.09444444444444493 * sp[19] + -0.05863095238095286 * sp[18] + -0.05466269841269865 * sp[18] + -0.04871031746031784 * sp[17];
    A[114] = 0.1346870059402921 * sp[19] + -0.079970409777051 * sp[18] + 0.06594051332493439 * sp[18] + -0.07014948226057123 * sp[17];
    A[115] = 0.1030982623552914 * sp[19] + -0.1520699369740544 * sp[18] + 0.1022391101689944 * sp[18] + -0.1305911323167025 * sp[17];
    A[116] = -0.1071428571428562 * sp[19] + 0.01934523809523996 * sp[18] + -0.05605158730158698 * sp[18] + 0.02182539682539827 * sp[17];
    A[117] = 0.2946278254943947 * sp[18] + 0.002805979290423018 * sp[18] + 0.1487169023924086 * sp[17];
    A[118] = -0.2061965247105818 * sp[19] + -0.1030982623552904 * sp[18] + -0.1030982623552908 * sp[18] + 0.1082531754730544 * sp[17];
    A[119] = -0.1458333333333375 * sp[18] + 0.004960317460317571 * sp[18] + -0.07043650793651063 * sp[17];
    A[120] = -0.02058531746031757 * sp[19] + 0.05820932539682574 * sp[18] + -0.007068452380952341 * sp[18] + 0.05114087301587347 * sp[17];
    A[121] = 0.02529761904761932 * sp[19] + -0.07524801587301654 * sp[18] + 0.01165674603174611 * sp[18] + -0.06111111111111172 * sp[17];
    A[122] = -0.01116071428571437 * sp[19] + 0.03266369047619071 * sp[18] + -0.006820436507936541 * sp[18] + 0.02385912698412713 * sp[17];
    A[123] = 0.01314484126984128 * sp[19] + 0.0438244047619049 * sp[18] + 0.004340277777777709 * sp[18] + 0.01116071428571432 * sp[17];
    A[124] = -0.0104166666666667 * sp[19] + -0.03358134920634915 * sp[18] + -0.006200396825396825 * sp[18] + -0.01190476190476186 * sp[17];
    A[125] = 0.01860119047619067 * sp[19] + 0.04308035714285741 * sp[18] + 0.009548611111111185 * sp[18] + 0.01860119047619047 * sp[17];
    A[126] = 0.04474206349206349 * sp[19] + 0.02237103174603176 * sp[18] + 0.02237103174603181 * sp[18] + 0.0176587301587302 * sp[17];
    A[127] = -0.09444444444444493 * sp[19] + -0.05466269841269865 * sp[18] + -0.05863095238095286 * sp[18] + -0.04871031746031784 * sp[17];
    A[128] = 0.1012896825396834 * sp[19] + 0.06850198412698469 * sp[18] + 0.06850198412698469 * sp[18] + 0.05734126984127041 * sp[17];
    A[129] = -0.1641497884897317 * sp[19] + -0.05822407027627447 * sp[18] + -0.09750778034219182 * sp[18] + -0.03507474113028567 * sp[17];
    A[130] = -0.2345485468582879 * sp[19] + -0.06142938132002899 * sp[18] + -0.1679642524204937 * sp[18] + -0.04209845712841141 * sp[17];
    A[131] = 0.2217261904761907 * sp[19] + 0.09945436507936553 * sp[18] + 0.1252480158730155 * sp[18] + 0.05109126984126951 * sp[17];
    A[132] = -0.04208968935634289 * sp[19] + -0.1950155606843829 * sp[18] + -0.0154328860973257 * sp[18] + -0.08979133729352906 * sp[17];
    A[133] = 0.10309826235529 * sp[19] + 0.08763352300199802 * sp[18] + 0.02577456558882171 * sp[18] + -0.04639421805987973 * sp[17];
    A[134] = -0.07440476190476306 * sp[19] + -0.05902777777777918 * sp[18] + -0.02728174603174635 * sp[18] + -0.003968253968253594 * sp[17];
    A[135] = 0.0434926790015507 * sp[19] + -0.06243303921190646 * sp[18] + -0.02314932914598859 * sp[18] + 0.03507474113028571 * sp[17];
    A[136] = -0.07856742013183729 * sp[19] + 0.1360899955855052 * sp[18] + -0.009820927516479984 * sp[18] + 0.07014948226057122 * sp[17];
    A[137] = 0.1248660784238154 * sp[19] + -0.1283735525368424 * sp[18] + 0.01192541198429716 * sp[18] + -0.03507474113028568 * sp[17];
    A[138] = -0.07856742013183668 * sp[19] + -0.1529258713280413 * sp[18] + 0.02665680325901706 * sp[18] + 0.04208968935634258 * sp[17];
    A[139] = 0.1487169023924089 * sp[19] + 0.2946278254943954 * sp[18] + 0.002805979290422942 * sp[18];
    A[140] = -0.08979133729352923 * sp[19] + -0.1950155606843834 * sp[18] + -0.01543288609732573 * sp[18] + -0.04208968935634295 * sp[17];
    A[141] = -0.2062394778460754 * sp[19] + -0.09329881140655705 * sp[18] + 0.04700015311458258 * sp[18] + 0.03507474113028554 * sp[17];
    A[142] = 0.1346870059402921 * sp[19] + 0.06594051332493439 * sp[18] + -0.079970409777051 * sp[18] + -0.07014948226057123 * sp[17];
    A[143] = -0.1641497884897317 * sp[19] + -0.09750778034219182 * sp[18] + -0.05822407027627447 * sp[18] + -0.03507474113028567 * sp[17];
    A[144] = 4.920634920634907 * sp[19] + 0.1984126984127022 * sp[18] + 0.1984126984127022 * sp[18] + 0.3968253968254027 * sp[17];
    A[145] = 0.02430049347996888 * sp[19] + -0.06075123369997295 * sp[18] + 0.2308546880599293 * sp[18] + 0.6075123369998048 * sp[17];
    A[146] = -0.5191061687281999 * sp[19] + -0.8067190459965516 * sp[18] + -0.3016427737204506 * sp[18] + -0.3507474113028566 * sp[17];
    A[147] = -0.1984126984127026 * sp[19] + 4.30555555555553 * sp[18] + 0.01984126984126973 * sp[18] + -0.1984126984127006 * sp[17];
    A[148] = -0.2187044413199078 * sp[19] + -0.03645074021998923 * sp[18] + 0.2551551815399187 * sp[18] + -0.2187044413199273 * sp[17];
    A[149] = -0.3507474113028561 * sp[19] + 0.5401510134063875 * sp[18] + 0.03507474113028543 * sp[18] + 0.3226876183986349 * sp[17];
    A[150] = 0.0652955661583518 * sp[19] + -0.1271545235715238 * sp[18] + -0.05154913117764597 * sp[18] + 0.06529556615835108 * sp[17];
    A[151] = -0.05326743555023457 * sp[19] + 0.1838585678669347 * sp[18] + -0.008591521862941312 * sp[18] + 0.08419691425682213 * sp[17];
    A[152] = -0.003436608745177769 * sp[19] + -0.05154913117764426 * sp[18] + -0.01718304372588166 * sp[18] + -0.003436608745176426 * sp[17];
    A[153] = -0.0352252396380577 * sp[19] + 0.02104922856420371 * sp[18] + 0.07947157723220398 * sp[18] + 0.1159855451497028 * sp[17];
    A[154] = -0.00687321749035422 * sp[19] + -0.177844502562879 * sp[18] + -0.047253370246175 * sp[18] + -0.1030982623552912 * sp[17];
    A[155] = -0.02663371777511688 * sp[19] + -0.007302793583500236 * sp[18] + -0.01073940232867661 * sp[18] + -0.01288728279441203 * sp[17];
    A[156] = 0.1314502845029976 * sp[19] + -0.01073940232867412 * sp[18] + 0.1576544261849668 * sp[18] + 0.1039574145415858 * sp[17];
    A[157] = 0.1030982623552914 * sp[19] + 0.1022391101689944 * sp[18] + -0.1520699369740544 * sp[18] + -0.1305911323167025 * sp[17];
    A[158] = -0.2345485468582879 * sp[19] + -0.1679642524204937 * sp[18] + -0.06142938132002899 * sp[18] + -0.04209845712841141 * sp[17];
    A[159] = 0.02430049347996888 * sp[19] + 0.2308546880599293 * sp[18] + -0.06075123369997295 * sp[18] + 0.6075123369998048 * sp[17];
    A[160] = 5.416666666666702 * sp[19] + 0.4315476190476338 * sp[18] + 0.4315476190476338 * sp[18] + 1.130952380952397 * sp[17];
    A[161] = -0.1890134809847098 * sp[19] + -0.06873217490352101 * sp[18] + -0.2749286996141045 * sp[18] + -0.1890134809847006 * sp[17];
    A[162] = 0.1701034543599518 * sp[19] + 0.4495591293798409 * sp[18] + 0.1579532076199487 * sp[18] + -0.4131083891598594 * sp[17];
    A[163] = -0.4017857142857182 * sp[19] + 3.593749999999995 * sp[18] + 0.5580357142857236 * sp[18] + -0.4017857142857128 * sp[17];
    A[164] = 0.300703265202947 * sp[19] + 0.1761261981902868 * sp[18] + 0.2792244605455818 * sp[18] + 0.3007032652029414 * sp[17];
    A[165] = -0.01686507936508123 * sp[19] + 0.07192460317460278 * sp[18] + -0.007440476190475729 * sp[18] + -0.01091269841269988 * sp[17];
    A[166] = -0.004960317460314811 * sp[19] + -0.1626984126984118 * sp[18] + 0.01984126984126909 * sp[18] + -0.1021825396825401 * sp[17];
    A[167] = 0.1001984126984122 * sp[19] + 0.1026785714285716 * sp[18] + -0.07192460317460359 * sp[18] + 0.1180555555555573 * sp[17];
    A[168] = -0.04513888888888806 * sp[19] + 0.005704365079364412 * sp[18] + 0.04340277777777802 * sp[18] + 0.05208333333333347 * sp[17];
    A[169] = 0.1289682539682535 * sp[19] + -0.01636904761904628 * sp[18] + -0.09176587301587376 * sp[18] + -0.1785714285714304 * sp[17];
    A[170] = -0.03819444444444274 * sp[19] + 0.1054067460317485 * sp[18] + 0.03596230158730124 * sp[18] + 0.1264880952380963 * sp[17];
    A[171] = 0.1473214285714276 * sp[19] + 0.04935515873015904 * sp[18] + 0.1068948412698425 * sp[18] + 0.05605158730158805 * sp[17];
    A[172] = -0.1071428571428562 * sp[19] + -0.05605158730158698 * sp[18] + 0.01934523809523996 * sp[18] + 0.02182539682539827 * sp[17];
    A[173] = 0.2217261904761907 * sp[19] + 0.1252480158730155 * sp[18] + 0.09945436507936553 * sp[18] + 0.05109126984126951 * sp[17];
    A[174] = -0.5191061687281999 * sp[19] + -0.3016427737204506 * sp[18] + -0.8067190459965516 * sp[18] + -0.3507474113028566 * sp[17];
    A[175] = -0.1890134809847098 * sp[19] + -0.2749286996141045 * sp[18] + -0.06873217490352101 * sp[18] + -0.1890134809847006 * sp[17];
    A[176] = 5.555555555555569 * sp[19] + 0.5902777777777796 * sp[18] + 0.5902777777777796 * sp[18] + 0.9126984126984289 * sp[17];
    A[177] = -0.3507474113028569 * sp[19] + -0.3016427737204435 * sp[18] + 0.2034334985556578 * sp[18] + -0.01402989645209469 * sp[17];
    A[178] = 0.07732369676647455 * sp[19] + 0.1675346763273485 * sp[18] + 0.0644364139720561 * sp[18] + 0.07732369676647415 * sp[17];
    A[179] = -0.6200396825396924 * sp[19] + 3.395337301587297 * sp[18] + 0.3596230158730228 * sp[18] + -0.6200396825397002 * sp[17];
    A[180] = 0.03507474113028562 * sp[19] + -0.01192541198429724 * sp[18] + 0.128373552536842 * sp[18] + -0.1248660784238151 * sp[17];
    A[181] = -0.07014948226057119 * sp[19] + 0.009820927516480034 * sp[18] + -0.1360899955855052 * sp[18] + 0.07856742013183707 * sp[17];
    A[182] = -0.0350747411302857 * sp[19] + 0.0231493291459886 * sp[18] + 0.06243303921190654 * sp[18] + -0.04349267900155111 * sp[17];
    A[183] = 0.03507474113028551 * sp[19] + 0.04700015311458276 * sp[18] + -0.09329881140655683 * sp[18] + -0.2062394778460752 * sp[17];
    A[184] = -0.07014948226057129 * sp[19] + -0.0799704097770513 * sp[18] + 0.06594051332493439 * sp[18] + 0.1346870059402923 * sp[17];
    A[185] = -0.03507474113028547 * sp[19] + -0.05822407027627412 * sp[18] + -0.09750778034219149 * sp[18] + -0.1641497884897314 * sp[17];
    A[186] = 0.04208968935634275 * sp[19] + 0.02665680325901707 * sp[18] + -0.1529258713280409 * sp[18] + -0.07856742013183692 * sp[17];
    A[187] = 0.002805979290423018 * sp[18] + 0.2946278254943947 * sp[18] + 0.1487169023924086 * sp[17];
    A[188] = -0.04208968935634289 * sp[19] + -0.0154328860973257 * sp[18] + -0.1950155606843829 * sp[18] + -0.08979133729352906 * sp[17];
    A[189] = -0.1984126984127026 * sp[19] + 0.01984126984126973 * sp[18] + 4.30555555555553 * sp[18] + -0.1984126984127006 * sp[17];
    A[190] = 0.1701034543599518 * sp[19] + 0.1579532076199487 * sp[18] + 0.4495591293798409 * sp[18] + -0.4131083891598594 * sp[17];
    A[191] = -0.3507474113028569 * sp[19] + 0.2034334985556578 * sp[18] + -0.3016427737204435 * sp[18] + -0.01402989645209469 * sp[17];
    A[192] = 0.396825396825403 * sp[19] + 0.1984126984127007 * sp[18] + 0.1984126984127007 * sp[18] + 4.920634920634902 * sp[17];
    A[193] = -0.1458029608799467 * sp[18] + -0.7290148043997451 * sp[18] + -0.4374088826398527 * sp[17];
    A[194] = 0.7014948226057121 * sp[19] + 0.3507474113028551 * sp[18] + 0.3507474113028556 * sp[18] + 0.2805979290422559 * sp[17];
    A[195] = -0.1005208057964091 * sp[19] + 0.07088005536926208 * sp[18] + -0.06314768569261567 * sp[18] + -0.08505606644311423 * sp[17];
    A[196] = 0.04639421805987969 * sp[19] + -0.01288728279441019 * sp[18] + 0.04897167461876192 * sp[18] + 0.03092947870658607 * sp[17];
    A[197] = -0.02319710902993935 * sp[19] + 0.03221820698602819 * sp[18] + 0.001288728279440788 * sp[18] + -0.01804219591217493 * sp[17];
    A[198] = 0.1005208057964092 * sp[19] + 0.1714008611656715 * sp[18] + 0.03737312010379365 * sp[18] + 0.1933092419161693 * sp[17];
    A[199] = -0.04639421805988008 * sp[19] + -0.05928150085429042 * sp[18] + 0.002577456558881659 * sp[18] + -0.04123930494211495 * sp[17];
    A[200] = 0.02319710902993906 * sp[19] + 0.0554153160159671 * sp[18] + 0.02448583730938073 * sp[18] + 0.07474624020758447 * sp[17];
    A[201] = 0.1030982623552905 * sp[19] + 0.07732369676646848 * sp[18] + 0.01546473935329246 * sp[18] + -0.05670404429540898 * sp[17];
    A[202] = -0.2061965247105818 * sp[19] + -0.1030982623552908 * sp[18] + -0.1030982623552904 * sp[18] + 0.1082531754730544 * sp[17];
    A[203] = 0.10309826235529 * sp[19] + 0.02577456558882171 * sp[18] + 0.08763352300199802 * sp[18] + -0.04639421805987973 * sp[17];
    A[204] = -0.2187044413199078 * sp[19] + 0.2551551815399187 * sp[18] + -0.03645074021998923 * sp[18] + -0.2187044413199273 * sp[17];
    A[205] = -0.4017857142857182 * sp[19] + 0.5580357142857236 * sp[18] + 3.593749999999995 * sp[18] + -0.4017857142857128 * sp[17];
    A[206] = 0.07732369676647455 * sp[19] + 0.0644364139720561 * sp[18] + 0.1675346763273485 * sp[18] + 0.07732369676647415 * sp[17];
    A[207] = -0.7290148043997451 * sp[18] + -0.1458029608799467 * sp[18] + -0.4374088826398527 * sp[17];
    A[208] = 0.8035714285714409 * sp[19] + 0.4017857142857215 * sp[18] + 0.4017857142857215 * sp[18] + 5.357142857142867 * sp[17];
    A[209] = -0.05154913117763341 * sp[18] + -0.257745655888216 * sp[18] + -0.1546473935329296 * sp[17];
    A[210] = 0.06200396825396903 * sp[19] + -0.02108134920634953 * sp[18] + 0.09598214285714132 * sp[18] + 0.05307539682539919 * sp[17];
    A[211] = -0.1240079365079382 * sp[19] + 0.01736111111111139 * sp[18] + -0.2405753968253957 * sp[18] + 0.04365079365079504 * sp[17];
    A[212] = -0.06200396825396925 * sp[19] + 0.04092261904761979 * sp[18] + 0.1460813492063478 * sp[18] + -0.06498015873016035 * sp[17];
    A[213] = 0.06200396825396904 * sp[19] + 0.08308531746031887 * sp[18] + -0.03397817460317261 * sp[18] + 0.04017857142857393 * sp[17];
    A[214] = -0.1240079365079383 * sp[19] + -0.1413690476190498 * sp[18] + 0.116567460317458 * sp[18] + 0.1428571428571438 * sp[17];
    A[215] = -0.0620039682539689 * sp[19] + -0.1029265873015888 * sp[18] + -0.2080853174603163 * sp[18] + -0.3139880952380974 * sp[17];
    A[216] = 0.07440476190476311 * sp[19] + 0.04712301587301668 * sp[18] + 0.01537698412698327 * sp[18] + -0.007936507936507678 * sp[17];
    A[217] = 0.004960317460317571 * sp[18] + -0.1458333333333375 * sp[18] + -0.07043650793651063 * sp[17];
    A[218] = -0.07440476190476306 * sp[19] + -0.02728174603174635 * sp[18] + -0.05902777777777918 * sp[18] + -0.003968253968253594 * sp[17];
    A[219] = -0.3507474113028561 * sp[19] + 0.03507474113028543 * sp[18] + 0.5401510134063875 * sp[18] + 0.3226876183986349 * sp[17];
    A[220] = 0.300703265202947 * sp[19] + 0.2792244605455818 * sp[18] + 0.1761261981902868 * sp[18] + 0.3007032652029414 * sp[17];
    A[221] = -0.6200396825396924 * sp[19] + 0.3596230158730228 * sp[18] + 3.395337301587297 * sp[18] + -0.6200396825397002 * sp[17];
    A[222] = 0.7014948226057121 * sp[19] + 0.3507474113028556 * sp[18] + 0.3507474113028551 * sp[18] + 0.2805979290422559 * sp[17];
    A[223] = -0.257745655888216 * sp[18] + -0.05154913117763341 * sp[18] + -0.1546473935329296 * sp[17];
    A[224] = 1.240079365079382 * sp[19] + 0.62003968253969 * sp[18] + 0.62003968253969 * sp[18] + 5.615079365079413 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "5ef7c449a95d7b424e9547ea1c3d1f06f62528b17ae4ce1a269846967409026af4c96e4c25d91f5b45e7fa670566e64f97f09f8d53deac0d681e42447247ea67";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    static const std::vector<std::size_t> position({});
    return position[i];
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return nullptr;
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_finite_element_2();
        break;
      }
    case 1:
      {
        return new forms_finite_element_2();
        break;
      }
    }
    
    return 0;
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_dofmap_2();
        break;
      }
    case 1:
      {
        return new forms_dofmap_2();
        break;
      }
    }
    
    return 0;
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return 0;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return 0;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return 0;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "108dafa0472311164e3d035eb30e30f4cf3ca036a1737d9e5ebc3b6566301b7e8745210ebbd68d48e8bf6b07ac5d7b23237e4d0bc8f94b17f4dc7d592b22029c";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    static const std::vector<std::size_t> position({});
    return position[i];
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return nullptr;
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_finite_element_2();
        break;
      }
    case 1:
      {
        return new forms_finite_element_2();
        break;
      }
    }
    
    return 0;
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_dofmap_2();
        break;
      }
    case 1:
      {
        return new forms_dofmap_2();
        break;
      }
    }
    
    return 0;
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return 0;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return 0;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return 0;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
