// Auto generated SWIG file for Python interface of DOLFIN
//
// Copyright (C) 2012-2016 Kristian B. Oelgaard, Tormod Landet
//
// This file is part of DOLFIN.
//
// DOLFIN is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// DOLFIN is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with DOLFIN. If not, see <http://www.gnu.org/licenses/>.
//

// SWIG docstrings generated by doxygen and generate_api_rst.py / parse_doxygen.py

%feature("docstring") dolfin::Amesos2LUSolver "
This class implements the direct solution (LU factorization) for linear systems of the form Ax = b. It is a wrapper for the Trilinos Amesos2 LU solver.
";

%feature("docstring") dolfin::Amesos2LUSolver::Amesos2LUSolver(std::shared_ptr< const TpetraMatrix > A, std::string method="default") "
Constructor. 

:param std\\:\\:shared_ptr< const TpetraMatrix > A: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::Amesos2LUSolver::Amesos2LUSolver(std::string method="default") "
Constructor. 

:param std\\:\\:string method:
";

%feature("docstring") dolfin::Amesos2LUSolver::get_operator() const "
Get operator (matrix) 

:rtype: const GenericLinearOperator &
";

%feature("docstring") dolfin::Amesos2LUSolver::init_solver(std::string &method) "
:param std\\:\\:string & method: 
:rtype: void
";

%feature("docstring") dolfin::Amesos2LUSolver::methods() "
Return a list of available solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::Amesos2LUSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::Amesos2LUSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::Amesos2LUSolver::set_operator(std::shared_ptr< const TpetraMatrix > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const TpetraMatrix > A: 
:rtype: void
";

%feature("docstring") dolfin::Amesos2LUSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::Amesos2LUSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::Amesos2LUSolver::solve(const TpetraMatrix &A, TpetraVector &x, const TpetraVector &b) "
Solve linear system Ax = b. 

:param const TpetraMatrix & A: 
:param TpetraVector & x: 
:param const TpetraVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::Amesos2LUSolver::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Amesos2LUSolver::~Amesos2LUSolver() "
Destructor.
";

%feature("docstring") dolfin::BelosKrylovSolver "
This class implements Krylov methods for linear systems of the form Ax = b. It is a wrapper for the Belos iterative solver from Trilinos 

Friends: :cpp:any:`Ifpack2Preconditioner`, :cpp:any:`MueluPreconditioner`.
";

%feature("docstring") dolfin::BelosKrylovSolver::BelosKrylovSolver(std::string method, std::shared_ptr< TrilinosPreconditioner > preconditioner) "
Create Krylov solver for a particular method and :cpp:any:`TrilinosPreconditioner` . 

:param std\\:\\:string method: 
:param std\\:\\:shared_ptr< TrilinosPreconditioner > preconditioner:
";

%feature("docstring") dolfin::BelosKrylovSolver::BelosKrylovSolver(std::string method="default", std::string preconditioner="default") "
Create Krylov solver for a particular method and names preconditioner 

:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::BelosKrylovSolver::check_dimensions(const TpetraMatrix &A, const GenericVector &x, const GenericVector &b) const "
:param const TpetraMatrix & A: 
:param const GenericVector & x: 
:param const GenericVector & b: 
:rtype: void
";

%feature("docstring") dolfin::BelosKrylovSolver::get_operator() const "
Get operator (matrix) 

:rtype: const TpetraMatrix &
";

%feature("docstring") dolfin::BelosKrylovSolver::init(const std::string &method) "
:param const std\\:\\:string & method: 
:rtype: void
";

%feature("docstring") dolfin::BelosKrylovSolver::methods() "
Return a list of available solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::BelosKrylovSolver::op_type "
Tpetra operator type. 

:rtype: Tpetra::Operator< double, int, dolfin::la_index, TpetraVector::node_type >
";

%feature("docstring") dolfin::BelosKrylovSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::BelosKrylovSolver::preconditioners() "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::BelosKrylovSolver::problem_type "
Belos problem type. 

:rtype: Belos::LinearProblem< double, TpetraVector::vector_type, op_type >
";

%feature("docstring") dolfin::BelosKrylovSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::BelosKrylovSolver::set_operators(std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P) "
:cpp:any:`Set`  operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > P: 
:rtype: void
";

%feature("docstring") dolfin::BelosKrylovSolver::set_options() "
:rtype: void
";

%feature("docstring") dolfin::BelosKrylovSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::BelosKrylovSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::BelosKrylovSolver::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::BelosKrylovSolver::~BelosKrylovSolver() "
Destructor.
";

%feature("docstring") dolfin::BlockMatrix "
Block :cpp:any:`Matrix` .
";

%feature("docstring") dolfin::BlockMatrix::BlockMatrix(std::size_t m=0, std::size_t n=0) "
Constructor. 

:param std\\:\\:size_t m: 
:param std\\:\\:size_t n:
";

%feature("docstring") dolfin::BlockMatrix::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::BlockMatrix::get_block(std::size_t i, std::size_t j) "
Get block. 

:param std\\:\\:size_t i: 
:param std\\:\\:size_t j: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::BlockMatrix::get_block(std::size_t i, std::size_t j) const "
Get block (const version) 

:param std\\:\\:size_t i: 
:param std\\:\\:size_t j: 
:rtype: std::shared_ptr< const GenericMatrix >
";

%feature("docstring") dolfin::BlockMatrix::matrices "
:rtype: boost::multi_array< std::shared_ptr< GenericMatrix >, 2 >
";

%feature("docstring") dolfin::BlockMatrix::mult(const BlockVector &x, BlockVector &y, bool transposed=false) const "
Matrix-vector product, y = Ax. 

:param const BlockVector & x: 
:param BlockVector & y: 
:param bool transposed: 
:rtype: void
";

%feature("docstring") dolfin::BlockMatrix::schur_approximation(bool symmetry=true) const "
Create a crude explicit Schur approximation of S = D - C A^-1 B of (A B; C D) If symmetry != 0, then the caller promises that B = symmetry * transpose(C). 

:param bool symmetry: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::BlockMatrix::set_block(std::size_t i, std::size_t j, std::shared_ptr< GenericMatrix > m) "
:cpp:any:`Set`  block. 

:param std\\:\\:size_t i: 
:param std\\:\\:size_t j: 
:param std\\:\\:shared_ptr< GenericMatrix > m: 
:rtype: void
";

%feature("docstring") dolfin::BlockMatrix::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::BlockMatrix::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::BlockMatrix::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::BlockMatrix::~BlockMatrix() "
Destructor.
";

%feature("docstring") dolfin::BlockVector "
Block vector.
";

%feature("docstring") dolfin::BlockVector::BlockVector(std::size_t n=0) "
Constructor. 

:param std\\:\\:size_t n:
";

%feature("docstring") dolfin::BlockVector::axpy(double a, const BlockVector &x) "
Add multiple of given vector (AXPY operation) 

:param double a: 
:param const BlockVector & x: 
:rtype: void
";

%feature("docstring") dolfin::BlockVector::copy() const "
Return copy of tensor. 

:rtype: BlockVector *
";

%feature("docstring") dolfin::BlockVector::empty() const "
Return true if empty. 

:rtype: bool
";

%feature("docstring") dolfin::BlockVector::get_block(std::size_t i) const "
Get sub-vector (const) 

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< const GenericVector >
";

%feature("docstring") dolfin::BlockVector::get_block(std::size_t) "
Get sub-vector (non-const) 

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::BlockVector::inner(const BlockVector &x) const "
Return inner product with given vector. 

:param const BlockVector & x: 
:rtype: double
";

%feature("docstring") dolfin::BlockVector::max() const "
Return maximum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::BlockVector::min() const "
Return minimum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::BlockVector::norm(std::string norm_type) const "
Return norm of vector. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::BlockVector::operator*=(double a) "
Multiply vector by given number. 

:param double a: 
:rtype: const BlockVector &
";

%feature("docstring") dolfin::BlockVector::operator+=(const BlockVector &x) "
Add given vector. 

:param const BlockVector & x: 
:rtype: const BlockVector &
";

%feature("docstring") dolfin::BlockVector::operator-=(const BlockVector &x) "
Subtract given vector. 

:param const BlockVector & x: 
:rtype: const BlockVector &
";

%feature("docstring") dolfin::BlockVector::operator/=(double a) "
Divide vector by given number. 

:param double a: 
:rtype: const BlockVector &
";

%feature("docstring") dolfin::BlockVector::operator=(const BlockVector &x) "
Assignment operator. 

:param const BlockVector & x: 
:rtype: const BlockVector &
";

%feature("docstring") dolfin::BlockVector::operator=(double a) "
Assignment operator. 

:param double a: 
:rtype: const BlockVector &
";

%feature("docstring") dolfin::BlockVector::set_block(std::size_t i, std::shared_ptr< GenericVector > v) "
:cpp:any:`Set`  function. 

:param std\\:\\:size_t i: 
:param std\\:\\:shared_ptr< GenericVector > v: 
:rtype: void
";

%feature("docstring") dolfin::BlockVector::size() const "
Number of vectors. 

:rtype: std::size_t
";

%feature("docstring") dolfin::BlockVector::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::BlockVector::vectors "
:rtype: std::vector< std::shared_ptr< GenericVector > >
";

%feature("docstring") dolfin::BlockVector::~BlockVector() "
Destructor.
";

%feature("docstring") dolfin::CoordinateMatrix "
Coordinate sparse matrix.
";

%feature("docstring") dolfin::CoordinateMatrix::CoordinateMatrix(const GenericMatrix &A, bool symmetric, bool base_one) "
Constructor. 

:param const GenericMatrix & A: 
:param bool symmetric: 
:param bool base_one:
";

%feature("docstring") dolfin::CoordinateMatrix::base_one() const "
Whether indices start from 0 (C-style) or 1 (FORTRAN-style) 

:rtype: bool
";

%feature("docstring") dolfin::CoordinateMatrix::columns() const "
Get column indices. 

:rtype: const std::vector< std::size_t > &
";

%feature("docstring") dolfin::CoordinateMatrix::mpi_comm() const "
Get MPI_Comm. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::CoordinateMatrix::norm(std::string norm_type) const "
Return norm of matrix. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::CoordinateMatrix::rows() const "
Get row indices. 

:rtype: const std::vector< std::size_t > &
";

%feature("docstring") dolfin::CoordinateMatrix::size(std::size_t dim) const "
Size 

:param std\\:\\:size_t dim:  (std::size_t) Dimension (0 or 1)
:rtype: std::size_t
";

%feature("docstring") dolfin::CoordinateMatrix::values() const "
Get values. 

:rtype: const std::vector< double > &
";

%feature("docstring") dolfin::CoordinateMatrix::~CoordinateMatrix() "
Destructor.
";

%feature("docstring") dolfin::DefaultFactory "
Default linear algebra factory based on global parameter \"linear_algebra_backend\".
";

%feature("docstring") dolfin::DefaultFactory::DefaultFactory() "
Constructor.
";

%feature("docstring") dolfin::DefaultFactory::create_krylov_solver(MPI_Comm comm, std::string method, std::string preconditioner) const "
Create Krylov solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:rtype: std::shared_ptr< dolfin::GenericLinearSolver >
";

%feature("docstring") dolfin::DefaultFactory::create_layout(std::size_t rank) const "
Create empty tensor layout. 

:param std\\:\\:size_t rank: 
:rtype: std::shared_ptr< TensorLayout >
";

%feature("docstring") dolfin::DefaultFactory::create_linear_operator(MPI_Comm comm) const "
Create empty linear operator. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericLinearOperator >
";

%feature("docstring") dolfin::DefaultFactory::create_lu_solver(MPI_Comm comm, std::string method) const "
Create LU solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: std::shared_ptr< dolfin::GenericLinearSolver >
";

%feature("docstring") dolfin::DefaultFactory::create_matrix(MPI_Comm comm) const "
Create empty matrix. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::DefaultFactory::create_vector(MPI_Comm comm) const "
Create empty vector. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::DefaultFactory::factory() "
Return instance of default backend. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::DefaultFactory::krylov_solver_methods() const "
Return a list of available Krylov solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::DefaultFactory::krylov_solver_preconditioners() const "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::DefaultFactory::lu_solver_methods() const "
Return a list of available LU solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::DefaultFactory::~DefaultFactory() "
Destructor.
";

%feature("docstring") dolfin::EigenFactory "
Eigen linear algebra factory.
";

%feature("docstring") dolfin::EigenFactory::EigenFactory() "

";

%feature("docstring") dolfin::EigenFactory::create_krylov_solver(MPI_Comm comm, std::string method, std::string preconditioner) const "
Create Krylov solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::EigenFactory::create_layout(std::size_t rank) const "
Create empty tensor layout. 

:param std\\:\\:size_t rank: 
:rtype: std::shared_ptr< TensorLayout >
";

%feature("docstring") dolfin::EigenFactory::create_linear_operator(MPI_Comm comm) const "
Create empty linear operator. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericLinearOperator >
";

%feature("docstring") dolfin::EigenFactory::create_lu_solver(MPI_Comm comm, std::string method) const "
Create LU solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::EigenFactory::create_matrix(MPI_Comm comm) const "
Create empty matrix. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::EigenFactory::create_vector(MPI_Comm comm) const "
Create empty vector. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::EigenFactory::factory "
:rtype: EigenFactory
";

%feature("docstring") dolfin::EigenFactory::instance() "
Return singleton instance. 

:rtype: EigenFactory &
";

%feature("docstring") dolfin::EigenFactory::krylov_solver_methods() const "
Return a list of available Krylov solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::EigenFactory::krylov_solver_preconditioners() const "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::EigenFactory::lu_solver_methods() const "
Return a list of available LU solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::EigenFactory::~EigenFactory() "
Destructor.
";

%feature("docstring") dolfin::EigenKrylovSolver "
This class implements Krylov methods for linear systems of the form Ax = b. It is a wrapper for the Krylov solvers of Eigen.
";

%feature("docstring") dolfin::EigenKrylovSolver::EigenKrylovSolver(std::string method="default", std::string preconditioner="default") "
Create Krylov solver for a particular method and names preconditioner 

:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::EigenKrylovSolver::call_solver(Solver &solver, GenericVector &x, const GenericVector &b) "
:param Solver & solver: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenKrylovSolver::get_operator() const "
Get operator (matrix) 

:rtype: std::shared_ptr< const EigenMatrix >
";

%feature("docstring") dolfin::EigenKrylovSolver::init(const std::string method, const std::string pc="default") "
:param const std\\:\\:string method: 
:param const std\\:\\:string pc: 
:rtype: void
";

%feature("docstring") dolfin::EigenKrylovSolver::methods() "
Return a list of available solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::EigenKrylovSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::EigenKrylovSolver::preconditioners() "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::EigenKrylovSolver::set_operator(std::shared_ptr< const EigenMatrix > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const EigenMatrix > A: 
:rtype: void
";

%feature("docstring") dolfin::EigenKrylovSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::EigenKrylovSolver::set_operators(std::shared_ptr< const EigenMatrix > A, std::shared_ptr< const EigenMatrix > P) "
:cpp:any:`Set`  operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const EigenMatrix > A: 
:param std\\:\\:shared_ptr< const EigenMatrix > P: 
:rtype: void
";

%feature("docstring") dolfin::EigenKrylovSolver::set_operators(std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P) "
:cpp:any:`Set`  operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > P: 
:rtype: void
";

%feature("docstring") dolfin::EigenKrylovSolver::solve(EigenVector &x, const EigenVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param EigenVector & x: 
:param const EigenVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenKrylovSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenKrylovSolver::solve(const EigenMatrix &A, EigenVector &x, const EigenVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param const EigenMatrix & A: 
:param EigenVector & x: 
:param const EigenVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenKrylovSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenKrylovSolver::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::EigenKrylovSolver::~EigenKrylovSolver() "
Destructor.
";

%feature("docstring") dolfin::EigenLUSolver "
This class implements the direct solution (LU factorization) for linear systems of the form Ax = b.
";

%feature("docstring") dolfin::EigenLUSolver::EigenLUSolver(std::shared_ptr< const EigenMatrix > A, std::string method="default") "
Constructor. 

:param std\\:\\:shared_ptr< const EigenMatrix > A: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::EigenLUSolver::EigenLUSolver(std::string method="default") "
Constructor. 

:param std\\:\\:string method:
";

%feature("docstring") dolfin::EigenLUSolver::call_solver(Solver &solver, GenericVector &x, const GenericVector &b) "
:param Solver & solver: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: void
";

%feature("docstring") dolfin::EigenLUSolver::get_operator() const "
Get operator (matrix) 

:rtype: const GenericLinearOperator &
";

%feature("docstring") dolfin::EigenLUSolver::methods() "
Return a list of available solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::EigenLUSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::EigenLUSolver::select_solver(const std::string method) const "
:param const std\\:\\:string method: 
:rtype: std::string
";

%feature("docstring") dolfin::EigenLUSolver::set_operator(std::shared_ptr< const EigenMatrix > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const EigenMatrix > A: 
:rtype: void
";

%feature("docstring") dolfin::EigenLUSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::EigenLUSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenLUSolver::solve(const EigenMatrix &A, EigenVector &x, const EigenVector &b) "
Solve linear system Ax = b. 

:param const EigenMatrix & A: 
:param EigenVector & x: 
:param const EigenVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenLUSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenLUSolver::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::EigenLUSolver::~EigenLUSolver() "
Destructor.
";

%feature("docstring") dolfin::EigenMatrix "
This class provides a sparse matrix class based on Eigen. It is a simple wrapper for Eigen::SparseMatrix implementing the :cpp:any:`GenericMatrix`  interface.
The interface is intentionally simple. For advanced usage, access the underlying Eigen matrix and use the standard Eigen interface which is documented at `http://eigen.tuxfamily.org <http://eigen.tuxfamily.org>`_
";

%feature("docstring") dolfin::EigenMatrix::EigenMatrix() "
Create empty matrix.
";

%feature("docstring") dolfin::EigenMatrix::EigenMatrix(const EigenMatrix &A) "
Copy constructor. 

:param const EigenMatrix & A:
";

%feature("docstring") dolfin::EigenMatrix::EigenMatrix(std::size_t M, std::size_t N) "
Create M x N matrix. 

:param std\\:\\:size_t M: 
:param std\\:\\:size_t N:
";

%feature("docstring") dolfin::EigenMatrix::add(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::add_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::axpy(double a, const GenericMatrix &A, bool same_nonzero_pattern) "
Add multiple of given matrix (AXPY operation) 

:param double a: 
:param const GenericMatrix & A: 
:param bool same_nonzero_pattern: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::compress() "
Compress matrix (eliminate all zeros from a sparse matrix) 

:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::copy() const "
Return copy of matrix. 

:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::EigenMatrix::data() const "
Return pointers to underlying compressed storage data See :cpp:any:`GenericMatrix`  for documentation. 

:rtype: std::tuple< const int *, const int *, const double *, std::size_t >
";

%feature("docstring") dolfin::EigenMatrix::eigen_matrix_type "
Eigen :cpp:any:`Matrix`  type. 

:rtype: Eigen::SparseMatrix< double, Eigen::RowMajor, int >
";

%feature("docstring") dolfin::EigenMatrix::empty() const "
Return true if empty. 

:rtype: bool
";

%feature("docstring") dolfin::EigenMatrix::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::EigenMatrix::get(double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) const "
Get block of values. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::get_diagonal(GenericVector &x) const "
Get diagonal of a matrix. 

:param GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::getrow(std::size_t row, std::vector< std::size_t > &columns, std::vector< double > &values) const "
Get non-zero values of given row. 

:param std\\:\\:size_t row: 
:param std\\:\\:vector< std\\:\\:size_t > & columns: 
:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::ident(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::ident_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using tenor layout. 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::init_vector(GenericVector &z, std::size_t dim) const "
Initialise vector z to be compatible with the matrix-vector product y = Ax. 

:param GenericVector & z:  (:cpp:any:`GenericVector` &) :cpp:any:`Vector`  to initialise
:param std\\:\\:size_t dim:  (std::size_t) The dimension (axis): dim = 0 --> z = y, dim = 1 --> z = x
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::local_range(std::size_t dim) const "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::EigenMatrix::mat() "
Return reference to Eigen matrix (non-const version) 

:rtype: eigen_matrix_type &
";

%feature("docstring") dolfin::EigenMatrix::mat() const "
Return reference to Eigen matrix (const version) 

:rtype: const eigen_matrix_type &
";

%feature("docstring") dolfin::EigenMatrix::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::EigenMatrix::mult(const GenericVector &x, GenericVector &y) const "
Matrix-vector product, y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::nnz() const "
Return number of non-zero entries in matrix. 

:rtype: std::size_t
";

%feature("docstring") dolfin::EigenMatrix::norm(std::string norm_type) const "
Return norm of matrix. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::EigenMatrix::operator()(dolfin::la_index i, dolfin::la_index j) const "
Access value of given entry. 

:param dolfin\\:\\:la_index i: 
:param dolfin\\:\\:la_index j: 
:rtype: double
";

%feature("docstring") dolfin::EigenMatrix::operator*=(double a) "
Multiply matrix by given number. 

:param double a: 
:rtype: const EigenMatrix &
";

%feature("docstring") dolfin::EigenMatrix::operator/=(double a) "
Divide matrix by given number. 

:param double a: 
:rtype: const EigenMatrix &
";

%feature("docstring") dolfin::EigenMatrix::operator=(const EigenMatrix &A) "
Assignment operator. 

:param const EigenMatrix & A: 
:rtype: const EigenMatrix &
";

%feature("docstring") dolfin::EigenMatrix::operator=(const GenericMatrix &A) "
Assignment operator. 

:param const GenericMatrix & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::EigenMatrix::resize(std::size_t M, std::size_t N) "
Resize matrix to M x N. 

:param std\\:\\:size_t M: 
:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::set(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::set_diagonal(const GenericVector &x) "
:cpp:any:`Set`  diagonal of a matrix. 

:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::set_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::setrow(std::size_t row_idx, const std::vector< std::size_t > &columns, const std::vector< double > &values) "
:cpp:any:`Set`  values for given row. 

:param std\\:\\:size_t row_idx: 
:param const std\\:\\:vector< std\\:\\:size_t > & columns: 
:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::EigenMatrix::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::EigenMatrix::transpmult(const GenericVector &x, GenericVector &y) const "
Matrix-vector product, y = A^T x. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::zero(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::zero_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenMatrix::~EigenMatrix() "
Destructor.
";

%feature("docstring") dolfin::EigenVector "
This class provides a simple vector class based on Eigen. It is a simple wrapper for a Eigen vector implementing the :cpp:any:`GenericVector`  interface.
The interface is intentionally simple. For advanced usage, access the underlying Eigen vector and use the standard Eigen interface which is documented at `http://eigen.tuxfamily.org <http://eigen.tuxfamily.org>`_
";

%feature("docstring") dolfin::EigenVector::EigenVector() "
Create empty vector (on MPI_COMM_SELF)
";

%feature("docstring") dolfin::EigenVector::EigenVector(MPI_Comm comm) "
Create empty vector. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::EigenVector::EigenVector(MPI_Comm comm, std::size_t N) "
Create vector of size N. 

:param MPI_Comm comm: 
:param std\\:\\:size_t N:
";

%feature("docstring") dolfin::EigenVector::EigenVector(const EigenVector &x) "
Copy constructor. 

:param const EigenVector & x:
";

%feature("docstring") dolfin::EigenVector::EigenVector(std::shared_ptr< Eigen::VectorXd > x) "
Construct vector from an Eigen shared_ptr. 

:param std\\:\\:shared_ptr< Eigen\\:\\:VectorXd > x:
";

%feature("docstring") dolfin::EigenVector::abs() "
Replace all entries in the vector by their absolute values. 

:rtype: void
";

%feature("docstring") dolfin::EigenVector::add(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::add_local(const Array< double > &values) "
Add values to each entry on local process. 

:param const Array< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::add_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::axpy(double a, const GenericVector &x) "
Add multiple of given vector (AXPY operation) 

:param double a: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::check_mpi_size(const MPI_Comm comm) "
:param const MPI_Comm comm: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::copy() const "
Create copy of tensor. 

:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::EigenVector::data() "
Return pointer to underlying data. 

:rtype: double *
";

%feature("docstring") dolfin::EigenVector::data() const "
Return pointer to underlying data (const version) 

:rtype: const double *
";

%feature("docstring") dolfin::EigenVector::empty() const "
Return true if vector is empty. 

:rtype: bool
";

%feature("docstring") dolfin::EigenVector::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::EigenVector::gather(GenericVector &x, const std::vector< dolfin::la_index > &indices) const "
Gather entries into local vector x. 

:param GenericVector & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::gather(std::vector< double > &x, const std::vector< dolfin::la_index > &indices) const "
Gather entries into x. 

:param std\\:\\:vector< double > & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::gather_on_zero(std::vector< double > &x) const "
Gather all entries into x on process 0. 

:param std\\:\\:vector< double > & x: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::get(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using global indices. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::get_local(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using local indices. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::get_local(std::vector< double > &values) const "
Get all values on local process. 

:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::init(std::pair< std::size_t, std::size_t > range) "
Resize vector with given ownership range. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::init(std::pair< std::size_t, std::size_t > range, const std::vector< std::size_t > &local_to_global_map, const std::vector< la_index > &ghost_indices) "
Resize vector with given ownership range and with ghost values. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:param const std\\:\\:vector< std\\:\\:size_t > & local_to_global_map: 
:param const std\\:\\:vector< la_index > & ghost_indices: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::init(std::size_t N) "
Initialize vector to size N. 

:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::inner(const GenericVector &x) const "
Return inner product with given vector. 

:param const GenericVector & x: 
:rtype: double
";

%feature("docstring") dolfin::EigenVector::local_range() const "
Return local ownership range of a vector. 

:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::EigenVector::local_size() const "
Return local size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::EigenVector::max() const "
Return maximum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::EigenVector::min() const "
Return minimum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::EigenVector::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::EigenVector::norm(std::string norm_type) const "
Compute norm of vector. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::EigenVector::operator*=(const GenericVector &x) "
Multiply vector by another vector pointwise. 

:param const GenericVector & x: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator*=(double a) "
Multiply vector by given number. 

:param double a: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator+=(const GenericVector &x) "
Add given vector. 

:param const GenericVector & x: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator+=(double a) "
Add number to all components of a vector. 

:param double a: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator-=(const GenericVector &x) "
Subtract given vector. 

:param const GenericVector & x: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator-=(double a) "
Subtract number from all components of a vector. 

:param double a: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator/=(double a) "
Divide vector by given number. 

:param double a: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator=(const EigenVector &x) "
Assignment operator. 

:param const EigenVector & x: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator=(const GenericVector &x) "
Assignment operator. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::EigenVector::operator=(double a) "
Assignment operator. 

:param double a: 
:rtype: const EigenVector &
";

%feature("docstring") dolfin::EigenVector::operator[](dolfin::la_index i) "
Access value of given entry (non-const version) 

:param dolfin\\:\\:la_index i: 
:rtype: double &
";

%feature("docstring") dolfin::EigenVector::operator[](dolfin::la_index i) const "
Access value of given entry (const version) 

:param dolfin\\:\\:la_index i: 
:rtype: double
";

%feature("docstring") dolfin::EigenVector::owns_index(std::size_t i) const "
Determine whether global vector index is owned by this process. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::EigenVector::resize(std::size_t N) "
Resize vector to size N. 

:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::set(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::set_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::set_local(const std::vector< double > &values) "
:cpp:any:`Set`  all values on local process. 

:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::EigenVector::size() const "
Return true if vector is empty. 

:rtype: std::size_t
";

%feature("docstring") dolfin::EigenVector::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::EigenVector::sum() const "
Return sum of values of vector. 

:rtype: double
";

%feature("docstring") dolfin::EigenVector::sum(const Array< std::size_t > &rows) const "
Return sum of selected rows in vector. Repeated entries are only summed once. 

:param const Array< std\\:\\:size_t > & rows: 
:rtype: double
";

%feature("docstring") dolfin::EigenVector::vec() "
Return reference to Eigen vector (non-const version) 

:rtype: Eigen::VectorXd &
";

%feature("docstring") dolfin::EigenVector::vec() const "
Return reference to Eigen vector (const version) 

:rtype: const Eigen::VectorXd &
";

%feature("docstring") dolfin::EigenVector::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::EigenVector::~EigenVector() "
Destructor.
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory "
Base class for LinearAlgebra factories.
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::GenericLinearAlgebraFactory() "
Constructor.
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::create_krylov_solver(MPI_Comm comm, std::string method, std::string preconditioner) const  "
Create Krylov solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::create_layout(std::size_t rank) const  "
Create empty tensor layout. 

:param std\\:\\:size_t rank: 
:rtype: std::shared_ptr< TensorLayout >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::create_linear_operator(MPI_Comm comm) const  "
Create empty linear operator. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericLinearOperator >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::create_lu_solver(MPI_Comm comm, std::string method) const  "
Create LU solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::create_matrix(MPI_Comm comm) const  "
Create empty matrix. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::create_vector(MPI_Comm comm) const  "
Create empty vector. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::krylov_solver_methods() const "
Return a list of available Krylov solver methods. This function should be overloaded by subclass if non-empty. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::krylov_solver_preconditioners() const "
Return a list of available preconditioners. This function should be overloaded by subclass if non-empty. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::lu_solver_methods() const "
Return a list of available LU solver methods. This function should be overloaded by subclass if non-empty. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::GenericLinearAlgebraFactory::~GenericLinearAlgebraFactory() "
Destructor.
";

%feature("docstring") dolfin::GenericLinearOperator "
This class defines a common interface for linear operators, including actual matrices (class :cpp:any:`GenericMatrix` ) and linear operators only defined in terms of their action on vectors.
This class is used internally by DOLFIN to define a class hierarchy of backend independent linear operators and solvers. Users should not interface to this class directly but instead use the :cpp:any:`LinearOperator`  class. 

Friends: :cpp:any:`LinearOperator`.
";

%feature("docstring") dolfin::GenericLinearOperator::init_layout(const GenericVector &x, const GenericVector &y, GenericLinearOperator *wrapper) "
Initialize linear operator to match parallel layout of vectors x and y for product y = Ax. Needs to be implemented by backend. 

:param const GenericVector & x: 
:param const GenericVector & y: 
:param GenericLinearOperator * wrapper: 
:rtype: void
";

%feature("docstring") dolfin::GenericLinearOperator::mult(const GenericVector &x, GenericVector &y) const  "
Compute matrix-vector product y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::GenericLinearOperator::size(std::size_t dim) const  "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericLinearOperator::str(bool verbose) const  "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::GenericLinearOperator::~GenericLinearOperator() "

";

%feature("docstring") dolfin::GenericLinearSolver "
This class provides a general solver for linear systems Ax = b.
";

%feature("docstring") dolfin::GenericLinearSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::GenericLinearSolver::require_matrix(const GenericLinearOperator &A) "
Down-cast :cpp:any:`GenericLinearOperator`  to :cpp:any:`GenericMatrix`  when an actual matrix is required, not only a linear operator. This is the const reference version of the down-cast. 

:param const GenericLinearOperator & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::GenericLinearSolver::require_matrix(std::shared_ptr< const GenericLinearOperator > A) "
Down-cast :cpp:any:`GenericLinearOperator`  to :cpp:any:`GenericMatrix`  when an actual matrix is required, not only a linear operator. This is the const reference version of the down-cast. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: std::shared_ptr< const GenericMatrix >
";

%feature("docstring") dolfin::GenericLinearSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::GenericLinearSolver::set_operators(std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P) "
:cpp:any:`Set`  operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > P: 
:rtype: void
";

%feature("docstring") dolfin::GenericLinearSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericLinearSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericLinearSolver::update_parameters(const Parameters &parameters) "
Update solver parameters (useful for :cpp:any:`LinearSolver`  wrapper) 

:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix "
This class defines a common interface for matrices.
";

%feature("docstring") dolfin::GenericMatrix::add(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::add(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using global indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::add(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::add_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::add_local(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using local indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::add_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::axpy(double a, const GenericMatrix &A, bool same_nonzero_pattern) "
Add multiple of given matrix (AXPY operation) 

:param double a: 
:param const GenericMatrix & A: 
:param bool same_nonzero_pattern: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::copy() const  "
Return copy of matrix. 

:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::GenericMatrix::get(double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) const "
Get block of values. 

:param double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::get(double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) const  "
Get block of values. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::get_diagonal(GenericVector &x) const  "
Get diagonal of a matrix. 

:param GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::getitem(std::pair< dolfin::la_index, dolfin::la_index > ij) const "
Get value of given entry. 

:param std\\:\\:pair< dolfin\\:\\:la_index, dolfin\\:\\:la_index > ij: 
:rtype: double
";

%feature("docstring") dolfin::GenericMatrix::getrow(std::size_t row, std::vector< std::size_t > &columns, std::vector< double > &values) const  "
Get non-zero values of given row (global index) on local process. 

:param std\\:\\:size_t row: 
:param std\\:\\:vector< std\\:\\:size_t > & columns: 
:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::ident(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::ident_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::ident_zeros() "
Insert one on the diagonal for all zero rows. 

:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::init_vector(GenericVector &z, std::size_t dim) const  "
Initialize vector z to be compatible with the matrix-vector product y = Ax. In the parallel case, both size and layout are important.

:param GenericVector & z:  (:cpp:any:`GenericVector` &) :cpp:any:`Vector`  to initialise
:param std\\:\\:size_t dim:  (std::size_t) The dimension (axis): dim = 0 --> z = y, dim = 1 --> z = x
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::is_symmetric(double tol) const "
Test if matrix is symmetric. 

:param double tol: 
:rtype: bool
";

%feature("docstring") dolfin::GenericMatrix::local_range(std::size_t dim) const  "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::GenericMatrix::nnz() const  "
Return number of non-zero entries in matrix (collective) 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericMatrix::norm(std::string norm_type) const  "
Return norm of matrix. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::GenericMatrix::operator()(dolfin::la_index i, dolfin::la_index j) const "
Get value of given entry. 

:param dolfin\\:\\:la_index i: 
:param dolfin\\:\\:la_index j: 
:rtype: double
";

%feature("docstring") dolfin::GenericMatrix::operator*=(double a) "
Multiply matrix by given number. 

:param double a: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::GenericMatrix::operator+=(const GenericMatrix &A) "
Add given matrix. 

:param const GenericMatrix & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::GenericMatrix::operator-=(const GenericMatrix &A) "
Subtract given matrix. 

:param const GenericMatrix & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::GenericMatrix::operator/=(double a) "
Divide matrix by given number. 

:param double a: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::GenericMatrix::operator=(const GenericMatrix &x) "
Assignment operator. 

:param const GenericMatrix & x: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::GenericMatrix::rank() const "
Return tensor rank (number of dimensions) 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericMatrix::set(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::set(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::set_diagonal(const GenericVector &x) "
:cpp:any:`Set`  diagonal of a matrix. 

:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::set_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::set_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::setitem(std::pair< dolfin::la_index, dolfin::la_index > ij, double value) "
:cpp:any:`Set`  given entry to value. apply(\"insert\") must be called before using using the object. 

:param std\\:\\:pair< dolfin\\:\\:la_index, dolfin\\:\\:la_index > ij: 
:param double value: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::setrow(std::size_t row, const std::vector< std::size_t > &columns, const std::vector< double > &values) "
:cpp:any:`Set`  values for given row (global index) on local process. 

:param std\\:\\:size_t row: 
:param const std\\:\\:vector< std\\:\\:size_t > & columns: 
:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::size(std::size_t dim) const  "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericMatrix::str(bool verbose) const  "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::GenericMatrix::transpmult(const GenericVector &x, GenericVector &y) const  "
Matrix-vector product, y = A^T x. The y vector must either be zero-sized or have correct size and parallel layout. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::zero(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::zero_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericMatrix::~GenericMatrix() "
Destructor.
";

%feature("docstring") dolfin::GenericTensor "
A common interface for arbitrary rank tensors.
";

%feature("docstring") dolfin::GenericTensor::add(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::add(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using global indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::add_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::add_local(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using local indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::empty() const  "
Return true if empty. 

:rtype: bool
";

%feature("docstring") dolfin::GenericTensor::factory() const  "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::GenericTensor::get(double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) const  "
Get block of values. 

:param double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using tensor layout. 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::local_range(std::size_t dim) const  "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::GenericTensor::rank() const  "
Return tensor rank (number of dimensions) 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericTensor::set(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::set_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericTensor::size(std::size_t dim) const  "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericTensor::str(bool verbose) const  "
Return :cpp:any:`MPI`  communicator. 
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::GenericTensor::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::GenericTensor::~GenericTensor() "
Destructor.
";

%feature("docstring") dolfin::GenericVector "
This class defines a common interface for vectors.
";

%feature("docstring") dolfin::GenericVector::abs() "
Replace all entries in the vector by their absolute values. 

:rtype: void
";

%feature("docstring") dolfin::GenericVector::add(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::add(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using global indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::add(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::add_local(const Array< double > &values) "
Add values to each entry on local process. 

:param const Array< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::add_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::add_local(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using local indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::add_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::axpy(double a, const GenericVector &x) "
Add multiple of given vector (AXPY operation) 

:param double a: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::copy() const  "
Return copy of vector. 

:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::GenericVector::gather(GenericVector &x, const std::vector< dolfin::la_index > &indices) const  "
Gather entries (given by global indices) into local vector x 

:param GenericVector & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::gather(std::vector< double > &x, const std::vector< dolfin::la_index > &indices) const  "
Gather entries (given by global indices) into x. 

:param std\\:\\:vector< double > & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::gather_on_zero(std::vector< double > &x) const  "
Gather all entries into x on process 0. 

:param std\\:\\:vector< double > & x: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::get(double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) const "
Get block of values using global indices. 

:param double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::get(double *block, std::size_t m, const dolfin::la_index *rows) const  "
Get block of values using global indices (values must all live on the local process, ghosts cannot be accessed) 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::get_local(double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) const "
Get block of values using local indices. 

:param double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::get_local(double *block, std::size_t m, const dolfin::la_index *rows) const  "
Get block of values using local indices (values must all live on the local process, ghost are accessible) 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::get_local(std::vector< double > &values) const  "
Get all values on local process. 

:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::getitem(dolfin::la_index i) const "
Get value of given entry. 

:param dolfin\\:\\:la_index i: 
:rtype: double
";

%feature("docstring") dolfin::GenericVector::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using sparsity pattern FIXME: This needs to be implemented on backend side! Remove it! 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::init(std::pair< std::size_t, std::size_t > range) "
Initialize vector with given local ownership range. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::init(std::pair< std::size_t, std::size_t > range, const std::vector< std::size_t > &local_to_global_map, const std::vector< la_index > &ghost_indices) "
Initialise vector with given ownership range and with ghost values FIXME: Reimplement using :cpp:any:`init(const TensorLayout&)`  and deprecate 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:param const std\\:\\:vector< std\\:\\:size_t > & local_to_global_map: 
:param const std\\:\\:vector< la_index > & ghost_indices: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::init(std::size_t N) "
Initialize vector to global size N. 

:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::inner(const GenericVector &x) const  "
Return inner product with given vector. 

:param const GenericVector & x: 
:rtype: double
";

%feature("docstring") dolfin::GenericVector::local_range() const  "
Return local ownership range of a vector. 

:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::GenericVector::local_range(std::size_t dim) const "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::GenericVector::local_size() const  "
Return local size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericVector::max() const  "
Return maximum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::GenericVector::min() const  "
Return minimum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::GenericVector::norm(std::string norm_type) const  "
Return norm of vector. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::GenericVector::operator*=(const GenericVector &x) "
Multiply vector by another vector pointwise. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator*=(double a) "
Multiply vector by given number. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator+=(const GenericVector &x) "
Add given vector. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator+=(double a) "
Add number to all components of a vector. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator-=(const GenericVector &x) "
Subtract given vector. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator-=(double a) "
Subtract number from all components of a vector. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator/=(double a) "
Divide vector by given number. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator=(const GenericVector &x) "
Assignment operator. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator=(double a) "
Assignment operator. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::GenericVector::operator[](dolfin::la_index i) const "
Get value of given entry. 

:param dolfin\\:\\:la_index i: 
:rtype: double
";

%feature("docstring") dolfin::GenericVector::owns_index(std::size_t i) const  "
Determine whether global vector index is owned by this process. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::GenericVector::rank() const "
Return tensor rank (number of dimensions) 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericVector::set(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::set(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::set_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::set_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::set_local(const std::vector< double > &values) "
:cpp:any:`Set`  all values on local process. 

:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::setitem(dolfin::la_index i, double value) "
:cpp:any:`Set`  given entry to value. apply(\"insert\") should be called before using using the object. 

:param dolfin\\:\\:la_index i: 
:param double value: 
:rtype: void
";

%feature("docstring") dolfin::GenericVector::size() const  "
Return global size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::GenericVector::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::GenericVector::str(bool verbose) const  "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::GenericVector::sum() const  "
Return sum of vector. 

:rtype: double
";

%feature("docstring") dolfin::GenericVector::sum(const Array< std::size_t > &rows) const  "
Return sum of selected rows in vector. Repeated entries are only summed once. 

:param const Array< std\\:\\:size_t > & rows: 
:rtype: double
";

%feature("docstring") dolfin::GenericVector::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::GenericVector::~GenericVector() "
Destructor.
";

%feature("docstring") dolfin::Ifpack2Preconditioner "
Implements preconditioners using Ifpack2 from Trilinos.
";

%feature("docstring") dolfin::Ifpack2Preconditioner::Ifpack2Preconditioner(std::string type="default") "
Create a particular preconditioner object. 

:param std\\:\\:string type:
";

%feature("docstring") dolfin::Ifpack2Preconditioner::init(std::shared_ptr< const TpetraMatrix > P) "
Initialise preconditioner based on Operator P. 

:param std\\:\\:shared_ptr< const TpetraMatrix > P: 
:rtype: void
";

%feature("docstring") dolfin::Ifpack2Preconditioner::prec_type "
:rtype: Ifpack2::Preconditioner< double, int, dolfin::la_index, TpetraVector::node_type >
";

%feature("docstring") dolfin::Ifpack2Preconditioner::preconditioners() "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::Ifpack2Preconditioner::set(BelosKrylovSolver &solver) "
:cpp:any:`Set`  the preconditioner type on a solver. 

:param BelosKrylovSolver & solver: 
:rtype: void
";

%feature("docstring") dolfin::Ifpack2Preconditioner::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Ifpack2Preconditioner::~Ifpack2Preconditioner() "
Destructor.
";

%feature("docstring") dolfin::IndexMap "
This class represents the distribution index arrays across processes. An index array is a contiguous collection of N+1 indices [0, 1, . . ., N] that are distributed across processes M processes. On a given process, the :cpp:any:`IndexMap`  stores a portion of the index set using local indices [0, 1, . . . , n], and a map from the local indices to a unique global index.
";

%feature("docstring") dolfin::IndexMap::IndexMap() "
Constructor.
";

%feature("docstring") dolfin::IndexMap::IndexMap(MPI_Comm mpi_comm) "
Index map with no data. 

:param MPI_Comm mpi_comm:
";

%feature("docstring") dolfin::IndexMap::IndexMap(MPI_Comm mpi_comm, std::size_t local_size, std::size_t block_size) "
Index map with local size on each process. This constructor is collective 

:param MPI_Comm mpi_comm: 
:param std\\:\\:size_t local_size: 
:param std\\:\\:size_t block_size:
";

%feature("docstring") dolfin::IndexMap::MapSize "
MapSize (ALL = all local indices, OWNED = owned local indices, UNOWNED = unowned local indices, GLOBAL = total indices globally) 

.. cpp:enumerator:: dolfin::IndexMap::MapSize::ALL = 0

.. cpp:enumerator:: dolfin::IndexMap::MapSize::OWNED = 1

.. cpp:enumerator:: dolfin::IndexMap::MapSize::UNOWNED = 2

.. cpp:enumerator:: dolfin::IndexMap::MapSize::GLOBAL = 3
";

%feature("docstring") dolfin::IndexMap::block_size() const "
Get block size. 

:rtype: int
";

%feature("docstring") dolfin::IndexMap::global_index_owner(std::size_t index) const "
Get process owner of any global index. 

:param std\\:\\:size_t index: 
:rtype: int
";

%feature("docstring") dolfin::IndexMap::init(std::size_t local_size, std::size_t block_size) "
Initialise with number of local entries and block size. This function is collective 

:param std\\:\\:size_t local_size: 
:param std\\:\\:size_t block_size: 
:rtype: void
";

%feature("docstring") dolfin::IndexMap::local_range() const "
Local range of indices. 

:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::IndexMap::local_to_global(std::size_t i) const "
Get global index of local index i. 

:param std\\:\\:size_t i: 
:rtype: std::size_t
";

%feature("docstring") dolfin::IndexMap::local_to_global_unowned() const "
Get local to global map for unowned indices (local indexing beyond end of local range) 

:rtype: const std::vector< std::size_t > &
";

%feature("docstring") dolfin::IndexMap::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::IndexMap::off_process_owner() const "
Get off process owner for unowned indices. 

:rtype: const std::vector< int > &
";

%feature("docstring") dolfin::IndexMap::set_local_to_global(const std::vector< std::size_t > &indices) "
:cpp:any:`Set`  local_to_global map for unowned indices (beyond end of local range). Computes and stores off-process owner array. 

:param const std\\:\\:vector< std\\:\\:size_t > & indices: 
:rtype: void
";

%feature("docstring") dolfin::IndexMap::size(MapSize type) const "
Get number of local indices of type MapSize::OWNED, MapSize::UNOWNED, MapSize::ALL or MapSize::GLOBAL 

:param MapSize type: 
:rtype: std::size_t
";

%feature("docstring") dolfin::IndexMap::~IndexMap() "
Destructor.
";

%feature("docstring") dolfin::KrylovSolver "
This class defines an interface for a Krylov solver. The appropriate solver is chosen on the basis of the matrix/vector type.
";

%feature("docstring") dolfin::KrylovSolver::KrylovSolver(MPI_Comm comm, std::shared_ptr< const GenericLinearOperator > A, std::string method="default", std::string preconditioner="default") "
Constructor. 

:param MPI_Comm comm: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::KrylovSolver::KrylovSolver(MPI_Comm comm, std::string method="default", std::string preconditioner="default") "
Constructor. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::KrylovSolver::KrylovSolver(std::shared_ptr< const GenericLinearOperator > A, std::string method="default", std::string preconditioner="default") "
Constructor. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::KrylovSolver::KrylovSolver(std::string method="default", std::string preconditioner="default") "
Constructor. 

:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::KrylovSolver::init(std::string method, std::string preconditioner, MPI_Comm comm) "
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:param MPI_Comm comm: 
:rtype: void
";

%feature("docstring") dolfin::KrylovSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::KrylovSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::KrylovSolver::set_operators(std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P) "
:cpp:any:`Set`  operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > P: 
:rtype: void
";

%feature("docstring") dolfin::KrylovSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::KrylovSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::KrylovSolver::solver "
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::KrylovSolver::update_parameters(const Parameters &parameters) "
Update solver parameters (pass parameters down to wrapped implementation) 

:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::KrylovSolver::~KrylovSolver() "
Destructor.
";

%feature("docstring") dolfin::LUSolver "
LU solver for the built-in LA backends.
";

%feature("docstring") dolfin::LUSolver::LUSolver(MPI_Comm comm, std::shared_ptr< const GenericLinearOperator > A, std::string method="default") "
Constructor. 

:param MPI_Comm comm: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::LUSolver::LUSolver(MPI_Comm comm, std::string method="default") "
Constructor. 

:param MPI_Comm comm: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::LUSolver::LUSolver(std::shared_ptr< const GenericLinearOperator > A, std::string method="default") "
Constructor. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::LUSolver::LUSolver(std::string method="default") "
Constructor. 

:param std\\:\\:string method:
";

%feature("docstring") dolfin::LUSolver::init(MPI_Comm comm, std::string method) "
:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: void
";

%feature("docstring") dolfin::LUSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::LUSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::LUSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::LUSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::LUSolver::solver "
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::LUSolver::update_parameters(const Parameters &parameters) "
Update solver parameters (pass parameters down to wrapped implementation) 

:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::LUSolver::~LUSolver() "
Destructor.
";

%feature("docstring") dolfin::LinearAlgebraObject "
This is a common base class for all DOLFIN linear algebra objects. In particular, it provides casting mechanisms between different types.
";

%feature("docstring") dolfin::LinearAlgebraObject::down_cast() "
Cast object to its derived class, if possible (non-const version). An error is thrown if the cast is unsuccessful. 

:rtype: T &
";

%feature("docstring") dolfin::LinearAlgebraObject::down_cast() const "
Cast object to its derived class, if possible (const version). An error is thrown if the cast is unsuccessful. 

:rtype: const T &
";

%feature("docstring") dolfin::LinearAlgebraObject::down_cast(std::shared_ptr< Y > A) "
Cast shared pointer object to its derived class, if possible. Caller must check for success (returns null if cast fails). 

:param std\\:\\:shared_ptr< Y > A: 
:rtype: std::shared_ptr< X >
";

%feature("docstring") dolfin::LinearAlgebraObject::instance() "
Return concrete instance / unwrap (non-const version) 

:rtype: LinearAlgebraObject *
";

%feature("docstring") dolfin::LinearAlgebraObject::instance() const "
Return concrete instance / unwrap (const version) 

:rtype: const LinearAlgebraObject *
";

%feature("docstring") dolfin::LinearAlgebraObject::mpi_comm() const  "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::LinearAlgebraObject::shared_instance() "
Return concrete shared ptr instance / unwrap (non-const version) 

:rtype: std::shared_ptr< LinearAlgebraObject >
";

%feature("docstring") dolfin::LinearAlgebraObject::shared_instance() const "
Return concrete shared ptr instance / unwrap (const version) 

:rtype: std::shared_ptr< const LinearAlgebraObject >
";

%feature("docstring") dolfin::LinearOperator "
This class defines an interface for linear operators defined only in terms of their action (matrix-vector product) and can be used for matrix-free solution of linear systems. The linear algebra backend is decided at run-time based on the present value of the \"linear_algebra_backend\" parameter.
To define a linear operator, users need to inherit from this class and overload the function mult(x, y) which defines the action of the matrix on the vector x as y = Ax.
";

%feature("docstring") dolfin::LinearOperator::LinearOperator() "
Create linear operator.
";

%feature("docstring") dolfin::LinearOperator::LinearOperator(const GenericVector &x, const GenericVector &y) "
Create linear operator to match parallel layout of vectors x and y for product y = Ax. 

:param const GenericVector & x: 
:param const GenericVector & y:
";

%feature("docstring") dolfin::LinearOperator::instance() "
Return concrete instance / unwrap (non-const version) 

:rtype: GenericLinearOperator *
";

%feature("docstring") dolfin::LinearOperator::instance() const "
Return concrete instance / unwrap (const version) 

:rtype: const GenericLinearOperator *
";

%feature("docstring") dolfin::LinearOperator::mpi_comm() const "
Return the :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::LinearOperator::mult(const GenericVector &x, GenericVector &y) const  "
Compute matrix-vector product y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::LinearOperator::shared_instance() "
Return concrete instance / unwrap (shared pointer version) 

:rtype: std::shared_ptr< LinearAlgebraObject >
";

%feature("docstring") dolfin::LinearOperator::shared_instance() const "
Return concrete instance / unwrap (const shared pointer version) 

:rtype: std::shared_ptr< const LinearAlgebraObject >
";

%feature("docstring") dolfin::LinearOperator::size(std::size_t dim) const  "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::LinearOperator::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::LinearOperator::~LinearOperator() "
Destructor.
";

%feature("docstring") dolfin::LinearSolver "
This class provides a general solver for linear systems Ax = b. 

Friends: :cpp:any:`KrylovSolver`, :cpp:any:`LUSolver`, :cpp:any:`LinearVariationalSolver`, :cpp:any:`NewtonSolver`.
";

%feature("docstring") dolfin::LinearSolver::LinearSolver(MPI_Comm comm, std::string method="default", std::string preconditioner="default") "
Create linear solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::LinearSolver::LinearSolver(std::string method="default", std::string preconditioner="default") "
Create linear solver. 

:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::LinearSolver::in_list(const std::string &method, const std::map< std::string, std::string > &methods) "
:param const std\\:\\:string & method: 
:param const std\\:\\:map< std\\:\\:string, std\\:\\:string > & methods: 
:rtype: bool
";

%feature("docstring") dolfin::LinearSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::LinearSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  the operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::LinearSolver::set_operators(std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P) "
:cpp:any:`Set`  the operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > P: 
:rtype: void
";

%feature("docstring") dolfin::LinearSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::LinearSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::LinearSolver::solver "
:rtype: std::unique_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::LinearSolver::update_parameters(const Parameters &parameters) "
Update solver parameters (pass parameters down to wrapped implementation) 

:param const Parameters & parameters: 
:rtype: void
";

%feature("docstring") dolfin::LinearSolver::~LinearSolver() "
Destructor.
";

%feature("docstring") dolfin::Matrix "
This class provides the default DOLFIN matrix class, based on the default DOLFIN linear algebra backend.
";

%feature("docstring") dolfin::Matrix::Matrix(MPI_Comm comm=MPI_COMM_WORLD) "
Create empty matrix. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::Matrix::Matrix(const GenericMatrix &A) "
Create a :cpp:any:`Vector`  from a :cpp:any:`GenericVector` . 

:param const GenericMatrix & A:
";

%feature("docstring") dolfin::Matrix::Matrix(const Matrix &A) "
Copy constructor. 

:param const Matrix & A:
";

%feature("docstring") dolfin::Matrix::add(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::add_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::axpy(double a, const GenericMatrix &A, bool same_nonzero_pattern) "
Add multiple of given matrix (AXPY operation) 

:param double a: 
:param const GenericMatrix & A: 
:param bool same_nonzero_pattern: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::copy() const "
Return copy of matrix. 

:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::Matrix::empty() const "
Return true if matrix is empty. 

:rtype: bool
";

%feature("docstring") dolfin::Matrix::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::Matrix::get(double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) const "
Get block of values. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::get_diagonal(GenericVector &x) const "
Get diagonal of a matrix. 

:param GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::getrow(std::size_t row, std::vector< std::size_t > &columns, std::vector< double > &values) const "
Get non-zero values of given row. 

:param std\\:\\:size_t row: 
:param std\\:\\:vector< std\\:\\:size_t > & columns: 
:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::ident(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::ident_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using tensor layout. 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::init_vector(GenericVector &y, std::size_t dim) const "
Resize vector y such that is it compatible with matrix for multiplication Ax = b (dim = 0 -> b, dim = 1 -> x) In parallel case, size and layout are important. 

:param GenericVector & y: 
:param std\\:\\:size_t dim: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::instance() "
Return concrete instance / unwrap (non-const version) 

:rtype: GenericMatrix *
";

%feature("docstring") dolfin::Matrix::instance() const "
Return concrete instance / unwrap (const version) 

:rtype: const GenericMatrix *
";

%feature("docstring") dolfin::Matrix::is_symmetric(double tol) const "
Test if matrix is symmetric. 

:param double tol: 
:rtype: bool
";

%feature("docstring") dolfin::Matrix::local_range(std::size_t dim) const "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::Matrix::matrix "
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::Matrix::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::Matrix::mult(const GenericVector &x, GenericVector &y) const "
Compute matrix-vector product y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::nnz() const "
Return number of non-zero entries in matrix (collective) 

:rtype: std::size_t
";

%feature("docstring") dolfin::Matrix::norm(std::string norm_type) const "
Return norm of matrix. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::Matrix::operator*=(double a) "
Multiply matrix by given number. 

:param double a: 
:rtype: const Matrix &
";

%feature("docstring") dolfin::Matrix::operator/=(double a) "
Divide matrix by given number. 

:param double a: 
:rtype: const Matrix &
";

%feature("docstring") dolfin::Matrix::operator=(const GenericMatrix &A) "
Assignment operator. 

:param const GenericMatrix & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::Matrix::operator=(const Matrix &A) "
Assignment operator. 

:param const Matrix & A: 
:rtype: const Matrix &
";

%feature("docstring") dolfin::Matrix::set(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::set_diagonal(const GenericVector &x) "
:cpp:any:`Set`  diagonal of a matrix. 

:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::set_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::setrow(std::size_t row, const std::vector< std::size_t > &columns, const std::vector< double > &values) "
:cpp:any:`Set`  values for given row. 

:param std\\:\\:size_t row: 
:param const std\\:\\:vector< std\\:\\:size_t > & columns: 
:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::shared_instance() "
Return concrete shared ptr instance / unwrap (non-const version) 

:rtype: std::shared_ptr< LinearAlgebraObject >
";

%feature("docstring") dolfin::Matrix::shared_instance() const "
Return concrete shared ptr instance / unwrap (const version) 

:rtype: std::shared_ptr< const LinearAlgebraObject >
";

%feature("docstring") dolfin::Matrix::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::Matrix::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Matrix::transpmult(const GenericVector &x, GenericVector &y) const "
Matrix-vector product, y = A^T x. The y vector must either be zero-sized or have correct size and parallel layout. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::Matrix::zero(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::zero_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Matrix::~Matrix() "
Destructor.
";

%feature("docstring") dolfin::MueluPreconditioner "
Implements Muelu preconditioner from Trilinos.
";

%feature("docstring") dolfin::MueluPreconditioner::MueluPreconditioner() "
Create a particular preconditioner object.
";

%feature("docstring") dolfin::MueluPreconditioner::init(std::shared_ptr< const TpetraMatrix > P) "
Initialise preconditioner based on Operator P. 

:param std\\:\\:shared_ptr< const TpetraMatrix > P: 
:rtype: void
";

%feature("docstring") dolfin::MueluPreconditioner::op_type "
:rtype: Tpetra::Operator< double, int, dolfin::la_index, TpetraVector::node_type >
";

%feature("docstring") dolfin::MueluPreconditioner::prec_type "
:rtype: MueLu::TpetraOperator< double, int, dolfin::la_index, TpetraVector::node_type >
";

%feature("docstring") dolfin::MueluPreconditioner::set(BelosKrylovSolver &solver) "
:cpp:any:`Set`  the preconditioner on a solver. 

:param BelosKrylovSolver & solver: 
:rtype: void
";

%feature("docstring") dolfin::MueluPreconditioner::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::MueluPreconditioner::~MueluPreconditioner() "
Destructor.
";

%feature("docstring") dolfin::PETScBaseMatrix "
This class is a base class for matrices that can be used in :cpp:any:`PETScKrylovSolver` .
";

%feature("docstring") dolfin::PETScBaseMatrix::PETScBaseMatrix() "
Constructor.
";

%feature("docstring") dolfin::PETScBaseMatrix::PETScBaseMatrix(Mat A) "
Constructor. 

:param Mat A:
";

%feature("docstring") dolfin::PETScBaseMatrix::PETScBaseMatrix(const PETScBaseMatrix &A) "
Copy constructor. 

:param const PETScBaseMatrix & A:
";

%feature("docstring") dolfin::PETScBaseMatrix::init_vector(GenericVector &z, std::size_t dim) const "
Initialize vector to be compatible with the matrix-vector product y = Ax. In the parallel case, both size and layout are important.

:param GenericVector & z:  (:cpp:any:`GenericVector` &) :cpp:any:`Vector`  to initialise
:param std\\:\\:size_t dim:  (std::size_t) The dimension (axis): dim = 0 --> z = y, dim = 1 --> z = x
:rtype: void
";

%feature("docstring") dolfin::PETScBaseMatrix::local_range(std::size_t dim) const "
Return local range along dimension dim. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::PETScBaseMatrix::mat() const "
Return PETSc Mat pointer. 

:rtype: Mat
";

%feature("docstring") dolfin::PETScBaseMatrix::mpi_comm() const "
Return the :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::PETScBaseMatrix::size() const "
Return number of rows and columns (num_rows, num_cols). PETSc returns -1 if size has not been set. 

:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::PETScBaseMatrix::size(std::size_t dim) const "
Return number of rows (dim = 0) or columns (dim = 1) 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScBaseMatrix::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScBaseMatrix::~PETScBaseMatrix() "
Destructor.
";

%feature("docstring") dolfin::PETScFactory "
PETSc linear algebra factory.
";

%feature("docstring") dolfin::PETScFactory::PETScFactory() "
Private constructor.
";

%feature("docstring") dolfin::PETScFactory::create_krylov_solver(MPI_Comm comm, std::string method, std::string preconditioner) const "
Create Krylov solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::PETScFactory::create_layout(std::size_t rank) const "
Create empty tensor layout. 

:param std\\:\\:size_t rank: 
:rtype: std::shared_ptr< TensorLayout >
";

%feature("docstring") dolfin::PETScFactory::create_linear_operator(MPI_Comm comm) const "
Create empty linear operator. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericLinearOperator >
";

%feature("docstring") dolfin::PETScFactory::create_lu_solver(MPI_Comm comm, std::string method) const "
Create LU solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::PETScFactory::create_matrix(MPI_Comm comm) const "
Create empty matrix. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::PETScFactory::create_vector(MPI_Comm comm) const "
Create empty vector. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::PETScFactory::factory "
:rtype: PETScFactory
";

%feature("docstring") dolfin::PETScFactory::instance() "
Return singleton instance. 

:rtype: PETScFactory &
";

%feature("docstring") dolfin::PETScFactory::krylov_solver_methods() const "
Return a list of available Krylov solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScFactory::krylov_solver_preconditioners() const "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScFactory::lu_solver_methods() const "
Return a list of available LU solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScFactory::~PETScFactory() "
Destructor.
";

%feature("docstring") dolfin::PETScKrylovSolver "
This class implements Krylov methods for linear systems of the form Ax = b. It is a wrapper for the Krylov solvers of PETSc. 

Friends: :cpp:any:`PETScSNESSolver`, :cpp:any:`PETScTAOSolver`.
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(KSP ksp) "
Create solver wrapper of a PETSc KSP object. 

:param KSP ksp:
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(MPI_Comm comm, std::string method, std::shared_ptr< PETScPreconditioner > preconditioner) "
Create Krylov solver for a particular method and :cpp:any:`PETScPreconditioner`  (shared_ptr version) 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:shared_ptr< PETScPreconditioner > preconditioner:
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(MPI_Comm comm, std::string method, std::shared_ptr< PETScUserPreconditioner > preconditioner) "
Create Krylov solver for a particular method and :cpp:any:`PETScPreconditioner`  (shared_ptr version) 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:shared_ptr< PETScUserPreconditioner > preconditioner:
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(MPI_Comm comm, std::string method="default", std::string preconditioner="default") "
Create Krylov solver for a particular method and named preconditioner 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(std::string method, std::shared_ptr< PETScPreconditioner > preconditioner) "
Create Krylov solver for a particular method and :cpp:any:`PETScPreconditioner`  (shared_ptr version) 

:param std\\:\\:string method: 
:param std\\:\\:shared_ptr< PETScPreconditioner > preconditioner:
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(std::string method, std::shared_ptr< PETScUserPreconditioner > preconditioner) "
Create Krylov solver for a particular method and :cpp:any:`PETScPreconditioner`  (shared_ptr version) 

:param std\\:\\:string method: 
:param std\\:\\:shared_ptr< PETScUserPreconditioner > preconditioner:
";

%feature("docstring") dolfin::PETScKrylovSolver::PETScKrylovSolver(std::string method="default", std::string preconditioner="default") "
Create Krylov solver for a particular method and named preconditioner 

:param std\\:\\:string method: 
:param std\\:\\:string preconditioner:
";

%feature("docstring") dolfin::PETScKrylovSolver::check_dimensions(const PETScBaseMatrix &A, const GenericVector &x, const GenericVector &b) const "
:param const PETScBaseMatrix & A: 
:param const GenericVector & x: 
:param const GenericVector & b: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::get_norm_type() const "
Get norm type used in convergence testing. 

:rtype: norm_type
";

%feature("docstring") dolfin::PETScKrylovSolver::get_norm_type(std::string norm) "
:param std\\:\\:string norm: 
:rtype: PETScKrylovSolver::norm_type
";

%feature("docstring") dolfin::PETScKrylovSolver::get_options_prefix() const "
Returns the prefix used by PETSc when searching the PETSc options database 

:rtype: std::string
";

%feature("docstring") dolfin::PETScKrylovSolver::ksp() const "
Return PETSc KSP pointer. 

:rtype: KSP
";

%feature("docstring") dolfin::PETScKrylovSolver::methods() "
Return a list of available solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScKrylovSolver::monitor(bool monitor_convergence) "
Monitor residual at each iteration. 

:param bool monitor_convergence: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::PETScKrylovSolver::norm_type "
Norm types used in convergence testing. Not all solvers types support all norm types (see `http://www.mcs.anl.gov/petsc/petsc-current/docs/manualpages/KSP/KSPSetNormType.html <http://www.mcs.anl.gov/petsc/petsc-current/docs/manualpages/KSP/KSPSetNormType.html>`_ ). Note that 'default' is a reserved keyword, so we use 'default_norm' 

.. cpp:enumerator:: dolfin::PETScKrylovSolver::norm_type::none 

.. cpp:enumerator:: dolfin::PETScKrylovSolver::norm_type::default_norm 

.. cpp:enumerator:: dolfin::PETScKrylovSolver::norm_type::preconditioned 

.. cpp:enumerator:: dolfin::PETScKrylovSolver::norm_type::unpreconditioned 

.. cpp:enumerator:: dolfin::PETScKrylovSolver::norm_type::natural
";

%feature("docstring") dolfin::PETScKrylovSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::PETScKrylovSolver::pc_dolfin "
:rtype: PETScUserPreconditioner *
";

%feature("docstring") dolfin::PETScKrylovSolver::preconditioner_set "
:rtype: bool
";

%feature("docstring") dolfin::PETScKrylovSolver::preconditioners() "
Return a list of available named preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScKrylovSolver::set_dm(DM dm) "
:cpp:any:`Set`  the DM. 

:param DM dm: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_dm_active(bool val) "
Activate/deactivate DM. 

:param bool val: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_from_options() const "
:cpp:any:`Set`  options from PETSc options database. 

:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_nonzero_guess(bool nonzero_guess) "
Use nonzero initial guess for solution function (nonzero_guess=true, the solution vector x will not be zeroed before the solver starts) 

:param bool nonzero_guess: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_norm_type(norm_type type) "
:cpp:any:`Set`  norm type used in convergence testing - not all solvers types support all norm types 

:param norm_type type: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_operator(const PETScBaseMatrix &A) "
:cpp:any:`Set`  operator (:cpp:any:`PETScMatrix` ). This is memory-safe as PETSc will increase the reference count to the underlying PETSc object. 

:param const PETScBaseMatrix & A: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_operators(const PETScBaseMatrix &A, const PETScBaseMatrix &P) "
:cpp:any:`Set`  operator and preconditioner matrix (:cpp:any:`PETScMatrix` ). This is memory-safe as PETSc will increase the reference count to the underlying PETSc objects. 

:param const PETScBaseMatrix & A: 
:param const PETScBaseMatrix & P: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_operators(std::shared_ptr< const GenericLinearOperator > A, std::shared_ptr< const GenericLinearOperator > P) "
:cpp:any:`Set`  operator (matrix) and preconditioner matrix. 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:param std\\:\\:shared_ptr< const GenericLinearOperator > P: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_options_prefix(std::string options_prefix) "
Sets the prefix used by PETSc when searching the PETSc options database 

:param std\\:\\:string options_prefix: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_reuse_preconditioner(bool reuse_pc) "
Reuse preconditioner if true, even if matrix operator changes (by default preconditioner will be re-built if the matrix changes) 

:param bool reuse_pc: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::set_tolerances(double relative, double absolute, double diverged, int max_iter) "
:cpp:any:`Set`  tolerances (relative residual, alsolute residial, maximum number of iterations) 

:param double relative: 
:param double absolute: 
:param double diverged: 
:param int max_iter: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScKrylovSolver::solve(GenericVector &x, const GenericVector &b, bool transpose) "
Solve linear system Ax = b and return number of iterations (A^t x = b if transpose is true) 

:param GenericVector & x: 
:param const GenericVector & b: 
:param bool transpose: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScKrylovSolver::solve(PETScVector &x, const PETScVector &b, bool transpose=false) "
Solve linear system Ax = b and return number of iterations (A^t x = b if transpose is true) 

:param PETScVector & x: 
:param const PETScVector & b: 
:param bool transpose: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScKrylovSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b and return number of iterations. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScKrylovSolver::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScKrylovSolver::write_report(int num_iterations, KSPConvergedReason reason) "
:param int num_iterations: 
:param KSPConvergedReason reason: 
:rtype: void
";

%feature("docstring") dolfin::PETScKrylovSolver::~PETScKrylovSolver() "
Destructor.
";

%feature("docstring") dolfin::PETScLUSolver "
This class implements the direct solution (LU factorization) for linear systems of the form Ax = b. It is a wrapper for the LU solver of PETSc. 

Friends: :cpp:any:`PETScSNESSolver`, :cpp:any:`PETScTAOSolver`.
";

%feature("docstring") dolfin::PETScLUSolver::PETScLUSolver(MPI_Comm comm, std::shared_ptr< const PETScMatrix > A, std::string method="default") "
Constructor. 

:param MPI_Comm comm: 
:param std\\:\\:shared_ptr< const PETScMatrix > A: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::PETScLUSolver::PETScLUSolver(MPI_Comm comm, std::string method="default") "
Constructor. 

:param MPI_Comm comm: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::PETScLUSolver::PETScLUSolver(std::shared_ptr< const PETScMatrix > A, std::string method="default") "
Constructor. 

:param std\\:\\:shared_ptr< const PETScMatrix > A: 
:param std\\:\\:string method:
";

%feature("docstring") dolfin::PETScLUSolver::PETScLUSolver(std::string method="default") "
Constructor. 

:param std\\:\\:string method:
";

%feature("docstring") dolfin::PETScLUSolver::get_options_prefix() const "
Returns the prefix used by PETSc when searching the options database 

:rtype: std::string
";

%feature("docstring") dolfin::PETScLUSolver::ksp() const "
Return PETSc KSP pointer. 

:rtype: KSP
";

%feature("docstring") dolfin::PETScLUSolver::lumethods "
:rtype: std::map< std::string, const MatSolverPackage >
";

%feature("docstring") dolfin::PETScLUSolver::methods() "
Return a list of available solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScLUSolver::mpi_comm() const "
Returns the :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::PETScLUSolver::parameter_type() const "
Return parameter type: \"krylov_solver\" or \"lu_solver\". 

:rtype: std::string
";

%feature("docstring") dolfin::PETScLUSolver::select_solver(MPI_Comm comm, std::string method) "
:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: const MatSolverPackage
";

%feature("docstring") dolfin::PETScLUSolver::set_from_options() const "
:cpp:any:`Set`  options from the PETSc options database. 

:rtype: void
";

%feature("docstring") dolfin::PETScLUSolver::set_operator(const PETScMatrix &A) "
:cpp:any:`Set`  operator (matrix) 

:param const PETScMatrix & A: 
:rtype: void
";

%feature("docstring") dolfin::PETScLUSolver::set_operator(std::shared_ptr< const GenericLinearOperator > A) "
:cpp:any:`Set`  operator (matrix) 

:param std\\:\\:shared_ptr< const GenericLinearOperator > A: 
:rtype: void
";

%feature("docstring") dolfin::PETScLUSolver::set_options_prefix(std::string options_prefix) "
Sets the prefix used by PETSc when searching the options database 

:param std\\:\\:string options_prefix: 
:rtype: void
";

%feature("docstring") dolfin::PETScLUSolver::solve(GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScLUSolver::solve(GenericVector &x, const GenericVector &b, bool transpose) "
Solve linear system Ax = b (A^t x = b if transpose is true) 

:param GenericVector & x: 
:param const GenericVector & b: 
:param bool transpose: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScLUSolver::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b) "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScLUSolver::solve(const PETScMatrix &A, PETScVector &x, const PETScVector &b) "
Solve linear system Ax = b. 

:param const PETScMatrix & A: 
:param PETScVector & x: 
:param const PETScVector & b: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScLUSolver::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScLUSolver::~PETScLUSolver() "
Destructor.
";

%feature("docstring") dolfin::PETScLinearOperator "
PETSc version of the :cpp:any:`GenericLinearOperator` . 
Matrix-free interface for the solution of linear systems defined in terms of the action (matrix-vector product) of a linear operator.
";

%feature("docstring") dolfin::PETScLinearOperator::PETScLinearOperator(MPI_Comm comm) "
Constructor. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::PETScLinearOperator::init_layout(const GenericVector &x, const GenericVector &y, GenericLinearOperator *wrapper) "
Initialize linear operator to match parallel layout of vectors x and y for product y = Ax. Needs to be implemented by backend. 

:param const GenericVector & x: 
:param const GenericVector & y: 
:param GenericLinearOperator * wrapper: 
:rtype: void
";

%feature("docstring") dolfin::PETScLinearOperator::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::PETScLinearOperator::mult(const GenericVector &x, GenericVector &y) const "
Compute matrix-vector product y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::PETScLinearOperator::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScLinearOperator::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScLinearOperator::wrapper() "
Return pointer to wrapper (const version) 

:rtype: GenericLinearOperator *
";

%feature("docstring") dolfin::PETScLinearOperator::wrapper() const "
Return pointer to wrapper (const version) 

:rtype: const GenericLinearOperator *
";

%feature("docstring") dolfin::PETScMatrix "
This class provides a simple matrix class based on PETSc. It is a wrapper for a PETSc matrix pointer (Mat) implementing the :cpp:any:`GenericMatrix`  interface.
The interface is intentionally simple. For advanced usage, access the PETSc Mat pointer using the function :cpp:any:`mat()`  and use the standard PETSc interface.
";

%feature("docstring") dolfin::PETScMatrix::PETScMatrix() "
Create empty matrix (on MPI_COMM_WORLD)
";

%feature("docstring") dolfin::PETScMatrix::PETScMatrix(MPI_Comm comm) "
Create empty matrix. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::PETScMatrix::PETScMatrix(Mat A) "
Create a wrapper around a PETSc Mat pointer. The Mat object should have been created, e.g. via PETSc MatCreate. 

:param Mat A:
";

%feature("docstring") dolfin::PETScMatrix::PETScMatrix(const PETScMatrix &A) "
Copy constructor. 

:param const PETScMatrix & A:
";

%feature("docstring") dolfin::PETScMatrix::add(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::add_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::apply(std::string mode) "
Finalize assembly of tensor. The following values are recognized for the mode parameter:
add - corresponds to PETSc MatAssemblyBegin+End(MAT_FINAL_ASSEMBLY) insert - corresponds to PETSc MatAssemblyBegin+End(MAT_FINAL_ASSEMBLY) flush - corresponds to PETSc MatAssemblyBegin+End(MAT_FLUSH_ASSEMBLY) 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::axpy(double a, const GenericMatrix &A, bool same_nonzero_pattern) "
Add multiple of given matrix (AXPY operation) 

:param double a: 
:param const GenericMatrix & A: 
:param bool same_nonzero_pattern: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::binary_dump(std::string file_name) const "
Dump matrix to PETSc binary format. 

:param std\\:\\:string file_name: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::copy() const "
Return copy of matrix. 

:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::PETScMatrix::create_petsc_nullspace(const VectorSpaceBasis &nullspace) const "
:param const VectorSpaceBasis & nullspace: 
:rtype: MatNullSpace
";

%feature("docstring") dolfin::PETScMatrix::empty() const "
Return true if empty. 

:rtype: bool
";

%feature("docstring") dolfin::PETScMatrix::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::PETScMatrix::get(double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) const "
Get block of values. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::get_diagonal(GenericVector &x) const "
Get diagonal of a matrix. 

:param GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::get_options_prefix() const "
Returns the prefix used by PETSc when searching the options database 

:rtype: std::string
";

%feature("docstring") dolfin::PETScMatrix::getrow(std::size_t row, std::vector< std::size_t > &columns, std::vector< double > &values) const "
Get non-zero values of given row. 

:param std\\:\\:size_t row: 
:param std\\:\\:vector< std\\:\\:size_t > & columns: 
:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::ident(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::ident_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using tensor layout. 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::init_vector(GenericVector &z, std::size_t dim) const "
Initialize vector z to be compatible with the matrix-vector product y = Ax. In the parallel case, both size and layout are important.

:param GenericVector & z:  (:cpp:any:`GenericVector` &) :cpp:any:`Vector`  to initialise
:param std\\:\\:size_t dim:  (std::size_t) The dimension (axis): dim = 0 --> z = y, dim = 1 --> z = x
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::is_symmetric(double tol) const "
Test if matrix is symmetric. 

:param double tol: 
:rtype: bool
";

%feature("docstring") dolfin::PETScMatrix::local_range(std::size_t dim) const "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::PETScMatrix::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::PETScMatrix::mult(const GenericVector &x, GenericVector &y) const "
Compute matrix-vector product y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::nnz() const "
Return number of non-zero entries in matrix (collective) 

:rtype: std::size_t
";

%feature("docstring") dolfin::PETScMatrix::norm(std::string norm_type) const "
Return norm of matrix. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::PETScMatrix::norm_types "
:rtype: const std::map< std::string, NormType >
";

%feature("docstring") dolfin::PETScMatrix::operator*=(double a) "
Multiply matrix by given number. 

:param double a: 
:rtype: const PETScMatrix &
";

%feature("docstring") dolfin::PETScMatrix::operator/=(double a) "
Divide matrix by given number. 

:param double a: 
:rtype: const PETScMatrix &
";

%feature("docstring") dolfin::PETScMatrix::operator=(const GenericMatrix &A) "
Assignment operator. 

:param const GenericMatrix & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::PETScMatrix::operator=(const PETScMatrix &A) "
Assignment operator. 

:param const PETScMatrix & A: 
:rtype: const PETScMatrix &
";

%feature("docstring") dolfin::PETScMatrix::set(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::set_diagonal(const GenericVector &x) "
:cpp:any:`Set`  diagonal of a matrix. 

:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::set_from_options() "
Call PETSc function MatSetFromOptions on the PETSc Mat object. 

:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::set_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::set_near_nullspace(const VectorSpaceBasis &nullspace) "
Attach near nullspace to matrix (used by preconditioners, such as smoothed aggregation algerbraic multigrid) 

:param const VectorSpaceBasis & nullspace: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::set_nullspace(const VectorSpaceBasis &nullspace) "
Attach nullspace to matrix (typically used by Krylov solvers when solving singular systems) 

:param const VectorSpaceBasis & nullspace: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::set_options_prefix(std::string options_prefix) "
Sets the prefix used by PETSc when searching the options database 

:param std\\:\\:string options_prefix: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::setrow(std::size_t row, const std::vector< std::size_t > &columns, const std::vector< double > &values) "
:cpp:any:`Set`  values for given row. 

:param std\\:\\:size_t row: 
:param const std\\:\\:vector< std\\:\\:size_t > & columns: 
:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScMatrix::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScMatrix::transpmult(const GenericVector &x, GenericVector &y) const "
Matrix-vector product, y = A^T x. The y vector must either be zero-sized or have correct size and parallel layout. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::zero(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::zero_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScMatrix::~PETScMatrix() "
Destructor.
";

%feature("docstring") dolfin::PETScObject "
This class calls :cpp:any:`SubSystemsManager`  to initialise PETSc.
All PETSc objects must be derived from this class.
";

%feature("docstring") dolfin::PETScObject::PETScObject() "
Constructor. Ensures that PETSc has been initialised.
";

%feature("docstring") dolfin::PETScObject::petsc_error(int error_code, std::string filename, std::string petsc_function) "
Print error message for PETSc calls that return an error. 

:param int error_code: 
:param std\\:\\:string filename: 
:param std\\:\\:string petsc_function: 
:rtype: void
";

%feature("docstring") dolfin::PETScObject::~PETScObject() "
Destructor.
";

%feature("docstring") dolfin::PETScOptions "
These class provides static functions that permit users to set and retrieve PETSc options via the PETSc option/parameter system. The option must not be prefixed by '-', e.g. 

::
   
   PETScOptions::set(\"mat_mumps_icntl_14\", 40);
   
Note: the non-templated functions are to simplify SWIG wapping into Python.
";

%feature("docstring") dolfin::PETScOptions::clear() "
Clear PETSc global options database. 

:rtype: void
";

%feature("docstring") dolfin::PETScOptions::clear(std::string option) "
Clear a PETSc option. 

:param std\\:\\:string option: 
:rtype: void
";

%feature("docstring") dolfin::PETScOptions::set(std::string option) "
:cpp:any:`Set`  PETSc option that takes no value. 

:param std\\:\\:string option: 
:rtype: void
";

%feature("docstring") dolfin::PETScOptions::set(std::string option, bool value) "
:cpp:any:`Set`  PETSc boolean option. 

:param std\\:\\:string option: 
:param bool value: 
:rtype: void
";

%feature("docstring") dolfin::PETScOptions::set(std::string option, const T value) "
Genetic function for setting PETSc option. 

:param std\\:\\:string option: 
:param const T value: 
:rtype: void
";

%feature("docstring") dolfin::PETScOptions::set(std::string option, double value) "
:cpp:any:`Set`  PETSc double option. 

:param std\\:\\:string option: 
:param double value: 
:rtype: void
";

%feature("docstring") dolfin::PETScOptions::set(std::string option, int value) "
:cpp:any:`Set`  PETSc integer option. 

:param std\\:\\:string option: 
:param int value: 
:rtype: void
";

%feature("docstring") dolfin::PETScOptions::set(std::string option, std::string value) "
:cpp:any:`Set`  PETSc string option. 

:param std\\:\\:string option: 
:param std\\:\\:string value: 
:rtype: void
";

%feature("docstring") dolfin::PETScPreconditioner "
This class is a wrapper for configuring PETSc preconditioners. It does not own a preconditioner. It can take a :cpp:any:`PETScKrylovSolver`  and set the preconditioner type and parameters. 

Friends: :cpp:any:`PETScSNESSolver`, :cpp:any:`PETScTAOSolver`.
";

%feature("docstring") dolfin::PETScPreconditioner::PETScPreconditioner(std::string type="default") "
Create a particular preconditioner object. 

:param std\\:\\:string type:
";

%feature("docstring") dolfin::PETScPreconditioner::gdim "
:rtype: std::size_t
";

%feature("docstring") dolfin::PETScPreconditioner::preconditioners() "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::PETScPreconditioner::set(PETScKrylovSolver &solver) "
:cpp:any:`Set`  the preconditioner type and parameters. 

:param PETScKrylovSolver & solver: 
:rtype: void
";

%feature("docstring") dolfin::PETScPreconditioner::set_coordinates(const std::vector< double > &x, std::size_t dim) "
:cpp:any:`Set`  the coordinates of the operator (matrix) rows and geometric dimension d. This is can be used by required for certain preconditioners, e.g. ML. The input for this function can be generated using GenericDofMap::tabulate_all_dofs. 

:param const std\\:\\:vector< double > & x: 
:param std\\:\\:size_t dim: 
:rtype: void
";

%feature("docstring") dolfin::PETScPreconditioner::set_fieldsplit(PETScKrylovSolver &solver, const std::vector< std::vector< dolfin::la_index >> &fields, const std::vector< std::string > &split_names) "
Assign indices from fields as separate PETSc index sets, with given names 

:param PETScKrylovSolver & solver:  (:cpp:any:`PETScKrylovSolver` &)
:param const std\\:\\:vector< std\\:\\:vector< dolfin\\:\\:la_index >> & fields:  (std::vector<std::vector<dolfin::la_index>>&)
:param const std\\:\\:vector< std\\:\\:string > & split_names:  (std::vector<std::string>&)
:rtype: void
";

%feature("docstring") dolfin::PETScPreconditioner::set_type(PETScKrylovSolver &solver, std::string type) "
Select type by name. 

:param PETScKrylovSolver & solver: 
:param std\\:\\:string type: 
:rtype: void
";

%feature("docstring") dolfin::PETScPreconditioner::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScPreconditioner::~PETScPreconditioner() "
Destructor.
";

%feature("docstring") dolfin::PETScUserPreconditioner "
This class specifies the interface for user-defined Krylov method PETScPreconditioners. A user wishing to implement her own :cpp:any:`PETScPreconditioner`  needs only supply a function that approximately solves the linear system given a right-hand side.
";

%feature("docstring") dolfin::PETScUserPreconditioner::PCApply(PC pc, Vec x, Vec y) "
:param PC pc: 
:param Vec x: 
:param Vec y: 
:rtype: int
";

%feature("docstring") dolfin::PETScUserPreconditioner::PCCreate(PC pc) "
:param PC pc: 
:rtype: int
";

%feature("docstring") dolfin::PETScUserPreconditioner::PETScUserPreconditioner() "
Constructor.
";

%feature("docstring") dolfin::PETScUserPreconditioner::petscpc "
PETSc PC object. 

:rtype: PC
";

%feature("docstring") dolfin::PETScUserPreconditioner::setup(const KSP ksp, PETScUserPreconditioner &pc) "
:cpp:any:`Set`  up. 

:param const KSP ksp: 
:param PETScUserPreconditioner & pc: 
:rtype: void
";

%feature("docstring") dolfin::PETScUserPreconditioner::solve(PETScVector &x, const PETScVector &b) "
Solve linear system approximately for given right-hand side b. 

:param PETScVector & x: 
:param const PETScVector & b: 
:rtype: void
";

%feature("docstring") dolfin::PETScUserPreconditioner::~PETScUserPreconditioner() "
Destructor.
";

%feature("docstring") dolfin::PETScVector "
A simple vector class based on PETSc.
It is a simple wrapper for a PETSc vector pointer (Vec) implementing the :cpp:any:`GenericVector`  interface.
The interface is intentionally simple. For advanced usage, access the PETSc Vec pointer using the function :cpp:any:`vec()`  and use the standard PETSc interface.
";

%feature("docstring") dolfin::PETScVector::PETScVector() "
Create empty vector (on MPI_COMM_WORLD)
";

%feature("docstring") dolfin::PETScVector::PETScVector(MPI_Comm comm) "
Create empty vector on an :cpp:any:`MPI`  communicator. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::PETScVector::PETScVector(MPI_Comm comm, std::size_t N) "
Create vector of size N. 

:param MPI_Comm comm: 
:param std\\:\\:size_t N:
";

%feature("docstring") dolfin::PETScVector::PETScVector(Vec x) "
Create vector wrapper of PETSc Vec pointer. The reference counter of the Vec will be increased, and decreased upon destruction of this object. 

:param Vec x:
";

%feature("docstring") dolfin::PETScVector::PETScVector(const PETScVector &x) "
Copy constructor. 

:param const PETScVector & x:
";

%feature("docstring") dolfin::PETScVector::PETScVector(const SparsityPattern &sparsity_pattern) "
Create vector. 

:param const SparsityPattern & sparsity_pattern:
";

%feature("docstring") dolfin::PETScVector::abs() "
Replace all entries in the vector by their absolute values. 

:rtype: void
";

%feature("docstring") dolfin::PETScVector::add(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::add_local(const Array< double > &values) "
Add values to each entry on local process. 

:param const Array< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::add_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::axpy(double a, const GenericVector &x) "
Add multiple of given vector (AXPY operation) 

:param double a: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::copy() const "
Return copy of vector. 

:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::PETScVector::empty() const "
Return true if vector is empty. 

:rtype: bool
";

%feature("docstring") dolfin::PETScVector::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::PETScVector::gather(GenericVector &y, const std::vector< dolfin::la_index > &indices) const "
Gather entries (given by global indices) into local (MPI_COMM_SELF) vector x. Provided x must be empty or of correct dimension (same as provided indices). This operation is collective 

:param GenericVector & y: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::gather(std::vector< double > &x, const std::vector< dolfin::la_index > &indices) const "
Gather entries (given by global indices) into x. This operation is collective 

:param std\\:\\:vector< double > & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::gather_on_zero(std::vector< double > &x) const "
Gather all entries into x on process 0. This operation is collective 

:param std\\:\\:vector< double > & x: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::get(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using global indices (all values must be owned by local process, ghosts cannot be accessed) 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::get_local(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using local indices. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::get_local(std::vector< double > &values) const "
Get all values on local process. 

:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::get_options_prefix() const "
Returns the prefix used by PETSc when searching the options database 

:rtype: std::string
";

%feature("docstring") dolfin::PETScVector::init(std::pair< std::size_t, std::size_t > range) "
Initialize vector with given ownership range. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::init(std::pair< std::size_t, std::size_t > range, const std::vector< std::size_t > &local_to_global_map, const std::vector< la_index > &ghost_indices) "
Initialize vector with given ownership range and with ghost values 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:param const std\\:\\:vector< std\\:\\:size_t > & local_to_global_map: 
:param const std\\:\\:vector< la_index > & ghost_indices: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::init(std::size_t N) "
Initialize vector to global size N. 

:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::inner(const GenericVector &v) const "
Return inner product with given vector. 

:param const GenericVector & v: 
:rtype: double
";

%feature("docstring") dolfin::PETScVector::local_range() const "
Return ownership range of a vector. 

:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::PETScVector::local_size() const "
Return local size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::PETScVector::max() const "
Return maximum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::PETScVector::min() const "
Return minimum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::PETScVector::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::PETScVector::norm(std::string norm_type) const "
Return norm of vector. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::PETScVector::norm_types "
:rtype: const std::map< std::string, NormType >
";

%feature("docstring") dolfin::PETScVector::operator*=(const GenericVector &x) "
Multiply vector by another vector pointwise. 

:param const GenericVector & x: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator*=(double a) "
Multiply vector by given number. 

:param double a: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator+=(const GenericVector &x) "
Add given vector. 

:param const GenericVector & x: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator+=(double a) "
Add number to all components of a vector. 

:param double a: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator-=(const GenericVector &x) "
Subtract given vector. 

:param const GenericVector & x: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator-=(double a) "
Subtract number from all components of a vector. 

:param double a: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator/=(double a) "
Divide vector by given number. 

:param double a: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator=(const GenericVector &x) "
Assignment operator. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::PETScVector::operator=(const PETScVector &x) "
Assignment operator. 

:param const PETScVector & x: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::operator=(double a) "
Assignment operator. 

:param double a: 
:rtype: const PETScVector &
";

%feature("docstring") dolfin::PETScVector::owns_index(std::size_t i) const "
Determine whether global vector index is owned by this process. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::PETScVector::reset(Vec vec) "
Switch underlying PETSc object. Intended for internal library usage. 

:param Vec vec: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::set(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::set_from_options() "
Call PETSc function VecSetFromOptions on the underlying Vec object 

:rtype: void
";

%feature("docstring") dolfin::PETScVector::set_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::set_local(const std::vector< double > &values) "
:cpp:any:`Set`  all values on local process. 

:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::set_options_prefix(std::string options_prefix) "
Sets the prefix used by PETSc when searching the options database 

:param std\\:\\:string options_prefix: 
:rtype: void
";

%feature("docstring") dolfin::PETScVector::size() const "
Return size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::PETScVector::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::PETScVector::sum() const "
Return sum of values of vector. 

:rtype: double
";

%feature("docstring") dolfin::PETScVector::sum(const Array< std::size_t > &rows) const "
Return sum of selected rows in vector. 

:param const Array< std\\:\\:size_t > & rows: 
:rtype: double
";

%feature("docstring") dolfin::PETScVector::update_ghost_values() "
Update values shared from remote processes. 

:rtype: void
";

%feature("docstring") dolfin::PETScVector::vec() const "
Return pointer to PETSc Vec object. 

:rtype: Vec
";

%feature("docstring") dolfin::PETScVector::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::PETScVector::~PETScVector() "
Destructor.
";

%feature("docstring") dolfin::Scalar "
This class represents a real-valued scalar quantity and implements the :cpp:any:`GenericTensor`  interface for scalars.
";

%feature("docstring") dolfin::Scalar::Scalar() "
Create zero scalar.
";

%feature("docstring") dolfin::Scalar::Scalar(MPI_Comm comm) "
Create zero scalar. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::Scalar::add(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::add(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using global indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::add_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
Add block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::add_local(const double *block, const std::vector< ArrayView< const dolfin::la_index >> &rows) "
Add block of values using local indices. 

:param const double * block: 
:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::add_local_value(double value) "
Add to local increment (added for testing, remove if we add a better way from python) 

:param double value: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::copy() const "
Return copy of scalar. 

:rtype: std::shared_ptr< Scalar >
";

%feature("docstring") dolfin::Scalar::empty() const "
Return true if empty. 

:rtype: bool
";

%feature("docstring") dolfin::Scalar::factory() const "
Return a factory for the default linear algebra backend. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::Scalar::get(double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) const "
Get block of values. 

:param double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::get_scalar_value() const "
Get final value (assumes prior :cpp:any:`apply()` , not part of :cpp:any:`GenericTensor`  interface) 

:rtype: double
";

%feature("docstring") dolfin::Scalar::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using sparsity pattern. 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::local_range(std::size_t dim) const "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::Scalar::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::Scalar::rank() const "
Return tensor rank (number of dimensions) 

:rtype: std::size_t
";

%feature("docstring") dolfin::Scalar::set(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::set_local(const double *block, const dolfin::la_index *num_rows, const dolfin::la_index *const *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param const dolfin\\:\\:la_index * num_rows: 
:param const dolfin\\:\\:la_index *const * rows: 
:rtype: void
";

%feature("docstring") dolfin::Scalar::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::Scalar::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Scalar::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::Scalar::~Scalar() "
Destructor.
";

%feature("docstring") dolfin::SparsityPattern "
This class implements a sparsity pattern data structure. It is used by most linear algebra backends.
";

%feature("docstring") dolfin::SparsityPattern::SparsityPattern(MPI_Comm mpi_comm, std::vector< std::shared_ptr< const IndexMap >> index_maps, std::size_t primary_dim) "
Create sparsity pattern for a generic tensor. 

:param MPI_Comm mpi_comm: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const IndexMap >> index_maps: 
:param std\\:\\:size_t primary_dim:
";

%feature("docstring") dolfin::SparsityPattern::SparsityPattern(std::size_t primary_dim) "
Create empty sparsity pattern. 

:param std\\:\\:size_t primary_dim:
";

%feature("docstring") dolfin::SparsityPattern::Type "
Whether :cpp:any:`SparsityPattern`  is sorted. 

.. cpp:enumerator:: dolfin::SparsityPattern::Type::sorted 

.. cpp:enumerator:: dolfin::SparsityPattern::Type::unsorted
";

%feature("docstring") dolfin::SparsityPattern::apply() "
Finalize sparsity pattern. 

:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::diagonal "
:rtype: std::vector< set_type >
";

%feature("docstring") dolfin::SparsityPattern::diagonal_pattern(Type type) const "
Return underlying sparsity pattern (diagonal). Options are 'sorted' and 'unsorted'. 

:param Type type: 
:rtype: std::vector< std::vector< std::size_t > >
";

%feature("docstring") dolfin::SparsityPattern::full_rows "
:rtype: set_type
";

%feature("docstring") dolfin::SparsityPattern::info_statistics() const "
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::init(MPI_Comm mpi_comm, std::vector< std::shared_ptr< const IndexMap >> index_maps) "
Initialize sparsity pattern for a generic tensor. 

:param MPI_Comm mpi_comm: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const IndexMap >> index_maps: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::insert_full_rows_local(const std::vector< std::size_t > &rows) "
Insert full rows (or columns, according to primary dimension) using local (process-wise) indices. This must be called before any other sparse insertion occurs to avoid quadratic complexity of dense rows insertion 

:param const std\\:\\:vector< std\\:\\:size_t > & rows: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::insert_global(const std::vector< ArrayView< const dolfin::la_index >> &entries) "
Insert non-zero entries using global indices. 

:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & entries: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::insert_global(dolfin::la_index i, dolfin::la_index j) "
Insert a global entry - will be fixed by :cpp:any:`apply()` 

:param dolfin\\:\\:la_index i: 
:param dolfin\\:\\:la_index j: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::insert_local(const std::vector< ArrayView< const dolfin::la_index >> &entries) "
Insert non-zero entries using local (process-wise) indices. 

:param const std\\:\\:vector< ArrayView< const dolfin\\:\\:la_index >> & entries: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::local_range(std::size_t dim) const "
Return local range for dimension dim. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::SparsityPattern::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::SparsityPattern::non_local "
:rtype: std::vector< std::size_t >
";

%feature("docstring") dolfin::SparsityPattern::num_local_nonzeros(std::vector< std::size_t > &num_nonzeros) const "
Fill vector with number of nonzeros in local_range for dimension 0 

:param std\\:\\:vector< std\\:\\:size_t > & num_nonzeros: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::num_nonzeros() const "
Return number of local nonzeros. 

:rtype: std::size_t
";

%feature("docstring") dolfin::SparsityPattern::num_nonzeros_diagonal(std::vector< std::size_t > &num_nonzeros) const "
Fill array with number of nonzeros for diagonal block in local_range for dimension 0. For matrices, fill array with number of nonzeros per local row for diagonal block 

:param std\\:\\:vector< std\\:\\:size_t > & num_nonzeros: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::num_nonzeros_off_diagonal(std::vector< std::size_t > &num_nonzeros) const "
Fill array with number of nonzeros for off-diagonal block in local_range for dimension 0. For matrices, fill array with number of nonzeros per local row for off-diagonal block. If there is no off-diagonal pattern, the vector is resized to zero-length 

:param std\\:\\:vector< std\\:\\:size_t > & num_nonzeros: 
:rtype: void
";

%feature("docstring") dolfin::SparsityPattern::off_diagonal "
:rtype: std::vector< set_type >
";

%feature("docstring") dolfin::SparsityPattern::off_diagonal_pattern(Type type) const "
Return underlying sparsity pattern (off-diagonal). Options are 'sorted' and 'unsorted'. Empty vector is returned if there is no off-diagonal contribution. 

:param Type type: 
:rtype: std::vector< std::vector< std::size_t > >
";

%feature("docstring") dolfin::SparsityPattern::primary_dim() const "
Return primary dimension (e.g., 0=row partition, 1=column partition) 

:rtype: std::size_t
";

%feature("docstring") dolfin::SparsityPattern::rank() const "
Return rank. 

:rtype: std::size_t
";

%feature("docstring") dolfin::SparsityPattern::set_type "
:cpp:any:`Set`  type used for the rows of the sparsity pattern. 

:rtype: dolfin::Set< std::size_t >
";

%feature("docstring") dolfin::SparsityPattern::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::TensorLayout "
This class described the size and possibly the sparsity of a (sparse) tensor. It is used by the linear algebra backends to initialise tensors.
";

%feature("docstring") dolfin::TensorLayout::Ghosts "
Ghosted or unghosted layout. 

.. cpp:enumerator:: dolfin::TensorLayout::Ghosts::GHOSTED = true

.. cpp:enumerator:: dolfin::TensorLayout::Ghosts::UNGHOSTED = false
";

%feature("docstring") dolfin::TensorLayout::Sparsity "
Sparse or dense layout. 

.. cpp:enumerator:: dolfin::TensorLayout::Sparsity::SPARSE = true

.. cpp:enumerator:: dolfin::TensorLayout::Sparsity::DENSE = false
";

%feature("docstring") dolfin::TensorLayout::TensorLayout(MPI_Comm mpi_comm, std::vector< std::shared_ptr< const IndexMap >> index_maps, std::size_t primary_dim, Sparsity sparsity_pattern, Ghosts ghosted) "
Create a tensor layout. 

:param MPI_Comm mpi_comm: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const IndexMap >> index_maps: 
:param std\\:\\:size_t primary_dim: 
:param Sparsity sparsity_pattern: 
:param Ghosts ghosted:
";

%feature("docstring") dolfin::TensorLayout::TensorLayout(std::size_t primary_dim, Sparsity sparsity_pattern) "
Create empty tensor layout. 

:param std\\:\\:size_t primary_dim: 
:param Sparsity sparsity_pattern:
";

%feature("docstring") dolfin::TensorLayout::index_map(std::size_t i) const "
Return :cpp:any:`IndexMap`  for dimension. 

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< const IndexMap >
";

%feature("docstring") dolfin::TensorLayout::init(MPI_Comm mpi_comm, std::vector< std::shared_ptr< const IndexMap >> index_maps, Ghosts ghosted) "
Initialize tensor layout. 

:param MPI_Comm mpi_comm: 
:param std\\:\\:vector< std\\:\\:shared_ptr< const IndexMap >> index_maps: 
:param Ghosts ghosted: 
:rtype: void
";

%feature("docstring") dolfin::TensorLayout::is_ghosted() const "
Require ghosts. 

:rtype: Ghosts
";

%feature("docstring") dolfin::TensorLayout::local_range(std::size_t dim) const "
Return local range for dimension dim. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::size_t, std::size_t >
";

%feature("docstring") dolfin::TensorLayout::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::TensorLayout::primary_dim "
Primary storage dim (e.g., 0=row major, 1=column major) 

:rtype: const std::size_t
";

%feature("docstring") dolfin::TensorLayout::rank() const "
Return rank. 

:rtype: std::size_t
";

%feature("docstring") dolfin::TensorLayout::size(std::size_t i) const "
Return global size for dimension i (size of tensor, includes non-zeroes) 

:param std\\:\\:size_t i: 
:rtype: std::size_t
";

%feature("docstring") dolfin::TensorLayout::sparsity_pattern() "
Return sparsity pattern (possibly null) 

:rtype: std::shared_ptr< SparsityPattern >
";

%feature("docstring") dolfin::TensorLayout::sparsity_pattern() const "
Return sparsity pattern (possibly null), const version. 

:rtype: std::shared_ptr< const SparsityPattern >
";

%feature("docstring") dolfin::TensorLayout::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::TpetraFactory "
Tpetra linear algebra factory.
";

%feature("docstring") dolfin::TpetraFactory::TpetraFactory() "
Private constructor.
";

%feature("docstring") dolfin::TpetraFactory::create_krylov_solver(MPI_Comm comm, std::string method, std::string preconditioner) const "
Create Krylov solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::TpetraFactory::create_layout(std::size_t rank) const "
Create empty tensor layout. 

:param std\\:\\:size_t rank: 
:rtype: std::shared_ptr< TensorLayout >
";

%feature("docstring") dolfin::TpetraFactory::create_linear_operator(MPI_Comm comm) const "
Create empty linear operator. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericLinearOperator >
";

%feature("docstring") dolfin::TpetraFactory::create_lu_solver(MPI_Comm comm, std::string method) const "
Create LU solver. 

:param MPI_Comm comm: 
:param std\\:\\:string method: 
:rtype: std::shared_ptr< GenericLinearSolver >
";

%feature("docstring") dolfin::TpetraFactory::create_matrix(MPI_Comm comm) const "
Create empty matrix. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::TpetraFactory::create_vector(MPI_Comm comm) const "
Create empty vector. 

:param MPI_Comm comm: 
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::TpetraFactory::factory "
:rtype: TpetraFactory
";

%feature("docstring") dolfin::TpetraFactory::instance() "
Return singleton instance. 

:rtype: TpetraFactory &
";

%feature("docstring") dolfin::TpetraFactory::krylov_solver_methods() const "
Return a list of available Krylov solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::TpetraFactory::krylov_solver_preconditioners() const "
Return a list of available preconditioners. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::TpetraFactory::lu_solver_methods() const "
Return a list of available LU solver methods. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::TpetraFactory::~TpetraFactory() "
Destructor.
";

%feature("docstring") dolfin::TpetraMatrix "
This class provides a simple matrix class based on Tpetra. It is a wrapper for a Tpetra matrix pointer (Teuchos::RCP<matrix_type>) implementing the :cpp:any:`GenericMatrix`  interface.
The interface is intentionally simple. For advanced usage, access the Tpetra::RCP<matrix_type> pointer using the function :cpp:any:`mat()`  and use the standard Tpetra interface.
";

%feature("docstring") dolfin::TpetraMatrix::TpetraMatrix() "
Create empty matrix.
";

%feature("docstring") dolfin::TpetraMatrix::TpetraMatrix(Teuchos::RCP< matrix_type > A) "
Create a wrapper around a Teuchos::RCP<matrix_type> pointer. 

:param Teuchos\\:\\:RCP< matrix_type > A:
";

%feature("docstring") dolfin::TpetraMatrix::TpetraMatrix(const TpetraMatrix &A) "
Copy constructor. 

:param const TpetraMatrix & A:
";

%feature("docstring") dolfin::TpetraMatrix::add(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::add_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::apply(std::string mode) "
Finalize assembly of tensor. The mode parameter is ignored. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::axpy(double a, const GenericMatrix &A, bool same_nonzero_pattern) "
Add multiple of given matrix (AXPY operation) 

:param double a: 
:param const GenericMatrix & A: 
:param bool same_nonzero_pattern: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::copy() const "
Return copy of matrix. 

:rtype: std::shared_ptr< GenericMatrix >
";

%feature("docstring") dolfin::TpetraMatrix::empty() const "
Return true if empty. 

:rtype: bool
";

%feature("docstring") dolfin::TpetraMatrix::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::TpetraMatrix::get(double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) const "
Get block of values. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::get_diagonal(GenericVector &x) const "
Get diagonal of a matrix. 

:param GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::getrow(std::size_t row, std::vector< std::size_t > &columns, std::vector< double > &values) const "
Get non-zero values of given row. 

:param std\\:\\:size_t row: 
:param std\\:\\:vector< std\\:\\:size_t > & columns: 
:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::graph_type "
Graph type (local index, global index) 

:rtype: Tpetra::CrsGraph< int, dolfin::la_index >
";

%feature("docstring") dolfin::TpetraMatrix::graphdump(const Teuchos::RCP< const graph_type > graph) "
Print out a graph, for debugging. 

:param const Teuchos\\:\\:RCP< const graph_type > graph: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::ident(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::ident_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to identity matrix. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::index_map "
:rtype: std::array< std::shared_ptr< const IndexMap >, 2 >
";

%feature("docstring") dolfin::TpetraMatrix::init(const TensorLayout &tensor_layout) "
Initialize zero tensor using tensor layout. 

:param const TensorLayout & tensor_layout: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::init_vector(GenericVector &z, std::size_t dim) const "
Initialize vector z to be compatible with the matrix-vector product y = Ax. In the parallel case, both size and layout are important.

:param GenericVector & z:  (:cpp:any:`GenericVector` &) :cpp:any:`Vector`  to initialise
:param std\\:\\:size_t dim:  (std::size_t) The dimension (axis): dim = 0 --> z = y, dim = 1 --> z = x
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::is_symmetric(double tol) const "
Test if matrix is symmetric. 

:param double tol: 
:rtype: bool
";

%feature("docstring") dolfin::TpetraMatrix::local_range(std::size_t dim) const "
Return local ownership range. 

:param std\\:\\:size_t dim: 
:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::TpetraMatrix::map_type "
Map type (local index, global index) 

:rtype: Tpetra::Map< int, dolfin::la_index >
";

%feature("docstring") dolfin::TpetraMatrix::mat() "
Return Teuchos reference counted pointer to raw matrix. 

:rtype: Teuchos::RCP< matrix_type >
";

%feature("docstring") dolfin::TpetraMatrix::mat() const "
Return Teuchos reference counted pointer to raw matrix (const) 

:rtype: Teuchos::RCP< const matrix_type >
";

%feature("docstring") dolfin::TpetraMatrix::matrix_type "
:cpp:any:`Matrix`  type (scalar, local index, global index) 

:rtype: Tpetra::CrsMatrix< double, int, dolfin::la_index >
";

%feature("docstring") dolfin::TpetraMatrix::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::TpetraMatrix::mult(const GenericVector &x, GenericVector &y) const "
Compute matrix-vector product y = Ax. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::nnz() const "
Return number of non-zero entries in matrix (collective) 

:rtype: std::size_t
";

%feature("docstring") dolfin::TpetraMatrix::norm(std::string norm_type) const "
Return norm of matrix. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::TpetraMatrix::operator*=(double a) "
Multiply matrix by given number. 

:param double a: 
:rtype: const TpetraMatrix &
";

%feature("docstring") dolfin::TpetraMatrix::operator/=(double a) "
Divide matrix by given number. 

:param double a: 
:rtype: const TpetraMatrix &
";

%feature("docstring") dolfin::TpetraMatrix::operator=(const GenericMatrix &A) "
Assignment operator. 

:param const GenericMatrix & A: 
:rtype: const GenericMatrix &
";

%feature("docstring") dolfin::TpetraMatrix::operator=(const TpetraMatrix &A) "
Assignment operator. 

:param const TpetraMatrix & A: 
:rtype: const TpetraMatrix &
";

%feature("docstring") dolfin::TpetraMatrix::set(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::set_diagonal(const GenericVector &x) "
:cpp:any:`Set`  diagonal of a matrix. 

:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::set_local(const double *block, std::size_t m, const dolfin::la_index *rows, std::size_t n, const dolfin::la_index *cols) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:param std\\:\\:size_t n: 
:param const dolfin\\:\\:la_index * cols: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::setrow(std::size_t row, const std::vector< std::size_t > &columns, const std::vector< double > &values) "
:cpp:any:`Set`  values for given row. 

:param std\\:\\:size_t row: 
:param const std\\:\\:vector< std\\:\\:size_t > & columns: 
:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::size(std::size_t dim) const "
Return size of given dimension. 

:param std\\:\\:size_t dim: 
:rtype: std::size_t
";

%feature("docstring") dolfin::TpetraMatrix::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::TpetraMatrix::transpmult(const GenericVector &x, GenericVector &y) const "
Matrix-vector product, y = A^T x. The y vector must either be zero-sized or have correct size and parallel layout. 

:param const GenericVector & x: 
:param GenericVector & y: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::zero(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (global row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::zero_local(std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  given rows (local row indices) to zero. 

:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraMatrix::~TpetraMatrix() "
Destructor.
";

%feature("docstring") dolfin::TpetraVector "
This class provides a simple vector class based on Tpetra. It is a wrapper for Teuchos::RCP<Tpetra::MultiVector> implementing the :cpp:any:`GenericVector`  interface.
The interface is intentionally simple. For advanced usage, access the Teuchos::RCP<Tpetra::MultiVector> using the function :cpp:any:`vec()`  and use the standard Tpetra interface. 

Friends: :cpp:any:`TpetraMatrix`.
";

%feature("docstring") dolfin::TpetraVector::TpetraVector(MPI_Comm comm, std::size_t N) "
Create vector of size N. 

:param MPI_Comm comm: 
:param std\\:\\:size_t N:
";

%feature("docstring") dolfin::TpetraVector::TpetraVector(MPI_Comm comm=MPI_COMM_WORLD) "
Create empty vector. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::TpetraVector::TpetraVector(const TpetraVector &x) "
Copy constructor. 

:param const TpetraVector & x:
";

%feature("docstring") dolfin::TpetraVector::abs() "
Replace all entries in the vector by their absolute values. 

:rtype: void
";

%feature("docstring") dolfin::TpetraVector::add(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::add_local(const Array< double > &values) "
Add values to each entry on local process. 

:param const Array< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::add_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::axpy(double a, const GenericVector &x) "
Add multiple of given vector (AXPY operation) 

:param double a: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::copy() const "
Return copy of vector. 

:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::TpetraVector::empty() const "
Return true if vector is empty. 

:rtype: bool
";

%feature("docstring") dolfin::TpetraVector::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::TpetraVector::gather(GenericVector &y, const std::vector< dolfin::la_index > &indices) const "
Gather entries (given by global indices) into local (MPI_COMM_SELF) vector x. Provided x must be empty or of correct dimension (same as provided indices). This operation is collective 

:param GenericVector & y: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::gather(std::vector< double > &x, const std::vector< dolfin::la_index > &indices) const "
Gather entries (given by global indices) into x. This operation is collective 

:param std\\:\\:vector< double > & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::gather_on_zero(std::vector< double > &x) const "
Gather all entries into x on process 0. This operation is collective 

:param std\\:\\:vector< double > & x: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::get(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using global indices (all values must be owned by local process, ghosts cannot be accessed) 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::get_local(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using local indices. 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::get_local(std::vector< double > &values) const "
Get all values on local process. 

:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::init(std::pair< std::size_t, std::size_t > range) "
Initialize vector with given ownership range. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::init(std::pair< std::size_t, std::size_t > range, const std::vector< std::size_t > &local_to_global_map, const std::vector< la_index > &ghost_indices) "
Initialize vector with given ownership range and with ghost values 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:param const std\\:\\:vector< std\\:\\:size_t > & local_to_global_map: 
:param const std\\:\\:vector< la_index > & ghost_indices: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::init(std::size_t N) "
Initialize vector to global size N. 

:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::inner(const GenericVector &v) const "
Return inner product with given vector. 

:param const GenericVector & v: 
:rtype: double
";

%feature("docstring") dolfin::TpetraVector::local_range() const "
Return ownership range of a vector. 

:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::TpetraVector::local_size() const "
Return local size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::TpetraVector::map_type "
:cpp:any:`TpetraVector`  map type (local index, global index) 

:rtype: Tpetra::Map< int, dolfin::la_index, node_type >
";

%feature("docstring") dolfin::TpetraVector::mapdump(Teuchos::RCP< const map_type > xmap, const std::string desc) "
output map for debugging 

:param Teuchos\\:\\:RCP< const map_type > xmap: 
:param const std\\:\\:string desc: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::mapdump(const std::string desc) "
Dump x.map and ghost_map for debugging. 

:param const std\\:\\:string desc: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::max() const "
Return maximum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::TpetraVector::min() const "
Return minimum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::TpetraVector::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::TpetraVector::node_type "
Node type. 

:rtype: Tpetra::MultiVector ::node_type
";

%feature("docstring") dolfin::TpetraVector::norm(std::string norm_type) const "
Return norm of vector. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::TpetraVector::operator*=(const GenericVector &x) "
Multiply vector by another vector pointwise. 

:param const GenericVector & x: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator*=(double a) "
Multiply vector by given number. 

:param double a: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator+=(const GenericVector &x) "
Add given vector. 

:param const GenericVector & x: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator+=(double a) "
Add number to all components of a vector. 

:param double a: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator-=(const GenericVector &x) "
Subtract given vector. 

:param const GenericVector & x: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator-=(double a) "
Subtract number from all components of a vector. 

:param double a: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator/=(double a) "
Divide vector by given number. 

:param double a: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator=(const GenericVector &x) "
Assignment operator. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::TpetraVector::operator=(const TpetraVector &x) "
Assignment operator. 

:param const TpetraVector & x: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::operator=(double a) "
Assignment operator. 

:param double a: 
:rtype: const TpetraVector &
";

%feature("docstring") dolfin::TpetraVector::owns_index(std::size_t i) const "
Determine whether global vector index is owned by this process. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::TpetraVector::set(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::set_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::set_local(const std::vector< double > &values) "
:cpp:any:`Set`  all values on local process. 

:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::TpetraVector::size() const "
Return size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::TpetraVector::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::TpetraVector::sum() const "
Return sum of values of vector. 

:rtype: double
";

%feature("docstring") dolfin::TpetraVector::sum(const Array< std::size_t > &rows) const "
Return sum of selected rows in vector. 

:param const Array< std\\:\\:size_t > & rows: 
:rtype: double
";

%feature("docstring") dolfin::TpetraVector::update_ghost_values() "
Update ghost values in vector. 

:rtype: void
";

%feature("docstring") dolfin::TpetraVector::vec() const "
Return pointer to Tpetra vector object. 

:rtype: Teuchos::RCP< vector_type >
";

%feature("docstring") dolfin::TpetraVector::vector_type "
:cpp:any:`TpetraVector`  vector type (scalar, local index, global index, node) 

:rtype: Tpetra::MultiVector< double, int, dolfin::la_index, node_type >
";

%feature("docstring") dolfin::TpetraVector::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::TpetraVector::~TpetraVector() "
Create vector wrapper of Tpetra Vec pointer. 
Destructor
";

%feature("docstring") dolfin::TrilinosParameters "
Method for translating DOLFIN :cpp:any:`Parameters`  to Teuchos::ParameterList needed by Trilinos objects
";

%feature("docstring") dolfin::TrilinosParameters::insert_parameters(const Parameters &params, Teuchos::RCP< Teuchos::ParameterList > parameter_list) "
Copy over parameters from a dolfin :cpp:any:`Parameters`  object to a Teuchos::ParameterList 

:param const Parameters & params:  (:cpp:any:`Parameters` ) dolfin parameter set [direction=in]
:param Teuchos\\:\\:RCP< Teuchos\\:\\:ParameterList > parameter_list:  (Teuchos::RCP<Teuchos::ParameterList>) Trilinos Teuchos parameter set [direction=inout]
:rtype: void
";

%feature("docstring") dolfin::TrilinosPreconditioner "
This class provides a common base for Trilinos preconditioners.
";

%feature("docstring") dolfin::TrilinosPreconditioner::TrilinosPreconditioner() "
Constructor.
";

%feature("docstring") dolfin::TrilinosPreconditioner::init(std::shared_ptr< const TpetraMatrix > P) "
Initialise this preconditioner with the operator P. 

:param std\\:\\:shared_ptr< const TpetraMatrix > P: 
:rtype: void
";

%feature("docstring") dolfin::TrilinosPreconditioner::set(BelosKrylovSolver &solver) "
:cpp:any:`Set`  this preconditioner on a solver. 

:param BelosKrylovSolver & solver: 
:rtype: void
";

%feature("docstring") dolfin::TrilinosPreconditioner::~TrilinosPreconditioner() "
Destructor.
";

%feature("docstring") dolfin::Vector "
This class provides the default DOLFIN vector class, based on the default DOLFIN linear algebra backend.
";

%feature("docstring") dolfin::Vector::Vector(MPI_Comm comm, std::size_t N) "
Create vector of size N. 

:param MPI_Comm comm: 
:param std\\:\\:size_t N:
";

%feature("docstring") dolfin::Vector::Vector(MPI_Comm comm=MPI_COMM_WORLD) "
Create empty vector. 

:param MPI_Comm comm:
";

%feature("docstring") dolfin::Vector::Vector(const GenericVector &x) "
Create a :cpp:any:`Vector`  from a :cpp:any:`GenericVector` . 

:param const GenericVector & x:
";

%feature("docstring") dolfin::Vector::Vector(const Vector &x) "
Copy constructor. 

:param const Vector & x:
";

%feature("docstring") dolfin::Vector::abs() "
Replace all entries in the vector by their absolute values. 

:rtype: void
";

%feature("docstring") dolfin::Vector::add(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Vector::add_local(const Array< double > &values) "
Add values to each entry on local process. 

:param const Array< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::Vector::add_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
Add block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Vector::apply(std::string mode) "
Finalize assembly of tensor. 

:param std\\:\\:string mode: 
:rtype: void
";

%feature("docstring") dolfin::Vector::axpy(double a, const GenericVector &x) "
Add multiple of given vector (AXPY operation) 

:param double a: 
:param const GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::Vector::copy() const "
Return copy of vector. 

:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::Vector::empty() const "
Return true if vector is empty. 

:rtype: bool
";

%feature("docstring") dolfin::Vector::factory() const "
Return linear algebra backend factory. 

:rtype: GenericLinearAlgebraFactory &
";

%feature("docstring") dolfin::Vector::gather(GenericVector &x, const std::vector< dolfin::la_index > &indices) const "
Gather entries (given by global indices) into local vector x 

:param GenericVector & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::Vector::gather(std::vector< double > &x, const std::vector< dolfin::la_index > &indices) const "
Gather entries (given by global indices) into x. 

:param std\\:\\:vector< double > & x: 
:param const std\\:\\:vector< dolfin\\:\\:la_index > & indices: 
:rtype: void
";

%feature("docstring") dolfin::Vector::gather_on_zero(std::vector< double > &x) const "
Gather all entries into x on process 0. 

:param std\\:\\:vector< double > & x: 
:rtype: void
";

%feature("docstring") dolfin::Vector::get(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using global indices (values must all live on the local process, ghosts are no accessible) 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Vector::get_local(double *block, std::size_t m, const dolfin::la_index *rows) const "
Get block of values using local indices (values must all live on the local process) 

:param double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Vector::get_local(std::vector< double > &values) const "
Get all values on local process. 

:param std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::Vector::init(std::pair< std::size_t, std::size_t > range) "
Initialize vector with given ownership range. 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:rtype: void
";

%feature("docstring") dolfin::Vector::init(std::pair< std::size_t, std::size_t > range, const std::vector< std::size_t > &local_to_global_map, const std::vector< la_index > &ghost_indices) "
Initialize vector with given ownership range and with ghost values 

:param std\\:\\:pair< std\\:\\:size_t, std\\:\\:size_t > range: 
:param const std\\:\\:vector< std\\:\\:size_t > & local_to_global_map: 
:param const std\\:\\:vector< la_index > & ghost_indices: 
:rtype: void
";

%feature("docstring") dolfin::Vector::init(std::size_t N) "
Initialize vector to size N. 

:param std\\:\\:size_t N: 
:rtype: void
";

%feature("docstring") dolfin::Vector::inner(const GenericVector &x) const "
Return inner product with given vector. 

:param const GenericVector & x: 
:rtype: double
";

%feature("docstring") dolfin::Vector::instance() "
Return concrete instance / unwrap (non-const version) 

:rtype: GenericVector *
";

%feature("docstring") dolfin::Vector::instance() const "
Return concrete instance / unwrap (const version) 

:rtype: const GenericVector *
";

%feature("docstring") dolfin::Vector::local_range() const "
Return local ownership range of a vector. 

:rtype: std::pair< std::int64_t, std::int64_t >
";

%feature("docstring") dolfin::Vector::local_size() const "
Return local size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::Vector::max() const "
Return maximum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::Vector::min() const "
Return minimum value of vector. 

:rtype: double
";

%feature("docstring") dolfin::Vector::mpi_comm() const "
Return :cpp:any:`MPI`  communicator. 

:rtype: MPI_Comm
";

%feature("docstring") dolfin::Vector::norm(std::string norm_type) const "
Return norm of vector. 

:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::Vector::operator*=(const GenericVector &x) "
Multiply vector by another vector pointwise. 

:param const GenericVector & x: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::operator*=(double a) "
Multiply vector by given number. 

:param double a: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::operator+=(const GenericVector &x) "
Add given vector. 

:param const GenericVector & x: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::operator+=(double a) "
Add number to all components of a vector. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::Vector::operator-=(const GenericVector &x) "
Subtract given vector. 

:param const GenericVector & x: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::operator-=(double a) "
Subtract number from all components of a vector. 

:param double a: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::Vector::operator/=(double a) "
Divide vector by given number. 

:param double a: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::operator=(const GenericVector &x) "
Assignment operator. 

:param const GenericVector & x: 
:rtype: const GenericVector &
";

%feature("docstring") dolfin::Vector::operator=(const Vector &x) "
Assignment operator. 

:param const Vector & x: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::operator=(double a) "
Assignment operator. 

:param double a: 
:rtype: const Vector &
";

%feature("docstring") dolfin::Vector::owns_index(std::size_t i) const "
Determine whether global vector index is owned by this process. 

:param std\\:\\:size_t i: 
:rtype: bool
";

%feature("docstring") dolfin::Vector::set(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using global indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Vector::set_local(const double *block, std::size_t m, const dolfin::la_index *rows) "
:cpp:any:`Set`  block of values using local indices. 

:param const double * block: 
:param std\\:\\:size_t m: 
:param const dolfin\\:\\:la_index * rows: 
:rtype: void
";

%feature("docstring") dolfin::Vector::set_local(const std::vector< double > &values) "
:cpp:any:`Set`  all values on local process. 

:param const std\\:\\:vector< double > & values: 
:rtype: void
";

%feature("docstring") dolfin::Vector::shared_instance() "
Return concrete shared ptr instance / unwrap (non-const version) 

:rtype: std::shared_ptr< LinearAlgebraObject >
";

%feature("docstring") dolfin::Vector::shared_instance() const "
Return concrete shared ptr instance / unwrap (const version) 

:rtype: std::shared_ptr< const LinearAlgebraObject >
";

%feature("docstring") dolfin::Vector::size() const "
Return size of vector. 

:rtype: std::size_t
";

%feature("docstring") dolfin::Vector::str(bool verbose) const "
Return informal string representation (pretty-print) 

:param bool verbose: 
:rtype: std::string
";

%feature("docstring") dolfin::Vector::sum() const "
Return sum of values of vector. 

:rtype: double
";

%feature("docstring") dolfin::Vector::sum(const Array< std::size_t > &rows) const "
Return sum of selected rows in vector. Repeated entries are only summed once. 

:param const Array< std\\:\\:size_t > & rows: 
:rtype: double
";

%feature("docstring") dolfin::Vector::vector "
:rtype: std::shared_ptr< GenericVector >
";

%feature("docstring") dolfin::Vector::zero() "
:cpp:any:`Set`  all entries to zero and keep any sparse structure. 

:rtype: void
";

%feature("docstring") dolfin::VectorSpaceBasis "
This class defines a basis for vector spaces, typically used for expressing nullspaces of singular operators and 'near nullspaces' used in smoothed aggregation algebraic multigrid.
";

%feature("docstring") dolfin::VectorSpaceBasis::VectorSpaceBasis(const std::vector< std::shared_ptr< GenericVector >> basis) "
Constructor. 

:param const std\\:\\:vector< std\\:\\:shared_ptr< GenericVector >> basis:
";

%feature("docstring") dolfin::VectorSpaceBasis::dim() const "
Number of vectors in the basis. 

:rtype: std::size_t
";

%feature("docstring") dolfin::VectorSpaceBasis::is_orthogonal(double tol=1.0e-10) const "
Test if basis is orthogonal. 

:param double tol: 
:rtype: bool
";

%feature("docstring") dolfin::VectorSpaceBasis::is_orthonormal(double tol=1.0e-10) const "
Test if basis is orthonormal. 

:param double tol: 
:rtype: bool
";

%feature("docstring") dolfin::VectorSpaceBasis::operator[](std::size_t i) const "
Get a particular basis vector. 

:param std\\:\\:size_t i: 
:rtype: std::shared_ptr< const GenericVector >
";

%feature("docstring") dolfin::VectorSpaceBasis::orthogonalize(GenericVector &x) const "
Orthogonalize x with respect to basis. 

:param GenericVector & x: 
:rtype: void
";

%feature("docstring") dolfin::VectorSpaceBasis::orthonormalize(double tol=1.0e-10) "
Apply the Gram-Schmidt process to orthonormalize the basis. Throws an error if a (near) linear dependency is detected. Error is thrown if <x_i, x_i> < tol. 

:param double tol: 
:rtype: void
";

%feature("docstring") dolfin::VectorSpaceBasis::~VectorSpaceBasis() "
Destructor.
";

%feature("docstring") dolfin::as_type(X &x) "
Cast object to its derived class, if possible (non-const version). An error is thrown if the cast is unsuccessful. 

:param X & x: 
:rtype: Y &
";

%feature("docstring") dolfin::as_type(std::shared_ptr< X > x) "
Cast shared pointer object to its derived class, if possible. Caller must check for success (returns null if cast fails). 

:param std\\:\\:shared_ptr< X > x: 
:rtype: std::shared_ptr< Y >
";

%feature("docstring") dolfin::has_krylov_solver_method(std::string method) "
Return true if Krylov method for the current linear algebra backend is available 

:param std\\:\\:string method: 
:rtype: bool
";

%feature("docstring") dolfin::has_krylov_solver_preconditioner(std::string preconditioner) "
Return true if Preconditioner for the current linear algebra backend is available 

:param std\\:\\:string preconditioner: 
:rtype: bool
";

%feature("docstring") dolfin::has_linear_algebra_backend(std::string backend) "
Return true if a specific linear algebra backend is supported. 

:param std\\:\\:string backend: 
:rtype: bool
";

%feature("docstring") dolfin::has_lu_solver_method(std::string method) "
Return true if LU method for the current linear algebra backend is available 

:param std\\:\\:string method: 
:rtype: bool
";

%feature("docstring") dolfin::has_type(const X &x) "
Check whether the object matches a specific type. 

:param const X & x: 
:rtype: bool
";

%feature("docstring") dolfin::in_nullspace(const GenericLinearOperator &A, const VectorSpaceBasis &x, std::string type="right") "
Check whether a vector space basis is in the nullspace of a given operator. The string option 'type' can be \"right\" for the right nullspace (Ax=0) or \"left\" for the left nullspace (A^Tx = 0). To test the left nullspace, A must also be of type :cpp:any:`GenericMatrix` . 

:param const GenericLinearOperator & A: 
:param const VectorSpaceBasis & x: 
:param std\\:\\:string type: 
:rtype: bool
";

%feature("docstring") dolfin::krylov_solver_methods() "
Return a list of available Krylov methods for current linear algebra backend 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::krylov_solver_preconditioners() "
Return a list of available preconditioners for current linear algebra backend 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::linear_algebra_backends() "
Return available linear algebra backends. 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::linear_solver_methods() "
Return a list of available solver methods for current linear algebra backend 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::list_krylov_solver_methods() "
List available Krylov methods for current linear algebra backend. 

:rtype: void
";

%feature("docstring") dolfin::list_krylov_solver_preconditioners() "
List available preconditioners for current linear algebra backend 

:rtype: void
";

%feature("docstring") dolfin::list_linear_algebra_backends() "
List available linear algebra backends. 

:rtype: void
";

%feature("docstring") dolfin::list_linear_solver_methods() "
List available solver methods for current linear algebra backend. 

:rtype: void
";

%feature("docstring") dolfin::list_lu_solver_methods() "
List available LU methods for current linear algebra backend. 

:rtype: void
";

%feature("docstring") dolfin::lu_solver_methods() "
Return a list of available LU methods for current linear algebra backend 

:rtype: std::map< std::string, std::string >
";

%feature("docstring") dolfin::norm(const GenericVector &x, std::string norm_type="l2") "
Compute norm of vector. Valid norm types are \"l2\", \"l1\" and \"linf\". 

:param const GenericVector & x: 
:param std\\:\\:string norm_type: 
:rtype: double
";

%feature("docstring") dolfin::normalize(GenericVector &x, std::string normalization_type="average") "
Normalize vector according to given normalization type. 

:param GenericVector & x: 
:param std\\:\\:string normalization_type: 
:rtype: double
";

%feature("docstring") dolfin::residual(const GenericLinearOperator &A, const GenericVector &x, const GenericVector &b) "
Compute residual ||Ax - b||. 

:param const GenericLinearOperator & A: 
:param const GenericVector & x: 
:param const GenericVector & b: 
:rtype: double
";

%feature("docstring") dolfin::solve(const GenericLinearOperator &A, GenericVector &x, const GenericVector &b, std::string method="lu", std::string preconditioner="none") "
Solve linear system Ax = b. 

:param const GenericLinearOperator & A: 
:param GenericVector & x: 
:param const GenericVector & b: 
:param std\\:\\:string method: 
:param std\\:\\:string preconditioner: 
:rtype: std::size_t
";

%feature("docstring") dolfin::usermult(Mat A, Vec x, Vec y) "
Callback function for PETSc mult function. 

:param Mat A: 
:param Vec x: 
:param Vec y: 
:rtype: int
";

